/////////////////////////////////////////////////////////////////////////////////////
//    This file is part of Voxel Mages.						/////
//										/////
//    Voxel Mages is free software: you can redistribute it and/or modify	/////
//    it under the terms of the GNU General Public License as published by	/////
//    the Free Software Foundation, either version 3 of the License, or		/////
//    (at your option) any later version.					/////
//										/////
//    Foobar is distributed in the hope that it will be useful,			/////
//    but WITHOUT ANY WARRANTY; without even the implied warranty of		/////
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the		/////
//    GNU General Public License for more details.				/////
//										/////
//    You should have received a copy of the GNU General Public License		/////
//    along with Foobar.  If not, see <http://www.gnu.org/licenses/>.		/////
/////////////////////////////////////////////////////////////////////////////////////    
 
 
#include<iostream>
#include<cstdlib>
#include<ctime>
#include<cstdio>
#include<fstream>
#include<cmath>
#include<GL/glut.h>
#include<string>
#include<cstring>
#include<sstream>
#include<fstream>
#include<cctype>
#include<time.h>
//Llibreries d'arxius//
#include <dirent.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <pwd.h>
#include <unistd.h>

#define AMPLADA 200
#define ALTURA 100

#define ORIGENX	400
#define ORIGENY	400

bool Finalitzada=false;
char *Actualdir;
int IdeFinestra;
unsigned long int Temps=0;			//Controla el temps de simulacio
    

void escriure(std::string text)    		//imprimira el text en pantalla
{
 unsigned int i;
 char s[300];
 
 for (i=0; i<text.length(); i++)
 {
	s[i]=text[i];
	glutBitmapCharacter(GLUT_BITMAP_HELVETICA_10, s[i]);
 }
}


void SumarArxius()
{
      //Comprovarem tots els posibles outputs del penelope per a sumar-los//
    //Comencem pel dels voxels//
    std::ifstream Arxiu1("tallyVoxelDoseDistrib.dat");
    std::ifstream Arxiu2;
    FILE* Output;
    DIR* Directori;
    int i=1;	//Index que recorre les diferents carpetes amb les diferents simulacions
    int j=0;	//Index comodi (per a varies coses)
    char NSim[2];
    std::string DireccioArxiu2;
    std::string Linea;
    char LineaChar[300];
    char Caracter;
    float Numero;
    //Creem una carpeta per a guardar els resultats
    system("rm -r Resultats");
    mkdir("Resultats",0744);
    if(Arxiu1.is_open())
    {
      //fem una copia//
      system("cp tallyVoxelDoseDistrib.dat ./temp2.txt");
      //Creem un bucle del qual eixirà quan recorrega i sume les contribucions de cada simulació//
      while(1)
      {
	int AuxXifres=0;
	AuxXifres=sprintf(NSim,"%i",i);
	DireccioArxiu2="sim";
	if(AuxXifres==1)
	{
	  DireccioArxiu2+=NSim[0];
	}
	else if(AuxXifres==2)
	{
	  DireccioArxiu2+=NSim[0];
	  DireccioArxiu2+=NSim[1];
	}
	
	//Si no es troa la carpeta voldrà dir que no hi ha més simulacions i per tant eixim del bucle
	Directori=opendir(DireccioArxiu2.c_str());
	if(Directori==NULL)
	{
	  Arxiu1.close();
	  break;
	}
	
	DireccioArxiu2=DireccioArxiu2+"/tallyVoxelDoseDistrib.dat";
	
	//Obrim els arxius de imput i output
	Arxiu2.open(DireccioArxiu2.c_str());
	
	Output=fopen("TempVox.txt","w");
	j=0;
	while(j<7)
	{
	  getline(Arxiu1,Linea);
	  Linea.clear();
	  getline(Arxiu2,Linea);
	
	  Linea+='\n';
	  Linea+='\0';
	  strcpy(LineaChar,Linea.c_str());
	  fprintf(Output,"%s",LineaChar);
	  Linea.clear();
	  j++;
	}
	Arxiu1>>Caracter;
	Arxiu2>>Caracter;

	fprintf(Output,"%c",Caracter);
	

	int NumVoxX;

	Arxiu1>>NumVoxX;
	Arxiu2>>NumVoxX;
	fprintf(Output,"  %d",NumVoxX);

	int NumVoxY;
	
	Arxiu1>>NumVoxY;
	Arxiu2>>NumVoxY;

	fprintf(Output," %d",NumVoxY);

	int NumVoxZ;
	
	Arxiu1>>NumVoxZ;
	Arxiu2>>NumVoxZ;

	fprintf(Output," %d",NumVoxZ);

	getline(Arxiu1,Linea);
	getline(Arxiu2,Linea);

	fprintf(Output,"\n");


	getline(Arxiu1,Linea);
	Linea.clear();
	getline(Arxiu2,Linea);
	
	Linea+='\n';
	Linea+='\0';
	strcpy(LineaChar,Linea.c_str());
	fprintf(Output,"%s",LineaChar);
	  
	Arxiu1>>Caracter;
	Arxiu2>>Caracter;
	
	fprintf(Output,"%c",Caracter);
	
	Arxiu1>>Numero;
	Arxiu2>>Numero;
	
	fprintf(Output,"   %.5E",Numero);

	Arxiu1>>Numero;
	Arxiu2>>Numero;
	
	fprintf(Output,"  %.5E",Numero);

	Arxiu1>>Numero;
	Arxiu2>>Numero;

	//Una vegada agafats els numeros botem de linea
	getline(Arxiu1,Linea);
	getline(Arxiu2,Linea);

	
	fprintf(Output,"  %.5E\n",Numero);
	
	j=0;
	while(j<5)
	{
	  getline(Arxiu1,Linea);
	  Linea.clear();
	  getline(Arxiu2,Linea);
	
	  Linea+='\n';
	  Linea+='\0';
	  strcpy(LineaChar,Linea.c_str());
	  fprintf(Output,"%s",LineaChar);
	  j++;
	}

	//Pasem a la part amb els voxels//
	
	j=1;		//Index de voxels X
	int k=1;	//Index de voxels Y
	int z=1;	//Index de voxels Z
	
	while(z<=NumVoxZ)
	{
	  //Aço agafara la linea que conte # zVoxIndex=N
	  getline(Arxiu1,Linea);
	  Linea.clear();
	  getline(Arxiu2,Linea);
	  
	  Linea+='\n';
	  Linea+='\0';
	  strcpy(LineaChar,Linea.c_str());
	  fprintf(Output,"%s",LineaChar);
	  
	  k=1;
	  while(k<=NumVoxY)
	  {
	    //Aço agafara la linea que conte # yVoxIndex=N
	    getline(Arxiu1,Linea);
	    Linea.clear();
	    getline(Arxiu2,Linea);
	    
	    Linea+='\n';
	    Linea+='\0';
	    strcpy(LineaChar,Linea.c_str());
	    fprintf(Output,"%s",LineaChar);
	    j=1;
	    while(j<=NumVoxX)
	    {
	      int l=0;		//Aquest index servira per a reccorrer els numeros d'una mateixa linea fins arribar al de la dosi
	      while(l<6)
	      {
		Arxiu1>>Numero;
		Arxiu2>>Numero;
		
		fprintf(Output,"  %.5E",Numero);
		
		l++;
	      }
	      //Agafem la dosis dels 2 arxius i la sumem
	      float Numero2=0;
	      float Dosis=0;
	      
	      Arxiu1>>Numero;
	      Arxiu2>>Numero2;
	      
	      Dosis=0.5*(Numero+Numero2);
	      
	      fprintf(Output,"  %.5E",Dosis);
	      
	      //Propaguem l'error dels dos arxius i la guardem
	      Arxiu1>>Numero;
	      Arxiu2>>Numero2;
	      
	      Dosis=sqrt(pow(Numero*0.5,2)+pow(Numero2*0.5,2));
	      
	      fprintf(Output," %.1E \n",Dosis);
	      //pasem de linea
	      getline(Arxiu1,Linea);
	      getline(Arxiu2,Linea);
	      j++;
	    }
	    getline(Arxiu1,Linea);
	    getline(Arxiu2,Linea);	    
	    fprintf(Output," \n");
	    k++;
	  }
	  getline(Arxiu1,Linea);
	  getline(Arxiu2,Linea);	  
	  fprintf(Output," \n");
	  z++;
	}
	
	getline(Arxiu1,Linea);
	getline(Arxiu2,Linea);
	
	fprintf(Output," \n");
	j=0;
	while(j<5)
	{
  	    getline(Arxiu1,Linea);
	    Linea.clear();
	    getline(Arxiu2,Linea);
	    
	    Linea+='\n';
	    Linea+='\0';
	    strcpy(LineaChar,Linea.c_str());
	    fprintf(Output,"%s",LineaChar);
	    Linea.clear();
	    j++;
	}
	Arxiu1>>Caracter;
	Arxiu2>>Caracter;
	
	fprintf(Output,"%c",Caracter);
	
	//Sumem el nombre d'events
	float Events=0;
	Arxiu1>>Numero;
	Arxiu2>>Events;
	
	Events=Numero+Events;
	fprintf(Output,"                %.0f\n",Events);
	
	//pasem de linea als arxius
  	getline(Arxiu1,Linea);
	Linea.clear();
	getline(Arxiu2,Linea);	

	//pasem la linea on posa CPU time [t] (s):
  	getline(Arxiu1,Linea);
	Linea.clear();
	getline(Arxiu2,Linea);	

	Linea+='\n';
	Linea+='\0';
	strcpy(LineaChar,Linea.c_str());
	fprintf(Output,"%s",LineaChar);
	Linea.clear();	
	
	//agafem el temps de cpu dels dos arxius i els comparem per a vore quina ha tardat més i guardem aquest numero al output
	Arxiu1>>Caracter;
	Arxiu2>>Caracter;

	fprintf(Output,"%c",Caracter);
	
	Arxiu1>>Numero;
	Arxiu2>>Events;
	
	if(Numero>=Events)
	{
	  fprintf(Output,"    %.5E\n",Numero);
	}
	else if(Numero<Events)
	{
	  fprintf(Output,"    %.5E\n",Events);
	}
	//Pasem de linea als arxius de resultats
  	getline(Arxiu2,Linea);
	Linea.clear();
	getline(Arxiu1,Linea);	
	
	j=0;
	while(j<10)
	{
  	  getline(Arxiu2,Linea);
	  Linea.clear();
	  getline(Arxiu1,Linea);
	    
	  Linea+='\n';
	  Linea+='\0';
	  strcpy(LineaChar,Linea.c_str());
	  fprintf(Output,"%s",LineaChar);
	  Linea.clear();
	  
	  j++;
	}
	
	Arxiu1.close();
	Arxiu2.close();
	fclose(Output);
	remove("tallyVoxelDoseDistrib.dat");
	rename("TempVox.txt","tallyVoxelDoseDistrib.dat");
	Arxiu1.open("tallyVoxelDoseDistrib.dat");
	i++;
	std::cout<<"Simulació "<<DireccioArxiu2<<", sumada"<<std::endl;
      }

      
      
      system("mv tallyVoxelDoseDistrib.dat ./Resultats/tallyVoxelDoseDistrib.dat");
      rename("temp2.txt","tallyVoxelDoseDistrib.dat");
    }
  

    //Comprovem el pròxim arxiu de resultats
    Arxiu1.open("tallySpatialDoseDistrib-3D.dat");
    i=1;
    j=0;
    if(Arxiu1.is_open())
    {
      //fem una copia//
      system("cp tallySpatialDoseDistrib-3D.dat ./temp3.txt");
      //Creem un bucle del qual eixirà quan recorrega i sume les contribucions de cada simulació//
      while(1)
      {
	int AuxXifres=0;
	AuxXifres=sprintf(NSim,"%i",i);
	DireccioArxiu2="sim";
	if(AuxXifres==1)
	{
	  DireccioArxiu2+=NSim[0];
	}
	else if(AuxXifres==2)
	{
	  DireccioArxiu2+=NSim[0];
	  DireccioArxiu2+=NSim[1];
	}
	//Si no es troa la carpeta voldrà dir que no hi ha més simulacions i per tant eixim del bucle
	Directori=opendir(DireccioArxiu2.c_str());
	if(Directori==NULL)
	{
	  Arxiu1.close();
	  break;
	}
	
	DireccioArxiu2=DireccioArxiu2+"/tallySpatialDoseDistrib-3D.dat";
	
	//Obrim els arxius de imput i output
	Arxiu2.open(DireccioArxiu2.c_str());
	
	Output=fopen("Temp.txt","w");
	j=0;
	while(j<4)
	{
	  getline(Arxiu1,Linea);
	  Linea.clear();
	  getline(Arxiu2,Linea);
	
	  Linea+='\n';
	  Linea+='\0';
	  strcpy(LineaChar,Linea.c_str());
	  fprintf(Output,"%s",LineaChar);
	  Linea.clear();
	  j++;
	}
	Arxiu1>>Caracter;
	Arxiu2>>Caracter;

	fprintf(Output,"%c",Caracter);
	

	int NumVoxX;

	Arxiu1>>NumVoxX;
	Arxiu2>>NumVoxX;
	fprintf(Output,"  %d",NumVoxX);

	int NumVoxY;
	
	Arxiu1>>NumVoxY;
	Arxiu2>>NumVoxY;

	fprintf(Output," %d",NumVoxY);

	int NumVoxZ;
	
	Arxiu1>>NumVoxZ;
	Arxiu2>>NumVoxZ;

	fprintf(Output," %d",NumVoxZ);

	getline(Arxiu1,Linea);
	getline(Arxiu2,Linea);

	fprintf(Output,"\n");
	//Copiem les linies fins que comensen els bins
	j=0;
	while(j<7)
	{
	  getline(Arxiu1,Linea);
	  Linea.clear();
	  getline(Arxiu2,Linea);
	
	  Linea+='\n';
	  Linea+='\0';
	  strcpy(LineaChar,Linea.c_str());
	  fprintf(Output,"%s",LineaChar);
	  j++;
	}

	//Pasem a la part amb els voxels//
	int Binstotals=NumVoxX*NumVoxY*NumVoxZ;
	int contadorX=1;		//Cada vegada que el contador arribe al NumVoxX imprimim un salt de linea i reiniciem el contador
	int contadorY=1;
	j=1;		
	while(j<=Binstotals)
	{
	      int l=0;		//Aquest index servira per a reccorrer els numeros d'una mateixa linea fins arribar al de la dosi
	      while(l<3)
	      {
		int NBin;	//Aquesta variable agafarà el int que indica el numero de bin
		
		Arxiu1>>NBin;
		Arxiu2>>NBin;
		
		if(NBin<10)
		{
		  fprintf(Output,"     %d",NBin);
		}
		else if(NBin<100)
		{
		  fprintf(Output,"    %d",NBin);
		}
		else if(NBin<1000)
		{
		  fprintf(Output,"   %d",NBin);
		}
		Arxiu1>>Numero;
		Arxiu2>>Numero;
		
		fprintf(Output,"  %0.5E",Numero);

		Arxiu1>>Numero;
		Arxiu2>>Numero;
		
		fprintf(Output,"  %0.5E",Numero);		
		l++;
	      }
	      //Agafem la dosis dels 2 arxius i la sumem
	      float Numero2=0;
	      float Dosis=0;
	      
	      Arxiu1>>Numero;
	      Arxiu2>>Numero2;
	      
	      
	      Dosis=0.5*(Numero+Numero2);
	      
	      fprintf(Output,"  %.5E",Dosis);
	      
	      Dosis=0.0;
	      //Propaguem l'error dels dos arxius i la guardem
	      Arxiu1>>Numero;
	      Arxiu2>>Numero2;
	      
	      Dosis=sqrt(pow(Numero*0.5,2)+pow(Numero2*0.5,2));
	      
	      fprintf(Output," %.1E \n",Dosis);
	      //pasem de linea
	      getline(Arxiu1,Linea);
	      getline(Arxiu2,Linea);
	      
	      //Si el contador ha arribat al nombre de bins X aleshores hi ha una linea en blanc
	      if(contadorX==NumVoxX)
	      {
		contadorX=0;
		contadorY++;
		getline(Arxiu1,Linea);
		getline(Arxiu2,Linea);
		
		fprintf(Output,"  \n");
		if(contadorY==NumVoxY+1)
		{
		  contadorY=1;
		  getline(Arxiu1,Linea);
		  getline(Arxiu2,Linea);
		
		  fprintf(Output,"  \n");
		  
		}
	      }

	      contadorX++;
	      j++;
	}
	
	j=0;
	while(j<6)
	{
  	    getline(Arxiu1,Linea);
	    Linea.clear();
	    getline(Arxiu2,Linea);
	    
	    Linea+='\n';
	    Linea+='\0';
	    strcpy(LineaChar,Linea.c_str());
	    fprintf(Output,"%s",LineaChar);
	    Linea.clear();
	    j++;
	}
	Arxiu1>>Caracter;
	Arxiu2>>Caracter;
	
	fprintf(Output,"%c",Caracter);
	
	//Sumem el nombre d'events
	float Events=0;
	Arxiu1>>Numero;
	Arxiu2>>Events;
	
	Events=Numero+Events;
	fprintf(Output,"          %.0f\n",Events);
	
	//pasem de linea als arxius
  	getline(Arxiu1,Linea);
	Linea.clear();
	getline(Arxiu2,Linea);	

	//pasem la linea on posa CPU time [t] (s):
  	getline(Arxiu1,Linea);
	Linea.clear();
	getline(Arxiu2,Linea);	

	Linea+='\n';
	Linea+='\0';
	strcpy(LineaChar,Linea.c_str());
	fprintf(Output,"%s",LineaChar);
	Linea.clear();	
	
	//agafem el temps de cpu dels dos arxius i els comparem per a vore quina ha tardat més
	Arxiu1>>Caracter;
	Arxiu2>>Caracter;

	fprintf(Output,"%c",Caracter);
	
	Arxiu1>>Numero;
	Arxiu2>>Events;
	
	if(Numero>=Events)
	{
	  fprintf(Output,"    %.5E\n",Numero);
	}
	else if(Numero<Events)
	{
	  fprintf(Output,"    %.5E\n",Events);
	}
	//Pasem de linea als arxius de resultats
  	getline(Arxiu2,Linea);
	Linea.clear();
	getline(Arxiu1,Linea);		
		
	j=0;
	while(j<10)
	{
  	  getline(Arxiu2,Linea);
	  Linea.clear();
	  getline(Arxiu1,Linea);
	    
	  Linea+='\n';
	  Linea+='\0';
	  strcpy(LineaChar,Linea.c_str());
	  fprintf(Output,"%s",LineaChar);
	  Linea.clear();
	  
	  j++;
	}
	
	Arxiu1.close();
	Arxiu2.close();
	fclose(Output);
	remove("tallySpatialDoseDistrib-3D.dat");
	rename("Temp.txt","tallySpatialDoseDistrib-3D.dat");
	Arxiu1.open("tallySpatialDoseDistrib-3D.dat");
	i++;
	std::cout<<"Simulació "<<DireccioArxiu2<<", sumada"<<std::endl;
      }
  
      system("mv tallySpatialDoseDistrib-3D.dat ./Resultats/tallySpatialDoseDistrib-3D.dat");
      rename("temp3.txt","tallySpatialDoseDistrib-3D.dat");
    }

    //Comprovem el pròxim arxiu de resultats
    Arxiu1.open("tallySphericalDoseDistrib.dat");
    i=1;
    j=0;
    if(Arxiu1.is_open())
    {
      //fem una copia//
      system("cp tallySphericalDoseDistrib.dat ./temp4.txt");
      //Creem un bucle del qual eixirà quan recorrega i sume les contribucions de cada simulació//
      while(1)
      {
	int AuxXifres=0;
	AuxXifres=sprintf(NSim,"%i",i);
	DireccioArxiu2="sim";
	if(AuxXifres==1)
	{
	  DireccioArxiu2+=NSim[0];
	}
	else if(AuxXifres==2)
	{
	  DireccioArxiu2+=NSim[0];
	  DireccioArxiu2+=NSim[1];
	}
	//Si no es troa la carpeta voldrà dir que no hi ha més simulacions i per tant eixim del bucle
	Directori=opendir(DireccioArxiu2.c_str());
	if(Directori==NULL)
	{
	  Arxiu1.close();
	  break;
	}
	
	DireccioArxiu2=DireccioArxiu2+"/tallySphericalDoseDistrib.dat";
	
	//Obrim els arxius de imput i output
	Arxiu2.open(DireccioArxiu2.c_str());
	
	Output=fopen("Temp.txt","w");
	j=0;
	while(j<4)
	{
	  getline(Arxiu1,Linea);
	  Linea.clear();
	  getline(Arxiu2,Linea);
	
	  Linea+='\n';
	  Linea+='\0';
	  strcpy(LineaChar,Linea.c_str());
	  fprintf(Output,"%s",LineaChar);
	  Linea.clear();
	  j++;
	}
	Arxiu1>>Caracter;
	Arxiu2>>Caracter;

	fprintf(Output,"%c",Caracter);
	

	int NumBins;

	Arxiu1>>NumBins;
	Arxiu2>>NumBins;
	fprintf(Output,"  %d",NumBins);

	getline(Arxiu1,Linea);
	getline(Arxiu2,Linea);

	fprintf(Output,"\n");
	//Copiem les linies fins que comensen els bins
	j=0;
	while(j<8)
	{
	  getline(Arxiu1,Linea);
	  Linea.clear();
	  getline(Arxiu2,Linea);
	
	  Linea+='\n';
	  Linea+='\0';
	  strcpy(LineaChar,Linea.c_str());
	  fprintf(Output,"%s",LineaChar);
	  j++;
	}

	//Pasem a la part amb els Bins//
	j=1;		
	while(j<=NumBins)
	{
	      int NBin;	//Aquesta variable agafarà el int que indica el numero de bin
		
	      Arxiu1>>NBin;
	      Arxiu2>>NBin;
		
	      if(NBin<10)
	      {
		fprintf(Output,"     %d",NBin);
	      }
	      else if(NBin<100)
	      {
		fprintf(Output,"    %d",NBin);		
	      }
	      else if(NBin<1000)
	      {
		fprintf(Output,"   %d",NBin);		
	      }
	      
	      Arxiu1>>Numero;
	      Arxiu2>>Numero;
		
	      fprintf(Output,"  %0.5E",Numero);

	      Arxiu1>>Numero;
	      Arxiu2>>Numero;
		
	      fprintf(Output,"  %0.5E",Numero);		

	      //Agafem la dosis dels 2 arxius i la sumem
	      float Numero2=0;
	      float Dosis=0;
	      
	      Arxiu1>>Numero;
	      Arxiu2>>Numero2;
	      
	      Dosis=0.5*(Numero+Numero2);
	      
	      fprintf(Output,"  %.5E",Dosis);
	      
	      //Propaguem l'error dels dos arxius i la guardem
	      Arxiu1>>Numero;
	      Arxiu2>>Numero2;
	      
	      Dosis=sqrt(pow(Numero*0.5,2)+pow(Numero2*0.5,2));
	      
	      fprintf(Output,"  %.1E \n",Dosis);
	      //pasem de linea
	      getline(Arxiu1,Linea);
	      getline(Arxiu2,Linea);
	      
	      j++;
	}
	
	j=0;
	while(j<6)
	{
  	    getline(Arxiu1,Linea);
	    Linea.clear();
	    getline(Arxiu2,Linea);
	    
	    Linea+='\n';
	    Linea+='\0';
	    strcpy(LineaChar,Linea.c_str());
	    fprintf(Output,"%s",LineaChar);
	    Linea.clear();
	    j++;
	}
	Arxiu1>>Caracter;
	Arxiu2>>Caracter;
	
	fprintf(Output,"%c",Caracter);
	
	//Sumem el nombre d'events
	float Events=0;
	Arxiu1>>Numero;
	Arxiu2>>Events;
	
	Events=Numero+Events;
	fprintf(Output,"          %.0f\n",Events);
	
	//pasem de linea als arxius
  	getline(Arxiu1,Linea);
	Linea.clear();
	getline(Arxiu2,Linea);	

	//pasem la linea on posa CPU time [t] (s):
  	getline(Arxiu1,Linea);
	Linea.clear();
	getline(Arxiu2,Linea);	

	Linea+='\n';
	Linea+='\0';
	strcpy(LineaChar,Linea.c_str());
	fprintf(Output,"%s",LineaChar);
	Linea.clear();	
	
	//agafem el temps de cpu dels dos arxius i els comparem per a vore quina ha tardat més
	Arxiu1>>Caracter;
	Arxiu2>>Caracter;

	fprintf(Output,"%c",Caracter);
	
	Arxiu1>>Numero;
	Arxiu2>>Events;
	
	if(Numero>=Events)
	{
	  fprintf(Output,"    %.5E\n",Numero);
	}
	else if(Numero<Events)
	{
	  fprintf(Output,"    %.5E\n",Events);
	}
	//Pasem de linea als arxius de resultats
  	getline(Arxiu2,Linea);
	Linea.clear();
	getline(Arxiu1,Linea);		
		
	j=0;
	while(j<10)
	{
  	  getline(Arxiu2,Linea);
	  Linea.clear();
	  getline(Arxiu1,Linea);
	    
	  Linea+='\n';
	  Linea+='\0';
	  strcpy(LineaChar,Linea.c_str());
	  fprintf(Output,"%s",LineaChar);
	  Linea.clear();
	  
	  j++;
	}
	
	Arxiu1.close();
	Arxiu2.close();
	fclose(Output);
	remove("tallySphericalDoseDistrib.dat");
	rename("Temp.txt","tallySphericalDoseDistrib.dat");
	Arxiu1.open("tallySphericalDoseDistrib.dat");
	i++;
	std::cout<<"Simulació "<<DireccioArxiu2<<", sumada"<<std::endl;
      }
  
      system("mv tallySphericalDoseDistrib.dat ./Resultats/tallySphericalDoseDistrib.dat");
      rename("temp4.txt","tallySphericalDoseDistrib.dat");
    }
  
    //Comprovem el pròxim arxiu de resultats
    Arxiu1.open("tallyParticleCurrentSpectrum-photon.dat");
    i=1;
    j=0;
    if(Arxiu1.is_open())
    {
      //fem una copia//
      system("cp tallyParticleCurrentSpectrum-photon.dat ./temp5.txt");
      //Creem un bucle del qual eixirà quan recorrega i sume les contribucions de cada simulació//
      while(1)
      {
	int AuxXifres=0;
	AuxXifres=sprintf(NSim,"%i",i);
	DireccioArxiu2="sim";
	if(AuxXifres==1)
	{
	  DireccioArxiu2+=NSim[0];
	}
	else if(AuxXifres==2)
	{
	  DireccioArxiu2+=NSim[0];
	  DireccioArxiu2+=NSim[1];
	}
	//Si no es troa la carpeta voldrà dir que no hi ha més simulacions i per tant eixim del bucle
	Directori=opendir(DireccioArxiu2.c_str());
	if(Directori==NULL)
	{
	  Arxiu1.close();
	  break;
	}
	
	DireccioArxiu2=DireccioArxiu2+"/tallyParticleCurrentSpectrum-photon.dat";
	
	//Obrim els arxius de imput i output
	Arxiu2.open(DireccioArxiu2.c_str());
	Output=fopen("Temp.txt","w");
	//Llegim fins on es troba el numero de bins
	j=0;
	while(j<10)
	{
	  getline(Arxiu1,Linea);
	  Linea.clear();
	  getline(Arxiu2,Linea);
	
	  Linea+='\n';
	  Linea+='\0';
	  strcpy(LineaChar,Linea.c_str());
	  fprintf(Output,"%s",LineaChar);
	  Linea.clear();
	  j++;
	}
	Arxiu1>>Caracter;
	Arxiu2>>Caracter;

	fprintf(Output,"%c",Caracter);
	

	//Llegim el numero de bins
	int NumBins;

	Arxiu1>>NumBins;
	Arxiu2>>NumBins;
	fprintf(Output,"  %d",NumBins);

	getline(Arxiu1,Linea);
	Linea.clear();
	getline(Arxiu2,Linea);

	Linea+='\n';
	Linea+='\0';
	strcpy(LineaChar,Linea.c_str());
	fprintf(Output,"%s",LineaChar);
	//Copiem les linies fins que comensen les dades
	j=0;
	while(j<4)
	{
	  getline(Arxiu1,Linea);
	  Linea.clear();
	  getline(Arxiu2,Linea);
	
	  Linea+='\n';
	  Linea+='\0';
	  strcpy(LineaChar,Linea.c_str());
	  fprintf(Output,"%s",LineaChar);
	  j++;
	}

	//Pasem a la part amb els Bins amb les dades//
	j=1;		
	while(j<=NumBins)
	{
	      //Agafem l'energia "low" del bin
	      Arxiu1>>Numero;
	      Arxiu2>>Numero;
		
	      fprintf(Output,"  %0.5E",Numero);

	      //Agafem l'energia "mid" del bin
	      Arxiu1>>Numero;
	      Arxiu2>>Numero;
		
	      fprintf(Output,"  %0.5E",Numero);		

	      //Agafem els comptes dels 2 arxius i fem la mitja
	      float Numero2=0;
	      float Comptes=0;
	      
	      Arxiu1>>Numero;
	      Arxiu2>>Numero2;
	      
	      Comptes=0.5*(Numero+Numero2);
	      
	      fprintf(Output,"  %.5E",Comptes);
	      
	      //Propaguem l'error dels dos arxius i el guardem
	      Arxiu1>>Numero;
	      Arxiu2>>Numero2;
	      
	      Comptes=sqrt(pow(Numero*0.5,2)+pow(Numero2*0.5,2));
	      
	      fprintf(Output,"  %.1E",Comptes);

	      int NBin;	//Aquesta variable agafarà el int que indica el numero de bin
		
	      Arxiu1>>NBin;
	      Arxiu2>>NBin;
		
	      fprintf(Output," %d \n",NBin);

	      //pasem de linea
	      getline(Arxiu1,Linea);
	      getline(Arxiu2,Linea);
	      
	      j++;
	}
	//Pasem dos linies despres de les dades
	j=0;
	while(j<2)
	{
  	    getline(Arxiu1,Linea);
	    Linea.clear();
	    getline(Arxiu2,Linea);
	    
	    Linea+='\n';
	    Linea+='\0';
	    strcpy(LineaChar,Linea.c_str());
	    fprintf(Output,"%s",LineaChar);
	    Linea.clear();
	    j++;
	}
	//Calculem el "Total particle current per history"
	Arxiu1>>Caracter;
	Arxiu2>>Caracter;

	fprintf(Output,"%c",Caracter);
	
	//Fem la mitja
	float TPC=0;
	Arxiu1>>Numero;
	Arxiu2>>TPC;
	
	TPC=(Numero+TPC)*0.5;
	fprintf(Output,"  %.5E",TPC);
	TPC=0;
	//Propaguem l'error dels dos arxius i el guardem
	Arxiu1>>Numero;
	Arxiu2>>TPC;
	      
	TPC=sqrt(pow(Numero*0.5,2)+pow(TPC*0.5,2));
	      
	fprintf(Output,"  %.1E \n",TPC);

	//pasem de linea
	getline(Arxiu1,Linea);
	getline(Arxiu2,Linea);
	
	//Pasem ara al nombre de histories i les sumem
	j=0;
	while(j<6)
	{
  	    getline(Arxiu1,Linea);
	    Linea.clear();
	    getline(Arxiu2,Linea);
	    
	    Linea+='\n';
	    Linea+='\0';
	    strcpy(LineaChar,Linea.c_str());
	    fprintf(Output,"%s",LineaChar);
	    Linea.clear();
	    j++;
	}
	Arxiu1>>Caracter;
	Arxiu2>>Caracter;
	
	fprintf(Output,"%c",Caracter);
	
	//Sumem el nombre d'events
	float Events=0;
	Arxiu1>>Numero;
	Arxiu2>>Events;
	
	Events=Numero+Events;
	fprintf(Output,"          %.0f\n",Events);
	
	//pasem de linea als arxius
  	getline(Arxiu1,Linea);
	Linea.clear();
	getline(Arxiu2,Linea);	

	//pasem la linea on posa CPU time [t] (s):
  	getline(Arxiu1,Linea);
	Linea.clear();
	getline(Arxiu2,Linea);	

	Linea+='\n';
	Linea+='\0';
	strcpy(LineaChar,Linea.c_str());
	fprintf(Output,"%s",LineaChar);
	Linea.clear();	
	
	//agafem el temps de cpu dels dos arxius i els comparem per a vore quina ha tardat més
	Arxiu1>>Caracter;
	Arxiu2>>Caracter;

	fprintf(Output,"%c",Caracter);
	
	Arxiu1>>Numero;
	Arxiu2>>Events;
	
	if(Numero>=Events)
	{
	  fprintf(Output,"    %.5E\n",Numero);
	}
	else if(Numero<Events)
	{
	  fprintf(Output,"    %.5E\n",Events);
	}
	//Pasem de linea
  	getline(Arxiu2,Linea);
	Linea.clear();
	getline(Arxiu1,Linea);		
		
	j=0;
	while(j<10)
	{
  	  getline(Arxiu2,Linea);
	  Linea.clear();
	  getline(Arxiu1,Linea);
	    
	  Linea+='\n';
	  Linea+='\0';
	  strcpy(LineaChar,Linea.c_str());
	  fprintf(Output,"%s",LineaChar);
	  Linea.clear();
	  
	  j++;
	}
	
	Arxiu1.close();
	Arxiu2.close();
	fclose(Output);
	remove("tallyParticleCurrentSpectrum-photon.dat");
	rename("Temp.txt","tallyParticleCurrentSpectrum-photon.dat");
	Arxiu1.open("tallyParticleCurrentSpectrum-photon.dat");
	i++;
	std::cout<<"Simulació "<<DireccioArxiu2<<", sumada"<<std::endl;
      }
  
      system("mv tallyParticleCurrentSpectrum-photon.dat ./Resultats/tallyParticleCurrentSpectrum-photon.dat");
      rename("temp5.txt","tallyParticleCurrentSpectrum-photon.dat"); //polla
    }
    //Comprovem el pròxim arxiu de resultats
    Arxiu1.open("tallyParticleCurrentSpectrum-electron.dat");
    i=1;
    j=0;
    if(Arxiu1.is_open())
    {
      //fem una copia//
      system("cp tallyParticleCurrentSpectrum-electron.dat ./temp6.txt");
      //Creem un bucle del qual eixirà quan recorrega i sume les contribucions de cada simulació//
      while(1)
      {
	int AuxXifres=0;
	AuxXifres=sprintf(NSim,"%i",i);
	DireccioArxiu2="sim";
	if(AuxXifres==1)
	{
	  DireccioArxiu2+=NSim[0];
	}
	else if(AuxXifres==2)
	{
	  DireccioArxiu2+=NSim[0];
	  DireccioArxiu2+=NSim[1];
	}
	//Si no es troa la carpeta voldrà dir que no hi ha més simulacions i per tant eixim del bucle
	Directori=opendir(DireccioArxiu2.c_str());
	if(Directori==NULL)
	{
	  Arxiu1.close();
	  break;
	}
	
	DireccioArxiu2=DireccioArxiu2+"/tallyParticleCurrentSpectrum-electron.dat";
	
	//Obrim els arxius de imput i output
	Arxiu2.open(DireccioArxiu2.c_str());
	Output=fopen("Temp.txt","w");
	//Llegim fins on es troba el numero de bins
	j=0;
	while(j<10)
	{
	  getline(Arxiu1,Linea);
	  Linea.clear();
	  getline(Arxiu2,Linea);
	
	  Linea+='\n';
	  Linea+='\0';
	  strcpy(LineaChar,Linea.c_str());
	  fprintf(Output,"%s",LineaChar);
	  Linea.clear();
	  j++;
	}
	Arxiu1>>Caracter;
	Arxiu2>>Caracter;

	fprintf(Output,"%c",Caracter);
	

	//Llegim el numero de bins
	int NumBins;

	Arxiu1>>NumBins;
	Arxiu2>>NumBins;
	fprintf(Output,"  %d",NumBins);

	getline(Arxiu1,Linea);
	Linea.clear();
	getline(Arxiu2,Linea);

	Linea+='\n';
	Linea+='\0';
	strcpy(LineaChar,Linea.c_str());
	fprintf(Output,"%s",LineaChar);
	//Copiem les linies fins que comensen les dades
	j=0;
	while(j<4)
	{
	  getline(Arxiu1,Linea);
	  Linea.clear();
	  getline(Arxiu2,Linea);
	
	  Linea+='\n';
	  Linea+='\0';
	  strcpy(LineaChar,Linea.c_str());
	  fprintf(Output,"%s",LineaChar);
	  j++;
	}

	//Pasem a la part amb els Bins amb les dades//
	j=1;		
	while(j<=NumBins)
	{
	      //Agafem l'energia "low" del bin
	      Arxiu1>>Numero;
	      Arxiu2>>Numero;
		
	      fprintf(Output,"  %0.5E",Numero);

	      //Agafem l'energia "mid" del bin
	      Arxiu1>>Numero;
	      Arxiu2>>Numero;
		
	      fprintf(Output,"  %0.5E",Numero);		

	      //Agafem els comptes dels 2 arxius i fem la mitja
	      float Numero2=0;
	      float Comptes=0;
	      
	      Arxiu1>>Numero;
	      Arxiu2>>Numero2;
	      
	      Comptes=0.5*(Numero+Numero2);
	      
	      fprintf(Output,"  %.5E",Comptes);
	      
	      //Propaguem l'error dels dos arxius i el guardem
	      Arxiu1>>Numero;
	      Arxiu2>>Numero2;
	      
	      Comptes=sqrt(pow(Numero*0.5,2)+pow(Numero2*0.5,2));
	      
	      fprintf(Output,"  %.1E",Comptes);

	      int NBin;	//Aquesta variable agafarà el int que indica el numero de bin
		
	      Arxiu1>>NBin;
	      Arxiu2>>NBin;
		
	      fprintf(Output," %d \n",NBin);

	      //pasem de linea
	      getline(Arxiu1,Linea);
	      getline(Arxiu2,Linea);
	      
	      j++;
	}
	//Pasem dos linies despres de les dades
	j=0;
	while(j<2)
	{
  	    getline(Arxiu1,Linea);
	    Linea.clear();
	    getline(Arxiu2,Linea);
	    
	    Linea+='\n';
	    Linea+='\0';
	    strcpy(LineaChar,Linea.c_str());
	    fprintf(Output,"%s",LineaChar);
	    Linea.clear();
	    j++;
	}
	//Calculem el "Total particle current per history"
	Arxiu1>>Caracter;
	Arxiu2>>Caracter;

	fprintf(Output,"%c",Caracter);
	
	//Fem la mitja
	float TPC=0;
	Arxiu1>>Numero;
	Arxiu2>>TPC;
	
	TPC=(Numero+TPC)*0.5;
	fprintf(Output,"  %.5E",TPC);
	TPC=0;
	//Propaguem l'error dels dos arxius i el guardem
	Arxiu1>>Numero;
	Arxiu2>>TPC;
	      
	TPC=sqrt(pow(Numero*0.5,2)+pow(TPC*0.5,2));
	      
	fprintf(Output,"  %.1E \n",TPC);

	//pasem de linea
	getline(Arxiu1,Linea);
	getline(Arxiu2,Linea);
	
	//Pasem ara al nombre de histories i les sumem
	j=0;
	while(j<6)
	{
  	    getline(Arxiu1,Linea);
	    Linea.clear();
	    getline(Arxiu2,Linea);
	    
	    Linea+='\n';
	    Linea+='\0';
	    strcpy(LineaChar,Linea.c_str());
	    fprintf(Output,"%s",LineaChar);
	    Linea.clear();
	    j++;
	}
	Arxiu1>>Caracter;
	Arxiu2>>Caracter;
	
	fprintf(Output,"%c",Caracter);
	
	//Sumem el nombre d'events
	float Events=0;
	Arxiu1>>Numero;
	Arxiu2>>Events;
	
	Events=Numero+Events;
	fprintf(Output,"          %.0f\n",Events);
	
	//pasem de linea als arxius
  	getline(Arxiu1,Linea);
	Linea.clear();
	getline(Arxiu2,Linea);	

	//pasem la linea on posa CPU time [t] (s):
  	getline(Arxiu1,Linea);
	Linea.clear();
	getline(Arxiu2,Linea);	

	Linea+='\n';
	Linea+='\0';
	strcpy(LineaChar,Linea.c_str());
	fprintf(Output,"%s",LineaChar);
	Linea.clear();	
	
	//agafem el temps de cpu dels dos arxius i els comparem per a vore quina ha tardat més
	Arxiu1>>Caracter;
	Arxiu2>>Caracter;

	fprintf(Output,"%c",Caracter);
	
	Arxiu1>>Numero;
	Arxiu2>>Events;
	
	if(Numero>=Events)
	{
	  fprintf(Output,"    %.5E\n",Numero);
	}
	else if(Numero<Events)
	{
	  fprintf(Output,"    %.5E\n",Events);
	}
	//Pasem de linea
  	getline(Arxiu2,Linea);
	Linea.clear();
	getline(Arxiu1,Linea);		
		
	j=0;
	while(j<10)
	{
  	  getline(Arxiu2,Linea);
	  Linea.clear();
	  getline(Arxiu1,Linea);
	    
	  Linea+='\n';
	  Linea+='\0';
	  strcpy(LineaChar,Linea.c_str());
	  fprintf(Output,"%s",LineaChar);
	  Linea.clear();
	  
	  j++;
	}
	
	Arxiu1.close();
	Arxiu2.close();
	fclose(Output);
	remove("tallyParticleCurrentSpectrum-electron.dat");
	rename("Temp.txt","tallyParticleCurrentSpectrum-electron.dat");
	Arxiu1.open("tallyParticleCurrentSpectrum-electron.dat");
	i++;
	std::cout<<"Simulació "<<DireccioArxiu2<<", sumada"<<std::endl;
      }
  
      system("mv tallyParticleCurrentSpectrum-electron.dat ./Resultats/tallyParticleCurrentSpectrum-electron.dat");
      rename("temp6.txt","tallyParticleCurrentSpectrum-electron.dat"); //polla
    }
    //Comprovem el pròxim arxiu de resultats
    Arxiu1.open("tallyParticleCurrentSpectrum-positron.dat");
    i=1;
    j=0;
    if(Arxiu1.is_open())
    {
      //fem una copia//
      system("cp tallyParticleCurrentSpectrum-positron.dat ./temp7.txt");
      //Creem un bucle del qual eixirà quan recorrega i sume les contribucions de cada simulació//
      while(1)
      {
	int AuxXifres=0;
	AuxXifres=sprintf(NSim,"%i",i);
	DireccioArxiu2="sim";
	if(AuxXifres==1)
	{
	  DireccioArxiu2+=NSim[0];
	}
	else if(AuxXifres==2)
	{
	  DireccioArxiu2+=NSim[0];
	  DireccioArxiu2+=NSim[1];
	}
	//Si no es troa la carpeta voldrà dir que no hi ha més simulacions i per tant eixim del bucle
	Directori=opendir(DireccioArxiu2.c_str());
	if(Directori==NULL)
	{
	  Arxiu1.close();
	  break;
	}
	
	DireccioArxiu2=DireccioArxiu2+"/tallyParticleCurrentSpectrum-positron.dat";
	
	//Obrim els arxius de imput i output
	Arxiu2.open(DireccioArxiu2.c_str());
	Output=fopen("Temp.txt","w");
	//Llegim fins on es troba el numero de bins
	j=0;
	while(j<10)
	{
	  getline(Arxiu1,Linea);
	  Linea.clear();
	  getline(Arxiu2,Linea);
	
	  Linea+='\n';
	  Linea+='\0';
	  strcpy(LineaChar,Linea.c_str());
	  fprintf(Output,"%s",LineaChar);
	  Linea.clear();
	  j++;
	}
	Arxiu1>>Caracter;
	Arxiu2>>Caracter;

	fprintf(Output,"%c",Caracter);
	

	//Llegim el numero de bins
	int NumBins;

	Arxiu1>>NumBins;
	Arxiu2>>NumBins;
	fprintf(Output,"  %d",NumBins);

	getline(Arxiu1,Linea);
	Linea.clear();
	getline(Arxiu2,Linea);

	Linea+='\n';
	Linea+='\0';
	strcpy(LineaChar,Linea.c_str());
	fprintf(Output,"%s",LineaChar);
	//Copiem les linies fins que comensen les dades
	j=0;
	while(j<4)
	{
	  getline(Arxiu1,Linea);
	  Linea.clear();
	  getline(Arxiu2,Linea);
	
	  Linea+='\n';
	  Linea+='\0';
	  strcpy(LineaChar,Linea.c_str());
	  fprintf(Output,"%s",LineaChar);
	  j++;
	}

	//Pasem a la part amb els Bins amb les dades//
	j=1;		
	while(j<=NumBins)
	{
	      //Agafem l'energia "low" del bin
	      Arxiu1>>Numero;
	      Arxiu2>>Numero;
		
	      fprintf(Output,"  %0.5E",Numero);

	      //Agafem l'energia "mid" del bin
	      Arxiu1>>Numero;
	      Arxiu2>>Numero;
		
	      fprintf(Output,"  %0.5E",Numero);		

	      //Agafem els comptes dels 2 arxius i fem la mitja
	      float Numero2=0;
	      float Comptes=0;
	      
	      Arxiu1>>Numero;
	      Arxiu2>>Numero2;
	      
	      Comptes=0.5*(Numero+Numero2);
	      
	      fprintf(Output,"  %.5E",Comptes);
	      
	      //Propaguem l'error dels dos arxius i el guardem
	      Arxiu1>>Numero;
	      Arxiu2>>Numero2;
	      
	      Comptes=sqrt(pow(Numero*0.5,2)+pow(Numero2*0.5,2));
	      
	      fprintf(Output,"  %.1E",Comptes);

	      int NBin;	//Aquesta variable agafarà el int que indica el numero de bin
		
	      Arxiu1>>NBin;
	      Arxiu2>>NBin;
		
	      fprintf(Output," %d \n",NBin);

	      //pasem de linea
	      getline(Arxiu1,Linea);
	      getline(Arxiu2,Linea);
	      
	      j++;
	}
	//Pasem dos linies despres de les dades
	j=0;
	while(j<2)
	{
  	    getline(Arxiu1,Linea);
	    Linea.clear();
	    getline(Arxiu2,Linea);
	    
	    Linea+='\n';
	    Linea+='\0';
	    strcpy(LineaChar,Linea.c_str());
	    fprintf(Output,"%s",LineaChar);
	    Linea.clear();
	    j++;
	}
	//Calculem el "Total particle current per history"
	Arxiu1>>Caracter;
	Arxiu2>>Caracter;

	fprintf(Output,"%c",Caracter);
	
	//Fem la mitja
	float TPC=0;
	Arxiu1>>Numero;
	Arxiu2>>TPC;
	
	TPC=(Numero+TPC)*0.5;
	fprintf(Output,"  %.5E",TPC);
	TPC=0;
	//Propaguem l'error dels dos arxius i el guardem
	Arxiu1>>Numero;
	Arxiu2>>TPC;
	      
	TPC=sqrt(pow(Numero*0.5,2)+pow(TPC*0.5,2));
	      
	fprintf(Output,"  %.1E \n",TPC);

	//pasem de linea
	getline(Arxiu1,Linea);
	getline(Arxiu2,Linea);
	
	//Pasem ara al nombre de histories i les sumem
	j=0;
	while(j<6)
	{
  	    getline(Arxiu1,Linea);
	    Linea.clear();
	    getline(Arxiu2,Linea);
	    
	    Linea+='\n';
	    Linea+='\0';
	    strcpy(LineaChar,Linea.c_str());
	    fprintf(Output,"%s",LineaChar);
	    Linea.clear();
	    j++;
	}
	Arxiu1>>Caracter;
	Arxiu2>>Caracter;
	
	fprintf(Output,"%c",Caracter);
	
	//Sumem el nombre d'events
	float Events=0;
	Arxiu1>>Numero;
	Arxiu2>>Events;
	
	Events=Numero+Events;
	fprintf(Output,"          %.0f\n",Events);
	
	//pasem de linea als arxius
  	getline(Arxiu1,Linea);
	Linea.clear();
	getline(Arxiu2,Linea);	

	//pasem la linea on posa CPU time [t] (s):
  	getline(Arxiu1,Linea);
	Linea.clear();
	getline(Arxiu2,Linea);	

	Linea+='\n';
	Linea+='\0';
	strcpy(LineaChar,Linea.c_str());
	fprintf(Output,"%s",LineaChar);
	Linea.clear();	
	
	//agafem el temps de cpu dels dos arxius i els comparem per a vore quina ha tardat més
	Arxiu1>>Caracter;
	Arxiu2>>Caracter;

	fprintf(Output,"%c",Caracter);
	
	Arxiu1>>Numero;
	Arxiu2>>Events;
	
	if(Numero>=Events)
	{
	  fprintf(Output,"    %.5E\n",Numero);
	}
	else if(Numero<Events)
	{
	  fprintf(Output,"    %.5E\n",Events);
	}
	//Pasem de linea
  	getline(Arxiu2,Linea);
	Linea.clear();
	getline(Arxiu1,Linea);		
		
	j=0;
	while(j<10)
	{
  	  getline(Arxiu2,Linea);
	  Linea.clear();
	  getline(Arxiu1,Linea);
	    
	  Linea+='\n';
	  Linea+='\0';
	  strcpy(LineaChar,Linea.c_str());
	  fprintf(Output,"%s",LineaChar);
	  Linea.clear();
	  
	  j++;
	}
	
	Arxiu1.close();
	Arxiu2.close();
	fclose(Output);
	remove("tallyParticleCurrentSpectrum-positron.dat");
	rename("Temp.txt","tallyParticleCurrentSpectrum-positron.dat");
	Arxiu1.open("tallyParticleCurrentSpectrum-positron.dat");
	i++;
	std::cout<<"Simulació "<<DireccioArxiu2<<", sumada"<<std::endl;
      }
  
      system("mv tallyParticleCurrentSpectrum-positron.dat ./Resultats/tallyParticleCurrentSpectrum-positron.dat");
      rename("temp7.txt","tallyParticleCurrentSpectrum-positron.dat"); //polla
    }
    //Comprovem el pròxim arxiu de resultats
    Arxiu1.open("tallyFluenceTrackLength-photon.dat");
    i=1;
    j=0;
    if(Arxiu1.is_open())
    {
      //fem una copia//
      system("cp tallyFluenceTrackLength-photon.dat ./temp8.txt");
      //Creem un bucle del qual eixirà quan recorrega i sume les contribucions de cada simulació//
      while(1)
      {
	int AuxXifres=0;
	AuxXifres=sprintf(NSim,"%i",i);
	DireccioArxiu2="sim";
	if(AuxXifres==1)
	{
	  DireccioArxiu2+=NSim[0];
	}
	else if(AuxXifres==2)
	{
	  DireccioArxiu2+=NSim[0];
	  DireccioArxiu2+=NSim[1];
	}
	//Si no es troa la carpeta voldrà dir que no hi ha més simulacions i per tant eixim del bucle
	Directori=opendir(DireccioArxiu2.c_str());
	if(Directori==NULL)
	{
	  Arxiu1.close();
	  break;
	}
	
	DireccioArxiu2=DireccioArxiu2+"/tallyFluenceTrackLength-photon.dat";
	
	//Obrim els arxius de imput i output
	Arxiu2.open(DireccioArxiu2.c_str());
	Output=fopen("Temp.txt","w");
	//Llegim fins on es troba el numero de bins
	j=0;
	while(j<9)
	{
	  getline(Arxiu1,Linea);
	  Linea.clear();
	  getline(Arxiu2,Linea);
	
	  Linea+='\n';
	  Linea+='\0';
	  strcpy(LineaChar,Linea.c_str());
	  fprintf(Output,"%s",LineaChar);
	  Linea.clear();
	  j++;
	}
	Arxiu1>>Caracter;
	Arxiu2>>Caracter;

	fprintf(Output,"%c",Caracter);
	

	//Llegim el numero de bins
	int NumBins;

	Arxiu1>>NumBins;
	Arxiu2>>NumBins;
	fprintf(Output,"  %d",NumBins);

	getline(Arxiu1,Linea);
	Linea.clear();
	getline(Arxiu2,Linea);

	Linea+='\n';
	Linea+='\0';
	strcpy(LineaChar,Linea.c_str());
	fprintf(Output,"%s",LineaChar);
	//Copiem les linies fins que comensen les dades
	j=0;
	while(j<6)
	{
	  getline(Arxiu1,Linea);
	  Linea.clear();
	  getline(Arxiu2,Linea);
	
	  Linea+='\n';
	  Linea+='\0';
	  strcpy(LineaChar,Linea.c_str());
	  fprintf(Output,"%s",LineaChar);
	  j++;
	}

	//Pasem a la part amb els Bins amb les dades//
	j=1;		
	while(j<=NumBins)
	{
	      //Agafem l'energia "low" del bin
	      Arxiu1>>Numero;
	      Arxiu2>>Numero;
		
	      fprintf(Output,"  %0.5E",Numero);

	      //Agafem l'energia "mid" del bin
	      Arxiu1>>Numero;
	      Arxiu2>>Numero;
		
	      fprintf(Output,"  %0.5E",Numero);		

	      //Agafem les fluencies dels 2 arxius i fem la mitja
	      float Numero2=0;
	      float Fluencia=0;
	      
	      Arxiu1>>Numero;
	      Arxiu2>>Numero2;
	      
	      Fluencia=0.5*(Numero+Numero2);
	      
	      fprintf(Output,"  %.5E",Fluencia);
	      
	      //Propaguem l'error dels dos arxius i el guardem
	      Arxiu1>>Numero;
	      Arxiu2>>Numero2;
	      
	      Fluencia=sqrt(pow(Numero*0.5,2)+pow(Numero2*0.5,2));
	      
	      fprintf(Output,"  %.1E",Fluencia);

	      int NBin;	//Aquesta variable agafarà el int que indica el numero de bin
		
	      Arxiu1>>NBin;
	      Arxiu2>>NBin;
		
	      fprintf(Output," %d \n",NBin);

	      //pasem de linea
	      getline(Arxiu1,Linea);
	      getline(Arxiu2,Linea);
	      
	      j++;
	}
	//Pasem ara al nombre de histories i les sumem
	j=0;
	while(j<6)
	{
  	    getline(Arxiu1,Linea);
	    Linea.clear();
	    getline(Arxiu2,Linea);
	    
	    Linea+='\n';
	    Linea+='\0';
	    strcpy(LineaChar,Linea.c_str());
	    fprintf(Output,"%s",LineaChar);
	    Linea.clear();
	    j++;
	}
	Arxiu1>>Caracter;
	Arxiu2>>Caracter;
	
	fprintf(Output,"%c",Caracter);
	
	//Sumem el nombre d'events
	float Events=0;
	Arxiu1>>Numero;
	Arxiu2>>Events;
	
	Events=Numero+Events;
	fprintf(Output,"          %.0f\n",Events);
	
	//pasem de linea als arxius
  	getline(Arxiu1,Linea);
	Linea.clear();
	getline(Arxiu2,Linea);	

	//pasem la linea on posa CPU time [t] (s):
  	getline(Arxiu1,Linea);
	Linea.clear();
	getline(Arxiu2,Linea);	

	Linea+='\n';
	Linea+='\0';
	strcpy(LineaChar,Linea.c_str());
	fprintf(Output,"%s",LineaChar);
	Linea.clear();	
	
	//agafem el temps de cpu dels dos arxius i els comparem per a vore quina ha tardat més
	Arxiu1>>Caracter;
	Arxiu2>>Caracter;

	fprintf(Output,"%c",Caracter);
	
	Arxiu1>>Numero;
	Arxiu2>>Events;
	
	if(Numero>=Events)
	{
	  fprintf(Output,"    %.5E\n",Numero);
	}
	else if(Numero<Events)
	{
	  fprintf(Output,"    %.5E\n",Events);
	}
	//Pasem de linea
  	getline(Arxiu2,Linea);
	Linea.clear();
	getline(Arxiu1,Linea);		
		
	j=0;
	while(j<8)
	{
  	  getline(Arxiu2,Linea);
	  Linea.clear();
	  getline(Arxiu1,Linea);
	    
	  Linea+='\n';
	  Linea+='\0';
	  strcpy(LineaChar,Linea.c_str());
	  fprintf(Output,"%s",LineaChar);
	  Linea.clear();
	  
	  j++;
	}
	
	Arxiu1.close();
	Arxiu2.close();
	fclose(Output);
	remove("tallyFluenceTrackLength-photon.dat");
	rename("Temp.txt","tallyFluenceTrackLength-photon.dat");
	Arxiu1.open("tallyFluenceTrackLength-photon.dat");
	i++;
	std::cout<<"Simulació "<<DireccioArxiu2<<", sumada"<<std::endl;
      }
  
      system("mv tallyFluenceTrackLength-photon.dat ./Resultats/tallyFluenceTrackLength-photon.dat");
      rename("temp8.txt","tallyFluenceTrackLength-photon.dat"); //polla
    }
    //Comprovem el pròxim arxiu de resultats
    Arxiu1.open("tallyFluenceTrackLength-electron.dat");
    i=1;
    j=0;
    if(Arxiu1.is_open())
    {
      //fem una copia//
      system("cp tallyFluenceTrackLength-electron.dat ./temp9.txt");
      //Creem un bucle del qual eixirà quan recorrega i sume les contribucions de cada simulació//
      while(1)
      {
	int AuxXifres=0;
	AuxXifres=sprintf(NSim,"%i",i);
	DireccioArxiu2="sim";
	if(AuxXifres==1)
	{
	  DireccioArxiu2+=NSim[0];
	}
	else if(AuxXifres==2)
	{
	  DireccioArxiu2+=NSim[0];
	  DireccioArxiu2+=NSim[1];
	}
	//Si no es troa la carpeta voldrà dir que no hi ha més simulacions i per tant eixim del bucle
	Directori=opendir(DireccioArxiu2.c_str());
	if(Directori==NULL)
	{
	  Arxiu1.close();
	  break;
	}
	
	DireccioArxiu2=DireccioArxiu2+"/tallyFluenceTrackLength-electron.dat";
	
	//Obrim els arxius de imput i output
	Arxiu2.open(DireccioArxiu2.c_str());
	Output=fopen("Temp.txt","w");
	//Llegim fins on es troba el numero de bins
	j=0;
	while(j<9)
	{
	  getline(Arxiu1,Linea);
	  Linea.clear();
	  getline(Arxiu2,Linea);
	
	  Linea+='\n';
	  Linea+='\0';
	  strcpy(LineaChar,Linea.c_str());
	  fprintf(Output,"%s",LineaChar);
	  Linea.clear();
	  j++;
	}
	Arxiu1>>Caracter;
	Arxiu2>>Caracter;

	fprintf(Output,"%c",Caracter);
	

	//Llegim el numero de bins
	int NumBins;

	Arxiu1>>NumBins;
	Arxiu2>>NumBins;
	fprintf(Output,"  %d",NumBins);

	getline(Arxiu1,Linea);
	Linea.clear();
	getline(Arxiu2,Linea);

	Linea+='\n';
	Linea+='\0';
	strcpy(LineaChar,Linea.c_str());
	fprintf(Output,"%s",LineaChar);
	//Copiem les linies fins que comensen les dades
	j=0;
	while(j<6)
	{
	  getline(Arxiu1,Linea);
	  Linea.clear();
	  getline(Arxiu2,Linea);
	
	  Linea+='\n';
	  Linea+='\0';
	  strcpy(LineaChar,Linea.c_str());
	  fprintf(Output,"%s",LineaChar);
	  j++;
	}

	//Pasem a la part amb els Bins amb les dades//
	j=1;		
	while(j<=NumBins)
	{
	      //Agafem l'energia "low" del bin
	      Arxiu1>>Numero;
	      Arxiu2>>Numero;
		
	      fprintf(Output,"  %0.5E",Numero);

	      //Agafem l'energia "mid" del bin
	      Arxiu1>>Numero;
	      Arxiu2>>Numero;
		
	      fprintf(Output,"  %0.5E",Numero);		

	      //Agafem les fluencies dels 2 arxius i fem la mitja
	      float Numero2=0;
	      float Fluencia=0;
	      
	      Arxiu1>>Numero;
	      Arxiu2>>Numero2;
	      
	      Fluencia=0.5*(Numero+Numero2);
	      
	      fprintf(Output,"  %.5E",Fluencia);
	      
	      //Propaguem l'error dels dos arxius i el guardem
	      Arxiu1>>Numero;
	      Arxiu2>>Numero2;
	      
	      Fluencia=sqrt(pow(Numero*0.5,2)+pow(Numero2*0.5,2));
	      
	      fprintf(Output,"  %.1E",Fluencia);

	      int NBin;	//Aquesta variable agafarà el int que indica el numero de bin
		
	      Arxiu1>>NBin;
	      Arxiu2>>NBin;
		
	      fprintf(Output," %d \n",NBin);

	      //pasem de linea
	      getline(Arxiu1,Linea);
	      getline(Arxiu2,Linea);
	      
	      j++;
	}
	//Pasem ara al nombre de histories i les sumem
	j=0;
	while(j<6)
	{
  	    getline(Arxiu1,Linea);
	    Linea.clear();
	    getline(Arxiu2,Linea);
	    
	    Linea+='\n';
	    Linea+='\0';
	    strcpy(LineaChar,Linea.c_str());
	    fprintf(Output,"%s",LineaChar);
	    Linea.clear();
	    j++;
	}
	Arxiu1>>Caracter;
	Arxiu2>>Caracter;
	
	fprintf(Output,"%c",Caracter);
	
	//Sumem el nombre d'events
	float Events=0;
	Arxiu1>>Numero;
	Arxiu2>>Events;
	
	Events=Numero+Events;
	fprintf(Output,"          %.0f\n",Events);
	
	//pasem de linea als arxius
  	getline(Arxiu1,Linea);
	Linea.clear();
	getline(Arxiu2,Linea);	

	//pasem la linea on posa CPU time [t] (s):
  	getline(Arxiu1,Linea);
	Linea.clear();
	getline(Arxiu2,Linea);	

	Linea+='\n';
	Linea+='\0';
	strcpy(LineaChar,Linea.c_str());
	fprintf(Output,"%s",LineaChar);
	Linea.clear();	
	
	//agafem el temps de cpu dels dos arxius i els comparem per a vore quina ha tardat més
	Arxiu1>>Caracter;
	Arxiu2>>Caracter;

	fprintf(Output,"%c",Caracter);
	
	Arxiu1>>Numero;
	Arxiu2>>Events;
	
	if(Numero>=Events)
	{
	  fprintf(Output,"    %.5E\n",Numero);
	}
	else if(Numero<Events)
	{
	  fprintf(Output,"    %.5E\n",Events);
	}
	//Pasem de linea
  	getline(Arxiu2,Linea);
	Linea.clear();
	getline(Arxiu1,Linea);		
		
	j=0;
	while(j<8)
	{
  	  getline(Arxiu2,Linea);
	  Linea.clear();
	  getline(Arxiu1,Linea);
	    
	  Linea+='\n';
	  Linea+='\0';
	  strcpy(LineaChar,Linea.c_str());
	  fprintf(Output,"%s",LineaChar);
	  Linea.clear();
	  
	  j++;
	}
	
	Arxiu1.close();
	Arxiu2.close();
	fclose(Output);
	remove("tallyFluenceTrackLength-electron.dat");
	rename("Temp.txt","tallyFluenceTrackLength-electron.dat");
	Arxiu1.open("tallyFluenceTrackLength-electron.dat");
	i++;
	std::cout<<"Simulació "<<DireccioArxiu2<<", sumada"<<std::endl;
      }
  
      system("mv tallyFluenceTrackLength-electron.dat ./Resultats/tallyFluenceTrackLength-electron.dat");
      rename("temp9.txt","tallyFluenceTrackLength-electron.dat"); //polla
    }
    //Comprovem el pròxim arxiu de resultats
    Arxiu1.open("tallyFluenceTrackLength-positron.dat");
    i=1;
    j=0;
    if(Arxiu1.is_open())
    {
      //fem una copia//
      system("cp tallyFluenceTrackLength-positron.dat ./temp10.txt");
      //Creem un bucle del qual eixirà quan recorrega i sume les contribucions de cada simulació//
      while(1)
      {
	int AuxXifres=0;
	AuxXifres=sprintf(NSim,"%i",i);
	DireccioArxiu2="sim";
	if(AuxXifres==1)
	{
	  DireccioArxiu2+=NSim[0];
	}
	else if(AuxXifres==2)
	{
	  DireccioArxiu2+=NSim[0];
	  DireccioArxiu2+=NSim[1];
	}
	//Si no es troa la carpeta voldrà dir que no hi ha més simulacions i per tant eixim del bucle
	Directori=opendir(DireccioArxiu2.c_str());
	if(Directori==NULL)
	{
	  Arxiu1.close();
	  break;
	}
	
	DireccioArxiu2=DireccioArxiu2+"/tallyFluenceTrackLength-positron.dat";
	
	//Obrim els arxius de imput i output
	Arxiu2.open(DireccioArxiu2.c_str());
	Output=fopen("Temp.txt","w");
	//Llegim fins on es troba el numero de bins
	j=0;
	while(j<9)
	{
	  getline(Arxiu1,Linea);
	  Linea.clear();
	  getline(Arxiu2,Linea);
	
	  Linea+='\n';
	  Linea+='\0';
	  strcpy(LineaChar,Linea.c_str());
	  fprintf(Output,"%s",LineaChar);
	  Linea.clear();
	  j++;
	}
	Arxiu1>>Caracter;
	Arxiu2>>Caracter;

	fprintf(Output,"%c",Caracter);
	

	//Llegim el numero de bins
	int NumBins;

	Arxiu1>>NumBins;
	Arxiu2>>NumBins;
	fprintf(Output,"  %d",NumBins);

	getline(Arxiu1,Linea);
	Linea.clear();
	getline(Arxiu2,Linea);

	Linea+='\n';
	Linea+='\0';
	strcpy(LineaChar,Linea.c_str());
	fprintf(Output,"%s",LineaChar);
	//Copiem les linies fins que comensen les dades
	j=0;
	while(j<6)
	{
	  getline(Arxiu1,Linea);
	  Linea.clear();
	  getline(Arxiu2,Linea);
	
	  Linea+='\n';
	  Linea+='\0';
	  strcpy(LineaChar,Linea.c_str());
	  fprintf(Output,"%s",LineaChar);
	  j++;
	}

	//Pasem a la part amb els Bins amb les dades//
	j=1;		
	while(j<=NumBins)
	{
	      //Agafem l'energia "low" del bin
	      Arxiu1>>Numero;
	      Arxiu2>>Numero;
		
	      fprintf(Output,"  %0.5E",Numero);

	      //Agafem l'energia "mid" del bin
	      Arxiu1>>Numero;
	      Arxiu2>>Numero;
		
	      fprintf(Output,"  %0.5E",Numero);		

	      //Agafem les fluencies dels 2 arxius i fem la mitja
	      float Numero2=0;
	      float Fluencia=0;
	      
	      Arxiu1>>Numero;
	      Arxiu2>>Numero2;
	      
	      Fluencia=0.5*(Numero+Numero2);
	      
	      fprintf(Output,"  %.5E",Fluencia);
	      
	      //Propaguem l'error dels dos arxius i el guardem
	      Arxiu1>>Numero;
	      Arxiu2>>Numero2;
	      
	      Fluencia=sqrt(pow(Numero*0.5,2)+pow(Numero2*0.5,2));
	      
	      fprintf(Output,"  %.1E",Fluencia);

	      int NBin;	//Aquesta variable agafarà el int que indica el numero de bin
		
	      Arxiu1>>NBin;
	      Arxiu2>>NBin;
		
	      fprintf(Output," %d \n",NBin);

	      //pasem de linea
	      getline(Arxiu1,Linea);
	      getline(Arxiu2,Linea);
	      
	      j++;
	}
	//Pasem ara al nombre de histories i les sumem
	j=0;
	while(j<6)
	{
  	    getline(Arxiu1,Linea);
	    Linea.clear();
	    getline(Arxiu2,Linea);
	    
	    Linea+='\n';
	    Linea+='\0';
	    strcpy(LineaChar,Linea.c_str());
	    fprintf(Output,"%s",LineaChar);
	    Linea.clear();
	    j++;
	}
	Arxiu1>>Caracter;
	Arxiu2>>Caracter;
	
	fprintf(Output,"%c",Caracter);
	
	//Sumem el nombre d'events
	float Events=0;
	Arxiu1>>Numero;
	Arxiu2>>Events;
	
	Events=Numero+Events;
	fprintf(Output,"          %.0f\n",Events);
	
	//pasem de linea als arxius
  	getline(Arxiu1,Linea);
	Linea.clear();
	getline(Arxiu2,Linea);	

	//pasem la linea on posa CPU time [t] (s):
  	getline(Arxiu1,Linea);
	Linea.clear();
	getline(Arxiu2,Linea);	

	Linea+='\n';
	Linea+='\0';
	strcpy(LineaChar,Linea.c_str());
	fprintf(Output,"%s",LineaChar);
	Linea.clear();	
	
	//agafem el temps de cpu dels dos arxius i els comparem per a vore quina ha tardat més
	Arxiu1>>Caracter;
	Arxiu2>>Caracter;

	fprintf(Output,"%c",Caracter);
	
	Arxiu1>>Numero;
	Arxiu2>>Events;
	
	if(Numero>=Events)
	{
	  fprintf(Output,"    %.5E\n",Numero);
	}
	else if(Numero<Events)
	{
	  fprintf(Output,"    %.5E\n",Events);
	}
	//Pasem de linea
  	getline(Arxiu2,Linea);
	Linea.clear();
	getline(Arxiu1,Linea);		
		
	j=0;
	while(j<8)
	{
  	  getline(Arxiu2,Linea);
	  Linea.clear();
	  getline(Arxiu1,Linea);
	    
	  Linea+='\n';
	  Linea+='\0';
	  strcpy(LineaChar,Linea.c_str());
	  fprintf(Output,"%s",LineaChar);
	  Linea.clear();
	  
	  j++;
	}
	
	Arxiu1.close();
	Arxiu2.close();
	fclose(Output);
	remove("tallyFluenceTrackLength-positron.dat");
	rename("Temp.txt","tallyFluenceTrackLength-positron.dat");
	Arxiu1.open("tallyFluenceTrackLength-positron.dat");
	i++;
	std::cout<<"Simulació "<<DireccioArxiu2<<", sumada"<<std::endl;
      }
  
      system("mv tallyFluenceTrackLength-positron.dat ./Resultats/tallyFluenceTrackLength-positron.dat");
      rename("temp10.txt","tallyFluenceTrackLength-positron.dat"); //polla
    }
  
}


void Comprovar()
{
  DIR* Directori;
  int i=1;
  char NSimul[2];
  bool SimFinal[100];
  SimFinal[0]=false;
  i=1;
  while(i<100)
  {
    SimFinal[i]=true;
    i++;
  }
  i=1;
  std::string NSimulacio;
  while(1)
  {
    int AuxXifres=0;
    //Recorrerem les posibles carpetes amb simulacions
    AuxXifres=sprintf(NSimul,"%i",i);
    
    NSimulacio="sim";
    if(AuxXifres==1)
    {
      NSimulacio+=NSimul[0];
    }
    else if(AuxXifres==2)
    {
      NSimulacio+=NSimul[0];
      NSimulacio+=NSimul[1];
    }
    //Mirem si el directori existeix intentant obrir-lo
    Directori=opendir(NSimulacio.c_str());
    if(Directori==NULL)
    {
      //si la carpeta no existeix eixim del bucle
      break;
    }
    else
    {
      closedir(Directori);
      //Si existeix posem la variable a false mirem si s'ha creat l'arxiu que indica que ha acabat
      SimFinal[i]=false;
      chdir(NSimulacio.c_str());
      std::ifstream Comprov("Complet.txt");
      if(Comprov.is_open())
      {
	SimFinal[i]=true;
	Comprov.close();
      }
      chdir(Actualdir);
    }
    i++;
  }
  //Comprovem que la simulacio externa ha acabat
  std::ifstream Comprov("Complet.txt");
  if(Comprov.is_open())
  {
    SimFinal[0]=true;
    Comprov.close();
  }
  //Si tots han acabat pasarem a sumar els arxius

  //Mirem si totes han acabat
  i=0;
  while(i<100)
  {
    if(SimFinal[i]!=true)
    {
      break;
    }
    i++;
  }
  //Si han acabat "i" tindrà el valor de 100
  if(i==100)
  {
    Finalitzada=true;
    Temps=glutGet(GLUT_ELAPSED_TIME);
    std::ofstream ArxiuTemps("Time.txt");
    ArxiuTemps<<"Simulations completed in "<<Temps/1000<<" seconds"<<std::endl; 
    ArxiuTemps.close();
    SumarArxius();
    system("mv Time.txt ./Resultats/Time.txt");
    glutShowWindow();
  }
  
    glutPostRedisplay();

}

void FuncioTemps(int a)
{
  if(Finalitzada==false)
  {
    Comprovar();
    glutTimerFunc(30000,FuncioTemps,0);
  }
}

void iniciar(void)
{
  glMatrixMode(GL_PROJECTION);			//copiem la matriu de projecció i pasem a una perspectiva ortho
  
  glLoadIdentity();
  glOrtho(0,AMPLADA,0,ALTURA,-10,10);
  
  glMatrixMode(GL_MODELVIEW);
  
  glLoadIdentity();
  glClearColor(0.32,0.34,0.34,1);				//posem el color de fons del menu
  glClearDepth(1);      
}


void dibuixar(void)
{
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    glRasterPos3f(20,40,1);

    //Comprovem si ha acabat la simulacio
    
    if(Finalitzada==true)
    {
      float HoresTrans=Temps/(1000.0*3600.0);
      int NumChars=0;
      char HTransChar[100];
      NumChars=sprintf(HTransChar,"%f",HoresTrans);
      std::string AuxTemps;
      int i=0;
      while(i<NumChars)
      {
	AuxTemps+=HTransChar[i];
	i++;
      }
      escriure("Les simulacions han acabat en ");
      escriure(AuxTemps);
      escriure(" h");
    }

    glFlush();
    glutSwapBuffers();
}

int main(int argc, char **argv)
{	

  if ((Actualdir = getenv("PWD")) == NULL)
  {
    std::cout<<"Error al trobar el directori actual"<<std::endl;
  }
  
  glutInit(&argc,argv);
  glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGBA | GLUT_DEPTH);
  glutInitWindowSize(AMPLADA,ALTURA);
  glutInitWindowPosition(ORIGENX,ORIGENY);
  glutCreateWindow("Finish");
 
  iniciar();
  glutHideWindow();				//Amaguem la finestra fins que acabe la simulacio
  
  glutDisplayFunc(dibuixar);
  glutTimerFunc(30000,FuncioTemps,0);
  glutMainLoop();
  
  
  return 0;
}
