 
#include<iostream>
#include<stdio.h>
#include<cstdio>
#include<cstdlib>
#include<fstream>
#include<sstream>
#include<cmath>
#include<cstring>
#include<cmath>
#include <unistd.h>

int main(int argc, char **argv)
{
  char help[2];
  char help2[5];
  char help3[4];
  sprintf(help,"-h");
  sprintf(help2,"-help");
  sprintf(help3,"help");
  if((argc!=2 && argc!=3) || (argc==2 && (strcmp(argv[1],help) || strcmp(argv[1],help2) || strcmp(argv[1],help3) )))
    {
      printf("Insert the voxelization file and the image viewer (optional)\n\n");
      printf("     voxelView < example.vox image_visor[optional]\n");
    }
  else
    {
      //Obrim el fitxer de voxelitzat i comprovem que s'obri be
      std::ifstream Fitxer_Voxels(argv[1]);
      if(Fitxer_Voxels.is_open())
	{
	  std::string LineaAux;
	  while(getline(Fitxer_Voxels,LineaAux))
	    {
	      if(LineaAux=="[SECTION VOXELS HEADER v.2008-04-13]")
		{
		  break;
		}
	    }
	  //Agafem el nombre de voxels en cada eix (x,y,z)
	  int Nombre_Voxels[3]={0};
	  Fitxer_Voxels>>Nombre_Voxels[0];
	  Fitxer_Voxels>>Nombre_Voxels[1];
	  Fitxer_Voxels>>Nombre_Voxels[2];
	  getline(Fitxer_Voxels,LineaAux);
	  
	  //Agafem el tamany d'aquests voxels
	  double Dim_Voxels[3]={0};
	  Fitxer_Voxels>>Dim_Voxels[0];
	  Fitxer_Voxels>>Dim_Voxels[1];
	  Fitxer_Voxels>>Dim_Voxels[2];
	  getline(Fitxer_Voxels,LineaAux);
	  
	  int i=0;
	  while(i<2)
	    {
	      getline(Fitxer_Voxels,LineaAux);
	      i++;
	    }
	  //Agafem si el voxelitzat deixa linies blanques al acabar un cicle de X o Y
	  bool Linies_Blanques=false;
	  Fitxer_Voxels>>Linies_Blanques;
	  getline(Fitxer_Voxels,LineaAux);
	  getline(Fitxer_Voxels,LineaAux);

	  //Creem una carpeta on guardar els plans del voxelitzat
	  system("rm -r temp > /dev/null");
	  system("mkdir temp > /dev/null");
	  //Comença ara amb les dades
	  int MaxMat=0;
	  double MaxDens=0;
	  int k=0;
	  while(k<Nombre_Voxels[2]) //Recorre la coordenada Z
	    {
	      std::cout<<"\r Processed "<<k<<"/"<<Nombre_Voxels[2]<<" planes";
	      fflush(stdout);
	      //Guardem el nom del fitxer del pla
	      std::string Nom_Out;
	      Nom_Out.clear();
	      char AuxChar[10];
	      sprintf(AuxChar,"%i",k);
	      Nom_Out=std::string("temp/Z=");
	      Nom_Out.append(AuxChar);

	      //L'obrim i carreguem els voxels
	      FILE* Out;
	      Out = fopen(Nom_Out.c_str(),"w");
	      if(Out==NULL){break;}
	      int j=0;
	      while(j<Nombre_Voxels[1])
		{
		  i=0;
		  while(i<Nombre_Voxels[0])
		    {
		      //Ens botem les linies que comencen amb #
		      std::string AuxString;
		      while(1)
			{
			  AuxString.clear();
			  Fitxer_Voxels>>AuxString;
			  if(AuxString[0]!='#')
			    {
			      break;
			    }
			  getline(Fitxer_Voxels,LineaAux);
			}
		      //Agafem el numero de material i densitat
		      int Material=atoi(AuxString.c_str());
		      float Densitat;

		      Fitxer_Voxels>>Densitat;
		      getline(Fitxer_Voxels,LineaAux);

		      if(Material>MaxMat){MaxMat=Material;}
		      if(Densitat>MaxDens){MaxDens=Densitat;}
		      //Guardem en l'Out el material, densitat i posicio x,y del centre del voxel
		      double Pos_Voxel[3]={0};
		      Pos_Voxel[0]=i*Dim_Voxels[0]+Dim_Voxels[0]*0.5;
		      Pos_Voxel[1]=j*Dim_Voxels[1]+Dim_Voxels[1]*0.5;
		      
		      fprintf(Out,"%i %.8f %.8f %.8f\n", Material, Densitat, Pos_Voxel[0], Pos_Voxel[1]);
		      i++;
		    }
		  //Si l'espai entre cicles esta activat, agafem una linea
		  if(Linies_Blanques==true)
		    {
		      getline(Fitxer_Voxels,LineaAux);
		    }
		  //Al canviar de j, deixem un espai en blanc
		  fprintf(Out,"\n");
		  j++;
		}
	      //Si l'espai entre cicles esta activat, agafem una linea
	      if(Linies_Blanques==true)
		{
		  getline(Fitxer_Voxels,LineaAux);
		}
	      fclose(Out);
	      k++;
	    }
	  Fitxer_Voxels.close();
	  printf("\n");
	  //Creem ara els comandos del gnuplot inicials
	  FILE* GNUPLOT;
	  GNUPLOT=fopen("temp/viewer.gpl","w");

	  
	  fprintf(GNUPLOT,"filename='temp/Z=0'\n");
	  fprintf(GNUPLOT,"set term png enhance size 2100,1300\n");
	  fprintf(GNUPLOT,"set out 'vox.png'\n");
	  fprintf(GNUPLOT,"set title 'Z=%.3f cm'\n",Dim_Voxels[2]*0.5);
	  fprintf(GNUPLOT,"set pm3d map\n");
	  fprintf(GNUPLOT,"set xlabel 'x (cm)'\n");
	  fprintf(GNUPLOT,"set ylabel 'y (cm)'\n");
	  fprintf(GNUPLOT,"set xrange [0:%.5f]\n",Dim_Voxels[0]*Nombre_Voxels[0]);
	  fprintf(GNUPLOT,"set yrange [0:%.5f]\n",Dim_Voxels[1]*Nombre_Voxels[1]);
	  fprintf(GNUPLOT,"set cbrange [0:%i]\n",MaxMat);
	  fprintf(GNUPLOT,"splot filename using 3:4:1\n");
	  fclose(GNUPLOT);
	  system("gnuplot temp/viewer.gpl");

	  if(argc==3)
	    {
	      std::string Imatge=std::string(argv[2])+" vox.png &";
	      system(Imatge.c_str());
	    }

	  //Creem ara un bucle infinit que permetra canviar de pla i de representar material o densitat
	  int Pla_Actual=0;
	  bool MaterialODensitat=true; //true = material, false = densitat
	  while(1)
	    {
	      printf("\033[2J"); //Neteja la pantalla
	      
	      printf("Ploting %s of the plane number %i, Z=%.5f\n\n", MaterialODensitat==true ? "materials":"density" , Pla_Actual, Dim_Voxels[2]*Pla_Actual+Dim_Voxels[2]*0.5);

	      printf("Introduce a new plane (integer) to plot, type 'm' to change between material and density or ''exit'' to finish the program.\n");
	      
	      std::string Introduir;
	      Introduir.clear();
	      scanf("%s", Introduir.c_str());

	      fflush( stdout );
	      
	      if(Introduir[0]=='e' && Introduir[1]=='x' && Introduir[2]=='i' && Introduir[3]=='t' && Introduir[4]=='\0')
		{
		  system("rm -r temp");
		  break;
		}
	      else if(Introduir[0]=='m' && Introduir[1]=='\0')
		{
		  if(MaterialODensitat==true){MaterialODensitat=false;}
		  else if(MaterialODensitat==false){MaterialODensitat=true;}
		}
	      else
		{
		  //Guardem el nombre de pla
		  int AuxPla=atoi(Introduir.c_str());
		  if(AuxPla>=0 && AuxPla<Nombre_Voxels[2])
		    {
		      Pla_Actual=AuxPla;
		    }
		  else
		    {
		      printf("Warning: Insert planes between 0-%i \n\n",Nombre_Voxels[2]);
		    }
		}
		  //Creem ara els comandos del gnuplot
		  FILE* GNUPLOT;
		  GNUPLOT=fopen("temp/viewer.gpl","w");

		  fprintf(GNUPLOT,"filename='temp/Z=%i'\n",Pla_Actual);
		  fprintf(GNUPLOT,"set term png enhance size 2100,1300\n");
		  fprintf(GNUPLOT,"set out 'vox.png'\n");		  
		  fprintf(GNUPLOT,"set title 'Z=%.3f cm'\n",Pla_Actual*Dim_Voxels[2]+Dim_Voxels[2]*0.5);
		  fprintf(GNUPLOT,"set pm3d map\n");
		  fprintf(GNUPLOT,"set xlabel 'x (cm)'\n");
		  fprintf(GNUPLOT,"set ylabel 'y (cm)'\n");
		  fprintf(GNUPLOT,"set xrange [0:%.5f]\n",Dim_Voxels[0]*Nombre_Voxels[0]);
		  fprintf(GNUPLOT,"set yrange [0:%.5f]\n",Dim_Voxels[1]*Nombre_Voxels[1]);
		  fprintf(GNUPLOT,"set cbrange [0:%.5f]\n",MaterialODensitat==true ? MaxMat:MaxDens);
		  if(MaterialODensitat==false)
		    {
		      fprintf(GNUPLOT,"set palette defined ( 0 0 0 0, 1 1 1 1 )\n");
		    }
		  fprintf(GNUPLOT,"splot filename using 3:4:%i\n",MaterialODensitat==true ? 1:2);
		  fclose(GNUPLOT);

		  system("gnuplot temp/viewer.gpl");

		  if(argc==3)
		    {
		      std::string Imatge=std::string(argv[2])+" vox.png &";
		      system(Imatge.c_str());
		    }		
	    }
	  
	}
    }
  return 0;
}
