#include "dicom.h"
#include <string>
#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <fstream>

int main()
{
	dicom::dicomfile *df;
	df = dicom::open_dicomfile("test.dcm");
	if (df) {
		// get some informations dicom file
		std::string studydesc =
				df->get_dataelement("StudyDescription")->to_string();
		// shorter form
		std::string studytime = (*df)["StudyDate"];

		printf("Study Description = %s\n", studydesc.c_str());
		printf("Study Time = %s\n", studytime.c_str());

		// get images' informations in DICOM file

		int width, height;
		int precision, signedness, ncomponents, bytes_per_pixel;
		int nframes;
		df->get_image_info(&width, &height,
			&precision, &signedness, &ncomponents, &bytes_per_pixel,
			&nframes);

		std::cout<<"width = "<<width<<", height = "<<height<<", precision = "<<precision<<", signedness = "<<signedness<<", NComponents = "<<ncomponents<<", bytsXpixel = "<<bytes_per_pixel<<", nframes = "<<nframes<<std::endl;

		int buffer_length;
		buffer_length = width*bytes_per_pixel*height*nframes;
		char* pixeldata= new char[width*height*bytes_per_pixel];
		
		int z=0;
		while(z<(width*height*bytes_per_pixel))
		{
		  pixeldata[z]='0';
		  z++;
		}
		int pixeldata_length;
		
		int row_step, frame_step;
		row_step = width*bytes_per_pixel;
                frame_step = width*bytes_per_pixel*height;
		
		df->get_pixeldata_a(&pixeldata, &pixeldata_length);		
		
		if (pixeldata) 
		{
		  int i=0;
		  int j=0;
		  int k=0;
		  int Nbyte=0;
		  
		  std::ofstream FitxerResultats("resultats.txt");
		  while(k<nframes)
		  {
		    j=0;
		    while(j<height)
		    {
		      i=0;
		      while(i<width)
		      {
			char Aux[bytes_per_pixel];
			int cont=0;
			while(cont<bytes_per_pixel)
			{
			  Aux[cont]=pixeldata[Nbyte];
			  float auxint2=Aux[cont];
			  FitxerResultats<<auxint2;
			  cont++;
			  Nbyte++;
			}
			FitxerResultats<<std::endl;
			i++;
		      }
		      j++;
		    }
		    k++;
		  }
		  
		  std::cout<<pixeldata_length<<" "<<Nbyte<<" "<<width*height*bytes_per_pixel<<std::endl;
		  
		  
		  delete pixeldata;
		}
		else{std::cout<<"Error"<<std::endl;}

		delete df;
	} else {
		printf("Error message: %s\n", dicom::get_error_message());
	}
}
