/////////////////////////////////////////////////////////////////////////////////////
//    This file is part of Voxel Mages 						  ///
//    Copyright (C) 2015 Vicent Gimenez Alventosa				  ///
//										  ///
//    Voxel Mages is free software: you can redistribute it and/or modify	  ///
//    it under the terms of the GNU General Public License as published by	  ///
//    the Free Software Foundation, either version 3 of the License, or		  ///
//    (at your option) any later version.					  ///
//										  ///
//    Foobar is distributed in the hope that it will be useful,			  ///
//    but WITHOUT ANY WARRANTY; without even the implied warranty of		  ///
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the		  ///
//    GNU General Public License for more details.				  ///
//										  ///
//    You should have received a copy of the GNU General Public License		  ///
//    along with Foobar.  If not, see <http://www.gnu.org/licenses/>.		  ///
/////////////////////////////////////////////////////////////////////////////////////    
 
/////////////////////////////////////////////////////////////////////////////////////////////////
//											       //
//				ARXIU AMB LA GEOMETRIA DE LA SIMULACIÓ			       //
//											       //
/////////////////////////////////////////////////////////////////////////////////////////////////

#ifndef GEOMETRIA_H
#define GEOMETRIA_H

#include<iostream>
#include<cstdlib>
#include<ctime>
#include<cstdio>
#include<fstream>
#include<cmath>
#include<GL/glut.h>
#include<string>
#include<sstream>
#include<fstream>
#include<cctype>

#include "objectes.h"
#include "menu.h"

#define MaxCubs 50
#define MaxEsferes 50
#define MaxCilindres 50
#define MaxPlans 50
#define MaxSecEsf 50

#define MaxFigures MaxCubs+MaxEsferes+MaxCilindres+MaxPlans+MaxSecEsf

#define MAX_CARACTERS_INTRODUIR 99 //Defineix el nombre maxim de caracters en les cadenes de caracters standard per a introduir dades

#define MAX_PRIORITAT 1000

#define AMPLADA_INICIAL 1500 //Guarda l'amplada original de la finestra del programa
#define ALTURA_INICIAL 700 //Guarda l'altura original de la finestra del programa
#define MAX_NOMBRE_CONTORNS 100 //Guarda el nombre màxim de contorns per a un dicom
#define MAX_TIPUS_LLAVORS 100 //Guarda el nombre màxim de tipus de llavors que por tindre un dicom

///////Contorns dicom////////
extern double** Punts_Contorn[MAX_NOMBRE_CONTORNS]; //Cada element del vector guardara tots els punts tridimensionals d'un contorn ordenats per plans. Cada 3 valors tindrem un punt (x,y,z)
extern int Nombre_Plans_Contorn[MAX_NOMBRE_CONTORNS]; //Guarda el nombre de plans que te cada contorn
extern int* Nombre_Punts_Contorn[MAX_NOMBRE_CONTORNS]; //Guarda el nombre de punts de cada pla del contorn
extern int Color_Contorn[MAX_NOMBRE_CONTORNS][3]; //Cada element del vector guarda el color d'un contorn en una upla de 3 (RGB);
extern std::string Nom_Contorn[MAX_NOMBRE_CONTORNS]; //Cada element del vector guarda el nom d'un contorn
extern int Nombre_Contorns;
extern unsigned long int Nombre_Voxels_Contorn[MAX_NOMBRE_CONTORNS]; //Guarda el nombre de voxels dins de cada contorn 
extern double Origen_Dicom[3]; //Guarda l'origen (x,y,z) del pla inferior del DICOM 
/////////////////////////////
///////Llavors dicom/////////
extern double* Posicio_Llavor[MAX_TIPUS_LLAVORS]; //Cada element, conte les posicions de les llavors d'un tipus [tipus_llavor(0,1,2,3...)][component]. Les components estan ordenades de la forma x1,y1,z1,x2,y2,z2... on els index 1,2... marquen el numero de llavor d'aquest tipus
extern int Nombre_Llavors[MAX_TIPUS_LLAVORS]; //Guarda el nombre de llavors de cada tipus
extern int Nombre_Tipus_Llavors; //Guarda el nombre de tipus diferents de llavors
/////////////////////////////
extern float MARGES;   //Factor de l'amplada i altura dels viewports destinada als marges

extern float AMPLADA_PANTALLA_GUARDAR_CARREGAR; //Factor de l'amplada de la finestra de guardar/carregar
extern float ALTURA_PANTALLA_GUARDAR_CARREGAR; //Factor de l'altura de la finestra de guardar/carregar

extern float AMPLADA_PANTALLA_GRAN; //Factor que controla l'amplada de la pantalla gran del visor
extern float ALTURA_PANTALLA_GRAN; //Factor que controla l'altura de la pantalla gran del visor
extern float ORIGEN_PANTALLA_GRAN_X;
extern float ORIGEN_PANTALLA_GRAN_Y;

extern float AMPLADA_PANTALLA_MENUDA; //Factor que controla l'amplada de les pantalles menudes del visor
extern float ALTURA_PANTALLA_MENUDA; //Factor que controla l'altura de les pantalles menudes del visor

extern float ORIGEN_PANTALLA_INFERIOR_X;
extern float ORIGEN_PANTALLA_INFERIOR_Y;

extern float ORIGEN_PANTALLA_SUPERIOR_X;
extern float ORIGEN_PANTALLA_SUPERIOR_Y;

extern float AMPLADA_MENU; //Factor que controla l'amplada del menu
extern float ALTURA_MENU; //Factor que controla l'altura del menu

extern float ORIGEN_MENU_X;
extern float ORIGEN_MENU_Y;

extern float AMPLADA_VISOR_2D; //Factor que controla l'amplada del visor 2D
extern float ALTURA_VISOR_2D; //Factor que controla l'altura del visor 2D

extern float ORIGEN_VISOR_2D_X;
extern float ORIGEN_VISOR_2D_Y;


extern int AMPLADA;   //Amplada de la finestra completa
extern int ALTURA;    //Altura de la finestra completa

extern int AMPLADA2;  //Amplada de la finestra de guardar/carregar
extern int ALTURA2;   //Altura de la finestra de guardar/carregar

extern int Dimensions_Pantalla_Gran[2];
extern int Origen_Pantalla_Gran[2];

extern int Dimensions_Pantalla_Menuda[2];
extern int Origen_Pantalla_Inferior[2];
extern int Origen_Pantalla_Superior[2]; //

extern int Dimensions_Menu[2];
extern int Origen_Menu[2];

extern int Dimensions_Visor2D[2];
extern int Origen_Visor2D[2];

//Nombre de Cubs					//
extern int NumCubs;
//Nombre d'Esferes					//
extern int NumEsf;
  //Nombre de Cilindres					//
extern int NumCil;
  //Nombre de Plans					//
extern int NumPla;
  //Nombre de Seccions d'esfera
extern int NumSecEsf;

extern Rectangle rectangles[MaxCubs+1];
extern Esfera esferes[MaxEsferes+1];
extern Cilindre cilindres[MaxCilindres+1];
extern Pla plans[MaxPlans+1];
extern SeccioEsfera secEsf[MaxSecEsf+1];

//////////////////////////////////////////////////////////
//////////////////Tamanys de lletres//////////////////////
//////////////////////////////////////////////////////////

extern float Tamany_Lletra_Menu;
extern float Tamany_Lletra_Botons_Menu;
extern float Tamany_Lletra_Quadres_Dades;
extern float Tamany_Lletra_Pantalla_Geometria;

/////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////BOTONS//////////////////////////////////
////////////////////////////////////////////////////////// 
extern B_Rect NovaFigura; 
extern B_Rect SelFigura;
extern B_Rect BColor;
extern B_Rect BGuardar;
extern B_Rect BGuardarVox;
extern B_Rect BCarregar;
extern B_Rect BEspai;
extern B_Rect BSimulacio;
extern B_Rect BLlengua;
extern B_Rect BResultats;
extern B_Rect BDicom;
extern B_Rect BTransformarGrup;

extern B_Rect NouCub;
extern B_Rect NovaEsfera;
extern B_Rect NouCilindre;
extern B_Rect NouPla;
extern B_Rect NouSeccioEsf;

extern B_Rect ColorObjecte;
extern B_Rect ColorMaterial;
extern B_Rect ColorPrioritat;
extern B_Rect ColorVoxels;
extern B_Rect ColorOpacitat;

extern B_Rect CVoxPunts;
extern B_Rect CVoxQuad;
extern B_Rect CVoxPla[3];
extern B_Rect CVoxPlaInf[3];
extern B_Rect BMallat;

extern B_Rect BGuardarGeo;
extern B_Rect BGuardarPenelope;
extern B_Rect BGuardarGeant4;
extern B_Rect BGuardarVoxelsPene;

extern B_Rect Crear;

extern B_Rect Centre[3];		//Per a introduir el centre del cub
extern B_Rect Dim[3];			//Per a introduir les dimensions del cub
extern B_Rect Prioritat;		//Per a introduir la prioritat al pintar	
extern B_Rect Interns;			//Per a introduir quines figures estan contingudes en aquesta
extern B_Rect AfegirInterns[2];	//Per a afegir i eliminar el grup de prioritat als interns de la figura
extern B_Rect MatDens[2];		//Per a afegir el material i la densitat al cub
extern B_Rect Angles[3];
extern B_Rect BTub;             //Per a dir si un cilindre es un tub o un cilindre/con masis

extern B_Rect BNetejarSeleccio;        //Neteja la seleccio de les figures a transformar
extern B_Rect IFiguraSelec;	       //Per a introduir la figura a seleccionar
extern B_Rect IMaterialSelec;          //Per a introduir el numero de material a seleccionar
extern B_Rect ICosSelec;               //Per a introduir el cos a seleccionar
extern B_Rect AfegirFiguraSelec[2];    //Afig la figura amb el numero especificat
extern B_Rect AfegirMaterialSelec[2];  //Afig les figures amb el material especificat
extern B_Rect AfegirCosSelec[2];       //Afig les figures amb el cos especificat
extern B_Rect BTranslacio;             //Ens permet translladar el grup de figures de la llista
extern B_Rect BParametresTransformacio[3]; //Botons per a introduir els parametres de la transformacio
extern B_Rect BBorrar;

extern B_Rect BNumVox[3];
extern B_Rect BDimVox[3];
/////////////////Botons menu 2///////////////////////////
extern B_Rect BGuardar2;
extern B_Rect BINomArxiu2;
extern B_Rect BCancelar2;
extern B_Rect BBorrar2;
extern B_Rect BCarregar2;

/////////////////Botons simulacio////////////////////////

extern B_Rect BNomSimulacio;
extern B_Rect BNomArxiuConfig;
//B_Rect BNomArxiuMaterials;
extern B_Rect BNomArxiuGeoQuad;
extern B_Rect BNomArxiuGeoVox;
extern B_Rect BNumSimulacions;

/////////////////Botons visor resultats///////////////////////

extern B_Rect BDosiMax;
extern B_Rect BDosiMin;

extern B_Rect BEscalaLog;
/////////////////Botons idioma////////////////////////
extern B_Rect BIdioma[3];
/////////////////Botons visor DICOMs///////////////////////
extern B_Rect Tallar;
extern B_Rect BPintMatDCM;
extern B_Rect BPintDensDCM;
extern B_Rect BDicom2D;
extern B_Rect BContornsDICOM;
/////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////FI DELS BOTONS//////////////////////////
////////////////////////////////////////////////////////// 


extern GLfloat Colors[200][3];
extern  bool PintEsp;					
extern  bool PintVox;	
extern  bool PintMallat;
extern  bool PintObjectes;
extern  bool PintVQuad;
extern  int  PintObMat;
extern  float OpacitatNormal;           //Controla l'opacitat de les figures, per a que siguen transparents o opaques.
extern  bool menuCreat;			//Mira si ja s'han canviat les caracteristiques dels botons
extern  bool menuCreat2;
extern  float TamanyBotons[2];
extern  int ControlMenu;
extern  int ControlSubMenu;				
extern  int ControlSubSubMenu;			
extern  float DistBotonsY;		//Marca la distancia entre botons en l'eix Y
extern  int Idioma;			//Controla l'idioma del programa, 0 és angles, 1 català i 2 castellà

//Variables d'introducció de dades
//////////SELECCIONAR FIGURA/////////
extern int ISelFig;
extern int ISelCos;
extern int ISelMaterial;
extern int FiguresSeleccionades[1000];
extern int NumFiguresSeleccionades;
extern int IParametresTransformacio[3];

extern char ISelFigChar[4];
extern char ISelCosChar[4];
extern char ISelMaterialChar[4];
extern char IParametresTransformacioChar[3][100];

extern bool SeleccioFigura;	//Controla si estem modificant una figura ja existent o creant una
extern int TipusFiguraSel;		//Guarda el tipus de figura seleccionada (1-rectangle,2-esfera,3-cilindre/con,4-pla,5-seccio d'esfera)
extern int NumFigSel;		//Guarda la posició que ocupa la figura seleccionada dins del vector d'eixe tipus de figura
//////////GUARDAR CARREGAR ARXIUS////
extern char INomArxiuChar[100];


///////////SIMULACIO/////////////////
extern char INomSimulacio[100];
extern char INomArxiuConfig[100];
//extern char INomArxiuMaterials[100];
extern char INomArxiuGeoQuad[100];
extern char INomArxiuGeoVox[100];
extern char INumSimulacions[2];

extern std::string NomSimulacio;
extern std::string NomArxiuConfig;
//extern std::string NomArxiuMaterials[20];
extern std::string NomArxiuGeoQuad;
extern std::string NomArxiuGeoVox;
extern int NumSimulacions;

///////////VISOR RESULTATS///////////
extern float MaxDosis;	//guarda la dosi màxima i mínima per a asignar després els colors
extern float MinDosis;
extern char IMaxDosisChar[100];
extern char IMinDosisChar[100];
extern float IntervalColorResultats;
extern int NumColorsResultats;
extern float DosisMaximaResultats;	//Guarda la dosi màxima dels resultats
extern float ColorsResultats[12][3];
extern bool EscalaLog;

///////////VISOR DICOMS//////////////
extern char INomDicom[100];

extern std::string ModalitatDicom;             //Guarda la modalitat de dicom que estem vegent (CT, US...)
extern std::string NomDicom;
extern float IntervalColorDicom;		//Per al visor de densitats, guarda el tamany dels intervals de color.
extern float MaxDensDCM;			//Guarda la densitat màxima de l'escala de densitats dels dicom
extern float MinDensDCM;			//Guarda la densitat mínima de l'escala de densitats dels dicom

extern bool PintarDicom;		//Controla si estem pintant una imatge dicom
extern bool PintMatDicom;			//Controla si pintem els materials del dicom
extern bool PintDensDicom;			//Controla si pintem les densitats del dicom
extern bool GuardarVoxDicomRep;		//Controla si ja tenim els vòxels que cal representar en un fitxer
extern bool DibuixarContorns;    //Controla si han de dibuixar-se els contorns
extern bool GuardarVoxDicomRepVisible;		//Igual que la anterior pero controla si estan guardats els fitxers amb els vòxels visibles
extern float DimEspaiDicom[3];
//////////Visor 2D////////////
extern bool ActivarVisor2D;
extern int PlaVisor2D;
extern float AmpladaVisor2D;
extern float AlturaVisor2D;
extern float DimPlaDicom[3];
///////////CUBS//////////////////////
extern char ICentreCubChar[3][100];
extern char IDimCubChar[3][100];
extern char IPrioritatCubChar[4];
extern char IDinsCubChar[4];
extern char DinsCubChar[100][4];
extern char IMatCubChar[3];
extern char IDensCubChar[100];
extern char IAnglesCubChar[3][100];

extern double ICentreCub[3];
extern double IDimCub[3];
extern int IPrioritatCub;
extern int IDinsCub[100];
extern int IMatCub;
extern float IDensCub;
extern double IAnglesCub[3];

////////////ESFERES//////////////////
extern double ICentreEsf[3];
extern double IDimEsf;
extern int IPrioritatEsf;
extern int IDinsEsf[100];
extern int IMatEsf;
extern float IDensEsf;

extern char ICentreEsfChar[3][100];
extern char IDimEsfChar[100];
extern char IPrioritatEsfChar[4];
extern char IDinsEsfChar[4];
extern char DinsEsfChar[100][4];
extern char IMatEsfChar[3];
extern char IDensEsfChar[100];

///////////CILINDRES//////////////////////
extern char ICentreCilChar[3][100];
extern char IDimCilChar[3][100];
extern char IPrioritatCilChar[4];
extern char IDinsCilChar[4];
extern char DinsCilChar[100][4];
extern char IMatCilChar[3];
extern char IDensCilChar[100];
extern char IAnglesCilChar[3][100];


extern double ICentreCil[3];
extern double IDimCil[3];
extern int IPrioritatCil;
extern int IDinsCil[100];
extern int IMatCil;
extern float IDensCil;
extern double IAnglesCil[3];
extern bool ITubCil;
///////////PLA INFINIT/////////////////////
extern double ICentrePla[3];
extern int IPrioritatPla;
extern int IDinsPla[100];
extern int IMatPla;
extern float IDensPla;
extern double IAnglesPla[3];

extern char ICentrePlaChar[3][100];
extern char IPrioritatPlaChar[4];
extern char IDinsPlaChar[4];
extern char DinsPlaChar[100][4];
extern char IMatPlaChar[3];
extern char IDensPlaChar[100];
extern char IAnglesPlaChar[3][100];

///////////SECCIO D'ESFERA//////////////////////
extern char ICentreSecEsfChar[3][100];
extern char IDimSecEsfChar[2][100];
extern char IPrioritatSecEsfChar[4];
extern char IDinsSecEsfChar[4];
extern char DinsSecEsfChar[100][4];
extern char IMatSecEsfChar[3];
extern char IDensSecEsfChar[100];
extern char IAnglesSecEsfChar[3][100];

extern double ICentreSecEsf[3];
extern double IDimSecEsf[2];
extern int IPrioritatSecEsf;
extern int IDinsSecEsf[100];
extern int IMatSecEsf;
extern float IDensSecEsf;
extern double IAnglesSecEsf[3];


//////////////////////ESPAI/////////////////////////////
extern int INumVox[3];
extern float IDimVox[3];

extern char INumVoxChar[3][4];
extern char IDimVoxChar[3][100];
///////////////////////////////////////////////
//////////////////////PLANS VOXELS/////////////////////////////
extern float PlansTall[3];
extern float PlansTallInf[3];

extern char IPlansTallChar[3][100];
extern char IPlansTallCharInf[3][100];


////////////////////////////////////////////////////////
//////////////////////LLISTA VOXELS/////////////////////
////////////////////////////////////////////////////////

extern bool CrearLlistaVox;		//Controla si s'ha de crear la llista amb els voxels
extern bool VoxelsActualitzats;		//Controla si cal voxelitzar la geometria o ja està actualitzat el voxelitzat
extern bool CrearLlistaMallat;		//Controla si s'ha de crear la llista amb el mallat
extern bool MallatActualitzat;
////////////////////////////////////////////////////////
//////////////////////MALLAT////////////////////////////
////////////////////////////////////////////////////////
//extern Mallat Malla1;
////////////////////////////////////////////////////////
void geo();	//asi definim tota la geometria de la simulacio
void mostrar();	//Cridarem a aquesta funcio per a mostrar la geometria per pantalla
void MostrarMenu(); //Aquesta funcio pintara el menu d'opcions
void MostrarMenu2();	//Pintara el menu de la finestra guardar/carregar
void iniciar(void);
void iniciarF2(void);
#endif
