/////////////////////////////////////////////////////////////////////////////////////
//    This file is part of Voxel Mages 						  ///
//    Copyright (C) 2015 Vicent Gimenez Alventosa				  ///
//										  ///
//    Voxel Mages is free software: you can redistribute it and/or modify	  ///
//    it under the terms of the GNU General Public License as published by	  ///
//    the Free Software Foundation, either version 3 of the License, or		  ///
//    (at your option) any later version.					  ///
//										  ///
//    Foobar is distributed in the hope that it will be useful,			  ///
//    but WITHOUT ANY WARRANTY; without even the implied warranty of		  ///
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the		  ///
//    GNU General Public License for more details.				  ///
//										  ///
//    You should have received a copy of the GNU General Public License		  ///
//    along with Foobar.  If not, see <http://www.gnu.org/licenses/>.		  ///
/////////////////////////////////////////////////////////////////////////////////////    
 

#include "menu.h"

botons::botons()
{
  Centre[0]=0;		//Iniciem la posicio al {0,0,0} ({x,y,z})
  Centre[1]=0;
  Centre[2]=0;
  
  Color[0]=1;		//Inicialment el botó serà blanc i opac
  Color[1]=1;
  Color[2]=1;
  Color[3]=1;

  ColorCont[0]=0;		//Inicialment el botó tindrà contorn color negre i opac
  ColorCont[1]=0;
  ColorCont[2]=0;
  ColorCont[3]=1;
  
  ColorText[0]=0;		//Inicialment el text serà Negre i opac
  ColorText[1]=0;
  ColorText[2]=0;
  ColorText[3]=1;

  LimitSuperior=0.0;
  LimitInferior=0.0;
  LimitDret=0.0;
  LimitEsquerra=0.0;
  
  UtilitzarTextura=false;
  DimTextura[0]=0;
  DimTextura[1]=0;
  
  Text=" ";			  //Li escrivim BOTO per defecte
  
  LlistaCreada=false;	//No esta creada la llista amb el boto pintat
}

//--------------------------------------Funcio de canviar text del boto------------------------------------------------//
void botons::Escriure(std::string NouText,float Tamany)
{
  Text=NouText;
  TamanyLletra=Tamany;
  Dibuixar();			//Redibuixa el botó
  
}

//-------------------------------------Funcio de canviar el color del boto---------------------------------------------//

void botons::ColorInt(GLfloat NouColor[4])
{
  Color[0]=NouColor[0];
  Color[1]=NouColor[1];
  Color[2]=NouColor[2];
  Color[3]=NouColor[3];
  
  Dibuixar();			//Redibuixa el botó
}

//-------------------------------------Funcio de canviar el color del contorn-----------------------------------//

void botons::ColorExt(GLfloat NouColorExt[4])
{
  ColorCont[0]=NouColorExt[0];
  ColorCont[1]=NouColorExt[1];
  ColorCont[2]=NouColorExt[2];
  ColorCont[3]=NouColorExt[3];
  
  Dibuixar();			//Redibuixa el botó
}

//-------------------------------------Funcio de canviar el color del text-----------------------------------//

void botons::ColorLletra(GLfloat NouColorText[4])
{
  ColorText[0]=NouColorText[0];
  ColorText[1]=NouColorText[1];
  ColorText[2]=NouColorText[2];
  ColorText[3]=NouColorText[3];
  
  Dibuixar();			//Redibuixa el botó
}


//-------------------------------------Funcio de moure el centre del boto-----------------------------------------//

void botons::Moure(GLfloat NouCentreX,GLfloat NouCentreY,GLfloat NouCentreZ)
{
  Centre[0]=NouCentreX;
  Centre[1]=NouCentreY;
  Centre[2]=NouCentreZ;
  
  Dibuixar();			//Redibuixa el botó
}

//-------------------------------------Funcio per a assignar textura al boto-----------------------------------------//
void botons::ActivarTextura(bool Activar,GLuint NomTexturaBoto,int NouDimTexturaX,int NouDimTexturaY)
{
  UtilitzarTextura=Activar;
  TexturaBoto=NomTexturaBoto;
  DimTextura[0]=NouDimTexturaX;
  DimTextura[1]=NouDimTexturaY;
  
  Dibuixar();
}
//-------------------------------------Funcio per a mostrar el boto per pantalla----------------------------------------------//

void botons::Mostra()
{
  //Comprovem si la llista ja està creada, sinó la crearem.
  if(LlistaCreada==false)
  {
    Dibuixar();
  }
  glCallList(Llista);
}

//////////////////////////////////////////////FUNCIONS DE LA SUBCLASE B_RECT//////////////////////////////////////////////

B_Rect::B_Rect()
{
  Dimensions[0]=3;			//Inicialitzem unes dimensions per defecte	
  Dimensions[1]=1;
  
  
}

//---------------------------------------------Funcio de canviar tamany--------------------------------------------------//
void B_Rect::Tamany(float x, float y)
{
  Dimensions[0]=x;
  Dimensions[1]=y;
  
  Dibuixar();			//Redibuixa el botó
}

//-------------------------------------------------Funcio dibuixar--------------------------------------------------------//

void B_Rect::Dibuixar()
{
  if(LlistaCreada==true)	//Si la llista ja esta creada previament es borrarà
  {
    glDeleteLists(Llista,1);
  }
  
  Llista=glGenLists(1);		//Genera un identificador per a la llista
  glNewList(Llista, GL_COMPILE);	//Comença la llista
    
    glMatrixMode(GL_MODELVIEW);		//Posem el MODELVIEW per a transformar l'objecte, no la càmera
    glPushMatrix();			//Fem una copia de la matriu actual i escrivim sobre la copia
  
    glTranslated(Centre[0],Centre[1],Centre[2]);		 //Translladem el el centre de la pantalla al centre de l'objecte per a dibuixar-lo

    //Comprovem si hem d'utilitzar textura o no
    if(UtilitzarTextura==false)
    {
      //Dibuixem el cos del botó
      glColor4f(Color[0], Color[1], Color[2], Color[3]);
      glBegin(GL_POLYGON); 
	glVertex3f(-Dimensions[0]/2.0, -Dimensions[1]/2.0, 0);
	glVertex3f(+Dimensions[0]/2.0, -Dimensions[1]/2.0, 0);
	glVertex3f(+Dimensions[0]/2.0, +Dimensions[1]/2.0, 0);
	glVertex3f(-Dimensions[0]/2.0, +Dimensions[1]/2.0, 0);
	glVertex3f(-Dimensions[0]/2.0, -Dimensions[1]/2.0, 0);
      glEnd();
      
      //Dibuixem el contorn del botó
      glColor4f(ColorCont[0], ColorCont[1], ColorCont[2], ColorCont[3]);
      glBegin(GL_LINE_STRIP); 
	glVertex3f(-Dimensions[0]/2.0, -Dimensions[1]/2.0, 0.001);
	glVertex3f(+Dimensions[0]/2.0, -Dimensions[1]/2.0, 0.001);
	glVertex3f(+Dimensions[0]/2.0, +Dimensions[1]/2.0, 0.001);
	glVertex3f(-Dimensions[0]/2.0, +Dimensions[1]/2.0, 0.001);
	glVertex3f(-Dimensions[0]/2.0, -Dimensions[1]/2.0, 0.001);
      glEnd();
    }    
    else if(UtilitzarTextura==true)
    {
      glEnable(GL_TEXTURE_2D);
      glBindTexture(GL_TEXTURE_2D, TexturaBoto);
      
      glColor4f(Color[0], Color[1], Color[2], Color[3]);
      glBegin(GL_QUADS);      
	glTexCoord2f(0.0f,0.0f); glVertex3f(-Dimensions[0]/2.0, -Dimensions[1]/2.0, 0.001);
	glTexCoord2f(float(Dimensions[0]/DimTextura[0]),0.0f); glVertex3f(+Dimensions[0]/2.0, -Dimensions[1]/2.0, 0.001);
	glTexCoord2f(float(Dimensions[0]/DimTextura[0]),float(Dimensions[1]/DimTextura[1])); glVertex3f(+Dimensions[0]/2.0, +Dimensions[1]/2.0, 0.001);
	glTexCoord2f(0.0f,float(Dimensions[1]/DimTextura[1])); glVertex3f(-Dimensions[0]/2.0, +Dimensions[1]/2.0, 0.001);
      glEnd();
      glDisable(GL_TEXTURE_2D);
    }
    //Escrivim el text a l'interior del botó
    glColor4f(ColorText[0], ColorText[1], ColorText[2], ColorText[3]);
    
    escriure2(Text,-Dimensions[0]/2+Dimensions[0]*0.02,-0.20*Dimensions[1],0.1,TamanyLletra);
  
    
    glPopMatrix();			//Tornem a a matriu inicial

  glEndList();				//acaba la llista

  //Calculem els limits del boto
  LimitSuperior=Centre[1]+Dimensions[1]/2.0;
  LimitInferior=Centre[1]-Dimensions[1]/2.0;
  LimitDret=Centre[0]+Dimensions[0]/2.0;
  LimitEsquerra=Centre[0]-Dimensions[0]/2.0;
  //Acabem dient que la llista està creada
  LlistaCreada=true;
  
}
