/////////////////////////////////////////////////////////////////////////////////////
//    This file is part of Voxel Mages 						  ///
//    Copyright (C) 2015 Vicent Gimenez Alventosa				  ///
//										  ///
//    Voxel Mages is free software: you can redistribute it and/or modify	  ///
//    it under the terms of the GNU General Public License as published by	  ///
//    the Free Software Foundation, either version 3 of the License, or		  ///
//    (at your option) any later version.					  ///
//										  ///
//    Foobar is distributed in the hope that it will be useful,			  ///
//    but WITHOUT ANY WARRANTY; without even the implied warranty of		  ///
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the		  ///
//    GNU General Public License for more details.				  ///
//										  ///
//    You should have received a copy of the GNU General Public License		  ///
//    along with Foobar.  If not, see <http://www.gnu.org/licenses/>.		  ///
/////////////////////////////////////////////////////////////////////////////////////    

#include "objectes.h"

float Proporcio_Lletra=1.0; //Factors que controlen el tamany de les lletres
int NumVoxels[3];
int PuntsGenVoxel=30;
int NumTotalFig=0;			//Conta el numero total de figures
//float Voxels[200][200][200][2];		//Ordenem els voxels en numero que ocupa en els eixos x,y,z i el [2] correspon a material i densitat
//float VoxelsCopia[200][200][200][2];
float**** Voxels;		//Ordenem els voxels en numero que ocupa en els eixos x,y,z i el [2] correspon a material i densitat
float**** VoxelsCopia;
int NumVoxelsAntic[3];
bool MatriuVoxelsConstruida=false;	//Controla si s'ha la matriu de voxels 

float RadiMaxVoxel;
float DimEspai[3]={0};
double DimVoxels[3];
bool CrearPunts=false;
int MaxMaterial=0;		//Indica quin número de material és el més alt
int MaxPrioritat=0;
int PrioritatsAsignades[1][1001]={0};	//Indica les prioritats que s'han utilitzat [0] i les que s'han assignat a dintre d'un objecte [1]
//---------------------------------Constructor de la matriu de voxels--------------------------------------------------------------//
void ConstruirMatriuVoxels(int PixelsX,int PixelsY,int PixelsZ)
{

    int ContConsVox=0;
    int ContConsVox2=0;
    int ContConsVox3=0;  

  //Si la matriu ja està construida l'eliminem//
  if(MatriuVoxelsConstruida==true)
  {
    while(ContConsVox<NumVoxelsAntic[0])
    {
      ContConsVox2=0;
      while(ContConsVox2<NumVoxelsAntic[1])
      {
	ContConsVox3=0;
	while(ContConsVox3<NumVoxelsAntic[2])
	{
	  delete[] Voxels[ContConsVox][ContConsVox2][ContConsVox3];	  
	  ContConsVox3++;
	}
	delete[] Voxels[ContConsVox][ContConsVox2];	  	
	ContConsVox2++;
      }
      delete[] Voxels[ContConsVox];	  
      ContConsVox++;
    }
    delete[] Voxels;
    MatriuVoxelsConstruida=false;
  }    

  //Construim la matriu de voxels i la inicialitzem
    ContConsVox=0;
    ContConsVox2=0;
    ContConsVox3=0;

    Voxels= new float***[PixelsX];
    while(ContConsVox<PixelsX)
    {
      Voxels[ContConsVox]=new float**[PixelsY];
      ContConsVox2=0;
      while(ContConsVox2<PixelsY)
      {
	Voxels[ContConsVox][ContConsVox2]=new float*[PixelsZ];
	ContConsVox3=0;
	while(ContConsVox3<PixelsZ)
	{
	  Voxels[ContConsVox][ContConsVox2][ContConsVox3]=new float[2];
	  
	  Voxels[ContConsVox][ContConsVox2][ContConsVox3][0]=1;
	  Voxels[ContConsVox][ContConsVox2][ContConsVox3][1]=1;
	  ContConsVox3++;
	}
	ContConsVox2++;
      }
      
      ContConsVox++;
    }
    NumVoxelsAntic[0]=NumVoxels[0];
    NumVoxelsAntic[1]=NumVoxels[1];
    NumVoxelsAntic[2]=NumVoxels[2];
    MatriuVoxelsConstruida=true;    
}
//---------------------------------Constructor--------------------------------------------------------------//
Objectes::Objectes()
{
  ColorRGBA[0]=1.0; //Color de l'objecte
  ColorRGBA[1]=0.0;
  ColorRGBA[2]=0.0;
  ColorRGBA[3]=0.5;
  ColorEspecular[0]=1.0; //Color que es reflexa
  ColorEspecular[1]=1.0;
  ColorEspecular[2]=1.0;
  ColorEspecular[3]=1.0;
  Shininess=100;	//Concentració de la reflexio de la llum
  Centre[0]=0;	//Centre de l'objecte
  Centre[1]=0;
  Centre[2]=0;
  Alfa=0;		//Angles fi i tecta per a girar l'objecte
  Beta=0;
  Gamma=0;
  Material=0;		//0 és el buit
  Prioritat=0;
  
  llistaCreada=false; //La llista no esta creada
  
  Densitat=0;
}
//--------------------------------Funció que torna el número de figura-----------------------------//
int Objectes::NumeroFigura() const
{
  return NFigura;
}

//---------------------------------Funcio asignar numero a la figura-------------------------//
void Objectes::AsignarNumero()
{
  NumTotalFig++;
  NFigura=NumTotalFig;
}

//----------------------------------Funcio que canvia la densitat--------------------------------//
void Objectes::CanviarMaterial(int NouMaterial,float NouDensitat)
{
  Material=NouMaterial;
  Densitat=NouDensitat;
  
  if(Material>MaxMaterial)	//Amb açò controlarem quin és l'index de material més alt
  {
    MaxMaterial=Material;
  }
  
  CrearLlista();
}

//----------------------------------Funcio que canvia el color--------------------------------------//
void Objectes::CanviarColor(GLfloat nouColorR,GLfloat nouColorG,GLfloat nouColorB)
{
  ColorRGBA[0]=nouColorR;
  ColorRGBA[1]=nouColorG;
  ColorRGBA[2]=nouColorB;
  
  CrearLlista();
}
//----------------------------------Funcio que canvia la opacitat--------------------------------------//
void Objectes::CanviarOpacitat(GLfloat nouOpacitat)
{
  ColorRGBA[3]=nouOpacitat;
  CrearLlista();
}
//----------------------------------Funcio que canvia el Centre-----------------------------------//
void Objectes::CanviarCentre(double nouCentreX,double nouCentreY,double nouCentreZ)
{
  Centre[0]=nouCentreX;
  Centre[1]=nouCentreY;
  Centre[2]=nouCentreZ;
  CrearLlista();
}


//--------------------------------Funcio que torna la Densitat-------------------------------------//
float Objectes::LlegirDensitat() const
{
  return Densitat;
}

//-----------------------Funció que canvia els angles per a girar l'objecte usant angles de Euler (Gira eix Z, eix X' i Eix Z'')------------------//

void Objectes::Girar(double nouAlfa,  double nouBeta, double nouGamma)
{
  Alfa=nouAlfa;
  Beta=nouBeta;
  Gamma=nouGamma;

  
  CrearLlista();
}

//-------------------------------Funcio pintar (A partir d'una llista)-----------------------//
void Objectes::Pintar()
{
  if(llistaCreada==false || CrearPunts==true)
  {
    CrearLlista();
  }
  
  glCallList(llista);
}
  //---------------------------------Constructor  Rectangle------------------------------------------------------------//
Rectangle::Rectangle()
{
  Dimensions[0]=1; //Dimensions del rectangle {x,y,z}
  Dimensions[1]=1;
  Dimensions[2]=1;
  
}
//-----------------------------------Operador =------------------------------------------------------------------------------//
Rectangle Rectangle::operator=(const Rectangle &c)
{
  //Comuns en totes les subclases de objectes//
  radiMax=c.radiMax;
  Densitat=c.Densitat;
  llista=c.llista;
  llistaCreada=c.llistaCreada;
  ColorRGBA[0]=c.ColorRGBA[0];
  ColorRGBA[1]=c.ColorRGBA[1];
  ColorRGBA[2]=c.ColorRGBA[2];
  ColorRGBA[3]=c.ColorRGBA[3];
  ColorEspecular[0]=c.ColorEspecular[0];
  ColorEspecular[1]=c.ColorEspecular[1];
  ColorEspecular[2]=c.ColorEspecular[2];
  ColorEspecular[3]=c.ColorEspecular[3];
  Shininess=c.Shininess;
  NFigura=c.NFigura;
  int i=0;
  while(i<100)
  {
    PDins[i]=c.PDins[i];
    i++;
  }
  Alfa=c.Alfa;
  Beta=c.Beta;
  Gamma=c.Gamma;
  Centre[0]=c.Centre[0];
  Centre[1]=c.Centre[1];
  Centre[2]=c.Centre[2];
  Material=c.Material;
  Prioritat=c.Prioritat;
  
  //especifiques//
  Dimensions[0]=c.Dimensions[0];
  Dimensions[1]=c.Dimensions[1];
  Dimensions[2]=c.Dimensions[2];
  return(*this);
}
//------------------------------------Controla les dimensions del rectangle---------------------------------------------//
void Rectangle::CanviarDimensions(double nouDimensionsX,double nouDimensionsY,double nouDimensionsZ)
{
  //(Amplada x, Amplada y, Amplada z)
  Dimensions[0]=fabs(nouDimensionsX);
  Dimensions[1]=fabs(nouDimensionsY);
  Dimensions[2]=fabs(nouDimensionsZ);
  
  CrearLlista();
}

  //---------------------------------Constructor  Cilindre------------------------------------------------------------//
Cilindre::Cilindre()
{
  Tub=false;

  Dimensions[0]=1; //Dimensions del cilindre {altura,radi superior,radi inferior}
  Dimensions[1]=1;
  Dimensions[2]=1;

  
}
//-----------------------------------Operador =------------------------------------------------------------------------------//
Cilindre Cilindre::operator=(const Cilindre &c)
{
  //Comuns en totes les subclases de objectes//
  radiMax=c.radiMax;
  Densitat=c.Densitat;
  llista=c.llista;
  llistaCreada=c.llistaCreada;
  ColorRGBA[0]=c.ColorRGBA[0];
  ColorRGBA[1]=c.ColorRGBA[1];
  ColorRGBA[2]=c.ColorRGBA[2];
  ColorRGBA[3]=c.ColorRGBA[3];
  ColorEspecular[0]=c.ColorEspecular[0];
  ColorEspecular[1]=c.ColorEspecular[1];
  ColorEspecular[2]=c.ColorEspecular[2];
  ColorEspecular[3]=c.ColorEspecular[3];
  Shininess=c.Shininess;
  NFigura=c.NFigura;
  int i=0;
  while(i<100)
  {
    PDins[i]=c.PDins[i];
    i++;
  }
  Alfa=c.Alfa;
  Beta=c.Beta;
  Gamma=c.Gamma;
  Centre[0]=c.Centre[0];
  Centre[1]=c.Centre[1];
  Centre[2]=c.Centre[2];
  Material=c.Material;
  Prioritat=c.Prioritat;
  
  //especifiques//
  Tub=c.Tub;
  Dimensions[0]=c.Dimensions[0];
  Dimensions[1]=c.Dimensions[1];
  Dimensions[2]=c.Dimensions[2];
  return(*this);
}
//------------------------------------Controla les dimensions del Cilindre---------------------------------------------//
void Cilindre::CanviarDimensions(double nouDimensionsA,double nouDimensionsRS,double nouDimensionsRI)
{
  //(altura,radi superior,radi inferior)
  Dimensions[0]=fabs(nouDimensionsA);
  Dimensions[1]=fabs(nouDimensionsRS);
  Dimensions[2]=fabs(nouDimensionsRI);
  
  CrearLlista();
}
//------------------------------------Controla si el Cilindre es un tub---------------------------------------------//
void Cilindre::ActivarTub(bool Activar)
{
  Tub=Activar;

  CrearLlista();
}
  //---------------------------------Constructor  Esfera------------------------------------------------------------//
Esfera::Esfera()
{
 
  Dimensions=1; //Dimensions de la esfera (radi)
  
}
//-----------------------------------Operador =------------------------------------------------------------------------------//
Esfera Esfera::operator=(const Esfera &c)
{
  //Comuns en totes les subclases de objectes//
  radiMax=c.radiMax;
  Densitat=c.Densitat;
  llista=c.llista;
  llistaCreada=c.llistaCreada;
  ColorRGBA[0]=c.ColorRGBA[0];
  ColorRGBA[1]=c.ColorRGBA[1];
  ColorRGBA[2]=c.ColorRGBA[2];
  ColorRGBA[3]=c.ColorRGBA[3];
  ColorEspecular[0]=c.ColorEspecular[0];
  ColorEspecular[1]=c.ColorEspecular[1];
  ColorEspecular[2]=c.ColorEspecular[2];
  ColorEspecular[3]=c.ColorEspecular[3];
  Shininess=c.Shininess;
  NFigura=c.NFigura;
  int i=0;
  while(i<100)
  {
    PDins[i]=c.PDins[i];
    i++;
  }
  Alfa=c.Alfa;
  Beta=c.Beta;
  Gamma=c.Gamma;
  Centre[0]=c.Centre[0];
  Centre[1]=c.Centre[1];
  Centre[2]=c.Centre[2];
  Material=c.Material;
  Prioritat=c.Prioritat;
  
  //especifiques//
  Dimensions=c.Dimensions;
  return(*this);
}
//------------------------------------Controla les dimensions de la esfera---------------------------------------------//
void Esfera::CanviarDimensions(double nouDimensions)
{
  //(radi)
  Dimensions=fabs(nouDimensions);
  
  CrearLlista();
}

//-----------------------------------------Constructor Pla infinit------------------------------------------------------//
Pla::Pla()
{
  Direccio[0]=0;	//components x,y,z del vector normal al pla
  Direccio[1]=0;
  Direccio[2]=1;
  
  Dimensions=20;		//Radi del cercle que representa el pla
}

//-----------------------------------------Canviar la direcció del Pla infinit------------------------------------------------------//
void Pla::CanviarDireccio(double nouDireccioX,double nouDireccioY,double nouDireccioZ)
{
  double AuxDireccio[3]={0,0,0};
  double Modul=sqrt(pow(nouDireccioX,2)+pow(nouDireccioY,2)+pow(nouDireccioZ,2));
  
  AuxDireccio[0]=nouDireccioX*1.0/Modul;
  AuxDireccio[1]=nouDireccioY*1.0/Modul;
  AuxDireccio[2]=nouDireccioZ*1.0/Modul;
  
  Direccio[0]=AuxDireccio[0];
  Direccio[1]=AuxDireccio[1];
  Direccio[2]=AuxDireccio[2];
 
  Beta=acos(Direccio[2]);
  if(Direccio[0]==0 && Direccio[1]==0)
  {
    Gamma=0;
  }
  else if(Direccio[0]==0)
  {
    Gamma=PI/2.0;
  }
  else
  {
    Gamma=atan(Direccio[1]*1.0/Direccio[0]);
  }
  //Resolem l'ambigüetat amb el signe//
  if(Direccio[0]<0)
  {
    Gamma=PI-Gamma;
  }  
  if(Direccio[1]<0)
  {
    Gamma=-Gamma;
  }
  
  //Pasem de radiants a angles
  Gamma=Gamma*180.0/PI;
  Beta=Beta*180.0/PI;
    
  CrearLlista();
}

//------------------------------------Controla les dimensions del Pla infinit---------------------------------------------//
void Pla::CanviarDimensions(double nouDimensions)
{
  Dimensions=fabs(nouDimensions);
  CrearLlista();
}

//-----------------------------------Operador =------------------------------------------------------------------------------//
Pla Pla::operator=(const Pla &c)
{
  //Comuns en totes les subclases de objectes//
  radiMax=c.radiMax;
  Densitat=c.Densitat;
  llista=c.llista;
  llistaCreada=c.llistaCreada;
  ColorRGBA[0]=c.ColorRGBA[0];
  ColorRGBA[1]=c.ColorRGBA[1];
  ColorRGBA[2]=c.ColorRGBA[2];
  ColorRGBA[3]=c.ColorRGBA[3];
  ColorEspecular[0]=c.ColorEspecular[0];
  ColorEspecular[1]=c.ColorEspecular[1];
  ColorEspecular[2]=c.ColorEspecular[2];
  ColorEspecular[3]=c.ColorEspecular[3];
  Shininess=c.Shininess;
  NFigura=c.NFigura;
  int i=0;
  while(i<100)
  {
    PDins[i]=c.PDins[i];
    i++;
  }
  Alfa=c.Alfa;
  Beta=c.Beta;
  Gamma=c.Gamma;
  Centre[0]=c.Centre[0];
  Centre[1]=c.Centre[1];
  Centre[2]=c.Centre[2];
  Material=c.Material;
  Prioritat=c.Prioritat;
  
  //especifiques//
  Dimensions=c.Dimensions;
  Direccio[0]=c.Direccio[0];
  Direccio[1]=c.Direccio[1];
  Direccio[2]=c.Direccio[2];
  return(*this);
}

//-----------------------------------------Constructor Seccio Esfera------------------------------------------------------//
SeccioEsfera::SeccioEsfera()
{
  Direccio[0]=0;	//components x,y,z del vector normal al pla que talla l'esfera
  Direccio[1]=0;
  Direccio[2]=1;
  
  Dimensions[0]=1;		//Radi de l'esfera
  Dimensions[1]=0.5;		//Altura del pla de tall
}

//-----------------------------------------Canviar la direcció de la seccio de l'esfera------------------------------------------------------//
void SeccioEsfera::CanviarDireccio(double nouDireccioX,double nouDireccioY,double nouDireccioZ)
{
  double AuxDireccio[3]={0,0,0};
  double Modul=sqrt(pow(nouDireccioX,2)+pow(nouDireccioY,2)+pow(nouDireccioZ,2));
  
  AuxDireccio[0]=nouDireccioX*1.0/Modul;
  AuxDireccio[1]=nouDireccioY*1.0/Modul;
  AuxDireccio[2]=nouDireccioZ*1.0/Modul;
  
  Direccio[0]=AuxDireccio[0];
  Direccio[1]=AuxDireccio[1];
  Direccio[2]=AuxDireccio[2];
 
  Beta=acos(Direccio[2]);
  if(Direccio[0]==0 && Direccio[1]==0)
  {
    Gamma=0;
  }
  else if(Direccio[0]==0)
  {
    Gamma=PI/2.0;
  }
  else
  {
    Gamma=atan(Direccio[1]*1.0/Direccio[0]);
  }
  //Resolem l'ambigüetat amb el signe//
  if(Direccio[0]<0)
  {
    Gamma=PI-Gamma;
  }  
  if(Direccio[1]<0)
  {
    Gamma=-Gamma;
  }
  
  //Pasem de radians a angles
  Gamma=Gamma*180.0/PI;
  Beta=Beta*180.0/PI;

  
  CrearLlista();
}


//------------------------------------Controla les dimensions de la seccio de l'esfera---------------------------------------------//
void SeccioEsfera::CanviarDimensions(double nouDimensionsR, double nouDimensionsT)
{
  Dimensions[0]=fabs(nouDimensionsR);
  Dimensions[1]=nouDimensionsT;
  
  CrearLlista();
}

//-----------------------------------Operador =------------------------------------------------------------------------------//
SeccioEsfera SeccioEsfera::operator=(const SeccioEsfera &c)
{
  //Comuns en totes les subclases de objectes//
  radiMax=c.radiMax;
  Densitat=c.Densitat;
  llista=c.llista;
  llistaCreada=c.llistaCreada;
  ColorRGBA[0]=c.ColorRGBA[0];
  ColorRGBA[1]=c.ColorRGBA[1];
  ColorRGBA[2]=c.ColorRGBA[2];
  ColorRGBA[3]=c.ColorRGBA[3];
  ColorEspecular[0]=c.ColorEspecular[0];
  ColorEspecular[1]=c.ColorEspecular[1];
  ColorEspecular[2]=c.ColorEspecular[2];
  ColorEspecular[3]=c.ColorEspecular[3];
  Shininess=c.Shininess;
  NFigura=c.NFigura;
  int i=0;
  while(i<100)
  {
    PDins[i]=c.PDins[i];
    i++;
  }
  Alfa=c.Alfa;
  Beta=c.Beta;
  Gamma=c.Gamma;
  Centre[0]=c.Centre[0];
  Centre[1]=c.Centre[1];
  Centre[2]=c.Centre[2];
  Material=c.Material;
  Prioritat=c.Prioritat;
  
  //especifiques//
  Dimensions[0]=c.Dimensions[0];
  Dimensions[1]=c.Dimensions[1];
  Direccio[0]=c.Direccio[0];
  Direccio[1]=c.Direccio[1];
  Direccio[2]=c.Direccio[2];
  return(*this);
}

//-----------------------------------Crear llista------------------------------------------------------------------//
void Objectes::CrearLlista()	//Crea la llista que es cridara per a pintar la figura
{
  if(llistaCreada==true)	//si ja esta creada previament es borrarà
  {
    glDeleteLists(llista,1);
    
  }else if(llistaCreada==false)	//si no estava creada, se li asignara un numero a la figura
  {
    AsignarNumero();
  }
  llista=glGenLists(1);	//Genera un identificador per a la llista
  glNewList(llista, GL_COMPILE);	//Comença la llista
  Dibuixar();
  glEndList();				//acaba la llista
  llistaCreada=true;			//informa que la llista ja esta creada
}
//---------------------------------------Dibuixa el rectangle----------------------------------------//
void Rectangle::Dibuixar()
{
  //La variable Centre conte (PosCentre x, PosCentre y, PosCentre z);
  //La variable dimensions conte (Tamany eix X, Tamany eix y, Tamany eix Z);
  
  
  glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT_AND_DIFFUSE, ColorRGBA);	//Definim la cara del material afectada per quin tipus de lum i el seu color
  glMaterialfv(GL_FRONT_AND_BACK,GL_SPECULAR,ColorEspecular);
  glMaterialf(GL_FRONT_AND_BACK,GL_SHININESS,Shininess);

  if(ColorRGBA[3]!=1)
  {    
    glEnable(GL_BLEND);
    glDepthMask(false);
    glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
    glMaterialf(GL_FRONT_AND_BACK,GL_SHININESS,250);	//Llevem els reflexos si és transparent//
  }  
  glMatrixMode(GL_MODELVIEW);		//Posem el MODELVIEW per a girar l'objecte, no la càmera
  glPushMatrix();			//Fem una copia de la matriu actual i escrivim sobre la copia
   
  //Primer vegem quin es el radimax que pot ocupar el rectangle 
  radiMax=pow(pow(Dimensions[0]/2.0,2)+pow(Dimensions[1]/2.0,2)+pow(Dimensions[2]/2.0,2),0.5);
  //i el voxel
  RadiMaxVoxel=pow(pow(DimVoxels[0]/2.0,2)+pow(DimVoxels[1]/2.0,2)+pow(DimVoxels[2]/2.0,2),0.5);
  
  
  if(CrearPunts==true)			//Mirem si ja s'han creat els punts d'aquest objecte i omplit els voxels corresponents
  { 
    
    //Omplim els voxels
      int i=0;		//Numero de voxel eix Z
      int j=0;		//Numero de voxel eix Y
      int k=0;		//Numero de voxel eix X
    
      float CentreVox[3];
    
      while(i<NumVoxels[2])	//Eix Z
      {
	CentreVox[2]=((i)*DimVoxels[2]+DimVoxels[2]/2.0);
	j=0;
	while(j<NumVoxels[1])	//Eix Y
	{
	  CentreVox[1]=((j)*DimVoxels[1]+DimVoxels[1]/2.0);
	  k=0;
	  while(k<NumVoxels[0])	//Eix X
	  {
	    CentreVox[0]=((k)*DimVoxels[0]+DimVoxels[0]/2.0);
	    //Comprovem primer si estan a una distancia on poden haber punts dins
	    if(pow(RadiMaxVoxel+radiMax,2)<=pow(CentreVox[0]-Centre[0],2)+pow(CentreVox[1]-Centre[1],2)+pow(CentreVox[2]-Centre[2],2))
	    {
	      
	      k++;
	      continue;
	    }
	    //Si esta prou prop rotem el voxel respecte al centre de la figura per a comprovar analíticament si esta dins o fora d'aquesta
	    
	    //Pasem al sistema de referència on el centre és el centre de la figura.
	    float CentreVoxAux[3];
	    
	    CentreVoxAux[0]=CentreVox[0]-Centre[0];
	    CentreVoxAux[1]=CentreVox[1]-Centre[1];
	    CentreVoxAux[2]=CentreVox[2]-Centre[2];
	    
	    //Rotem el punt del centre del voxel per a comprovar si esta dins (Relaitzarem la rotació inversa a la de la figura)
	    
	    float PuntsAux1[3];
	    float PuntsAux2[3];
	   	    	    
	    // rotacio -Gamma al voltant de l'eix Z
	    PuntsAux1[0]=CentreVoxAux[0]*cos(PI*Gamma/180.0)+CentreVoxAux[1]*sin(PI*Gamma/180.0);
	    PuntsAux1[1]=-CentreVoxAux[0]*sin(PI*Gamma/180.0)+CentreVoxAux[1]*cos(PI*Gamma/180.0);
	    PuntsAux1[2]=CentreVoxAux[2];
	    //Rotacio -Beta al voltant de l'eix Y
	    PuntsAux2[0]=PuntsAux1[0]*cos(PI*Beta/180.0)-PuntsAux1[2]*sin(PI*Beta/180.0);
	    PuntsAux2[1]=PuntsAux1[1];
	    PuntsAux2[2]=PuntsAux1[0]*sin(PI*Beta/180.0)+PuntsAux1[2]*cos(PI*Beta/180.0);
	    //Rotacio -Alfa al voltant de l'eix Z
	    CentreVoxAux[0]=PuntsAux2[0]*cos(PI*Alfa/180.0)+PuntsAux2[1]*sin(PI*Alfa/180.0);
	    CentreVoxAux[1]=-PuntsAux2[0]*sin(PI*Alfa/180.0)+PuntsAux2[1]*cos(PI*Alfa/180.0);
	    CentreVoxAux[2]=PuntsAux2[2];   
	      
	      if(CentreVoxAux[0]<Dimensions[0]/2.0 && CentreVoxAux[0]>-Dimensions[0]/2.0 && CentreVoxAux[1]<Dimensions[1]/2.0 && CentreVoxAux[1]>-Dimensions[1]/2.0 && CentreVoxAux[2]<Dimensions[2]/2.0 && CentreVoxAux[2]>-Dimensions[2]/2.0)
	      {
		//Si la figura te com a material el zero, no es modificaran els vòxels que ocupa. Guardarem un valor de -999 per a recuperar posteriorment el valor original//
		if(Material==0)
		{
		  Voxels[k][j][i][0]=-999;
		  Voxels[k][j][i][1]=-999;		  
		}
		else if(Voxels[k][j][i][0]==-999)
		{
		  k++;
		  continue;
		}
		else
		{
		  Voxels[k][j][i][0]=Material;
		  Voxels[k][j][i][1]=Densitat;
		}
		////////////////////////////////////////////////////////////////////////////////
	      }

	    k++;
	  }
	  j++;
	}
	i++;
      }
    }
    
///////////////////////////////////////////////////////////////////////////////////////////
////////////Serveix per a comprovar on s'han generat els punts aleatoris///////////////////
//   glBegin(GL_POINTS);								///
//   int i=0;										///
//    while(i<NumPunts)									///
//    {											///
//      glVertex3f(PuntsInterns[0][i],PuntsInterns[1][i],PuntsInterns[2][i]);		///
//      i++;										///
//    }											///
//     glEnd();										///
///////////////////////////////////////////////////////////////////////////////////////////      

  
//Hem de tindre en compte que les transformacions van a un "stack" o "pila" conforme les cridem. Per tant, la primera transformació que s'aplica als vertex es l'ultima que apareix en el codi, ja que, serà la que ocupe la posició de dalt a la pila.
  
  glTranslated(Centre[0],Centre[1],Centre[2]);		 //Translladem l'objecte al seu centre

  glRotated(Gamma,0,0,1);			//Rotem al voltant de l'eix Z3  
  glRotated(Beta,0,1,0);			//Rotem al voltant de l'eix Y2
  glRotated(Alfa,0,0,1);			//Rotem al voltant de l'eix Z1
  
  
  //cara de baix
  glBegin(GL_POLYGON);
    glNormal3d(0,0,-1);
    glVertex3f(-Dimensions[0]/2.0, -Dimensions[1]/2.0, -Dimensions[2]/2.0);
    glVertex3f(+Dimensions[0]/2.0, -Dimensions[1]/2.0, -Dimensions[2]/2.0);
    glVertex3f(+Dimensions[0]/2.0, +Dimensions[1]/2.0, -Dimensions[2]/2.0);
    glVertex3f(-Dimensions[0]/2.0, +Dimensions[1]/2.0, -Dimensions[2]/2.0);
    glVertex3f(-Dimensions[0]/2.0, -Dimensions[1]/2.0, -Dimensions[2]/2.0);
  glEnd();
  
  
  //Cara de dalt
  glBegin(GL_POLYGON);
    glNormal3d(0,0,1);
    glVertex3f(-Dimensions[0]/2.0, -Dimensions[1]/2.0, +Dimensions[2]/2.0);
    glVertex3f(+Dimensions[0]/2.0, -Dimensions[1]/2.0, +Dimensions[2]/2.0);
    glVertex3f(+Dimensions[0]/2.0, +Dimensions[1]/2.0, +Dimensions[2]/2.0);
    glVertex3f(-Dimensions[0]/2.0, +Dimensions[1]/2.0, +Dimensions[2]/2.0);
    glVertex3f(-Dimensions[0]/2.0, -Dimensions[1]/2.0, +Dimensions[2]/2.0);
  glEnd();

  //Cara frontal
  glBegin(GL_POLYGON);
    glNormal3d(1,0,0);
    glVertex3f(+Dimensions[0]/2.0, -Dimensions[1]/2.0, -Dimensions[2]/2.0);
    glVertex3f(+Dimensions[0]/2.0, -Dimensions[1]/2.0, +Dimensions[2]/2.0);
    glVertex3f(+Dimensions[0]/2.0, +Dimensions[1]/2.0, +Dimensions[2]/2.0);
    glVertex3f(+Dimensions[0]/2.0, +Dimensions[1]/2.0, -Dimensions[2]/2.0);
    glVertex3f(+Dimensions[0]/2.0, -Dimensions[1]/2.0, -Dimensions[2]/2.0);
  glEnd();

  //Cara darrere
  glBegin(GL_POLYGON);
    glNormal3d(-1,0,0);
    glVertex3f(-Dimensions[0]/2.0, -Dimensions[1]/2.0, -Dimensions[2]/2.0);
    glVertex3f(-Dimensions[0]/2.0, -Dimensions[1]/2.0, +Dimensions[2]/2.0);
    glVertex3f(-Dimensions[0]/2.0, +Dimensions[1]/2.0, +Dimensions[2]/2.0);
    glVertex3f(-Dimensions[0]/2.0, +Dimensions[1]/2.0, -Dimensions[2]/2.0);
    glVertex3f(-Dimensions[0]/2.0, -Dimensions[1]/2.0, -Dimensions[2]/2.0);
  glEnd();

  //Cara lateral esquerra
  glBegin(GL_POLYGON);
    glNormal3d(0,-1,0);
    glVertex3f(-Dimensions[0]/2.0, -Dimensions[1]/2.0, -Dimensions[2]/2.0);
    glVertex3f(-Dimensions[0]/2.0, -Dimensions[1]/2.0, +Dimensions[2]/2.0);
    glVertex3f(+Dimensions[0]/2.0, -Dimensions[1]/2.0, +Dimensions[2]/2.0);
    glVertex3f(+Dimensions[0]/2.0, -Dimensions[1]/2.0, -Dimensions[2]/2.0);
    glVertex3f(-Dimensions[0]/2.0, -Dimensions[1]/2.0, -Dimensions[2]/2.0);
  glEnd();  
  
  //Cara lateral dreta
  glBegin(GL_POLYGON);
    glNormal3d(0,1,0);
    glVertex3f(-Dimensions[0]/2.0, +Dimensions[1]/2.0, -Dimensions[2]/2.0);
    glVertex3f(-Dimensions[0]/2.0, +Dimensions[1]/2.0, +Dimensions[2]/2.0);
    glVertex3f(+Dimensions[0]/2.0, +Dimensions[1]/2.0, +Dimensions[2]/2.0);
    glVertex3f(+Dimensions[0]/2.0, +Dimensions[1]/2.0, -Dimensions[2]/2.0);
    glVertex3f(-Dimensions[0]/2.0, +Dimensions[1]/2.0, -Dimensions[2]/2.0);
  glEnd();  
  
  //Desactivem tot lo del blending//
  if(ColorRGBA[3]!=1)
  {  
    glDepthMask(true);
    glDisable(GL_BLEND);
  } 
  //////////////////////////////////  
  
  glPopMatrix();			//Tornem a a matriu inicial
}

//---------------------------------------Dibuixa el cilindre----------------------------------------//
void Cilindre::Dibuixar()
{
  float AngleDibuix=0;
  //La variable Centre conte (PosCentre x, PosCentre y, PosCentre z);
  //La variable dimensions conte (altura,radi superior,radi inferior);
  
  glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT_AND_DIFFUSE, ColorRGBA);	//Definim la cara del material afectada per quin tipus de lum i el seu color
  glMaterialfv(GL_FRONT_AND_BACK,GL_SPECULAR,ColorEspecular);
  glMaterialf(GL_FRONT_AND_BACK,GL_SHININESS,Shininess);

  if(ColorRGBA[3]!=1)
  {    
    glEnable(GL_BLEND);
    glDepthMask(false);
    glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
    glMaterialf(GL_FRONT_AND_BACK,GL_SHININESS,250);	//Llevem els reflexos si és transparent//
  }
  
  glMatrixMode(GL_MODELVIEW);		//Posem el MODELVIEW per a girar l'objecte, no la càmera
  glPushMatrix();			//Fem una copia de la matriu actual i escrivim sobre la copia
  
  //Primer vegem quin es el radimax que pot ocupar el rectangle 
  if(Dimensions[1]<=Dimensions[2])
  {
    radiMax=pow(pow(Dimensions[0],2)+pow(Dimensions[2],2),0.5);
  
    
  }else if(Dimensions[2]<Dimensions[1])
  {
    radiMax=pow(pow(Dimensions[0],2)+pow(Dimensions[1],2),0.5);
  }

  //i el voxel
  RadiMaxVoxel=pow(pow(DimVoxels[0]/2.0,2)+pow(DimVoxels[1]/2.0,2)+pow(DimVoxels[2]/2.0,2),0.5);
  
  if(CrearPunts==true)			//Mirem si ja s'han creat els punts d'aquest objecte i omplit els voxels corresponents
  { 
    
    //Omplim els voxels
      int i=0;		//Numero de voxel eix Z
      int j=0;		//Numero de voxel eix Y
      int k=0;		//Numero de voxel eix X
    
      float CentreVox[3];
    
      while(i<NumVoxels[2])	//Eix Z
      {
	CentreVox[2]=((i)*DimVoxels[2]+DimVoxels[2]/2.0);
	j=0;
	while(j<NumVoxels[1])	//Eix Y
	{
	  CentreVox[1]=((j)*DimVoxels[1]+DimVoxels[1]/2.0);
	  k=0;
	  while(k<NumVoxels[0])	//Eix X
	  {
	    CentreVox[0]=((k)*DimVoxels[0]+DimVoxels[0]/2.0);
	    //Comprovem primer si estan a una distancia on poden haber punts dins
	    if(pow(RadiMaxVoxel+radiMax,2)<=pow(CentreVox[0]-Centre[0],2)+pow(CentreVox[1]-Centre[1],2)+pow(CentreVox[2]-Centre[2],2))
	    {
	      
	      k++;
	      continue;
	    }
	    //Si esta prou prop rotem el voxel respecte al centre de la figura per a comprovar analíticament si esta dins o fora d'aquesta
	    
	    //Pasem al sistema de referència on el centre és el centre de la figura.
	    float CentreVoxAux[3];
	    
	    CentreVoxAux[0]=CentreVox[0]-Centre[0];
	    CentreVoxAux[1]=CentreVox[1]-Centre[1];
	    CentreVoxAux[2]=CentreVox[2]-Centre[2];
	    
	    //Rotem el punt del centre del voxel per a comprovar si esta dins (Relaitzarem la rotació inversa a la de la figura)
	    
	    float PuntsAux1[3];
	    float PuntsAux2[3];
	   
	    // rotacio -Gamma al voltant de l'eix Z
	    PuntsAux1[0]=CentreVoxAux[0]*cos(PI*Gamma/180.0)+CentreVoxAux[1]*sin(PI*Gamma/180.0);
	    PuntsAux1[1]=-CentreVoxAux[0]*sin(PI*Gamma/180.0)+CentreVoxAux[1]*cos(PI*Gamma/180.0);
	    PuntsAux1[2]=CentreVoxAux[2];
	    //Rotacio -Beta al voltant de l'eix Y
	    PuntsAux2[0]=PuntsAux1[0]*cos(PI*Beta/180.0)-PuntsAux1[2]*sin(PI*Beta/180.0);
	    PuntsAux2[1]=PuntsAux1[1];
	    PuntsAux2[2]=PuntsAux1[0]*sin(PI*Beta/180.0)+PuntsAux1[2]*cos(PI*Beta/180.0);
	    //Rotacio -Alfa al voltant de l'eix Z
	    CentreVoxAux[0]=PuntsAux2[0]*cos(PI*Alfa/180.0)+PuntsAux2[1]*sin(PI*Alfa/180.0);
	    CentreVoxAux[1]=-PuntsAux2[0]*sin(PI*Alfa/180.0)+PuntsAux2[1]*cos(PI*Alfa/180.0);
	    CentreVoxAux[2]=PuntsAux2[2];   
	      
	    //Posem les condicions per a que estiga dins del cilindre/con o tub
	      if(CentreVoxAux[2]>=Dimensions[0]/2.0 || CentreVoxAux[2]<=-Dimensions[0]/2.0)
	      {
		k++;
		continue;
	      }
	      //Apliquem ara diferents criteris segons siga un tub o no
	      if(Tub==false)
		{
		  if((pow(CentreVoxAux[0],2)+pow(CentreVoxAux[1],2))>pow(Dimensions[2]+(1.0*(CentreVoxAux[2]+Dimensions[0]/2.0)/Dimensions[0])*(Dimensions[1]-Dimensions[2]),2))
		    {
		      k++;
		      continue;
		    }
		}
	      else if(Tub==true)
		{
		  if(pow(CentreVoxAux[0],2)+pow(CentreVoxAux[1],2)>pow(Dimensions[1],2) || pow(CentreVoxAux[0],2)+pow(CentreVoxAux[1],2)<pow(Dimensions[2],2))
		    {
		      k++;
		      continue;
		    }
		}
		//Si la figura te com a material el zero, no es modificaran els vòxels que ocupa. Guardarem un valor de -999 per a recuperar posteriorment el valor original//
		if(Material==0)
		{
		  Voxels[k][j][i][0]=-999;
		  Voxels[k][j][i][1]=-999;		  
		}
		else if(Voxels[k][j][i][0]==-999)
		{
		  k++;
		  continue;
		}
		else
		{
		  Voxels[k][j][i][0]=Material;
		  Voxels[k][j][i][1]=Densitat;
		}
		////////////////////////////////////////////////////////////////////////////////


	    k++;
	  }
	  j++;
	}
	i++;
      }
    }
///////////////////////////////////////////////////////////////////////////////////////////
////////////Serveix per a comprovar on s'han generat els punts aleatoris///////////////////
//   glBegin(GL_POINTS);								///
//   int i=0;										///
//    while(i<NumPunts)									///
//    {											///
//      glVertex3f(PuntsInterns[0][i],PuntsInterns[1][i],PuntsInterns[2][i]);		///
//      i++;										///
//    }											///
//     glEnd();										///
///////////////////////////////////////////////////////////////////////////////////////////  

    
//ARA PASEM AL DIBUIX
  
//Hem de tindre en compte que les transformacions van a un "stack" o "pila" conforme les cridem. Per tant, la primera transformació que s'aplica als vertex es l'ultima que apareix en el codi, ja que, serà la que ocupe la posició de dalt a la pila.
  
  glTranslated(Centre[0],Centre[1],Centre[2]);		 //Translladem l'objecte al seu centre

  glRotated(Gamma,0,0,1);			//Rotem al voltant de l'eix Z3  
  glRotated(Beta,0,1,0);			//Rotem al voltant de l'eix Y2
  glRotated(Alfa,0,0,1);			//Rotem al voltant de l'eix Z1

  if(Tub==false)
    {
      //cara de baix
      glBegin(GL_POLYGON);
      glNormal3d(0,0,-1);
      while(AngleDibuix<2*PI)
	{
	  glVertex3f(+Dimensions[2]*cos(AngleDibuix),+Dimensions[2]*sin(AngleDibuix),-Dimensions[0]/2.0);
	  AngleDibuix=AngleDibuix+0.01;
	}
      glEnd();
  
      //cara de dalt
      AngleDibuix=0;
      glBegin(GL_POLYGON);
      glNormal3d(0,0,1);
      while(AngleDibuix<2*PI)
	{
	  glVertex3f(+Dimensions[1]*cos(AngleDibuix),+Dimensions[1]*sin(AngleDibuix),+Dimensions[0]/2.0);
	  AngleDibuix=AngleDibuix+0.01;
	}
      glEnd();
  
  
      //Parets laterals
      AngleDibuix=0;
      while(AngleDibuix<2*PI)
	{
	  glBegin(GL_POLYGON);
	  glNormal3d(cos(AngleDibuix),sin(AngleDibuix),0);
	  //Els Dos vertex de baix d'un dels rectangles que formaran la cara
	  glVertex3f(+Dimensions[2]*cos(AngleDibuix),+Dimensions[2]*sin(AngleDibuix),-Dimensions[0]/2.0);	
	  glNormal3d(cos(AngleDibuix-0.01),sin(AngleDibuix-0.01),0);
	  glVertex3f(+Dimensions[2]*cos(AngleDibuix-0.01),+Dimensions[2]*sin(AngleDibuix-0.01),-Dimensions[0]/2.0);
      
	  //Els Dos vertex de dalt d'un dels rectangles que formaran la cara
	  glVertex3f(+Dimensions[1]*cos(AngleDibuix-0.01),+Dimensions[1]*sin(AngleDibuix-0.01),+Dimensions[0]/2.0);
	  glNormal3d(cos(AngleDibuix),sin(AngleDibuix),0);
	  glVertex3f(+Dimensions[1]*cos(AngleDibuix),+Dimensions[1]*sin(AngleDibuix),+Dimensions[0]/2.0);
      
	  //Tornem al vertex inicial
	  glVertex3f(+Dimensions[2]*cos(AngleDibuix),+Dimensions[2]*sin(AngleDibuix),-Dimensions[0]/2.0);
      
	  AngleDibuix=AngleDibuix+0.01;
      
	  glEnd();
	}
    }
  else if(Tub==true)
    {
      //cara de baix
      while(AngleDibuix<2*PI)
	{
	  glBegin(GL_POLYGON);
	  glNormal3d(0,0,-1);	  
	   glVertex3f(+Dimensions[1]*cos(AngleDibuix),+Dimensions[1]*sin(AngleDibuix),-Dimensions[0]/2.0);
	   glVertex3f(+Dimensions[2]*cos(AngleDibuix),+Dimensions[2]*sin(AngleDibuix),-Dimensions[0]/2.0);
	   glVertex3f(+Dimensions[2]*cos(AngleDibuix+0.01),+Dimensions[2]*sin(AngleDibuix+0.01),-Dimensions[0]/2.0);
	   glVertex3f(+Dimensions[1]*cos(AngleDibuix+0.01),+Dimensions[1]*sin(AngleDibuix+0.01),-Dimensions[0]/2.0);	  
	   
	  glEnd();	  
	  AngleDibuix=AngleDibuix+0.01;
	}

      //cara de dalt
      AngleDibuix=0;
      while(AngleDibuix<2*PI)
	{
	  glBegin(GL_POLYGON);
	  glNormal3d(0,0,1);	  
	   glVertex3f(+Dimensions[1]*cos(AngleDibuix),+Dimensions[1]*sin(AngleDibuix),Dimensions[0]/2.0);
	   glVertex3f(+Dimensions[2]*cos(AngleDibuix),+Dimensions[2]*sin(AngleDibuix),Dimensions[0]/2.0);
	   glVertex3f(+Dimensions[2]*cos(AngleDibuix+0.01),+Dimensions[2]*sin(AngleDibuix+0.01),Dimensions[0]/2.0);
	   glVertex3f(+Dimensions[1]*cos(AngleDibuix+0.01),+Dimensions[1]*sin(AngleDibuix+0.01),Dimensions[0]/2.0);	  
	   
	  glEnd();	  
	  AngleDibuix=AngleDibuix+0.01;
	}

      //Parets laterals externes
      AngleDibuix=0;
      while(AngleDibuix<2*PI)
	{
	  glBegin(GL_POLYGON);
	  glNormal3d(cos(AngleDibuix),sin(AngleDibuix),0);
	  //Els Dos vertex de baix d'un dels rectangles que formaran la cara
	  glVertex3f(+Dimensions[1]*cos(AngleDibuix),+Dimensions[1]*sin(AngleDibuix),-Dimensions[0]/2.0);	
	  glNormal3d(cos(AngleDibuix-0.01),sin(AngleDibuix-0.01),0);
	  glVertex3f(+Dimensions[1]*cos(AngleDibuix-0.01),+Dimensions[1]*sin(AngleDibuix-0.01),-Dimensions[0]/2.0);
      
	  //Els Dos vertex de dalt d'un dels rectangles que formaran la cara
	  glVertex3f(+Dimensions[1]*cos(AngleDibuix-0.01),+Dimensions[1]*sin(AngleDibuix-0.01),+Dimensions[0]/2.0);
	  glNormal3d(cos(AngleDibuix),sin(AngleDibuix),0);
	  glVertex3f(+Dimensions[1]*cos(AngleDibuix),+Dimensions[1]*sin(AngleDibuix),+Dimensions[0]/2.0);
      
	  //Tornem al vertex inicial
	  glVertex3f(+Dimensions[1]*cos(AngleDibuix),+Dimensions[1]*sin(AngleDibuix),-Dimensions[0]/2.0);
      
	  AngleDibuix=AngleDibuix+0.01;
      
	  glEnd();
	}
      //Parets laterals internes
      AngleDibuix=0;
      while(AngleDibuix<2*PI)
	{
	  glBegin(GL_POLYGON);
	  glNormal3d(-cos(AngleDibuix),-sin(AngleDibuix),0);
	  //Els Dos vertex de baix d'un dels rectangles que formaran la cara
	  glVertex3f(+Dimensions[2]*cos(AngleDibuix),+Dimensions[2]*sin(AngleDibuix),-Dimensions[0]/2.0);	
	  glNormal3d(-cos(AngleDibuix-0.01),-sin(AngleDibuix-0.01),0);
	  glVertex3f(+Dimensions[2]*cos(AngleDibuix-0.01),+Dimensions[2]*sin(AngleDibuix-0.01),-Dimensions[0]/2.0);
      
	  //Els Dos vertex de dalt d'un dels rectangles que formaran la cara
	  glVertex3f(+Dimensions[2]*cos(AngleDibuix-0.01),+Dimensions[2]*sin(AngleDibuix-0.01),+Dimensions[0]/2.0);
	  glNormal3d(-cos(AngleDibuix),-sin(AngleDibuix),0);
	  glVertex3f(+Dimensions[2]*cos(AngleDibuix),+Dimensions[2]*sin(AngleDibuix),+Dimensions[0]/2.0);
      
	  //Tornem al vertex inicial
	  glVertex3f(+Dimensions[2]*cos(AngleDibuix),+Dimensions[2]*sin(AngleDibuix),-Dimensions[0]/2.0);
      
	  AngleDibuix=AngleDibuix+0.01;
      
	  glEnd();
	}

    }
  
  //Desactivem tot lo del blending//
  if(ColorRGBA[3]!=1)
  {  
    glDepthMask(true);
    glDisable(GL_BLEND);
  } 
  //////////////////////////////////
  
  glPopMatrix();			//Tornem a a matriu inicial


}    
    
//---------------------------------------Dibuixa Esfera----------------------------------------//
void Esfera::Dibuixar()
{
  float AngleDibuixTecta=0;
  float AngleDibuixFi=0;
  //La variable Centre conte (PosCentre x, PosCentre y, PosCentre z);
  //La variable dimensions conte (radi);

  glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT_AND_DIFFUSE, ColorRGBA);	//Definim la cara del material afectada per quin tipus de lum i el seu color
  glMaterialfv(GL_FRONT_AND_BACK,GL_SPECULAR,ColorEspecular);
  glMaterialf(GL_FRONT_AND_BACK,GL_SHININESS,Shininess);
  //Activem les transparències si la opacitat de l'objecte no és completament opac (opacitat!=1)//
  if(ColorRGBA[3]!=1)
  {    
    glEnable(GL_BLEND);
    glDepthMask(false);
    glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
    glMaterialf(GL_FRONT_AND_BACK,GL_SHININESS,250);	//Llevem els reflexos si és transparent//
  }
  /////////////////////////////////////////////////////////////////////////////////////////////////
  glMatrixMode(GL_MODELVIEW);		//Posem el MODELVIEW per a girar l'objecte, no la càmera
  glPushMatrix();			//Fem una copia de la matriu actual i escrivim sobre la copia
  
  
  //Primer vegem quin es el radimax que pot ocupar la esfera
  radiMax=Dimensions;
  
    if(CrearPunts==true)			//Mirem si ja s'han creat els punts d'aquest objecte i omplit els voxels corresponents
  {
    //Creem punts a l'interior de la figura per a despres asignarli a cada voxel el material i densitat en funció dels punts que te dins
    //Primer mirem quants voxels caben en el volum de l'objecte i en funció d'aixo determinem el nombe de punts generats


      //No creem punts ja que l'esfera la fe de forma algebraica
    
    
    
      //Omplim els voxels
      int i=0;		//Numero de voxel eix Z
      int j=0;		//Numero de voxel eix Y
      int k=0;		//Numero de voxel eix X

      float CentreVox[3];
    
      while(i<NumVoxels[2])	//Eix Z
      {
	CentreVox[2]=((i)*DimVoxels[2]+DimVoxels[2]/2.0);
	j=0;
	while(j<NumVoxels[1])	//Eix Y
	{
	  CentreVox[1]=((j)*DimVoxels[1]+DimVoxels[1]/2.0);
//#pragma omp parallel default(shared) ////////////////////Comença el paral·lelitzat (usa OpenMP)/////////////////////	(AL PARAL·LELITZAR IX MALAMENT)
//	 {	  
//#pragma omp for ordered	/////////////////////////////////////Comença un cicle for paral·lelitzat//////////////////////

	  for(k=0;k<NumVoxels[0];k++)	//Eix X
	  {
	    CentreVox[0]=((k)*DimVoxels[0]+DimVoxels[0]/2.0);

	      //Comprovem ara si els punts de l'objecte estan dins del voxel. Si troba 1 omplira el voxel i pasara al voxel següent
	      if(pow(radiMax,2)>pow(CentreVox[0]-Centre[0],2)+pow(CentreVox[1]-Centre[1],2)+pow(CentreVox[2]-Centre[2],2))
	      {
		//Si la figura te com a material el zero, no es modificaran els vòxels que ocupa. Guardarem un valor de -999 per a recuperar posteriorment el valor original//
		if(Material==0)
		{
		  Voxels[k][j][i][0]=-999;
		  Voxels[k][j][i][1]=-999;		  
		}
		else if(Voxels[k][j][i][0]==-999)
		{
		  k++;
		  continue;
		}
		else
		{
		  Voxels[k][j][i][0]=Material;
		  Voxels[k][j][i][1]=Densitat;
		}
		////////////////////////////////////////////////////////////////////////////////
	      }
	     
	  }
//}/////////////////////////////////////////////Acaba la paral·lelització////////////////////
	    j++;
	 }
	  i++;
	}

    }
     
      
//Pasem ara al dibuix
  
  
//Hem de tindre en compte que les transformacions van a un "stack" o "pila" conforme les cridem. Per tant, la primera transformació que s'aplica als vertex es l'ultima que apareix en el codi, ja que, serà la que ocupe la posició de dalt a la pila.
  
  glTranslated(Centre[0],Centre[1],Centre[2]);		 //Translladem l'objecte al seu centre

  glRotated(Gamma,0,0,1);			//Rotem al voltant de l'eix Z3  
  glRotated(Beta,0,1,0);			//Rotem al voltant de l'eix Y2
  glRotated(Alfa,0,0,1);			//Rotem al voltant de l'eix Z1
    
    while(AngleDibuixTecta<=PI)
    {
      //Dibuixem cada linea de triangles utilitzant el triangle strip
      AngleDibuixFi=0;
      //Dibuixem el triangle inicial
      
      glBegin(GL_TRIANGLE_STRIP);
	//Vertex de baix del primer triangle
	glNormal3d(sin(AngleDibuixTecta)*cos(AngleDibuixFi),sin(AngleDibuixTecta)*sin(AngleDibuixFi),cos(AngleDibuixTecta));
	glVertex3f(+Dimensions*sin(AngleDibuixTecta)*cos(AngleDibuixFi),+Dimensions*sin(AngleDibuixTecta)*sin(AngleDibuixFi),Dimensions*cos(AngleDibuixTecta));
	
	//Segon vertex de baix del primer triangle
	AngleDibuixFi=AngleDibuixFi+0.1;
	
	glNormal3d(sin(AngleDibuixTecta)*cos(AngleDibuixFi),sin(AngleDibuixTecta)*sin(AngleDibuixFi),cos(AngleDibuixTecta));
	glVertex3f(+Dimensions*sin(AngleDibuixTecta)*cos(AngleDibuixFi),+Dimensions*sin(AngleDibuixTecta)*sin(AngleDibuixFi),Dimensions*cos(AngleDibuixTecta));
	
	//Vertex de dalt del primer triangle
	AngleDibuixTecta=AngleDibuixTecta+0.0866025;
	AngleDibuixFi=AngleDibuixFi-0.05;
	
	glNormal3d(sin(AngleDibuixTecta)*cos(AngleDibuixFi),sin(AngleDibuixTecta)*sin(AngleDibuixFi),cos(AngleDibuixTecta));
	glVertex3f(+Dimensions*sin(AngleDibuixTecta)*cos(AngleDibuixFi),+Dimensions*sin(AngleDibuixTecta)*sin(AngleDibuixFi),Dimensions*cos(AngleDibuixTecta));
	
	AngleDibuixTecta=AngleDibuixTecta-0.0866025;
	AngleDibuixFi=AngleDibuixFi+0.05;
      //Una vegada hem dibuixat el primer triangle anem pintant els altres afegint vertex
      while(AngleDibuixFi<=2*PI+0.15)
      {
	AngleDibuixFi=AngleDibuixFi+0.05;
	AngleDibuixTecta=AngleDibuixTecta+0.0866025;
	
	glNormal3d(sin(AngleDibuixTecta)*cos(AngleDibuixFi),sin(AngleDibuixTecta)*sin(AngleDibuixFi),cos(AngleDibuixTecta));
	glVertex3f(+Dimensions*sin(AngleDibuixTecta)*cos(AngleDibuixFi),+Dimensions*sin(AngleDibuixTecta)*sin(AngleDibuixFi),Dimensions*cos(AngleDibuixTecta));
	
	AngleDibuixTecta=AngleDibuixTecta-0.0866025;
	AngleDibuixFi=AngleDibuixFi+0.05;
	
	glNormal3d(sin(AngleDibuixTecta)*cos(AngleDibuixFi),sin(AngleDibuixTecta)*sin(AngleDibuixFi),cos(AngleDibuixTecta));
	glVertex3f(+Dimensions*sin(AngleDibuixTecta)*cos(AngleDibuixFi),+Dimensions*sin(AngleDibuixTecta)*sin(AngleDibuixFi),Dimensions*cos(AngleDibuixTecta));
	
      }
      
      glEnd();
      
      AngleDibuixTecta=AngleDibuixTecta+0.0866025;
    }
  //Desactivem tot lo del blending//
  if(ColorRGBA[3]!=1)
  {  
    glDepthMask(true);
    glDisable(GL_BLEND);
  } 
  //////////////////////////////////
  glPopMatrix();			//Tornem a a matriu inicial
}    

//---------------------------------------Dibuixa el Pla infinit----------------------------------------//
void Pla::Dibuixar()
{
  float AngleDibuix=0;
  //La variable Centre conte (PosCentre x, PosCentre y, PosCentre z);
  //La variable dimensions conte el radi del cercle que representa el pla infinit;
  
  glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT_AND_DIFFUSE, ColorRGBA);	//Definim la cara del material afectada per quin tipus de lum i el seu color
  glMaterialfv(GL_FRONT_AND_BACK,GL_SPECULAR,ColorEspecular);
  glMaterialf(GL_FRONT_AND_BACK,GL_SHININESS,Shininess);

  if(ColorRGBA[3]!=1)
  {    
    glEnable(GL_BLEND);
    glDepthMask(false);
    glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
    glMaterialf(GL_FRONT_AND_BACK,GL_SHININESS,250);	//Llevem els reflexos si és transparent//
  }  
  glMatrixMode(GL_MODELVIEW);		//Posem el MODELVIEW per a girar l'objecte, no la càmera
  glPushMatrix();			//Fem una copia de la matriu actual i escrivim sobre la copia
  
  if(CrearPunts==true)			//Mirem si s'han de crear els punts d'aquest objecte i omplit els voxels corresponents
  { 
    
    //Omplim els voxels
      int i=0;		//Numero de voxel eix Z
      int j=0;		//Numero de voxel eix Y
      int k=0;		//Numero de voxel eix X
    
      float CentreVox[3];
    
      while(i<NumVoxels[2])	//Eix Z
      {
	CentreVox[2]=((i)*DimVoxels[2]+DimVoxels[2]/2.0);
	j=0;
	while(j<NumVoxels[1])	//Eix Y
	{
	  CentreVox[1]=((j)*DimVoxels[1]+DimVoxels[1]/2.0);
	  k=0;
	  while(k<NumVoxels[0])	//Eix X
	  {
	    CentreVox[0]=((k)*DimVoxels[0]+DimVoxels[0]/2.0);
	    
	    //Pasem al sistema de referència on el centre és el centre del pla.
	    float CentreVoxAux[3];
	    
	    CentreVoxAux[0]=CentreVox[0]-Centre[0];
	    CentreVoxAux[1]=CentreVox[1]-Centre[1];
	    CentreVoxAux[2]=CentreVox[2]-Centre[2];
	    
	    //Rotem el punt del centre del voxel per a comprovar si esta dins (Relaitzarem la rotació inversa a la de la figura)
	    
	    float PuntsAux1[3];
	    float PuntsAux2[3];
	   
	    // rotacio -Gamma al voltant de l'eix Z
	    PuntsAux1[0]=CentreVoxAux[0]*cos(PI*Gamma/180.0)+CentreVoxAux[1]*sin(PI*Gamma/180.0);
	    PuntsAux1[1]=-CentreVoxAux[0]*sin(PI*Gamma/180.0)+CentreVoxAux[1]*cos(PI*Gamma/180.0);
	    PuntsAux1[2]=CentreVoxAux[2];
	    //Rotacio -Beta al voltant de l'eix Y
	    PuntsAux2[0]=PuntsAux1[0]*cos(PI*Beta/180.0)-PuntsAux1[2]*sin(PI*Beta/180.0);
	    PuntsAux2[1]=PuntsAux1[1];
	    PuntsAux2[2]=PuntsAux1[0]*sin(PI*Beta/180.0)+PuntsAux1[2]*cos(PI*Beta/180.0);
	    //Rotacio -Alfa al voltant de l'eix Z
	    CentreVoxAux[0]=PuntsAux2[0]*cos(PI*Alfa/180.0)+PuntsAux2[1]*sin(PI*Alfa/180.0);
	    CentreVoxAux[1]=-PuntsAux2[0]*sin(PI*Alfa/180.0)+PuntsAux2[1]*cos(PI*Alfa/180.0);
	    CentreVoxAux[2]=PuntsAux2[2];   
	      
	    //Posem les condicions per a que estiga dins del Pla
	      if(CentreVoxAux[2]<0)
	      {
		k++;
		continue;
	      }
	      else
	      {
		//Si la figura te com a material el zero, no es modificaran els vòxels que ocupa. Guardarem un valor de -999 per a recuperar posteriorment el valor original//
		if(Material==0)
		{
		  Voxels[k][j][i][0]=-999;
		  Voxels[k][j][i][1]=-999;		  
		}
		else if(Voxels[k][j][i][0]==-999)
		{
		  k++;
		  continue;
		}
		else
		{
		  Voxels[k][j][i][0]=Material;
		  Voxels[k][j][i][1]=Densitat;
		}
		////////////////////////////////////////////////////////////////////////////////
	      }

	    k++;
	  }
	  j++;
	}
	i++;
      }
    }
///////////////////////////////////////////////////////////////////////////////////////////
////////////Serveix per a comprovar on s'han generat els punts aleatoris///////////////////
//   glBegin(GL_POINTS);								///
//   int i=0;										///
//    while(i<NumPunts)									///
//    {											///
//      glVertex3f(PuntsInterns[0][i],PuntsInterns[1][i],PuntsInterns[2][i]);		///
//      i++;										///
//    }											///
//     glEnd();										///
///////////////////////////////////////////////////////////////////////////////////////////  

    
//ARA PASEM AL DIBUIX
  
  
//Hem de tindre en compte que les transformacions van a un "stack" o "pila" conforme les cridem. Per tant, la primera transformació que s'aplica als vertex es l'ultima que apareix en el codi, ja que, serà la que ocupe la posició de dalt a la pila.
  
  glTranslated(Centre[0],Centre[1],Centre[2]);		 //Translladem l'objecte al seu centre

  glRotated(Gamma,0,0,1);			//Rotem al voltant de l'eix Z3  
  glRotated(Beta,0,1,0);			//Rotem al voltant de l'eix Y2
  glRotated(Alfa,0,0,1);			//Rotem al voltant de l'eix Z1
  
  //Disc del pla
  AngleDibuix=0;
  
  glBegin(GL_POLYGON);
  while(AngleDibuix<2*PI)
  {
      glNormal3d(0,0,1);
      //Vertex del contorn del cercle
      glVertex3f(Dimensions*cos(AngleDibuix),Dimensions*sin(AngleDibuix),0);
      //Augmentem l'angle
      AngleDibuix=AngleDibuix+0.01;
  }
  glNormal3d(Direccio[0],Direccio[1],Direccio[2]);
  glVertex3f(Dimensions,0,0);	//Vertex Inicial
  glEnd();
    
  glBegin(GL_LINES);
  glVertex3f(0,0,0);
  glVertex3f(0,0,Dimensions);
  glEnd();
  
  //Desactivem tot lo del blending//
  if(ColorRGBA[3]!=1)
  {  
    glDepthMask(true);
    glDisable(GL_BLEND);
  } 
  //////////////////////////////////  
  glPopMatrix();			//Tornem a la matriu inicial


}    

//---------------------------------------Dibuixa la secció d'esfera---------------------------------------//
void SeccioEsfera::Dibuixar()
{
  //La variable Centre conte (PosCentre x, PosCentre y, PosCentre z);
  //La variable dimensions conte el radi i la posicio del pla de tall;
  
  glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT_AND_DIFFUSE, ColorRGBA);	//Definim la cara del material afectada per quin tipus de lum i el seu color
  glMaterialfv(GL_FRONT_AND_BACK,GL_SPECULAR,ColorEspecular);
  glMaterialf(GL_FRONT_AND_BACK,GL_SHININESS,Shininess);

  if(ColorRGBA[3]!=1)
  {    
    glEnable(GL_BLEND);
    glDepthMask(false);
    glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
    glMaterialf(GL_FRONT_AND_BACK,GL_SHININESS,250);	//Llevem els reflexos si és transparent//
  }  
  glMatrixMode(GL_MODELVIEW);		//Posem el MODELVIEW per a girar l'objecte, no la càmera
  glPushMatrix();			//Fem una copia de la matriu actual i escrivim sobre la copia
  
  radiMax=Dimensions[0];
  
  if(CrearPunts==true)			//Mirem si s'han de crear els punts d'aquest objecte i omplit els voxels corresponents
  { 
    
    //Omplim els voxels
      int i=0;		//Numero de voxel eix Z
      int j=0;		//Numero de voxel eix Y
      int k=0;		//Numero de voxel eix X
    
      float CentreVox[3];
    
      while(i<NumVoxels[2])	//Eix Z
      {
	CentreVox[2]=((i)*DimVoxels[2]+DimVoxels[2]/2.0);
	j=0;
	while(j<NumVoxels[1])	//Eix Y
	{
	  CentreVox[1]=((j)*DimVoxels[1]+DimVoxels[1]/2.0);
	  k=0;
	  while(k<NumVoxels[0])	//Eix X
	  {
	    CentreVox[0]=((k)*DimVoxels[0]+DimVoxels[0]/2.0);
	    
	    //Pasem al sistema de referència on el centre és el centre del pla.
	    float CentreVoxAux[3];
	    
	    CentreVoxAux[0]=CentreVox[0]-Centre[0];
	    CentreVoxAux[1]=CentreVox[1]-Centre[1];
	    CentreVoxAux[2]=CentreVox[2]-Centre[2];
	    
	    if(sqrt(pow(CentreVoxAux[0],2)+pow(CentreVoxAux[1],2)+pow(CentreVoxAux[2],2))>radiMax)
	    {
	      k++;
	      continue;
	    }
	    
	    //Rotem el punt del centre del voxel per a comprovar si esta dins (Relaitzarem la rotació inversa a la de la figura)
	    
	    float PuntsAux1[3];
	    float PuntsAux2[3];
	   
	    // rotacio -Gamma al voltant de l'eix Z
	    PuntsAux1[0]=CentreVoxAux[0]*cos(PI*Gamma/180.0)+CentreVoxAux[1]*sin(PI*Gamma/180.0);
	    PuntsAux1[1]=-CentreVoxAux[0]*sin(PI*Gamma/180.0)+CentreVoxAux[1]*cos(PI*Gamma/180.0);
	    PuntsAux1[2]=CentreVoxAux[2];
	    //Rotacio -Beta al voltant de l'eix Y
	    PuntsAux2[0]=PuntsAux1[0]*cos(PI*Beta/180.0)-PuntsAux1[2]*sin(PI*Beta/180.0);
	    PuntsAux2[1]=PuntsAux1[1];
	    PuntsAux2[2]=PuntsAux1[0]*sin(PI*Beta/180.0)+PuntsAux1[2]*cos(PI*Beta/180.0);
	    //Rotacio -Alfa al voltant de l'eix Z
	    CentreVoxAux[0]=PuntsAux2[0]*cos(PI*Alfa/180.0)+PuntsAux2[1]*sin(PI*Alfa/180.0);
	    CentreVoxAux[1]=-PuntsAux2[0]*sin(PI*Alfa/180.0)+PuntsAux2[1]*cos(PI*Alfa/180.0);
	    CentreVoxAux[2]=PuntsAux2[2];   
	      
	    //Posem les condicions per a que estiga dins de la seccio d'esfera, tenint en compte que ja hem comprovar que esta dins de l'esfera
	      if(CentreVoxAux[2]>Dimensions[1])
	      {
		k++;
		continue;
	      }
	      else
	      {
		//Si la figura te com a material el zero, no es modificaran els vòxels que ocupa. Guardarem un valor de -999 per a recuperar posteriorment el valor original//
		if(Material==0)
		{
		  Voxels[k][j][i][0]=-999;
		  Voxels[k][j][i][1]=-999;		  
		}
		else if(Voxels[k][j][i][0]==-999)
		{
		  k++;
		  continue;
		}
		else
		{
		  Voxels[k][j][i][0]=Material;
		  Voxels[k][j][i][1]=Densitat;
		}
		////////////////////////////////////////////////////////////////////////////////
	      }

	    k++;
	  }
	  j++;
	}
	i++;
      }
    }
///////////////////////////////////////////////////////////////////////////////////////////
////////////Serveix per a comprovar on s'han generat els punts aleatoris///////////////////
//   glBegin(GL_POINTS);								///
//   int i=0;										///
//    while(i<NumPunts)									///
//    {											///
//      glVertex3f(PuntsInterns[0][i],PuntsInterns[1][i],PuntsInterns[2][i]);		///
//      i++;										///
//    }											///
//     glEnd();										///
///////////////////////////////////////////////////////////////////////////////////////////  

    
//ARA PASEM AL DIBUIX
  
  
//Hem de tindre en compte que les transformacions van a un "stack" o "pila" conforme les cridem. Per tant, la primera transformació que s'aplica als vertex es l'ultima que apareix en el codi, ja que, serà la que ocupe la posició de dalt a la pila.
  
  glTranslated(Centre[0],Centre[1],Centre[2]);		 //Translladem l'objecte al seu centre

  glRotated(Gamma,0,0,1);			//Rotem al voltant de l'eix Z3  
  glRotated(Beta,0,1,0);			//Rotem al voltant de l'eix Y2
  glRotated(Alfa,0,0,1);			//Rotem al voltant de l'eix Z1

  float AngleDibuixFi=0;
  float AngleDibuixTecta=0;

  float RadiTall=Dimensions[0]*sqrt(1-pow(Dimensions[1]*1.0/Dimensions[0],2));  
  
  if(Dimensions[1]>0)
  {
    AngleDibuixTecta=acos(Dimensions[1]*1.0/Dimensions[0]);
  }else if(Dimensions[1]<0)
  {
    AngleDibuixTecta=PI-acos(fabs(Dimensions[1])*1.0/Dimensions[0]);
  }else if(Dimensions[1]==0)
  {
    AngleDibuixTecta=PI/2.0;
  }
  
  while(AngleDibuixTecta<=PI)
    {
      //Dibuixem cada linea de triangles utilitzant el triangle strip
      AngleDibuixFi=0;
      //Dibuixem el triangle inicial
      
      glBegin(GL_TRIANGLE_STRIP);
	//Vertex de baix del primer triangle
	glNormal3d(sin(AngleDibuixTecta)*cos(AngleDibuixFi),sin(AngleDibuixTecta)*sin(AngleDibuixFi),cos(AngleDibuixTecta));
	glVertex3f(+Dimensions[0]*sin(AngleDibuixTecta)*cos(AngleDibuixFi),+Dimensions[0]*sin(AngleDibuixTecta)*sin(AngleDibuixFi),Dimensions[0]*cos(AngleDibuixTecta));
	
	//Segon vertex de baix del primer triangle
	AngleDibuixFi=AngleDibuixFi+0.1;
	
	glNormal3d(sin(AngleDibuixTecta)*cos(AngleDibuixFi),sin(AngleDibuixTecta)*sin(AngleDibuixFi),cos(AngleDibuixTecta));
	glVertex3f(+Dimensions[0]*sin(AngleDibuixTecta)*cos(AngleDibuixFi),+Dimensions[0]*sin(AngleDibuixTecta)*sin(AngleDibuixFi),Dimensions[0]*cos(AngleDibuixTecta));
	
	//Vertex de dalt del primer triangle
	AngleDibuixTecta=AngleDibuixTecta+0.0866025;
	AngleDibuixFi=AngleDibuixFi-0.05;
	
	glNormal3d(sin(AngleDibuixTecta)*cos(AngleDibuixFi),sin(AngleDibuixTecta)*sin(AngleDibuixFi),cos(AngleDibuixTecta));
	glVertex3f(+Dimensions[0]*sin(AngleDibuixTecta)*cos(AngleDibuixFi),+Dimensions[0]*sin(AngleDibuixTecta)*sin(AngleDibuixFi),Dimensions[0]*cos(AngleDibuixTecta));
	
	AngleDibuixTecta=AngleDibuixTecta-0.0866025;
	AngleDibuixFi=AngleDibuixFi+0.05;
      //Una vegada hem dibuixat el primer triangle anem pintant els altres afegint vertex
      while(AngleDibuixFi<=2*PI+0.6)
      {
	AngleDibuixFi=AngleDibuixFi+0.05;
	AngleDibuixTecta=AngleDibuixTecta+0.0866025;
	
	glNormal3d(sin(AngleDibuixTecta)*cos(AngleDibuixFi),sin(AngleDibuixTecta)*sin(AngleDibuixFi),cos(AngleDibuixTecta));
	glVertex3f(+Dimensions[0]*sin(AngleDibuixTecta)*cos(AngleDibuixFi),+Dimensions[0]*sin(AngleDibuixTecta)*sin(AngleDibuixFi),Dimensions[0]*cos(AngleDibuixTecta));
	
	AngleDibuixTecta=AngleDibuixTecta-0.0866025;
	AngleDibuixFi=AngleDibuixFi+0.05;
	
	glNormal3d(sin(AngleDibuixTecta)*cos(AngleDibuixFi),sin(AngleDibuixTecta)*sin(AngleDibuixFi),cos(AngleDibuixTecta));
	glVertex3f(+Dimensions[0]*sin(AngleDibuixTecta)*cos(AngleDibuixFi),+Dimensions[0]*sin(AngleDibuixTecta)*sin(AngleDibuixFi),Dimensions[0]*cos(AngleDibuixTecta));
	
      }
      
      glEnd();
      
      AngleDibuixTecta=AngleDibuixTecta+0.0866025;
    }
    float AngleDibuix=0;
  glBegin(GL_POLYGON);
  while(AngleDibuix<=2*PI)
  {
      glNormal3d(0,0,1);
      //Vertex del contorn del cercle
      glVertex3f(RadiTall*cos(AngleDibuix),RadiTall*sin(AngleDibuix),Dimensions[1]);
      //Augmentem l'angle
      AngleDibuix=AngleDibuix+0.0866025;
  }
  glEnd();
    
  //Desactivem tot lo del blending//
  if(ColorRGBA[3]!=1)
  {  
    glDepthMask(true);
    glDisable(GL_BLEND);
  } 
  //////////////////////////////////  
  glPopMatrix();			//Tornem a a matriu inicial


}    

void RotarPunts(int NumPunts, float** PuntsInterns, double Alfa, double Beta, double Gamma)
{
  /////Creem punts auxiliars per a realitzar la rotació////////////
  
      float** PuntsAux1= new float* [3];		//Creem un punter a punters de 3 dimensions
  
      PuntsAux1[0]= new float[NumPunts];		//A cada una de estes li asignem NumPunts dimensions
      PuntsAux1[1]= new float[NumPunts];
      PuntsAux1[2]= new float[NumPunts];
  
      float** PuntsAux2= new float* [3];		//Creem un punter a punters de 3 dimensions
  
      PuntsAux2[0]= new float[NumPunts];		//A cada una de estes li asignem NumPunts dimensions
      PuntsAux2[1]= new float[NumPunts];
      PuntsAux2[2]= new float[NumPunts];
  
       if(PuntsAux1[0]==0 || PuntsAux1[1]==0 || PuntsAux1[2]==0 || PuntsAux1==0)
    {
	std::cout<<"Memòria insuficient"<<std::endl;
    }
      
      
       if(PuntsAux2[0]==0 || PuntsAux2[1]==0 || PuntsAux2[2]==0 || PuntsAux2==0)
    {
	std::cout<<"Memòria insuficient"<<std::endl;
    }
      
    int i=0;
    while(i<NumPunts)
    {
      
      PuntsAux1[0][i]=PuntsInterns[0][i]*cos(Alfa)+PuntsInterns[1][i]*sin(Alfa);
      PuntsAux1[1][i]=-PuntsInterns[0][i]*sin(Alfa)+PuntsInterns[1][i]*cos(Alfa);
      PuntsAux1[2][i]=PuntsInterns[2][i];
      i++;
    }
    
    i=0;
    while(i<NumPunts)
    {
      PuntsAux2[0][i]=PuntsAux1[0][i];
      PuntsAux2[1][i]=PuntsAux1[1][i]*cos(Beta)+PuntsAux1[2][i]*sin(Beta);
      PuntsAux2[2][i]=-PuntsAux1[1][i]*sin(Beta)+PuntsAux1[2][i]*cos(Beta);
      i++;
    }
    
        i=0;
    while(i<NumPunts)
    {
      PuntsInterns[0][i]=PuntsAux2[0][i]*cos(Gamma)+PuntsAux2[1][i]*sin(Gamma);
      PuntsInterns[1][i]=-PuntsAux2[0][i]*sin(Gamma)+PuntsAux2[1][i]*cos(Gamma);
      PuntsInterns[2][i]=PuntsAux2[2][i];
      i++;
    }
    delete [] PuntsAux1[0];
    delete [] PuntsAux1[1];
    delete [] PuntsAux1[2];
    delete [] PuntsAux1;
    
    delete [] PuntsAux2[0];
    delete [] PuntsAux2[1];
    delete [] PuntsAux2[2];
    delete [] PuntsAux2;
}

void escriure(std::string text,float x,float y, float z, float Tamany)    		//imprimira el text en pantalla
{
 unsigned int i;
 char s;
 glPushMatrix();
 glLoadIdentity();
 glTranslatef(x,y,z);
 glScalef(Proporcio_Lletra,Proporcio_Lletra,1.0);

 glScalef(Tamany*0.70,Tamany,1.0);

 for (i=0; i<text.length(); i++)
 {
	s=text[i];
	glutStrokeCharacter(GLUT_STROKE_MONO_ROMAN, s);
 }

 glPopMatrix();
}

//--------------------------------Funcio escriure2, la posicio introduida sera una translacio desde la posicio actual----------------//
void escriure2(std::string text,float x,float y, float z, float Tamany)    		//imprimira el text en pantalla
{
 unsigned int i;
 char s;
 glPushMatrix();
 glTranslatef(x,y,z);
 glScalef(Proporcio_Lletra,Proporcio_Lletra,1.0);

 glScalef(Tamany*0.70,Tamany,1.0);
 
 for (i=0; i<text.length(); i++)
 {
	s=text[i];
	glutStrokeCharacter(GLUT_STROKE_MONO_ROMAN, s);
 }

 glPopMatrix();
}


