/////////////////////////////////////////////////////////////////////////////////////
//    This file is part of Voxel Mages 						  ///
//    Copyright (C) 2015 Vicent Gimenez Alventosa				  ///
//										  ///
//    Voxel Mages is free software: you can redistribute it and/or modify	  ///
//    it under the terms of the GNU General Public License as published by	  ///
//    the Free Software Foundation, either version 3 of the License, or		  ///
//    (at your option) any later version.					  ///
//										  ///
//    Foobar is distributed in the hope that it will be useful,			  ///
//    but WITHOUT ANY WARRANTY; without even the implied warranty of		  ///
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the		  ///
//    GNU General Public License for more details.				  ///
//										  ///
//    You should have received a copy of the GNU General Public License		  ///
//    along with Foobar.  If not, see <http://www.gnu.org/licenses/>.		  ///
/////////////////////////////////////////////////////////////////////////////////////    


#include "geometria.h"

///////Contorns dicom////////
double** Punts_Contorn[MAX_NOMBRE_CONTORNS]; //Cada element del vector guardara tots els punts tridimensionals d'un contorn ordenats per plans. Cada 3 valors tindrem un punt (x,y,z)
int Nombre_Plans_Contorn[MAX_NOMBRE_CONTORNS]; //Guarda el nombre de plans que te cada contorn
int* Nombre_Punts_Contorn[MAX_NOMBRE_CONTORNS]; //Guarda el nombre de punts de cada pla del contorn
int Color_Contorn[MAX_NOMBRE_CONTORNS][3]; //Cada element del vector guarda el color d'un contorn en una upla de 3 (RGB);
std::string Nom_Contorn[MAX_NOMBRE_CONTORNS]; //Cada element del vector guarda el nom d'un contorn
int Nombre_Contorns;
unsigned long int Nombre_Voxels_Contorn[MAX_NOMBRE_CONTORNS]={0}; //Guarda el nombre de voxels dins de cada contorn
double Origen_Dicom[3]; //Guarda l'origen (x,y,z) del pla inferior del DICOM 
/////////////////////////////
///////Llavors dicom/////////
double* Posicio_Llavor[MAX_TIPUS_LLAVORS]; //Cada element, conte les posicions de les llavors d'un tipus [tipus_llavor(0,1,2,3...)][component]. Les components estan ordenades de la forma x1,y1,z1,x2,y2,z2... on els index 1,2... marquen el numero de llavor d'aquest tipus
int Nombre_Llavors[MAX_TIPUS_LLAVORS]; //Guarda el nombre de llavors de cada tipus
int Nombre_Tipus_Llavors; //Guarda el nombre de tipus diferents de llavors
/////////////////////////////
//////////////////DIMENSIONS DE LA PANTALLA EN PIXELS///////


float MARGES=0.0035;   //Factor de l'amplada i altura dels viewports destinada als marges

float AMPLADA_PANTALLA_GUARDAR_CARREGAR=0.34; //Factor de l'amplada de la finestra de guardar/carregar
float ALTURA_PANTALLA_GUARDAR_CARREGAR=0.75; //Factor de l'altura de la finestra de guardar/carregar

float AMPLADA_PANTALLA_GRAN=0.52-MARGES; //Factor que controla l'amplada de la pantalla gran del visor
float ALTURA_PANTALLA_GRAN=1-2*MARGES; //Factor que controla l'altura de la pantalla gran del visor
float ORIGEN_PANTALLA_GRAN_X=MARGES;
float ORIGEN_PANTALLA_GRAN_Y=MARGES;

float AMPLADA_PANTALLA_MENUDA=0.28-2*MARGES; //Factor que controla l'amplada de les pantalles menudes del visor
float ALTURA_PANTALLA_MENUDA=0.5-1.5*MARGES; //Factor que controla l'altura de les pantalles menudes del visor

float ORIGEN_PANTALLA_INFERIOR_X=2*MARGES+AMPLADA_PANTALLA_GRAN;
float ORIGEN_PANTALLA_INFERIOR_Y=MARGES;

float ORIGEN_PANTALLA_SUPERIOR_X=2*MARGES+AMPLADA_PANTALLA_GRAN;
float ORIGEN_PANTALLA_SUPERIOR_Y=2*MARGES+ALTURA_PANTALLA_MENUDA;

float AMPLADA_MENU=0.2; //Factor que controla l'amplada del menu
float ALTURA_MENU=1; //Factor que controla l'altura del menu

float ORIGEN_MENU_X=0.8;
float ORIGEN_MENU_Y=0;

float AMPLADA_VISOR_2D=0.8; //Factor que controla l'amplada del visor 2D
float ALTURA_VISOR_2D=1; //Factor que controla l'altura del visor 2D

float ORIGEN_VISOR_2D_X=0;
float ORIGEN_VISOR_2D_Y=0;

////////////////////////////////////////////////////////////////////////////

int AMPLADA=1500;
int ALTURA=750;

int AMPLADA2;
int ALTURA2;

int Dimensions_Pantalla_Gran[2];
int Origen_Pantalla_Gran[2];

int Dimensions_Pantalla_Menuda[2];
int Origen_Pantalla_Inferior[2];
int Origen_Pantalla_Superior[2];

int Dimensions_Menu[2];
int Origen_Menu[2];

int Dimensions_Visor2D[2];
int Origen_Visor2D[2];

//////////////////////////////////////////////////////////
//////////////////Tamanys de lletres//////////////////////
//////////////////////////////////////////////////////////

float Tamany_Lletra_Menu=0.075;
float Tamany_Lletra_Botons_Menu=0.08;
float Tamany_Lletra_Quadres_Dades=0.08;
float Tamany_Lletra_Pantalla_Geometria=0.11;
float Tamany_Lletra_Espai=0.004;
//////////////////////////////////////////////////////////
//////////////////BOTONS//////////////////////////////////
////////////////////////////////////////////////////////// 
B_Rect NovaFigura; 
B_Rect SelFigura;
B_Rect BColor;
B_Rect BGuardar;
B_Rect BGuardarVox;
B_Rect BCarregar;
B_Rect BEspai;
B_Rect BSimulacio;
B_Rect BLlengua;
B_Rect BResultats;
B_Rect BDicom;
B_Rect BTransformarGrup;

B_Rect NouCub;
B_Rect NovaEsfera;
B_Rect NouCilindre;
B_Rect NouPla;
B_Rect NouSeccioEsf;

B_Rect ColorObjecte;
B_Rect ColorMaterial;
B_Rect ColorPrioritat;
B_Rect ColorOpacitat;
B_Rect ColorVoxels;

B_Rect CVoxPunts;
B_Rect CVoxQuad;
B_Rect CVoxPla[3];		//Controlen els plans de tall superiors
B_Rect CVoxPlaInf[3];		//i inferiors respectivament
B_Rect BMallat;

B_Rect BGuardarGeo;
B_Rect BGuardarPenelope;
B_Rect BGuardarGeant4;
B_Rect BGuardarVoxelsPene;

B_Rect Crear;

B_Rect Centre[3];		//Per a introduir el centre del cub
B_Rect Dim[3];			//Per a introduir les dimensions del cub
B_Rect Prioritat;		//Per a introduir la prioritat al pintar	
B_Rect Interns;			//Per a introduir quines figures estan contingudes en aquesta
B_Rect AfegirInterns[2];	//Per a afegir i eliminar el grup de prioritat als interns de la figura
B_Rect MatDens[2];		//Per a afegir el material i la densitat al cub
B_Rect Angles[3];
B_Rect BTub;                    //Per a dir si un cilindre es un tub o un cilindre/con masis

B_Rect BNetejarSeleccio;        //Neteja la seleccio de les figures a transformar
B_Rect IFiguraSelec;		//Per a introduir el numero de figura a seleccionar
B_Rect IMaterialSelec;          //Per a introduir el numero de material a seleccionar
B_Rect ICosSelec;               //Per a introduir el cos a seleccionar
B_Rect AfegirFiguraSelec[2];    //Afig la figura amb el numero especificat
B_Rect AfegirMaterialSelec[2];  //Afig les figures amb el material especificat
B_Rect AfegirCosSelec[2];       //Afig les figures amb el cos especificat
B_Rect BTranslacio;             //Boto que ens permet relaitzar una translació d'un grup de figures
B_Rect BParametresTransformacio[3]; //Botons per a introduir els parametres de la transformacio
B_Rect BBorrar;

B_Rect BNumVox[3];
B_Rect BDimVox[3];
/////////////////Botons menu 2///////////////////////////
B_Rect BGuardar2;
B_Rect BINomArxiu2;
B_Rect BCancelar2;
B_Rect BBorrar2;
B_Rect BCarregar2;

/////////////////Botons simulacio////////////////////////

B_Rect BNomSimulacio;
B_Rect BNomArxiuConfig;
//B_Rect BNomArxiuMaterials;
B_Rect BNomArxiuGeoQuad;
B_Rect BNomArxiuGeoVox;
B_Rect BNumSimulacions;

/////////////////Botons visor resultats///////////////////////

B_Rect BDosiMax;
B_Rect BDosiMin;

B_Rect BEscalaLog;
/////////////////Botons idioma////////////////////////
B_Rect BIdioma[3];
/////////////////Botons Veure Dicom////////////////////////
B_Rect Tallar;
B_Rect BPintMatDCM;
B_Rect BPintDensDCM;
B_Rect BDicom2D;
B_Rect BContornsDICOM;
//////////////////////////////////////////////////////////
/////////////////Variables per a introduir////////////////
//////////////////////////////////////////////////////////
////////////////////////////////////////////////////////
////////////////////////SIMULACIO///////////////////////
////////////////////////////////////////////////////////
char INomSimulacio[100];
char INomArxiuConfig[100];
//char INomArxiuMaterials[100];
char INomArxiuGeoQuad[100];
char INomArxiuGeoVox[100];
char INumSimulacions[2]={'1','V'};

std::string NomSimulacio;
std::string NomArxiuConfig;
//std::string NomArxiuMaterials[20];
std::string NomArxiuGeoQuad;
std::string NomArxiuGeoVox;
int NumSimulacions=1;
////////////////////////////////////////////////////////
////////////////////////RESULTATS///////////////////////
////////////////////////////////////////////////////////

int NumColorsResultats=10;

float ColorsResultats[12][3] = {
  {0.900, 0.900, 0.900},
  {0.800, 0.800, 0.800},
  {0.700, 0.700, 0.700},
  {0.600, 0.600, 0.600},
  {0.500, 0.500, 0.500},
  {0.400, 0.400, 0.400},
  {0.300, 0.300, 0.300},
  {0.200, 0.200, 0.200},
  {0.100, 0.100, 0.100},
  {0.000, 0.000, 0.000},
//  {0.098, 0.027, 0.102},
//  {0.035, 0.004, 0.184},
//  {0.016, 0.016, 0.286},
//  {0.000, 0.027, 0.392},
//  {0.047, 0.173, 0.541},
//  {0.094, 0.322, 0.694},
//  {0.224, 0.490, 0.819},
//  {0.525, 0.710, 0.898},
//  {0.827, 0.925, 0.973},
//  {0.945, 0.914, 0.749},
//  {0.973, 0.788, 0.373},
//  {1.000, 0.667, 0.000},
//  {0.800, 0.502, 0.000},
//  {0.800, 0.000, 0.000},
//  {1.000, 0.000, 0.000},
};

float MaxDosis=0;	//guarda la dosi màxima per a asignar després els colors
float MinDosis=0;
float IntervalColorResultats=0;
float DosisMaximaResultats=0;	//Guarda la dosi màxima dels resultats

char IMaxDosisChar[100];
char IMinDosisChar[100];
bool EscalaLog=false;
////////////////////////////////////////////////////////
//////////////////////VISOR DICOM///////////////////////
////////////////////////////////////////////////////////
float DimEspaiDicom[3];		//Controla les dimensions de l'espai del dicom carregat
char INomDicom[100];
bool PintMatDicom=true;
bool PintDensDicom=false;
bool GuardarVoxDicomRep=true;
bool GuardarVoxDicomRepVisible=true;
bool DibuixarContorns=false;    //Controla si han de dibuixar-se els contorns

float IntervalColorDicom=0;		//Per al visor de densitats, guarda el tamany dels intervals de color.
float MaxDensDCM=0;
float MinDensDCM=0;

std::string ModalitatDicom;             //Guarda la modalitat de dicom que estem vegent (CT, US...)
std::string NomDicom;
bool PintarDicom=false;
int NumVoxVisiblesDicom=0;		//Conta el nombre de vòels visibles al DICOM
//////////Visor 2D////////////
bool ActivarVisor2D=false;
int PlaVisor2D=0;
float AmpladaVisor2D;
float AlturaVisor2D;

float DimPlaDicom[3]={0,0,0};	//[0] i [1] guarden les dimensions x i y dels plans del DICOM respectivament, [2] guarda el tamany dels voxels en l'eix Z

////////////////////////////////////////////////////////
////////////////GUARDAR/CARREGAR/BORRAR/////////////////
////////////////////////////////////////////////////////
char INomArxiuChar[100];
////////////////////////////////////////////////////////
//////////////////////Seleccionar figura////////////////
////////////////////////////////////////////////////////
int ISelFig;
int ISelCos;
int ISelMaterial;
int FiguresSeleccionades[1000]={0};
int NumFiguresSeleccionades=0;
int IParametresTransformacio[3];

char ISelFigChar[4]={'V','V','V','V'};
char ISelCosChar[4]={'V','V','V','V'};
char ISelMaterialChar[4]={'V','V','V','V'};
char IParametresTransformacioChar[3][100];
////////////////////////////////////////////////////////
//////////////////////CUB///////////////////////////////
////////////////////////////////////////////////////////
double ICentreCub[3];
double IDimCub[3];
int IPrioritatCub;
int IDinsCub[100];
int IMatCub;
float IDensCub;
double IAnglesCub[3];

char ICentreCubChar[3][100];
char IDimCubChar[3][100];
char IPrioritatCubChar[4]={'V','V','V','V'};
char IDinsCubChar[4]={'V','V','V','V'};
char DinsCubChar[100][4];
char IMatCubChar[3]={'V','V','V'};
char IDensCubChar[100];
char IAnglesCubChar[3][100];

////////////////////////////////////////////////////////
//////////////////////ESFERA////////////////////////////
////////////////////////////////////////////////////////
double ICentreEsf[3];
double IDimEsf;
int IPrioritatEsf;
int IDinsEsf[100];
int IMatEsf;
float IDensEsf;

char ICentreEsfChar[3][100];
char IDimEsfChar[100];
char IPrioritatEsfChar[4]={'V','V','V','V'};
char IDinsEsfChar[4]={'V','V','V','V'};
char DinsEsfChar[100][4];
char IMatEsfChar[3]={'V','V','V'};
char IDensEsfChar[100];

////////////////////////////////////////////////////////
//////////////////////CILINDRES/////////////////////////
////////////////////////////////////////////////////////
double ICentreCil[3];
double IDimCil[3];
int IPrioritatCil;
int IDinsCil[100];
int IMatCil;
float IDensCil;
double IAnglesCil[3];
bool ITubCil=false;                       //Per a dir si un cilindre es un tub o un cilindre/con masis

char ICentreCilChar[3][100];
char IDimCilChar[3][100];
char IPrioritatCilChar[4]={'V','V','V','V'};
char IDinsCilChar[4]={'V','V','V','V'};
char DinsCilChar[100][4];
char IMatCilChar[3]={'V','V','V'};
char IDensCilChar[100];
char IAnglesCilChar[3][100];


////////////////////////////////////////////////////////
//////////////////////PLA INFINIT///////////////////////
////////////////////////////////////////////////////////
double ICentrePla[3];
int IPrioritatPla;
int IDinsPla[100];
int IMatPla;
float IDensPla;
double IAnglesPla[3];

char ICentrePlaChar[3][100];
char IPrioritatPlaChar[4]={'V','V','V','V'};
char IDinsPlaChar[4]={'V','V','V','V'};
char DinsPlaChar[100][4];
char IMatPlaChar[3]={'V','V','V'};
char IDensPlaChar[100];
char IAnglesPlaChar[3][100];

////////////////////////////////////////////////////////
//////////////////SECCIÓ ESFERA/////////////////////////
////////////////////////////////////////////////////////
double ICentreSecEsf[3];
double IDimSecEsf[2];
int IPrioritatSecEsf;
int IDinsSecEsf[100];
int IMatSecEsf;
float IDensSecEsf;
double IAnglesSecEsf[3];

char ICentreSecEsfChar[3][100];
char IDimSecEsfChar[2][100];
char IPrioritatSecEsfChar[4]={'V','V','V','V'};
char IDinsSecEsfChar[4]={'V','V','V','V'};
char DinsSecEsfChar[100][4];
char IMatSecEsfChar[3]={'V','V','V'};
char IDensSecEsfChar[100];
char IAnglesSecEsfChar[3][100];

////////////////////////////////////////////////////////
/////////////////////COLOR, VOXELS//////////////////////
////////////////////////////////////////////////////////
float PlansTall[3]={10,10,10};
float PlansTallInf[3]={0,0,0};

char IPlansTallChar[3][100];
char IPlansTallCharInf[3][100];

bool SeleccioFigura=false;	//Controla si estem modificant una figura ja existent o creant una
int TipusFiguraSel=0;		//Guarda el tipus de figura seleccionada (1-rectangle,2-esfera,3-cilindre/con,4-pla,5-seccio d'esfera)
int NumFigSel=0;		//Guarda la posició que ocupa la figura seleccionada dins del vector d'eixe tipus de figura

float Opacitat=0.3;             //Controla la opacitat quan estem seleccionant figura
float OpacitatNormal=1.0;       //Controla la opacitat normal de les figures, que podem canviar al menu de color
////////////////////////////////////////////////////////
//////////////////////LLISTA VOXELS/////////////////////
////////////////////////////////////////////////////////

bool CrearLlistaVox=false;		//Controla si s'ha de crear la llista amb els voxels
bool LlistaVoxCreada=false;		//Controla si s'ha creat ja la llista amb els voxels
bool VoxelsActualitzats=false;		//Controla si cal voxelitzar la geometria o ja està actualitzat el voxelitzat
GLuint llistaVox;

////////////////////////////////////////////////////////
//////////////////////LLISTA MALLAT/////////////////////
////////////////////////////////////////////////////////

//Mallat Malla1;

bool CrearLlistaMallat=false;
bool LlistaMallatCreada=false;
bool MallatActualitzat=false;
GLuint llistaMalla;
////////////////////////////////////////////////////////
//////////////////////ESPAI/////////////////////////////
////////////////////////////////////////////////////////
int INumVox[3];
float IDimVox[3];

char INumVoxChar[3][4];
char IDimVoxChar[3][100];

////////////////////////////////////////////////////////
//////////////////////TEXTURES//////////////////////////
////////////////////////////////////////////////////////
GLuint TexturaMenu;
std::string NomArxiuTexturaMenu="Textures/FonsMenu";
int DimTexturaMenu[2]={1,1};
int NumSamplesTexMenu=3;			//Per a RGB tenim 3, per a RGBA tenim 4

GLuint TexturaBotons;
std::string NomArxiuTexturaBotons="Textures/TexturaBotoGran";
int DimTexturaBotons[2]={120,30};
int NumSamplesTexBotons=3;			//Per a RGB tenim 3, per a RGBA tenim 4

GLuint TexturaBotonsMenuts;
std::string NomArxiuTexturaBotonsMenuts="Textures/TexturaBotoMenut";
int DimTexturaBotonsMenuts[2]={60,30};
int NumSamplesTexBotonsMenuts=3;			//Per a RGB tenim 3, per a RGBA tenim 4

GLuint TexturaBotonsFinestra;
std::string NomArxiuTexturaBotonsFinestra="Textures/TexturaBotoMenut";
int DimTexturaBotonsFinestra[2]={60,30};
int NumSamplesTexBotonsFinestra=3;			//Per a RGB tenim 3, per a RGBA tenim 4

bool CarregarTexturaMenu=true;			//Controla si ja s'ha carregat les textures del menu i botons
bool CarregarTexturaFinestra=true;
//////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////
////Definim el nombre de figures de cada tipus  en el .h//
//////////////////////////////////////////////////////////
////////////////////////////////////////////////////////// 
//////////////////////////////////////////////////////////
/////		No tocar 		//////////////////
//////////////////////////////////////////////////////////
 GLfloat Colors[200][3];				//
							//
  Rectangle rectangles[MaxCubs+1];			//							
							//
  Esfera esferes[MaxEsferes+1];				//							
							//
  Cilindre cilindres[MaxCilindres+1];			//							
							//				
  Pla plans[MaxPlans+1];				//
							//
  SeccioEsfera secEsf[MaxSecEsf+1];			//
  bool PintObjectes=true;				//
  bool PintEsp=true;					//
  bool PintVox=false;					//
  bool PintVQuad=true;					//
  bool PintMallat=false;				//
  int  PintObMat=0;					//
  bool menuCreat=false;					//
  bool menuCreat2=false; //Menu de guardar/carregar	//
							//
//////////////////////////////////////////////////////////

int NumCubs=0;
int NumCil=0;
int NumEsf=0;
int NumPla=0;
int NumSecEsf=0;
int Idioma=0;			//Controla l'idioma del programa, 0 és angles, 1 català i 2 castellà
//////////////////////////////////////////////////////////
//	  Variables que controlen el menú		//
//////////////////////////////////////////////////////////
							//
  int ControlMenu=0;				        //
  int ControlSubMenu=0;					//
  int ControlSubSubMenu=0;				//
  float TamanyBotons[2]={120,30};			//
  float DistBotonsY=35;					//
							//
//////////////////////////////////////////////////////////
////////////////////////////////////////////Aquesta funcio crea la geometria a mostrar per pantalla/////////////////////////////////////////////
void geo()
{
//////////////////////////////////////////////////////////////
////Posicions i dimensions de les diferents finestres       //
//////////////////////////////////////////////////////////////
 AMPLADA=1500;
 ALTURA=750;
 
 AMPLADA2=float(AMPLADA)*AMPLADA_PANTALLA_GUARDAR_CARREGAR;
ALTURA2=float(ALTURA)*ALTURA_PANTALLA_GUARDAR_CARREGAR;

 //L'origen es el canto esquerra inferior

 Dimensions_Pantalla_Gran[0]=AMPLADA*AMPLADA_PANTALLA_GRAN;
 Dimensions_Pantalla_Gran[1]=ALTURA*ALTURA_PANTALLA_GRAN;
 
 Origen_Pantalla_Gran[0]=AMPLADA*ORIGEN_PANTALLA_GRAN_X;
 Origen_Pantalla_Gran[1]=ALTURA*ORIGEN_PANTALLA_GRAN_Y;

 Dimensions_Pantalla_Menuda[0]=AMPLADA*AMPLADA_PANTALLA_MENUDA;
 Dimensions_Pantalla_Menuda[1]=ALTURA*ALTURA_PANTALLA_MENUDA;

 Origen_Pantalla_Inferior[0]=AMPLADA*ORIGEN_PANTALLA_INFERIOR_X;
 Origen_Pantalla_Inferior[1]=ALTURA*ORIGEN_PANTALLA_INFERIOR_Y;

 Origen_Pantalla_Superior[0]=AMPLADA*ORIGEN_PANTALLA_SUPERIOR_X;
 Origen_Pantalla_Superior[1]=ALTURA*ORIGEN_PANTALLA_SUPERIOR_Y;

 Dimensions_Menu[0]=AMPLADA*AMPLADA_MENU;
 Dimensions_Menu[1]=ALTURA*ALTURA_MENU;
   
 Origen_Menu[0]=AMPLADA*ORIGEN_MENU_X;
 Origen_Menu[1]=ALTURA*ORIGEN_MENU_Y;

 Dimensions_Visor2D[0]=AMPLADA*AMPLADA_VISOR_2D;
 Dimensions_Visor2D[1]=ALTURA*ALTURA_VISOR_2D;
 
 Origen_Visor2D[0]=AMPLADA*ORIGEN_VISOR_2D_X;
 Origen_Visor2D[1]=ALTURA*ORIGEN_VISOR_2D_Y;

 AmpladaVisor2D=Dimensions_Visor2D[0]*(1-0.01); //L'amplada del visor no inclou l'amplada de la barra
 AlturaVisor2D=Dimensions_Visor2D[1];
 
//////////////////////////////////////////////////////////////
////Introduïm el nombre de Voxels i les dimensions d'aquests//
//////////////////////////////////////////////////////////////
  NumVoxels[0]=100;				//Eix X
  NumVoxels[1]=100;				//Eix Y
  NumVoxels[2]=100;				//Eix Z
  //Dimensions dels voxels
  DimVoxels[0]=0.1;				//Dimensió X
  DimVoxels[1]=0.1;				//Dimensió Y
  DimVoxels[2]=0.1;				//Dimensió Z
  //Calculem el tamany de l'espai(No tocar)
  DimEspai[0]=NumVoxels[0]*DimVoxels[0];
  DimEspai[1]=NumVoxels[1]*DimVoxels[1];
  DimEspai[2]=NumVoxels[2]*DimVoxels[2];
  
  
////////////////////////////////////////////////////////// 
   iniciar();						//
//////////////////////////////////////////////////////////

    //Calculem el radi màxim d'un voxel
   RadiMaxVoxel=pow(pow(DimVoxels[0]*0.5,2)+pow(DimVoxels[1]*0.5,2)+pow(DimVoxels[2]*0.5,2),0.5);
       
   
////////////////////////////////////////////////////////////////////
/////Creem una paleta de colors per als diferents objectes//////////
////////////////////////////////////////////////////////////////////   
      
   int i=1;
     Colors[0][0]= 0;
     Colors[0][1]= 0;
     Colors[0][2]= 0;

     
   while(i<200)
   {

     Colors[i][0]= (rand() % 101)/100.0;
     Colors[i][1]= (rand() % 101)/100.0;
     Colors[i][2]= (rand() % 101)/100.0;
     i++;
   }
   
   //Posem uns colors inicials per defecte//
     //Color 1
     Colors[1][0]= 1;
     Colors[1][1]= 0;
     Colors[1][2]= 0;
     //Color 2
     Colors[2][0]= 0;
     Colors[2][1]= 1;
     Colors[2][2]= 0;
     //Color 3
     Colors[3][0]= 0;
     Colors[3][1]= 0;
     Colors[3][2]= 1;
     //Color 4
     Colors[4][0]= 1;
     Colors[4][1]= 0.308;
     Colors[4][2]= 0;
     //Color 5
     Colors[5][0]= 0;
     Colors[5][1]= 1;
     Colors[5][2]= 0.537255;
     //Color 6
     Colors[6][0]= 0.4;
     Colors[6][1]= 0;
     Colors[6][2]= 1;
     //Color 7
     Colors[7][0]= 1;
     Colors[7][1]= 0.635294;
     Colors[7][2]= 0;
     //Color 8
     Colors[8][0]= 0;
     Colors[8][1]= 1;
     Colors[8][2]= 1;
     //Color 9
     Colors[9][0]= 1;
     Colors[9][1]= 0;
     Colors[9][2]= 1;
     //Color 10
     Colors[10][0]= 1;
     Colors[10][1]= 1;
     Colors[10][2]= 0;
     //Color 11
     Colors[11][0]= 0;
     Colors[11][1]= 0.5686275;
     Colors[11][2]= 1;
     //Color 12
     Colors[12][0]= 1;
     Colors[12][1]= 0;
     Colors[12][2]= 0.30196;
     //Color 13
     Colors[13][0]= 0.60392;
     Colors[13][1]= 1;
     Colors[13][2]= 0;
     //Ara repetim els mateixos colors pero mes foscos//
     
     i=1;
     float IntFoscor=0.20;
     int NumColBase=13;
     while(i<=3)
     {
	  //Color 1
	  Colors[NumColBase*i+1][0]= 1-IntFoscor*i;
	  Colors[NumColBase*i+1][1]= 0;
	  Colors[NumColBase*i+1][2]= 0;
	  //Color 2
	  Colors[NumColBase*i+2][0]= 0;
	  Colors[NumColBase*i+2][1]= 1-IntFoscor*i;
	  Colors[NumColBase*i+2][2]= 0;
	  //Color 3
	  Colors[NumColBase*i+3][0]= 0;
	  Colors[NumColBase*i+3][1]= 0;
	  Colors[NumColBase*i+3][2]= 1-IntFoscor*i;
	  //Color 4
	  Colors[NumColBase*i+4][0]= 1-IntFoscor*i;
	  Colors[NumColBase*i+4][1]= 0.308-IntFoscor*i*0.308;
	  Colors[NumColBase*i+4][2]= 0;
	  //Color 5
	  Colors[NumColBase*i+5][0]= 0;
	  Colors[NumColBase*i+5][1]= 1-IntFoscor*i;
	  Colors[NumColBase*i+5][2]= 0.537255-IntFoscor*i*0.537255;
	  //Color 6
	  Colors[NumColBase*i+6][0]= 0.4-IntFoscor*i*0.4;
	  Colors[NumColBase*i+6][1]= 0;
	  Colors[NumColBase*i+6][2]= 1-IntFoscor*i;
	  //Color 7
	  Colors[NumColBase*i+7][0]= 1-IntFoscor*i;
	  Colors[NumColBase*i+7][1]= 0.635294-IntFoscor*i*0.635294;
	  Colors[NumColBase*i+7][2]= 0;
	  //Color 8
	  Colors[NumColBase*i+8][0]= 0;
	  Colors[NumColBase*i+8][1]= 1-IntFoscor*i;
	  Colors[NumColBase*i+8][2]= 1-IntFoscor*i;
	  //Color 9
	  Colors[NumColBase*i+9][0]= 1-IntFoscor*i;
	  Colors[NumColBase*i+9][1]= 0;
	  Colors[NumColBase*i+9][2]= 1-IntFoscor*i;
	  //Color 10
	  Colors[NumColBase*i+10][0]= 1-IntFoscor*i;
	  Colors[NumColBase*i+10][1]= 1-IntFoscor*i;
	  Colors[NumColBase*i+10][2]= 0;
	  //Color 11
	  Colors[NumColBase*i+11][0]= 0;
	  Colors[NumColBase*i+11][1]= 0.5686275-IntFoscor*i*0.5686275;
	  Colors[NumColBase*i+11][2]= 1-IntFoscor*i;
	  //Color 12
	  Colors[NumColBase*i+12][0]= 1-IntFoscor*i;
	  Colors[NumColBase*i+12][1]= 0;
	  Colors[NumColBase*i+12][2]= 0.30196-IntFoscor*i*0.30196;
	  //Color 13
	  Colors[NumColBase*i+13][0]= 0.60392-IntFoscor*i*0.60392;
	  Colors[NumColBase*i+13][1]= 1-IntFoscor*i;
	  Colors[NumColBase*i+13][2]= 0;
	  i++;
     }
            
     
}
//-----------------------------------------------------FUNCIÓ MOSTRAR PER PANTALLA-------------------------------------------------------//
void mostrar()
{
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
      glEnable(GL_LIGHT0);		//activem la font de llum número 0

    
int i=0;	//Recorre els ordres de prioritat    
int j=1;    	//Recorre les diferents figures
int tempsAux=0; 	//Serveix per a calcular intervals de temps
///////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Aci dibuixem i carreguem les figures/////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////
if(PintObjectes==true)
{
  if(CrearPunts==true)
  { 
    i=0;
    j=0;
    int k=0;
    while(i<NumVoxels[0])
    {
      j=0;
      while(j<NumVoxels[1])
      {
	k=0;
	while(k<NumVoxels[2])
	{
	  Voxels[i][j][k][0]=1;
	  Voxels[i][j][k][1]=1;
	  k++;
	}
	j++;
      }
      i++;
    }
    tempsAux=glutGet( GLUT_ELAPSED_TIME );		//Mesura el temps transcorregut desde el prmer glutGet
      
  }
  
  i=1;
  while(i<=1000)			//1000 és el nombre màxim de prioritats
  {
    bool FerCopia=false;
    int NumTrobat=0;
    //Comprovem primer si cal fer copia dels vòxels. Sols serà necessàri si tenim dos o més figures amb la mateixa prioritat//
    j=0;
    while(j<1000)
    {
      if(i==PrioritatsAsignades[0][j])
      {
	NumTrobat++;
      }
      if(NumTrobat>=2 && CrearPunts==true)
      {
	FerCopia=true;
	break;
      }
      j++;
    }
    //Primer fem una copia dels vòxels. Açò es fara al canviar de prioritat, es a dir, en cada objecte//
    if(FerCopia==true)
    {
      //Si cal fer copia, primer creem una matriu per a fer la copia//////////////////////////
      //Construim la matriu de voxels i la inicialitzem
	int ContConsVox=0;
	int ContConsVox2=0;
	int ContConsVox3=0;

	VoxelsCopia= new float***[NumVoxels[0]];
	while(ContConsVox<NumVoxels[0])
	{
	  VoxelsCopia[ContConsVox]=new float**[NumVoxels[1]];
	  ContConsVox2=0;
	  while(ContConsVox2<NumVoxels[1])
	  {
	    VoxelsCopia[ContConsVox][ContConsVox2]=new float*[NumVoxels[2]];
	    ContConsVox3=0;
	    while(ContConsVox3<NumVoxels[2])
	    {
	      VoxelsCopia[ContConsVox][ContConsVox2][ContConsVox3]=new float[2];
	      
	      VoxelsCopia[ContConsVox][ContConsVox2][ContConsVox3][0]=1;
	      VoxelsCopia[ContConsVox][ContConsVox2][ContConsVox3][1]=1;
	      ContConsVox3++;
	    }
	    ContConsVox2++;
	  }
	  
	  ContConsVox++;
	}      
      ///////////////////////////////////////////////////////////////
      ///Una vegada creada la matriu, fem la copia///////////////////
      ///////////////////////////////////////////////////////////////
      int m=0;
      j=0;
      int k=0;
      while(m<NumVoxels[0])
      {
	j=0;
	while(j<NumVoxels[1])
	{
	  k=0;
	  while(k<NumVoxels[2])
	  {
	    VoxelsCopia[m][j][k][0]=Voxels[m][j][k][0];
	    VoxelsCopia[m][j][k][1]=Voxels[m][j][k][1];
	    k++;
	  }
	  j++;
	}
	m++;
      }
    }
    ///////////////////////////////////////////////////////////////////////////////////////////////
    j=1;
    while(j<=NumCubs)
    {
      if(rectangles[j].Prioritat==i)
      {
	//Mirem si esta activada l'opcio de seleccionar figura. Si és així reduim la opacitat de totes les figures exepte la seleccionada//
	if(SeleccioFigura==true)
	{
	  if(TipusFiguraSel==1 && NumFigSel==j)
	  {
	    rectangles[j].CanviarOpacitat(1);
	  }
	  else
	  {
	    rectangles[j].CanviarOpacitat(Opacitat);	    
	  }
	}
	////////////////Si no hi ha figura seleccionada, totes seran opaques/////////////
	else
	{
	    rectangles[j].CanviarOpacitat(OpacitatNormal);	    	  
	}
	/////////////////////////////////////////////////////////////////////////////////
	if(PintObMat==0)		//Controla si pinta el color segons el numero d'objecte, la prioritat de l'objecte o el material
	{
	  rectangles[j].CanviarColor(Colors[rectangles[j].NumeroFigura()][0],Colors[rectangles[j].NumeroFigura()][1],Colors[rectangles[j].NumeroFigura()][2]);
	}else if(PintObMat==1)		//Esta part pintara segons el material
	{
	  rectangles[j].CanviarColor(Colors[rectangles[j].Material][0],Colors[rectangles[j].Material][1],Colors[rectangles[j].Material][2]);
	}
	else if(PintObMat==2)		//Esta part pintara segons la prioritat
	{
	  rectangles[j].CanviarColor(Colors[rectangles[j].Prioritat][0],Colors[rectangles[j].Prioritat][1],Colors[rectangles[j].Prioritat][2]);
	}
	rectangles[j].Pintar();
		
      }
      j++;
    }
    j=1;
          
    while(j<=NumEsf)
    {
      if(esferes[j].Prioritat==i)
      {
	//Mirem si esta activada l'opcio de seleccionar figura. Si és així reduim la opacitat de totes les figures exepte la seleccionada//
	if(SeleccioFigura==true)
	{
	  if(TipusFiguraSel==2 && NumFigSel==j)
	  {
	    esferes[j].CanviarOpacitat(1);
	  }
	  else
	  {
	    esferes[j].CanviarOpacitat(Opacitat);	    
	  }
	}
	////////////////Si no hi ha figura seleccionada, totes seran opaques/////////////
	else
	{
	    esferes[j].CanviarOpacitat(OpacitatNormal);	    	  
	}
	/////////////////////////////////////////////////////////////////////////////////	
	if(PintObMat==0)		//Controla si pinta el color segons el numero d'objecte, la prioritat de l'objecte o el material
	{
	  esferes[j].CanviarColor(Colors[esferes[j].NumeroFigura()][0],Colors[esferes[j].NumeroFigura()][1],Colors[esferes[j].NumeroFigura()][2]);
	}else if(PintObMat==1)		//Esta part pintara segons el material
	{
	  esferes[j].CanviarColor(Colors[esferes[j].Material][0],Colors[esferes[j].Material][1],Colors[esferes[j].Material][2]);
	}
	else if(PintObMat==2)		//Esta part pintara segons la prioritat
	{
	  esferes[j].CanviarColor(Colors[esferes[j].Prioritat][0],Colors[esferes[j].Prioritat][1],Colors[esferes[j].Prioritat][2]);
	}
	esferes[j].Pintar();
		
      }
      j++;
    }
    j=1;
    while(j<=NumCil)
    {
      if(cilindres[j].Prioritat==i)
      {
	//Mirem si esta activada l'opcio de seleccionar figura. Si és així reduim la opacitat de totes les figures exepte la seleccionada//
	if(SeleccioFigura==true)
	{
	  if(TipusFiguraSel==3 && NumFigSel==j)
	  {
	    cilindres[j].CanviarOpacitat(1);
	  }
	  else
	  {
	    cilindres[j].CanviarOpacitat(Opacitat);	    
	  }
	}
	////////////////Si no hi ha figura seleccionada, totes seran opaques/////////////
	else
	{
	    cilindres[j].CanviarOpacitat(OpacitatNormal);	    	  
	}
	/////////////////////////////////////////////////////////////////////////////////	
	if(PintObMat==0)		//Controla si pinta el color segons el numero d'objecte, la prioritat de l'objecte o el material
	{
	  cilindres[j].CanviarColor(Colors[cilindres[j].NumeroFigura()][0],Colors[cilindres[j].NumeroFigura()][1],Colors[cilindres[j].NumeroFigura()][2]);
	}else if(PintObMat==1)		//Esta part pintara segons el material
	{
	  cilindres[j].CanviarColor(Colors[cilindres[j].Material][0],Colors[cilindres[j].Material][1],Colors[cilindres[j].Material][2]);
	}
	else if(PintObMat==2)		//Esta part pintara segons la prioritat
	{
	  cilindres[j].CanviarColor(Colors[cilindres[j].Prioritat][0],Colors[cilindres[j].Prioritat][1],Colors[cilindres[j].Prioritat][2]);
	}
	cilindres[j].Pintar();
	
      }
      j++;
    }
    j=1;
    while(j<=NumPla)
    {
      if(plans[j].Prioritat==i)
      {
	//Reescalem el pla quan el pintem//
	float DimMin=DimEspai[0];	//Mirem la dimensió minima per a asignar-li una dimensió al pla

	if(DimMin>DimEspai[1])
	{
	  DimMin=DimEspai[1];
	}
	if(DimMin>DimEspai[2])
	{
	  DimMin=DimEspai[2];     
	}	
	plans[j].CanviarDimensions(DimMin/4.0);
	//Mirem si esta activada l'opcio de seleccionar figura. Si és així reduim la opacitat de totes les figures exepte la seleccionada//
	if(SeleccioFigura==true)
	{
	  if(TipusFiguraSel==4 && NumFigSel==j)
	  {
	    plans[j].CanviarOpacitat(1);
	  }
	  else
	  {
	    plans[j].CanviarOpacitat(Opacitat);	    
	  }
	}
	////////////////Si no hi ha figura seleccionada, totes seran opaques/////////////
	else
	{
	    plans[j].CanviarOpacitat(OpacitatNormal);	    	  
	}
	/////////////////////////////////////////////////////////////////////////////////	
	if(PintObMat==0)		//Controla si pinta el color segons el numero d'objecte, la prioritat de l'objecte o el material
	{
	  plans[j].CanviarColor(Colors[plans[j].NumeroFigura()][0],Colors[plans[j].NumeroFigura()][1],Colors[plans[j].NumeroFigura()][2]);
	}else if(PintObMat==1)		//Esta part pintara segons el material
	{
	  plans[j].CanviarColor(Colors[plans[j].Material][0],Colors[plans[j].Material][1],Colors[plans[j].Material][2]);
	}
	else if(PintObMat==2)		//Esta part pintara segons la prioritat
	{
	  plans[j].CanviarColor(Colors[plans[j].Prioritat][0],Colors[plans[j].Prioritat][1],Colors[plans[j].Prioritat][2]);
	}
	plans[j].Pintar();
	
      }
      j++;
    }
    j=1;
    while(j<=NumSecEsf)
    {
      if(secEsf[j].Prioritat==i)
      {
	//Mirem si esta activada l'opcio de seleccionar figura. Si és així reduim la opacitat de totes les figures exepte la seleccionada//
	if(SeleccioFigura==true)
	{
	  if(TipusFiguraSel==5 && NumFigSel==j)
	  {
	    secEsf[j].CanviarOpacitat(1);
	  }
	  else
	  {
	    secEsf[j].CanviarOpacitat(Opacitat);	    
	  }
	}
	////////////////Si no hi ha figura seleccionada, totes seran opaques/////////////
	else
	{
	    secEsf[j].CanviarOpacitat(OpacitatNormal);	    	  
	}
	/////////////////////////////////////////////////////////////////////////////////	
	if(PintObMat==0)		//Controla si pinta el color segons el numero d'objecte, la prioritat de l'objecte o el material
	{
	  secEsf[j].CanviarColor(Colors[secEsf[j].NumeroFigura()][0],Colors[secEsf[j].NumeroFigura()][1],Colors[secEsf[j].NumeroFigura()][2]);
	}else if(PintObMat==1)		//Esta part pintara segons el material
	{
	  secEsf[j].CanviarColor(Colors[secEsf[j].Material][0],Colors[secEsf[j].Material][1],Colors[secEsf[j].Material][2]);
	}
	else if(PintObMat==2)		//Esta part pintara segons la prioritat
	{
	  secEsf[j].CanviarColor(Colors[secEsf[j].Prioritat][0],Colors[secEsf[j].Prioritat][1],Colors[secEsf[j].Prioritat][2]);
	}
	secEsf[j].Pintar();
	
      }
      j++;
    }
    
    if(FerCopia==true)
    {
      //Ara omplim els vòxels amb valors -999 amb els vòxels de la copia. Aquests vòxels corresponen a buits de l'objecte, ja que la figura que forma aquest buit se li ha asignat material zero
      int m=0;
      j=0;
      int k=0;
      while(m<NumVoxels[0])
      {
	j=0;
	while(j<NumVoxels[1])
	{
	  k=0;
	  while(k<NumVoxels[2])
	  {
	    if(Voxels[m][j][k][0]==-999)
	    {
	      Voxels[m][j][k][0]=VoxelsCopia[m][j][k][0];
	      Voxels[m][j][k][1]=VoxelsCopia[m][j][k][1];
	    }
	    k++;
	  }
	  j++;
	}
	m++;
      }
      FerCopia=false;
	//Una vegada acabada aquesta prioritat, borrem la copia i lliurem aquest espai de memoria i pasem a la següent prioritat//
	int ContConsVox=0;
	int ContConsVox2=0;
	int ContConsVox3=0;  
	while(ContConsVox<NumVoxels[0])
	{
	  ContConsVox2=0;
	  while(ContConsVox2<NumVoxels[1])
	  {
	    ContConsVox3=0;
	    while(ContConsVox3<NumVoxels[2])
	    {
	      delete[] VoxelsCopia[ContConsVox][ContConsVox2][ContConsVox3];	  
	      ContConsVox3++;
	    }
	    delete[] VoxelsCopia[ContConsVox][ContConsVox2];	  	
	    ContConsVox2++;
	  }
	  delete[] VoxelsCopia[ContConsVox];	  
	  ContConsVox++;
	}          
	
      //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	
      
    }
    
    i++;
  }
    if(CrearPunts==true)
  {
      if(Idioma==0)
      {
	  std::cout<<"Voxels created in: "<<(glutGet( GLUT_ELAPSED_TIME )-tempsAux)/1000.0<<" seconds"<<std::endl; 
      }
      else if(Idioma==1)
      {
	  std::cout<<"Voxels creats en: "<<(glutGet( GLUT_ELAPSED_TIME )-tempsAux)/1000.0<<" segons"<<std::endl; 
      }
      else if(Idioma==2)
      {
	  std::cout<<"Voxeles creados en: "<<(glutGet( GLUT_ELAPSED_TIME )-tempsAux)/1000.0<<" segundos"<<std::endl; 
      }
  }

  
 
}					
					
////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////Pintem l'espai que hem definit per a la simulació//////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////
  
  glDisable(GL_LIGHT0);
  glDisable(GL_LIGHTING);
  
  //Recalculem les dimensions de l'espai
  DimEspai[0]=NumVoxels[0]*DimVoxels[0];
  DimEspai[1]=NumVoxels[1]*DimVoxels[1];
  DimEspai[2]=NumVoxels[2]*DimVoxels[2];
  
  float DimEspaiRep[3];			//Variable amb les dimensions de l'espai a representar
   
   //Mirem si estem pintant un Dicom o no
   if(PintarDicom==true)
   {
     DimEspaiRep[0]=DimEspaiDicom[0];
     DimEspaiRep[1]=DimEspaiDicom[1];
     DimEspaiRep[2]=DimEspaiDicom[2];
   }
   else
   {
     DimEspaiRep[0]=DimEspai[0];
     DimEspaiRep[1]=DimEspai[1];
     DimEspaiRep[2]=DimEspai[2];
     //Posem els plans inferiors a zero, ho canviarem quan posem l'opcio de plans iferiors a la resta de visors
     PlansTallInf[0]=0;
     PlansTallInf[1]=0;
     PlansTallInf[2]=0;
   }
   
  if(PintEsp==true)			//Pinta un cub que defineix l'espai de la simulació
  {
    std::string AuxString;
    
    glShadeModel(GL_FLAT);					//hombres sense suavitzar

    //De moment desactivem pintar la posicio dels cantos del  prisma de l'espai, la font no es veu be
    /*
      glPushMatrix();

    if((ControlMenu==3 || ControlMenu==9 || ControlMenu==10) && ControlSubMenu==1)
    { 
      glColor3f(0,0,0);      
      AuxIndex=sprintf(auxChar,"(%.2f,%.2f,%.2f) cm",PlansTallInf[0],PlansTallInf[1],PlansTallInf[2]);      
      int j=0;
      while(j<AuxIndex)
      {
	AuxString+=auxChar[j];
	j++;
      }
      glColor3f(0,0,0);
      escriure2(AuxString,PlansTallInf[0]-0.04*PlansTall[0],PlansTallInf[1]-0.04*PlansTall[1],PlansTallInf[2]-0.04*PlansTall[2],Tamany_Lletra_Espai);
      AuxString.clear();
      glColor3f(0,0,0);
    }
    else
    {
      glColor3f(0,0,0);
      escriure2("(0,0,0) cm",-0.04*DimEspaiRep[0],-0.04*DimEspaiRep[1],-0.04*DimEspaiRep[2],Tamany_Lletra_Espai);
      //escriure2("(0,0,0) cm",0,0,0,Tamany_Lletra_Espai);
    }
    glColor3f(0,0,0);

    //Si estem a algun dels submenus que pinten vòxels i pots fixar plans de tall, marcarem aquests plans i no les dimensions totals de l'espai
    if((ControlMenu==3 || ControlMenu==9 || ControlMenu==10) && ControlSubMenu==1)
      {
	AuxIndex=sprintf(auxChar,"(%.2f,%.2f,0) cm",PlansTall[0],PlansTall[1]);

	int j=0;
	while(j<AuxIndex)
	  {
	    AuxString+=auxChar[j];
	    j++;
	  }
	escriure2(AuxString,PlansTall[0]+0.04*PlansTall[0],PlansTall[1]+0.04*PlansTall[1],PlansTallInf[2]-0.04*PlansTall[2],Tamany_Lletra_Espai);
    
	AuxString.clear();      
      }
    else
      {
	AuxIndex=sprintf(auxChar,"(%.2f,%.2f,0) cm",DimEspaiRep[0],DimEspaiRep[1]);

	int j=0;
	while(j<AuxIndex)
	  {
	    AuxString+=auxChar[j];
	    j++;
	  }
	escriure2(AuxString,DimEspaiRep[0]+0.04*DimEspaiRep[0],DimEspaiRep[1]+0.04*DimEspaiRep[1],-0.04*DimEspaiRep[2],Tamany_Lletra_Espai);
    
	AuxString.clear();            
      }
    
    glColor3f(0,0,0);
    //Si estem a algun dels submenus que pinten vòxels i pots fixar plans de tall, marcarem aquests plans i no les dimensions totals de l'espai
    if((ControlMenu==3 || ControlMenu==9 || ControlMenu==10) && ControlSubMenu==1)
      {
	AuxIndex=sprintf(auxChar,"(%.2f,0,0) cm",PlansTall[0]);

	int j=0;
	while(j<AuxIndex)
	  {
	    AuxString+=auxChar[j];
	    j++;
	  }
	escriure2(AuxString,PlansTall[0],PlansTallInf[1]-0.04*PlansTall[1],PlansTallInf[2]-0.04*PlansTall[2],Tamany_Lletra_Espai);
	AuxString.clear();

      }
    else
      {
	AuxIndex=sprintf(auxChar,"(%.2f,0,0) cm",DimEspaiRep[0]);

	int j=0;
	while(j<AuxIndex)
	  {
	    AuxString+=auxChar[j];
	    j++;
	  }
	escriure2(AuxString,DimEspaiRep[0],-0.04*DimEspaiRep[1],-0.04*DimEspaiRep[2],Tamany_Lletra_Espai);
	AuxString.clear();
      
      }
    
    glColor3f(0,0,0);
    //Si estem a algun dels submenus que pinten vòxels i pots fixar plans de tall, marcarem aquests plans i no les dimensions totals de l'espai
    if((ControlMenu==3 || ControlMenu==9 || ControlMenu==10) && ControlSubMenu==1)
      {
	AuxIndex=sprintf(auxChar,"(%.2f,0,%.2f) cm",PlansTall[0],PlansTall[2]);

	int j=0;
	while(j<AuxIndex)
	  {
	    AuxString+=auxChar[j];
	    j++;
	  }
	escriure2(AuxString,PlansTall[0],PlansTallInf[1]-0.04*PlansTall[1],PlansTall[2]+0.04*PlansTall[2],Tamany_Lletra_Espai);
	AuxString.clear();
      
      }
    else
      {
	AuxIndex=sprintf(auxChar,"(%.2f,0,%.2f) cm",DimEspaiRep[0],DimEspaiRep[2]);

	int j=0;
	while(j<AuxIndex)
	  {
	    AuxString+=auxChar[j];
	    j++;
	  }
	escriure2(AuxString,DimEspaiRep[0],-0.04*DimEspaiRep[1],DimEspaiRep[2]+0.04*DimEspaiRep[2],Tamany_Lletra_Espai);
	AuxString.clear();
      
      }
    
    glColor3f(0,0,0);
    //Si estem a algun dels submenus que pinten vòxels i pots fixar plans de tall, marcarem aquests plans i no les dimensions totals de l'espai
    if((ControlMenu==3 || ControlMenu==9 || ControlMenu==10) && ControlSubMenu==1)
      {
	AuxIndex=sprintf(auxChar,"(0,%.2f,0) cm",PlansTall[1]);

	int j=0;
	while(j<AuxIndex)
	  {
	    AuxString+=auxChar[j];
	    j++;
	  }
	escriure2(AuxString,PlansTallInf[0]-0.04*PlansTall[0],PlansTall[1],PlansTallInf[2]-0.04*PlansTall[2],Tamany_Lletra_Espai);
	AuxString.clear();
      
      }
    else
      {
	AuxIndex=sprintf(auxChar,"(0,%.2f,0) cm",DimEspaiRep[1]);

	int j=0;
	while(j<AuxIndex)
	  {
	    AuxString+=auxChar[j];
	    j++;
	  }
	escriure2(AuxString,-0.04*DimEspaiRep[0],DimEspaiRep[1],-0.04*DimEspaiRep[2],Tamany_Lletra_Espai);
	AuxString.clear();
      
      }

    glColor3f(0,0,0);
    //Si estem a algun dels submenus que pinten vòxels i pots fixar plans de tall, marcarem aquests plans i no les dimensions totals de l'espai
    if((ControlMenu==3 || ControlMenu==9 || ControlMenu==10) && ControlSubMenu==1)
      {
	AuxIndex=sprintf(auxChar,"(0,%.2f,%.2f) cm",PlansTall[1],PlansTall[2]);

	int j=0;
	while(j<AuxIndex)
	  {
	    AuxString+=auxChar[j];
	    j++;
	  }
	escriure2(AuxString,PlansTallInf[0]-0.04*PlansTall[0],PlansTall[1],PlansTall[2]+0.04*PlansTall[2],Tamany_Lletra_Espai);
	AuxString.clear();
      
      }
    else
      {
	AuxIndex=sprintf(auxChar,"(0,%.2f,%.2f) cm",DimEspaiRep[1],DimEspaiRep[2]);

	int j=0;
	while(j<AuxIndex)
	  {
	    AuxString+=auxChar[j];
	    j++;
	  }
	escriure2(AuxString,-0.04*DimEspaiRep[0],DimEspaiRep[1],DimEspaiRep[2]+0.04*DimEspaiRep[2],Tamany_Lletra_Espai);
	AuxString.clear();
      
      }

    glColor3f(0,0,0);
    //Si estem a algun dels submenus que pinten vòxels i pots fixar plans de tall, marcarem aquests plans i no les dimensions totals de l'espai
    if((ControlMenu==3 || ControlMenu==9 || ControlMenu==10) && ControlSubMenu==1)
      {
	AuxIndex=sprintf(auxChar,"(0,0,%.2f) cm",PlansTall[2]);

	int j=0;
	while(j<AuxIndex)
	  {
	    AuxString+=auxChar[j];
	    j++;
	  }
	escriure2(AuxString,PlansTallInf[0]-0.04*PlansTall[0],PlansTallInf[1]-0.04*PlansTall[1],PlansTall[2],Tamany_Lletra_Espai);
	AuxString.clear();
      
      }
    else
      {
	AuxIndex=sprintf(auxChar,"(0,0,%.2f) cm",DimEspaiRep[2]);

	int j=0;
	while(j<AuxIndex)
	  {
	    AuxString+=auxChar[j];
	    j++;
	  }
	escriure2(AuxString,-0.04*DimEspaiRep[0],-0.04*DimEspaiRep[1],DimEspaiRep[2],Tamany_Lletra_Espai);
	AuxString.clear();
      
      }
    
    glColor3f(0,0,0);
    //Si estem a algun dels submenus que pinten vòxels i pots fixar plans de tall, marcarem aquests plans i no les dimensions totals de l'espai
    if((ControlMenu==3 || ControlMenu==9 || ControlMenu==10) && ControlSubMenu==1)
    {
      AuxIndex=sprintf(auxChar,"(%.2f,%.2f,%.2f) cm",PlansTall[0],PlansTall[1],PlansTall[2]);


    int j=0;
    while(j<AuxIndex)
    {
      AuxString+=auxChar[j];
      j++;
    }
    escriure2(AuxString,PlansTall[0]+0.04*PlansTall[0],PlansTall[1]+0.04*PlansTall[1],PlansTall[2],Tamany_Lletra_Espai);
    AuxString.clear();
      
    }
    else
    {
      AuxIndex=sprintf(auxChar,"(%.2f,%.2f,%.2f) cm",DimEspaiRep[0],DimEspaiRep[1],DimEspaiRep[2]);

    int j=0;
    while(j<AuxIndex)
    {
      AuxString+=auxChar[j];
      j++;
    }
    escriure2(AuxString,DimEspaiRep[0]+0.04*DimEspaiRep[0],DimEspaiRep[1]+0.04*DimEspaiRep[1],DimEspaiRep[2],Tamany_Lletra_Espai);
    AuxString.clear();
      
    }
    glPopMatrix();

    */
      //Pasem a pintar el prisma de l'espai
    glColor3f(0,1,0);
    //Quadrat inferior
    glBegin(GL_LINE_STRIP);
      glColor3f(0,0,0);
      glVertex3f(0,0,0);
      glVertex3f(DimEspaiRep[0],0,0);
      glColor3f(0,1,0);
      glVertex3f(DimEspaiRep[0],DimEspaiRep[1],0);
      glVertex3f(0,DimEspaiRep[1],0);
      glColor3f(0,0,0);
      glVertex3f(0,0,0);
      glColor3f(0,1,0);
    glEnd();
    //Quadrat superior
    glBegin(GL_LINE_STRIP);
      glVertex3f(0,0,DimEspaiRep[2]);
      glVertex3f(DimEspaiRep[0],0,DimEspaiRep[2]);
      glVertex3f(DimEspaiRep[0],DimEspaiRep[1],DimEspaiRep[2]);
      glVertex3f(0,DimEspaiRep[1],DimEspaiRep[2]);
      glVertex3f(0,0,DimEspaiRep[2]);
    glEnd();
    //Linies que uneixen els quadrats
    glBegin(GL_LINES);
      glColor3f(0,0,0);
      glVertex3f(0,0,0);
      glVertex3f(0,0,DimEspaiRep[2]);
      glColor3f(0,1,0);
    glEnd();

    glBegin(GL_LINES);
      glVertex3f(DimEspaiRep[0],0,0);
      glVertex3f(DimEspaiRep[0],0,DimEspaiRep[2]);
    glEnd();

    glBegin(GL_LINES);
      glVertex3f(DimEspaiRep[0],DimEspaiRep[1],0);
      glVertex3f(DimEspaiRep[0],DimEspaiRep[1],DimEspaiRep[2]);
    glEnd();

    glBegin(GL_LINES);
      glVertex3f(0,DimEspaiRep[1],0);
      glVertex3f(0,DimEspaiRep[1],DimEspaiRep[2]);
    glEnd();
    glShadeModel(GL_SMOOTH);					//hombres suavisades
  }
  
/////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////Aci es pinten els voxels////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////
int ColIndex=0;
  i=0;					//index X dels voxels
  j=0;					//index Y dels voxels
  int k=0;				//index Z dels voxels
  
  float CentreVox[3];			//Calcula el centre del voxel per a pintar-lo
  
  if(PintVox==true)			//Pinta els voxels (El centre del cub o complet, depen de l'opció)
  {

    if(CrearLlistaVox==true)
    {
      if(LlistaVoxCreada==true)
      {
	glDeleteLists(llistaVox,1);
      }
      llistaVox=glGenLists(1);
      glNewList(llistaVox,GL_COMPILE);      
      
      //Mirem si estem pintant els voxels d'un dicom o un voxelitzat d'una geometria normal
      if(PintarDicom==true && ActivarVisor2D==true)
      {
	    //Obrim el fitxer depenent del pla seleccionat al visor
	    std::string NomFitxer;
	    char NumContZChar[5];
	    sprintf(NumContZChar,"%i",PlaVisor2D);
	    
	    NomFitxer.clear();
	    NomFitxer=std::string("TempPD/DicomRepZ")+std::string(NumContZChar)+std::string(".dat");
	    FILE* DicomVisible;
	    DicomVisible=fopen(NomFitxer.c_str(),"rb");
	    NomFitxer.clear();

	    if(DicomVisible==NULL)
	    {
	      if(Idioma==0)
	      {
		  std::cout<<"DicomRepZ"<<PlaVisor2D<<" file not found, recharge DICOMs"<<std::endl; 
	      }
	      else if(Idioma==1)
	      {
		  std::cout<<"No s'ha trobat el fitxer DicomRepZ"<<PlaVisor2D<<", recarrega el DICOM"<<std::endl; 
	      }
	      else if(Idioma==2)
	      {
		  std::cout<<"No se ha encontrado el fichero DicomRepZ"<<PlaVisor2D<<", recarga el DICOM"<<std::endl; 
	      }	  
	      
	    }
	    else
	    {
	      //Llegim primer el tamany dels vòxels
	      float TamPixels[3];
	      int NumPixels[2];
	      
	      
	      fread(NumPixels,sizeof(int),2,DicomVisible);
	      fread(TamPixels,sizeof(float),3,DicomVisible);

	      //Controla el tamany en que representem els pixels del dicom, no el tamany real 
	      float TamPixelsRep[3];
	      TamPixelsRep[0]=float(AmpladaVisor2D/NumPixels[0]);
	      TamPixelsRep[1]=float(AlturaVisor2D/NumPixels[1]);
	      
	      DimPlaDicom[0]=TamPixels[0]*NumPixels[0];
	      DimPlaDicom[1]=TamPixels[1]*NumPixels[1];
	      DimPlaDicom[2]=TamPixels[2];
	      
	      float MitatTamPixels[2];
	      MitatTamPixels[0]=TamPixelsRep[0]*0.5;
	      MitatTamPixels[1]=TamPixelsRep[1]*0.5;
	      
	      //Pasem ara a llegir els vòxels i representar-los
		int ContadorX=0;
		int ContadorY=0;
		while(!feof(DicomVisible))
		{
		  int Mat[1];
		  float Dens[1];
		  
		  fread(Mat,sizeof(int),1,DicomVisible);
		  fread(Dens,sizeof(float),1,DicomVisible);
		  
		  CentreVox[0]=ContadorX*TamPixelsRep[0]+MitatTamPixels[0];
		  CentreVox[1]=ContadorY*TamPixelsRep[1]+MitatTamPixels[1];
		  
		  //Augmentem els contadors
		  ContadorX++;
		  if(ContadorX==NumPixels[0])
		  {
		    ContadorX=0;
		    ContadorY++;
		    if(ContadorY==NumPixels[1])
		    {
		      break;
		    }
		  }	    
		
		//Una vegada tenim la informació, el representem
		//Mirem ara com hem de pinar el vòxel, si per material o per densitat
		if(PintMatDicom==true)
		{
		  ColIndex=int(Mat[0]);//Usa un color depenent del material del voxel
		  glColor3f(Colors[ColIndex][0],Colors[ColIndex][1],Colors[ColIndex][2]);		//Coloregem els voxels segons el material	     
		}
		else if(PintDensDicom==true)
		{
		  if(Dens[0]>MaxDensDCM)
		  {
		    glColor3f(0.67451,0.223529,1.);	//Si es pasa de l'scala ho pintara morat		
		  }
		  else if(Dens[0]<MinDensDCM)
		  {
		    glColor3f(0, 1, 0.9);	//Si no arriba a l'escala ho pintara blau clar
		  }
		  else	//Si es troba dins l'escala se li assignarà un color d'aquesta
		  {
		    ColIndex=int(Dens[0]/IntervalColorDicom);	//Usa un color depenent de la densitat del vòxel
		    glColor3f(ColorsResultats[ColIndex][0],ColorsResultats[ColIndex][1],ColorsResultats[ColIndex][2]);
		  }
		}
		//Una vegada asignat el color, el dibuixem
		//Dibuixem el pixel
			  glMatrixMode(GL_MODELVIEW);		//Posem el MODELVIEW per a girar l'objecte, no la càmera
			  glPushMatrix();			//Fem una copia de la matriu actual i escrivim sobre la copia
			  glTranslated(CentreVox[0],CentreVox[1],0);		 //Translladem el centre de la pantalla al centre de l'objecte per a girar-lo i pintar-lo
	      
			  //Rectangle
			  glBegin(GL_QUADS);
			    glNormal3d(0,0,1);
			    glVertex3f(-MitatTamPixels[0], -MitatTamPixels[1], 0);
			    glVertex3f(+MitatTamPixels[0], -MitatTamPixels[1], 0);
			    glVertex3f(+MitatTamPixels[0], +MitatTamPixels[1], 0);
			    glVertex3f(-MitatTamPixels[0], +MitatTamPixels[1], 0);
			  glEnd();
			  
			  glPopMatrix();
		  
		}
		fclose(DicomVisible);

		//Es pintaran els contorns i llavors la variable Z dels quals estiga entre aquests plans
		double PlaZInf=(PlaVisor2D-1)*TamPixels[2]+TamPixels[2]*0.5;
		double PlaZ=PlaVisor2D*TamPixels[2]+TamPixels[2]*0.5;
		//Calculem els factors per a pasar de dimensions del dicom a dimensions de pantalla
		double factor_pantalla_X=TamPixelsRep[0]/TamPixels[0];
		double factor_pantalla_Y=TamPixelsRep[1]/TamPixels[1];
	    	
		//////////////////////////////////////////////
		//Pintem els contorns d'aquest pla          //
		if(Nombre_Contorns>0 && DibuixarContorns==true)
		  {
		    glPushMatrix();
		    glLoadIdentity();

		    int contador_pintar_contorns=0;
		    while(contador_pintar_contorns<Nombre_Contorns)
		      {
			//Busquem el pla del contorn que comparteix pla z=cnt amb el voxel
			int Pla_Pintar=-1;  //Guarda el pla del contorn que hem de dibuixar
			int contador_plans=0;
			while(contador_plans<Nombre_Plans_Contorn[contador_pintar_contorns])
			  {
			    double Z =Punts_Contorn[contador_pintar_contorns][contador_plans][2];
			    //Mirem si aquest pla es valid;
			    if(Z>PlaZInf && Z<=PlaZ)
			      {
				Pla_Pintar=contador_plans;
				break;
			      }
			    contador_plans++;
			  }
			//Si no hem trobat cap pla, pasem de contorn
			if(Pla_Pintar==-1)
			  {
			    contador_pintar_contorns++;
			    continue;
			  }
			
			//Posem primer el color del contorn
			glColor4f(float(Color_Contorn[contador_pintar_contorns][0])/255.0,float(Color_Contorn[contador_pintar_contorns][1])/255.0,float(Color_Contorn[contador_pintar_contorns][2])/255.0,0.8);
			/////////////////////////////
			//Comensem a fer un poligon//
			////////////////////////////////////////////////////
			//Activem les transparencies////////////////////////
			glEnable(GL_BLEND);
			glDepthMask(false);
			glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
			////////////////////////////////////////////////////
			glBegin(GL_POLYGON);
			int contador_punts_contorn=0;
			while(contador_punts_contorn<Nombre_Punts_Contorn[contador_pintar_contorns][Pla_Pintar])
			  {
			    double X =factor_pantalla_X*Punts_Contorn[contador_pintar_contorns][Pla_Pintar][contador_punts_contorn];
			    double Y =factor_pantalla_Y*Punts_Contorn[contador_pintar_contorns][Pla_Pintar][contador_punts_contorn+1]; //Li apliquem una transformació perque no tenim el mateix origen Y que el DICOM. El nostre origen esta baix a l'esquerra i el del dicom dalt a l'esquerra
			    glVertex3f(X, Y, 1);
			    contador_punts_contorn=contador_punts_contorn+3;
			  }
			glEnd();
			//////////////////////////////////
			//Desactivem tot lo del blending//
			glDepthMask(true);
			glDisable(GL_BLEND);    
			////////////////////////////////////////////////
			//Finalment fem el contorn de fora del poligon//
			glBegin(GL_LINE_STRIP);
			contador_punts_contorn=0;
			while(contador_punts_contorn<Nombre_Punts_Contorn[contador_pintar_contorns][Pla_Pintar])
			  {
			    double X =factor_pantalla_X*Punts_Contorn[contador_pintar_contorns][Pla_Pintar][contador_punts_contorn];
			    double Y =factor_pantalla_Y*Punts_Contorn[contador_pintar_contorns][Pla_Pintar][contador_punts_contorn+1]; //Li apliquem una transformació perque no tenim el mateix origen Y que el DICOM. El nostre origen esta baix a l'esquerra i el del dicom dalt a l'esquerra
			    glVertex3f(X, Y, 1.1);
			    contador_punts_contorn=contador_punts_contorn+3;
			  }
			glEnd();
			////////////////////////////////////////////////
			
			//Acaba le poligon
			glColor4f(1,1,1,1);
			contador_pintar_contorns++;
		      }		    
		    glPopMatrix();
		  }
		//////////////////////////////////////////////
		//////////////////////////////////////////////
		//Pintem les llavors d'aquest pla           //
		if(Nombre_Tipus_Llavors>0)
		  {
		    int contador_tipus_llavor=0;
		    while(contador_tipus_llavor<Nombre_Tipus_Llavors)
		      {
			glPushMatrix();
			glLoadIdentity();
			int contador_llavors=0;
			while(contador_llavors<Nombre_Llavors[contador_tipus_llavor]*3) //*3 perque tenim 3 components per llavor (x,y,z)
			  {
			    if(Posicio_Llavor[contador_tipus_llavor][contador_llavors+2]>PlaZInf && Posicio_Llavor[contador_tipus_llavor][contador_llavors+2]<=PlaZ)
			      {
				//Si esta entre el pla inferior i este, dibuixem la llavor
				double X = Posicio_Llavor[contador_tipus_llavor][contador_llavors]*factor_pantalla_X;
				double Y = Posicio_Llavor[contador_tipus_llavor][contador_llavors+1]*factor_pantalla_Y;
				//Dibuixarem una creueta
				glColor3f(1,1,1);
				glBegin(GL_LINES);
				glVertex3f(X-Dimensions_Visor2D[0]*0.01,Y,2);
				glVertex3f(X+Dimensions_Visor2D[0]*0.01,Y,2);

				glVertex3f(X,Y-Dimensions_Visor2D[1]*0.01,2);
				glVertex3f(X,Y+Dimensions_Visor2D[1]*0.01,2);
				glEnd();
			      }
			    contador_llavors=contador_llavors+3;
			  }
			contador_tipus_llavor++;
			glPopMatrix();
		      }
		  }
	    }		
      }
      else if(PintarDicom==true && GuardarVoxDicomRep==true)
      {
	//Al pintar nomes els cubs del contorn ara si podem crear la llista
	//Obrim l'arxiu amb el dicom
	FILE* InDicom;
	InDicom=fopen("TempDicom.dat", "rb" );
	//Borrem la carpeta DicomTemp si existeix i la tornem a crear
	system("rm -rf TempPD");
	system("mkdir TempPD");
	FILE* DicomVisible;
	DicomVisible=fopen("TempPD/DicomRepZ0.dat", "wb" );
	FILE* DicomVisible2;
	DicomVisible2=fopen("TempPD/DicomRepVisibleZ0.dat", "wb" );
	//Mirem si s'ha ober correctament
	if (InDicom==NULL)
	{
	  if(Idioma==0)
	  {
	      std::cout<<"DICOM materials file not found"<<std::endl; 
	  }
	  else if(Idioma==1)
	  {
	      std::cout<<"No s'ha trobat el fitxer amb els materials del DICOM"<<std::endl; 
	  }
	  else if(Idioma==2)
	  {
	      std::cout<<"No se ha encontrado el fichero con los materiales del DICOM"<<std::endl; 
	  }	  
	}
	else
	{
	  NumVoxVisiblesDicom=0;
	  if(Idioma==0)
	  {
	      std::cout<<"Rendering DICOM..."<<std::endl; 
	  }
	  else if(Idioma==1)
	  {
	      std::cout<<"Representant el DICOM..."<<std::endl; 
	  }
	  else if(Idioma==2)
	  {
	      std::cout<<"Representando el DICOM..."<<std::endl; 
	  }	  
	  
	  //Ara llegim els primers valors que corresponen a: Num pixels eix X, Num pixels eix Y, tamany pixels eix x,y,z
	  int NPixels[2]={0,0};
	  float TamPixels[3]={0,0,0};

	  fread(NPixels,sizeof(int),2,InDicom);
	  fread(TamPixels,sizeof(float),3,InDicom);
	  
	  
	  int NPixelsX=NPixels[0];
	  int NPixelsY=NPixels[1];

	  //Guardem els tamanys dels vòxels abans de res
	  
	  fwrite(NPixels,sizeof(int),2,DicomVisible);
	  fwrite(TamPixels,sizeof(float),3,DicomVisible);

  
	  if(GuardarVoxDicomRepVisible==true)
	  {
	    float TamPixelsz05[1]={float(TamPixels[2]*0.5)};
	    fwrite(TamPixelsz05,sizeof(float),1,DicomVisible2);
	  }
	  
	  double MitatTamPixels[3];
	  MitatTamPixels[0]=TamPixels[0]*0.5;
	  MitatTamPixels[1]=TamPixels[1]*0.5;
	  MitatTamPixels[2]=TamPixels[2]*0.5;
	  //Una vegada tenim aquests valors, pasem a llegir l'arxiu i pintar els voxels
	  if(PintVQuad==false)
	  {
	      glBegin(GL_POINTS);
	  }
 	  int ContadorX=0;
	  int ContadorY=0;
	  int ContadorZ=0;
	  while(!feof(InDicom))
	  {
	    int Mat[1]={0};
	    float Dens[1]={0};
	    float Densitat;

	    fread(Mat,sizeof(int),1,InDicom);
	    fread(Dens,sizeof(float),1,InDicom);
	    
	    Densitat=Dens[0];

	    CentreVox[0]=ContadorX*TamPixels[0]+TamPixels[0]*0.5;
	    CentreVox[1]=ContadorY*TamPixels[1]+TamPixels[1]*0.5;
	    CentreVox[2]=ContadorZ*TamPixels[2]+TamPixels[2]*0.5;
	    
	    //Guardem, en aquest ordre, material i densitat
	    fwrite(Mat,sizeof(int),1,DicomVisible);
	    fwrite(Dens,sizeof(float),1,DicomVisible);

	    bool continuar=true;
	    if(CentreVox[0]<=PlansTallInf[0] || CentreVox[0]>=PlansTall[0] || CentreVox[1]<=PlansTallInf[1] || CentreVox[1]>=PlansTall[1] || CentreVox[2]<=PlansTallInf[2] || CentreVox[2]>=PlansTall[2])
	    {
	      continuar=false;
	    }	    
	    //Si el centre del vòxel es troba a més de 2 vegades la longitud del vòxel dels plans de tall, no el pintarem
	    else if((CentreVox[0]-PlansTallInf[0])>2*TamPixels[0] &&  (CentreVox[1]-PlansTallInf[1])>2*TamPixels[1] && (CentreVox[2]-PlansTallInf[2])>2*TamPixels[2] && (PlansTall[0]-CentreVox[0])>2*TamPixels[0] && (PlansTall[1]-CentreVox[1])>2*TamPixels[1] && (PlansTall[2]-CentreVox[2])>2*TamPixels[2])
	    {
	      continuar=false;
	    }
	    //Els que pasen el filtre els guardem en el arxiu amb els vòxels visibles
	    if(GuardarVoxDicomRepVisible==true && continuar==true)
	    {
	      fwrite(CentreVox,sizeof(float),2,DicomVisible2);
	      fwrite(Mat,sizeof(int),1,DicomVisible2);
	      fwrite(Dens,sizeof(float),1,DicomVisible2);
	    }
	    
	    //Augmentem els contadors
	    ContadorX++;
	    if(ContadorX==NPixelsX)
	    {
	      ContadorX=0;
	      ContadorY++;
	      if(ContadorY==NPixelsY)
	      {
		ContadorY=0;
		float PercentatgeCompletat=TamPixels[2]*ContadorZ*100.0/DimEspaiDicom[2];
		std::cout.precision(2);
		std::cout<<"\r"<<PercentatgeCompletat<<"%                "; //\r tornarà al inici de la línia
		fflush( stdout );
		std::cout.precision(6);
		ContadorZ++;
		fclose(DicomVisible);
		
		std::string NomFitxer;
		char NumContZChar[5];
		sprintf(NumContZChar,"%i",ContadorZ);
		
		NomFitxer.clear();
		NomFitxer=std::string("TempPD/DicomRepZ")+std::string(NumContZChar)+std::string(".dat");
		DicomVisible=fopen(NomFitxer.c_str(),"wb");
		
		//Guardem la informació amb el nombre de pixels en cada eix i el tamany d'aquests
		fwrite(NPixels,sizeof(int),2,DicomVisible);
		fwrite(TamPixels,sizeof(float),3,DicomVisible);

		if(GuardarVoxDicomRepVisible==true)
		{
		  fclose(DicomVisible2);
		  NomFitxer.clear();
		  NomFitxer=std::string("TempPD/DicomRepVisibleZ")+std::string(NumContZChar)+std::string(".dat");
		  DicomVisible2=fopen(NomFitxer.c_str(),"wb");
		  
		  float Auxfloat[1]={float(ContadorZ*TamPixels[2]+TamPixels[2]*0.5)};
		  fwrite(Auxfloat,sizeof(float),1,DicomVisible2);
		}
	      }
	    }

	    //Si no cal dibuixar el voxel pasem al següent
	    if(continuar==false)
	    {
	      continue;
	    }
	    //Mirem ara com hem de pintar el vòxel, si per material o per densitat
	    if(PintMatDicom==true)
	    {
	      ColIndex=Mat[0];//Usa un color depenent del material del voxel
	      glColor3f(Colors[ColIndex][0],Colors[ColIndex][1],Colors[ColIndex][2]);		//Coloregem els voxels segons el material	      
	      
	    }
	    else if(PintDensDicom==true)
	    {
	      if(Densitat>MaxDensDCM)
	      {
		glColor3f(0.67451,0.223529,1.);	//Si es pasa de l'scala ho pintara morat		
	      }
	      else if(Densitat<MinDensDCM)
	      {
		glColor3f(0.900, 0.900, 0.900);	//Si no arriba a l'escala ho pintara gris clar
	      }
	      else	//Si es troba dins l'escala se li assignarà un color d'aquesta
	      {
		ColIndex=int(Densitat/IntervalColorDicom);	//Usa un color depenent de la densitat del vòxel
		glColor3f(ColorsResultats[ColIndex][0],ColorsResultats[ColIndex][1],ColorsResultats[ColIndex][2]);
	      }
	    }
	    if(PintVQuad==false)
	    {
	      
	      glVertex3f(CentreVox[0],CentreVox[1],CentreVox[2]);
	      	      
	    }
	    else if(PintVQuad==true)
	    {
		      glMatrixMode(GL_MODELVIEW);		//Posem el MODELVIEW per a girar l'objecte, no la càmera
		      glPushMatrix();			//Fem una copia de la matriu actual i escrivim sobre la copia
		      glTranslated(CentreVox[0],CentreVox[1],CentreVox[2]);		 //Translladem el centre de la pantalla al centre de l'objecte per a girar-lo i pintar-lo
	  
	  
		      //cara de baix
		      glBegin(GL_QUADS);
			glNormal3d(0,0,-1);
			glVertex3f(-MitatTamPixels[0], -MitatTamPixels[1], -MitatTamPixels[2]);
			glVertex3f(+MitatTamPixels[0], -MitatTamPixels[1], -MitatTamPixels[2]);
			glVertex3f(+MitatTamPixels[0], +MitatTamPixels[1], -MitatTamPixels[2]);
			glVertex3f(-MitatTamPixels[0], +MitatTamPixels[1], -MitatTamPixels[2]);
		      glEnd();
	  
	  
		      //Cara de dalt
		      glBegin(GL_QUADS);
			glNormal3d(0,0,1);
			glVertex3f(-MitatTamPixels[0], -MitatTamPixels[1], +MitatTamPixels[2]);
			glVertex3f(+MitatTamPixels[0], -MitatTamPixels[1], +MitatTamPixels[2]);
			glVertex3f(+MitatTamPixels[0], +MitatTamPixels[1], +MitatTamPixels[2]);
			glVertex3f(-MitatTamPixels[0], +MitatTamPixels[1], +MitatTamPixels[2]);
		      glEnd();

		      //Cara frontal
		      glBegin(GL_QUADS);
			glNormal3d(1,0,0);
			glVertex3f(+MitatTamPixels[0], -MitatTamPixels[1], -MitatTamPixels[2]);
			glVertex3f(+MitatTamPixels[0], -MitatTamPixels[1], +MitatTamPixels[2]);
			glVertex3f(+MitatTamPixels[0], +MitatTamPixels[1], +MitatTamPixels[2]);
			glVertex3f(+MitatTamPixels[0], +MitatTamPixels[1], -MitatTamPixels[2]);
		      glEnd();

		      //Cara darrere
		      glBegin(GL_QUADS);
			glNormal3d(-1,0,0);
			glVertex3f(-MitatTamPixels[0], -MitatTamPixels[1], -MitatTamPixels[2]);
			glVertex3f(-MitatTamPixels[0], -MitatTamPixels[1], +MitatTamPixels[2]);
			glVertex3f(-MitatTamPixels[0], +MitatTamPixels[1], +MitatTamPixels[2]);
			glVertex3f(-MitatTamPixels[0], +MitatTamPixels[1], -MitatTamPixels[2]);
		      glEnd();

		      //Cara lateral esquerra
		      glBegin(GL_QUADS);
			glNormal3d(0,-1,0);
			glVertex3f(-MitatTamPixels[0], -MitatTamPixels[1], -MitatTamPixels[2]);
			glVertex3f(-MitatTamPixels[0], -MitatTamPixels[1], +MitatTamPixels[2]);
			glVertex3f(+MitatTamPixels[0], -MitatTamPixels[1], +MitatTamPixels[2]);
			glVertex3f(+MitatTamPixels[0], -MitatTamPixels[1], -MitatTamPixels[2]);
		      glEnd();  
	  
		      //Cara lateral dreta
		      glBegin(GL_QUADS);
			glNormal3d(0,1,0);
			glVertex3f(-MitatTamPixels[0], +MitatTamPixels[1], -MitatTamPixels[2]);
			glVertex3f(-MitatTamPixels[0], +MitatTamPixels[1], +MitatTamPixels[2]);
			glVertex3f(+MitatTamPixels[0], +MitatTamPixels[1], +MitatTamPixels[2]);
			glVertex3f(+MitatTamPixels[0], +MitatTamPixels[1], -MitatTamPixels[2]);
		      glEnd();  
	  
	  
		      glPopMatrix();
	    }
	      
	  }
	  
	  std::cout<<"\r"<<"100%          "<<std::endl;
	  fflush( stdout );
	  std::cout<<std::endl;
	  

	  if(PintVQuad==false)
	  {
    	      glEnd();
	  }
	  GuardarVoxDicomRep=false;
	  GuardarVoxDicomRepVisible=false;
	  system("rm TempDicom.dat");
	}
	fclose(InDicom);
	fclose(DicomVisible);
	fclose(DicomVisible2);
      }
      else if (PintarDicom==true && GuardarVoxDicomRep==false && GuardarVoxDicomRepVisible==true)
      {
	//Si ja tenim els fitxers amb els vòxels del dicom que hem de representar, els llegirem, pintarem i guardarem uns nous amb els vòxels visibles sols
	//Primer mirem a partir de quin pla hem de llegir i fins a quin
	int PlaInicial;
	int PlaFinal;
	//Obrim el pla z=0 per a llegir el tamany en l'eix Z dels voxels
	FILE* DicomAux;
	DicomAux=fopen("TempPD/DicomRepZ0.dat", "rb" );

	int AuxInt[2];
	float AuxFloat[3];
	
	fread(AuxInt,sizeof(int),2,DicomAux);
	fread(AuxFloat,sizeof(float),3,DicomAux);
	
	float TamPlaZ=0;
//	char MerdaChar;
	int ContadorZ;

	TamPlaZ=AuxFloat[2];
	
	fclose(DicomAux);
	//Una vegada tenim el tamany Z dels vòxels, calculem els plans inferior i superior
	PlaInicial=int(PlansTallInf[2]/TamPlaZ);
	PlaFinal=int(PlansTall[2]/TamPlaZ);
	//    #pragma omp parallel default(shared) ////////////////////Comença el paral·lelitzat (usa OpenMP)/////////////////////	(AL PARAL·LELITZAR IX MALAMENT)
	//{
	//    #pragma omp for ordered	/////////////////////////////////////Comença un cicle for paral·lelitzat//////////////////////

	  for(ContadorZ=PlaInicial;ContadorZ<PlaFinal;ContadorZ++)
	  {
	    float PercentatgeCompletat=(ContadorZ-PlaInicial)*100.0/(PlaFinal-PlaInicial);
	    std::cout.precision(2);
	    std::cout<<"\r"<<PercentatgeCompletat<<"%                "; //\r tornarà al inici de la línia
	    fflush( stdout );
	    std::cout.precision(6);
	    
	    //Obrim el fitxer depenent del contadorZ
	    std::string NomFitxer;
	    char NumContZChar[5];
	    sprintf(NumContZChar,"%i",ContadorZ);
	    
	    NomFitxer.clear();
	    NomFitxer=std::string("TempPD/DicomRepZ")+std::string(NumContZChar)+std::string(".dat");
	    FILE* DicomVisible;
	    DicomVisible=fopen(NomFitxer.c_str(),"rb");
	    NomFitxer.clear();
	    NomFitxer=std::string("TempPD/DicomRepVisibleZ")+std::string(NumContZChar)+std::string(".dat");	    
	    FILE* DicomVisible2;
	    DicomVisible2=fopen(NomFitxer.c_str(),"wb");
	    //Guardem la coordenada z del centre dels vòxels d'aquest pla en el fitxer de dicoms visibles
	    float GuardarCoordZ[1]={float(ContadorZ*TamPlaZ+TamPlaZ*0.5)};
	    fwrite(GuardarCoordZ,sizeof(float),1,DicomVisible2);
	    
/*	    DicomVisible2<<ContadorZ*TamPlaZ+TamPlaZ*0.5;
	    DicomVisible2<<',';*/

	    if(DicomVisible==NULL)
	    {
	      if(Idioma==0)
	      {
		  std::cout<<"DicomRepZ"<<ContadorZ<<" file not found, recharge DICOMs"<<std::endl; 
	      }
	      else if(Idioma==1)
	      {
		  std::cout<<"No s'ha trobat el fitxer DicomRepZ"<<ContadorZ<<", recarrega el DICOM"<<std::endl; 
	      }
	      else if(Idioma==2)
	      {
		  std::cout<<"No se ha encontrado el fichero DicomRepZ"<<ContadorZ<<", recarga el DICOM"<<std::endl; 
	      }	  
	      
	    }
	    else
	    {
	      //Llegim primer el tamany dels vòxels
	      float TamPixels[3];
	      int NumPixels[2];
	      int NPixelsX=0;
	      int NPixelsY=0;
	      
	      fread(NumPixels,sizeof(int),2,DicomVisible);
	      fread(TamPixels,sizeof(float),3,DicomVisible);
	      NPixelsX=NumPixels[0];
	      NPixelsY=NumPixels[1];
	      
	      float MitatTamPixels[3];
	      MitatTamPixels[0]=TamPixels[0]*0.5;
	      MitatTamPixels[1]=TamPixels[1]*0.5;
	      MitatTamPixels[2]=TamPixels[2]*0.5;
	      //Pasem ara a llegir els vòxels i representar-los
	      if(PintVQuad==false)
	      {
		  glBegin(GL_POINTS);
	      }	  
		int ContadorX=0;
		int ContadorY=0;
		while(!feof(DicomVisible))
		{
		  int Material;
		  float Densitat;
		  
		  int Mat[1];
		  float Dens[1];
		  
		  fread(Mat,sizeof(int),1,DicomVisible);
		  fread(Dens,sizeof(float),1,DicomVisible);
		  
		  Material=Mat[0];
		  Densitat=Dens[0];
		  
		  CentreVox[0]=ContadorX*TamPixels[0]+TamPixels[0]*0.5;
		  CentreVox[1]=ContadorY*TamPixels[1]+TamPixels[1]*0.5;
		  CentreVox[2]=ContadorZ*TamPixels[2]+TamPixels[2]*0.5;
		  
		  //Augmentem els contadors
		  ContadorX++;
		  bool acabar=false;
		  if(ContadorX==NPixelsX)
		  {
		    ContadorX=0;
		    ContadorY++;
		    if(ContadorY==NPixelsY)
		    {
		      acabar=true;
		    }
		  }
		
		//Una vegada tenim la informació, el representem
		//Mirem si esta dins dels limits
		if(CentreVox[0]<=PlansTallInf[0] || CentreVox[0]>=PlansTall[0] || CentreVox[1]<=PlansTallInf[1] || CentreVox[1]>=PlansTall[1])
		{
		  if(acabar==false)
		  {
		    continue;
		  }
		  else
		  {
		    break;
		  }
		}	    
		//Si el centre del vòxel es troba a més de 2 vegades la longitud del vòxel dels plans de tall, no el pintarem
		else if((CentreVox[0]-PlansTallInf[0])>2*TamPixels[0] &&  (CentreVox[1]-PlansTallInf[1])>2*TamPixels[1] && (CentreVox[2]-PlansTallInf[2])>2*TamPixels[2] && (PlansTall[0]-CentreVox[0])>2*TamPixels[0] && (PlansTall[1]-CentreVox[1])>2*TamPixels[1] && (PlansTall[2]-CentreVox[2])>2*TamPixels[2])
		{
		  if(acabar==false)
		  {
		    continue;
		  }
		  else
		  {
		    break;
		  }
		}
		//Si hem de pintar el vòxel, el guardarem en un arxiu. Guardem, en aquest ordre, Centre x,y, material i densitat
		
		fwrite(CentreVox,sizeof(float),2,DicomVisible2);
		fwrite(Mat,sizeof(int),1,DicomVisible2);
		fwrite(Dens,sizeof(float),1,DicomVisible2);
		
		//Mirem ara com hem de pinar el vòxel, si per material o per densitat
		if(PintMatDicom==true)
		{
		  ColIndex=int(Material);//Usa un color depenent del material del voxel
		  glColor3f(Colors[ColIndex][0],Colors[ColIndex][1],Colors[ColIndex][2]);		//Coloregem els voxels segons el material	     
		}
		else if(PintDensDicom==true)
		{
		  if(Densitat>MaxDensDCM)
		  {
		    glColor3f(0.67451,0.223529,1.);	//Si es pasa de l'scala ho pintara morat		
		  }
		  else if(Densitat<MinDensDCM)
		  {
		    glColor3f(0, 1, 0.9);	//Si no arriba a l'escala ho pintara blau clar
		  }
		  else	//Si es troba dins l'escala se li assignarà un color d'aquesta
		  {
		    ColIndex=int(Densitat/IntervalColorDicom);	//Usa un color depenent de la densitat del vòxel
		    glColor3f(ColorsResultats[ColIndex][0],ColorsResultats[ColIndex][1],ColorsResultats[ColIndex][2]);
		  }
		}
		//Una vegada asignat el color, el dibuixem
		if(PintVQuad==false)
		{
		  glVertex3f(CentreVox[0],CentreVox[1],CentreVox[2]);
		}
		else if(PintVQuad==true)
		{
			  glMatrixMode(GL_MODELVIEW);		//Posem el MODELVIEW per a girar l'objecte, no la càmera
			  glPushMatrix();			//Fem una copia de la matriu actual i escrivim sobre la copia
			  glTranslated(CentreVox[0],CentreVox[1],CentreVox[2]);		 //Translladem el centre de la pantalla al centre de l'objecte per a girar-lo i pintar-lo
	      
	      
		      //cara de baix
		      glBegin(GL_QUADS);
			glNormal3d(0,0,-1);
			glVertex3f(-MitatTamPixels[0], -MitatTamPixels[1], -MitatTamPixels[2]);
			glVertex3f(+MitatTamPixels[0], -MitatTamPixels[1], -MitatTamPixels[2]);
			glVertex3f(+MitatTamPixels[0], +MitatTamPixels[1], -MitatTamPixels[2]);
			glVertex3f(-MitatTamPixels[0], +MitatTamPixels[1], -MitatTamPixels[2]);
		      glEnd();
	  
	  
		      //Cara de dalt
		      glBegin(GL_QUADS);
			glNormal3d(0,0,1);
			glVertex3f(-MitatTamPixels[0], -MitatTamPixels[1], +MitatTamPixels[2]);
			glVertex3f(+MitatTamPixels[0], -MitatTamPixels[1], +MitatTamPixels[2]);
			glVertex3f(+MitatTamPixels[0], +MitatTamPixels[1], +MitatTamPixels[2]);
			glVertex3f(-MitatTamPixels[0], +MitatTamPixels[1], +MitatTamPixels[2]);
		      glEnd();

		      //Cara frontal
		      glBegin(GL_QUADS);
			glNormal3d(1,0,0);
			glVertex3f(+MitatTamPixels[0], -MitatTamPixels[1], -MitatTamPixels[2]);
			glVertex3f(+MitatTamPixels[0], -MitatTamPixels[1], +MitatTamPixels[2]);
			glVertex3f(+MitatTamPixels[0], +MitatTamPixels[1], +MitatTamPixels[2]);
			glVertex3f(+MitatTamPixels[0], +MitatTamPixels[1], -MitatTamPixels[2]);
		      glEnd();

		      //Cara darrere
		      glBegin(GL_QUADS);
			glNormal3d(-1,0,0);
			glVertex3f(-MitatTamPixels[0], -MitatTamPixels[1], -MitatTamPixels[2]);
			glVertex3f(-MitatTamPixels[0], -MitatTamPixels[1], +MitatTamPixels[2]);
			glVertex3f(-MitatTamPixels[0], +MitatTamPixels[1], +MitatTamPixels[2]);
			glVertex3f(-MitatTamPixels[0], +MitatTamPixels[1], -MitatTamPixels[2]);
		      glEnd();

		      //Cara lateral esquerra
		      glBegin(GL_QUADS);
			glNormal3d(0,-1,0);
			glVertex3f(-MitatTamPixels[0], -MitatTamPixels[1], -MitatTamPixels[2]);
			glVertex3f(-MitatTamPixels[0], -MitatTamPixels[1], +MitatTamPixels[2]);
			glVertex3f(+MitatTamPixels[0], -MitatTamPixels[1], +MitatTamPixels[2]);
			glVertex3f(+MitatTamPixels[0], -MitatTamPixels[1], -MitatTamPixels[2]);
		      glEnd();  
	  
		      //Cara lateral dreta
		      glBegin(GL_QUADS);
			glNormal3d(0,1,0);
			glVertex3f(-MitatTamPixels[0], +MitatTamPixels[1], -MitatTamPixels[2]);
			glVertex3f(-MitatTamPixels[0], +MitatTamPixels[1], +MitatTamPixels[2]);
			glVertex3f(+MitatTamPixels[0], +MitatTamPixels[1], +MitatTamPixels[2]);
			glVertex3f(+MitatTamPixels[0], +MitatTamPixels[1], -MitatTamPixels[2]);
		      glEnd();  
	      
	      
			  glPopMatrix();
		}

		if(acabar==true)
		{
		  break;
		}
		  
	      }
	      
	      if(PintVQuad==false)
	      {
		    glEnd();
	      }	  
	      fclose(DicomVisible);
	      fclose(DicomVisible2);
	    }

	  }
	
	  //	}		/////////////////////Acaba la paral·lelització///////////////////////
  	    std::cout<<"\r 100%                "; //\r tornarà al inici de la línia
	    fflush( stdout );
	    std::cout<<std::endl;
	    GuardarVoxDicomRepVisible=false;
      }
      else if(PintarDicom==true && GuardarVoxDicomRep==false && GuardarVoxDicomRepVisible==false)
      {
	//Primer mirem a partir de quin pla hem de llegir i fins a quin
	int PlaInicial;
	int PlaFinal;
	//Obrim el pla z=0 per a llegir el tamany en l'eix Z dels voxels
	FILE* DicomAux;
	DicomAux=fopen("TempPD/DicomRepZ0.dat","rb");
	
	float TamPlaZ=0;
	float TamPixels[3];
//	char MerdaChar;
	int ContadorZ;
	int AuxInt[2];
	
	fread(AuxInt,sizeof(int),2,DicomAux);
	fread(TamPixels,sizeof(float),3,DicomAux);

	TamPlaZ=TamPixels[2];
	float MitatTamPixels[3];
	MitatTamPixels[0]=TamPixels[0]*0.5;
	MitatTamPixels[1]=TamPixels[1]*0.5;
	MitatTamPixels[2]=TamPixels[2]*0.5;
	fclose(DicomAux);
	//Una vegada tenim el tamany Z dels vòxels, calculem els plans inferior i superior
	PlaInicial=int(PlansTallInf[2]/TamPlaZ);
	PlaFinal=int(PlansTall[2]/TamPlaZ);
	//    #pragma omp parallel default(shared) ////////////////////Comença el paral·lelitzat (usa OpenMP)/////////////////////	(AL PARAL·LELITZAR IX MALAMENT)
	//{
	// #pragma omp for ordered	/////////////////////////////////////Comença un cicle for paral·lelitzat//////////////////////

	  for(ContadorZ=PlaInicial;ContadorZ<PlaFinal;ContadorZ++)
	  {
	    float PercentatgeCompletat=(ContadorZ-PlaInicial)*100.0/(PlaFinal-PlaInicial);
	    std::cout.precision(2);
	    std::cout<<"\r"<<PercentatgeCompletat<<"%                "; //\r tornarà al inici de la línia
	    fflush( stdout );
	    std::cout.precision(6);
	    
	    //Obrim el fitxer depenent del contadorZ
	    std::string NomFitxer;
	    char NumContZChar[5];
	    sprintf(NumContZChar,"%i",ContadorZ);
	    
	    NomFitxer.clear();
	    NomFitxer=std::string("TempPD/DicomRepVisibleZ")+std::string(NumContZChar)+std::string(".dat");
	    	FILE* DicomVisible;
		DicomVisible=fopen(NomFitxer.c_str(),"rb");
	    //Guardem la coordenada z del centre dels vòxels d'aquest pla en el fitxer de dicoms visibles
	    if(DicomVisible==NULL)
	    {
	      if(Idioma==0)
	      {
		  std::cout<<"DicomRepVisibleZ"<<ContadorZ<<" file not found, recharge DICOMs"<<std::endl; 
	      }
	      else if(Idioma==1)
	      {
		  std::cout<<"No s'ha trobat el fitxer DicomRepVisibleZ"<<ContadorZ<<", recarrega el DICOM"<<std::endl; 
	      }
	      else if(Idioma==2)
	      {
		  std::cout<<"No se ha encontrado el fichero DicomRepVisibleZ"<<ContadorZ<<", recarga el DICOM"<<std::endl; 
	      }	  
	      
	    }
	    else
	    {	      
	      //Pasem ara a llegir els vòxels i representar-los
	      //El primer valor és el centre del vòxel en l'eix Z
	      float AuxFloat[1];
	      fread(AuxFloat,sizeof(float),1,DicomVisible);
	      CentreVox[2]=AuxFloat[0];
	            
	      if(PintVQuad==false)
	      {
		  glBegin(GL_POINTS);
	      }	  
	      while(!feof(DicomVisible))
	      {
		  int Material;
		  float Densitat;
		  int Mat[1];
		  float Dens[1];
		  
		  fread(CentreVox,sizeof(float),2,DicomVisible);
		  fread(Mat,sizeof(int),1,DicomVisible);
		  fread(Dens,sizeof(float),1,DicomVisible);
		  
		  Material=Mat[0];
		  Densitat=Dens[0];
		  
		//Una vegada tenim la informació, el representem
		//Mirem ara com hem de pinar el vòxel, si per material o per densitat
		if(PintMatDicom==true)
		{
		  ColIndex=int(Material);//Usa un color depenent del material del voxel
		  glColor3f(Colors[ColIndex][0],Colors[ColIndex][1],Colors[ColIndex][2]);		//Coloregem els voxels segons el material	     
		}
		else if(PintDensDicom==true)
		{
		  if(Densitat>MaxDensDCM)
		  {
		    glColor3f(0.67451,0.223529,1.);	//Si es pasa de l'scala ho pintara morat		
		  }
		  else if(Densitat<MinDensDCM)
		  {
		    glColor3f(0, 1, 0.9);	//Si no arriba a l'escala ho pintara blau clar
		  }
		  else	//Si es troba dins l'escala se li assignarà un color d'aquesta
		  {
		    ColIndex=int(Densitat/IntervalColorDicom);	//Usa un color depenent de la densitat del vòxel
		    glColor3f(ColorsResultats[ColIndex][0],ColorsResultats[ColIndex][1],ColorsResultats[ColIndex][2]);
		  }
		}
		//Una vegada asignat el color, el dibuixem
		if(PintVQuad==false)
		{
		  glVertex3f(CentreVox[0],CentreVox[1],CentreVox[2]);
		}
		else if(PintVQuad==true)
		{
			  glMatrixMode(GL_MODELVIEW);		//Posem el MODELVIEW per a girar l'objecte, no la càmera
			  glPushMatrix();			//Fem una copia de la matriu actual i escrivim sobre la copia
			  glTranslated(CentreVox[0],CentreVox[1],CentreVox[2]);		 //Translladem el centre de la pantalla al centre de l'objecte per a girar-lo i pintar-lo
	      
	      
		      //cara de baix
		      glBegin(GL_QUADS);
			glNormal3d(0,0,-1);
			glVertex3f(-MitatTamPixels[0], -MitatTamPixels[1], -MitatTamPixels[2]);
			glVertex3f(+MitatTamPixels[0], -MitatTamPixels[1], -MitatTamPixels[2]);
			glVertex3f(+MitatTamPixels[0], +MitatTamPixels[1], -MitatTamPixels[2]);
			glVertex3f(-MitatTamPixels[0], +MitatTamPixels[1], -MitatTamPixels[2]);
		      glEnd();
	  
	  
		      //Cara de dalt
		      glBegin(GL_QUADS);
			glNormal3d(0,0,1);
			glVertex3f(-MitatTamPixels[0], -MitatTamPixels[1], +MitatTamPixels[2]);
			glVertex3f(+MitatTamPixels[0], -MitatTamPixels[1], +MitatTamPixels[2]);
			glVertex3f(+MitatTamPixels[0], +MitatTamPixels[1], +MitatTamPixels[2]);
			glVertex3f(-MitatTamPixels[0], +MitatTamPixels[1], +MitatTamPixels[2]);
		      glEnd();

		      //Cara frontal
		      glBegin(GL_QUADS);
			glNormal3d(1,0,0);
			glVertex3f(+MitatTamPixels[0], -MitatTamPixels[1], -MitatTamPixels[2]);
			glVertex3f(+MitatTamPixels[0], -MitatTamPixels[1], +MitatTamPixels[2]);
			glVertex3f(+MitatTamPixels[0], +MitatTamPixels[1], +MitatTamPixels[2]);
			glVertex3f(+MitatTamPixels[0], +MitatTamPixels[1], -MitatTamPixels[2]);
		      glEnd();

		      //Cara darrere
		      glBegin(GL_QUADS);
			glNormal3d(-1,0,0);
			glVertex3f(-MitatTamPixels[0], -MitatTamPixels[1], -MitatTamPixels[2]);
			glVertex3f(-MitatTamPixels[0], -MitatTamPixels[1], +MitatTamPixels[2]);
			glVertex3f(-MitatTamPixels[0], +MitatTamPixels[1], +MitatTamPixels[2]);
			glVertex3f(-MitatTamPixels[0], +MitatTamPixels[1], -MitatTamPixels[2]);
		      glEnd();

		      //Cara lateral esquerra
		      glBegin(GL_QUADS);
			glNormal3d(0,-1,0);
			glVertex3f(-MitatTamPixels[0], -MitatTamPixels[1], -MitatTamPixels[2]);
			glVertex3f(-MitatTamPixels[0], -MitatTamPixels[1], +MitatTamPixels[2]);
			glVertex3f(+MitatTamPixels[0], -MitatTamPixels[1], +MitatTamPixels[2]);
			glVertex3f(+MitatTamPixels[0], -MitatTamPixels[1], -MitatTamPixels[2]);
		      glEnd();  
	  
		      //Cara lateral dreta
		      glBegin(GL_QUADS);
			glNormal3d(0,1,0);
			glVertex3f(-MitatTamPixels[0], +MitatTamPixels[1], -MitatTamPixels[2]);
			glVertex3f(-MitatTamPixels[0], +MitatTamPixels[1], +MitatTamPixels[2]);
			glVertex3f(+MitatTamPixels[0], +MitatTamPixels[1], +MitatTamPixels[2]);
			glVertex3f(+MitatTamPixels[0], +MitatTamPixels[1], -MitatTamPixels[2]);
		      glEnd();  
	      
	      
			  glPopMatrix();
		}
	      }
	      if(PintVQuad==false)
	      {
		    glEnd();
	      }	  
	      fclose(DicomVisible);
	    }

	  }
	
	  //	}		/////////////////////Acaba la paral·lelització///////////////////////
  	    std::cout<<"\r 100%                "; //\r tornarà al inici de la línia
	    fflush( stdout );	
	    std::cout<<std::endl;
      }
      else
      { 
	float MitatTamPixels[3];
	MitatTamPixels[0]=DimVoxels[0]*0.5;
	MitatTamPixels[1]=DimVoxels[1]*0.5;
	MitatTamPixels[2]=DimVoxels[2]*0.5;
      if(PintVQuad==false)
      {
	glBegin(GL_POINTS);
      }
	while(k<NumVoxels[2])
	{
	  CentreVox[2]=(k*DimVoxels[2]+DimVoxels[2]*0.5);
	  j=0;
	  while(j<NumVoxels[1])
	  {
	    CentreVox[1]=(j*DimVoxels[1]+DimVoxels[1]*0.5);
	    	    
	    //i=0;						//antic while
	    //while(i<NumVoxels[0])
	    for(i=0;i<NumVoxels[0];i++)
	    {
	      //std::cout<<Voxels[i][j][k][0]<<std::endl;
	      
	      CentreVox[0]=(i*DimVoxels[0]+DimVoxels[0]*0.5);
	      
	      //Comprovem que si estem al visor de resultats, la dosi del voxel esta dins del rang
	      if(ControlMenu==9 && (Voxels[i][j][k][0]<MinDosis || Voxels[i][j][k][0]>MaxDosis))
	      {
		continue;
	      }
	      else if(Voxels[i][j][k][0]==1)			//El material 1 és el que el programa agafara com a transparent
	      {
		//i++;					//era per a l'antic while
		continue;
	      }
	      //Mirem si els vòxels del voltant d'aquest han de pintar-se. Si s'han de pintar i aquest queda ocult no caldrà pintar-lo.
	      //No obstant, primer hem de mirar si ens trobem a l'extrem de l'espai, en aquest cas sempre hem de pintar el vòxel ja que no queda ocult.
	      //A més, si es troba a l'extrem inicial, intentariem accedir a una posició de vector negativa i donaria violació de segment.
	      else if(i!=0 && i!=NumVoxels[0]-1 && j!=0 && j!=NumVoxels[1]-1 && k!=0 && k!=NumVoxels[2]-1)
	      {
		//Una vegada comprovat que no es troba a un dels plans inicias de l'espai (k=0,j=0,i=0 i els superiors) comprovem si els vòxels del voltant es dibuixen i oculten aquest
		if(Voxels[i+1][j][k][0]!=1 && Voxels[i-1][j][k][0]!=1 && Voxels[i][j+1][k][0]!=1 && Voxels[i][j-1][k][0]!=1 && Voxels[i][j][k+1][0]!=1 && Voxels[i][j][k-1][0]!=1 && abs(PlansTall[0]-(CentreVox[0]+DimVoxels[0]))>2*DimVoxels[0] && abs(PlansTall[1]-(CentreVox[1]+DimVoxels[1]))>2*DimVoxels[1] && abs(PlansTall[2]-(CentreVox[2]+DimVoxels[2]))>2*DimVoxels[2])
		{
		  //Hem de comprovar que si ens trobem en el visor de resultats, els voxels colindants tinguen una dosi dins del rang, perque si no no es pintaran.
		  if(ControlMenu==9)
		  {
		    //Comprovat ja que estem en el visor de resultats, comprovem que els voxels que envolten al que estem dibuixant tenen dosis dins del rang
		    if((Voxels[i+1][j][k][0]<MinDosis || Voxels[i+1][j][k][0]>MaxDosis) || (Voxels[i-1][j][k][0]<MinDosis || Voxels[i-1][j][k][0]>MaxDosis) || (Voxels[i][j+1][k][0]<MinDosis || Voxels[i][j+1][k][0]>MaxDosis) || (Voxels[i][j-1][k][0]<MinDosis || Voxels[i][j-1][k][0]>MaxDosis) || (Voxels[i][j][k+1][0]<MinDosis || Voxels[i][j][k+1][0]>MaxDosis) || (Voxels[i][j][k-1][0]<MinDosis || Voxels[i][j][k-1][0]>MaxDosis))
		    {
		      //Si s'acompleix, un dels cubs que l'envolten no es pintarà i per tant este no queda completament ocult. Per tant el dibuixem
		    }
		    else
		    {
		      //En canvi si no s'acompleix, aquest vòxel estarà completament ocult i per tant no el pintem
		      continue;
		    }
		  }
		  //Si no estem al visor de resultats, pasem de voxel
		  else
		  {
		    continue;
		  }
		}
	      }
	      if(ControlMenu==9)	//Si estem pintant els voxels dels resultats utilitzem el gradient de colors ColorsResultats
	      {
		if(EscalaLog==false)
		{
		  ColIndex=int(Voxels[i][j][k][0]/IntervalColorResultats);	//Fixem el color  segons la dosi del voxel
		}
		else if(EscalaLog==true)
		{
		  float MaxLog=log10(MaxDosis);
		  float MinLog;
		  if(MinDosis<1)
		  {
		    MinLog=0;
		  }
		  else
		  {
		    MinLog=log10(MinDosis);
		  }
		  float IntervalLog=(MaxLog-MinLog)*1.0/NumColorsResultats;

		  if(Voxels[i][j][k][0]<1)
		  {
		    ColIndex=0;
		  }
		  else
		  {
		    ColIndex=int(log10(Voxels[i][j][k][0])/IntervalLog);	//Fixem el color  segons la dosi del voxel
		  }
		}
		
		if(ColIndex>=NumColorsResultats)
		{
		  ColIndex=NumColorsResultats-1;
		}
		glColor3f(ColorsResultats[ColIndex][0],ColorsResultats[ColIndex][1],ColorsResultats[ColIndex][2]);
	      }
	      else
	      {
		ColIndex=int(Voxels[i][j][k][0]);						//Usa un color depenent del material del voxel
		glColor3f(Colors[ColIndex][0],Colors[ColIndex][1],Colors[ColIndex][2]);		//Coloregem els voxels segons el material
	      }
	      if(CentreVox[0]<=PlansTall[0] && CentreVox[1]<=PlansTall[1] && CentreVox[2]<=PlansTall[2])
	      {
		  if(PintVQuad==false)				//Pintem nomes el centre del voxel
		  {
		    glVertex3f(CentreVox[0],CentreVox[1],CentreVox[2]);
		  }
		  
		  if(PintVQuad==true)				//Pintem el voxel complet (el cub)
		  {
		      glMatrixMode(GL_MODELVIEW);		//Posem el MODELVIEW per a girar l'objecte, no la càmera
		      glPushMatrix();			//Fem una copia de la matriu actual i escrivim sobre la copia
	  
		      glTranslated(CentreVox[0],CentreVox[1],CentreVox[2]);		 //Translladem el centre de la pantalla al centre de l'objecte per a girar-lo i pintar-lo
	  
	  
		      //cara de baix
		      glBegin(GL_QUADS);
			glNormal3d(0,0,-1);
			glVertex3f(-MitatTamPixels[0], -MitatTamPixels[1], -MitatTamPixels[2]);
			glVertex3f(+MitatTamPixels[0], -MitatTamPixels[1], -MitatTamPixels[2]);
			glVertex3f(+MitatTamPixels[0], +MitatTamPixels[1], -MitatTamPixels[2]);
			glVertex3f(-MitatTamPixels[0], +MitatTamPixels[1], -MitatTamPixels[2]);
		      glEnd();
	  
	  
		      //Cara de dalt
		      glBegin(GL_QUADS);
			glNormal3d(0,0,1);
			glVertex3f(-MitatTamPixels[0], -MitatTamPixels[1], +MitatTamPixels[2]);
			glVertex3f(+MitatTamPixels[0], -MitatTamPixels[1], +MitatTamPixels[2]);
			glVertex3f(+MitatTamPixels[0], +MitatTamPixels[1], +MitatTamPixels[2]);
			glVertex3f(-MitatTamPixels[0], +MitatTamPixels[1], +MitatTamPixels[2]);
		      glEnd();

		      //Cara frontal
		      glBegin(GL_QUADS);
			glNormal3d(1,0,0);
			glVertex3f(+MitatTamPixels[0], -MitatTamPixels[1], -MitatTamPixels[2]);
			glVertex3f(+MitatTamPixels[0], -MitatTamPixels[1], +MitatTamPixels[2]);
			glVertex3f(+MitatTamPixels[0], +MitatTamPixels[1], +MitatTamPixels[2]);
			glVertex3f(+MitatTamPixels[0], +MitatTamPixels[1], -MitatTamPixels[2]);
		      glEnd();

		      //Cara darrere
		      glBegin(GL_QUADS);
			glNormal3d(-1,0,0);
			glVertex3f(-MitatTamPixels[0], -MitatTamPixels[1], -MitatTamPixels[2]);
			glVertex3f(-MitatTamPixels[0], -MitatTamPixels[1], +MitatTamPixels[2]);
			glVertex3f(-MitatTamPixels[0], +MitatTamPixels[1], +MitatTamPixels[2]);
			glVertex3f(-MitatTamPixels[0], +MitatTamPixels[1], -MitatTamPixels[2]);
		      glEnd();

		      //Cara lateral esquerra
		      glBegin(GL_QUADS);
			glNormal3d(0,-1,0);
			glVertex3f(-MitatTamPixels[0], -MitatTamPixels[1], -MitatTamPixels[2]);
			glVertex3f(-MitatTamPixels[0], -MitatTamPixels[1], +MitatTamPixels[2]);
			glVertex3f(+MitatTamPixels[0], -MitatTamPixels[1], +MitatTamPixels[2]);
			glVertex3f(+MitatTamPixels[0], -MitatTamPixels[1], -MitatTamPixels[2]);
		      glEnd();  
	  
		      //Cara lateral dreta
		      glBegin(GL_QUADS);
			glNormal3d(0,1,0);
			glVertex3f(-MitatTamPixels[0], +MitatTamPixels[1], -MitatTamPixels[2]);
			glVertex3f(-MitatTamPixels[0], +MitatTamPixels[1], +MitatTamPixels[2]);
			glVertex3f(+MitatTamPixels[0], +MitatTamPixels[1], +MitatTamPixels[2]);
			glVertex3f(+MitatTamPixels[0], +MitatTamPixels[1], -MitatTamPixels[2]);
		      glEnd();  
	  
	  
		      glPopMatrix();
		  }
	      }
	      //i++;		//antic while
	    }
	    j++;
	  }
	  k++;
	}

	if(PintVQuad==false)
	{
	  glEnd();
	}	
	  
      }
	glEndList();
	LlistaVoxCreada=true;
	CrearLlistaVox=false;
    }

//    if(PintarDicom==true && PintVQuad==true)	//No podem crear una llista amb els cubs del dicom perque hi ha massa i dona violació de segment
//    {
//      CrearLlistaVox=true;
//    }
//    else
//    {
      glCallList(llistaVox);
//    }
//	Ara que sols pintem el contorn, si que podem
  }
/*  else if(PintMallat==true)
  {
    if(CrearLlistaMallat==true)
    {
      if(LlistaMallatCreada==true)
      {
	glDeleteLists(llistaMalla,1);
      }
      llistaMalla=glGenLists(1);
      glNewList(llistaMalla,GL_COMPILE);
      
	  if(Idioma==0)
	  {
	      std::cout<<"Rendering mesh..."<<std::endl; 
	  }
	  else if(Idioma==1)
	  {
	      std::cout<<"Representant el mallat..."<<std::endl; 
	  }
	  else if(Idioma==2)
	  {
	      std::cout<<"Representando el mallado..."<<std::endl; 
	  }	  

	//Si s'obri correctament llegim tot el fitxer
	int ContadorElements=0;
	int ElementsTotals=Malla1.LlegirNumElements();
	while(ContadorElements<ElementsTotals)
	{
	  float V1[3];
	  float V2[3];
	  float V3[3];
	  float V4[3];
	  float material;
	  
	  Malla1.LlegirVertex(ContadorElements,V1,V2,V3,V4);
	  material=Malla1.LlegirMaterial(ContadorElements);
	  
	  ContadorElements++;

	  //Asignem un color segons el material, si aquest és 1 no es pintara
	  if(material==1)
	  {
	    continue;
	  }
	  //si un vertex esta fora dels plans de tall, no el pintarem
	  if(V1[0]>PlansTall[0] || V2[0]>PlansTall[0] || V3[0]>PlansTall[0] || V4[0]>PlansTall[0] || V1[1]>PlansTall[1] || V2[1]>PlansTall[1] || V3[1]>PlansTall[1] || V4[1]>PlansTall[1] || V1[2]>PlansTall[2] || V2[2]>PlansTall[2] || V3[2]>PlansTall[2] || V4[2]>PlansTall[2])
	  {
	    continue;
	  }
	  ColIndex=int(material);
	  glColor3f(Colors[ColIndex][0],Colors[ColIndex][1],Colors[ColIndex][2]);		//Coloregem els voxels segons el material

	  //Representem les 4 cares triangulars del poligon
	  glBegin(GL_POLYGON);
	  glVertex3f(V1[0],V1[1],V1[2]);
	  glVertex3f(V2[0],V2[1],V2[2]);
	  glVertex3f(V3[0],V3[1],V3[2]);
	  glEnd();

	  glColor3f(0,0,0);
	  glBegin(GL_LINE_STRIP);
	  glVertex3f(V1[0],V1[1],V1[2]);
	  glVertex3f(V2[0],V2[1],V2[2]);
	  glVertex3f(V3[0],V3[1],V3[2]);	  
	  glEnd();
	  
	  glColor3f(Colors[ColIndex][0],Colors[ColIndex][1],Colors[ColIndex][2]);		//Coloregem els voxels segons el material	  
	  glBegin(GL_POLYGON);
	  glVertex3f(V1[0],V1[1],V1[2]);
	  glVertex3f(V2[0],V2[1],V2[2]);
	  glVertex3f(V4[0],V4[1],V4[2]);
	  glEnd();

	  glColor3f(0,0,0);
	  glBegin(GL_LINE_STRIP);
	  glVertex3f(V1[0],V1[1],V1[2]);
	  glVertex3f(V2[0],V2[1],V2[2]);
	  glVertex3f(V4[0],V4[1],V4[2]);
	  glEnd();
	  
	  glColor3f(Colors[ColIndex][0],Colors[ColIndex][1],Colors[ColIndex][2]);		//Coloregem els voxels segons el material	     
	  glBegin(GL_POLYGON);
	  glVertex3f(V1[0],V1[1],V1[2]);
	  glVertex3f(V4[0],V4[1],V4[2]);
	  glVertex3f(V3[0],V3[1],V3[2]);
	  glEnd();

	  glColor3f(0,0,0);
	  glBegin(GL_LINE_STRIP);
	  glVertex3f(V1[0],V1[1],V1[2]);
	  glVertex3f(V4[0],V4[1],V4[2]);
	  glVertex3f(V3[0],V3[1],V3[2]);
	  glEnd();
	  
	  glColor3f(Colors[ColIndex][0],Colors[ColIndex][1],Colors[ColIndex][2]);		//Coloregem els voxels segons el material	    
	  glBegin(GL_POLYGON);
	  glVertex3f(V2[0],V2[1],V2[2]);
	  glVertex3f(V3[0],V3[1],V3[2]);
	  glVertex3f(V4[0],V4[1],V4[2]);
	  glEnd();	  

	  glColor3f(0,0,0);
	  glBegin(GL_LINE_STRIP);
	  glVertex3f(V2[0],V2[1],V2[2]);
	  glVertex3f(V3[0],V3[1],V3[2]);
	  glVertex3f(V4[0],V4[1],V4[2]);
	  glEnd();
	  
	}

	glEndList();
	LlistaMallatCreada=true;
	CrearLlistaMallat=false;
    }
    glCallList(llistaMalla);
  }
*/

  glEnable(GL_LIGHTING);
  glEnable(GL_LIGHT0);
  
  if(CrearPunts==true)
  {
    CrearPunts=false;
    VoxelsActualitzats=true;
  }
}
//////////////////////////////////////////Funcio menu//////////////////////////////////////////////////////

void MostrarMenu()
{
  GLfloat ColorBotons[3]={1,1,1};
  GLfloat ColorTextnou[4]={1,1,1,1};
  
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  
  glDisable(GL_LIGHT0);
  glDisable(GL_LIGHTING); 

  //Carreguem la textura del menu si no s'ha carregat mai
  if(CarregarTexturaMenu==true)
  {
    //Obrim el fitxer amb la textura del menu
    std::ifstream DirTexMenu(NomArxiuTexturaMenu.c_str());
    if(DirTexMenu.is_open())
    {
      //Una vegada comprovat que s'ha obert correctament creem un buffer on guardarem la textura
      float *buffer = new float[DimTexturaMenu[0]*DimTexturaMenu[1]*NumSamplesTexMenu];
      int ContBuffer=0;
      int i=0;
      while(i<DimTexturaMenu[0])
      {
	int j=0;
	while(j<DimTexturaMenu[1])
	{
	  std::string AuxLinia;
	  int z=0;
	  while(z<NumSamplesTexMenu)
	  {
	    float AuxFloat=0;
	    char AuxChar;
	    
	    DirTexMenu>>AuxFloat;
	    DirTexMenu>>AuxChar;
	    
	    buffer[ContBuffer]=AuxFloat;
	    ContBuffer++;
	    z++;
	  }
	  getline(DirTexMenu,AuxLinia);
	  j++;
	}
	i++;
      }
      //Tanquem l'arxiu
      DirTexMenu.close();
      //Generem i carreguem la textura
      glDeleteTextures(1,&TexturaMenu);
      glGenTextures(1,&TexturaMenu);
      glBindTexture(GL_TEXTURE_2D, TexturaMenu);
      
      //Carreguem la textura
      glTexImage2D(GL_TEXTURE_2D,0,3,DimTexturaMenu[0],DimTexturaMenu[1],0,GL_RGB,GL_FLOAT,buffer);
      //Eliminem el buffer
      delete[] buffer;
      //Diem que la textura no es repetisca, tant en l'eix horitzontal (s) com en el vertical (t)
      glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
      glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);      
      // when texture area is small, bilinear filter the closest mipmap
      glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR );
      // when texture area is large, bilinear filter the first mipmap
      glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR );
      

    }
    //Obrim ara l'arxiu amb la textura dels botons grans i fem el mateix procediment
    DirTexMenu.open(NomArxiuTexturaBotons.c_str());
    if(DirTexMenu.is_open())
    {
      //Una vegada comprovat que s'ha obert correctament creem un buffer on guardarem la textura
      float *buffer = new float[DimTexturaBotons[0]*DimTexturaBotons[1]*NumSamplesTexBotons];
      int ContBuffer=0;
      int i=0;
      while(i<DimTexturaBotons[0])
      {
	int j=0;
	while(j<DimTexturaBotons[1])
	{
	  std::string AuxLinia;
	  int z=0;
	  while(z<NumSamplesTexBotons)
	  {
	    float AuxFloat=0;
	    char AuxChar;
	    
	    DirTexMenu>>AuxFloat;
	    DirTexMenu>>AuxChar;
	    
	    buffer[ContBuffer]=AuxFloat;
	    ContBuffer++;
	    z++;
	  }
	  getline(DirTexMenu,AuxLinia);
	  j++;
	}
	i++;
      }
      //Tanquem l'arxiu
      DirTexMenu.close();
      //Generem i carreguem la textura
      glDeleteTextures(1,&TexturaBotons);
      glGenTextures(1,&TexturaBotons);
      glBindTexture(GL_TEXTURE_2D, TexturaBotons);
      
      //Carreguem la textura
      glTexImage2D(GL_TEXTURE_2D,0,3,DimTexturaBotons[0],DimTexturaBotons[1],0,GL_RGB,GL_FLOAT,buffer);
      //Eliminem el buffer
      delete[] buffer;
      //Diem que la textura no es repetisca, tant en l'eix horitzontal (s) com en el vertical (t)
      glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
      glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);      
      // when texture area is small, bilinear filter the closest mipmap
      glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR );
      // when texture area is large, bilinear filter the first mipmap
      glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR );
      

    }    

    //Obrim ara l'arxiu amb la textura dels botons menuts i fem el mateix procediment
    DirTexMenu.open(NomArxiuTexturaBotonsMenuts.c_str());
    if(DirTexMenu.is_open())
    {
      //Una vegada comprovat que s'ha obert correctament creem un buffer on guardarem la textura
      float *buffer = new float[DimTexturaBotonsMenuts[0]*DimTexturaBotonsMenuts[1]*NumSamplesTexBotonsMenuts];
      int ContBuffer=0;
      int i=0;
      while(i<DimTexturaBotonsMenuts[0])
      {
	int j=0;
	while(j<DimTexturaBotonsMenuts[1])
	{
	  std::string AuxLinia;
	  int z=0;
	  while(z<NumSamplesTexBotonsMenuts)
	  {
	    float AuxFloat=0;
	    char AuxChar;
	    
	    DirTexMenu>>AuxFloat;
	    DirTexMenu>>AuxChar;
	    
	    buffer[ContBuffer]=AuxFloat;
	    ContBuffer++;
	    z++;
	  }
	  getline(DirTexMenu,AuxLinia);
	  j++;
	}
	i++;
      }
      //Tanquem l'arxiu
      DirTexMenu.close();
      //Generem i carreguem la textura
      glDeleteTextures(1,&TexturaBotonsMenuts);
      glGenTextures(1,&TexturaBotonsMenuts);
      glBindTexture(GL_TEXTURE_2D, TexturaBotonsMenuts);
      
      //Carreguem la textura
      glTexImage2D(GL_TEXTURE_2D,0,3,DimTexturaBotonsMenuts[0],DimTexturaBotonsMenuts[1],0,GL_RGB,GL_FLOAT,buffer);
      //Eliminem el buffer
      delete[] buffer;
      //Diem que la textura no es repetisca, tant en l'eix horitzontal (s) com en el vertical (t)
      glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
      glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);      
      // when texture area is small, bilinear filter the closest mipmap
      glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR );
      // when texture area is large, bilinear filter the first mipmap
      glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR );
      

    }    
    
    //Diguem que les textures ja s'han carregat
      CarregarTexturaMenu=false;    
  }
  //Ara pintem la textura
      //Activem la textura corresponent
    glEnable(GL_TEXTURE_2D);
    glBindTexture(GL_TEXTURE_2D, TexturaMenu);

    glBegin(GL_QUADS);
      glColor3f(1,1,1);
      glTexCoord2f(0.0f,0.0f);glVertex3f(0,0,-1);

      glTexCoord2f(1.0f,0.0f);glVertex3f(Dimensions_Menu[0],0,-1);

      glTexCoord2f(1.0f,1.0f);glVertex3f(Dimensions_Menu[0],Dimensions_Menu[1],-1);

      glTexCoord2f(0.0f,1.0f);glVertex3f(0,Dimensions_Menu[1],-1);
      
    glEnd();
    
    glDisable(GL_TEXTURE_2D);
  
    TamanyBotons[0]=0.4*Dimensions_Menu[0];
    TamanyBotons[1]=0.0375*Dimensions_Menu[1];			//Dimensions dels botons
    DistBotonsY=0.04375*Dimensions_Menu[1];					//Espai entre botons eix Y
    float SeparacioVora=Dimensions_Menu[0]*0.0666;
    float Origen_Botons_Menu_Principal_Y=0.9375*Dimensions_Menu[1];

  if(menuCreat==false)
  {
    int i=0;
    //Valors per defecte de les variables que s'introdueixen als quadres//
    while(i<100)	//Primer les buidem (Omplint-les de V que sera el caracter que buscara per a parar de llegir)
    {      
      //Del cub//
      ICentreCubChar[0][i]='V';
      IDimCubChar[0][i]='V';
      ICentreCubChar[1][i]='V';
      IDimCubChar[1][i]='V';   
      ICentreCubChar[2][i]='V';
      IDimCubChar[2][i]='V';      
      DinsCubChar[i][0]='V';
      DinsCubChar[i][1]='V';
      DinsCubChar[i][2]='V';
      DinsCubChar[i][3]='V';
      IDensCubChar[i]='V';
      IAnglesCubChar[0][i]='V';
      IAnglesCubChar[1][i]='V';
      IAnglesCubChar[2][i]='V';
      
      //De l'esfera//
      ICentreEsfChar[0][i]='V';
      ICentreEsfChar[1][i]='V';  
      ICentreEsfChar[2][i]='V';
      IDimEsfChar[i]='V';      
      DinsEsfChar[i][0]='V';
      DinsEsfChar[i][1]='V';
      DinsEsfChar[i][2]='V';
      DinsEsfChar[i][3]='V';
      IDensEsfChar[i]='V';
      
      //Del cilindre//
      ICentreCilChar[0][i]='V';
      IDimCilChar[0][i]='V';
      ICentreCilChar[1][i]='V';
      IDimCilChar[1][i]='V';   
      ICentreCilChar[2][i]='V';
      IDimCilChar[2][i]='V';      
      DinsCilChar[i][0]='V';
      DinsCilChar[i][1]='V';
      DinsCilChar[i][2]='V';
      DinsCilChar[i][3]='V';
      IDensCilChar[i]='V';
      IAnglesCilChar[0][i]='V';
      IAnglesCilChar[1][i]='V';
      IAnglesCilChar[2][i]='V';
      
      //Del pla infinit//
      ICentrePlaChar[0][i]='V';
      ICentrePlaChar[1][i]='V';
      ICentrePlaChar[2][i]='V';   
      DinsPlaChar[i][0]='V';
      DinsPlaChar[i][1]='V';
      DinsPlaChar[i][2]='V';
      DinsPlaChar[i][3]='V';
      IDensPlaChar[i]='V';
      IAnglesPlaChar[0][i]='V';
      IAnglesPlaChar[1][i]='V';
      IAnglesPlaChar[2][i]='V';
            
      //De la secció d'esfera//
      ICentreSecEsfChar[0][i]='V';
      IDimSecEsfChar[0][i]='V';
      ICentreSecEsfChar[1][i]='V';
      IDimSecEsfChar[1][i]='V';   
      ICentreSecEsfChar[2][i]='V';      
      DinsSecEsfChar[i][0]='V';
      DinsSecEsfChar[i][1]='V';
      DinsSecEsfChar[i][2]='V';
      DinsSecEsfChar[i][3]='V';
      IDensSecEsfChar[i]='V';
      IAnglesSecEsfChar[0][i]='V';
      IAnglesSecEsfChar[1][i]='V';
      IAnglesSecEsfChar[2][i]='V';
            
      //Plans de tall superiors//
      IPlansTallChar[0][i]='V';
      IPlansTallChar[1][i]='V';
      IPlansTallChar[2][i]='V';
    
      //Plans de tall inferiors//
      IPlansTallCharInf[0][i]='V';
      IPlansTallCharInf[1][i]='V';
      IPlansTallCharInf[2][i]='V';

      //Dimensions Voxels
      IDimVoxChar[0][i]='V';
      IDimVoxChar[1][i]='V';
      IDimVoxChar[2][i]='V';
      
      IMaxDosisChar[i]='V';
      IMinDosisChar[i]='V';

      //Transformacions de grups de figures
      IParametresTransformacioChar[0][i]='V';
      IParametresTransformacioChar[1][i]='V';
      IParametresTransformacioChar[2][i]='V';
      i++;
    }
    //Per defecte el tamany de l'espai és 100x100x100 i les dimensions dels voxels 0.5
    INumVoxChar[0][0]='1';
    INumVoxChar[0][1]='0';
    INumVoxChar[0][2]='0';
    INumVoxChar[0][3]='V';

    INumVoxChar[1][0]='1';
    INumVoxChar[1][1]='0';
    INumVoxChar[1][2]='0';    
    INumVoxChar[1][3]='V';

    INumVoxChar[2][0]='1';
    INumVoxChar[2][1]='0';
    INumVoxChar[2][2]='0';    
    INumVoxChar[2][3]='V';
    
    IDimVoxChar[0][0]='1';
    IDimVoxChar[0][1]='0';
    IDimVoxChar[0][2]='.';

    IDimVoxChar[1][0]='1';
    IDimVoxChar[1][1]='0';
    IDimVoxChar[1][2]='.';    

    IDimVoxChar[2][0]='1';
    IDimVoxChar[2][1]='0';
    IDimVoxChar[2][2]='.';        
    //L'angle per defecte serà zero//
    IAnglesCubChar[0][0]='0';
    IAnglesCubChar[1][0]='0';
    IAnglesCubChar[2][0]='0';
    
    IAnglesCilChar[0][0]='0';
    IAnglesCilChar[1][0]='0';
    IAnglesCilChar[2][0]='0';

    //En aquestes figures les variables guarden la direccio d'un vector normal, no l'angle
    IAnglesPlaChar[0][0]='0';
    IAnglesPlaChar[1][0]='0';
    IAnglesPlaChar[2][0]='1';
    
    IAnglesSecEsfChar[0][0]='0';
    IAnglesSecEsfChar[1][0]='0';
    IAnglesSecEsfChar[2][0]='1';
    
    //La densitat per defecte serà 1//
    IDensCubChar[0]='1';
    IDensEsfChar[0]='1';
    IDensCilChar[0]='1';
    IDensPlaChar[0]='1';
    IDensSecEsfChar[0]='1';
    
    //De la simulacio//
    INomSimulacio[0]='\0';
    INomArxiuConfig[0]='\0';
    //INomArxiuMaterials[0]='\0';
    INomArxiuGeoQuad[0]='\0';
    INomArxiuGeoVox[0]='\0';
    
    //Del carregador de DICOM//
    INomDicom[0]='\0';
    ////////////////////////////////////////////////////////////////////////////////////
    /////////////////Botons menu////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////////////
    
    int AmpladaMenu=Dimensions_Menu[0];
      //OPCIONS DE CONSTRUCCIO DE GEOMETRIA
    NovaFigura.ColorInt(ColorBotons);
    NovaFigura.Moure(TamanyBotons[0]*0.5+SeparacioVora,Origen_Botons_Menu_Principal_Y,0);
    NovaFigura.Tamany(TamanyBotons[0],TamanyBotons[1]);
    NovaFigura.ColorLletra(ColorTextnou);
    NovaFigura.ActivarTextura(1,TexturaBotons,TamanyBotons[0],TamanyBotons[1]);
    
    SelFigura.ColorInt(ColorBotons);
    SelFigura.Moure(AmpladaMenu-TamanyBotons[0]*0.5-SeparacioVora,Origen_Botons_Menu_Principal_Y,0);
    SelFigura.Tamany(TamanyBotons[0],TamanyBotons[1]);
    SelFigura.ColorLletra(ColorTextnou);
    SelFigura.ActivarTextura(1,TexturaBotons,TamanyBotons[0],TamanyBotons[1]);

    BColor.ColorInt(ColorBotons);
    BColor.Moure(TamanyBotons[0]*0.5+SeparacioVora,Origen_Botons_Menu_Principal_Y-DistBotonsY,0);
    BColor.Tamany(TamanyBotons[0],TamanyBotons[1]);
    BColor.ColorLletra(ColorTextnou);
    BColor.ActivarTextura(1,TexturaBotons,TamanyBotons[0],TamanyBotons[1]);
    
    BGuardar.ColorInt(ColorBotons);
    BGuardar.Moure(AmpladaMenu-TamanyBotons[0]*0.5-SeparacioVora,Origen_Botons_Menu_Principal_Y-DistBotonsY,0);
    BGuardar.Tamany(TamanyBotons[0],TamanyBotons[1]);
    BGuardar.ColorLletra(ColorTextnou);    
    BGuardar.ActivarTextura(1,TexturaBotons,TamanyBotons[0],TamanyBotons[1]);

    BCarregar.ColorInt(ColorBotons);
    BCarregar.Moure(TamanyBotons[0]*0.5+SeparacioVora,Origen_Botons_Menu_Principal_Y-DistBotonsY*2,0);
    BCarregar.Tamany(TamanyBotons[0],TamanyBotons[1]);
    BCarregar.ColorLletra(ColorTextnou);    
    BCarregar.ActivarTextura(1,TexturaBotons,TamanyBotons[0],TamanyBotons[1]);

    BTransformarGrup.ColorInt(ColorBotons);
    BTransformarGrup.Moure(AmpladaMenu-TamanyBotons[0]*0.5-SeparacioVora,Origen_Botons_Menu_Principal_Y-DistBotonsY*2,0);
    BTransformarGrup.Tamany(TamanyBotons[0],TamanyBotons[1]);
    BTransformarGrup.ColorLletra(ColorTextnou);    
    BTransformarGrup.ActivarTextura(1,TexturaBotons,TamanyBotons[0],TamanyBotons[1]);
    
      //OPCIONS DELS VOXELS
    BEspai.ColorInt(ColorBotons);
    BEspai.Moure(TamanyBotons[0]*0.5+SeparacioVora,Origen_Botons_Menu_Principal_Y-DistBotonsY*4,0);
    BEspai.Tamany(TamanyBotons[0],TamanyBotons[1]);
    BEspai.ColorLletra(ColorTextnou);    
    BEspai.ActivarTextura(1,TexturaBotons,TamanyBotons[0],TamanyBotons[1]);

    ColorVoxels.ColorInt(ColorBotons);
    ColorVoxels.Moure(AmpladaMenu-TamanyBotons[0]*0.5-SeparacioVora,Origen_Botons_Menu_Principal_Y-4*DistBotonsY,0);
    ColorVoxels.Tamany(TamanyBotons[0],TamanyBotons[1]);
    ColorVoxels.ColorLletra(ColorTextnou);
    ColorVoxels.ActivarTextura(1,TexturaBotons,TamanyBotons[0],TamanyBotons[1]);
    
    BGuardarVox.ColorInt(ColorBotons);
    BGuardarVox.Moure(TamanyBotons[0]*0.5+SeparacioVora,Origen_Botons_Menu_Principal_Y-DistBotonsY*5,0);
    BGuardarVox.Tamany(TamanyBotons[0],TamanyBotons[1]);
    BGuardarVox.ColorLletra(ColorTextnou);    
    BGuardarVox.ActivarTextura(1,TexturaBotons,TamanyBotons[0],TamanyBotons[1]);
    
    BDicom.ColorInt(ColorBotons);
    BDicom.Moure(AmpladaMenu-TamanyBotons[0]*0.5-SeparacioVora,Origen_Botons_Menu_Principal_Y-DistBotonsY*5,0);
    BDicom.Tamany(TamanyBotons[0],TamanyBotons[1]);
    BDicom.ColorLletra(ColorTextnou);
    BDicom.ActivarTextura(1,TexturaBotons,TamanyBotons[0],TamanyBotons[1]);
    
        //OPCIONS DE SIMULACIO
    BSimulacio.ColorInt(ColorBotons);
    BSimulacio.Moure(TamanyBotons[0]*0.5+SeparacioVora,Origen_Botons_Menu_Principal_Y-DistBotonsY*7,0);
    BSimulacio.Tamany(TamanyBotons[0],TamanyBotons[1]);
    BSimulacio.ColorLletra(ColorTextnou);    
    BSimulacio.ActivarTextura(1,TexturaBotons,TamanyBotons[0],TamanyBotons[1]);
            
    BResultats.ColorInt(ColorBotons);
    BResultats.Moure(AmpladaMenu-TamanyBotons[0]*0.5-SeparacioVora,Origen_Botons_Menu_Principal_Y-DistBotonsY*7,0);
    BResultats.Tamany(TamanyBotons[0],TamanyBotons[1]);
    BResultats.ColorLletra(ColorTextnou);
    BResultats.ActivarTextura(1,TexturaBotons,TamanyBotons[0],TamanyBotons[1]);

      if(Idioma==0)
      {
	NovaFigura.Escriure(" New object",Tamany_Lletra_Botons_Menu);
	 SelFigura.Escriure(" Select object",Tamany_Lletra_Botons_Menu);
	 BColor.Escriure(" Color",Tamany_Lletra_Botons_Menu);
	 BGuardar.Escriure(" Save",Tamany_Lletra_Botons_Menu);
	 BCarregar.Escriure(" Load",Tamany_Lletra_Botons_Menu);
	 BTransformarGrup.Escriure(" Transformations",Tamany_Lletra_Botons_Menu);
	 BEspai.Escriure(" Space",Tamany_Lletra_Botons_Menu);
	 BSimulacio.Escriure(" Simulation",Tamany_Lletra_Botons_Menu);	
	 BResultats.Escriure(" Results viewer",Tamany_Lletra_Botons_Menu);
	 BDicom.Escriure(" DICOM loader",Tamany_Lletra_Botons_Menu);
	 BGuardarVox.Escriure(" Save",Tamany_Lletra_Botons_Menu);
	 ColorVoxels.Escriure(" Voxels",Tamany_Lletra_Botons_Menu);
      }
      else if(Idioma==1)
      {
	 NovaFigura.Escriure(" Nou objecte",Tamany_Lletra_Botons_Menu);
	 SelFigura.Escriure(" Seleccionar objecte",Tamany_Lletra_Botons_Menu);
	 BColor.Escriure(" Color",Tamany_Lletra_Botons_Menu);
	 BGuardar.Escriure(" Desa",Tamany_Lletra_Botons_Menu);
	 BCarregar.Escriure(" Obri",Tamany_Lletra_Botons_Menu);
	 BTransformarGrup.Escriure(" Transformacions",Tamany_Lletra_Botons_Menu);
	 BEspai.Escriure(" Espai",Tamany_Lletra_Botons_Menu);
	 BSimulacio.Escriure(" Simulacio",Tamany_Lletra_Botons_Menu);
	 BResultats.Escriure(" Visor de resultats",Tamany_Lletra_Botons_Menu);
	 BDicom.Escriure(" Carregar DICOM",Tamany_Lletra_Botons_Menu);
	 BGuardarVox.Escriure(" Desa",Tamany_Lletra_Botons_Menu);
	 ColorVoxels.Escriure(" Voxels",Tamany_Lletra_Botons_Menu);
      }
      else if(Idioma==2)
      {
	 NovaFigura.Escriure(" Nuevo objeto",Tamany_Lletra_Botons_Menu);
	 SelFigura.Escriure(" Seleccionar objeto",Tamany_Lletra_Botons_Menu);
	 BColor.Escriure(" Color",Tamany_Lletra_Botons_Menu);
	 BGuardar.Escriure(" Guardar",Tamany_Lletra_Botons_Menu);
	 BCarregar.Escriure(" Cargar",Tamany_Lletra_Botons_Menu);
	 BTransformarGrup.Escriure(" Transformaciones",Tamany_Lletra_Botons_Menu);
	 BEspai.Escriure(" Espacio",Tamany_Lletra_Botons_Menu);
	 BSimulacio.Escriure(" Simulacion",Tamany_Lletra_Botons_Menu);	  
	 BResultats.Escriure(" Visor de resultados",Tamany_Lletra_Botons_Menu);
	 BDicom.Escriure(" Cargar DICOM",Tamany_Lletra_Botons_Menu);
	 BGuardarVox.Escriure(" Guardar",Tamany_Lletra_Botons_Menu);
	 ColorVoxels.Escriure(" Voxels",Tamany_Lletra_Botons_Menu);
      }        
    
    ////////////////////////////////////////////////////////////////////////////////////
    ////////////////Botons submenu crear figura/////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////////////
      float Origen_Botons_Crear_Figura[2]={float(0.25*Dimensions_Menu[0]),float(0.44375*Dimensions_Menu[1])};
    NouCub.ColorInt(ColorBotons);
    NouCub.Moure(Origen_Botons_Crear_Figura[0],Origen_Botons_Crear_Figura[1],0);
    NouCub.Tamany(TamanyBotons[0],TamanyBotons[1]);
    NouCub.ColorLletra(ColorTextnou);
    NouCub.ActivarTextura(1,TexturaBotons,TamanyBotons[0],TamanyBotons[1]);    
    
    NovaEsfera.ColorInt(ColorBotons);
    NovaEsfera.Moure(Origen_Botons_Crear_Figura[0],Origen_Botons_Crear_Figura[1]-DistBotonsY,0);
    NovaEsfera.Tamany(TamanyBotons[0],TamanyBotons[1]);
    NovaEsfera.ColorLletra(ColorTextnou);
    NovaEsfera.ActivarTextura(1,TexturaBotons,TamanyBotons[0],TamanyBotons[1]);
    
    NouCilindre.ColorInt(ColorBotons);
    NouCilindre.Moure(Origen_Botons_Crear_Figura[0],Origen_Botons_Crear_Figura[1]-2*DistBotonsY,0);
    NouCilindre.Tamany(TamanyBotons[0],TamanyBotons[1]);
    NouCilindre.ColorLletra(ColorTextnou);
    NouCilindre.ActivarTextura(1,TexturaBotons,TamanyBotons[0],TamanyBotons[1]);
    
    NouPla.ColorInt(ColorBotons);
    NouPla.Moure(Origen_Botons_Crear_Figura[0],Origen_Botons_Crear_Figura[1]-3*DistBotonsY,0);
    NouPla.Tamany(TamanyBotons[0],TamanyBotons[1]);
    NouPla.ColorLletra(ColorTextnou);
    NouPla.ActivarTextura(1,TexturaBotons,TamanyBotons[0],TamanyBotons[1]);

    NouSeccioEsf.ColorInt(ColorBotons);
    NouSeccioEsf.Moure(Origen_Botons_Crear_Figura[0],Origen_Botons_Crear_Figura[1]-4*DistBotonsY,0);
    NouSeccioEsf.Tamany(TamanyBotons[0],TamanyBotons[1]);
    NouSeccioEsf.ColorLletra(ColorTextnou);
    NouSeccioEsf.ActivarTextura(1,TexturaBotons,TamanyBotons[0],TamanyBotons[1]);

    Crear.ColorInt(ColorBotons);
    Crear.Moure(Origen_Botons_Crear_Figura[0],TamanyBotons[1]*2,0);
    Crear.Tamany(TamanyBotons[0],TamanyBotons[1]);
    Crear.ColorLletra(ColorTextnou);
    Crear.ActivarTextura(1,TexturaBotons,TamanyBotons[0],TamanyBotons[1]);
    
    BBorrar.ColorInt(ColorBotons);
    BBorrar.Moure(0.73*Dimensions_Menu[0],TamanyBotons[1]*2,0);
    BBorrar.Tamany(TamanyBotons[0],TamanyBotons[1]);
    BBorrar.ColorLletra(ColorTextnou);
    BBorrar.ActivarTextura(1,TexturaBotons,TamanyBotons[0],TamanyBotons[1]);

      if(Idioma==0)
      {
	 NouCub.Escriure(" Cube",Tamany_Lletra_Botons_Menu);
	 NovaEsfera.Escriure(" Sphere",Tamany_Lletra_Botons_Menu);
	 NouCilindre.Escriure(" Cylinder/Cone",Tamany_Lletra_Botons_Menu);
	 NouPla.Escriure(" Infinite plane",Tamany_Lletra_Botons_Menu);
	 NouSeccioEsf.Escriure(" Sphere section",Tamany_Lletra_Botons_Menu);
	 Crear.Escriure(" Done",Tamany_Lletra_Botons_Menu);
	 BBorrar.Escriure(" Delete",Tamany_Lletra_Botons_Menu);
      }
      else if(Idioma==1)
      {
	 NouCub.Escriure(" Cub",Tamany_Lletra_Botons_Menu);
	 NovaEsfera.Escriure(" Esfera",Tamany_Lletra_Botons_Menu);
	 NouCilindre.Escriure(" Cilindre/Con",Tamany_Lletra_Botons_Menu);
	 NouPla.Escriure(" Pla infinit",Tamany_Lletra_Botons_Menu);
	 NouSeccioEsf.Escriure(" Seccio d'esfera",Tamany_Lletra_Botons_Menu);
	 Crear.Escriure(" Fet",Tamany_Lletra_Botons_Menu);
	 BBorrar.Escriure(" Borrar",Tamany_Lletra_Botons_Menu);
      }
      else if(Idioma==2)
      {
	 NouCub.Escriure(" Cubo",Tamany_Lletra_Botons_Menu);
	 NovaEsfera.Escriure(" Esfera",Tamany_Lletra_Botons_Menu);
	 NouCilindre.Escriure(" Cilindro/Cono",Tamany_Lletra_Botons_Menu);
	 NouPla.Escriure(" Plano infinito",Tamany_Lletra_Botons_Menu);
	 NouSeccioEsf.Escriure(" Seccion de esfera",Tamany_Lletra_Botons_Menu);
	 Crear.Escriure(" Hecho",Tamany_Lletra_Botons_Menu);
	 BBorrar.Escriure(" Borrar",Tamany_Lletra_Botons_Menu);
      }        
    
    
    ////////////////////////////////////////////////////////////////////////////////////
    ////////////////Botons submenu seleccionar figura - Transformacions/////////////////
    ////////////////////////////////////////////////////////////////////////////////////

      float Tamany_Botons_Introduir_Transformacio[2]={float(0.133333333*Dimensions_Menu[0]),float(0.01875*Dimensions_Menu[1])};
      
    BNetejarSeleccio.ColorInt(ColorBotons);
    BNetejarSeleccio.Moure(0.466*Dimensions_Menu[0],0.4875*Dimensions_Menu[1],0);
    BNetejarSeleccio.Tamany(TamanyBotons[0],TamanyBotons[1]);
    BNetejarSeleccio.ColorLletra(ColorTextnou);
    BNetejarSeleccio.ActivarTextura(1,TexturaBotons,TamanyBotons[0],TamanyBotons[1]);

    BTranslacio.ColorInt(ColorBotons);
    BTranslacio.Moure(TamanyBotons[0]*0.5+SeparacioVora,0.25*Dimensions_Menu[1],0);
    BTranslacio.Tamany(TamanyBotons[0],TamanyBotons[1]);
    BTranslacio.ColorLletra(ColorTextnou);
    BTranslacio.ActivarTextura(1,TexturaBotons,TamanyBotons[0],TamanyBotons[1]);

    BParametresTransformacio[0].Moure(0.466*Dimensions_Menu[0],0.13125*Dimensions_Menu[1],0);
    BParametresTransformacio[0].Tamany(Tamany_Botons_Introduir_Transformacio[0],Tamany_Botons_Introduir_Transformacio[1]);
    
    BParametresTransformacio[1].Moure(0.6333*Dimensions_Menu[0],0.13125*Dimensions_Menu[1],0);
    BParametresTransformacio[1].Tamany(Tamany_Botons_Introduir_Transformacio[0],Tamany_Botons_Introduir_Transformacio[1]);
    
    BParametresTransformacio[2].Moure(0.8*Dimensions_Menu[0],0.13125*Dimensions_Menu[1],0);
    BParametresTransformacio[2].Tamany(Tamany_Botons_Introduir_Transformacio[0],Tamany_Botons_Introduir_Transformacio[1]);    
    if(Idioma==0)
      {
	BNetejarSeleccio.Escriure(" Clean",Tamany_Lletra_Botons_Menu);
	BTranslacio.Escriure(" Translation",Tamany_Lletra_Botons_Menu);
      }
    else if(Idioma==1)
      {
	BNetejarSeleccio.Escriure(" Neteja",Tamany_Lletra_Botons_Menu);
	BTranslacio.Escriure(" Translacio",Tamany_Lletra_Botons_Menu);
      }
    else if(Idioma==2)
      {
	BNetejarSeleccio.Escriure(" Limpia",Tamany_Lletra_Botons_Menu);
	BTranslacio.Escriure(" Translacion",Tamany_Lletra_Botons_Menu);
      }
    float Tamany_Botons_Introduir_Seleccio_Obj_Transformacio[2]={float(0.1*Dimensions_Menu[0]),float(0.01875*Dimensions_Menu[1])};
      
    IFiguraSelec.Moure(0.466*Dimensions_Menu[0],0.44375*Dimensions_Menu[1],0);
    IFiguraSelec.Tamany(Tamany_Botons_Introduir_Seleccio_Obj_Transformacio[0],Tamany_Botons_Introduir_Seleccio_Obj_Transformacio[1]);
    
    ICosSelec.Moure(0.466*Dimensions_Menu[0],0.4*Dimensions_Menu[1],0);
    ICosSelec.Tamany(Tamany_Botons_Introduir_Seleccio_Obj_Transformacio[0],Tamany_Botons_Introduir_Seleccio_Obj_Transformacio[1]);

    IMaterialSelec.Moure(0.466*Dimensions_Menu[0],0.35625*Dimensions_Menu[1],0);
    IMaterialSelec.Tamany(Tamany_Botons_Introduir_Seleccio_Obj_Transformacio[0],Tamany_Botons_Introduir_Seleccio_Obj_Transformacio[1]);

    GLfloat verd[4]={0,0.8,0,1};
    float roig[4]={1,0,0,1};

    float Tamany_Botons_Afegir=0.01625*Dimensions_Menu[1];
    
    AfegirFiguraSelec[0].Moure(0.66666*Dimensions_Menu[0],0.44375*Dimensions_Menu[1],0);
    AfegirFiguraSelec[0].Tamany(Tamany_Botons_Afegir,Tamany_Botons_Afegir);
    
    AfegirFiguraSelec[1].Moure(0.76666*Dimensions_Menu[0],0.44375*Dimensions_Menu[1],0);
    AfegirFiguraSelec[1].Tamany(Tamany_Botons_Afegir,Tamany_Botons_Afegir);

    AfegirFiguraSelec[0].ColorInt(verd);
    AfegirFiguraSelec[1].ColorInt(roig);
    
    AfegirFiguraSelec[0].Escriure("+",Tamany_Lletra_Quadres_Dades);
    AfegirFiguraSelec[1].Escriure("-",Tamany_Lletra_Quadres_Dades);
    
    AfegirCosSelec[0].Moure(0.66666*Dimensions_Menu[0],0.4*Dimensions_Menu[1],0);
    AfegirCosSelec[0].Tamany(Tamany_Botons_Afegir,Tamany_Botons_Afegir);
    
    AfegirCosSelec[1].Moure(0.76666*Dimensions_Menu[0],0.4*Dimensions_Menu[1],0);
    AfegirCosSelec[1].Tamany(Tamany_Botons_Afegir,Tamany_Botons_Afegir);

    AfegirCosSelec[0].ColorInt(verd);
    AfegirCosSelec[1].ColorInt(roig);
    
    AfegirCosSelec[0].Escriure("+",Tamany_Lletra_Quadres_Dades);
    AfegirCosSelec[1].Escriure("-",Tamany_Lletra_Quadres_Dades);

    AfegirMaterialSelec[0].Moure(0.66666*Dimensions_Menu[0],0.35625*Dimensions_Menu[1],0);
    AfegirMaterialSelec[0].Tamany(Tamany_Botons_Afegir,Tamany_Botons_Afegir);
    
    AfegirMaterialSelec[1].Moure(0.76666*Dimensions_Menu[0],0.35625*Dimensions_Menu[1],0);
    AfegirMaterialSelec[1].Tamany(Tamany_Botons_Afegir,Tamany_Botons_Afegir);

    AfegirMaterialSelec[0].ColorInt(verd);
    AfegirMaterialSelec[1].ColorInt(roig);
    
    AfegirMaterialSelec[0].Escriure("+",Tamany_Lletra_Quadres_Dades);
    AfegirMaterialSelec[1].Escriure("-",Tamany_Lletra_Quadres_Dades);
    ////////////////////////////////////////////////////////////////////////////////////
    ////////////////Botons submenu color ///////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////////////

    float Origen_Botons_Color[2]={float(0.5*Dimensions_Menu[0]),float(0.44375*Dimensions_Menu[1])};

    ColorObjecte.ColorInt(ColorBotons);
    ColorObjecte.Moure(Origen_Botons_Color[0],Origen_Botons_Color[1],0);
    ColorObjecte.Tamany(TamanyBotons[0],TamanyBotons[1]);
    ColorObjecte.ColorLletra(ColorTextnou);
    ColorObjecte.ActivarTextura(1,TexturaBotons,TamanyBotons[0],TamanyBotons[1]);
    
    ColorMaterial.ColorInt(ColorBotons);
    ColorMaterial.Moure(Origen_Botons_Color[0],Origen_Botons_Color[1]-DistBotonsY,0);
    ColorMaterial.Tamany(TamanyBotons[0],TamanyBotons[1]);
    ColorMaterial.ColorLletra(ColorTextnou);
    ColorMaterial.ActivarTextura(1,TexturaBotons,TamanyBotons[0],TamanyBotons[1]);
    
    ColorPrioritat.ColorInt(ColorBotons);
    ColorPrioritat.Moure(Origen_Botons_Color[0],Origen_Botons_Color[1]-2*DistBotonsY,0);
    ColorPrioritat.Tamany(TamanyBotons[0],TamanyBotons[1]);
    ColorPrioritat.ColorLletra(ColorTextnou);
    ColorPrioritat.ActivarTextura(1,TexturaBotons,TamanyBotons[0],TamanyBotons[1]);
    
    ColorOpacitat.ColorInt(ColorBotons);
    ColorOpacitat.Moure(Origen_Botons_Color[0],Origen_Botons_Color[1]-3*DistBotonsY,0);
    ColorOpacitat.Tamany(TamanyBotons[0],TamanyBotons[1]);
    ColorOpacitat.ColorLletra(ColorTextnou);
    ColorOpacitat.ActivarTextura(1,TexturaBotons,TamanyBotons[0],TamanyBotons[1]);
      if(Idioma==0)
      {
	 ColorObjecte.Escriure(" Object",Tamany_Lletra_Botons_Menu);
	 ColorMaterial.Escriure(" Material",Tamany_Lletra_Botons_Menu);
	 ColorPrioritat.Escriure(" Body",Tamany_Lletra_Botons_Menu);	
	 ColorOpacitat.Escriure(" Opacity",Tamany_Lletra_Botons_Menu);	
      }
      else if(Idioma==1)
      {
	 ColorObjecte.Escriure(" Objecte",Tamany_Lletra_Botons_Menu);
	 ColorMaterial.Escriure(" Material",Tamany_Lletra_Botons_Menu);
	 ColorPrioritat.Escriure(" Cos",Tamany_Lletra_Botons_Menu);
	 ColorOpacitat.Escriure(" Opacitat",Tamany_Lletra_Botons_Menu);	
      }
      else if(Idioma==2)
      {
	 ColorObjecte.Escriure(" Objeto",Tamany_Lletra_Botons_Menu);
	 ColorMaterial.Escriure(" Material",Tamany_Lletra_Botons_Menu);
	 ColorPrioritat.Escriure(" Cuerpo",Tamany_Lletra_Botons_Menu);
	 ColorOpacitat.Escriure(" Opacidad",Tamany_Lletra_Botons_Menu);	
      }        


    ////////////////////////////////////////////////////////////////////////////////////
    ////////////////Botons submenu Espai ///////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////////////

      float Tamany_Botons_Espai[2]={float(0.1333333*Dimensions_Menu[0]),float(0.01875*Dimensions_Menu[1])};

    //NumVoxels//
    BNumVox[0].Moure(0.3*Dimensions_Menu[0],0.44375*Dimensions_Menu[1],0);
    BNumVox[0].Tamany(Tamany_Botons_Espai[0],Tamany_Botons_Espai[1]);
    
    BNumVox[1].Moure(0.4666*Dimensions_Menu[0],0.44375*Dimensions_Menu[1],0);
    BNumVox[1].Tamany(Tamany_Botons_Espai[0],Tamany_Botons_Espai[1]);
    
    BNumVox[2].Moure(0.6333*Dimensions_Menu[0],0.44375*Dimensions_Menu[1],0);
    BNumVox[2].Tamany(Tamany_Botons_Espai[0],Tamany_Botons_Espai[1]);    
    
    //Dimensions//
    BDimVox[0].Moure(0.3*Dimensions_Menu[0],0.4*Dimensions_Menu[1],0);
    BDimVox[0].Tamany(Tamany_Botons_Espai[0],Tamany_Botons_Espai[1]);
    
    BDimVox[1].Moure(0.4666*Dimensions_Menu[0],0.4*Dimensions_Menu[1],0);
    BDimVox[1].Tamany(Tamany_Botons_Espai[0],Tamany_Botons_Espai[1]);
    
    BDimVox[2].Moure(0.6333*Dimensions_Menu[0],0.4*Dimensions_Menu[1],0);
    BDimVox[2].Tamany(Tamany_Botons_Espai[0],Tamany_Botons_Espai[1]);    
    
    ////////////////////////////////////////////////////////////////////////////////////
    ////////////////Botons submenu Desar ///////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////////////    

    BGuardarGeo.ColorInt(ColorBotons);
    BGuardarGeo.Moure(Origen_Botons_Color[0],Origen_Botons_Color[1],0);
    BGuardarGeo.Tamany(TamanyBotons[0],TamanyBotons[1]);
    BGuardarGeo.ColorLletra(ColorTextnou);
    BGuardarGeo.ActivarTextura(1,TexturaBotons,TamanyBotons[0],TamanyBotons[1]);
    
    BGuardarPenelope.ColorInt(ColorBotons);
    BGuardarPenelope.Moure(Origen_Botons_Color[0],Origen_Botons_Color[1]-DistBotonsY,0);
    BGuardarPenelope.Tamany(TamanyBotons[0],TamanyBotons[1]);
    BGuardarPenelope.ColorLletra(ColorTextnou);
    BGuardarPenelope.ActivarTextura(1,TexturaBotons,TamanyBotons[0],TamanyBotons[1]);

    BGuardarGeant4.ColorInt(ColorBotons);
    BGuardarGeant4.Moure(Origen_Botons_Color[0],Origen_Botons_Color[1]-DistBotonsY*2,0);
    BGuardarGeant4.Tamany(TamanyBotons[0],TamanyBotons[1]);
    BGuardarGeant4.ColorLletra(ColorTextnou);
    BGuardarGeant4.ActivarTextura(1,TexturaBotons,TamanyBotons[0],TamanyBotons[1]);
      
    BGuardarVoxelsPene.ColorInt(ColorBotons);
    BGuardarVoxelsPene.Moure(Origen_Botons_Color[0],Origen_Botons_Color[1],0);
    BGuardarVoxelsPene.Tamany(TamanyBotons[0],TamanyBotons[1]);
    BGuardarVoxelsPene.ColorLletra(ColorTextnou);
    BGuardarVoxelsPene.ActivarTextura(1,TexturaBotons,TamanyBotons[0],TamanyBotons[1]);

      if(Idioma==0)
      {
        BGuardarGeo.Escriure(" Save geometry",Tamany_Lletra_Botons_Menu);
	BGuardarPenelope.Escriure(" Save Penelope.geo",Tamany_Lletra_Botons_Menu);
	BGuardarGeant4.Escriure(" Save Geant4.cpp",Tamany_Lletra_Botons_Menu);	
	BGuardarVoxelsPene.Escriure(" Save Penelope.vox",Tamany_Lletra_Botons_Menu);	
      }
      else if(Idioma==1)
      {
        BGuardarGeo.Escriure(" Guardar geometria",Tamany_Lletra_Botons_Menu);
	BGuardarPenelope.Escriure(" Guardar Penelope.geo",Tamany_Lletra_Botons_Menu);
	BGuardarGeant4.Escriure(" Guardar Geant4.cpp",Tamany_Lletra_Botons_Menu);	
	BGuardarVoxelsPene.Escriure(" Guardar Penelope.vox",Tamany_Lletra_Botons_Menu);
      }
      else if(Idioma==2)
      {
        BGuardarGeo.Escriure(" Guardar geometria",Tamany_Lletra_Botons_Menu);
	BGuardarPenelope.Escriure(" Guardar Penelope.geo",Tamany_Lletra_Botons_Menu);
	BGuardarGeant4.Escriure(" Guardar Geant4.cpp",Tamany_Lletra_Botons_Menu);	
	BGuardarVoxelsPene.Escriure(" Guardar Penelope.vox",Tamany_Lletra_Botons_Menu);	
      }        

    /////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////Botons submenu visor de Dicom/////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    Tallar.ColorInt(ColorBotons);
    Tallar.Moure(0.33333*Dimensions_Menu[0]+TamanyBotons[0],TamanyBotons[1]*2,0);
    Tallar.Tamany(TamanyBotons[0],TamanyBotons[1]);
    Tallar.ColorLletra(ColorTextnou);
    Tallar.ActivarTextura(1,TexturaBotons,TamanyBotons[0],TamanyBotons[1]);

    
    BContornsDICOM.ColorInt(ColorBotons);
    BContornsDICOM.Moure(Origen_Botons_Color[0],Origen_Botons_Color[1]-DistBotonsY*2,0);
    BContornsDICOM.Tamany(TamanyBotons[0],TamanyBotons[1]);
    BContornsDICOM.ColorLletra(ColorTextnou);
    BContornsDICOM.ActivarTextura(1,TexturaBotons,TamanyBotons[0],TamanyBotons[1]);
    
    BPintMatDCM.ColorInt(ColorBotons);
    BPintMatDCM.Moure(Origen_Botons_Color[0]-TamanyBotons[0]/4.0-1,Origen_Botons_Color[1]-3*DistBotonsY,0);
    BPintMatDCM.Tamany(TamanyBotons[0]*0.5,TamanyBotons[1]);
    BPintMatDCM.ColorLletra(ColorTextnou);
    BPintMatDCM.ActivarTextura(1,TexturaBotonsMenuts,TamanyBotons[0]*0.5,TamanyBotons[1]);
    BPintMatDCM.Escriure(" Mat",Tamany_Lletra_Botons_Menu);
    
    BPintDensDCM.ColorInt(ColorBotons);
    BPintDensDCM.Moure(Origen_Botons_Color[0]+TamanyBotons[0]/4.0+1,Origen_Botons_Color[1]-3*DistBotonsY,0);
    BPintDensDCM.Tamany(TamanyBotons[0]*0.5,TamanyBotons[1]);
    BPintDensDCM.ColorLletra(ColorTextnou);
    BPintDensDCM.ActivarTextura(1,TexturaBotonsMenuts,TamanyBotons[0]*0.5,TamanyBotons[1]);
    BPintDensDCM.Escriure(" Dens",Tamany_Lletra_Botons_Menu);    
    
    BDicom2D.ColorInt(ColorBotons);
    BDicom2D.Moure(Origen_Botons_Color[0],DistBotonsY*0.6,0);
    BDicom2D.Tamany(TamanyBotons[0]*0.5,TamanyBotons[1]);
    BDicom2D.ColorLletra(ColorTextnou);
    BDicom2D.ActivarTextura(1,TexturaBotonsMenuts,TamanyBotons[0]*0.5,TamanyBotons[1]);
    BDicom2D.Escriure(" 2D",Tamany_Lletra_Botons_Menu);

    if(Idioma==0)
      {
	BContornsDICOM.Escriure("  Contours",Tamany_Lletra_Botons_Menu);
      }
    else if(Idioma==1)
      {
	BContornsDICOM.Escriure("  Contorns",Tamany_Lletra_Botons_Menu);
      }
    else if(Idioma==2)
      {
	BContornsDICOM.Escriure("  Contornos",Tamany_Lletra_Botons_Menu);
      }
    /////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    ///////////////Botons subsubmenu NouCub NouCilindre NovaEsfera Pla infinit Seccio Esfera/////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    //Centre//
    
    Centre[0].Moure(0.3*Dimensions_Menu[0],0.44375*Dimensions_Menu[1],0);
    Centre[0].Tamany(Tamany_Botons_Espai[0],Tamany_Botons_Espai[1]);
    
    Centre[1].Moure(0.46666*Dimensions_Menu[0],0.44375*Dimensions_Menu[1],0);
    Centre[1].Tamany(Tamany_Botons_Espai[0],Tamany_Botons_Espai[1]);
    
    Centre[2].Moure(0.63333*Dimensions_Menu[0],0.44375*Dimensions_Menu[1],0);
    Centre[2].Tamany(Tamany_Botons_Espai[0],Tamany_Botons_Espai[1]);    
    
    //Dimensions//
    Dim[0].Moure(0.3*Dimensions_Menu[0],0.4*Dimensions_Menu[1],0);
    Dim[0].Tamany(Tamany_Botons_Espai[0],Tamany_Botons_Espai[1]);
    
    Dim[1].Moure(0.46666*Dimensions_Menu[0],0.4*Dimensions_Menu[1],0);
    Dim[1].Tamany(Tamany_Botons_Espai[0],Tamany_Botons_Espai[1]);
    
    Dim[2].Moure(0.63333*Dimensions_Menu[0],0.4*Dimensions_Menu[1],0);
    Dim[2].Tamany(Tamany_Botons_Espai[0],Tamany_Botons_Espai[1]);    
    //Prioritat//
    Prioritat.Moure(0.4166*Dimensions_Menu[0],0.35625*Dimensions_Menu[1],0);
    Prioritat.Tamany(0.1*Dimensions_Menu[0],Tamany_Botons_Espai[1]);

    //Activar/desactivar tub
    float Blau[3]={0,0,0.6};
    BTub.Moure(0.6*Dimensions_Menu[0],0.35625*Dimensions_Menu[1],0);
    BTub.Tamany(Tamany_Botons_Espai[1],Tamany_Botons_Espai[1]);
    BTub.ColorInt(Blau);
    
    //Figures internes//
    Interns.Moure(0.55*Dimensions_Menu[0],0.3125*Dimensions_Menu[1],0);
    Interns.Tamany(Tamany_Botons_Espai[1]*2,Tamany_Botons_Espai[1]);
    
    AfegirInterns[0].Moure(0.666666*Dimensions_Menu[0],0.3125*Dimensions_Menu[1],0);
    AfegirInterns[1].Moure(0.766666*Dimensions_Menu[0],0.3125*Dimensions_Menu[1],0);
    AfegirInterns[0].Tamany(Tamany_Botons_Espai[1],Tamany_Botons_Espai[1]);
    AfegirInterns[1].Tamany(Tamany_Botons_Espai[1],Tamany_Botons_Espai[1]);
    
    
    AfegirInterns[0].ColorInt(verd);
    AfegirInterns[1].ColorInt(roig);
    
    AfegirInterns[0].Escriure("+",Tamany_Lletra_Quadres_Dades);
    AfegirInterns[1].Escriure("-",Tamany_Lletra_Quadres_Dades);
    
    //Material i Densitat//
    MatDens[0].Moure(0.3*Dimensions_Menu[0],0.21875*Dimensions_Menu[1],0);
    MatDens[1].Moure(0.3*Dimensions_Menu[0],0.175*Dimensions_Menu[1],0);
    
    MatDens[0].Tamany(Tamany_Botons_Espai[0],Tamany_Botons_Espai[1]);
    MatDens[1].Tamany(Tamany_Botons_Espai[0],Tamany_Botons_Espai[1]);
    
    
    Angles[0].Moure(0.3*Dimensions_Menu[0],0.13125*Dimensions_Menu[1],0);
    Angles[0].Tamany(Tamany_Botons_Espai[0],Tamany_Botons_Espai[1]);
    
    Angles[1].Moure(0.46666*Dimensions_Menu[0],0.13125*Dimensions_Menu[1],0);
    Angles[1].Tamany(Tamany_Botons_Espai[0],Tamany_Botons_Espai[1]);
    
    Angles[2].Moure(0.63333*Dimensions_Menu[0],0.13125*Dimensions_Menu[1],0);
    Angles[2].Tamany(Tamany_Botons_Espai[0],Tamany_Botons_Espai[1]);    

        
    menuCreat=true;

    ///////////////////////////////////////////////////////////////////////////////////////
    ///////////////Botons subsubmenu Color Voxels//////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////    
    
    CVoxPunts.ColorInt(ColorBotons);
    CVoxPunts.Moure(Origen_Botons_Color[0]-TamanyBotons[0]/4.0-1,Origen_Botons_Color[1]-4*DistBotonsY,0);
    CVoxPunts.Tamany(TamanyBotons[0]*0.5,TamanyBotons[1]);
    CVoxPunts.ColorLletra(ColorTextnou);
    CVoxPunts.ActivarTextura(1,TexturaBotonsMenuts,TamanyBotons[0]*0.5,TamanyBotons[1]);
    
    CVoxQuad.ColorInt(ColorBotons);
    CVoxQuad.Moure(Origen_Botons_Color[0]+TamanyBotons[0]/4.0+1,Origen_Botons_Color[1]-4*DistBotonsY,0);
    CVoxQuad.Tamany(TamanyBotons[0]*0.5,TamanyBotons[1]);
    CVoxQuad.ColorLletra(ColorTextnou);
    CVoxQuad.ActivarTextura(1,TexturaBotonsMenuts,TamanyBotons[0]*0.5,TamanyBotons[1]);
    
    CVoxPla[0].Moure(0.266666*Dimensions_Menu[0],Origen_Botons_Color[1]-6*DistBotonsY+DistBotonsY*0.5,0);
    CVoxPla[0].Tamany(Tamany_Botons_Espai[0],Tamany_Botons_Espai[1]);

    CVoxPla[1].Moure(0.5*Dimensions_Menu[0],Origen_Botons_Color[1]-6*DistBotonsY+DistBotonsY*0.5,0);
    CVoxPla[1].Tamany(Tamany_Botons_Espai[0],Tamany_Botons_Espai[1]);

    CVoxPla[2].Moure(0.7333333*Dimensions_Menu[0],Origen_Botons_Color[1]-6*DistBotonsY+DistBotonsY*0.5,0);
    CVoxPla[2].Tamany(Tamany_Botons_Espai[0],Tamany_Botons_Espai[1]);    
    
    CVoxPlaInf[0].Moure(0.266666*Dimensions_Menu[0],Origen_Botons_Color[1]-7*DistBotonsY,0);
    CVoxPlaInf[0].Tamany(Tamany_Botons_Espai[0],Tamany_Botons_Espai[1]);

    CVoxPlaInf[1].Moure(0.5*Dimensions_Menu[0],Origen_Botons_Color[1]-7*DistBotonsY,0);
    CVoxPlaInf[1].Tamany(Tamany_Botons_Espai[0],Tamany_Botons_Espai[1]);

    CVoxPlaInf[2].Moure(0.7333333*Dimensions_Menu[0],Origen_Botons_Color[1]-7*DistBotonsY,0);
    CVoxPlaInf[2].Tamany(Tamany_Botons_Espai[0],Tamany_Botons_Espai[1]);    

    BMallat.ColorInt(ColorBotons);
    BMallat.Moure(0.333333*Dimensions_Menu[0]+TamanyBotons[0],TamanyBotons[1]*2,0);
    BMallat.Tamany(TamanyBotons[0],TamanyBotons[1]);
    BMallat.ColorLletra(ColorTextnou);
    BMallat.ActivarTextura(1,TexturaBotons,TamanyBotons[0],TamanyBotons[1]);    
    
      if(Idioma==0)
      {
	CVoxPunts.Escriure(" Points",Tamany_Lletra_Botons_Menu);
	CVoxQuad.Escriure(" Cubes",Tamany_Lletra_Botons_Menu); 
	BMallat.Escriure(" Mesh",Tamany_Lletra_Botons_Menu);
      }
      else if(Idioma==1)
      {
	CVoxPunts.Escriure(" Punts",Tamany_Lletra_Botons_Menu);
	CVoxQuad.Escriure(" Cubs",Tamany_Lletra_Botons_Menu);
	BMallat.Escriure(" Mallat",Tamany_Lletra_Botons_Menu);	
      }
      else if(Idioma==2)
      {
	CVoxPunts.Escriure(" Puntos",Tamany_Lletra_Botons_Menu);
	CVoxQuad.Escriure(" Cubos",Tamany_Lletra_Botons_Menu);
	BMallat.Escriure(" Mallado",Tamany_Lletra_Botons_Menu);	
      }        

    ///////////////////////////////////////////////////////////////////////////////////////
    //////////////////Botons subsubmenu Simulacio//////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////   
      float Origen_Botons_Simulacio[2]={float(0.36666666*Dimensions_Menu[0]),float(0.44375*Dimensions_Menu[1])};
      float Tamany_Botons_Simulacio[2]={float(0.666666*Dimensions_Menu[0]),float(0.01875*Dimensions_Menu[1])};
    BNomSimulacio.Moure(Origen_Botons_Simulacio[0],Origen_Botons_Simulacio[1],0);
    BNomSimulacio.Tamany(Tamany_Botons_Simulacio[0],Tamany_Botons_Simulacio[1]);
    BNomArxiuConfig.Moure(Origen_Botons_Simulacio[0],Origen_Botons_Simulacio[1]-1*DistBotonsY,0);
    BNomArxiuConfig.Tamany(Tamany_Botons_Simulacio[0],Tamany_Botons_Simulacio[1]);
    BNomArxiuGeoQuad.Moure(Origen_Botons_Simulacio[0],Origen_Botons_Simulacio[1]-2*DistBotonsY,0);
    BNomArxiuGeoQuad.Tamany(Tamany_Botons_Simulacio[0],Tamany_Botons_Simulacio[1]);
    BNomArxiuGeoVox.Moure(Origen_Botons_Simulacio[0],Origen_Botons_Simulacio[1]-3*DistBotonsY,0);
    BNomArxiuGeoVox.Tamany(Tamany_Botons_Simulacio[0],Tamany_Botons_Simulacio[1]);
    BNumSimulacions.Moure(0.066666*Dimensions_Menu[0],Origen_Botons_Simulacio[1]-4*DistBotonsY,0);
    BNumSimulacions.Tamany(Tamany_Botons_Espai[0]*0.5,Tamany_Botons_Espai[1]);      
      
    ///////////////////////////////////////////////////////////////////////////////////////
    //////////////////Botons subsubmenu Idioma/////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////    

    float TamBotonsIdioma[2]={float(0.0666666*Dimensions_Menu[0]),float(0.025*Dimensions_Menu[1])};
    float ColorIdioma[3]={0.8,0.8,0};
    float ColorIdiomaSel[3]={0,0.6,0};
    float ColorTextIdioma[3]={0,0,0};
    
    if(Idioma==0)
    {
      BIdioma[0].ColorInt(ColorIdiomaSel);      
    }
    else
    {
      BIdioma[0].ColorInt(ColorIdioma);
    }
    BIdioma[0].Moure(AmpladaMenu-TamBotonsIdioma[0]*0.5,TamBotonsIdioma[1]*0.5,0);
    BIdioma[0].Tamany(TamBotonsIdioma[0],TamBotonsIdioma[1]);
    BIdioma[0].ColorLletra(ColorTextIdioma);
    
    if(Idioma==1)
    {
      BIdioma[1].ColorInt(ColorIdiomaSel);      
    }
    else
    {
      BIdioma[1].ColorInt(ColorIdioma);
    }
    BIdioma[1].Moure(AmpladaMenu-TamBotonsIdioma[0]*0.5-TamBotonsIdioma[0],TamBotonsIdioma[1]*0.5,0);
    BIdioma[1].Tamany(TamBotonsIdioma[0],TamBotonsIdioma[1]);
    BIdioma[1].ColorLletra(ColorTextIdioma);
    
    if(Idioma==2)
    {
      BIdioma[2].ColorInt(ColorIdiomaSel);      
    }
    else
    {
      BIdioma[2].ColorInt(ColorIdioma);
    }
    BIdioma[2].Moure(AmpladaMenu-TamBotonsIdioma[0]*0.5-TamBotonsIdioma[0]*2,TamBotonsIdioma[1]*0.5,0);
    BIdioma[2].Tamany(TamBotonsIdioma[0],TamBotonsIdioma[1]);
    BIdioma[2].ColorLletra(ColorTextIdioma);

        BIdioma[0].Escriure("en",Tamany_Lletra_Quadres_Dades);
	BIdioma[1].Escriure("cat",Tamany_Lletra_Quadres_Dades);
	BIdioma[2].Escriure("es",Tamany_Lletra_Quadres_Dades);	

    ///////////////////////////////////////////////////////////////////////////////////////
    //////////////////Botons subsubmenu visor resultats////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////    

    //Els botons de introduir els plans de tall i punts/quad són els del submenu voxels del menu color
    
    BDosiMin.Moure(0.3*Dimensions_Menu[0],0.4*Dimensions_Menu[1],0);
    BDosiMin.Tamany(Tamany_Botons_Espai[0],Tamany_Botons_Espai[1]);
    
    BDosiMax.Moure(0.633333*Dimensions_Menu[0],0.4*Dimensions_Menu[1],0);
    BDosiMax.Tamany(Tamany_Botons_Espai[0],Tamany_Botons_Espai[1]);    
    
    BEscalaLog.ColorInt(ColorBotons);
    BEscalaLog.Moure(0.633333*Dimensions_Menu[0],0.325*Dimensions_Menu[1],0);
    BEscalaLog.Tamany(TamanyBotons[0],TamanyBotons[1]);
    BEscalaLog.ColorLletra(ColorTextnou);
    BEscalaLog.ActivarTextura(1,TexturaBotons,TamanyBotons[0],TamanyBotons[1]);    
  }  
  


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////    
///////////////////////////////////////////Mostra el menu principal//////////////////////////////////////////////////////////////////////////    
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////   
    glColor3f(1,1,1);
    if(Idioma==0)
    {
      escriure("Geometry construction",0.3*Dimensions_Menu[0],Dimensions_Menu[1]-SeparacioVora,0,Tamany_Lletra_Menu);
    }
    else if(Idioma==1)
    {
      escriure("Construccio de geometries",0.3*Dimensions_Menu[0],Dimensions_Menu[1]-SeparacioVora,0,Tamany_Lletra_Menu);
    }
    else if(Idioma==2)
    {
      escriure("Construccion de geometrias",0.3*Dimensions_Menu[0],Dimensions_Menu[1]-SeparacioVora,0,Tamany_Lletra_Menu);
    }

    if(Idioma==0)
    {
      escriure("Voxel options",0.38*Dimensions_Menu[0],Origen_Botons_Menu_Principal_Y-DistBotonsY*3,0,Tamany_Lletra_Menu);
    }
    else if(Idioma==1)
    {
      escriure("Opcions per a voxels",0.33*Dimensions_Menu[0],Origen_Botons_Menu_Principal_Y-DistBotonsY*3,0,Tamany_Lletra_Menu);
    }
    else if(Idioma==2)
    {
      escriure("Opciones para voxeles",0.33*Dimensions_Menu[0],Origen_Botons_Menu_Principal_Y-DistBotonsY*3,0,Tamany_Lletra_Menu);
    }

    if(Idioma==0)
    {
      escriure("Simulation options",0.35*Dimensions_Menu[0],Origen_Botons_Menu_Principal_Y-DistBotonsY*6,0,Tamany_Lletra_Menu);
    }
    else if(Idioma==1)
    {
      escriure("Opcions de simulacio",0.35*Dimensions_Menu[0],Origen_Botons_Menu_Principal_Y-DistBotonsY*6,0,Tamany_Lletra_Menu);
    }
    else if(Idioma==2)
    {
      escriure("Opciones de simulacion",0.35*Dimensions_Menu[0],Origen_Botons_Menu_Principal_Y-DistBotonsY*6,0,Tamany_Lletra_Menu);
    }
    
  NovaFigura.Mostra();
  SelFigura.Mostra();
  BColor.Mostra();
  BGuardar.Mostra();
  BGuardarVox.Mostra();
  ColorVoxels.Mostra();
  BCarregar.Mostra();
  BEspai.Mostra();
  BSimulacio.Mostra();
  BLlengua.Mostra();
  BResultats.Mostra();
  BDicom.Mostra();
  BTransformarGrup.Mostra();
  //Idioma
  BIdioma[0].Mostra();
  BIdioma[1].Mostra();
  BIdioma[2].Mostra();
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////    
///////////////////////////////////////////Mostra el submenu de crear figura//////////////////////////////////////////////////////////////////////////    
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  //Posicions del text del subsubmeno de crear les figures (introduccio de centre, dimensions etc)
  float Pos_Text_Centre[2]={float(0.066666*Dimensions_Menu[0]),float(0.44*Dimensions_Menu[1])};
  float Pos_Text_Dimensions[2]={float(0.0166666*Dimensions_Menu[0]),float(0.39625*Dimensions_Menu[1])};
  float Pos_Text_Prioritat[2]={float(0.066666*Dimensions_Menu[0]),float(0.3525*Dimensions_Menu[1])};
  float Pos_Text_Interns[2]={float(0.066666*Dimensions_Menu[0]),float(0.30875*Dimensions_Menu[1])};
  float Pos_Text_Material[2]={float(0.066666*Dimensions_Menu[0]),float(0.215*Dimensions_Menu[1])};
  float Pos_Text_Densitat[2]={float(0.066666*Dimensions_Menu[0]),float(0.17125*Dimensions_Menu[1])};
  float Pos_Text_Angles[2]={float(0.066666*Dimensions_Menu[0]),float(0.1275*Dimensions_Menu[1])};
  if(ControlMenu==1 && ControlSubMenu==0)
    {
      NouCub.Mostra();
      NovaEsfera.Mostra();
      NouCilindre.Mostra();
      NouPla.Mostra();
      NouSeccioEsf.Mostra();

      glColor3f(1,1,1);
      
      int NumCaracters=0;
      std::string auxLinea;      
      if(Idioma==0)
      {
	auxLinea="Body used: ";
	NumCaracters=12;
      }
      else if(Idioma==1)
      {
	auxLinea="Cos usat: ";
	NumCaracters=10;
      }
      else if(Idioma==2)
      {
	auxLinea="Cuerpo usado: ";
	NumCaracters=14;
      }
      int m=0;
      bool SaltLinea=false;
      while(m<1001)
      {
	if(PrioritatsAsignades[0][m]==0)
	{
	  break;
	}
	char auxChar[3];
	int auxNum=0;
	auxNum=sprintf(auxChar,"%i",PrioritatsAsignades[0][m]);
	if(auxNum==1)
	{
	  auxLinea+=auxChar[0];
	  auxLinea+=',';
	  NumCaracters+=2;
	}
	else if(auxNum==2)
	{
	  auxLinea+=auxChar[0];
	  auxLinea+=auxChar[1];
	  auxLinea+=',';
	  NumCaracters+=3;	  
	}
	else if(auxNum==3)
	{
	  auxLinea+=auxChar[0];
	  auxLinea+=auxChar[1];
	  auxLinea+=auxChar[2];
	  auxLinea+=',';
	  NumCaracters+=4;	  
	}
	if(NumCaracters>=70 && SaltLinea==false)
	{
	  escriure(auxLinea,0.03333*Dimensions_Menu[0],0.5*Dimensions_Menu[1],0,Tamany_Lletra_Menu);
	  auxLinea.clear();
	  SaltLinea=true;
	}
	
	m++;
      }
      if(SaltLinea==false)
	{
	  escriure(auxLinea,0.03333*Dimensions_Menu[0],0.5*Dimensions_Menu[1],0,Tamany_Lletra_Menu);
	}
      else
	{
	  escriure(auxLinea,0.03333*Dimensions_Menu[0],0.48*Dimensions_Menu[1],0,Tamany_Lletra_Menu);
	}
    }
  //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////    
  ///////////////////////////////////////////Mostra el submenu de seleccionar figura//////////////////////////////////////////////////////////////////////////    
  /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////   
  else if(ControlMenu==2)    
    {

      glColor3f(1,1,1);     
      if(Idioma==0)
	{
	  escriure("Figure number: ",0.066666*Dimensions_Menu[0],0.44*Dimensions_Menu[1],0,Tamany_Lletra_Menu);
	}
      else if(Idioma==1)
	{
	  escriure("Numero de la figura: ",0.066666*Dimensions_Menu[0],0.44*Dimensions_Menu[1],0,Tamany_Lletra_Menu);
	}
      else if(Idioma==2)
	{
	  escriure("Numero de la figura: ",0.066666*Dimensions_Menu[0],0.44*Dimensions_Menu[1],0,Tamany_Lletra_Menu); 
	}
      
      int IndexChar=0;
      while(ISelFigChar[IndexChar]!='V' && IndexChar<3)		//Mira quina posició és la primera buida (Amb una 'V')
	{
	  IndexChar++;
	}
	
      std::string AuxString;
	
      int j=0;
      while(j<IndexChar)
	{
	  AuxString+=ISelFigChar[j];
	  j++;
	}
	  
      IFiguraSelec.Escriure(AuxString,Tamany_Lletra_Quadres_Dades);      
	
      AuxString.clear();
      IFiguraSelec.Mostra();
      Crear.Mostra();
      BBorrar.Mostra();
    }
  //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////    
///////////////////////////////////////////Mostra el submenu de transformacions//////////////////////////////////////////////////////////////////////////    
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////   
    else if(ControlMenu==11)    
    {

      glColor3f(1,1,1);      
      if(Idioma==0)
      {
	escriure("Figure number: ",0.066666*Dimensions_Menu[0],0.44*Dimensions_Menu[1],0,Tamany_Lletra_Menu);
	escriure("Body number: ",0.066666*Dimensions_Menu[0],0.3975*Dimensions_Menu[1],0,Tamany_Lletra_Menu);
	escriure("Material number: ",0.066666*Dimensions_Menu[0],0.35375*Dimensions_Menu[1],0,Tamany_Lletra_Menu);
	escriure("Figures selected: ",0.066666*Dimensions_Menu[0],0.325*Dimensions_Menu[1],0,Tamany_Lletra_Menu);
      }
      else if(Idioma==1)
      {
	escriure("Numero de la figura: ",0.066666*Dimensions_Menu[0],0.44*Dimensions_Menu[1],0,Tamany_Lletra_Menu);
	escriure("Numero de cos: ",0.066666*Dimensions_Menu[0],0.3975*Dimensions_Menu[1],0,Tamany_Lletra_Menu);
	escriure("Numero de material: ",0.066666*Dimensions_Menu[0],0.35375*Dimensions_Menu[1],0,Tamany_Lletra_Menu);
	escriure("Figures seleccionades: ",0.066666*Dimensions_Menu[0],0.325*Dimensions_Menu[1],0,Tamany_Lletra_Menu);	
      }
      else if(Idioma==2)
      {
	escriure("Numero de la figura: ",0.066666*Dimensions_Menu[0],0.44*Dimensions_Menu[1],0,Tamany_Lletra_Menu); 
	escriure("Numero de cuerpo: ",0.066666*Dimensions_Menu[0],0.3975*Dimensions_Menu[1],0,Tamany_Lletra_Menu);
	escriure("Numero de material: ",0.066666*Dimensions_Menu[0],0.35375*Dimensions_Menu[1],0,Tamany_Lletra_Menu);
	escriure("Figuras seleccionadas: ",0.066666*Dimensions_Menu[0],0.325*Dimensions_Menu[1],0,Tamany_Lletra_Menu);	
      }
      int contAux=0;
      int j=0;
      std::string AuxString;
      AuxString.clear();
      int ContadorLinies=0;
      while(j<NumFiguresSeleccionades)
	{
	  if(contAux==10)
	    {
	      escriure(AuxString,0.5*Dimensions_Menu[0],0.325*Dimensions_Menu[1],0,Tamany_Lletra_Menu);
	      ContadorLinies++;
	      AuxString.clear();
	    }
	  if(contAux==28)
	    {
	      escriure(AuxString,0.066666*Dimensions_Menu[0],0.3*Dimensions_Menu[1],0,Tamany_Lletra_Menu);
	      ContadorLinies++;
	      AuxString.clear();
	    }
	  char auxChar[3];
	  int NumCaracters=sprintf(auxChar,"%d",FiguresSeleccionades[j]);
	  int i=0;
	  while(i<NumCaracters)
	    {
	      AuxString+=auxChar[i];
	      i++;
	    }
	  AuxString+=',';
	  contAux++;
	  j++;
	}
      escriure(AuxString,(ContadorLinies==0) ? 0.5*Dimensions_Menu[0] : 0.066666*Dimensions_Menu[0],(0.325-0.025*ContadorLinies)*Dimensions_Menu[1],0,Tamany_Lletra_Menu);
      AuxString.clear();
      /////Variable de la seleccio segons figura/////
      int IndexChar=0;
      while(ISelFigChar[IndexChar]!='V' && IndexChar<3)		//Mira quina posició és la primera buida (Amb una 'V')
	{
	  IndexChar++;
	}
      j=0;
      while(j<IndexChar)
	{
	  AuxString+=ISelFigChar[j];
	  j++;
	}
	
      IFiguraSelec.Escriure(AuxString,Tamany_Lletra_Quadres_Dades);      
      
      AuxString.clear();
      
      /////Variable de la seleccio segons cos/////
      IndexChar=0;
      while(ISelCosChar[IndexChar]!='V' && IndexChar<3)		//Mira quina posició és la primera buida (Amb una 'V')
	{
	  IndexChar++;
	}
	
      AuxString.clear();
	
      j=0;
      while(j<IndexChar)
	{
	  AuxString+=ISelCosChar[j];
	  j++;
	}
	
      ICosSelec.Escriure(AuxString,Tamany_Lletra_Quadres_Dades);      

      /////Variable de la seleccio segons material/////
      IndexChar=0;
      while(ISelMaterialChar[IndexChar]!='V' && IndexChar<3)		//Mira quina posició és la primera buida (Amb una 'V')
	{
	  IndexChar++;
	}
	
      AuxString.clear();
	
      j=0;
      while(j<IndexChar)
	{
	  AuxString+=ISelMaterialChar[j];
	  j++;
	}
	
      IMaterialSelec.Escriure(AuxString,Tamany_Lletra_Quadres_Dades);      
      
      IFiguraSelec.Mostra();
      ICosSelec.Mostra();
      IMaterialSelec.Mostra();
      AfegirFiguraSelec[0].Mostra();
      AfegirCosSelec[0].Mostra();
      AfegirMaterialSelec[0].Mostra();
      AfegirFiguraSelec[1].Mostra();
      AfegirCosSelec[1].Mostra();
      AfegirMaterialSelec[1].Mostra();
      
      BNetejarSeleccio.Mostra();
      Crear.Mostra();

      float Negre[3]={0,0,0};
      BTranslacio.ColorLletra(Negre);
      if(ControlSubMenu==0 || ControlSubMenu==1 || ControlSubMenu==2 || ControlSubMenu==3 || ControlSubMenu==4)
	{
	  if(ControlSubMenu==1)
	    {
	      //Marquem en verd l'opcio que hem elegit
	      float verd[3]={0,1,0};
	      BTranslacio.ColorLletra(verd);
	      
	      glColor3f(1,1,1);

	      if(Idioma==0)
		{
		  escriure("(x,y,z) Translation:",0.066666*Dimensions_Menu[0],0.1275*Dimensions_Menu[1],0,Tamany_Lletra_Menu);
		}
	      else if(Idioma==1)
		{
		  escriure("Translacio (x,y,z):",0.066666*Dimensions_Menu[0],0.1275*Dimensions_Menu[1],0,Tamany_Lletra_Menu);	
		}
	      else if(Idioma==2)
		{
		  escriure("Translacion (x,y,z):",0.066666*Dimensions_Menu[0],0.1275*Dimensions_Menu[1],0,Tamany_Lletra_Menu);
		}
	      int i=0;
	      while(i<3)
		{
		  j=0;
		  IndexChar=0;
		  while(IParametresTransformacioChar[i][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
		    {
		      IndexChar++;
		    }
	
		  AuxString.clear();
	
		  if(IndexChar<7)
		    {
		      j=0;
		      while(j<IndexChar)
			{
			  AuxString+=IParametresTransformacioChar[i][j];
			  j++;
			}
		    }else
		    {
		      j=5;
		      while(j>0)
			{
			  AuxString+=IParametresTransformacioChar[i][IndexChar-j];
			  j--;
			}
		    }
		  BParametresTransformacio[i].Escriure(AuxString,Tamany_Lletra_Quadres_Dades);
		  BParametresTransformacio[i].Mostra();
		  i++;
		}
	      

	    }
	  BTranslacio.Mostra();
	}
    }
  
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////    
///////////////////////////////////////////Mostra el submenu de seleccionar color//////////////////////////////////////////////////////////////////////////    
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////   
    else if(ControlMenu==3 && ControlSubMenu==0)
    {
      glColor3f(1,1,1);

      if(Idioma==0)
      {
	escriure("Assign the color according to the:",0.1*Dimensions_Menu[0],0.4875*Dimensions_Menu[1],0,Tamany_Lletra_Menu);
      }
      else if(Idioma==1)
      {
	escriure("Asignara el color en funcio de:",0.1*Dimensions_Menu[0],0.4875*Dimensions_Menu[1],0,Tamany_Lletra_Menu);
      }
      else if(Idioma==2)
      {
	escriure("Asignara el color en funcion de:",0.1*Dimensions_Menu[0],0.4875*Dimensions_Menu[1],0,Tamany_Lletra_Menu);
      }

      ColorObjecte.Mostra();
      ColorMaterial.Mostra();
      ColorPrioritat.Mostra();
      ColorOpacitat.Mostra();
      
    }
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////    
///////////////////////////////////////////Mostra el submenu de color voxels//////////////////////////////////////////////////////////////////////////    
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////   
    
    else if(ControlMenu==3 && ControlSubMenu==1)
      {
	float Origen_Botons_Y=0.44375*Dimensions_Menu[1];
	Crear.Mostra();					//Mostra el boto de fet
	glColor3f(1,1,1);

	if(Idioma==0)
	  {
	    escriure("Cutting planes (cm)",0.38333*Dimensions_Menu[0],Origen_Botons_Y-5*DistBotonsY,0,Tamany_Lletra_Menu);
	  }
	else if(Idioma==1)
	  {
	    escriure("Plans de tall (cm)",0.38333*Dimensions_Menu[0],Origen_Botons_Y-5*DistBotonsY,0,Tamany_Lletra_Menu);
	  }
	else if(Idioma==2)
	  {
	    escriure("Planos de corte (cm)",0.38333*Dimensions_Menu[0],Origen_Botons_Y-5*DistBotonsY,0,Tamany_Lletra_Menu);
	  }	
	
	escriure("X = ",0.13333*Dimensions_Menu[0],Origen_Botons_Y-6*DistBotonsY+DistBotonsY*0.5-TamanyBotons[1]/6.0,0,Tamany_Lletra_Menu);

	escriure("Y = ",0.366666*Dimensions_Menu[0],Origen_Botons_Y-6*DistBotonsY+DistBotonsY*0.5-TamanyBotons[1]/6.0,0,Tamany_Lletra_Menu);

	escriure("Z = ",0.6*Dimensions_Menu[0],Origen_Botons_Y-6*DistBotonsY+DistBotonsY*0.5-TamanyBotons[1]/6.0,0,Tamany_Lletra_Menu);
	
	int IndexChar=0;
	int i=0;
	while(i<3)
	  {
	    int j=0;
	    IndexChar=0;
	    while(IPlansTallChar[i][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
	      {
		IndexChar++;
	      }
	  
	    std::string AuxString;
	  
	    if(IndexChar<7)
	      {
		j=0;
		while(j<IndexChar)
		  {
		    AuxString+=IPlansTallChar[i][j];
		    j++;
		  }
	      }else
	      {
		j=5;
		while(j>0)
		  {
		    AuxString+=IPlansTallChar[i][IndexChar-j];
		    j--;
		  }
	      }
	    CVoxPla[i].Escriure(AuxString,Tamany_Lletra_Quadres_Dades);
	    i++;
	  }
	
	
	
	CVoxPunts.Mostra();
	CVoxQuad.Mostra();
	//	BMallat.Mostra();
	CVoxPla[0].Mostra();
	CVoxPla[1].Mostra();
	CVoxPla[2].Mostra();  
      }

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////    
///////////////////////////////////////////Mostra el submenu de guardar//////////////////////////////////////////////////////////////////////////    
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////   
     else if(ControlMenu==4)
     {
       BGuardarGeo.Mostra();
       BGuardarPenelope.Mostra();
       BGuardarGeant4.Mostra();
     }
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////    
///////////////////////////////////////////Mostra el submenu de guardar voxels//////////////////////////////////////////////////////////////////////////    
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////   
     else if(ControlMenu==8)
     {
       BGuardarVoxelsPene.Mostra();
     }

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////    
///////////////////////////////////////////Mostra el submenu de canviar l'espai//////////////////////////////////////////////////////////////////////////    
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////   
      
    else if(ControlMenu==6)
    {
      ///////////////////////////////////////////////////////////////////////////////////////////
      ////////////////////////////////NumVoxels//////////////////////////////////////////////////
      ///////////////////////////////////////////////////////////////////////////////////////////
      int IndexChar=0;
      glColor3f(1,1,1);
      char AuxCharNVox[200];
      int NumCharAuxNVox;
      NumCharAuxNVox=sprintf(AuxCharNVox,"Nº Voxels: (%i,%i,%i)",NumVoxels[0],NumVoxels[1],NumVoxels[2]);
      
      std::string AuxString;
      int i=0;
      while(i<NumCharAuxNVox)
      {
	AuxString+=AuxCharNVox[i];
	i++;
      }
      escriure(AuxString,0.03333*Dimensions_Menu[0],0.3625*Dimensions_Menu[1],0,Tamany_Lletra_Menu);

      NumCharAuxNVox=sprintf(AuxCharNVox,"Voxel Dimensions: %.2fx%.2fx%.2f cm",DimVoxels[0],DimVoxels[1],DimVoxels[2]);

      AuxString.clear();
      i=0;
      while(i<NumCharAuxNVox)
      {
	AuxString+=AuxCharNVox[i];
	i++;
      }
      escriure(AuxString,0.03333*Dimensions_Menu[0],0.3375*Dimensions_Menu[1],0,Tamany_Lletra_Menu);
      
      NumCharAuxNVox=sprintf(AuxCharNVox,"Dimensions: %.2fx%.2fx%.2f cm",DimEspai[0],DimEspai[1],DimEspai[2]);

      AuxString.clear();
      i=0;
      while(i<NumCharAuxNVox)
      {
	AuxString+=AuxCharNVox[i];
	i++;
      }
      escriure(AuxString,0.03333*Dimensions_Menu[0],0.3125*Dimensions_Menu[1],0,Tamany_Lletra_Menu);

      glColor3f(1,1,1);
      escriure("Nº Voxels:(",0.0666666*Dimensions_Menu[0],0.44*Dimensions_Menu[1],0,Tamany_Lletra_Menu);
      
      glColor3f(1,1,1);
      escriure(",",0.38333*Dimensions_Menu[0],0.44*Dimensions_Menu[1],0,Tamany_Lletra_Menu);

      glColor3f(1,1,1);
      escriure(",",0.55*Dimensions_Menu[0],0.44*Dimensions_Menu[1],0,Tamany_Lletra_Menu);

      glColor3f(1,1,1);
      escriure(")",0.72*Dimensions_Menu[0],0.44*Dimensions_Menu[1],0,Tamany_Lletra_Menu);
      i=0;
      while(i<3)
      {
	int j=0;
	IndexChar=0;
	while(INumVoxChar[i][IndexChar]!='V' && IndexChar<3)		//Mira quina posició és la primera buida (Amb una 'V')
	{
	  IndexChar++;
	}
	
	AuxString.clear();
	
	  j=0;
	  while(j<IndexChar)
	  {
	    AuxString+=INumVoxChar[i][j];
	    j++;
	  }

	 BNumVox[i].Escriure(AuxString,Tamany_Lletra_Quadres_Dades);
	i++;
      }
      
      BNumVox[0].Mostra();
      BNumVox[1].Mostra();
      BNumVox[2].Mostra();
      glColor3f(1,1,1);      
      
      ///////////////////////////////////////////////////////////////////////////////////////////
      ////////////////////////////////Dimensions/////////////////////////////////////////////////
      ///////////////////////////////////////////////////////////////////////////////////////////
      glColor3f(1,1,1);

      if(Idioma==0)
      {
	escriure("Dimensions:(",0.01666*Dimensions_Menu[0],0.39625*Dimensions_Menu[1],0,Tamany_Lletra_Menu);
      }
      else if(Idioma==1)
      {
	escriure("Dimensions:(",0.01666*Dimensions_Menu[0],0.39625*Dimensions_Menu[1],0,Tamany_Lletra_Menu);
      }
      else if(Idioma==2)
      {
	escriure("Dimensiones: (",0.01666*Dimensions_Menu[0],0.39625*Dimensions_Menu[1],0,Tamany_Lletra_Menu);
      }	
      
      glColor3f(1,1,1);
      escriure(",",0.383333*Dimensions_Menu[0],0.39625*Dimensions_Menu[1],0,Tamany_Lletra_Menu);

      glColor3f(1,1,1);
      escriure(",",0.55*Dimensions_Menu[0],0.39625*Dimensions_Menu[1],0,Tamany_Lletra_Menu);

      glColor3f(1,1,1);
      escriure(") (cm)",0.72*Dimensions_Menu[0],0.39625*Dimensions_Menu[1],0,Tamany_Lletra_Menu);
      i=0;
      while(i<3)
      {
	int j=0;
	IndexChar=0;
	while(IDimVoxChar[i][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
	{
	  IndexChar++;
	}
	
	std::string AuxString;
	
	if(IndexChar<7)
	{
	  j=0;
	  while(j<IndexChar)
	  {
	    AuxString+=IDimVoxChar[i][j];
	    j++;
	  }
	}else
	{
	  j=5;
	  while(j>0)
	  {
	    AuxString+=IDimVoxChar[i][IndexChar-j];
	    j--;
	  }
	}
	BDimVox[i].Escriure(AuxString,Tamany_Lletra_Quadres_Dades);
	i++;
      }
      
      BDimVox[0].Mostra();
      BDimVox[1].Mostra();
      BDimVox[2].Mostra();      
      glColor3f(1,1,1);      
      
      ///////////////////////////////////////////////////////////////////////////////////////////
      ////////////////////////////////Guardar/////////////////////////////////////////////////
      ///////////////////////////////////////////////////////////////////////////////////////////
      Crear.Mostra();
    }

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////    
///////////////////////////////////////////Mostra el submenu de la simulacio//////////////////////////////////////////////////////////////////////////    
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////   
     else if(ControlMenu==7)
     {
      std::string AuxString;
       AuxString.clear();
      //Escrivim el nom de la simulació al quadre d'introduir-lo
      int IndexChar=0;
      while(INomSimulacio[IndexChar]!='\0' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una '\0')
      {
	IndexChar++;
      }
      
      int i=0;
      if(IndexChar<33)
      {
	while(i<IndexChar)
	{
	  AuxString+=INomSimulacio[i];
	  i++;
	}
      }else
      {
	i=33;
	while(i>0)
	{
	  AuxString+=INomSimulacio[IndexChar-i];
	  i--;
	} 
      }
      
      BNomSimulacio.Escriure(AuxString,Tamany_Lletra_Quadres_Dades);      
      AuxString.clear();       
      
      //Escrivim el nom de l'arxiu de configuració al quadre d'introduir-lo
      IndexChar=0;
      while(INomArxiuConfig[IndexChar]!='\0' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una '\0')
      {
	IndexChar++;
      }    
      
      i=0;
      if(IndexChar<33)
      {
	while(i<IndexChar)
	{
	  AuxString+=INomArxiuConfig[i];
	  i++;
	}
      }else
      {
	i=33;
	while(i>0)
	{
	  AuxString+=INomArxiuConfig[IndexChar-i];
	  i--;
	} 
      }
      
      BNomArxiuConfig.Escriure(AuxString,Tamany_Lletra_Quadres_Dades);
      AuxString.clear();       

      //Escrivim el nom de l'arxiu de geometria (Quadrigues) al quadre d'introduir-lo
      IndexChar=0;
      while(INomArxiuGeoQuad[IndexChar]!='\0' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una '\0')
      {
	IndexChar++;
      }    
      
      i=0;
      if(IndexChar<33)
      {
	while(i<IndexChar)
	{
	  AuxString+=INomArxiuGeoQuad[i];
	  i++;
	}
      }else
      {
	i=33;
	while(i>0)
	{
	  AuxString+=INomArxiuGeoQuad[IndexChar-i];
	  i--;
	} 
      }
      
      BNomArxiuGeoQuad.Escriure(AuxString,Tamany_Lletra_Quadres_Dades);
      AuxString.clear();       

      //Escrivim el nom de l'arxiu de voxelitzat al quadre d'introduir-lo
      IndexChar=0;
      while(INomArxiuGeoVox[IndexChar]!='\0' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una '\0')
      {
	IndexChar++;
      }    
      
      i=0;
      if(IndexChar<33)
      {
	while(i<IndexChar)
	{
	  AuxString+=INomArxiuGeoVox[i];
	  i++;
	}
      }else
      {
	i=33;
	while(i>0)
	{
	  AuxString+=INomArxiuGeoVox[IndexChar-i];
	  i--;
	} 
      }
      
      BNomArxiuGeoVox.Escriure(AuxString,Tamany_Lletra_Quadres_Dades);
      AuxString.clear();       

      //Escrivim el numero de simulacions///////////////////////////////////
      IndexChar=0;
      if(INumSimulacions[0]!='V')
      {
	AuxString=INumSimulacions[0];
	if(INumSimulacions[1]!='V')
	{
	  AuxString+=INumSimulacions[1];
	}
      }
      else
      {
	AuxString=' ';
      }
      
      BNumSimulacions.Escriure(AuxString,Tamany_Lletra_Quadres_Dades);
      AuxString.clear();       

      //Escrivim el nom de l'arxiu de materials al quadre d'introduir-lo
/*      IndexChar=0;
      while(INomArxiuMaterials[IndexChar]!='\0' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una '\0')
      {
	IndexChar++;
      }    
      std::string AuxString;
      
      i=0;
      if(IndexChar<33)
      {
	while(i<IndexChar)
	{
	  AuxString+=INomArxiuMaterials[i];
	  i++;
	}
      }else
      {
	i=33;
	while(i>0)
	{
	  AuxString+=INomArxiuMaterials[IndexChar-i];
	  i--;
	} 
      }
      
      BNomArxiuMaterials.Escriure(AuxString,Tamany_Lletra_Quadres_Dades);
      AuxString.clear();       
*/      
       
      BNomSimulacio.Mostra();
      BNomArxiuConfig.Mostra();
      BNomArxiuGeoQuad.Mostra();
      BNomArxiuGeoVox.Mostra();
      BNumSimulacions.Mostra();
      float Origen_Botons_X=0.033333*Dimensions_Menu[0];
      float Origen_Botons_Y=0.45*Dimensions_Menu[1];
      if(Idioma==0)
      {
	glColor3f(1,1,1);
	escriure("Name of the simulation:",Origen_Botons_X,(1+0.01875)*Origen_Botons_Y,0,Tamany_Lletra_Menu);
	glColor3f(1,1,1);
	escriure("Name of the configuration file:",Origen_Botons_X,(1+0.01875)*Origen_Botons_Y-DistBotonsY*1,0,Tamany_Lletra_Menu);	
	glColor3f(1,1,1);
	escriure("Filename geometry (Quadrics):",Origen_Botons_X,(1+0.01875)*Origen_Botons_Y-DistBotonsY*2,0,Tamany_Lletra_Menu);       
	glColor3f(1,1,1);
	escriure("Filename of voxels:",Origen_Botons_X,(1+0.01875)*Origen_Botons_Y-DistBotonsY*3,0,Tamany_Lletra_Menu);       	
	glColor3f(1,1,1);
	escriure("Number of simultaneous simulations",Origen_Botons_X,(1+0.01875)*Origen_Botons_Y-DistBotonsY*4,0,Tamany_Lletra_Menu);       
      }
      else if(Idioma==1)
      {
	glColor3f(1,1,1);
	escriure("Nom de la simulacio:",Origen_Botons_X,(1+0.01875)*Origen_Botons_Y,0,Tamany_Lletra_Menu);
	glColor3f(1,1,1);
	escriure("Nom de l'arxiu de configuracio:",Origen_Botons_X,(1+0.01875)*Origen_Botons_Y-DistBotonsY*1,0,Tamany_Lletra_Menu);
	glColor3f(1,1,1);
	escriure("Nom de l'arxiu de geometria (Quadriques):",Origen_Botons_X,(1+0.01875)*Origen_Botons_Y-DistBotonsY*2,0,Tamany_Lletra_Menu);       	
	glColor3f(1,1,1);
	escriure("Nom de l'arxiu de voxelitzat:",Origen_Botons_X,(1+0.01875)*Origen_Botons_Y-DistBotonsY*3,0,Tamany_Lletra_Menu);       	
	glColor3f(1,1,1);
	escriure("Nombre de simulacions simultanies",Origen_Botons_X,(1+0.01875)*Origen_Botons_Y-DistBotonsY*4,0,Tamany_Lletra_Menu);       	
      }
      else if(Idioma==2)
      {
	glColor3f(1,1,1);
	escriure("Nombre de la simulacion:",Origen_Botons_X,(1+0.01875)*Origen_Botons_Y,0,Tamany_Lletra_Menu);
	glColor3f(1,1,1);
	escriure("Nombre del archivo de configuracion:",Origen_Botons_X,(1+0.01875)*Origen_Botons_Y-DistBotonsY*1,0,Tamany_Lletra_Menu);
	glColor3f(1,1,1);
	escriure("Nombre del archivo de geometria (cuadricas):",Origen_Botons_X,(1+0.01875)*Origen_Botons_Y-DistBotonsY*2,0,Tamany_Lletra_Menu);
	glColor3f(1,1,1);
	escriure("Nombre del archivo de voxelizado:",Origen_Botons_X,(1+0.01875)*Origen_Botons_Y-DistBotonsY*3,0,Tamany_Lletra_Menu);       
	glColor3f(1,1,1);
	escriure("Numero de simulaciones simultaneas",Origen_Botons_X,(1+0.01875)*Origen_Botons_Y-DistBotonsY*4,0,Tamany_Lletra_Menu);       
      }	

         
    /////////////////////////////////Boto Crear/////////////////////////////////////////////////////////
      Crear.Mostra();       

    }
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////    
///////////////////////////////////////////Mostra el submenu del visor de resultats//////////////////////////////////////////////////////////////////////////    
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////   
     else if(ControlMenu==9)
     {
       if(ControlSubMenu==0)
	 {
	   float Origen_Botons_X=0.033333*Dimensions_Menu[0];
	   float Origen_Botons_Y=0.44375*Dimensions_Menu[1];

	   std::string AuxString;
	   AuxString.clear();
	   //Escrivim el nom de la simulació al quadre d'introduir-lo
	   int IndexChar=0;
	   while(INomSimulacio[IndexChar]!='\0' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una '\0')
	     {
	       IndexChar++;
	     }
	
	   int i=0;
	   if(IndexChar<33)
	     {
	       while(i<IndexChar)
		 {
		   AuxString+=INomSimulacio[i];
		   i++;
		 }
	     }else
	     {
	       i=33;
	       while(i>0)
		 {
		   AuxString+=INomSimulacio[IndexChar-i];
		   i--;
		 } 
	     }
	
	   BNomSimulacio.Escriure(AuxString,Tamany_Lletra_Quadres_Dades);      
	   AuxString.clear();  
	
	   if(Idioma==0)
	     {
	       glColor3f(1,1,1);
	       escriure("Name of the simulation:",Origen_Botons_X,(1+0.01875)*Origen_Botons_Y,0,Tamany_Lletra_Menu);
	     }
	   else if(Idioma==1)
	     {
	       glColor3f(1,1,1);
	       escriure("Nom de la simulacio:",Origen_Botons_X,(1+0.01875)*Origen_Botons_Y,0,Tamany_Lletra_Menu);
	     }
	   else if(Idioma==2)
	     {
	       glColor3f(1,1,1);
	       escriure("Nombre de la simulacion:",Origen_Botons_X,(1+0.01875)*Origen_Botons_Y,0,Tamany_Lletra_Menu);
	     }	
      
	   BNomSimulacio.Mostra();

	   /////////////////////////////////Boto Crear/////////////////////////////////////////////////////////
	   Crear.Mostra();
	 }
       else if(ControlSubMenu==1)
	 {
	   float Origen_Botons_Y=float(0.44375*Dimensions_Menu[1]);

	   Crear.Mostra();					//Mostra el boto de fet
	   ////////////Boto escala log/////////
	   glColor3f(1,1,1);

	   if(Idioma==0)
	     {
	       escriure("Apply logarithm",0.3*Dimensions_Menu[0],0.31875*Dimensions_Menu[1],0,Tamany_Lletra_Menu);
	     }
	   else if(Idioma==1)
	     {
	       escriure("Aplicar logaritmes",0.3*Dimensions_Menu[0],0.31875*Dimensions_Menu[1],0,Tamany_Lletra_Menu);
	     }
	   else if(Idioma==2)
	     {
	       escriure("Aplicar logaritmos",0.3*Dimensions_Menu[0],0.31875*Dimensions_Menu[1],0,Tamany_Lletra_Menu);
	     }	

	   if(EscalaLog==false)
	     {
	       BEscalaLog.Escriure("OFF",Tamany_Lletra_Botons_Menu);
	     }
	   else if(EscalaLog==true)
	     {
	       BEscalaLog.Escriure("ON",Tamany_Lletra_Botons_Menu);
	     }
	   BEscalaLog.Mostra();
	
	   ////////////Plans de tall///////////
	   glColor3f(1,1,1);
	   if(Idioma==0)
	     {
	       escriure("Cutting planes (cm)",0.3666*Dimensions_Menu[0],Origen_Botons_Y-5*DistBotonsY,0,Tamany_Lletra_Menu);
	     }
	   else if(Idioma==1)
	     {
	       escriure("Plans de tall (cm)",0.3666*Dimensions_Menu[0],Origen_Botons_Y-5*DistBotonsY,0,Tamany_Lletra_Menu);
	     }
	   else if(Idioma==2)
	     {
	       escriure("Planos de corte (cm)",0.3666*Dimensions_Menu[0],Origen_Botons_Y-5*DistBotonsY,0,Tamany_Lletra_Menu);
	     }	
	
	   escriure("X = ",0.13333*Dimensions_Menu[0],Origen_Botons_Y-6*DistBotonsY+DistBotonsY*0.5-TamanyBotons[1]/6.0,0,Tamany_Lletra_Menu);

	   escriure("Y = ",0.3666*Dimensions_Menu[0],Origen_Botons_Y-6*DistBotonsY+DistBotonsY*0.5-TamanyBotons[1]/6.0,0,Tamany_Lletra_Menu);

	   escriure("Z = ",0.6*Dimensions_Menu[0],Origen_Botons_Y-6*DistBotonsY+DistBotonsY*0.5-TamanyBotons[1]/6.0,0,Tamany_Lletra_Menu);

	   int IndexChar=0;
	   int i=0;
	   while(i<3)
	     {
	       int j=0;
	       IndexChar=0;
	       while(IPlansTallChar[i][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
		 {
		   IndexChar++;
		 }
	  
	       std::string AuxString;
	  
	       if(IndexChar<7)
		 {
		   j=0;
		   while(j<IndexChar)
		     {
		       AuxString+=IPlansTallChar[i][j];
		       j++;
		     }
		 }else
		 {
		   j=5;
		   while(j>0)
		     {
		       AuxString+=IPlansTallChar[i][IndexChar-j];
		       j--;
		     }
		 }
	       CVoxPla[i].Escriure(AuxString,Tamany_Lletra_Quadres_Dades);
	       i++;
	     }

	   //////////Dosis minima i màxima//////////
	   glColor3f(1,1,1);
	
	   char DosisMaximaResultatsChar[20];
	   IndexChar=0;
	   IndexChar=sprintf(DosisMaximaResultatsChar,"%.5E eV/g",DosisMaximaResultats);
	
	   glColor3f(1,1,1);
	   if(Idioma==0)
	     {
	       escriure("Dose limits (eV/g)",0.333333*Dimensions_Menu[0],Origen_Botons_Y,0,Tamany_Lletra_Menu);
	     }
	   else if(Idioma==1)
	     {
	       escriure("Limits de dosis (eV/g)",0.333333*Dimensions_Menu[0],Origen_Botons_Y,0,Tamany_Lletra_Menu);
	     }
	   else if(Idioma==2)
	     {
	       escriure("Limites de dosis (eV/g)",0.333333*Dimensions_Menu[0],Origen_Botons_Y,0,Tamany_Lletra_Menu);
	     }


	   std::string AuxString;
	   if(Idioma==0)
	     {
	       AuxString="Maximum dose in a voxel: ";
	     }
	   else if(Idioma==1)
	     {
	       AuxString="Dosis maxima en un voxel: ";
	     }
	   else if(Idioma==2)
	     {
	       AuxString="Dosis maxima en un voxel: ";
	     }

	   int j=0;
	   while(j<IndexChar)
	     {
	       AuxString+=DosisMaximaResultatsChar[j];
	       j++;
	     }
	   
	   escriure(AuxString,0.133333*Dimensions_Menu[0],0.3625*Dimensions_Menu[1],0,Tamany_Lletra_Menu);
      
	   glColor3f(1,1,1);
	   escriure("Min: ",0.116666*Dimensions_Menu[0],0.39625*Dimensions_Menu[1],0,Tamany_Lletra_Menu);
      
	   glColor3f(1,1,1);
	   escriure(" Max: ",0.416666*Dimensions_Menu[0],0.39625*Dimensions_Menu[1],0,Tamany_Lletra_Menu);

	   AuxString.clear();
	   IndexChar=0;
	   ///////////////Text del quadre dosis mínima/////////////////////////
	   j=0;
	   IndexChar=0;
	   while(IMinDosisChar[IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
	     {
	       IndexChar++;
	     }
	
	   AuxString.clear();
	
	   if(IndexChar<7)
	     {
	       j=0;
	       while(j<IndexChar)
		 {
		   AuxString+=IMinDosisChar[j];
		   j++;
		 }
	     }else
	     {
	       j=5;
	       while(j>0)
		 {
		   AuxString+=IMinDosisChar[IndexChar-j];
		   j--;
		 }
	     }
	   BDosiMin.Escriure(AuxString,Tamany_Lletra_Quadres_Dades);
      
	   ///////////////////Text del quadre dosis màxima///////////////////
	   j=0;
	   IndexChar=0;
	   while(IMaxDosisChar[IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
	     {
	       IndexChar++;
	     }
	
	   AuxString.clear();
	
	   if(IndexChar<7)
	     {
	       j=0;
	       while(j<IndexChar)
		 {
		   AuxString+=IMaxDosisChar[j];
		   j++;
		 }
	     }else
	     {
	       j=5;
	       while(j>0)
		 {
		   AuxString+=IMaxDosisChar[IndexChar-j];
		   j--;
		 }
	     }
	   BDosiMax.Escriure(AuxString,Tamany_Lletra_Quadres_Dades);

	
	   BDosiMin.Mostra();
	   BDosiMax.Mostra();      
	   glColor3f(1,1,1);      

	
	   CVoxPunts.Mostra();
	   CVoxQuad.Mostra();
	   CVoxPla[0].Mostra();
	   CVoxPla[1].Mostra();
	   CVoxPla[2].Mostra();  
	
	
            
      
	 }      

     }
/////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////Submenu del carregador de DICOM//////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////     
     else if(ControlMenu==10)
     {
       if(ControlSubMenu==0)
	 {
	   float Origen_Botons_X=0.033333*Dimensions_Menu[0];
	   float Origen_Botons_Y=0.44375*Dimensions_Menu[1];
	   
	   std::string AuxString;
	   AuxString.clear();
	   //Escrivim el nom de la carpeta amb el dicom al quadre d'introduir-lo
	   int IndexChar=0;
	   while(INomDicom[IndexChar]!='\0' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una '\0')
	     {
	       IndexChar++;
	     }
	
	   int i=0;
	   if(IndexChar<33)
	     {
	       while(i<IndexChar)
		 {
		   AuxString+=INomDicom[i];
		   i++;
		 }
	     }else
	     {
	       i=33;
	       while(i>0)
		 {
		   AuxString+=INomDicom[IndexChar-i];
		   i--;
		 } 
	     }
	
	   BNomSimulacio.Escriure(AuxString,Tamany_Lletra_Quadres_Dades);      
	   AuxString.clear();  
	
	   if(Idioma==0)
	     {
	       glColor3f(1,1,1);
	       escriure("DICOM folder:",Origen_Botons_X,(1+0.03)*Origen_Botons_Y,0,Tamany_Lletra_Menu);
	     }
	   else if(Idioma==1)
	     {
	       glColor3f(1,1,1);
	       escriure("Arxiu amb el DICOM:",Origen_Botons_X,(1+0.03)*Origen_Botons_Y,0,Tamany_Lletra_Menu);
	     }
	   else if(Idioma==2)
	     {
	       glColor3f(1,1,1);
	       escriure("Archivo con el DICOM:",Origen_Botons_X,(1+0.03)*Origen_Botons_Y,0,Tamany_Lletra_Menu);
	     }	
      
	   BNomSimulacio.Mostra();

	   /////////////////////////////////Boto Crear/////////////////////////////////////////////////////////
	   Crear.Mostra();
	 }
       else if(ControlSubMenu==1)
	 {
	   float Origen_Botons_Y=float(0.44375*Dimensions_Menu[1]);
	   //Mostrem el boto de guardar voxels penelope
	   BGuardarVoxelsPene.Mostra();
	   //Mostrem els botons per a canviar entre representar materials i densitat
	   BPintMatDCM.Mostra();
	   BPintDensDCM.Mostra();
	   BContornsDICOM.Mostra();
	   
	   if(ActivarVisor2D==true)
	     {
	       BDicom2D.Escriure(" 3D",Tamany_Lletra_Botons_Menu);
	     }
	   else
	     {
	       BDicom2D.Escriure(" 2D",Tamany_Lletra_Botons_Menu);
	     }
	
	   BDicom2D.Mostra();
	   //Mostrem el boto de fet
	   Crear.Mostra();					//Mostra el boto de fet
	   if(Idioma==0)
	     {
	       Tallar.Escriure(" Cut",Tamany_Lletra_Botons_Menu);
	     }
	   else if(Idioma==1)
	     {
	       Tallar.Escriure(" Tallar",Tamany_Lletra_Botons_Menu);
	     }
	   else if(Idioma==2)
	     {
	       Tallar.Escriure(" Cortar",Tamany_Lletra_Botons_Menu);
	     }		
	   Tallar.Mostra();
	   ////////////Plans de tall superior///////////
	   glColor3f(1,1,1);
	   if(Idioma==0)
	     {
	       escriure("Superior cutting planes (cm)",0.3*Dimensions_Menu[0],Origen_Botons_Y-5*DistBotonsY,0,Tamany_Lletra_Menu);
	     }
	   else if(Idioma==1)
	     {
	       escriure("Plans de tall superiors(cm)",0.3*Dimensions_Menu[0],Origen_Botons_Y-5*DistBotonsY,0,Tamany_Lletra_Menu);
	     }
	   else if(Idioma==2)
	     {
	       escriure("Planos de corte superiores(cm)",0.3*Dimensions_Menu[0],Origen_Botons_Y-5*DistBotonsY,0,Tamany_Lletra_Menu);
	     }	
	
	   escriure("X = ",0.133333*Dimensions_Menu[0],Origen_Botons_Y-6*DistBotonsY+DistBotonsY*0.5-TamanyBotons[1]/6.0,0,Tamany_Lletra_Menu);

	   escriure("Y = ",0.36666*Dimensions_Menu[0],Origen_Botons_Y-6*DistBotonsY+DistBotonsY*0.5-TamanyBotons[1]/6.0,0,Tamany_Lletra_Menu);

	   escriure("Z = ",0.6*Dimensions_Menu[0],Origen_Botons_Y-6*DistBotonsY+DistBotonsY*0.5-TamanyBotons[1]/6.0,0,Tamany_Lletra_Menu);

	
	   int IndexChar=0;
	   int i=0;
	   while(i<3)
	     {
	       int j=0;
	       IndexChar=0;
	       while(IPlansTallChar[i][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
		 {
		   IndexChar++;
		 }
	  
	       std::string AuxString;
	  
	       if(IndexChar<7)
		 {
		   j=0;
		   while(j<IndexChar)
		     {
		       AuxString+=IPlansTallChar[i][j];
		       j++;
		     }
		 }else
		 {
		   j=5;
		   while(j>0)
		     {
		       AuxString+=IPlansTallChar[i][IndexChar-j];
		       j--;
		     }
		 }
	       CVoxPla[i].Escriure(AuxString,Tamany_Lletra_Quadres_Dades);
	       i++;
	     }

	   ////////////Plans de tall inferior///////////
	   glColor3f(1,1,1);
	   if(Idioma==0)
	     {
	       escriure("Lower cutting planes (cm)",0.3*Dimensions_Menu[0],Origen_Botons_Y-6*DistBotonsY+DistBotonsY*0.15-DistBotonsY*0.5,0,Tamany_Lletra_Menu);
	     }
	   else if(Idioma==1)
	     {
	       escriure("Plans de tall inferiors(cm)",0.3*Dimensions_Menu[0],Origen_Botons_Y-6*DistBotonsY+DistBotonsY*0.15-DistBotonsY*0.5,0,Tamany_Lletra_Menu);
	     }
	   else if(Idioma==2)
	     {
	       escriure("Planos de corte inferiores(cm)",0.3*Dimensions_Menu[0],Origen_Botons_Y-6*DistBotonsY+DistBotonsY*0.15-DistBotonsY*0.5,0,Tamany_Lletra_Menu);
	     }	
	
	   escriure("X = ",0.133333*Dimensions_Menu[0],Origen_Botons_Y-7*DistBotonsY-TamanyBotons[1]/6.0,0,Tamany_Lletra_Menu);

	   escriure("Y = ",0.366666*Dimensions_Menu[0],Origen_Botons_Y-7*DistBotonsY-TamanyBotons[1]/6.0,0,Tamany_Lletra_Menu);

	   escriure("Z = ",0.6*Dimensions_Menu[0],Origen_Botons_Y-7*DistBotonsY-TamanyBotons[1]/6.0,0,Tamany_Lletra_Menu);

	
	   IndexChar=0;
	   i=0;
	   while(i<3)
	     {
	       int j=0;
	       IndexChar=0;
	       while(IPlansTallCharInf[i][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
		 {
		   IndexChar++;
		 }
	  
	       std::string AuxString;
	  
	       if(IndexChar<7)
		 {
		   j=0;
		   while(j<IndexChar)
		     {
		       AuxString+=IPlansTallCharInf[i][j];
		       j++;
		     }
		 }else
		 {
		   j=5;
		   while(j>0)
		     {
		       AuxString+=IPlansTallCharInf[i][IndexChar-j];
		       j--;
		     }
		 }
	       CVoxPlaInf[i].Escriure(AuxString,Tamany_Lletra_Quadres_Dades);
	       i++;
	     }
	 
	   glColor3f(1,1,1);      

	
	   CVoxPunts.Mostra();
	   CVoxQuad.Mostra();
	   CVoxPla[0].Mostra();
	   CVoxPla[1].Mostra();
	   CVoxPla[2].Mostra();  
	   CVoxPlaInf[0].Mostra();
	   CVoxPlaInf[1].Mostra();
	   CVoxPlaInf[2].Mostra();  
	
       
       
	 }
       
     }    
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////    
///////////////////////////////////////////Mostra el subsubmenu de nou cub//////////////////////////////////////////////////////////////////////////    
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////   
    else if(ControlMenu==1 && ControlSubMenu==1)
    {
      ///////////////////////////////////////////////////////////////////////////////////////////
      ////////////////////////////////Centre/////////////////////////////////////////////////////
      ///////////////////////////////////////////////////////////////////////////////////////////
      
      int IndexChar=0;
      glColor3f(1,1,1);
      if(Idioma==0)
      {
	escriure("Center: (",Pos_Text_Centre[0],Pos_Text_Centre[1],0,Tamany_Lletra_Menu);	
      }
      else if(Idioma==1)
      {
	escriure("Centre: (",Pos_Text_Centre[0],Pos_Text_Centre[1],0,Tamany_Lletra_Menu);
      }
      else if(Idioma==2)
      {
	escriure("Centro: (",Pos_Text_Centre[0],Pos_Text_Centre[1],0,Tamany_Lletra_Menu);
      }	
            
      glColor3f(1,1,1);
      escriure(",",0.38333*Dimensions_Menu[0],Pos_Text_Centre[1],0,Tamany_Lletra_Menu);

      glColor3f(1,1,1);
      escriure(",",0.55*Dimensions_Menu[0],Pos_Text_Centre[1],0,Tamany_Lletra_Menu);

      glColor3f(1,1,1);
      escriure(") (cm)",0.72*Dimensions_Menu[0],Pos_Text_Centre[1],0,Tamany_Lletra_Menu);
      int i=0;
      while(i<3)
      {
	int j=0;
	IndexChar=0;
	while(ICentreCubChar[i][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
	{
	  IndexChar++;
	}
	
	std::string AuxString;
	
	if(IndexChar<7)
	{
	  j=0;
	  while(j<IndexChar)
	  {
	    AuxString+=ICentreCubChar[i][j];
	    j++;
	  }
	}else
	{
	  j=5;
	  while(j>0)
	  {
	    AuxString+=ICentreCubChar[i][IndexChar-j];
	    j--;
	  }
	}
	Centre[i].Escriure(AuxString,Tamany_Lletra_Quadres_Dades);
	i++;
      }
      
      Centre[0].Mostra();
      Centre[1].Mostra();
      Centre[2].Mostra();
      glColor3f(1,1,1);
      ///////////////////////////////////////////////////////////////////////////////////////////
      ////////////////////////////////Dimensions/////////////////////////////////////////////////
      ///////////////////////////////////////////////////////////////////////////////////////////

      glColor3f(1,1,1);
      if(Idioma==0)
      {
	escriure("Dimensions: (",Pos_Text_Dimensions[0],Pos_Text_Dimensions[1],0,Tamany_Lletra_Menu);
      }
      else if(Idioma==1)
      {
	escriure("Dimensions: (",Pos_Text_Dimensions[0],Pos_Text_Dimensions[1],0,Tamany_Lletra_Menu);	
      }
      else if(Idioma==2)
      {
	escriure("Dimensiones: (",Pos_Text_Dimensions[0],Pos_Text_Dimensions[1],0,Tamany_Lletra_Menu);
      }	
      
      glColor3f(1,1,1);
      escriure(",",0.38333*Dimensions_Menu[0],Pos_Text_Dimensions[1],0,Tamany_Lletra_Menu);

      glColor3f(1,1,1);
      escriure(",",0.55*Dimensions_Menu[0],Pos_Text_Dimensions[1],0,Tamany_Lletra_Menu);

      glColor3f(1,1,1);
      escriure(") (cm)",0.72*Dimensions_Menu[0],Pos_Text_Dimensions[1],0,Tamany_Lletra_Menu);
      i=0;
      while(i<3)
      {
	int j=0;
	IndexChar=0;
	while(IDimCubChar[i][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
	{
	  IndexChar++;
	}
	
	std::string AuxString;
	
	if(IndexChar<7)
	{
	  j=0;
	  while(j<IndexChar)
	  {
	    AuxString+=IDimCubChar[i][j];
	    j++;
	  }
	}else
	{
	  j=5;
	  while(j>0)
	  {
	    AuxString+=IDimCubChar[i][IndexChar-j];
	    j--;
	  }
	}
	Dim[i].Escriure(AuxString,Tamany_Lletra_Quadres_Dades);
	i++;
      }
      
      Dim[0].Mostra();
      Dim[1].Mostra();
      Dim[2].Mostra();      
      glColor3f(1,1,1);
      ///////////////////////////////////////////////////////////////////////////////////////////
      ////////////////////////////////Prioritat al pintar//////////////////////////////////////
      ///////////////////////////////////////////////////////////////////////////////////////////
      glColor3f(1,1,1);
      if(Idioma==0)
      {
	escriure("Body number: ",Pos_Text_Prioritat[0],Pos_Text_Prioritat[1],0,Tamany_Lletra_Menu);
      }
      else if(Idioma==1)
      {
	escriure("Numero de cos: ",Pos_Text_Prioritat[0],Pos_Text_Prioritat[1],0,Tamany_Lletra_Menu);	
      }
      else if(Idioma==2)
      {
	escriure("Numero de cuerpo: ",Pos_Text_Prioritat[0],Pos_Text_Prioritat[1],0,Tamany_Lletra_Menu);
      }
      
	IndexChar=0;
	while(IPrioritatCubChar[IndexChar]!='V' && IndexChar<3)		//Mira quina posició és la primera buida (Amb una 'V')
	{
	  IndexChar++;
	}
	
	std::string AuxString;
	
	  int j=0;
	  while(j<IndexChar)
	  {
	    AuxString+=IPrioritatCubChar[j];
	    j++;
	  }
	
	Prioritat.Escriure(AuxString,Tamany_Lletra_Quadres_Dades);      
     
      Prioritat.Mostra();
      
      AuxString.clear();	//Netegem el string
      
      glColor3f(1,1,1);
      ///////////////////////////////////////////////////////////////////////////////////////////
      ////////////////////////////////Objectes interns/////////////////////////////////////////
      ///////////////////////////////////////////////////////////////////////////////////////////
      glColor3f(1,1,1);
      if(Idioma==0)
      {
	escriure("Bodies within the object:",Pos_Text_Interns[0],Pos_Text_Interns[1],0,Tamany_Lletra_Menu);
      }
      else if(Idioma==1)
      {
	escriure("Cossos dins de l'objecte:",Pos_Text_Interns[0],Pos_Text_Interns[1],0,Tamany_Lletra_Menu);	
      }
      else if(Idioma==2)
      {
	escriure("Cuerpos dentro del objeto:",Pos_Text_Interns[0],Pos_Text_Interns[1],0,Tamany_Lletra_Menu);
      }	
	
	
      IndexChar=0;
	while(IDinsCubChar[IndexChar]!='V' && IndexChar<3)		//Mira quina posició és la primera buida (Amb una 'V')
	{
	  IndexChar++;
	}
	
	  j=0;
	  while(j<IndexChar)
	  {
	    AuxString+=IDinsCubChar[j];
	    j++;
	  }
	
	Interns.Escriure(AuxString,Tamany_Lletra_Quadres_Dades);      
           
      AfegirInterns[0].Mostra();
      AfegirInterns[1].Mostra();
      Interns.Mostra();
      glColor3f(1,1,1);
      //Ara escrivim les prioritats ja incloses al cub
      if(Idioma==0)
      {
	escriure("Interior bodies:",Pos_Text_Interns[0],0.275*Dimensions_Menu[1],0,Tamany_Lletra_Menu);
      }
      else if(Idioma==1)
      {
	escriure("Cossos ja afegits: ",Pos_Text_Interns[0],0.275*Dimensions_Menu[1],0,Tamany_Lletra_Menu);	
      }
      else if(Idioma==2)
      {
	escriure("Cuerpos ya añadidos: ",Pos_Text_Interns[0],0.275*Dimensions_Menu[1],0,Tamany_Lletra_Menu);
      }	

      j=0;
      IndexChar=0;
      AuxString.clear();
      //Pintem primer la primera linea
      while(DinsCubChar[IndexChar][0]!='V' && IndexChar<9)
      {
	j=0;
	while(DinsCubChar[IndexChar][j]!='V' && j<3)
	{
	  AuxString+=DinsCubChar[IndexChar][j];
	  j++;
	}
	AuxString+=',';
	IndexChar++;
      }
      escriure(AuxString,Pos_Text_Interns[0]+Dimensions_Menu[0]*0.33,0.275*Dimensions_Menu[1],0,Tamany_Lletra_Menu);
      //Pintem ara la segona linea el desplacem una linea baix per a que no pase el tamany de la pantalla
      glColor3f(1,1,1);
      AuxString.clear();
      while(DinsCubChar[IndexChar][0]!='V' && IndexChar<100)
      {
	j=0;
	while(DinsCubChar[IndexChar][j]!='V' && j<3)
	{
	  AuxString+=DinsCubChar[IndexChar][j];
	  j++;
	}
	AuxString+=',';
	IndexChar++;
      }      
      escriure(AuxString,Pos_Text_Interns[0],0.25*Dimensions_Menu[1],0,Tamany_Lletra_Menu);
      ///////////////////////////////////////////////////////////////////////////////////////////
      /////////////////////////////////Material i densitat////////////////////////////////////////////////
      ///////////////////////////////////////////////////////////////////////////////////////////
      glColor3f(1,1,1);

      if(Idioma==0)
      {
	escriure("Material: ",Pos_Text_Material[0],Pos_Text_Material[1],0,Tamany_Lletra_Menu);
      }
      else if(Idioma==1)
      {
	escriure("Material: ",Pos_Text_Material[0],Pos_Text_Material[1],0,Tamany_Lletra_Menu);	
      }
      else if(Idioma==2)
      {
	escriure("Material: ",Pos_Text_Material[0],Pos_Text_Material[1],0,Tamany_Lletra_Menu);
      }
      
      if(Idioma==0)
      {
	escriure("Density: ",Pos_Text_Densitat[0],Pos_Text_Densitat[1],0,Tamany_Lletra_Menu);

	escriure("(Only for voxels) (g/cm^3)",0.433333*Dimensions_Menu[0],Pos_Text_Densitat[1],0,Tamany_Lletra_Menu);
      }
      else if(Idioma==1)
      {
	escriure("Densitat: ",Pos_Text_Densitat[0],Pos_Text_Densitat[1],0,Tamany_Lletra_Menu);

	escriure("(Sols per al voxels) (g/cm^3)",0.433333*Dimensions_Menu[0],Pos_Text_Densitat[1],0,Tamany_Lletra_Menu);
      }
      else if(Idioma==2)
      {
	escriure("Densidad: ",Pos_Text_Densitat[0],Pos_Text_Densitat[1],0,Tamany_Lletra_Menu);

	escriure("(Solo para voxeles) (g/cm^3)",0.433333*Dimensions_Menu[0],Pos_Text_Densitat[1],0,Tamany_Lletra_Menu);	
      }	
      //Material//
      
      AuxString.clear();
      IndexChar=0;
      	while(IMatCubChar[IndexChar]!='V' && IndexChar<2)		//Mira quina posició és la primera buida (Amb una 'V')
	{
	  IndexChar++;
	}
	
	  j=0;
	  while(j<IndexChar)
	  {
	    AuxString+=IMatCubChar[j];
	    j++;
	  }
	
	MatDens[0].Escriure(AuxString,Tamany_Lletra_Quadres_Dades);      
	
	AuxString.clear();
	
	//Densitat//
	
	j=0;
	IndexChar=0;
	while(IDensCubChar[IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
	{
	  IndexChar++;
	}
	
	AuxString.clear();
	
	if(IndexChar<7)
	{
	  j=0;
	  while(j<IndexChar)
	  {
	    AuxString+=IDensCubChar[j];
	    j++;
	  }
	}else
	{
	  j=5;
	  while(j>0)
	  {
	    AuxString+=IDensCubChar[IndexChar-j];
	    j--;
	  }
	}
	MatDens[1].Escriure(AuxString,Tamany_Lletra_Quadres_Dades);
	AuxString.clear();
    MatDens[0].Mostra();
    MatDens[1].Mostra();  
///////////////////////////////////////////////////////////////////////////////////////////      
///////////////////////////////////Angles de Rotacio//////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////
    IndexChar=0;
      glColor3f(1,1,1);

      if(Idioma==0)
      {
	escriure("Angles: (",Pos_Text_Angles[0],Pos_Text_Angles[1],0,Tamany_Lletra_Menu);
      }
      else if(Idioma==1)
      {
	escriure("Angles: (",Pos_Text_Angles[0],Pos_Text_Angles[1],0,Tamany_Lletra_Menu);	
      }
      else if(Idioma==2)
      {
	escriure("Angulos: (",Pos_Text_Angles[0],Pos_Text_Angles[1],0,Tamany_Lletra_Menu);
      }      
      
      glColor3f(1,1,1);
      escriure(",",0.38333*Dimensions_Menu[0],Pos_Text_Angles[1],0,Tamany_Lletra_Menu);

      glColor3f(1,1,1);
      escriure(",",0.55*Dimensions_Menu[0],Pos_Text_Angles[1],0,Tamany_Lletra_Menu);

      glColor3f(1,1,1);
      escriure(") DEG",0.72*Dimensions_Menu[0],Pos_Text_Angles[1],0,Tamany_Lletra_Menu);
      
      i=0;
      while(i<3)
      {
	j=0;
	IndexChar=0;
	while(IAnglesCubChar[i][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
	{
	  IndexChar++;
	}
	
	AuxString.clear();
	
	if(IndexChar<7)
	{
	  j=0;
	  while(j<IndexChar)
	  {
	    AuxString+=IAnglesCubChar[i][j];
	    j++;
	  }
	}else
	{
	  j=5;
	  while(j>0)
	  {
	    AuxString+=IAnglesCubChar[i][IndexChar-j];
	    j--;
	  }
	}
	Angles[i].Escriure(AuxString,Tamany_Lletra_Quadres_Dades);
	i++;
      }
      
      Angles[0].Mostra();
      Angles[1].Mostra();
      Angles[2].Mostra();
      glColor3f(1,1,1);   
      
    
    /////////////////////////////////Boto Crear/////////////////////////////////////////////////////////
      Crear.Mostra();

    }

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////    
///////////////////////////////////////////Mostra el subsubmenu de nova esfera//////////////////////////////////////////////////////////////////////////    
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////   
    else if(ControlMenu==1 && ControlSubMenu==2)
    {
      ///////////////////////////////////////////////////////////////////////////////////////////
      ////////////////////////////////Centre///////////////////////////////////////////////
      ///////////////////////////////////////////////////////////////////////////////////////////
      int IndexChar=0;
      glColor3f(1,1,1);
      if(Idioma==0)
      {
	escriure("Center: (",Pos_Text_Centre[0],Pos_Text_Centre[1],0,Tamany_Lletra_Menu);	
      }
      else if(Idioma==1)
      {
	escriure("Centre: (",Pos_Text_Centre[0],Pos_Text_Centre[1],0,Tamany_Lletra_Menu);	
      }
      else if(Idioma==2)
      {
	escriure("Centro: (",Pos_Text_Centre[0],Pos_Text_Centre[1],0,Tamany_Lletra_Menu);	
      }	
            
      glColor3f(1,1,1);
      escriure(",",0.38333*Dimensions_Menu[0],Pos_Text_Centre[1],0,Tamany_Lletra_Menu);

      glColor3f(1,1,1);
      escriure(",",0.55*Dimensions_Menu[0],Pos_Text_Centre[1],0,Tamany_Lletra_Menu);

      glColor3f(1,1,1);
      escriure(") (cm)",0.72*Dimensions_Menu[0],Pos_Text_Centre[1],0,Tamany_Lletra_Menu);
      int i=0;
      while(i<3)
      {
	int j=0;
	IndexChar=0;
	while(ICentreEsfChar[i][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
	{
	  IndexChar++;
	}
	
	std::string AuxString;
	
	if(IndexChar<7)
	{
	  j=0;
	  while(j<IndexChar)
	  {
	    AuxString+=ICentreEsfChar[i][j];
	    j++;
	  }
	}else
	{
	  j=5;
	  while(j>0)
	  {
	    AuxString+=ICentreEsfChar[i][IndexChar-j];
	    j--;
	  }
	}
	Centre[i].Escriure(AuxString,Tamany_Lletra_Quadres_Dades);
	i++;
      }
      
      Centre[0].Mostra();
      Centre[1].Mostra();
      Centre[2].Mostra();
      glColor3f(1,1,1);
      ///////////////////////////////////////////////////////////////////////////////////////////
      ////////////////////////////////Dimensions/////////////////////////////////////////////
      ///////////////////////////////////////////////////////////////////////////////////////////
      glColor3f(1,1,1);
      if(Idioma==0)
      {
	escriure("Radius (cm):",Pos_Text_Dimensions[0],Pos_Text_Dimensions[1],0,Tamany_Lletra_Menu);
      }
      else if(Idioma==1)
      {
	escriure("Radi (cm):",Pos_Text_Dimensions[0],Pos_Text_Dimensions[1],0,Tamany_Lletra_Menu);
      }
      else if(Idioma==2)
      {
	escriure("Radio (cm):",Pos_Text_Dimensions[0],Pos_Text_Dimensions[1],0,Tamany_Lletra_Menu);
      }	
      
	int j=0;
	IndexChar=0;
	while(IDimEsfChar[IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
	{
	  IndexChar++;
	}
	
	std::string AuxString;
	
	if(IndexChar<7)
	{
	  j=0;
	  while(j<IndexChar)
	  {
	    AuxString+=IDimEsfChar[j];
	    j++;
	  }
	}else
	{
	  j=5;
	  while(j>0)
	  {
	    AuxString+=IDimEsfChar[IndexChar-j];
	    j--;
	  }
	}
	Dim[0].Escriure(AuxString,Tamany_Lletra_Quadres_Dades);

      
      Dim[0].Mostra();
      glColor3f(1,1,1);
      ///////////////////////////////////////////////////////////////////////////////////////////
      ////////////////////////////////Prioritat al pintar//////////////////////////////////////
      ///////////////////////////////////////////////////////////////////////////////////////////
      glColor3f(1,1,1);
      if(Idioma==0)
      {
	escriure("Body number: ",Pos_Text_Prioritat[0],Pos_Text_Prioritat[1],0,Tamany_Lletra_Menu);
      }
      else if(Idioma==1)
      {
	escriure("Numero de cos: ",Pos_Text_Prioritat[0],Pos_Text_Prioritat[1],0,Tamany_Lletra_Menu);	
      }
      else if(Idioma==2)
      {
	escriure("Numero de cuerpo: ",Pos_Text_Prioritat[0],Pos_Text_Prioritat[1],0,Tamany_Lletra_Menu);
      }
      
	IndexChar=0;
	while(IPrioritatEsfChar[IndexChar]!='V' && IndexChar<3)		//Mira quina posició és la primera buida (Amb una 'V')
	{
	  IndexChar++;
	}
	
	AuxString.clear();
	
	  j=0;
	  while(j<IndexChar)
	  {
	    AuxString+=IPrioritatEsfChar[j];
	    j++;
	  }
	
	Prioritat.Escriure(AuxString,Tamany_Lletra_Quadres_Dades);      
     
      Prioritat.Mostra();
      
      AuxString.clear();	//Netegem el string
      
      glColor3f(1,1,1);
      ///////////////////////////////////////////////////////////////////////////////////////////
      ////////////////////////////////Objectes interns/////////////////////////////////////////
      ///////////////////////////////////////////////////////////////////////////////////////////
      glColor3f(1,1,1);
      if(Idioma==0)
      {
	escriure("Bodies within the object:",Pos_Text_Interns[0],Pos_Text_Interns[1],0,Tamany_Lletra_Menu);
      }
      else if(Idioma==1)
      {
	escriure("Cossos dins de l'objecte:",Pos_Text_Interns[0],Pos_Text_Interns[1],0,Tamany_Lletra_Menu);	
      }
      else if(Idioma==2)
      {
	escriure("Cuerpos dentro del objeto:",Pos_Text_Interns[0],Pos_Text_Interns[1],0,Tamany_Lletra_Menu);
      }	
	
      IndexChar=0;
	while(IDinsEsfChar[IndexChar]!='V' && IndexChar<3)		//Mira quina posició és la primera buida (Amb una 'V')
	{
	  IndexChar++;
	}
	
	  j=0;
	  while(j<IndexChar)
	  {
	    AuxString+=IDinsEsfChar[j];
	    j++;
	  }
	
	Interns.Escriure(AuxString,Tamany_Lletra_Quadres_Dades);      
           
      AfegirInterns[0].Mostra();
      AfegirInterns[1].Mostra();
      Interns.Mostra();
      glColor3f(1,1,1);
      //Ara escrivim les prioritats ja incloses al cub
      if(Idioma==0)
      {
	escriure("Interior priorities:",Pos_Text_Interns[0],0.275*Dimensions_Menu[1],0,Tamany_Lletra_Menu);
      }
      else if(Idioma==1)
      {
	escriure("Prioritats ja afegides: ",Pos_Text_Interns[0],0.275*Dimensions_Menu[1],0,Tamany_Lletra_Menu);	
      }
      else if(Idioma==2)
      {
	escriure("Prioridades ya añadidas: ",Pos_Text_Interns[0],0.275*Dimensions_Menu[1],0,Tamany_Lletra_Menu);
      }	
      j=0;
      IndexChar=0;
      AuxString.clear();
      //Pintem primer la primera linea
      while(DinsEsfChar[IndexChar][0]!='V' && IndexChar<9)
      {
	j=0;
	while(DinsEsfChar[IndexChar][j]!='V' && j<3)
	{
	  AuxString+=DinsEsfChar[IndexChar][j];
	  j++;
	}
	AuxString+=',';
	IndexChar++;
      }
      escriure(AuxString,Pos_Text_Interns[0]+Dimensions_Menu[0]*0.33,0.275*Dimensions_Menu[1],0,Tamany_Lletra_Menu);
      //Pintem ara la segona linea el desplacem una linea baix per a que no pase el tamany de la pantalla
      glColor3f(1,1,1);
      AuxString.clear();
      while(DinsEsfChar[IndexChar][0]!='V' && IndexChar<100)
      {
	j=0;
	while(DinsEsfChar[IndexChar][j]!='V' && j<3)
	{
	  AuxString+=DinsEsfChar[IndexChar][j];
	  j++;
	}
	AuxString+=',';
	IndexChar++;
      }      
      escriure(AuxString,Pos_Text_Interns[0],0.25*Dimensions_Menu[1],0,Tamany_Lletra_Menu);
      ///////////////////////////////////////////////////////////////////////////////////////////
      /////////////////////////////////Material i densitat////////////////////////////////////////////////
      ///////////////////////////////////////////////////////////////////////////////////////////
      glColor3f(1,1,1);
      if(Idioma==0)
      {
	escriure("Material: ",Pos_Text_Material[0],Pos_Text_Material[1],0,Tamany_Lletra_Menu);
      }
      else if(Idioma==1)
      {
	escriure("Material: ",Pos_Text_Material[0],Pos_Text_Material[1],0,Tamany_Lletra_Menu);	
      }
      else if(Idioma==2)
      {
	escriure("Material: ",Pos_Text_Material[0],Pos_Text_Material[1],0,Tamany_Lletra_Menu);
      }
      
      if(Idioma==0)
      {
	escriure("Density: ",Pos_Text_Densitat[0],Pos_Text_Densitat[1],0,Tamany_Lletra_Menu);
	escriure("(Only for voxels) (g/cm^3)",0.433333*Dimensions_Menu[0],Pos_Text_Densitat[1],0,Tamany_Lletra_Menu);
      }
      else if(Idioma==1)
      {
	escriure("Densitat: ",Pos_Text_Densitat[0],Pos_Text_Densitat[1],0,Tamany_Lletra_Menu);
	escriure("(Sols per al voxels) (g/cm^3)",0.433333*Dimensions_Menu[0],Pos_Text_Densitat[1],0,Tamany_Lletra_Menu);
      }
      else if(Idioma==2)
      {
	escriure("Densidad: ",Pos_Text_Densitat[0],Pos_Text_Densitat[1],0,Tamany_Lletra_Menu);
	escriure("(Solo para voxeles) (g/cm^3)",0.433333*Dimensions_Menu[0],Pos_Text_Densitat[1],0,Tamany_Lletra_Menu);	
      }	
      //Material//
      
      AuxString.clear();
      IndexChar=0;
      	while(IMatEsfChar[IndexChar]!='V' && IndexChar<2)		//Mira quina posició és la primera buida (Amb una 'V')
	{
	  IndexChar++;
	}
	
	  j=0;
	  while(j<IndexChar)
	  {
	    AuxString+=IMatEsfChar[j];
	    j++;
	  }
	
	MatDens[0].Escriure(AuxString,Tamany_Lletra_Quadres_Dades);      
	
	AuxString.clear();
	
	//Densitat//
	
	j=0;
	IndexChar=0;
	while(IDensEsfChar[IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
	{
	  IndexChar++;
	}
	
	AuxString.clear();
	
	if(IndexChar<7)
	{
	  j=0;
	  while(j<IndexChar)
	  {
	    AuxString+=IDensEsfChar[j];
	    j++;
	  }
	}else
	{
	  j=5;
	  while(j>0)
	  {
	    AuxString+=IDensEsfChar[IndexChar-j];
	    j--;
	  }
	}
	MatDens[1].Escriure(AuxString,Tamany_Lletra_Quadres_Dades);
	AuxString.clear();
      MatDens[0].Mostra();
      MatDens[1].Mostra();
      
    /////////////////////////////////Boto Crear/////////////////////////////////////////////////////////
      Crear.Mostra();

    }    
  
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////    
///////////////////////////////////////////Mostra el subsubmenu de nou cilindre//////////////////////////////////////////////////////////////////////////    
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////   
    else if(ControlMenu==1 && ControlSubMenu==3)
    {
      ///////////////////////////////////////////////////////////////////////////////////////////
      ////////////////////////////////Centre///////////////////////////////////////////////
      ///////////////////////////////////////////////////////////////////////////////////////////
     int IndexChar=0;
      glColor3f(1,1,1);
      if(Idioma==0)
      {
	escriure("Center: (",Pos_Text_Centre[0],Pos_Text_Centre[1],0,Tamany_Lletra_Menu);	
      }
      else if(Idioma==1)
      {
	escriure("Centre: (",Pos_Text_Centre[0],Pos_Text_Centre[1],0,Tamany_Lletra_Menu);	
      }
      else if(Idioma==2)
      {
	escriure("Centro: (",Pos_Text_Centre[0],Pos_Text_Centre[1],0,Tamany_Lletra_Menu);	
      }	
            
      glColor3f(1,1,1);
      escriure(",",0.38333*Dimensions_Menu[0],Pos_Text_Centre[1],0,Tamany_Lletra_Menu);

      glColor3f(1,1,1);
      escriure(",",0.55*Dimensions_Menu[0],Pos_Text_Centre[1],0,Tamany_Lletra_Menu);

      glColor3f(1,1,1);
      escriure(") (cm)",0.72*Dimensions_Menu[0],Pos_Text_Centre[1],0,Tamany_Lletra_Menu);
      int i=0;
      while(i<3)
      {
	int j=0;
	IndexChar=0;
	while(ICentreCilChar[i][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
	{
	  IndexChar++;
	}
	
	std::string AuxString;
	
	if(IndexChar<7)
	{
	  j=0;
	  while(j<IndexChar)
	  {
	    AuxString+=ICentreCilChar[i][j];
	    j++;
	  }
	}else
	{
	  j=5;
	  while(j>0)
	  {
	    AuxString+=ICentreCilChar[i][IndexChar-j];
	    j--;
	  }
	}
	Centre[i].Escriure(AuxString,Tamany_Lletra_Quadres_Dades);
	i++;
      }
      
      Centre[0].Mostra();
      Centre[1].Mostra();
      Centre[2].Mostra();
      glColor3f(1,1,1);
      ///////////////////////////////////////////////////////////////////////////////////////////
      ////////////////////////////////Dimensions/////////////////////////////////////////////
      ///////////////////////////////////////////////////////////////////////////////////////////

      glColor3f(1,1,1);
      if(Idioma==0)
      {
	escriure("Dimensions: (",Pos_Text_Dimensions[0],Pos_Text_Dimensions[1],0,Tamany_Lletra_Menu);
      }
      else if(Idioma==1)
      {
	escriure("Dimensions: (",Pos_Text_Dimensions[0],Pos_Text_Dimensions[1],0,Tamany_Lletra_Menu);	
      }
      else if(Idioma==2)
      {
	escriure("Dimensiones: (",Pos_Text_Dimensions[0],Pos_Text_Dimensions[1],0,Tamany_Lletra_Menu);
      }	
      
      glColor3f(1,1,1);
      escriure(",",0.38333*Dimensions_Menu[0],Pos_Text_Dimensions[1],0,Tamany_Lletra_Menu);

      glColor3f(1,1,1);
      escriure(",",0.55*Dimensions_Menu[0],Pos_Text_Dimensions[1],0,Tamany_Lletra_Menu);

      glColor3f(1,1,1);
      escriure(") (cm)",0.72*Dimensions_Menu[0],Pos_Text_Dimensions[1],0,Tamany_Lletra_Menu);
      i=0;
      while(i<3)
      {
	int j=0;
	IndexChar=0;
	while(IDimCilChar[i][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
	{
	  IndexChar++;
	}
	
	std::string AuxString;
	
	if(IndexChar<7)
	{
	  j=0;
	  while(j<IndexChar)
	  {
	    AuxString+=IDimCilChar[i][j];
	    j++;
	  }
	}else
	{
	  j=5;
	  while(j>0)
	  {
	    AuxString+=IDimCilChar[i][IndexChar-j];
	    j--;
	  }
	}
	Dim[i].Escriure(AuxString,Tamany_Lletra_Quadres_Dades);
	i++;
      }
      
      Dim[0].Mostra();
      Dim[1].Mostra();
      Dim[2].Mostra();      
      glColor3f(1,1,1);
      ///////////////////////////////////////////////////////////////////////////////////////////
      ////////////////////////////////Prioritat al pintar//////////////////////////////////////
      ///////////////////////////////////////////////////////////////////////////////////////////
      glColor3f(1,1,1);
      if(Idioma==0)
      {
	escriure("Body number: ",Pos_Text_Prioritat[0],Pos_Text_Prioritat[1],0,Tamany_Lletra_Menu);
      }
      else if(Idioma==1)
      {
	escriure("Numero de cos: ",Pos_Text_Prioritat[0],Pos_Text_Prioritat[1],0,Tamany_Lletra_Menu);
      }
      else if(Idioma==2)
      {
	escriure("Numero de cuerpo: ",Pos_Text_Prioritat[0],Pos_Text_Prioritat[1],0,Tamany_Lletra_Menu);
      }	
      
	IndexChar=0;
	while(IPrioritatCilChar[IndexChar]!='V' && IndexChar<3)		//Mira quina posició és la primera buida (Amb una 'V')
	{
	  IndexChar++;
	}
	
	std::string AuxString;
	
	  int j=0;
	  while(j<IndexChar)
	  {
	    AuxString+=IPrioritatCilChar[j];
	    j++;
	  }
	
	Prioritat.Escriure(AuxString,Tamany_Lletra_Quadres_Dades);      
     
      Prioritat.Mostra();
      
      AuxString.clear();	//Netegem el string
      
      glColor3f(1,1,1);
      ///////////////////////////////////////////////////////////////////////////////////////////
      ////////////////////////////////Opcio tuberia/////////////////////////////////////////////
      ///////////////////////////////////////////////////////////////////////////////////////////

      glColor3f(1,1,1);
      if(Idioma==0)
      {
	if(ITubCil==false){escriure("cilinder/cone",0.666666*Dimensions_Menu[0],0.3525*Dimensions_Menu[1],0,Tamany_Lletra_Menu);}
	else if(ITubCil==true){escriure("tube",0.666666*Dimensions_Menu[0],0.3525*Dimensions_Menu[1],0,Tamany_Lletra_Menu);}
      }
      else if(Idioma==1)
      {
	if(ITubCil==false){escriure("cilindre/con",0.666666*Dimensions_Menu[0],0.3525*Dimensions_Menu[1],0,Tamany_Lletra_Menu);}
	else if(ITubCil==true){escriure("tub",0.666666*Dimensions_Menu[0],0.3525*Dimensions_Menu[1],0,Tamany_Lletra_Menu);}
      }
      else if(Idioma==2)
      {
	if(ITubCil==false){escriure("cilindro/cono",0.666666*Dimensions_Menu[0],0.3525*Dimensions_Menu[1],0,Tamany_Lletra_Menu);}
	else if(ITubCil==true){escriure("tubo",0.666666*Dimensions_Menu[0],0.3525*Dimensions_Menu[1],0,Tamany_Lletra_Menu);}
      }	
      BTub.Mostra();

      ///////////////////////////////////////////////////////////////////////////////////////////
      ////////////////////////////////Objectes interns/////////////////////////////////////////
      ///////////////////////////////////////////////////////////////////////////////////////////
      glColor3f(1,1,1);
      if(Idioma==0)
      {
	escriure("Bodies within the object:",Pos_Text_Interns[0],Pos_Text_Interns[1],0,Tamany_Lletra_Menu);
      }
      else if(Idioma==1)
      {
	escriure("Cossos dins de l'objecte:",Pos_Text_Interns[0],Pos_Text_Interns[1],0,Tamany_Lletra_Menu);	
      }
      else if(Idioma==2)
      {
	escriure("Cuerpos dentro del objeto:",Pos_Text_Interns[0],Pos_Text_Interns[1],0,Tamany_Lletra_Menu);
      }	
	
      IndexChar=0;
	while(IDinsCilChar[IndexChar]!='V' && IndexChar<3)		//Mira quina posició és la primera buida (Amb una 'V')
	{
	  IndexChar++;
	}
	
	  j=0;
	  while(j<IndexChar)
	  {
	    AuxString+=IDinsCilChar[j];
	    j++;
	  }
	
	Interns.Escriure(AuxString,Tamany_Lletra_Quadres_Dades);      
           
      AfegirInterns[0].Mostra();
      AfegirInterns[1].Mostra();
      Interns.Mostra();
      glColor3f(1,1,1);
      //Ara escrivim les prioritats ja incloses al cub
      if(Idioma==0)
      {
	escriure("Interior priorities:",Pos_Text_Interns[0],0.275*Dimensions_Menu[1],0,Tamany_Lletra_Menu);
      }
      else if(Idioma==1)
      {
	escriure("Prioritats ja afegides: ",Pos_Text_Interns[0],0.275*Dimensions_Menu[1],0,Tamany_Lletra_Menu);	
      }
      else if(Idioma==2)
      {
	escriure("Prioridades ya añadidas: ",Pos_Text_Interns[0],0.275*Dimensions_Menu[1],0,Tamany_Lletra_Menu);
      }	
      j=0;
      IndexChar=0;
      AuxString.clear();
      //Pintem primer la primera linea
      while(DinsCilChar[IndexChar][0]!='V' && IndexChar<9)
      {
	j=0;
	while(DinsCilChar[IndexChar][j]!='V' && j<3)
	{
	  AuxString+=DinsCilChar[IndexChar][j];
	  j++;
	}
	AuxString+=',';
	IndexChar++;
      }
      escriure(AuxString,Pos_Text_Interns[0]+Dimensions_Menu[0]*0.33,0.275*Dimensions_Menu[1],0,Tamany_Lletra_Menu);
      //Pintem ara la segona linea el desplacem una linea baix per a que no pase el tamany de la pantalla
      glColor3f(1,1,1);
      AuxString.clear();
      while(DinsCilChar[IndexChar][0]!='V' && IndexChar<100)
      {
	j=0;
	while(DinsCilChar[IndexChar][j]!='V' && j<3)
	{
	  AuxString+=DinsCilChar[IndexChar][j];
	  j++;
	}
	AuxString+=',';
	IndexChar++;
      }      
      escriure(AuxString,Pos_Text_Interns[0],0.25*Dimensions_Menu[1],0,Tamany_Lletra_Menu);
      ///////////////////////////////////////////////////////////////////////////////////////////
      /////////////////////////////////Material i densitat////////////////////////////////////////////////
      ///////////////////////////////////////////////////////////////////////////////////////////
      glColor3f(1,1,1);
      if(Idioma==0)
      {
	escriure("Material: ",Pos_Text_Material[0],Pos_Text_Material[1],0,Tamany_Lletra_Menu);
      }
      else if(Idioma==1)
      {
	escriure("Material: ",Pos_Text_Material[0],Pos_Text_Material[1],0,Tamany_Lletra_Menu);	
      }
      else if(Idioma==2)
      {
	escriure("Material: ",Pos_Text_Material[0],Pos_Text_Material[1],0,Tamany_Lletra_Menu);
      }
      
      if(Idioma==0)
      {
	escriure("Density: ",Pos_Text_Densitat[0],Pos_Text_Densitat[1],0,Tamany_Lletra_Menu);
	escriure("(Only for voxels) (g/cm^3)",0.433333*Dimensions_Menu[0],Pos_Text_Densitat[1],0,Tamany_Lletra_Menu);
      }
      else if(Idioma==1)
      {
	escriure("Densitat: ",Pos_Text_Densitat[0],Pos_Text_Densitat[1],0,Tamany_Lletra_Menu);
	escriure("(Sols per al voxels) (g/cm^3)",0.433333*Dimensions_Menu[0],Pos_Text_Densitat[1],0,Tamany_Lletra_Menu);
      }
      else if(Idioma==2)
      {
	escriure("Densidad: ",Pos_Text_Densitat[0],Pos_Text_Densitat[1],0,Tamany_Lletra_Menu);
	escriure("(Solo para voxeles) (g/cm^3)",0.433333*Dimensions_Menu[0],Pos_Text_Densitat[1],0,Tamany_Lletra_Menu);
      }	
      //Material//
      
      AuxString.clear();
      IndexChar=0;
      	while(IMatCilChar[IndexChar]!='V' && IndexChar<2)		//Mira quina posició és la primera buida (Amb una 'V')
	{
	  IndexChar++;
	}
	
	  j=0;
	  while(j<IndexChar)
	  {
	    AuxString+=IMatCilChar[j];
	    j++;
	  }
	
	MatDens[0].Escriure(AuxString,Tamany_Lletra_Quadres_Dades);      
	
	AuxString.clear();
	
	//Densitat//
	
	j=0;
	IndexChar=0;
	while(IDensCilChar[IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
	{
	  IndexChar++;
	}
	
	AuxString.clear();
	
	if(IndexChar<7)
	{
	  j=0;
	  while(j<IndexChar)
	  {
	    AuxString+=IDensCilChar[j];
	    j++;
	  }
	}else
	{
	  j=5;
	  while(j>0)
	  {
	    AuxString+=IDensCilChar[IndexChar-j];
	    j--;
	  }
	}
	MatDens[1].Escriure(AuxString,Tamany_Lletra_Quadres_Dades);
	AuxString.clear();
    MatDens[0].Mostra();
    MatDens[1].Mostra();  
///////////////////////////////////////////////////////////////////////////////////////////      
///////////////////////////////////Angles de Rotacio//////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////
    IndexChar=0;
      glColor3f(1,1,1);
      if(Idioma==0)
      {
	escriure("Angles: (",Pos_Text_Angles[0],Pos_Text_Angles[1],0,Tamany_Lletra_Menu);
      }
      else if(Idioma==1)
      {
	escriure("Angles: (",Pos_Text_Angles[0],Pos_Text_Angles[1],0,Tamany_Lletra_Menu);	
      }
      else if(Idioma==2)
      {
	escriure("Angulos: (",Pos_Text_Angles[0],Pos_Text_Angles[1],0,Tamany_Lletra_Menu);
      }      
      
      glColor3f(1,1,1);
      escriure(",",0.38333*Dimensions_Menu[0],Pos_Text_Angles[1],0,Tamany_Lletra_Menu);

      glColor3f(1,1,1);
      escriure(",",0.55*Dimensions_Menu[0],Pos_Text_Angles[1],0,Tamany_Lletra_Menu);

      glColor3f(1,1,1);
      escriure(") DEG",0.72*Dimensions_Menu[0],Pos_Text_Angles[1],0,Tamany_Lletra_Menu);
      
      i=0;
      while(i<3)
      {
	j=0;
	IndexChar=0;
	while(IAnglesCilChar[i][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
	{
	  IndexChar++;
	}
	
	AuxString.clear();
	
	if(IndexChar<7)
	{
	  j=0;
	  while(j<IndexChar)
	  {
	    AuxString+=IAnglesCilChar[i][j];
	    j++;
	  }
	}else
	{
	  j=5;
	  while(j>0)
	  {
	    AuxString+=IAnglesCilChar[i][IndexChar-j];
	    j--;
	  }
	}
	Angles[i].Escriure(AuxString,Tamany_Lletra_Quadres_Dades);
	i++;
      }
      
      Angles[0].Mostra();
      Angles[1].Mostra();
      Angles[2].Mostra();
      glColor3f(1,1,1);   
      
    
    /////////////////////////////////Boto Crear/////////////////////////////////////////////////////////
      Crear.Mostra();

    }


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////    
///////////////////////////////////////////Mostra el subsubmenu de nou Pla//////////////////////////////////////////////////////////////////////////    
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////   
    else if(ControlMenu==1 && ControlSubMenu==4)
    {
      ///////////////////////////////////////////////////////////////////////////////////////////
      ////////////////////////////////Centre///////////////////////////////////////////////
      ///////////////////////////////////////////////////////////////////////////////////////////
     int IndexChar=0;
      glColor3f(1,1,1);
      if(Idioma==0)
      {
	escriure("Center: (",Pos_Text_Centre[0],Pos_Text_Centre[1],0,Tamany_Lletra_Menu);	
      }
      else if(Idioma==1)
      {
	escriure("Centre: (",Pos_Text_Centre[0],Pos_Text_Centre[1],0,Tamany_Lletra_Menu);
      }
      else if(Idioma==2)
      {
	escriure("Centro: (",Pos_Text_Centre[0],Pos_Text_Centre[1],0,Tamany_Lletra_Menu);
      }	
            
      glColor3f(1,1,1);
      escriure(",",0.38333*Dimensions_Menu[0],Pos_Text_Centre[1],0,Tamany_Lletra_Menu);

      glColor3f(1,1,1);
      escriure(",",0.55*Dimensions_Menu[0],Pos_Text_Centre[1],0,Tamany_Lletra_Menu);

      glColor3f(1,1,1);
      escriure(") (cm)",0.72*Dimensions_Menu[0],Pos_Text_Centre[1],0,Tamany_Lletra_Menu);
      int i=0;
      while(i<3)
      {
	int j=0;
	IndexChar=0;
	while(ICentrePlaChar[i][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
	{
	  IndexChar++;
	}
	
	std::string AuxString;
	
	if(IndexChar<7)
	{
	  j=0;
	  while(j<IndexChar)
	  {
	    AuxString+=ICentrePlaChar[i][j];
	    j++;
	  }
	}else
	{
	  j=5;
	  while(j>0)
	  {
	    AuxString+=ICentrePlaChar[i][IndexChar-j];
	    j--;
	  }
	}
	Centre[i].Escriure(AuxString,Tamany_Lletra_Quadres_Dades);
	i++;
      }
      
      Centre[0].Mostra();
      Centre[1].Mostra();
      Centre[2].Mostra();
      glColor3f(1,1,1);

      ///////////////////////////////////////////////////////////////////////////////////////////
      ////////////////////////////////Prioritat al pintar//////////////////////////////////////
      ///////////////////////////////////////////////////////////////////////////////////////////
      glColor3f(1,1,1);
      if(Idioma==0)
      {
	escriure("Body number: ",Pos_Text_Prioritat[0],Pos_Text_Prioritat[1],0,Tamany_Lletra_Menu);
      }
      else if(Idioma==1)
      {
	escriure("Numero de cos: ",Pos_Text_Prioritat[0],Pos_Text_Prioritat[1],0,Tamany_Lletra_Menu);
      }
      else if(Idioma==2)
      {
	escriure("Numero de cuerpo: ",Pos_Text_Prioritat[0],Pos_Text_Prioritat[1],0,Tamany_Lletra_Menu);
      }
      
	IndexChar=0;
	while(IPrioritatPlaChar[IndexChar]!='V' && IndexChar<3)		//Mira quina posició és la primera buida (Amb una 'V')
	{
	  IndexChar++;
	}
	
	std::string AuxString;
	
	  int j=0;
	  while(j<IndexChar)
	  {
	    AuxString+=IPrioritatPlaChar[j];
	    j++;
	  }
	
	Prioritat.Escriure(AuxString,Tamany_Lletra_Quadres_Dades);      
     
      Prioritat.Mostra();
      
      AuxString.clear();	//Netegem el string
      
      glColor3f(1,1,1);
      ///////////////////////////////////////////////////////////////////////////////////////////
      ////////////////////////////////Objectes interns/////////////////////////////////////////
      ///////////////////////////////////////////////////////////////////////////////////////////
      glColor3f(1,1,1);
      if(Idioma==0)
      {
	escriure("Bodies within the object:",Pos_Text_Interns[0],Pos_Text_Interns[1],0,Tamany_Lletra_Menu);
      }
      else if(Idioma==1)
      {
	escriure("Cossos dins de l'objecte:",Pos_Text_Interns[0],Pos_Text_Interns[1],0,Tamany_Lletra_Menu);	
      }
      else if(Idioma==2)
      {
	escriure("Cuerpos dentro del objeto:",Pos_Text_Interns[0],Pos_Text_Interns[1],0,Tamany_Lletra_Menu);
      }	
	
      IndexChar=0;
	while(IDinsPlaChar[IndexChar]!='V' && IndexChar<3)		//Mira quina posició és la primera buida (Amb una 'V')
	{
	  IndexChar++;
	}
	
	  j=0;
	  while(j<IndexChar)
	  {
	    AuxString+=IDinsPlaChar[j];
	    j++;
	  }
	
	Interns.Escriure(AuxString,Tamany_Lletra_Quadres_Dades);      
           
      AfegirInterns[0].Mostra();
      AfegirInterns[1].Mostra();
      Interns.Mostra();
      glColor3f(1,1,1);
      //Ara escrivim les prioritats ja incloses al cub
      if(Idioma==0)
      {
	escriure("Interior priorities:",Pos_Text_Interns[0],0.275*Dimensions_Menu[1],0,Tamany_Lletra_Menu);
      }
      else if(Idioma==1)
      {
	escriure("Prioritats ja afegides: ",Pos_Text_Interns[0],0.275*Dimensions_Menu[1],0,Tamany_Lletra_Menu);	
      }
      else if(Idioma==2)
      {
	escriure("Prioridades ya añadidas: ",Pos_Text_Interns[0],0.275*Dimensions_Menu[1],0,Tamany_Lletra_Menu);
      }	
      j=0;
      IndexChar=0;
      AuxString.clear();
      //Pintem primer la primera linea
      while(DinsPlaChar[IndexChar][0]!='V' && IndexChar<9)
      {
	j=0;
	while(DinsPlaChar[IndexChar][j]!='V' && j<3)
	{
	  AuxString+=DinsPlaChar[IndexChar][j];
	  j++;
	}
	AuxString+=',';
	IndexChar++;
      }
      escriure(AuxString,Pos_Text_Interns[0]+Dimensions_Menu[0]*0.33,0.275*Dimensions_Menu[1],0,Tamany_Lletra_Menu);
      //Pintem ara la segona linea el desplacem una linea baix per a que no pase el tamany de la pantalla
      glColor3f(1,1,1);
      AuxString.clear();
      while(DinsPlaChar[IndexChar][0]!='V' && IndexChar<100)
      {
	j=0;
	while(DinsPlaChar[IndexChar][j]!='V' && j<3)
	{
	  AuxString+=DinsPlaChar[IndexChar][j];
	  j++;
	}
	AuxString+=',';
	IndexChar++;
      }      
      escriure(AuxString,Pos_Text_Interns[0],0.25*Dimensions_Menu[1],0,Tamany_Lletra_Menu);
      ///////////////////////////////////////////////////////////////////////////////////////////
      /////////////////////////////////Material i densitat////////////////////////////////////////////////
      ///////////////////////////////////////////////////////////////////////////////////////////
      glColor3f(1,1,1);
      if(Idioma==0)
      {
	escriure("Material: ",Pos_Text_Material[0],Pos_Text_Material[1],0,Tamany_Lletra_Menu);
      }
      else if(Idioma==1)
      {
	escriure("Material: ",Pos_Text_Material[0],Pos_Text_Material[1],0,Tamany_Lletra_Menu);	
      }
      else if(Idioma==2)
      {
	escriure("Material: ",Pos_Text_Material[0],Pos_Text_Material[1],0,Tamany_Lletra_Menu);
      }	

      if(Idioma==0)
      {
	escriure("Density: ",Pos_Text_Densitat[0],Pos_Text_Densitat[1],0,Tamany_Lletra_Menu);
	escriure("(Only for voxels) (g/cm^3)",0.433333*Dimensions_Menu[0],Pos_Text_Densitat[1],0,Tamany_Lletra_Menu);
      }
      else if(Idioma==1)
      {
	escriure("Densitat: ",Pos_Text_Densitat[0],Pos_Text_Densitat[1],0,Tamany_Lletra_Menu);
	escriure("(Sols per al voxels) (g/cm^3)",0.433333*Dimensions_Menu[0],Pos_Text_Densitat[1],0,Tamany_Lletra_Menu);
      }
      else if(Idioma==2)
      {
	escriure("Densidad: ",Pos_Text_Densitat[0],Pos_Text_Densitat[1],0,Tamany_Lletra_Menu);
	escriure("(Solo para voxeles) (g/cm^3)",0.433333*Dimensions_Menu[0],Pos_Text_Densitat[1],0,Tamany_Lletra_Menu);
      }	
      //Material//
      
      AuxString.clear();
      IndexChar=0;
      	while(IMatPlaChar[IndexChar]!='V' && IndexChar<2)		//Mira quina posició és la primera buida (Amb una 'V')
	{
	  IndexChar++;
	}
	
	  j=0;
	  while(j<IndexChar)
	  {
	    AuxString+=IMatPlaChar[j];
	    j++;
	  }
	
	MatDens[0].Escriure(AuxString,Tamany_Lletra_Quadres_Dades);      
	
	AuxString.clear();
	
	//Densitat//
	
	j=0;
	IndexChar=0;
	while(IDensPlaChar[IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
	{
	  IndexChar++;
	}
	
	AuxString.clear();
	
	if(IndexChar<7)
	{
	  j=0;
	  while(j<IndexChar)
	  {
	    AuxString+=IDensPlaChar[j];
	    j++;
	  }
	}else
	{
	  j=5;
	  while(j>0)
	  {
	    AuxString+=IDensPlaChar[IndexChar-j];
	    j--;
	  }
	}
	MatDens[1].Escriure(AuxString,Tamany_Lletra_Quadres_Dades);
	AuxString.clear();
    MatDens[0].Mostra();
    MatDens[1].Mostra();  
///////////////////////////////////////////////////////////////////////////////////////////      
///////////////////////////////////Direccio////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////
    IndexChar=0;
      glColor3f(1,1,1);

      if(Idioma==0)
      {
	escriure("Direction: (",Pos_Text_Angles[0],Pos_Text_Angles[1],0,Tamany_Lletra_Menu);
      }
      else if(Idioma==1)
      {
	escriure("Direccio: (",Pos_Text_Angles[0],Pos_Text_Angles[1],0,Tamany_Lletra_Menu);
      }
      else if(Idioma==2)
      {
	escriure("Direccion: (",Pos_Text_Angles[0],Pos_Text_Angles[1],0,Tamany_Lletra_Menu);
      }      
      
      glColor3f(1,1,1);
      escriure(",",0.38333*Dimensions_Menu[0],Pos_Text_Angles[1],0,Tamany_Lletra_Menu);

      glColor3f(1,1,1);
      escriure(",",0.55*Dimensions_Menu[0],Pos_Text_Angles[1],0,Tamany_Lletra_Menu);

      glColor3f(1,1,1);
      escriure(")",0.72*Dimensions_Menu[0],Pos_Text_Angles[1],0,Tamany_Lletra_Menu);
      
      i=0;
      while(i<3)
      {
	j=0;
	IndexChar=0;
	while(IAnglesPlaChar[i][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
	{
	  IndexChar++;
	}
	
	AuxString.clear();
	
	if(IndexChar<7)
	{
	  j=0;
	  while(j<IndexChar)
	  {
	    AuxString+=IAnglesPlaChar[i][j];
	    j++;
	  }
	}else
	{
	  j=5;
	  while(j>0)
	  {
	    AuxString+=IAnglesPlaChar[i][IndexChar-j];
	    j--;
	  }
	}
	Angles[i].Escriure(AuxString,Tamany_Lletra_Quadres_Dades);
	i++;
      }
      
      Angles[0].Mostra();
      Angles[1].Mostra();
      Angles[2].Mostra();
      glColor3f(1,1,1);   
      
    
    /////////////////////////////////Boto Crear/////////////////////////////////////////////////////////
      Crear.Mostra();

    }


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////    
///////////////////////////////////////////Mostra el subsubmenu de nova seccio d'esfera//////////////////////////////////////////////////////////////////////////    
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////   
    else if(ControlMenu==1 && ControlSubMenu==5)
    {
      ///////////////////////////////////////////////////////////////////////////////////////////
      //////////////////////////////////////Centre///////////////////////////////////////////////
      ///////////////////////////////////////////////////////////////////////////////////////////
     int IndexChar=0;
      glColor3f(1,1,1);

      if(Idioma==0)
      {
	escriure("Center: (",Pos_Text_Centre[0],Pos_Text_Centre[1],0,Tamany_Lletra_Menu);
      }
      else if(Idioma==1)
      {
	escriure("Centre: (",Pos_Text_Centre[0],Pos_Text_Centre[1],0,Tamany_Lletra_Menu);
      }
      else if(Idioma==2)
      {
	escriure("Centro: (",Pos_Text_Centre[0],Pos_Text_Centre[1],0,Tamany_Lletra_Menu);
      }	
                  
      glColor3f(1,1,1);
      escriure(",",0.38333*Dimensions_Menu[0],Pos_Text_Centre[1],0,Tamany_Lletra_Menu);

      glColor3f(1,1,1);
      escriure(",",0.55*Dimensions_Menu[0],Pos_Text_Centre[1],0,Tamany_Lletra_Menu);

      glColor3f(1,1,1);
      escriure(") (cm)",0.72*Dimensions_Menu[0],Pos_Text_Centre[1],0,Tamany_Lletra_Menu);
      int i=0;
      while(i<3)
      {
	int j=0;
	IndexChar=0;
	while(ICentreSecEsfChar[i][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
	{
	  IndexChar++;
	}
	
	std::string AuxString;
	
	if(IndexChar<7)
	{
	  j=0;
	  while(j<IndexChar)
	  {
	    AuxString+=ICentreSecEsfChar[i][j];
	    j++;
	  }
	}else
	{
	  j=5;
	  while(j>0)
	  {
	    AuxString+=ICentreSecEsfChar[i][IndexChar-j];
	    j--;
	  }
	}
	Centre[i].Escriure(AuxString,Tamany_Lletra_Quadres_Dades);
	i++;
      }
      
      Centre[0].Mostra();
      Centre[1].Mostra();
      Centre[2].Mostra();
      glColor3f(1,1,1);
      ///////////////////////////////////////////////////////////////////////////////////////////
      ////////////////////////////////Dimensions/////////////////////////////////////////////
      ///////////////////////////////////////////////////////////////////////////////////////////
      glColor3f(1,1,1);

      if(Idioma==0)
      {
	escriure("Dimensions: (",Pos_Text_Dimensions[0],Pos_Text_Dimensions[1],0,Tamany_Lletra_Menu);
      }
      else if(Idioma==1)
      {
	escriure("Dimensions: (",Pos_Text_Dimensions[0],Pos_Text_Dimensions[1],0,Tamany_Lletra_Menu);
      }
      else if(Idioma==2)
      {
	escriure("Dimensiones: (",Pos_Text_Dimensions[0],Pos_Text_Dimensions[1],0,Tamany_Lletra_Menu);
      }	
      
      glColor3f(1,1,1);
      escriure(",",0.38333*Dimensions_Menu[0],Pos_Text_Dimensions[1],0,Tamany_Lletra_Menu);

      glColor3f(1,1,1);
      escriure(") (cm)",0.72*Dimensions_Menu[0],Pos_Text_Dimensions[1],0,Tamany_Lletra_Menu);

      i=0;
      while(i<2)
      {
	int j=0;
	IndexChar=0;
	while(IDimSecEsfChar[i][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
	{
	  IndexChar++;
	}
	
	std::string AuxString;
	
	if(IndexChar<7)
	{
	  j=0;
	  while(j<IndexChar)
	  {
	    AuxString+=IDimSecEsfChar[i][j];
	    j++;
	  }
	}else
	{
	  j=5;
	  while(j>0)
	  {
	    AuxString+=IDimSecEsfChar[i][IndexChar-j];
	    j--;
	  }
	}
	Dim[i].Escriure(AuxString,Tamany_Lletra_Quadres_Dades);
	i++;
      }
      
      Dim[0].Mostra();
      Dim[1].Mostra();     
      glColor3f(1,1,1);
      ///////////////////////////////////////////////////////////////////////////////////////////
      ////////////////////////////////Prioritat al pintar//////////////////////////////////////
      ///////////////////////////////////////////////////////////////////////////////////////////
      glColor3f(1,1,1);
      if(Idioma==0)
      {
	escriure("Body number: ",Pos_Text_Prioritat[0],Pos_Text_Prioritat[1],0,Tamany_Lletra_Menu);
      }
      else if(Idioma==1)
      {
	escriure("Numero de cos: ",Pos_Text_Prioritat[0],Pos_Text_Prioritat[1],0,Tamany_Lletra_Menu);
      }
      else if(Idioma==2)
      {
	escriure("Numero de cuerpo: ",Pos_Text_Prioritat[0],Pos_Text_Prioritat[1],0,Tamany_Lletra_Menu);
      }
      
	IndexChar=0;
	while(IPrioritatSecEsfChar[IndexChar]!='V' && IndexChar<3)		//Mira quina posició és la primera buida (Amb una 'V')
	{
	  IndexChar++;
	}
	
	std::string AuxString;
	
	  int j=0;
	  while(j<IndexChar)
	  {
	    AuxString+=IPrioritatSecEsfChar[j];
	    j++;
	  }
	
	Prioritat.Escriure(AuxString,Tamany_Lletra_Quadres_Dades);      
     
      Prioritat.Mostra();
      
      AuxString.clear();	//Netegem el string
      
      glColor3f(1,1,1);
      ///////////////////////////////////////////////////////////////////////////////////////////
      ////////////////////////////////Objectes interns/////////////////////////////////////////
      ///////////////////////////////////////////////////////////////////////////////////////////
      glColor3f(1,1,1);
      if(Idioma==0)
      {
	escriure("Bodies within the object:",Pos_Text_Interns[0],Pos_Text_Interns[1],0,Tamany_Lletra_Menu);
      }
      else if(Idioma==1)
      {
	escriure("Cossos dins de l'objecte:",Pos_Text_Interns[0],Pos_Text_Interns[1],0,Tamany_Lletra_Menu);
      }
      else if(Idioma==2)
      {
	escriure("Cuerpos dentro del objeto:",Pos_Text_Interns[0],Pos_Text_Interns[1],0,Tamany_Lletra_Menu);
      }	
	
      IndexChar=0;
	while(IDinsSecEsfChar[IndexChar]!='V' && IndexChar<3)		//Mira quina posició és la primera buida (Amb una 'V')
	{
	  IndexChar++;
	}
	
	  j=0;
	  while(j<IndexChar)
	  {
	    AuxString+=IDinsSecEsfChar[j];
	    j++;
	  }
	
	Interns.Escriure(AuxString,Tamany_Lletra_Quadres_Dades);      
           
      AfegirInterns[0].Mostra();
      AfegirInterns[1].Mostra();
      Interns.Mostra();
      glColor3f(1,1,1);
      //Ara escrivim les prioritats ja incloses al cub
      if(Idioma==0)
      {
	escriure("Interior priorities:",Pos_Text_Interns[0],0.275*Dimensions_Menu[1],0,Tamany_Lletra_Menu);
      }
      else if(Idioma==1)
      {
	escriure("Prioritats ja afegides: ",Pos_Text_Interns[0],0.275*Dimensions_Menu[1],0,Tamany_Lletra_Menu);
      }
      else if(Idioma==2)
      {
	escriure("Prioridades ya añadidas: ",Pos_Text_Interns[0],0.275*Dimensions_Menu[1],0,Tamany_Lletra_Menu);
      }	
      j=0;
      IndexChar=0;
      AuxString.clear();
      //Pintem primer la primera linea
      while(DinsSecEsfChar[IndexChar][0]!='V' && IndexChar<9)
      {
	j=0;
	while(DinsSecEsfChar[IndexChar][j]!='V' && j<3)
	{
	  AuxString+=DinsSecEsfChar[IndexChar][j];
	  j++;
	}
	AuxString+=',';
	IndexChar++;
      }
      escriure(AuxString,Pos_Text_Interns[0]+Dimensions_Menu[0]*0.33,0.275*Dimensions_Menu[1],0,Tamany_Lletra_Menu);
      //Pintem ara la segona linea el desplacem una linea baix per a que no pase el tamany de la pantalla
      glColor3f(1,1,1);
      AuxString.clear();
      while(DinsSecEsfChar[IndexChar][0]!='V' && IndexChar<100)
      {
	j=0;
	while(DinsSecEsfChar[IndexChar][j]!='V' && j<3)
	{
	  AuxString+=DinsSecEsfChar[IndexChar][j];
	  j++;
	}
	AuxString+=',';
	IndexChar++;
      }      
      escriure(AuxString,Pos_Text_Interns[0],0.25*Dimensions_Menu[1],0,Tamany_Lletra_Menu);
      ///////////////////////////////////////////////////////////////////////////////////////////
      /////////////////////////////////Material i densitat////////////////////////////////////////////////
      ///////////////////////////////////////////////////////////////////////////////////////////
      glColor3f(1,1,1);
      if(Idioma==0)
      {
	escriure("Material: ",Pos_Text_Material[0],Pos_Text_Material[1],0,Tamany_Lletra_Menu);

      }
      else if(Idioma==1)
      {
	escriure("Material: ",Pos_Text_Material[0],Pos_Text_Material[1],0,Tamany_Lletra_Menu);

      }
      else if(Idioma==2)
      {
	escriure("Material: ",Pos_Text_Material[0],Pos_Text_Material[1],0,Tamany_Lletra_Menu);

      }
      
      if(Idioma==0)
      {
	escriure("Density: ",Pos_Text_Densitat[0],Pos_Text_Densitat[1],0,Tamany_Lletra_Menu);
	escriure("(Only for voxels) (g/cm^3)",0.433333*Dimensions_Menu[0],Pos_Text_Densitat[1],0,Tamany_Lletra_Menu);
      }
      else if(Idioma==1)
      {
	escriure("Densitat: ",Pos_Text_Densitat[0],Pos_Text_Densitat[1],0,Tamany_Lletra_Menu);
	escriure("(Sols per al voxels) (g/cm^3)",0.433333*Dimensions_Menu[0],Pos_Text_Densitat[1],0,Tamany_Lletra_Menu);
      }
      else if(Idioma==2)
      {
	escriure("Densidad: ",Pos_Text_Densitat[0],Pos_Text_Densitat[1],0,Tamany_Lletra_Menu);
	escriure("(Solo para voxeles) (g/cm^3)",0.433333*Dimensions_Menu[0],Pos_Text_Densitat[1],0,Tamany_Lletra_Menu);
      }	
      //Material//
      
      AuxString.clear();
      IndexChar=0;
      	while(IMatSecEsfChar[IndexChar]!='V' && IndexChar<2)		//Mira quina posició és la primera buida (Amb una 'V')
	{
	  IndexChar++;
	}
	
	  j=0;
	  while(j<IndexChar)
	  {
	    AuxString+=IMatSecEsfChar[j];
	    j++;
	  }
	
	MatDens[0].Escriure(AuxString,Tamany_Lletra_Quadres_Dades);      
	
	AuxString.clear();
	
	//Densitat//
	
	j=0;
	IndexChar=0;
	while(IDensSecEsfChar[IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
	{
	  IndexChar++;
	}
	
	AuxString.clear();
	
	if(IndexChar<7)
	{
	  j=0;
	  while(j<IndexChar)
	  {
	    AuxString+=IDensSecEsfChar[j];
	    j++;
	  }
	}else
	{
	  j=5;
	  while(j>0)
	  {
	    AuxString+=IDensSecEsfChar[IndexChar-j];
	    j--;
	  }
	}
	MatDens[1].Escriure(AuxString,Tamany_Lletra_Quadres_Dades);
	AuxString.clear();
    MatDens[0].Mostra();
    MatDens[1].Mostra();  
///////////////////////////////////////////////////////////////////////////////////////////      
///////////////////////////////////Direcció ///////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////
    IndexChar=0;
      glColor3f(1,1,1);
      if(Idioma==0)
      {
	escriure("Direction: (",Pos_Text_Angles[0],Pos_Text_Angles[1],0,Tamany_Lletra_Menu);
      }
      else if(Idioma==1)
      {
	escriure("Direccio: (",Pos_Text_Angles[0],Pos_Text_Angles[1],0,Tamany_Lletra_Menu);	
      }
      else if(Idioma==2)
      {
	escriure("Direccion: (",Pos_Text_Angles[0],Pos_Text_Angles[1],0,Tamany_Lletra_Menu);
      }      
      
      glColor3f(1,1,1);
      escriure(",",0.38333*Dimensions_Menu[0],Pos_Text_Angles[1],0,Tamany_Lletra_Menu);

      glColor3f(1,1,1);
      escriure(",",0.55*Dimensions_Menu[0],Pos_Text_Angles[1],0,Tamany_Lletra_Menu);

      glColor3f(1,1,1);
      escriure(")",0.72*Dimensions_Menu[0],Pos_Text_Angles[1],0,Tamany_Lletra_Menu);
      
      i=0;
      while(i<3)
      {
	j=0;
	IndexChar=0;
	while(IAnglesSecEsfChar[i][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
	{
	  IndexChar++;
	}
	
	AuxString.clear();
	
	if(IndexChar<7)
	{
	  j=0;
	  while(j<IndexChar)
	  {
	    AuxString+=IAnglesSecEsfChar[i][j];
	    j++;
	  }
	}else
	{
	  j=5;
	  while(j>0)
	  {
	    AuxString+=IAnglesSecEsfChar[i][IndexChar-j];
	    j--;
	  }
	}
	Angles[i].Escriure(AuxString,Tamany_Lletra_Quadres_Dades);
	i++;
      }
      
      Angles[0].Mostra();
      Angles[1].Mostra();
      Angles[2].Mostra();
      glColor3f(1,1,1);   
      
    
    /////////////////////////////////Boto Crear/////////////////////////////////////////////////////////
      Crear.Mostra();

    }


    
    
  glEnable(GL_LIGHTING);
  glEnable(GL_LIGHT0);
}

//-------------------------------------Funció menu guardar/carregar-------------------------------------------

void MostrarMenu2()
{
  GLfloat ColorBotons[3]={1,1,1};
  GLfloat ColorTextnou[4]={1,1,1,1};
  
  ///////////////////////////////Carreguem la textura dels botons//////////////////////////////////
  if(CarregarTexturaFinestra==true)
  {
    std::ifstream DirTexMenu(NomArxiuTexturaBotonsFinestra.c_str());
    //Obrim ara l'arxiu amb la textura dels botons menuts i fem el mateix procediment que la resta de  carregues de textura
    if(DirTexMenu.is_open())
    {
      //Una vegada comprovat que s'ha obert correctament creem un buffer on guardarem la textura
      float *buffer = new float[DimTexturaBotonsFinestra[0]*DimTexturaBotonsFinestra[1]*NumSamplesTexBotonsFinestra];
      int ContBuffer=0;
      int i=0;
      while(i<DimTexturaBotonsFinestra[0])
      {
	int j=0;
	while(j<DimTexturaBotonsFinestra[1])
	{
	  std::string AuxLinia;
	  int z=0;
	  while(z<NumSamplesTexBotonsFinestra)
	  {
	    float AuxFloat=0;
	    char AuxChar;
	    
	    DirTexMenu>>AuxFloat;
	    DirTexMenu>>AuxChar;
	    
	    buffer[ContBuffer]=AuxFloat;
	    ContBuffer++;
	    z++;
	  }
	  getline(DirTexMenu,AuxLinia);
	  j++;
	}
	i++;
      }
      //Tanquem l'arxiu
      DirTexMenu.close();
      //Generem i carreguem la textura
      glDeleteTextures(1,&TexturaBotonsFinestra);
      glGenTextures(1,&TexturaBotonsFinestra);
      glBindTexture(GL_TEXTURE_2D, TexturaBotonsFinestra);
      
      //Carreguem la textura
      glTexImage2D(GL_TEXTURE_2D,0,3,DimTexturaBotonsFinestra[0],DimTexturaBotonsFinestra[1],0,GL_RGB,GL_FLOAT,buffer);
      //Eliminem el buffer
      delete[] buffer;
      //Diem que la textura no es repetisca, tant en l'eix horitzontal (s) com en el vertical (t)
      glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
      glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);      
      // when texture area is small, bilinear filter the closest mipmap
      glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR );
      // when texture area is large, bilinear filter the first mipmap
      glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR );
      

      CarregarTexturaFinestra=false;
    }    
  }
  ///////////////////////////////Creem els botons del menu/////////////////////////////////////////
  if(menuCreat2==false)
  {    
    BGuardar2.Moure(AMPLADA2-TamanyBotons[0]*0.5,TamanyBotons[1]*2,5);
    BGuardar2.Tamany(TamanyBotons[0]*0.5,TamanyBotons[1]);
    BGuardar2.ColorInt(ColorBotons);
    BGuardar2.ColorLletra(ColorTextnou);
    BGuardar2.ActivarTextura(1,TexturaBotonsFinestra,TamanyBotons[0]*0.5,TamanyBotons[1]);
        
    BCancelar2.Moure(AMPLADA2-TamanyBotons[0]*0.5*2-10,TamanyBotons[1]*2,5);
    BCancelar2.Tamany(TamanyBotons[0]*0.5,TamanyBotons[1]);
    BCancelar2.ColorInt(ColorBotons);
    BCancelar2.ColorLletra(ColorTextnou);
    BCancelar2.ActivarTextura(1,TexturaBotonsFinestra,TamanyBotons[0]*0.5,TamanyBotons[1]);
    
    BBorrar2.Moure(AMPLADA2-TamanyBotons[0]*0.5*3-20,TamanyBotons[1]*2,5);
    BBorrar2.Tamany(TamanyBotons[0]*0.5,TamanyBotons[1]);
    BBorrar2.ColorInt(ColorBotons);
    BBorrar2.ColorLletra(ColorTextnou);
    BBorrar2.ActivarTextura(1,TexturaBotonsFinestra,TamanyBotons[0]*0.5,TamanyBotons[1]);
    
    BINomArxiu2.Moure(AMPLADA2/4.5+5,TamanyBotons[1]*2,5);
    BINomArxiu2.Tamany(AMPLADA2/2.5,20);
    
    BCarregar2.Moure(AMPLADA2-TamanyBotons[0]*0.5,TamanyBotons[1]*2,5);
    BCarregar2.Tamany(TamanyBotons[0]*0.5,TamanyBotons[1]);
    BCarregar2.ColorInt(ColorBotons);
    BCarregar2.ColorLletra(ColorTextnou);
    BCarregar2.ActivarTextura(1,TexturaBotonsFinestra,TamanyBotons[0]*0.5,TamanyBotons[1]);    

    if(Idioma==0)
    {
      BGuardar2.Escriure(" Save",Tamany_Lletra_Botons_Menu);
      BCancelar2.Escriure(" Cancel",Tamany_Lletra_Botons_Menu); 
      BBorrar2.Escriure(" Delete",Tamany_Lletra_Botons_Menu);     
      BCarregar2.Escriure(" Open",Tamany_Lletra_Botons_Menu);    
    }
    else if(Idioma==1)
    {
      BGuardar2.Escriure(" Desa",Tamany_Lletra_Botons_Menu);
      BCancelar2.Escriure(" Cancelar",Tamany_Lletra_Botons_Menu); 
      BBorrar2.Escriure(" Borrar",Tamany_Lletra_Botons_Menu);     
      BCarregar2.Escriure(" Obri",Tamany_Lletra_Botons_Menu);    
    }
    else if(Idioma==2)
    {
      BGuardar2.Escriure(" Guardar",Tamany_Lletra_Botons_Menu);
      BCancelar2.Escriure(" Cancelar",Tamany_Lletra_Botons_Menu); 
      BBorrar2.Escriure(" Borrar",Tamany_Lletra_Botons_Menu);     
      BCarregar2.Escriure(" Abrir",Tamany_Lletra_Botons_Menu);    
    }      
    
    //Buidem el INomArxiuChar

      INomArxiuChar[0]='\0';
    

    menuCreat2=true;
  }

  ///////////////////////////////////////////////////////////////////////////////////////////////////
  ///////////////////////////////////Crear botons de guardar geometria///////////////////////////////
  ///////////////////////////////////////////////////////////////////////////////////////////////////
  //GUARDAR GEOMENTRA, GEOMETRIAPENELOPE, VOXELSPENELOPE//
  if(ControlMenu==4 || ControlMenu==5)
  {
    if(ControlSubMenu==1 || ControlMenu==5)
    {
      glColor3f(0,0.7,0);
      escriure(".txt",AMPLADA2/4.5+AMPLADA2/4-0.06666*Dimensions_Menu[0],TamanyBotons[1]*2-0.01*Dimensions_Menu[0],0.1,Tamany_Lletra_Menu);
    }else if(ControlSubMenu==2)
    {
      glColor3f(0,0.7,0);
      escriure(".geo",AMPLADA2/4.5+AMPLADA2/4-0.06666*Dimensions_Menu[0],TamanyBotons[1]*2-0.01*Dimensions_Menu[0],0.1,Tamany_Lletra_Menu);    
    }else if(ControlSubMenu==3)
    {
      glColor3f(0,0.7,0);
      escriure(".vox",AMPLADA2/4.5+AMPLADA2/4-0.06666*Dimensions_Menu[0],TamanyBotons[1]*2-0.01*Dimensions_Menu[0],0.1,Tamany_Lletra_Menu);    
    }else if(ControlSubMenu==4)
    {
      glColor3f(0,0.7,0);
      //escriure("",AMPLADA2/4.5+AMPLADA2/4-0.06666*Dimensions_Menu[0],TamanyBotons[1]*2-0.01*Dimensions_Menu[0],0.1,Tamany_Lletra_Menu);    
    }
    
    int IndexChar=0;
    while(INomArxiuChar[IndexChar]!='\0' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
    {
      IndexChar++;
    }    
    std::string AuxString;
    
    int i=0;
    if(IndexChar<33)
    {
      while(i<IndexChar)
      {
	AuxString+=INomArxiuChar[i];
	i++;
      }
    }else
    {
      i=33;
      while(i>0)
      {
	AuxString+=INomArxiuChar[IndexChar-i];
	i--;
      } 
    }
    
    BINomArxiu2.Escriure(AuxString,Tamany_Lletra_Quadres_Dades);
    
    AuxString.clear();
    
    if(ControlMenu==4)
    {
      BGuardar2.Mostra();
    }else if(ControlMenu==5)
    {
      BCarregar2.Mostra();
    }
    BCancelar2.Mostra();
    BINomArxiu2.Mostra();
    BBorrar2.Mostra();
  }
  
}

//-------------------------------------Funcio inici------------------------------------------------------------------------//
void iniciar(void)
{
  //
  glMatrixMode(GL_PROJECTION);			//S'encarrega de moure i transformar la càmera (Les coordenades de la camera)
  glLoadIdentity();
  gluPerspective(45.0f,1.0, 0.01f, 800.0f);		//Parametres de la perspectiva

  glMatrixMode(GL_MODELVIEW);			//S'encarrega de moure i transformar l'espai (Les coordenades de l'espai)
  glLoadIdentity();
  gluLookAt(DimEspai[0]+DimEspai[1]+DimEspai[2],DimEspai[1]*0.5,DimEspai[2]*0.5,DimEspai[0]*0.5,DimEspai[1]*0.5,DimEspai[2]*0.5,0.0,0.0,1.0);		//fixem la camera i el punt on mira
  
  glClearColor(0,0,0,1.0);				//posem el color per defecte
  glClearDepth(1);						//inicialitzem la profunditat
  glEnable(GL_DEPTH_TEST);					//abilitem la profunditat
  glShadeModel(GL_SMOOTH);					//hombres suavisades
  
}
//-------------------------------------Funcio inici finestra guardar/carregar------------------------------------------------------------------------//

void iniciarF2(void)
{
  glMatrixMode(GL_PROJECTION);			//copiem la matriu de projecció i pasem a una perspectiva ortho
  
  glLoadIdentity();
  glOrtho(0,AMPLADA2,0,ALTURA2,-10,10);
  
  glMatrixMode(GL_MODELVIEW);
  
  glLoadIdentity();
  glClearColor(0.3,0.3,1.0,1);
  //glClearColor(0.32,0.34,0.34,1);				//posem el color de fons del menu
  glClearDepth(1);      
  glEnable(GL_DEPTH_TEST);					//abilitem la profunditat
  glShadeModel(GL_SMOOTH);					//hombres suavisades

}
