/////////////////////////////////////////////////////////////////////////////////////
//    This file is part of Voxel Mages 						  ///
//    Copyright (C) 2015 Vicent Gimenez Alventosa				  ///
//										  ///
//    Voxel Mages is free software: you can redistribute it and/or modify	  ///
//    it under the terms of the GNU General Public License as published by	  ///
//    the Free Software Foundation, either version 3 of the License, or		  ///
//    (at your option) any later version.					  ///
//										  ///
//    Foobar is distributed in the hope that it will be useful,			  ///
//    but WITHOUT ANY WARRANTY; without even the implied warranty of		  ///
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the		  ///
//    GNU General Public License for more details.				  ///
//										  ///
//    You should have received a copy of the GNU General Public License		  ///
//    along with Foobar.  If not, see <http://www.gnu.org/licenses/>.		  ///
/////////////////////////////////////////////////////////////////////////////////////    

#include<iostream>
#include<cstdlib>
#include<ctime>
#include<cstdio>
#include<fstream>
#include<cmath>
#include<GL/glut.h>
#include<string>
#include<cstring>
#include<sstream>
#include<fstream>
#include<cctype>
#include <time.h>
//Llibreries d'arxius//
#include <dirent.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <pwd.h>
#include <unistd.h>

#include "dicom.h"
#include "objectes.h"
#include "geometria.h"
#include "menu.h"

#define ORIGENX	100
#define ORIGENY	100
#define DElecW 1	//Definim la densitat electrònica de l'aigua. Aquest valor serveix per a determinar la densitat dels vòxels dels DICOMs

double PROPORCIO_PANTALLA=(double)AMPLADA/(double)ALTURA;

float DistanciaObservadorOrigen;
float FactorMoviment=0.01;              //Controla per quin factor es multiplica la distancia observador-origen per a calcular el moviment
float IncrementMovimentPantalla=0.25;	//Controla el que es mou la pantalla amb les tecles w,s,a,d

float X=0;
float Y=0;
float Z=0;

float X1=0;
float Y1=0;
float Z1=0;

float X2=0;
float Y2=0;
float Z2=0;

float YGC=0;			//Controla el pujar i baixar la finestra amb els noms dels arxius

float angle=0;
float angle1=0;
float angle2=0;

int Pantalla=0;			//Controla quina pantalla estem movent, la 3 és la del menu, (escriure etc)
int PosLlegenda=0;              //Controla la posicio de la llegenda per a poder correr-la i veure tots els objectes d'aquesta
int FigBorrades[1000]={0};	//La posició [0] guarda el nombre de figures que s'han borrat, la resta quina figura s'ha borrat en cada cas.

//Variables que guarden la posició del cursor per a girar la figura.

int PosCursorX;

float PosVisor2D[2]={0,0};
//Variables de control de finestres//

int IdeFinestres[2];		//[0]-> Finestra Principal  [1]-> Finestra de guardar/carregar
//Variables de control de renderitzat

bool RendFinestraGran=true;	//Controlen quines finestres cal renderitzar
bool RendFinestraSup=true;
bool RendFinestraInf=true;
bool RendMenu=true;
bool RendVisor2D=true;

GLuint TexturaFGran;	//variables amb les textures
GLuint TexturaFSup;
GLuint TexturaFInf;
GLuint TexturaVisor2D;
//Variables de control d'errors
int ColorBotoCrear=0;	//Controla si hem de canviar el color del boto crear per a marcar que s'ha realitzat una accio be o hi ha un error [0]->Negre, [1]->Verd (correcte), [2]-> Roig (Error)

//Variables de directoris//


char *Homedir;
char *Actualdir;
std::string Geometriadir;
std::string Programadir;

bool Eixir=false;		//Controla el tancament del programa

//Variables per a la llegenda

int NumMatsCal=0;  //Guarda el nombre de materials que conte un dicom

//Variables per al visor de DICOMs 2D
bool SelPlaTallInf[2]={false,false};	//0 per a l'eix X 1 per a l'eix Y
bool SelPlaTallSup[2]={false,false};	//0 per a l'eix X 1 per a l'eix Y
bool SelBarraVisor=false;
bool ActualitzarPlansVisor2D=true;

float AlturaBarraMobil;
float AmpladaBarreta;

////Funcions////////
void dibuixar(void);
void teclat(unsigned char tecla, int x, int y);
void ratoli(int boto, int estat, int x, int y);
void MovRatoli(int x, int y);
void TeclatEsp(int tecla, int x, int y);

void FGuardarCarregar(void);
void FTeclatEsp(int tecla, int x, int y);
void Fteclat(unsigned char tecla, int x, int y);

//--------------------------------------Funcio dibuixar----------------------------------------------------------------------//

void dibuixar(void)
{

  //Iniciem les matrius de posicio etc per a tornar a la posicio correcta si no estem pintant un dicom
  //if(PintarDicom==false)
  //{
      //iniciar();
  //}
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  //glPushMatrix();				//Copiem la matriu
  //glLoadIdentity();				//Carreguem la identitat per a dibuixar be els objectes
  
/////////////////////////////////////////////////////ILUMINACIO/////////////////////////////////////////////////////////////////////////


  glEnable(GL_LIGHTING);					//Activar la iluminació
  
  GLfloat LlumAmbient[4]={0.2, 0.2, 0.2, 1.0};			//posem el color i intensitat de la llum ambient
  GLfloat ColorLlum[4]={1.0,1.0,1.0,1.0};			//Color i intensitat de la llum difusa
  GLfloat PosLlum[4]={GLfloat(DimEspai[0]/2.0),GLfloat(DimEspai[1]/2.0),GLfloat(DimEspai[2]),1.0};		//posicio de la llum
  GLfloat ColorSpecular[4]={1,1,1,1.0};			//Color de la llum especular
   
  glLightModelfv (GL_LIGHT_MODEL_AMBIENT, LlumAmbient);	//Fixem la llum ambiental
  glLightModeli(GL_LIGHT_MODEL_LOCAL_VIEWER, GL_TRUE);	//Coloca el punt de vista per a la iluminacio en (0,0,0)
  
  glLightfv(GL_LIGHT0,GL_DIFFUSE,ColorLlum);			//definim la llum difusa
  glLightfv(GL_LIGHT0,GL_POSITION,PosLlum);			//definim la posicio de la font
  glLightfv(GL_LIGHT0,GL_SPECULAR,ColorSpecular);		//definim la llum especular
  glLightf(GL_LIGHT0,GL_SHININESS,100);				//definim la quantitat de llum especular
  glLightf(GL_LIGHT0,GL_LINEAR_ATTENUATION,0.02);				//Atenuacio de la llum	posar baixet!!!
  glLightf(GL_LIGHT0,GL_SPOT_CUTOFF,180);
  //glLightf(GL_LIGHT0,GL_SPOT_DIRECTION,50);
 
///////////////////////////////////////////////////Final iluminació/////////////////////////////////////////////////////////////////////


////////////////////PASEM A COMPROVAR QUE LA FINESTRA TE LES DIMENSIONS QUE TOCA////////////////////////////////////////////////////////

  //std::cout<<"("<<DimEspai[0]<<","<<DimEspai[1]<<","<<DimEspai[2]<<")"<<std::endl;
  int Amplada_Actual;
  int Altura_Actual;
  Amplada_Actual=glutGet(GLUT_WINDOW_WIDTH);
  Altura_Actual=glutGet(GLUT_WINDOW_HEIGHT);

  if(Amplada_Actual!=AMPLADA || Altura_Actual!=ALTURA)
    {
      glutReshapeWindow(AMPLADA,ALTURA);

      Proporcio_Lletra=(float)AMPLADA/(float)AMPLADA_INICIAL;
      menuCreat=false;
      menuCreat2=false;
      //Redimensionem les coses
      AMPLADA2=AMPLADA*AMPLADA_PANTALLA_GUARDAR_CARREGAR;
      ALTURA2=ALTURA*ALTURA_PANTALLA_GUARDAR_CARREGAR;

      //Redimensionem la finestra de guardar/carregar
      glutSetWindow(IdeFinestres[1]);
      glutReshapeWindow(AMPLADA2,ALTURA2);
      glutPositionWindow(AMPLADA/4.0,ALTURA/6.0);
      glutSetWindow(IdeFinestres[0]);

      glutReshapeWindow(AMPLADA,ALTURA);
      //L'origen es el canto esquerra inferior

      Dimensions_Pantalla_Gran[0]=AMPLADA*AMPLADA_PANTALLA_GRAN;
      Dimensions_Pantalla_Gran[1]=ALTURA*ALTURA_PANTALLA_GRAN;
 
      Origen_Pantalla_Gran[0]=AMPLADA*ORIGEN_PANTALLA_GRAN_X;
      Origen_Pantalla_Gran[1]=ALTURA*ORIGEN_PANTALLA_GRAN_Y;

      Dimensions_Pantalla_Menuda[0]=AMPLADA*AMPLADA_PANTALLA_MENUDA;
      Dimensions_Pantalla_Menuda[1]=ALTURA*ALTURA_PANTALLA_MENUDA;

      Origen_Pantalla_Inferior[0]=AMPLADA*ORIGEN_PANTALLA_INFERIOR_X;
      Origen_Pantalla_Inferior[1]=ALTURA*ORIGEN_PANTALLA_INFERIOR_Y;

      Origen_Pantalla_Superior[0]=AMPLADA*ORIGEN_PANTALLA_SUPERIOR_X;
      Origen_Pantalla_Superior[1]=ALTURA*ORIGEN_PANTALLA_SUPERIOR_Y;

      Dimensions_Menu[0]=AMPLADA*AMPLADA_MENU;
      Dimensions_Menu[1]=ALTURA*ALTURA_MENU;
   
      Origen_Menu[0]=AMPLADA*ORIGEN_MENU_X;
      Origen_Menu[1]=ALTURA*ORIGEN_MENU_Y;

      Dimensions_Visor2D[0]=AMPLADA*AMPLADA_VISOR_2D;
      Dimensions_Visor2D[1]=ALTURA*ALTURA_VISOR_2D;
 
      Origen_Visor2D[0]=AMPLADA*ORIGEN_VISOR_2D_X;
      Origen_Visor2D[1]=ALTURA*ORIGEN_VISOR_2D_Y;

      AmpladaVisor2D=Dimensions_Visor2D[0]*(1-0.01); //L'amplada del visor no inclou l'amplada de la barra
      AlturaVisor2D=Dimensions_Visor2D[1];

      RendFinestraGran=true;
      RendFinestraInf=true;
      RendFinestraSup=true;
      RendVisor2D=true;
      glutPostRedisplay();
      
    }
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  
if(ActivarVisor2D==true)
{
  
  //Diguem que no ha de pintar l'espai
  PintEsp=false;
  ////////////////////////////////////
 
 //Pantalla del visor 2D de DICOMs/////////////////////////////////////////////////////////////////////////////////
  glViewport(Origen_Visor2D[0],Origen_Visor2D[1],Dimensions_Visor2D[0],Dimensions_Visor2D[1]);
  glScissor(Origen_Visor2D[0],Origen_Visor2D[1],Dimensions_Visor2D[0],Dimensions_Visor2D[1]);
  glEnable(GL_SCISSOR_TEST);  

  glMatrixMode(GL_PROJECTION);			//copiem la matriu de projecció i pasem a una perspectiva ortho
  glPushMatrix();
  
  glLoadIdentity();
  glOrtho(0,Dimensions_Visor2D[0],0,Dimensions_Visor2D[1],-10,10);
  
  glMatrixMode(GL_MODELVIEW);
  glPushMatrix();
  
  glLoadIdentity();
  glClearColor(0.32,0.34,0.34,1);				//posem el color de fons del menu
  glClearDepth(1);      
   
  if(RendVisor2D==true)
  {
    RendVisor2D=false;
    mostrar();				//Funcio en geometria.cpp que crea el menu
    
    //Guardem ara la textura
      //Activem la textura corresponent
      glDeleteTextures(1,&TexturaVisor2D);
      glGenTextures(1,&TexturaVisor2D);
      glBindTexture(GL_TEXTURE_2D, TexturaVisor2D);
      //Fem una copia de la imatge a la textura
      glCopyTexImage2D(GL_TEXTURE_2D,0,GL_RGB,Origen_Visor2D[0],Origen_Visor2D[1],AmpladaVisor2D,AlturaVisor2D,0);	//Important, açò ha d'estar després del glBind o no ho eixirà be
            
      //Diem que la textura no es repetisca, tant en l'eix horitzontal (s) com en el vertical (t)
      glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
      glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);      
      // when texture area is small, bilinear filter the closest mipmap
      glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR );
      // when texture area is large, bilinear filter the first mipmap
      glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR );
    
      glDisable(GL_LIGHT0);				//Desactivem la llum per a colorejar el text
      glDisable(GL_LIGHTING);
  }
  else
  {
    glDisable(GL_LIGHT0);
    glDisable(GL_LIGHTING); 
    
    
    //Activem la textura corresponent i la carreguem
    glEnable(GL_TEXTURE_2D);
    glBindTexture(GL_TEXTURE_2D, TexturaVisor2D);

    glBegin(GL_QUADS);
      glColor3f(1,1,1);
      glTexCoord2f(0.0f,0.0f);glVertex3f(0,0,0);

      glTexCoord2f(1.0f,0.0f);glVertex3f(AmpladaVisor2D,0,0);

      glTexCoord2f(1.0f,1.0f);glVertex3f(AmpladaVisor2D,AlturaVisor2D,0);

      glTexCoord2f(0.0f,1.0f);glVertex3f(0,AlturaVisor2D,0);
      
    glEnd();
    
    glDisable(GL_TEXTURE_2D);
    
  }
  //Escrivim la llegenda en blanc
  glPushMatrix();
  glLoadIdentity();

  //Escrivim la llegenda dels contorns si esta activa l'opcio de pintarlos
  if(Nombre_Contorns>0 && DibuixarContorns==true)
    {
      int i=0;
      while(i<Nombre_Contorns)
	{
	  std::string AuxString(Nom_Contorn[i]);
	  glColor3f(float(Color_Contorn[i][0])/255.0,float(Color_Contorn[i][1])/255.0,float(Color_Contorn[i][2])/255.0);

	  escriure(AuxString,0.018*AMPLADA,ALTURA-(i+1)*0.03375*ALTURA,3,Tamany_Lletra_Pantalla_Geometria);
	  
	  glColor3f(0,0,0);
	  i++;
	}
    }
  glColor3f(1,1,1);
  glTranslatef(0.006666*Dimensions_Visor2D[0],0.0125*Dimensions_Visor2D[1],1);
      
  char AuxChar[200];
  
  sprintf(AuxChar,"X=%.2f Y=%.2f cm     Frame Num: %i",PosVisor2D[0],PosVisor2D[1],PlaVisor2D);
  std::string AuxString(AuxChar);
  escriure2(AuxString,0,0,0,Tamany_Lletra_Pantalla_Geometria);
      
  glPopMatrix();
  //Dibuixem un rectangle que marcara la regio que delimiten els plans de tall
  float SelDicomSup[2]={0,0};
  float SelDicomInf[2]={0,0};
      
  SelDicomSup[0]=float(AmpladaVisor2D/DimPlaDicom[0])*PlansTall[0];
  SelDicomSup[1]=float(AlturaVisor2D/DimPlaDicom[1])*PlansTall[1];	
  SelDicomInf[0]=float(AmpladaVisor2D/DimPlaDicom[0])*PlansTallInf[0];
  SelDicomInf[1]=float(AlturaVisor2D/DimPlaDicom[1])*PlansTallInf[1];
      
  if(ActualitzarPlansVisor2D==true)
    {
      //Canviem les variables de Introduir Plans de tall per a que tinguen aquests valors
      sprintf(IPlansTallChar[0],"%.2f",PlansTall[0]);
      sprintf(IPlansTallChar[1],"%.2f",PlansTall[1]);
      sprintf(IPlansTallChar[2],"%.2f",PlansTall[2]);
	
      sprintf(IPlansTallCharInf[0],"%.2f",PlansTallInf[0]);
      sprintf(IPlansTallCharInf[1],"%.2f",PlansTallInf[1]);
      sprintf(IPlansTallCharInf[2],"%.2f",PlansTallInf[2]);
	
      ActualitzarPlansVisor2D=false;
    }
  ////////////////////////////////////////////////////////
  //Dibuixem el recuadre que delimita els  plans de tall//
  ////////////////////////////////////////////////////////
  glColor3f(0,0,0);
  glBegin(GL_LINE_STRIP);
  glVertex3f(SelDicomSup[0],SelDicomSup[1],0.05);
  glVertex3f(SelDicomSup[0],SelDicomInf[1],0.05);
  glVertex3f(SelDicomInf[0],SelDicomInf[1],0.05);
  glVertex3f(SelDicomInf[0],SelDicomSup[1],0.05);
  glVertex3f(SelDicomSup[0],SelDicomSup[1],0.05);
  glEnd();
      
  /////////////////////////////////////////////////////////////
  //Dibuixem ara la barreta per a canviar de pla de la imatge//
  /////////////////////////////////////////////////////////////
  float NumPlans=float(DimEspaiDicom[2]/DimPlaDicom[2]);
  AmpladaBarreta=Dimensions_Visor2D[0]-AmpladaVisor2D;
  AlturaBarraMobil=float((AlturaVisor2D-2*AmpladaBarreta*0.21)/NumPlans);
  float PosBarraMobil=PlaVisor2D*AlturaBarraMobil+AlturaBarraMobil*0.5;
  //Contorn
  glBegin(GL_QUADS);
  glColor3f(0.3,0.3,0.3);
  glVertex3f(AmpladaVisor2D,0,0.04);
  glVertex3f(AmpladaVisor2D,AlturaVisor2D,0.04);
  glVertex3f(Origen_Menu[0],AlturaVisor2D,0.04);
  glVertex3f(Origen_Menu[0],0,0.04);
  glEnd();
      
  //Interior
  glBegin(GL_QUADS);
  glColor3f(0.8,0.8,0.8);
  glVertex3f(AmpladaVisor2D+AmpladaBarreta*0.2,AmpladaBarreta*0.2,0.05);
  glVertex3f(AmpladaVisor2D+AmpladaBarreta*0.2,AlturaVisor2D-AmpladaBarreta*0.2,0.05);
  glColor3f(0.5,0.5,0.5);
  glVertex3f(Origen_Menu[0]-AmpladaBarreta*0.2,AlturaVisor2D-AmpladaBarreta*0.2,0.05);
  glVertex3f(Origen_Menu[0]-AmpladaBarreta*0.2,AmpladaBarreta*0.2,0.05);
  glEnd();
      
  //Barreta mobil
  glBegin(GL_QUADS);
  glColor3f(0.8,0.8,0.8);
  glVertex3f(AmpladaVisor2D+AmpladaBarreta*0.21,AmpladaBarreta*0.21+PosBarraMobil-AlturaBarraMobil*0.5,0.06);
  glVertex3f(AmpladaVisor2D+AmpladaBarreta*0.21,AmpladaBarreta*0.21+PosBarraMobil+AlturaBarraMobil*0.5,0.06);
  glColor3f(0.9,0.9,0.9);
  glVertex3f(Origen_Menu[0]-AmpladaBarreta*0.21,AmpladaBarreta*0.21+PosBarraMobil+AlturaBarraMobil*0.5,0.06);
  glVertex3f(Origen_Menu[0]-AmpladaBarreta*0.21,AmpladaBarreta*0.21+PosBarraMobil-AlturaBarraMobil*0.5,0.06);
  glEnd();      
  //////////////////////////////////////////////////////////////
  glMatrixMode(GL_PROJECTION);
  glPopMatrix();  
  glMatrixMode(GL_MODELVIEW);
  glPopMatrix();  
  glDisable(GL_SCISSOR_TEST);
  
  glClearColor(1,1,1,1);  //Color de les separacions entre pantalles
  glEnable(GL_LIGHT0);				//Desactivem la llum per a colorejar el text
  glEnable(GL_LIGHTING);

  //PlaVisor2D
 }
 else
   {
     //Diguem que ha de pintar l'espai
     PintEsp=true;
     ///////////////////////////////
     if(RendFinestraGran==true)
       {  
	 //Pantalla gran///////////////////////////////////////////////////////////////////////////
	 glViewport(Origen_Pantalla_Gran[0],Origen_Pantalla_Gran[1],Dimensions_Pantalla_Gran[0],Dimensions_Pantalla_Gran[1]);
	 glScissor(Origen_Pantalla_Gran[0],Origen_Pantalla_Gran[1],Dimensions_Pantalla_Gran[0],Dimensions_Pantalla_Gran[1]);		//evita que es modifiquen les imatges dels altres viewports
	 glEnable(GL_SCISSOR_TEST);		//ho activem
	 glMatrixMode(GL_MODELVIEW);  
	 glPushMatrix();			//copiem la matriu per a fer transformacions i no pedre l'original
	 PosLlum[0]=DimEspai[0]+DimEspai[1]+DimEspai[2];	//Movem la llum on es troba la camera
	 PosLlum[1]=DimEspai[1]/2.0;
	 PosLlum[2]=DimEspai[2]/2.0;		//Posem la llum sobre la càmera
	 glLightfv(GL_LIGHT0,GL_POSITION,PosLlum);
    
	 glTranslatef(X,Y,Z);

    //Per a rotar hem de saber si estem vegent un Dicom o no
    if(PintarDicom==true)
    {
      glTranslatef(DimEspaiDicom[0]/2.0,DimEspaiDicom[1]/2.0,DimEspaiDicom[2]/2.0);   //Tornem a l'origen
      glRotatef(angle,0,0,1);						//Rotem
      glTranslatef(-DimEspaiDicom[0]/2.0,-DimEspaiDicom[1]/2.0,-DimEspaiDicom[2]/2.0); 	//Pasem al centre de l'espai per a rotar al voltant d'aquest
      glClearColor(1,1,1,1.0);		//Color de fons    
    }else
    {
      glTranslatef(DimEspai[0]/2.0,DimEspai[1]/2.0,DimEspai[2]/2.0);   //Tornem a la situacio inicial
      glRotatef(angle,0,0,1);						//Rotem
      glTranslatef(-DimEspai[0]/2.0,-DimEspai[1]/2.0,-DimEspai[2]/2.0); //Translladem el centre de l'espai (l'espai del programa delimitat per les linies) al (0,0,0) per a rotar respecte al centre
      glClearColor(1,1,1,1.0);		//Color de fons
    }
    mostrar();				//Dibuixem les fiugures

    glDisable(GL_LIGHT0);				//Desactivem la llum per a colorejar el text
    glDisable(GL_LIGHTING);
    
    glMatrixMode(GL_PROJECTION);			//copiem la matriu de projecció i pasem a una perspectiva ortho
    glPushMatrix();
    glLoadIdentity();
    glOrtho(0,Dimensions_Pantalla_Gran[0],0,Dimensions_Pantalla_Gran[1],-10,10);  
    
    glMatrixMode(GL_MODELVIEW);			//S'encarrega de moure i transformar l'espai (Les coordenades de l'espai)
    glPushMatrix();				//Fem un altra copia de la matriu perque anem a llevar les llums per a pintar la llegenda
    glLoadIdentity();
    

    
    int j=0;
    int i=1;
    int NumBorrades=0;					//Conta les borrades per a no deixar espais en blanc al pintar la llegenda
    if(ControlMenu==9)
    {
      float AmpladaLlegenda=10;
      float AlturaLlegenda=600;
      float OrigenLlegenda[2]={650,100};
      float DistVerticaLlegenda=AlturaLlegenda*1.0/NumColorsResultats;
      j=0;
      while(j<NumColorsResultats)
      {
	//Asignem el color i pintem el quadre de la llegenda
	glColor3f(ColorsResultats[j][0],ColorsResultats[j][1],ColorsResultats[j][2]);
	glBegin(GL_POLYGON);
	  glVertex3f(OrigenLlegenda[0],OrigenLlegenda[1]+j*DistVerticaLlegenda, 1);
	  glVertex3f(OrigenLlegenda[0],OrigenLlegenda[1]+(j+1)*DistVerticaLlegenda, 1);
	  glVertex3f(OrigenLlegenda[0]+AmpladaLlegenda,OrigenLlegenda[1]+(j+1)*DistVerticaLlegenda, 1);
	  glVertex3f(OrigenLlegenda[0]+AmpladaLlegenda,OrigenLlegenda[1]+j*DistVerticaLlegenda, 1);
	  glVertex3f(OrigenLlegenda[0],OrigenLlegenda[1]+j*DistVerticaLlegenda, 1);
	glEnd();
	//Escrivim a la llegenda el valor dels intervals
	char auxChar[20];
	float auxFloat=MinDosis+IntervalColorResultats*j;
	std::string AuxString;
	
	if(EscalaLog==false)
	{
	  sprintf(auxChar,"%.2E eV/g",auxFloat);
	}
	else if(EscalaLog==true)
	{
	  sprintf(auxChar,"log (%.2E eV/g)",auxFloat);
	}
	AuxString=auxChar;
	glColor3f(0,0,0);
	escriure(AuxString,OrigenLlegenda[0]+AmpladaLlegenda+1,OrigenLlegenda[1]+j*DistVerticaLlegenda,1,Tamany_Lletra_Pantalla_Geometria);
	if(j==(NumColorsResultats-1))
	{
	  glColor3f(0,0,0);

	  auxFloat=MinDosis+IntervalColorResultats*(j+1);
	  AuxString.clear();
		  
	  if(EscalaLog==false)
	  {
	    sprintf(auxChar,"%.2E eV/g",auxFloat);
	  }
	  else if(EscalaLog==true)
	  {
	    sprintf(auxChar,"log (%.2E eV/g)",auxFloat); 
	  }
	  AuxString=auxChar;
	  escriure(AuxString,OrigenLlegenda[0]+AmpladaLlegenda+1,OrigenLlegenda[1]+1+(j+1)*DistVerticaLlegenda,1,Tamany_Lletra_Pantalla_Geometria);
	  glColor3f(0,0,0);
	}
	
	j++;
      }
    }
    else if(PintObMat==0 && PintObjectes==true)		//Pinta la llegenda, de materials o de objectes
    {
      while(i<=NumTotalFig)				//Escriu la llegenda d'objectes
      {
	bool borrada=false;				//Controla si aquest objecte s'ha borrat
	j=1;
	while(j<=FigBorrades[0])				//Busquem en el vector de figures borrades
	{
	  if(FigBorrades[j]==i)				//Si la figura en questió es troba entre les borrades es saltarà
	  {
	    borrada=true;
	    NumBorrades++;
	    break;
	  }
	  j++;
	}
	if(borrada==true)
	{
	  i++;
	  continue;
	}
	int NumChar=0;
	char a[3];
	NumChar=sprintf(a, "%d", i);
	//Omplim amb espais els llocs sense número
	if(NumChar==1)
	{
	  a[1]=' ';
	  a[2]=' ';
	}
	else if(NumChar==2)
	{
	  a[2]=' ';
	}
	glColor3f(Colors[i][0],Colors[i][1],Colors[i][2]);
	std::string AuxString;
      
	if(Idioma==0)
	{
	  AuxString="Object: ";
	}
	else if(Idioma==1)
	{
	  AuxString="Objecte: ";
	}
	else if(Idioma==2)
	{
	  AuxString="Objeto: ";
	}
	j=0;
	while(j<3)
	{
	  AuxString+=a[j];
	  j++;
	}
	escriure(AuxString,0.018*AMPLADA,ALTURA-(i-NumBorrades-PosLlegenda)*0.03375*ALTURA,0,Tamany_Lletra_Pantalla_Geometria);
      AuxString.clear();
	i++;
      }
    }else if(PintObMat==1 || ( PintVox==true && PintObjectes==false) || (PintVQuad==true && PintObjectes==false))
    {
      if(PintarDicom==false)
      {
	while(i<=MaxMaterial)				//Escriu la llegenda de materials
	{
	  int NumChar=0;
	  char a[3];
	  NumChar=sprintf(a, "%d", i);
	  //Omplim amb espais els llocs sense número
	  if(NumChar==1)
	  {
	    a[1]=' ';
	    a[2]=' ';
	  }
	  else if(NumChar==2)
	  {
	    a[2]=' ';
	  }      
	  glColor3f(Colors[i][0],Colors[i][1],Colors[i][2]);
	  std::string AuxString;
	  if(Idioma==0)
	  {
	    AuxString="Material: ";
	  }
	  else if(Idioma==1)
	  {
	    AuxString="Material: ";
	  }
	  else if(Idioma==2)
	  {
	    AuxString="Material: ";
	  }    
	  j=0;
	  while(j<3)
	  {
	    AuxString+=a[j];
	    j++;
	  }
	  escriure(AuxString,0.018*AMPLADA,ALTURA-i*0.03375*ALTURA,0,Tamany_Lletra_Pantalla_Geometria);
	  AuxString.clear();
	  i++;
	}
      }
      else if(PintarDicom==true)
      {
	if(PintMatDicom==true)
	{
	  while(i<=NumMatsCal)				//Escriu la llegenda de materials
	  {
	    int NumChar=0;
	    char a[3];
	    NumChar=sprintf(a, "%d", i);
	    //Omplim amb espais els llocs sense número
	    if(NumChar==1)
	    {
	      a[1]=' ';
	      a[2]=' ';
	    }
	    else if(NumChar==2)
	    {
	      a[2]=' ';
	    }      
	    glColor3f(Colors[i][0],Colors[i][1],Colors[i][2]);
	    std::string AuxString;
	    if(Idioma==0)
	    {
	      AuxString="Material: ";
	    }
	    else if(Idioma==1)
	    {
	      AuxString="Material: ";
	    }
	    else if(Idioma==2)
	    {
	      AuxString="Material: ";
	    }    
	    j=0;
	    while(j<3)
	    {
	      AuxString+=a[j];
	      j++;
	    }
	    escriure(AuxString,0.018*AMPLADA,ALTURA-i*0.03375*ALTURA,0,Tamany_Lletra_Pantalla_Geometria);
	    i++;
	  }
	}
	else if(PintDensDicom==true)
	{
	    float AmpladaLlegenda=0.0067*AMPLADA;
	    float AlturaLlegenda=0.75*ALTURA;
	    float OrigenLlegenda[2]={float(0.43*AMPLADA),float(0.125*ALTURA)};
	    float DistVerticaLlegenda=AlturaLlegenda*1.0/NumColorsResultats;
	    j=0;
	    while(j<NumColorsResultats)
	    {
	      //Asignem el color i pintem el quadre de la llegenda
	      glColor3f(ColorsResultats[j][0],ColorsResultats[j][1],ColorsResultats[j][2]);
	      glBegin(GL_POLYGON);
		glVertex3f(OrigenLlegenda[0],OrigenLlegenda[1]+j*DistVerticaLlegenda, 1);
		glVertex3f(OrigenLlegenda[0],OrigenLlegenda[1]+(j+1)*DistVerticaLlegenda, 1);
		glVertex3f(OrigenLlegenda[0]+AmpladaLlegenda,OrigenLlegenda[1]+(j+1)*DistVerticaLlegenda, 1);
		glVertex3f(OrigenLlegenda[0]+AmpladaLlegenda,OrigenLlegenda[1]+j*DistVerticaLlegenda, 1);
		glVertex3f(OrigenLlegenda[0],OrigenLlegenda[1]+j*DistVerticaLlegenda, 1);
	      glEnd();
	      //Escrivim a la llegenda el valor dels intervals
	      char auxChar[20];
	      float auxFloat=MinDensDCM+IntervalColorDicom*j;

	      
	      sprintf(auxChar,"%.2E g/cm^3",auxFloat);
	      std::string AuxString(auxChar);
	      glColor3f(0,0,0);
	      escriure(AuxString,OrigenLlegenda[0]+AmpladaLlegenda+1,OrigenLlegenda[1]+j*DistVerticaLlegenda,1,Tamany_Lletra_Pantalla_Geometria);
	      AuxString.clear();
	      if(j==(NumColorsResultats-1))
	      {
		glColor3f(0,0,0);

		auxFloat=MinDensDCM+IntervalColorDicom*(j+1);
		sprintf(auxChar,"%.2E g/cm^3",auxFloat);
		
		AuxString=auxChar;
		escriure(AuxString,OrigenLlegenda[0]+AmpladaLlegenda+1,OrigenLlegenda[1]+1+(j+1)*DistVerticaLlegenda,1,Tamany_Lletra_Pantalla_Geometria);
		glColor3f(0,0,0);
	      }
	      
	      j++;
	    }	  
	}
      }
    }else if(PintObMat==2 && PintObjectes==true)
    {
      i=0;
      MaxPrioritat=0;
      while(i<1000)
      {
	if(PrioritatsAsignades[0][i]>MaxPrioritat)
	{
	  MaxPrioritat=PrioritatsAsignades[0][i];
	}
	if(PrioritatsAsignades[0][i]==0)
	{
	  break;
	}
	i++;
      }
      i=1;
      while(i<=MaxPrioritat)				//Escriu la llegenda de materials
      {
	char a[3];
	sprintf(a, "%d", i);
	glColor3f(Colors[i][0],Colors[i][1],Colors[i][2]);
	std::string AuxString;
	if(Idioma==0)
	{
	  AuxString="Body: ";
	}
	else if(Idioma==1)
	{
	  AuxString="Cos: ";
	}
	else if(Idioma==2)
	{
	  AuxString="Cuerpo: ";
	}

	AuxString.append(a);
	
	escriure(AuxString,0.018*AMPLADA,ALTURA-(i-PosLlegenda)*0.03375*ALTURA,0,Tamany_Lletra_Pantalla_Geometria);           //PosLlegenda ens permetra correr la llegenda per a veure tots els objectes utilitzant les fletxes
	AuxString.clear();
	i++;
      }
    }
    glPopMatrix();				//Tornem a la primera copia de la matriu

    glMatrixMode(GL_PROJECTION);			//Recuperem la matriu de projecció
    glPopMatrix();
    
    glMatrixMode(GL_MODELVIEW);
    glPopMatrix();				//Tornem a la matriu original
    glEnable(GL_LIGHTING);			//Tornem a activar la llum
    glDisable(GL_SCISSOR_TEST);			//Desactivem el test
 }
 else
 {
   //Si no hem de renderitzar de nou, carreguem la textura
   //Pantalla Gran/////////////////////////////////////////////////////////////////////////////////
   glViewport(Origen_Pantalla_Gran[0],Origen_Pantalla_Gran[1],Dimensions_Pantalla_Gran[0],Dimensions_Pantalla_Gran[1]);
   glScissor(Origen_Pantalla_Gran[0],Origen_Pantalla_Gran[1],Dimensions_Pantalla_Gran[0],Dimensions_Pantalla_Gran[1]);		//evita que es modifiquen les imatges dels altres viewports  glEnable(GL_SCISSOR_TEST);  

  glMatrixMode(GL_PROJECTION);			//copiem la matriu de projecció i pasem a una perspectiva ortho
  glPushMatrix();
  
  glLoadIdentity();
  glOrtho(0,Dimensions_Pantalla_Gran[0],0,Dimensions_Pantalla_Gran[1],-10,10);
  
  glMatrixMode(GL_MODELVIEW);
  glPushMatrix();
  
  glLoadIdentity();
 
  glClearColor(0,0,0,1);  //Color de les separacions entre pantalles
  glClearDepth(1);    

  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);    
    glDisable(GL_LIGHT0);
    glDisable(GL_LIGHTING); 
    
    
    //Activem la textura corresponent
    glEnable(GL_TEXTURE_2D);
    glBindTexture(GL_TEXTURE_2D, TexturaFGran);

    glBegin(GL_QUADS);
      glColor3f(1,1,1);
      glTexCoord2f(0.0f,0.0f);glVertex3f(0,0,0);

      glTexCoord2f(1.0f,0.0f);glVertex3f(Dimensions_Pantalla_Gran[0],0,0);

      glTexCoord2f(1.0f,1.0f);glVertex3f(Dimensions_Pantalla_Gran[0],Dimensions_Pantalla_Gran[1],0);

      glTexCoord2f(0.0f,1.0f);glVertex3f(0,Dimensions_Pantalla_Gran[1],0);
      
    glEnd();
    
    glDisable(GL_TEXTURE_2D);
    
    
    glMatrixMode(GL_PROJECTION);
    glPopMatrix();  
    glMatrixMode(GL_MODELVIEW);
    glPopMatrix();  
    glDisable(GL_SCISSOR_TEST);
    
    glClearColor(0,0,0,1);  //Color de les separacions entre pantalles (negre)

    glEnable(GL_LIGHT0);
    glEnable(GL_LIGHTING); 

    
 }
 if(RendFinestraInf==true)
 { 
 //Pantalla de baix////////////////////////////////////////////////////////////////
  glViewport(Origen_Pantalla_Inferior[0],Origen_Pantalla_Inferior[1],Dimensions_Pantalla_Menuda[0],Dimensions_Pantalla_Menuda[1]);
  glScissor(Origen_Pantalla_Inferior[0],Origen_Pantalla_Inferior[1],Dimensions_Pantalla_Menuda[0],Dimensions_Pantalla_Menuda[1]);
  glEnable(GL_SCISSOR_TEST);
  glMatrixMode(GL_MODELVIEW);  
  glPushMatrix(); 
  //Hem de veure si estem veient un Dicom o no per a rotar be
  if(PintarDicom==true)
  {
    //Mou la camera per a que es veja per baix
    glTranslatef(DimEspaiDicom[0]+DimEspaiDicom[1]+DimEspaiDicom[2],DimEspaiDicom[1]/2.0,DimEspaiDicom[2]/2.0);
    glRotatef(-90,0,1,0);
    glTranslatef(-DimEspaiDicom[0]/2.0,-DimEspaiDicom[0]/2.0,DimEspaiDicom[2]/2.0);
    glTranslatef(X1,Y1,Z1); 

    glTranslatef(DimEspaiDicom[0]/2.0,DimEspaiDicom[1]/2.0,DimEspaiDicom[2]/2.0);   //tornem a la posicio original
    glRotatef(angle1,0,0,1);		//Rotem
    glTranslatef(-DimEspaiDicom[0]/2.0,-DimEspaiDicom[1]/2.0,-DimEspaiDicom[2]/2.0); 	//fem que el centre de l'espai de voxels es situe al origen

    
    glClearColor(1,1,1,1.0);		//Color de fons
  }
  else
  {
    PosLlum[0]=DimEspai[0]+DimEspai[1]+DimEspai[2];	//Movem la llum on es troba la camera
    PosLlum[1]=DimEspai[1]/2.0;
    PosLlum[2]=DimEspai[2]/2.0;		//Posem la llum sobre la càmera
    glLightfv(GL_LIGHT0,GL_POSITION,PosLlum);

    //Mou la camera per a que es veja per baix
    glTranslatef(DimEspai[0]+DimEspai[1]+DimEspai[2],DimEspai[1]/2.0,DimEspai[2]/2.0);
    glRotatef(-90,0,1,0);
    glTranslatef(-DimEspai[0]/2.0,-DimEspai[0]/2.0,DimEspai[2]/2.0);
    glTranslatef(X1,Y1,Z1); 

    glTranslatef(DimEspai[0]/2.0,DimEspai[1]/2.0,DimEspai[2]/2.0);   //tornem a la posicio anterior
    glRotatef(angle1,0,0,1);		//Rotem
    glTranslatef(-DimEspai[0]/2.0,-DimEspai[1]/2.0,-DimEspai[2]/2.0); 	//Situem el centre de l'espai de voxelitzat al (0,0,0) per a fer la rotacio de l'espai

    
    glClearColor(1,1,1,1.0);		//Color de fons
    
  }
  mostrar();
  
  glMatrixMode(GL_MODELVIEW);  
  glPopMatrix();
  glDisable(GL_SCISSOR_TEST);
 }  
 else
 {
   //Si no hem de renderitzar de nou, carreguem la textura
   //Pantalla de la pantalla inferior//////////////////////////////////////////////////////////////////
  glViewport(Origen_Pantalla_Inferior[0],Origen_Pantalla_Inferior[1],Dimensions_Pantalla_Menuda[0],Dimensions_Pantalla_Menuda[1]);
  glScissor(Origen_Pantalla_Inferior[0],Origen_Pantalla_Inferior[1],Dimensions_Pantalla_Menuda[0],Dimensions_Pantalla_Menuda[1]);
  glEnable(GL_SCISSOR_TEST);  

  glMatrixMode(GL_PROJECTION);			//copiem la matriu de projecció i pasem a una perspectiva ortho
  glPushMatrix();
  
  glLoadIdentity();
  glOrtho(0,Dimensions_Pantalla_Menuda[0],0,Dimensions_Pantalla_Menuda[1],-10,10);
  
  glMatrixMode(GL_MODELVIEW);
  glPushMatrix();
  
  glLoadIdentity();
 
  glClearColor(0,0,0,1);  //Color de les separacions entre pantalles
  glClearDepth(1);    

  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);    
    glDisable(GL_LIGHT0);
    glDisable(GL_LIGHTING); 
    
    
    //Activem la textura corresponent
    glEnable(GL_TEXTURE_2D);
    glBindTexture(GL_TEXTURE_2D, TexturaFInf);

    glBegin(GL_QUADS);
      glColor3f(1,1,1);
      glTexCoord2f(0.0f,0.0f);glVertex3f(0,0,0);

      glTexCoord2f(1.0f,0.0f);glVertex3f(Dimensions_Pantalla_Menuda[0],0,0);

      glTexCoord2f(1.0f,1.0f);glVertex3f(Dimensions_Pantalla_Menuda[0],Dimensions_Pantalla_Menuda[1],0);

      glTexCoord2f(0.0f,1.0f);glVertex3f(0,Dimensions_Pantalla_Menuda[1],0);
      
    glEnd();
    
    glDisable(GL_TEXTURE_2D);
    
    
    glMatrixMode(GL_PROJECTION);
    glPopMatrix();  
    glMatrixMode(GL_MODELVIEW);
    glPopMatrix();  
    glDisable(GL_SCISSOR_TEST);
    
    glClearColor(0,0,0,1);  //Color de les separacions entre pantalles (negre)

    glEnable(GL_LIGHT0);
    glEnable(GL_LIGHTING); 
   
 }
 if(RendFinestraSup==true)
 {
  //Pantalla de dalt//////////////////////////////////////////////////////////////////
  glViewport(Origen_Pantalla_Superior[0],Origen_Pantalla_Superior[1],Dimensions_Pantalla_Menuda[0],Dimensions_Pantalla_Menuda[1]);
  glScissor(Origen_Pantalla_Superior[0],Origen_Pantalla_Superior[1],Dimensions_Pantalla_Menuda[0],Dimensions_Pantalla_Menuda[1]);
  glEnable(GL_SCISSOR_TEST);
  glMatrixMode(GL_MODELVIEW);
  glPushMatrix(); 
  //Mirem si estem representant un Dicom o no per a rotar correctament
  if(PintarDicom==true)
  {
    //Movem la camera per a mirar des de dalt
    glTranslatef(DimEspaiDicom[0]+DimEspaiDicom[1]+DimEspaiDicom[2],DimEspaiDicom[1]/2.0,DimEspaiDicom[2]/2.0);
    glRotatef(90,0,1,0);
    glTranslatef(-DimEspaiDicom[0]/2.0,-DimEspaiDicom[1]/2.0,-DimEspaiDicom[2]-DimEspaiDicom[2]/2.0);
    glTranslatef(X2,Y2,Z2);  

    glTranslatef(DimEspaiDicom[0]/2.0,DimEspaiDicom[1]/2.0,DimEspaiDicom[2]/2.0);   //Tornem a la posicio inicial.
    glRotatef(angle2,0,0,1);	//Rotem
    glTranslatef(-DimEspaiDicom[0]/2.0,-DimEspaiDicom[1]/2.0,-DimEspaiDicom[2]/2.0); 	//Situem el centre de l'espai de voxelitzat al (0,0,0)

    
    glClearColor(1,1,1,1.0);		//Color de fons
    
  }
  else
  {
    PosLlum[0]=DimEspai[0]+DimEspai[1]+DimEspai[2];	//Movem la llum on es troba la camera
    PosLlum[1]=DimEspai[1]/2.0;
    PosLlum[2]=DimEspai[2]/2.0;		//Posem la llum sobre la càmera
    glLightfv(GL_LIGHT0,GL_POSITION,PosLlum);

    //Movem a la camera per a mirar des de dalt
    glTranslatef(DimEspai[0]+DimEspai[1]+DimEspai[2],DimEspai[1]/2.0,DimEspai[2]/2.0);
    glRotatef(90,0,1,0);
    glTranslatef(-DimEspai[0]/2.0,-DimEspai[1]/2.0,-DimEspai[2]-DimEspai[2]/2.0);
    glTranslatef(X2,Y2,Z2);  

    glTranslatef(DimEspai[0]/2.0,DimEspai[1]/2.0,DimEspai[2]/2.0);   //Tornem a la posicio inicial
    glRotatef(angle2,0,0,1);	//Rotem
    glTranslatef(-DimEspai[0]/2.0,-DimEspai[1]/2.0,-DimEspai[2]/2.0); 	////Situem el centre de l'espai de voxelitzat al (0,0,0)

    
    glClearColor(1,1,1,1.0);		//Color de fons
  }
  mostrar();
  
  glMatrixMode(GL_MODELVIEW);
  glPopMatrix();
  glDisable(GL_SCISSOR_TEST);
  
 }
 else
 {
   //Si no hem de renderitzar de nou, carreguem la textura
   //Pantalla de la finestra superior///////////////////////////////////////////////////////////////////
  glViewport(Origen_Pantalla_Superior[0],Origen_Pantalla_Superior[1],Dimensions_Pantalla_Menuda[0],Dimensions_Pantalla_Menuda[1]);
  glScissor(Origen_Pantalla_Superior[0],Origen_Pantalla_Superior[1],Dimensions_Pantalla_Menuda[0],Dimensions_Pantalla_Menuda[1]);
  glEnable(GL_SCISSOR_TEST);  

  glMatrixMode(GL_PROJECTION);			//copiem la matriu de projecció i pasem a una perspectiva ortho
  glPushMatrix();
  
  glLoadIdentity();
  glOrtho(0,Dimensions_Pantalla_Menuda[0],0,Dimensions_Pantalla_Menuda[1],-10,10);
  
  glMatrixMode(GL_MODELVIEW);
  glPushMatrix();
  
  glLoadIdentity();
 
  glClearColor(0,0,0,1);  //Color de les separacions entre pantalles
  glClearDepth(1);    

  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);    
    glDisable(GL_LIGHT0);
    glDisable(GL_LIGHTING); 
    
    
    //Activem la textura corresponent
    glEnable(GL_TEXTURE_2D);
    glBindTexture(GL_TEXTURE_2D, TexturaFSup);

    glBegin(GL_QUADS);
      glColor3f(1,1,1);
      glTexCoord2f(0.0f,0.0f);glVertex3f(0,0,0);

      glTexCoord2f(1.0f,0.0f);glVertex3f(Dimensions_Pantalla_Menuda[0],0,0);

      glTexCoord2f(1.0f,1.0f);glVertex3f(Dimensions_Pantalla_Menuda[0],Dimensions_Pantalla_Menuda[1],0);

      glTexCoord2f(0.0f,1.0f);glVertex3f(0,Dimensions_Pantalla_Menuda[1],0);
      
    glEnd();
    
    glDisable(GL_TEXTURE_2D);
    
    
    glMatrixMode(GL_PROJECTION);
    glPopMatrix();  
    glMatrixMode(GL_MODELVIEW);
    glPopMatrix();  
    glDisable(GL_SCISSOR_TEST);
    
    glClearColor(0,0,0,1);  //Color de les separacions entre pantalles (negre)

    glEnable(GL_LIGHT0);
    glEnable(GL_LIGHTING); 
   
   
 }
}
 //Pantalla de menu/////////////////////////////////////////////////////////////////////////////////
  glViewport(Origen_Menu[0],Origen_Menu[1],Dimensions_Menu[0],Dimensions_Menu[1]);
  glScissor(Origen_Menu[0],Origen_Menu[1],Dimensions_Menu[0],Dimensions_Menu[1]);
  glEnable(GL_SCISSOR_TEST);  

  glMatrixMode(GL_PROJECTION);			//copiem la matriu de projecció i pasem a una perspectiva ortho
  glPushMatrix();
  
  glLoadIdentity();
  glOrtho(0,Dimensions_Menu[0],0,Dimensions_Menu[1],-10,10);
  
  glMatrixMode(GL_MODELVIEW);
  glPushMatrix();
  
  glLoadIdentity();
  glClearColor(0.32,0.34,0.34,1);				//posem el color de fons del menu
  glClearDepth(1);    

  if(ColorBotoCrear==0)
  {
    float Negre[3]={0,0,0};
    Crear.ColorLletra(Negre);
  }
  else if(ColorBotoCrear==1)
  {
    float Verd[3]={0,1,0};
    Crear.ColorLletra(Verd);
    ColorBotoCrear=0;
  }
  else if(ColorBotoCrear==2)
  {
    float Roig[3]={1,0,0};
    Crear.ColorLletra(Roig);
    ColorBotoCrear=0;
  }
  MostrarMenu();				//Funcio en geometria.cpp que crea el menu

  glMatrixMode(GL_PROJECTION);
  glPopMatrix();  
  glMatrixMode(GL_MODELVIEW);
  glPopMatrix();  
  glDisable(GL_SCISSOR_TEST);
  
  glClearColor(0,0,0,1);  //Color de les separacions entre pantalles

  ////////////////////////////////////////////////////////////////////////
  //Una vegada renderitzada, pasem a crear les textures que han canviat.//
  ////////////////////////////////////////////////////////////////////////
  //Pantalla gran
  if(RendFinestraGran==true)
  {
      //Activem la textura corresponent
      glDeleteTextures(1,&TexturaFGran);
      glGenTextures(1,&TexturaFGran);
      glBindTexture(GL_TEXTURE_2D, TexturaFGran);
      //Fem una copia de la imatge a la textura
      glCopyTexImage2D(GL_TEXTURE_2D,0,GL_RGB,Origen_Pantalla_Gran[0],Origen_Pantalla_Gran[1],Dimensions_Pantalla_Gran[0],Dimensions_Pantalla_Gran[1],0);	//Important, açò ha d'estar després del glBind o no ho eixirà be
            
      //Diem que la textura no es repetisca, tant en l'eix horitzontal (s) com en el vertical (t)
      glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
      glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);      
      // when texture area is small, bilinear filter the closest mipmap
      glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR );
      // when texture area is large, bilinear filter the first mipmap
      glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR );
	
      

      RendFinestraGran=false;
  }
  //Pantalla Superior
  if(RendFinestraSup==true)
  {
      //Activem la textura corresponent
      glDeleteTextures(1,&TexturaFSup);
      glGenTextures(1,&TexturaFSup);
      glBindTexture(GL_TEXTURE_2D, TexturaFSup);
      //Fem una copia de la imatge a la textura
      glCopyTexImage2D(GL_TEXTURE_2D,0,GL_RGB,Origen_Pantalla_Superior[0],Origen_Pantalla_Superior[1],Dimensions_Pantalla_Menuda[0],Dimensions_Pantalla_Menuda[1],0);	//Important, açò ha d'estar després del glBind o no ho eixirà be
            
      //Diem que la textura no es repetisca, tant en l'eix horitzontal (s) com en el vertical (t)
      glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
      glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);      
      // when texture area is small, bilinear filter the closest mipmap
      glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR );
      // when texture area is large, bilinear filter the first mipmap
      glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR );
	
      

      RendFinestraSup=false;
  }   
  //Pantalla Inferior
  if(RendFinestraInf==true)
  {
      //Activem la textura corresponent
      glDeleteTextures(1,&TexturaFInf);
      glGenTextures(1,&TexturaFInf);
      glBindTexture(GL_TEXTURE_2D, TexturaFInf);
      //Fem una copia de la imatge a la textura
      glCopyTexImage2D(GL_TEXTURE_2D,0,GL_RGB,Origen_Pantalla_Inferior[0],Origen_Pantalla_Inferior[1],Dimensions_Pantalla_Menuda[0],Dimensions_Pantalla_Menuda[1],0);	//Important, açò ha d'estar després del glBind o no ho eixirà be
            
      //Diem que la textura no es repetisca, tant en l'eix horitzontal (s) com en el vertical (t)
      glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
      glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);      
      // when texture area is small, bilinear filter the closest mipmap
      glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR );
      // when texture area is large, bilinear filter the first mipmap
      glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR );
	
      

      RendFinestraInf=false;
  }  
  
    glFlush();
    glutSwapBuffers();
 
}
//--------------------------------------Funcio dibuixar la finestra guardar/carregar----------------------------------------------------------------------//

void FGuardarCarregar(void)
{
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

  glMatrixMode(GL_PROJECTION);			//copiem la matriu de projecció i pasem a una perspectiva ortho
  glPushMatrix();
  
  glLoadIdentity();
  glOrtho(0,AMPLADA2,0,ALTURA2,-10,10);
  
  glMatrixMode(GL_MODELVIEW);
  glPushMatrix();
  
  glLoadIdentity();
  glClearColor(0.32,0.34,0.34,1);				//posem el color de fons del menu
  glClearDepth(1);    
  
  //Dibuixem un rectangle
  glColor3f(0.32,0.34,0.34);
  int Amplada_Vora=0.02;
  glBegin(GL_QUADS);
	glVertex3f(Amplada_Vora*AMPLADA2, Amplada_Vora*ALTURA2, 0);
	glVertex3f(AMPLADA2*(1-Amplada_Vora), Amplada_Vora*ALTURA2, 0);
	glVertex3f(AMPLADA2*(1-Amplada_Vora),ALTURA2*(1-Amplada_Vora*2), 0);
	glVertex3f(Amplada_Vora*AMPLADA, ALTURA2*(1-Amplada_Vora*2), 0);
  glEnd();  
  //Dibuixem un rectangle a la part superior
  glBegin(GL_QUADS);
	glColor3f(0,0,1);
	glVertex3f(0,ALTURA2*(1-Amplada_Vora*2), 5);
	glColor3f(0,0,1);	
	glVertex3f(AMPLADA2,ALTURA2*(1-Amplada_Vora*2),5);
	glColor3f(1,1,1);	
	glVertex3f(AMPLADA2,ALTURA2, 5);
	glColor3f(1,1,1);
	glVertex3f(0, ALTURA2, 5);
  glEnd();  

  //////////////////////////////////////////////////////////////////////////
  /////////////////Guardar/Carregar Geometria///////////////////////////////
  //////////////////////////////////////////////////////////////////////////
  if((ControlMenu==4 && ControlSubMenu==1) || ControlMenu==5)
  {
    glMatrixMode(GL_MODELVIEW);
    glPushMatrix();
    
    glTranslatef(0,YGC,0);	//Moura cap a dalt i cap a baix per a veure tots els arxius
    
    DIR *Directori;		//creem una variable directori
    std::string AuxString;	//String que usarem per a escriure per pantalla
    char AuxChar[200];		//Char on guardarem els noms dels arxius per a pasar-los al string
    dirent *data;		//Variable dela clase "dirent" que emmagatzema informació del directori
    //Obrim el directori 
    Directori=opendir(Geometriadir.c_str());		//Obrim el directori 
    int i=0;
    while((data=readdir(Directori))!=NULL)		//llegim el directori guardant la informació de un dels arxius en cada cicle
    {
      glColor3f(1,1,1);
      
      sprintf(AuxChar,"%s",data->d_name);	//Guardem el nom de l'arxiu (d_name) en AuxChar i el nombre de caracters
      if(AuxChar[0]!='.')				//No mostrem els arxius .algo
      {
	AuxString=AuxChar;
	escriure(AuxString,0.166666*Dimensions_Menu[0],ALTURA2-(0.05+i*0.0375)*Dimensions_Menu[1],0.01,Tamany_Lletra_Pantalla_Geometria);				//escrivim el string per pantalla
	i++;
      }
      AuxString.clear();				//netegem el string
    }
    glPopMatrix();
    MostrarMenu2();

  glMatrixMode(GL_PROJECTION);
  glPopMatrix();  
  glMatrixMode(GL_MODELVIEW);
  glPopMatrix();  
  
  glClearColor(0,0,0,1);  //Color de les separacions entre pantalles
    
    
  }
  //////////////////////////////////////////////////////////////////////////
  /////////////////Guardar Geometria Penelope///////////////////////////////
  //////////////////////////////////////////////////////////////////////////  
  else if(ControlMenu==4 && ControlSubMenu==2)
  {
    glMatrixMode(GL_MODELVIEW);
    glPushMatrix();
    
    glTranslatef(0,YGC,0);	//Moura cap a dalt i cap a baix per a veure tots els arxius
    
    DIR *Directori;		//creem una variable directori
    std::string AuxString;	//String que usarem per a escriure per pantalla
    char AuxChar[200];		//Char on guardarem els noms dels arxius per a pasar-los al string
    dirent *data;		//Variable dela clase "dirent" que emmagatzema informació del directori
    //Obrim el directori 
    Directori=opendir("GeometriesPenelope");		//Obrim el directori 
    int i=0;
    while((data=readdir(Directori))!=NULL)		//llegim el directori guardant la informació de un dels arxius en cada cicle
    {
      glColor3f(1,1,1);
      
      sprintf(AuxChar,"%s",data->d_name);	//Guardem el nom de l'arxiu (d_name) en AuxChar i el nombre de caracters
      if(AuxChar[0]!='.')				//No mostrem els arxius .algo
      {
	AuxString=AuxChar;       
	escriure(AuxString,0.166666*Dimensions_Menu[0],ALTURA2-(0.05+i*0.0375)*Dimensions_Menu[1],0.01,Tamany_Lletra_Pantalla_Geometria);				//escrivim el string per pantalla
	 i++;
      }
      AuxString.clear();				//netegem el string
    }
    glPopMatrix();
    MostrarMenu2();
    
  }
  //////////////////////////////////////////////////////////////////////////
  /////////////////Guardar Geometria Geant4  ///////////////////////////////
  //////////////////////////////////////////////////////////////////////////  
  else if(ControlMenu==4 && ControlSubMenu==4)
  {
    glMatrixMode(GL_MODELVIEW);
    glPushMatrix();
    
    glTranslatef(0,YGC,0);	//Moura cap a dalt i cap a baix per a veure tots els arxius
    
    DIR *Directori;		//creem una variable directori
    std::string AuxString;	//String que usarem per a escriure per pantalla
    char AuxChar[200];		//Char on guardarem els noms dels arxius per a pasar-los al string
    dirent *data;		//Variable dela clase "dirent" que emmagatzema informació del directori
    //Obrim el directori 
    Directori=opendir("GeometriesGeant4");		//Obrim el directori 
    int i=0;
    while((data=readdir(Directori))!=NULL)		//llegim el directori guardant la informació de un dels arxius en cada cicle
    {
      glColor3f(1,1,1);
      
      sprintf(AuxChar,"%s",data->d_name);	//Guardem el nom de l'arxiu (d_name) en AuxChar i el nombre de caracters
      if(AuxChar[0]!='.')				//No mostrem els arxius .algo
      {
	AuxString=AuxChar;
	escriure(AuxString,0.166666*Dimensions_Menu[0],ALTURA2-(0.05+i*0.0375)*Dimensions_Menu[1],0.01,Tamany_Lletra_Pantalla_Geometria);				//escrivim el string per pantalla
	 i++;
      }
      AuxString.clear();				//netegem el string
    }
    glPopMatrix();
    MostrarMenu2();
    
  } 
  
  //////////////////////////////////////////////////////////////////////////
  /////////////////Guardar Voxels Penelope//////////////////////////////////
  //////////////////////////////////////////////////////////////////////////  
  else if(ControlMenu==4 && ControlSubMenu==3)
  {
    glMatrixMode(GL_MODELVIEW);
    glPushMatrix();
    
    glTranslatef(0,YGC,0);	//Moura cap a dalt i cap a baix per a veure tots els arxius
    
    DIR *Directori;		//creem una variable directori
    std::string AuxString;	//String que usarem per a escriure per pantalla
    char AuxChar[200];		//Char on guardarem els noms dels arxius per a pasar-los al string
    dirent *data;		//Variable dela clase "dirent" que emmagatzema informació del directori
    //Obrim el directori 
    Directori=opendir("VoxelsPenelope");		//Obrim el directori 
    int i=0;
    while((data=readdir(Directori))!=NULL)		//llegim el directori guardant la informació de un dels arxius en cada cicle
    {
      glColor3f(1,1,1);
      
      sprintf(AuxChar,"%s",data->d_name);	//Guardem el nom de l'arxiu (d_name) en AuxChar i el nombre de caracters
      if(AuxChar[0]!='.')				//No mostrem els arxius .algo
      {
	AuxString=AuxChar;
	escriure(AuxString,0.166666*Dimensions_Menu[0],ALTURA2-(0.05+i*0.0375)*Dimensions_Menu[1],0.01,Tamany_Lletra_Pantalla_Geometria);			//escrivim el string per pantalla
	i++;
      }
      AuxString.clear();				//netegem el string
     
    }
    glPopMatrix();
    MostrarMenu2();
    
  }   
  glFlush();
  glutSwapBuffers();
  
}
//---------------------------------------Funcio que controla el teclat------------------------------------------//

void teclat(unsigned char tecla, int x, int y)
{
  int i=0;
  int IndexChar=0;		//Indica quin index de la cadena de caracters esta buit (Ho marquem amb una V)
  bool LocPunt=false;		//Indica si ja s'ha introduit un . per a indicar decimals

    ////////////////////////////////Controla la introduccio de la figura a seleccionar//////////////////////////////////////////////////////
    if(ControlMenu==2)
    {
      while(ISelFigChar[IndexChar]!='V' && IndexChar<3)		//Mira quina posició és la primera buida (Amb una 'V')
      {
	IndexChar++;
      }
      if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
      {
	ISelFigChar[IndexChar-1]='V';
      }
      //Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
      else if( IndexChar<3 && ( tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0'))
      {
	  ISelFigChar[IndexChar]=tecla;
      }      
    }

  ////////////////////////////////Controla la introduccio de les dades de l'espai//////////////////////////////////////////////////////
    else if(ControlMenu==6)
      {
	////////////////////////////////Voxels en l'eix X////////////////////////////////////////////////////////////////////	
	if(ControlSubMenu==1)
	  {
	    while(INumVoxChar[0][IndexChar]!='V' && IndexChar<3)		//Mira quina posició és la primera buida (Amb una 'V')
	      {
		IndexChar++;
	      }
	    if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
	      {
		INumVoxChar[0][IndexChar-1]='V';
	      }
	    else if(tecla==9)						//Si apretem el tabulador
	      {
		ControlSubMenu++;
	      }
	    //Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
	    else if( IndexChar<3 && (tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0'))
	      {
		INumVoxChar[0][IndexChar]=tecla;
	      }
	  }
	
	////////////////////////////////Voxels en l'eix Y////////////////////////////////////////////////////////////////////

	else if(ControlSubMenu==2)
	  {
	    while(INumVoxChar[1][IndexChar]!='V' && IndexChar<3)		//Mira quina posició és la primera buida (Amb una 'V')
	      {
		IndexChar++;
	      }
	    if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
	      {
		INumVoxChar[1][IndexChar-1]='V';
	      }
	    else if(tecla==9)						//Si apretem el tabulador
	      {
		ControlSubMenu++;
	      }      
	    //Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
	    else if( IndexChar<3 && (tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0'))
	      {
		INumVoxChar[1][IndexChar]=tecla;
	      }
	  }  

	////////////////////////////////Voxels en l'eix Z////////////////////////////////////////////////////////////////////

	else if(ControlSubMenu==3)
	  {
	    while(INumVoxChar[2][IndexChar]!='V' && IndexChar<3)		//Mira quina posició és la primera buida (Amb una 'V')
	      {
		IndexChar++;
	      }
	    if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
	      {
		INumVoxChar[2][IndexChar-1]='V';
	      }
	    else if(tecla==9)						//Si apretem el tabulador
	      {
		ControlSubMenu++;
	      }      
	    //Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
	    else if( IndexChar<3 && (tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0'))
	      {
		INumVoxChar[2][IndexChar]=tecla;
	      }
	  } 
    
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	//////////////////////////Dimensio X Voxels/////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	else if(ControlSubMenu==4)	//Indica que omplim el quadre de la dimensio X del voxel
	  {
	    while(IDimVoxChar[0][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
	      {
		IndexChar++;
	      }
	    if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
	      {
		IDimVoxChar[0][IndexChar-1]='V';
	      }
	    else if(tecla==9)						//Si apretem el tabulador
	      {
		ControlSubMenu++;
	      }      
	    //Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
	    else if( IndexChar<MAX_CARACTERS_INTRODUIR && (tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0' || tecla=='.'))
	      {
		if(tecla=='.')		//si es un punt mirarem si ja hi ha un punt al array
		  {
		    i=0;
		    while(i<IndexChar)	//Mira totes les posicions ocupades en busca d'un '.'
		      {
			if(IDimVoxChar[0][i]=='.')	//Si el troba posara LocPunt=true
			  {
			    LocPunt=true;
			    break;
			  }
			i++;
		      }
		    if(LocPunt==false)			//si no ha trobat punt el posarà a l'array
		      {
			IDimVoxChar[0][IndexChar]=tecla;
		      }
		  }else
		  {
		    IDimVoxChar[0][IndexChar]=tecla;
		  }
	      }
	  }    
    
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	//////////////////////////Dimensio Y Voxels/////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	else if(ControlSubMenu==5)	//Indica que omplim el quadre de la dimensio Y del voxel
	  {
	    while(IDimVoxChar[1][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
	      {
		IndexChar++;
	      }
	    if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
	      {
		IDimVoxChar[1][IndexChar-1]='V';
	      }
	    else if(tecla==9)						//Si apretem el tabulador
	      {
		ControlSubMenu++;
	      }
	    //Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
	    else if( IndexChar<MAX_CARACTERS_INTRODUIR && (tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0' || tecla=='.'))
	      {
		if(tecla=='.')		//si es un punt mirarem si ja hi ha un punt al array
		  {
		    i=0;
		    while(i<IndexChar)	//Mira totes les posicions ocupades en busca d'un '.'
		      {
			if(IDimVoxChar[1][i]=='.')	//Si el troba posara LocPunt=true
			  {
			    LocPunt=true;
			    break;
			  }
			i++;
		      }
		    if(LocPunt==false)			//si no ha trobat punt el posarà a l'array
		      {
			IDimVoxChar[1][IndexChar]=tecla;
		      }
		  }else
		  {
		    IDimVoxChar[1][IndexChar]=tecla;
		  }
	      }
	  }     
    
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	//////////////////////////Dimensio Z Voxels/////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	else if(ControlSubMenu==6)	//Indica que omplim el quadre de la dimensio X del voxel
	  {
	    while(IDimVoxChar[2][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
	      {
		IndexChar++;
	      }
	    if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
	      {
		IDimVoxChar[2][IndexChar-1]='V';
	      }
	    else if(tecla==9)						//Si apretem el tabulador
	      {
		ControlSubMenu=1;
	      }
	    //Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
	    else if( IndexChar<MAX_CARACTERS_INTRODUIR && (tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0' || tecla=='.'))
	      {
		if(tecla=='.')		//si es un punt mirarem si ja hi ha un punt al array
		  {
		    i=0;
		    while(i<IndexChar)	//Mira totes les posicions ocupades en busca d'un '.'
		      {
			if(IDimVoxChar[2][i]=='.')	//Si el troba posara LocPunt=true
			  {
			    LocPunt=true;
			    break;
			  }
			i++;
		      }
		    if(LocPunt==false)			//si no ha trobat punt el posarà a l'array
		      {
			IDimVoxChar[2][IndexChar]=tecla;
		      }
		  }else
		  {
		    IDimVoxChar[2][IndexChar]=tecla;
		  }
	      }
	  }
      }
    else if(ControlMenu==1)
      {
	if(ControlSubMenu==1)
	  {
	    //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    ////////////////////////////////Controla la introduccio de dades del cub//////////////////////////////////////////////////////
	    //////////////////////////Coordenada X/////////////////////////////////////////////////////////////////////////////////
	    if(ControlSubSubMenu==1)	//Indica que omplim el quadre de CentreX del cub
	      {
		while(ICentreCubChar[0][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    ICentreCubChar[0][IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<MAX_CARACTERS_INTRODUIR && ((tecla=='-' && IndexChar==0) || tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0' || tecla=='.'))
		  {
		    if(tecla=='.')		//si es un punt mirarem si ja hi ha un punt al array
		      {
			i=0;
			while(i<IndexChar)	//Mira totes les posicions ocupades en busca d'un '.'
			  {
			    if(ICentreCubChar[0][i]=='.')	//Si el troba posara LocPunt=true
			      {
				LocPunt=true;
				break;
			      }
			    i++;
			  }
			if(LocPunt==false)			//si no ha trobat punt el posarà a l'array
			  {
			    ICentreCubChar[0][IndexChar]=tecla;
			  }
		      }else
		      {
			ICentreCubChar[0][IndexChar]=tecla;
		      }
		  }
	      }
	    //////////////////////////Coordenada Y/////////////////////////////////////////////////////////////////////////////////   
	    else if(ControlSubSubMenu==2)	//Indica que omplim el quadre de CentreY del cub
	      {
		while(ICentreCubChar[1][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    ICentreCubChar[1][IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<MAX_CARACTERS_INTRODUIR && ((tecla=='-' && IndexChar==0) || tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0' || tecla=='.'))
		  {
		    if(tecla=='.')		//si es un punt mirarem si ja hi ha un punt al array
		      {
			i=0;
			while(i<IndexChar)	//Mira totes les posicions ocupades en busca d'un '.'
			  {
			    if(ICentreCubChar[1][i]=='.')	//Si el troba posara LocPunt=true
			      {
				LocPunt=true;
				break;
			      }
			    i++;
			  }
			if(LocPunt==false)			//si no ha trobat punt el posarà a l'array
			  {
			    ICentreCubChar[1][IndexChar]=tecla;
			  }
		      }else
		      {
			ICentreCubChar[1][IndexChar]=tecla;
		      }
		  }
	      }
	    //////////////////////////Coordenada Z/////////////////////////////////////////////////////////////////////////////////   
	    else if(ControlSubSubMenu==3)	//Indica que omplim el quadre de CentreZ del cub
	      {
		while(ICentreCubChar[2][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    ICentreCubChar[2][IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<MAX_CARACTERS_INTRODUIR && ((tecla=='-' && IndexChar==0) || tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0' || tecla=='.'))
		  {
		    if(tecla=='.')		//si es un punt mirarem si ja hi ha un punt al array
		      {
			i=0;
			while(i<IndexChar)	//Mira totes les posicions ocupades en busca d'un '.'
			  {
			    if(ICentreCubChar[2][i]=='.')	//Si el troba posara LocPunt=true
			      {
				LocPunt=true;
				break;
			      }
			    i++;
			  }
			if(LocPunt==false)			//si no ha trobat punt el posarà a l'array
			  {
			    ICentreCubChar[2][IndexChar]=tecla;
			  }
		      }else
		      {
			ICentreCubChar[2][IndexChar]=tecla;
		      }
		  }
	      }
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    //////////////////////////Dimensio X Cub/////////////////////////////////////////////////////////////////////////////////
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    else if(ControlSubSubMenu==4)	//Indica que omplim el quadre de la dimensio X del cub
	      {
		while(IDimCubChar[0][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    IDimCubChar[0][IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<MAX_CARACTERS_INTRODUIR && ((tecla=='-' && IndexChar==0) || tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0' || tecla=='.'))
		  {
		    if(tecla=='.')		//si es un punt mirarem si ja hi ha un punt al array
		      {
			i=0;
			while(i<IndexChar)	//Mira totes les posicions ocupades en busca d'un '.'
			  {
			    if(IDimCubChar[0][i]=='.')	//Si el troba posara LocPunt=true
			      {
				LocPunt=true;
				break;
			      }
			    i++;
			  }
			if(LocPunt==false)			//si no ha trobat punt el posarà a l'array
			  {
			    IDimCubChar[0][IndexChar]=tecla;
			  }
		      }else
		      {
			IDimCubChar[0][IndexChar]=tecla;
		      }
		  }
	      }
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////    
	    //////////////////////////Dimensio Y Cub/////////////////////////////////////////////////////////////////////////////////   
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    else if(ControlSubSubMenu==5)	//Indica que omplim el quadre de la dimensió Y del cub
	      {
		while(IDimCubChar[1][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    IDimCubChar[1][IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<MAX_CARACTERS_INTRODUIR && ((tecla=='-' && IndexChar==0) || tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0' || tecla=='.'))
		  {
		    if(tecla=='.')		//si es un punt mirarem si ja hi ha un punt al array
		      {
			i=0;
			while(i<IndexChar)	//Mira totes les posicions ocupades en busca d'un '.'
			  {
			    if(IDimCubChar[1][i]=='.')	//Si el troba posara LocPunt=true
			      {
				LocPunt=true;
				break;
			      }
			    i++;
			  }
			if(LocPunt==false)			//si no ha trobat punt el posarà a l'array
			  {
			    IDimCubChar[1][IndexChar]=tecla;
			  }
		      }else
		      {
			IDimCubChar[1][IndexChar]=tecla;
		      }
		  }
	      }
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    //////////////////////////Dimensio Z Cub/////////////////////////////////////////////////////////////////////////////////   
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////    
	    else if(ControlSubSubMenu==6)	//Indica que omplim el quadre de la dimensió Z del cub
	      {
		while(IDimCubChar[2][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    IDimCubChar[2][IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<MAX_CARACTERS_INTRODUIR && ((tecla=='-' && IndexChar==0) || tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0' || tecla=='.'))
		  {
		    if(tecla=='.')		//si es un punt mirarem si ja hi ha un punt al array
		      {
			i=0;
			while(i<IndexChar)	//Mira totes les posicions ocupades en busca d'un '.'
			  {
			    if(IDimCubChar[2][i]=='.')	//Si el troba posara LocPunt=true
			      {
				LocPunt=true;
				break;
			      }
			    i++;
			  }
			if(LocPunt==false)			//si no ha trobat punt el posarà a l'array
			  {
			    IDimCubChar[2][IndexChar]=tecla;
			  }
		      }else
		      {
			IDimCubChar[2][IndexChar]=tecla;
		      }
		  }
	      }
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    ////////////////////////////////Prioritat//////////////////////////////////////////////////////////////////////////////
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    else if(ControlSubSubMenu==7)	//Indica que omplim el quadre de prioritat del cub
	      {
		while(IPrioritatCubChar[IndexChar]!='V' && IndexChar<3)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    IPrioritatCubChar[IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<3 && ( tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0'))
		  {
		    IPrioritatCubChar[IndexChar]=tecla;
		  }
	      }
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    ////////////////////////////////Prioritats Dins//////////////////////////////////////////////////////////////////////////////
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    else if(ControlSubSubMenu==8)	//Indica que omplim el quadre de prioritats a dintre del cub
	      {
		while(IDinsCubChar[IndexChar]!='V' && IndexChar<3)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    IDinsCubChar[IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<3 && ( tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0'))
		  {
		    IDinsCubChar[IndexChar]=tecla;
		  }
	      }
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    ////////////////////////////////Material//////////////////////////////////////////////////////////////////////////////
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    else if(ControlSubSubMenu==9)	//Indica que omplim el quadre de material del cub
	      {
		while(IMatCubChar[IndexChar]!='V' && IndexChar<2)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    IMatCubChar[IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<2 && ( tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0'))
		  {
	
		    IMatCubChar[IndexChar]=tecla;
	
		  }
	      }
    
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    //////////////////////////Densitat Cub/////////////////////////////////////////////////////////////////////////////////   
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////    
	    else if(ControlSubSubMenu==10)	//Indica que omplim el quadre de densitat del cub
	      {
		while(IDensCubChar[IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    IDensCubChar[IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<MAX_CARACTERS_INTRODUIR && ((tecla=='-' && IndexChar==0) || tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0' || tecla=='.'))
		  {
		    if(tecla=='.')		//si es un punt mirarem si ja hi ha un punt al array
		      {
			i=0;
			while(i<IndexChar)	//Mira totes les posicions ocupades en busca d'un '.'
			  {
			    if(IDensCubChar[i]=='.')	//Si el troba posara LocPunt=true
			      {
				LocPunt=true;
				break;
			      }
			    i++;
			  }
			if(LocPunt==false)			//si no ha trobat punt el posarà a l'array
			  {
			    IDensCubChar[IndexChar]=tecla;
			  }
		      }else
		      {
			IDensCubChar[IndexChar]=tecla;
		      }
		  }
	      }    
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    //////////////////////////Angles rotació Cub/////////////////////////////////////////////////////////////////////////////////   
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////    
    
	    //////////////////////////Angle Alfa/////////////////////////////////////////////////////////////////////////////////
	    else if(ControlSubSubMenu==11)	//Indica que omplim el quadre de angle alfa del cub
	      {
		while(IAnglesCubChar[0][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    IAnglesCubChar[0][IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<MAX_CARACTERS_INTRODUIR && ((tecla=='-' && IndexChar==0) || tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0' || tecla=='.'))
		  {
		    if(tecla=='.')		//si es un punt mirarem si ja hi ha un punt al array
		      {
			i=0;
			while(i<IndexChar)	//Mira totes les posicions ocupades en busca d'un '.'
			  {
			    if(IAnglesCubChar[0][i]=='.')	//Si el troba posara LocPunt=true
			      {
				LocPunt=true;
				break;
			      }
			    i++;
			  }
			if(LocPunt==false)			//si no ha trobat punt el posarà a l'array
			  {
			    IAnglesCubChar[0][IndexChar]=tecla;
			  }
		      }else
		      {
			IAnglesCubChar[0][IndexChar]=tecla;
		      }
		  }
	      }
	    //////////////////////////Angle Beta/////////////////////////////////////////////////////////////////////////////////   
	    else if(ControlSubSubMenu==12)	//Indica que omplim el quadre de angle beta del cub
	      {
		while(IAnglesCubChar[1][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    IAnglesCubChar[1][IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<MAX_CARACTERS_INTRODUIR && ((tecla=='-' && IndexChar==0) || tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0' || tecla=='.'))
		  {
		    if(tecla=='.')		//si es un punt mirarem si ja hi ha un punt al array
		      {
			i=0;
			while(i<IndexChar)	//Mira totes les posicions ocupades en busca d'un '.'
			  {
			    if(IAnglesCubChar[1][i]=='.')	//Si el troba posara LocPunt=true
			      {
				LocPunt=true;
				break;
			      }
			    i++;
			  }
			if(LocPunt==false)			//si no ha trobat punt el posarà a l'array
			  {
			    IAnglesCubChar[1][IndexChar]=tecla;
			  }
		      }else
		      {
			IAnglesCubChar[1][IndexChar]=tecla;
		      }
		  }
	      }
	    //////////////////////////Angle Gamma/////////////////////////////////////////////////////////////////////////////////   
	    else if(ControlSubSubMenu==13)	//Indica que omplim el quadre de angle gamma del cub
	      {
		while(IAnglesCubChar[2][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    IAnglesCubChar[2][IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu=1;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<MAX_CARACTERS_INTRODUIR && ((tecla=='-' && IndexChar==0) || tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0' || tecla=='.'))
		  {
		    if(tecla=='.')		//si es un punt mirarem si ja hi ha un punt al array
		      {
			i=0;
			while(i<IndexChar)	//Mira totes les posicions ocupades en busca d'un '.'
			  {
			    if(IAnglesCubChar[2][i]=='.')	//Si el troba posara LocPunt=true
			      {
				LocPunt=true;
				break;
			      }
			    i++;
			  }
			if(LocPunt==false)			//si no ha trobat punt el posarà a l'array
			  {
			    IAnglesCubChar[2][IndexChar]=tecla;
			  }
		      }else
		      {
			IAnglesCubChar[2][IndexChar]=tecla;
		      }
		  }
	      }    
    
	  }
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////Fi del la introducció de cubs//////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
 
	if(ControlSubMenu==2)
	  {
	    ////////////////////////////////Controla la introduccio de dades de l'esfera//////////////////////////////////////////////////////
	    //////////////////////////Coordenada X/////////////////////////////////////////////////////////////////////////////////
	    if(ControlSubSubMenu==1)	//Indica que omplim el quadre de CentreX del l'esfera
	      {
		while(ICentreEsfChar[0][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    ICentreEsfChar[0][IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<MAX_CARACTERS_INTRODUIR && ((tecla=='-' && IndexChar==0) || tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0' || tecla=='.'))
		  {
		    if(tecla=='.')		//si es un punt mirarem si ja hi ha un punt al array
		      {
			i=0;
			while(i<IndexChar)	//Mira totes les posicions ocupades en busca d'un '.'
			  {
			    if(ICentreEsfChar[0][i]=='.')	//Si el troba posara LocPunt=true
			      {
				LocPunt=true;
				break;
			      }
			    i++;
			  }
			if(LocPunt==false)			//si no ha trobat punt el posarà a l'array
			  {
			    ICentreEsfChar[0][IndexChar]=tecla;
			  }
		      }else
		      {
			ICentreEsfChar[0][IndexChar]=tecla;
		      }
		  }
	      }
	    //////////////////////////Coordenada Y/////////////////////////////////////////////////////////////////////////////////   
	    else if(ControlSubSubMenu==2)	//Indica que omplim el quadre de CentreY l'esfera
	      {
		while(ICentreEsfChar[1][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    ICentreEsfChar[1][IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<MAX_CARACTERS_INTRODUIR && ((tecla=='-' && IndexChar==0) || tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0' || tecla=='.'))
		  {
		    if(tecla=='.')		//si es un punt mirarem si ja hi ha un punt al array
		      {
			i=0;
			while(i<IndexChar)	//Mira totes les posicions ocupades en busca d'un '.'
			  {
			    if(ICentreEsfChar[1][i]=='.')	//Si el troba posara LocPunt=true
			      {
				LocPunt=true;
				break;
			      }
			    i++;
			  }
			if(LocPunt==false)			//si no ha trobat punt el posarà a l'array
			  {
			    ICentreEsfChar[1][IndexChar]=tecla;
			  }
		      }else
		      {
			ICentreEsfChar[1][IndexChar]=tecla;
		      }
		  }
	      }
	    //////////////////////////Coordenada Z/////////////////////////////////////////////////////////////////////////////////   
	    else if(ControlSubSubMenu==3)	//Indica que omplim el quadre de CentreZ de l'esfera
	      {
		while(ICentreEsfChar[2][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    ICentreEsfChar[2][IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<MAX_CARACTERS_INTRODUIR && ((tecla=='-' && IndexChar==0) || tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0' || tecla=='.'))
		  {
		    if(tecla=='.')		//si es un punt mirarem si ja hi ha un punt al array
		      {
			i=0;
			while(i<IndexChar)	//Mira totes les posicions ocupades en busca d'un '.'
			  {
			    if(ICentreEsfChar[2][i]=='.')	//Si el troba posara LocPunt=true
			      {
				LocPunt=true;
				break;
			      }
			    i++;
			  }
			if(LocPunt==false)			//si no ha trobat punt el posarà a l'array
			  {
			    ICentreEsfChar[2][IndexChar]=tecla;
			  }
		      }else
		      {
			ICentreEsfChar[2][IndexChar]=tecla;
		      }
		  }
	      }
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    //////////////////////////Radi esfera/////////////////////////////////////////////////////////////////////////////////
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    else if(ControlSubSubMenu==4)	//Indica que omplim el quadre amb el radi de l'esfera
	      {
		while(IDimEsfChar[IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    IDimEsfChar[IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<MAX_CARACTERS_INTRODUIR && ((tecla=='-' && IndexChar==0) || tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0' || tecla=='.'))
		  {
		    if(tecla=='.')		//si es un punt mirarem si ja hi ha un punt al array
		      {
			i=0;
			while(i<IndexChar)	//Mira totes les posicions ocupades en busca d'un '.'
			  {
			    if(IDimEsfChar[i]=='.')	//Si el troba posara LocPunt=true
			      {
				LocPunt=true;
				break;
			      }
			    i++;
			  }
			if(LocPunt==false)			//si no ha trobat punt el posarà a l'array
			  {
			    IDimEsfChar[IndexChar]=tecla;
			  }
		      }else
		      {
			IDimEsfChar[IndexChar]=tecla;
		      }
		  }
	      }

	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    ////////////////////////////////Prioritat//////////////////////////////////////////////////////////////////////////////
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    else if(ControlSubSubMenu==5)	//Indica que omplim el quadre amb la prioritat de l'esfera
	      {
		while(IPrioritatEsfChar[IndexChar]!='V' && IndexChar<3)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    IPrioritatEsfChar[IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<3 && ( tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0'))
		  {
		    IPrioritatEsfChar[IndexChar]=tecla;
		  }
	      }
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    ////////////////////////////////Prioritats Dins//////////////////////////////////////////////////////////////////////////////
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    else if(ControlSubSubMenu==6)	//Indica que omplim el quadre per a introduir prioritats contingudes a l'esfera
	      {
		while(IDinsEsfChar[IndexChar]!='V' && IndexChar<3)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    IDinsEsfChar[IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<3 && ( tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0'))
		  {
		    IDinsEsfChar[IndexChar]=tecla;
		  }
	      }
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    ////////////////////////////////Material//////////////////////////////////////////////////////////////////////////////
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    else if(ControlSubSubMenu==7)	//Indica que omplim el quadre material de l'esfera
	      {
		while(IMatEsfChar[IndexChar]!='V' && IndexChar<2)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    IMatEsfChar[IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<2 && ( tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0'))
		  {
	
		    IMatEsfChar[IndexChar]=tecla;
	
		  }
	      }
    
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    //////////////////////////Densitat Esfera/////////////////////////////////////////////////////////////////////////////////   
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////    
	    else if(ControlSubSubMenu==8)	//Indica que omplim el quadre amb la densitat de l'esfera
	      {
		while(IDensEsfChar[IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    IDensEsfChar[IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu=1;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<MAX_CARACTERS_INTRODUIR && ((tecla=='-' && IndexChar==0) || tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0' || tecla=='.'))
		  {
		    if(tecla=='.')		//si es un punt mirarem si ja hi ha un punt al array
		      {
			i=0;
			while(i<IndexChar)	//Mira totes les posicions ocupades en busca d'un '.'
			  {
			    if(IDensEsfChar[i]=='.')	//Si el troba posara LocPunt=true
			      {
				LocPunt=true;
				break;
			      }
			    i++;
			  }
			if(LocPunt==false)			//si no ha trobat punt el posarà a l'array
			  {
			    IDensEsfChar[IndexChar]=tecla;
			  }
		      }else
		      {
			IDensEsfChar[IndexChar]=tecla;
		      }
		  }
	      }    
	  }
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////Fi del la introducció de les esferes//////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	if(ControlSubMenu==3)
	  {
	    ////////////////////////////////Controla la introduccio de dades del cilindre//////////////////////////////////////////////////////
	    //////////////////////////Coordenada X/////////////////////////////////////////////////////////////////////////////////
	    if(ControlSubSubMenu==1)	//Indica que omplim el quadre de CentreX del cilindre
	      {
		while(ICentreCilChar[0][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    ICentreCilChar[0][IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<MAX_CARACTERS_INTRODUIR && ((tecla=='-' && IndexChar==0) || tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0' || tecla=='.'))
		  {
		    if(tecla=='.')		//si es un punt mirarem si ja hi ha un punt al array
		      {
			i=0;
			while(i<IndexChar)	//Mira totes les posicions ocupades en busca d'un '.'
			  {
			    if(ICentreCilChar[0][i]=='.')	//Si el troba posara LocPunt=true
			      {
				LocPunt=true;
				break;
			      }
			    i++;
			  }
			if(LocPunt==false)			//si no ha trobat punt el posarà a l'array
			  {
			    ICentreCilChar[0][IndexChar]=tecla;
			  }
		      }else
		      {
			ICentreCilChar[0][IndexChar]=tecla;
		      }
		  }
	      }
	    //////////////////////////Coordenada Y/////////////////////////////////////////////////////////////////////////////////   
	    else if(ControlSubSubMenu==2)	//Indica que omplim el quadre de CentreY del cilindre
	      {
		while(ICentreCilChar[1][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    ICentreCilChar[1][IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<MAX_CARACTERS_INTRODUIR && ((tecla=='-' && IndexChar==0) || tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0' || tecla=='.'))
		  {
		    if(tecla=='.')		//si es un punt mirarem si ja hi ha un punt al array
		      {
			i=0;
			while(i<IndexChar)	//Mira totes les posicions ocupades en busca d'un '.'
			  {
			    if(ICentreCilChar[1][i]=='.')	//Si el troba posara LocPunt=true
			      {
				LocPunt=true;
				break;
			      }
			    i++;
			  }
			if(LocPunt==false)			//si no ha trobat punt el posarà a l'array
			  {
			    ICentreCilChar[1][IndexChar]=tecla;
			  }
		      }else
		      {
			ICentreCilChar[1][IndexChar]=tecla;
		      }
		  }
	      }
	    //////////////////////////Coordenada Z/////////////////////////////////////////////////////////////////////////////////   
	    else if(ControlSubSubMenu==3)	//Indica que omplim el quadre de CentreZ del cilindre
	      {
		while(ICentreCilChar[2][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    ICentreCilChar[2][IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<MAX_CARACTERS_INTRODUIR && ((tecla=='-' && IndexChar==0) || tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0' || tecla=='.'))
		  {
		    if(tecla=='.')		//si es un punt mirarem si ja hi ha un punt al array
		      {
			i=0;
			while(i<IndexChar)	//Mira totes les posicions ocupades en busca d'un '.'
			  {
			    if(ICentreCilChar[2][i]=='.')	//Si el troba posara LocPunt=true
			      {
				LocPunt=true;
				break;
			      }
			    i++;
			  }
			if(LocPunt==false)			//si no ha trobat punt el posarà a l'array
			  {
			    ICentreCilChar[2][IndexChar]=tecla;
			  }
		      }else
		      {
			ICentreCilChar[2][IndexChar]=tecla;
		      }
		  }
	      }
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    //////////////////////////Dimensio altura cilindre/////////////////////////////////////////////////////////////////////////////////
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    else if(ControlSubSubMenu==4)	//Indica que omplim el quadre de la dimensio X del cilindre
	      {
		while(IDimCilChar[0][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    IDimCilChar[0][IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<MAX_CARACTERS_INTRODUIR && ((tecla=='-' && IndexChar==0) || tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0' || tecla=='.'))
		  {
		    if(tecla=='.')		//si es un punt mirarem si ja hi ha un punt al array
		      {
			i=0;
			while(i<IndexChar)	//Mira totes les posicions ocupades en busca d'un '.'
			  {
			    if(IDimCilChar[0][i]=='.')	//Si el troba posara LocPunt=true
			      {
				LocPunt=true;
				break;
			      }
			    i++;
			  }
			if(LocPunt==false)			//si no ha trobat punt el posarà a l'array
			  {
			    IDimCilChar[0][IndexChar]=tecla;
			  }
		      }else
		      {
			IDimCilChar[0][IndexChar]=tecla;
		      }
		  }
	      }
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////    
	    //////////////////////////Dimensio radi superior cilindre/////////////////////////////////////////////////////////////////////////////////   
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    else if(ControlSubSubMenu==5)	//Indica que omplim el quadre de la dimensió Y del cilindre
	      {
		while(IDimCilChar[1][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    IDimCilChar[1][IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<MAX_CARACTERS_INTRODUIR && ((tecla=='-' && IndexChar==0) || tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0' || tecla=='.'))
		  {
		    if(tecla=='.')		//si es un punt mirarem si ja hi ha un punt al array
		      {
			i=0;
			while(i<IndexChar)	//Mira totes les posicions ocupades en busca d'un '.'
			  {
			    if(IDimCilChar[1][i]=='.')	//Si el troba posara LocPunt=true
			      {
				LocPunt=true;
				break;
			      }
			    i++;
			  }
			if(LocPunt==false)			//si no ha trobat punt el posarà a l'array
			  {
			    IDimCilChar[1][IndexChar]=tecla;
			  }
		      }else
		      {
			IDimCilChar[1][IndexChar]=tecla;
		      }
		  }
	      }
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    //////////////////////////Dimensio radi inferior cilindre/////////////////////////////////////////////////////////////////////////////////   
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////    
	    else if(ControlSubSubMenu==6)	//Indica que omplim el quadre de la dimensió Z del cub
	      {
		while(IDimCilChar[2][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    IDimCilChar[2][IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<MAX_CARACTERS_INTRODUIR && ((tecla=='-' && IndexChar==0) || tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0' || tecla=='.'))
		  {
		    if(tecla=='.')		//si es un punt mirarem si ja hi ha un punt al array
		      {
			i=0;
			while(i<IndexChar)	//Mira totes les posicions ocupades en busca d'un '.'
			  {
			    if(IDimCilChar[2][i]=='.')	//Si el troba posara LocPunt=true
			      {
				LocPunt=true;
				break;
			      }
			    i++;
			  }
			if(LocPunt==false)			//si no ha trobat punt el posarà a l'array
			  {
			    IDimCilChar[2][IndexChar]=tecla;
			  }
		      }else
		      {
			IDimCilChar[2][IndexChar]=tecla;
		      }
		  }
	      }
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    ////////////////////////////////Prioritat//////////////////////////////////////////////////////////////////////////////
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    else if(ControlSubSubMenu==7)	//Indica que omplim el quadre de prioritat del cilindre
	      {
		while(IPrioritatCilChar[IndexChar]!='V' && IndexChar<3)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    IPrioritatCilChar[IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<3 && ( tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0'))
		  {
		    IPrioritatCilChar[IndexChar]=tecla;
		  }
	      }
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    ////////////////////////////////Prioritats Dins//////////////////////////////////////////////////////////////////////////////
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    else if(ControlSubSubMenu==8)	//Indica que omplim el quadre de prioritats a dintre del cilindre
	      {
		while(IDinsCilChar[IndexChar]!='V' && IndexChar<3)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    IDinsCilChar[IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<3 && ( tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0'))
		  {
		    IDinsCilChar[IndexChar]=tecla;
		  }
	      }
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    ////////////////////////////////Material//////////////////////////////////////////////////////////////////////////////
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    else if(ControlSubSubMenu==9)	//Indica que omplim el quadre de material del cilindre
	      {
		while(IMatCilChar[IndexChar]!='V' && IndexChar<2)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    IMatCilChar[IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<2 && ( tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0'))
		  {
	
		    IMatCilChar[IndexChar]=tecla;
	
		  }
	      }
    
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    //////////////////////////Densitat Cil/////////////////////////////////////////////////////////////////////////////////   
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////    
	    else if(ControlSubSubMenu==10)	//Indica que omplim el quadre de densitat del cilindre
	      {
		while(IDensCilChar[IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    IDensCilChar[IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<MAX_CARACTERS_INTRODUIR && ((tecla=='-' && IndexChar==0) || tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0' || tecla=='.'))
		  {
		    if(tecla=='.')		//si es un punt mirarem si ja hi ha un punt al array
		      {
			i=0;
			while(i<IndexChar)	//Mira totes les posicions ocupades en busca d'un '.'
			  {
			    if(IDensCilChar[i]=='.')	//Si el troba posara LocPunt=true
			      {
				LocPunt=true;
				break;
			      }
			    i++;
			  }
			if(LocPunt==false)			//si no ha trobat punt el posarà a l'array
			  {
			    IDensCilChar[IndexChar]=tecla;
			  }
		      }else
		      {
			IDensCilChar[IndexChar]=tecla;
		      }
		  }
	      }    
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    //////////////////////////Angles rotació cilindre/////////////////////////////////////////////////////////////////////////////////   
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////    
    
	    //////////////////////////Angle Alfa/////////////////////////////////////////////////////////////////////////////////
	    else if(ControlSubSubMenu==11)	//Indica que omplim el quadre de angle alfa del cilindre
	      {
		while(IAnglesCilChar[0][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    IAnglesCilChar[0][IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<MAX_CARACTERS_INTRODUIR && ((tecla=='-' && IndexChar==0) || tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0' || tecla=='.'))
		  {
		    if(tecla=='.')		//si es un punt mirarem si ja hi ha un punt al array
		      {
			i=0;
			while(i<IndexChar)	//Mira totes les posicions ocupades en busca d'un '.'
			  {
			    if(IAnglesCilChar[0][i]=='.')	//Si el troba posara LocPunt=true
			      {
				LocPunt=true;
				break;
			      }
			    i++;
			  }
			if(LocPunt==false)			//si no ha trobat punt el posarà a l'array
			  {
			    IAnglesCilChar[0][IndexChar]=tecla;
			  }
		      }else
		      {
			IAnglesCilChar[0][IndexChar]=tecla;
		      }
		  }
	      }
	    //////////////////////////Angle Beta/////////////////////////////////////////////////////////////////////////////////   
	    else if(ControlSubSubMenu==12)	//Indica que omplim el quadre de angle beta del cilindre
	      {
		while(IAnglesCilChar[1][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    IAnglesCilChar[1][IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<MAX_CARACTERS_INTRODUIR && ((tecla=='-' && IndexChar==0) || tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0' || tecla=='.'))
		  {
		    if(tecla=='.')		//si es un punt mirarem si ja hi ha un punt al array
		      {
			i=0;
			while(i<IndexChar)	//Mira totes les posicions ocupades en busca d'un '.'
			  {
			    if(IAnglesCilChar[1][i]=='.')	//Si el troba posara LocPunt=true
			      {
				LocPunt=true;
				break;
			      }
			    i++;
			  }
			if(LocPunt==false)			//si no ha trobat punt el posarà a l'array
			  {
			    IAnglesCilChar[1][IndexChar]=tecla;
			  }
		      }else
		      {
			IAnglesCilChar[1][IndexChar]=tecla;
		      }
		  }
	      }
	    //////////////////////////Angle Gamma/////////////////////////////////////////////////////////////////////////////////   
	    else if(ControlSubSubMenu==13)	//Indica que omplim el quadre de angle gamma del cilindre
	      {
		while(IAnglesCilChar[2][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    IAnglesCilChar[2][IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu=1;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<MAX_CARACTERS_INTRODUIR && ((tecla=='-' && IndexChar==0) || tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0' || tecla=='.'))
		  {
		    if(tecla=='.')		//si es un punt mirarem si ja hi ha un punt al array
		      {
			i=0;
			while(i<IndexChar)	//Mira totes les posicions ocupades en busca d'un '.'
			  {
			    if(IAnglesCilChar[2][i]=='.')	//Si el troba posara LocPunt=true
			      {
				LocPunt=true;
				break;
			      }
			    i++;
			  }
			if(LocPunt==false)			//si no ha trobat punt el posarà a l'array
			  {
			    IAnglesCilChar[2][IndexChar]=tecla;
			  }
		      }else
		      {
			IAnglesCilChar[2][IndexChar]=tecla;
		      }
		  }
	      }    
	  }
    
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////Fi del la introducció de cilindres//////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	if(ControlSubMenu==4)
	  {
	
	    ////////////////////////////////Controla la introduccio de dades del pla infinit//////////////////////////////////////////////////////
	    //////////////////////////Coordenada X/////////////////////////////////////////////////////////////////////////////////
	    if(ControlSubSubMenu==1)	//Indica que omplim el quadre de CentreX del cilindre
	      {
		while(ICentrePlaChar[0][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    ICentrePlaChar[0][IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<MAX_CARACTERS_INTRODUIR && ((tecla=='-' && IndexChar==0) || tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0' || tecla=='.'))
		  {
		    if(tecla=='.')		//si es un punt mirarem si ja hi ha un punt al array
		      {
			i=0;
			while(i<IndexChar)	//Mira totes les posicions ocupades en busca d'un '.'
			  {
			    if(ICentrePlaChar[0][i]=='.')	//Si el troba posara LocPunt=true
			      {
				LocPunt=true;
				break;
			      }
			    i++;
			  }
			if(LocPunt==false)			//si no ha trobat punt el posarà a l'array
			  {
			    ICentrePlaChar[0][IndexChar]=tecla;
			  }
		      }else
		      {
			ICentrePlaChar[0][IndexChar]=tecla;
		      }
		  }
	      }
	    //////////////////////////Coordenada Y/////////////////////////////////////////////////////////////////////////////////   
	    else if(ControlSubSubMenu==2)	//Indica que omplim el quadre de CentreY del cilindre
	      {
		while(ICentrePlaChar[1][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    ICentrePlaChar[1][IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<MAX_CARACTERS_INTRODUIR && ((tecla=='-' && IndexChar==0) || tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0' || tecla=='.'))
		  {
		    if(tecla=='.')		//si es un punt mirarem si ja hi ha un punt al array
		      {
			i=0;
			while(i<IndexChar)	//Mira totes les posicions ocupades en busca d'un '.'
			  {
			    if(ICentrePlaChar[1][i]=='.')	//Si el troba posara LocPunt=true
			      {
				LocPunt=true;
				break;
			      }
			    i++;
			  }
			if(LocPunt==false)			//si no ha trobat punt el posarà a l'array
			  {
			    ICentrePlaChar[1][IndexChar]=tecla;
			  }
		      }else
		      {
			ICentrePlaChar[1][IndexChar]=tecla;
		      }
		  }
	      }
	    //////////////////////////Coordenada Z/////////////////////////////////////////////////////////////////////////////////   
	    else if(ControlSubSubMenu==3)	//Indica que omplim el quadre de CentreZ del cilindre
	      {
		while(ICentrePlaChar[2][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    ICentrePlaChar[2][IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<MAX_CARACTERS_INTRODUIR && ((tecla=='-' && IndexChar==0) || tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0' || tecla=='.'))
		  {
		    if(tecla=='.')		//si es un punt mirarem si ja hi ha un punt al array
		      {
			i=0;
			while(i<IndexChar)	//Mira totes les posicions ocupades en busca d'un '.'
			  {
			    if(ICentrePlaChar[2][i]=='.')	//Si el troba posara LocPunt=true
			      {
				LocPunt=true;
				break;
			      }
			    i++;
			  }
			if(LocPunt==false)			//si no ha trobat punt el posarà a l'array
			  {
			    ICentrePlaChar[2][IndexChar]=tecla;
			  }
		      }else
		      {
			ICentrePlaChar[2][IndexChar]=tecla;
		      }
		  }
	      }
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    ////////////////////////////////Prioritat//////////////////////////////////////////////////////////////////////////////
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    else if(ControlSubSubMenu==4)	//Indica que omplim el quadre de prioritat del cilindre
	      {
		while(IPrioritatPlaChar[IndexChar]!='V' && IndexChar<3)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    IPrioritatPlaChar[IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<3 && ( tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0'))
		  {
		    IPrioritatPlaChar[IndexChar]=tecla;
		  }
	      }
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    ////////////////////////////////Prioritats Dins//////////////////////////////////////////////////////////////////////////////
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    else if(ControlSubSubMenu==5)	//Indica que omplim el quadre de prioritats a dintre del cilindre
	      {
		while(IDinsPlaChar[IndexChar]!='V' && IndexChar<3)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    IDinsPlaChar[IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<3 && ( tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0'))
		  {
		    IDinsPlaChar[IndexChar]=tecla;
		  }
	      }
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    ////////////////////////////////Material//////////////////////////////////////////////////////////////////////////////
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    else if(ControlSubSubMenu==6)	//Indica que omplim el quadre de material del cilindre
	      {
		while(IMatPlaChar[IndexChar]!='V' && IndexChar<2)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    IMatPlaChar[IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<2 && ( tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0'))
		  {
	
		    IMatPlaChar[IndexChar]=tecla;
	
		  }
	      }
    
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    //////////////////////////Densitat Pla/////////////////////////////////////////////////////////////////////////////////   
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////    
	    else if(ControlSubSubMenu==7)	//Indica que omplim el quadre de densitat del cilindre
	      {
		while(IDensPlaChar[IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    IDensPlaChar[IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<MAX_CARACTERS_INTRODUIR && ((tecla=='-' && IndexChar==0) || tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0' || tecla=='.'))
		  {
		    if(tecla=='.')		//si es un punt mirarem si ja hi ha un punt al array
		      {
			i=0;
			while(i<IndexChar)	//Mira totes les posicions ocupades en busca d'un '.'
			  {
			    if(IDensPlaChar[i]=='.')	//Si el troba posara LocPunt=true
			      {
				LocPunt=true;
				break;
			      }
			    i++;
			  }
			if(LocPunt==false)			//si no ha trobat punt el posarà a l'array
			  {
			    IDensPlaChar[IndexChar]=tecla;
			  }
		      }else
		      {
			IDensPlaChar[IndexChar]=tecla;
		      }
		  }
	      }    
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    //////////////////////////Direccio pla/////////////////////////////////////////////////////////////////////////////////   
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////    
    
	    //////////////////////////Direccio X/////////////////////////////////////////////////////////////////////////////////
	    else if(ControlSubSubMenu==8)	//Indica que omplim el quadre de angle alfa del cilindre
	      {
		while(IAnglesPlaChar[0][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    IAnglesPlaChar[0][IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<MAX_CARACTERS_INTRODUIR && ((tecla=='-' && IndexChar==0) || tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0' || tecla=='.'))
		  {
		    if(tecla=='.')		//si es un punt mirarem si ja hi ha un punt al array
		      {
			i=0;
			while(i<IndexChar)	//Mira totes les posicions ocupades en busca d'un '.'
			  {
			    if(IAnglesPlaChar[0][i]=='.')	//Si el troba posara LocPunt=true
			      {
				LocPunt=true;
				break;
			      }
			    i++;
			  }
			if(LocPunt==false)			//si no ha trobat punt el posarà a l'array
			  {
			    IAnglesPlaChar[0][IndexChar]=tecla;
			  }
		      }else
		      {
			IAnglesPlaChar[0][IndexChar]=tecla;
		      }
		  }
	      }
	    //////////////////////////Direccio Y/////////////////////////////////////////////////////////////////////////////////   
	    else if(ControlSubSubMenu==9)	//Indica que omplim el quadre de angle beta del cilindre
	      {
		while(IAnglesPlaChar[1][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    IAnglesPlaChar[1][IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<MAX_CARACTERS_INTRODUIR && ((tecla=='-' && IndexChar==0) || tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0' || tecla=='.'))
		  {
		    if(tecla=='.')		//si es un punt mirarem si ja hi ha un punt al array
		      {
			i=0;
			while(i<IndexChar)	//Mira totes les posicions ocupades en busca d'un '.'
			  {
			    if(IAnglesPlaChar[1][i]=='.')	//Si el troba posara LocPunt=true
			      {
				LocPunt=true;
				break;
			      }
			    i++;
			  }
			if(LocPunt==false)			//si no ha trobat punt el posarà a l'array
			  {
			    IAnglesPlaChar[1][IndexChar]=tecla;
			  }
		      }else
		      {
			IAnglesPlaChar[1][IndexChar]=tecla;
		      }
		  }
	      }
	    //////////////////////////Direccio Z/////////////////////////////////////////////////////////////////////////////////   
	    else if(ControlSubSubMenu==10)	//Indica que omplim el quadre de angle gamma del cilindre
	      {
		while(IAnglesPlaChar[2][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    IAnglesPlaChar[2][IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu=1;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<MAX_CARACTERS_INTRODUIR && ((tecla=='-' && IndexChar==0) || tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0' || tecla=='.'))
		  {
		    if(tecla=='.')		//si es un punt mirarem si ja hi ha un punt al array
		      {
			i=0;
			while(i<IndexChar)	//Mira totes les posicions ocupades en busca d'un '.'
			  {
			    if(IAnglesPlaChar[2][i]=='.')	//Si el troba posara LocPunt=true
			      {
				LocPunt=true;
				break;
			      }
			    i++;
			  }
			if(LocPunt==false)			//si no ha trobat punt el posarà a l'array
			  {
			    IAnglesPlaChar[2][IndexChar]=tecla;
			  }
		      }else
		      {
			IAnglesPlaChar[2][IndexChar]=tecla;
		      }
		  }
	      }    
	  }
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////Fi del la introducció de plans//////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	if(ControlSubMenu==5)
	  {
	    ////////////////////////////////Controla la introduccio de dades de la secció d'esfera//////////////////////////////////////////////////////
	    //////////////////////////Coordenada X/////////////////////////////////////////////////////////////////////////////////
	    if(ControlSubSubMenu==1)	//Indica que omplim el quadre de CentreX de la secció d'esfera
	      {
		while(ICentreSecEsfChar[0][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    ICentreSecEsfChar[0][IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<MAX_CARACTERS_INTRODUIR && ((tecla=='-' && IndexChar==0) || tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0' || tecla=='.'))
		  {
		    if(tecla=='.')		//si es un punt mirarem si ja hi ha un punt al array
		      {
			i=0;
			while(i<IndexChar)	//Mira totes les posicions ocupades en busca d'un '.'
			  {
			    if(ICentreSecEsfChar[0][i]=='.')	//Si el troba posara LocPunt=true
			      {
				LocPunt=true;
				break;
			      }
			    i++;
			  }
			if(LocPunt==false)			//si no ha trobat punt el posarà a l'array
			  {
			    ICentreSecEsfChar[0][IndexChar]=tecla;
			  }
		      }else
		      {
			ICentreSecEsfChar[0][IndexChar]=tecla;
		      }
		  }
	      }
	    //////////////////////////Coordenada Y/////////////////////////////////////////////////////////////////////////////////   
	    else if(ControlSubSubMenu==2)	//Indica que omplim el quadre de CentreY de la secció d'esfera
	      {
		while(ICentreSecEsfChar[1][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    ICentreSecEsfChar[1][IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<MAX_CARACTERS_INTRODUIR && ((tecla=='-' && IndexChar==0) || tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0' || tecla=='.'))
		  {
		    if(tecla=='.')		//si es un punt mirarem si ja hi ha un punt al array
		      {
			i=0;
			while(i<IndexChar)	//Mira totes les posicions ocupades en busca d'un '.'
			  {
			    if(ICentreSecEsfChar[1][i]=='.')	//Si el troba posara LocPunt=true
			      {
				LocPunt=true;
				break;
			      }
			    i++;
			  }
			if(LocPunt==false)			//si no ha trobat punt el posarà a l'array
			  {
			    ICentreSecEsfChar[1][IndexChar]=tecla;
			  }
		      }else
		      {
			ICentreSecEsfChar[1][IndexChar]=tecla;
		      }
		  }
	      }
	    //////////////////////////Coordenada Z/////////////////////////////////////////////////////////////////////////////////   
	    else if(ControlSubSubMenu==3)	//Indica que omplim el quadre de CentreZ de la secció d'esfera
	      {
		while(ICentreSecEsfChar[2][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    ICentreSecEsfChar[2][IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<MAX_CARACTERS_INTRODUIR && ((tecla=='-' && IndexChar==0) || tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0' || tecla=='.'))
		  {
		    if(tecla=='.')		//si es un punt mirarem si ja hi ha un punt al array
		      {
			i=0;
			while(i<IndexChar)	//Mira totes les posicions ocupades en busca d'un '.'
			  {
			    if(ICentreSecEsfChar[2][i]=='.')	//Si el troba posara LocPunt=true
			      {
				LocPunt=true;
				break;
			      }
			    i++;
			  }
			if(LocPunt==false)			//si no ha trobat punt el posarà a l'array
			  {
			    ICentreSecEsfChar[2][IndexChar]=tecla;
			  }
		      }else
		      {
			ICentreSecEsfChar[2][IndexChar]=tecla;
		      }
		  }
	      }
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    //////////////////////////Dimensio radi de la secció d'esfera/////////////////////////////////////////////////////////////////////////////////
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    else if(ControlSubSubMenu==4)	//Indica que omplim el quadre del radi de la secció d'esfera
	      {
		while(IDimSecEsfChar[0][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    IDimSecEsfChar[0][IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<MAX_CARACTERS_INTRODUIR && ((tecla=='-' && IndexChar==0) || tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0' || tecla=='.'))
		  {
		    if(tecla=='.')		//si es un punt mirarem si ja hi ha un punt al array
		      {
			i=0;
			while(i<IndexChar)	//Mira totes les posicions ocupades en busca d'un '.'
			  {
			    if(IDimSecEsfChar[0][i]=='.')	//Si el troba posara LocPunt=true
			      {
				LocPunt=true;
				break;
			      }
			    i++;
			  }
			if(LocPunt==false)			//si no ha trobat punt el posarà a l'array
			  {
			    IDimSecEsfChar[0][IndexChar]=tecla;
			  }
		      }else
		      {
			IDimSecEsfChar[0][IndexChar]=tecla;
		      }
		  }
	      }
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////    
	    //////////////////////////Dimensio altura de tall del pla/////////////////////////////////////////////////////////////////////////////////   
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    else if(ControlSubSubMenu==5)	//Indica que omplim el quadre de l'altura de tall del pla de la secció d'esfera
	      {
		while(IDimSecEsfChar[1][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    IDimSecEsfChar[1][IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<MAX_CARACTERS_INTRODUIR && ((tecla=='-' && IndexChar==0) || tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0' || tecla=='.'))
		  {
		    if(tecla=='.')		//si es un punt mirarem si ja hi ha un punt al array
		      {
			i=0;
			while(i<IndexChar)	//Mira totes les posicions ocupades en busca d'un '.'
			  {
			    if(IDimSecEsfChar[1][i]=='.')	//Si el troba posara LocPunt=true
			      {
				LocPunt=true;
				break;
			      }
			    i++;
			  }
			if(LocPunt==false)			//si no ha trobat punt el posarà a l'array
			  {
			    IDimSecEsfChar[1][IndexChar]=tecla;
			  }
		      }else
		      {
			IDimSecEsfChar[1][IndexChar]=tecla;
		      }
		  }
	      }

	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    ////////////////////////////////Prioritat//////////////////////////////////////////////////////////////////////////////
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    else if(ControlSubSubMenu==6)	//Indica que omplim el quadre de prioritat de la secció d'esfera
	      {
		while(IPrioritatSecEsfChar[IndexChar]!='V' && IndexChar<3)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    IPrioritatSecEsfChar[IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<3 && ( tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0'))
		  {
		    IPrioritatSecEsfChar[IndexChar]=tecla;
		  }
	      }
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    ////////////////////////////////Prioritats Dins//////////////////////////////////////////////////////////////////////////////
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    else if(ControlSubSubMenu==7)	//Indica que omplim el quadre de prioritats a dintre de la secció d'esfera
	      {
		while(IDinsSecEsfChar[IndexChar]!='V' && IndexChar<3)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    IDinsSecEsfChar[IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<3 && ( tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0'))
		  {
		    IDinsSecEsfChar[IndexChar]=tecla;
		  }
	      }
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    ////////////////////////////////Material//////////////////////////////////////////////////////////////////////////////
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    else if(ControlSubSubMenu==8)	//Indica que omplim el quadre de material de la secció d'esfera
	      {
		while(IMatSecEsfChar[IndexChar]!='V' && IndexChar<2)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    IMatSecEsfChar[IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<2 && ( tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0'))
		  {
	
		    IMatSecEsfChar[IndexChar]=tecla;
	
		  }
	      }
    
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    //////////////////////////Densitat SecEsf/////////////////////////////////////////////////////////////////////////////////   
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////    
	    else if(ControlSubSubMenu==9)	//Indica que omplim el quadre de densitat de la secció d'esfera
	      {
		while(IDensSecEsfChar[IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    IDensSecEsfChar[IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<MAX_CARACTERS_INTRODUIR && ((tecla=='-' && IndexChar==0) || tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0' || tecla=='.'))
		  {
		    if(tecla=='.')		//si es un punt mirarem si ja hi ha un punt al array
		      {
			i=0;
			while(i<IndexChar)	//Mira totes les posicions ocupades en busca d'un '.'
			  {
			    if(IDensSecEsfChar[i]=='.')	//Si el troba posara LocPunt=true
			      {
				LocPunt=true;
				break;
			      }
			    i++;
			  }
			if(LocPunt==false)			//si no ha trobat punt el posarà a l'array
			  {
			    IDensSecEsfChar[IndexChar]=tecla;
			  }
		      }else
		      {
			IDensSecEsfChar[IndexChar]=tecla;
		      }
		  }
	      }    
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    //////////////////////////Angles rotació de la secció d'esfera/////////////////////////////////////////////////////////////////////////////////   
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////    
    
	    //////////////////////////Direccio X/////////////////////////////////////////////////////////////////////////////////
	    else if(ControlSubSubMenu==10)	//Indica que omplim el quadre de direccio X del de la secció d'esfera
	      {
		while(IAnglesSecEsfChar[0][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    IAnglesSecEsfChar[0][IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<MAX_CARACTERS_INTRODUIR && ((tecla=='-' && IndexChar==0) || tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0' || tecla=='.'))
		  {
		    if(tecla=='.')		//si es un punt mirarem si ja hi ha un punt al array
		      {
			i=0;
			while(i<IndexChar)	//Mira totes les posicions ocupades en busca d'un '.'
			  {
			    if(IAnglesSecEsfChar[0][i]=='.')	//Si el troba posara LocPunt=true
			      {
				LocPunt=true;
				break;
			      }
			    i++;
			  }
			if(LocPunt==false)			//si no ha trobat punt el posarà a l'array
			  {
			    IAnglesSecEsfChar[0][IndexChar]=tecla;
			  }
		      }else
		      {
			IAnglesSecEsfChar[0][IndexChar]=tecla;
		      }
		  }
	      }
	    //////////////////////////Direccio Y/////////////////////////////////////////////////////////////////////////////////   
	    else if(ControlSubSubMenu==11)	//Indica que omplim el quadre de direccio Y de la secció d'esfera
	      {
		while(IAnglesSecEsfChar[1][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    IAnglesSecEsfChar[1][IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<MAX_CARACTERS_INTRODUIR && ((tecla=='-' && IndexChar==0) || tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0' || tecla=='.'))
		  {
		    if(tecla=='.')		//si es un punt mirarem si ja hi ha un punt al array
		      {
			i=0;
			while(i<IndexChar)	//Mira totes les posicions ocupades en busca d'un '.'
			  {
			    if(IAnglesSecEsfChar[1][i]=='.')	//Si el troba posara LocPunt=true
			      {
				LocPunt=true;
				break;
			      }
			    i++;
			  }
			if(LocPunt==false)			//si no ha trobat punt el posarà a l'array
			  {
			    IAnglesSecEsfChar[1][IndexChar]=tecla;
			  }
		      }else
		      {
			IAnglesSecEsfChar[1][IndexChar]=tecla;
		      }
		  }
	      }
	    //////////////////////////Direccio Z/////////////////////////////////////////////////////////////////////////////////   
	    else if(ControlSubSubMenu==12)	//Indica que omplim el quadre de direccio Z de la secció d'esfera
	      {
		while(IAnglesSecEsfChar[2][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    IAnglesSecEsfChar[2][IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu=1;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<MAX_CARACTERS_INTRODUIR && ((tecla=='-' && IndexChar==0) || tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0' || tecla=='.'))
		  {
		    if(tecla=='.')		//si es un punt mirarem si ja hi ha un punt al array
		      {
			i=0;
			while(i<IndexChar)	//Mira totes les posicions ocupades en busca d'un '.'
			  {
			    if(IAnglesSecEsfChar[2][i]=='.')	//Si el troba posara LocPunt=true
			      {
				LocPunt=true;
				break;
			      }
			    i++;
			  }
			if(LocPunt==false)			//si no ha trobat punt el posarà a l'array
			  {
			    IAnglesSecEsfChar[2][IndexChar]=tecla;
			  }
		      }else
		      {
			IAnglesSecEsfChar[2][IndexChar]=tecla;
		      }
		  }
	      }
	  }
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////Fi del la introducció de seccio d'esfera//////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    
}
    else if(ControlMenu==3)
      {
	if(ControlSubMenu==1)
	  {
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    //////////////////////////Plans de tall dels voxels/////////////////////////////////////////////////////////////////////////////////   
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////    
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    //////////////////////////Plans X///////////////////////////////////////////////////////////////////////////////////////   
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////    
 
 
	    if(ControlSubSubMenu==1)	//Indica que omplim el quadre de pla X de tall per a pintar els voxels
	      {
		while(IPlansTallChar[0][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    IPlansTallChar[0][IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<MAX_CARACTERS_INTRODUIR && ( tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0' || tecla=='.'))
		  {
		    if(tecla=='.')		//si es un punt mirarem si ja hi ha un punt al array
		      {
			i=0;
			while(i<IndexChar)	//Mira totes les posicions ocupades en busca d'un '.'
			  {
			    if(IPlansTallChar[0][i]=='.')	//Si el troba posara LocPunt=true
			      {
				LocPunt=true;
				break;
			      }
			    i++;
			  }
			if(LocPunt==false)			//si no ha trobat punt el posarà a l'array
			  {
			    IPlansTallChar[0][IndexChar]=tecla;
			  }
		      }else
		      {
			IPlansTallChar[0][IndexChar]=tecla;
		      }
		  }
	      }    
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    //////////////////////////Plans Y///////////////////////////////////////////////////////////////////////////////////////   
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////    
    
	    else if(ControlSubSubMenu==2)	//Indica que omplim el quadre de pla Y de tall per a pintar els voxels
	      {
		while(IPlansTallChar[1][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    IPlansTallChar[1][IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<MAX_CARACTERS_INTRODUIR && ( tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0' || tecla=='.'))
		  {
		    if(tecla=='.')		//si es un punt mirarem si ja hi ha un punt al array
		      {
			i=0;
			while(i<IndexChar)	//Mira totes les posicions ocupades en busca d'un '.'
			  {
			    if(IPlansTallChar[1][i]=='.')	//Si el troba posara LocPunt=true
			      {
				LocPunt=true;
				break;
			      }
			    i++;
			  }
			if(LocPunt==false)			//si no ha trobat punt el posarà a l'array
			  {
			    IPlansTallChar[1][IndexChar]=tecla;
			  }
		      }else
		      {
			IPlansTallChar[1][IndexChar]=tecla;
		      }
		  }
	      }    
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    //////////////////////////Plans Z///////////////////////////////////////////////////////////////////////////////////////   
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////    
    
	    else if(ControlSubSubMenu==3)	//Indica que omplim el quadre de pla Y de tall per a pintar els voxels
	      {
		while(IPlansTallChar[2][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    IPlansTallChar[2][IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<MAX_CARACTERS_INTRODUIR && ( tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0' || tecla=='.'))
		  {
		    if(tecla=='.')		//si es un punt mirarem si ja hi ha un punt al array
		      {
			i=0;
			while(i<IndexChar)	//Mira totes les posicions ocupades en busca d'un '.'
			  {
			    if(IPlansTallChar[2][i]=='.')	//Si el troba posara LocPunt=true
			      {
				LocPunt=true;
				break;
			      }
			    i++;
			  }
			if(LocPunt==false)			//si no ha trobat punt el posarà a l'array
			  {
			    IPlansTallChar[2][IndexChar]=tecla;
			  }
		      }else
		      {
			IPlansTallChar[2][IndexChar]=tecla;
		      }
		  }
	      }
	  }
      }
    else if(ControlMenu==7)
      {
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	//////////////////////////Simulacio////////////////////////////////////////////////////////////////////////////////////   
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////    
 
	if(ControlSubMenu==1)	//Nom de la simulacio
	  {
	    while(INomSimulacio[IndexChar]!='\0' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
	      {
		IndexChar++;
	      }
	    if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
	      {
		INomSimulacio[IndexChar-1]='\0';
	      }
	    else if(tecla==' ' && IndexChar==0)
	      {
		//No fa res si posem un espai al inici
	      }
	    else if(tecla<=31 || tecla==127)
	      {
		//No fa res ja que són caràcters no imprimibles
	      }
	    //Aquest if mirara si hem arribat al màxim tamany de l'array
	    else if(IndexChar<99)
	      {
		INomSimulacio[IndexChar]=tecla;
		INomSimulacio[IndexChar+1]='\0';
	      }
      
	  }
	else if(ControlSubMenu==2)	//Nom de l'arxiu de configuracio
	  {
	    while(INomArxiuConfig[IndexChar]!='\0' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
	      {
		IndexChar++;
	      }
	    if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
	      {
		INomArxiuConfig[IndexChar-1]='\0';
	      }
	    else if(tecla==' ' && IndexChar==0)
	      {
		//No fa res si posem un espai al inici
	      }
	    else if(tecla<=31 || tecla==127)
	      {
		//No fa res ja que són caràcters no imprimibles
	      }
	    //Aquest if mirara si hem arribat al màxim tamany de l'array
	    else if(IndexChar<99)
	      {
		INomArxiuConfig[IndexChar]=tecla;
		INomArxiuConfig[IndexChar+1]='\0';
	      }
      
	  }
	else if(ControlSubMenu==3)	//Nom de l'arxiu de geometria quadrigues
	  {
	    while(INomArxiuGeoQuad[IndexChar]!='\0' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
	      {
		IndexChar++;
	      }
	    if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
	      {
		INomArxiuGeoQuad[IndexChar-1]='\0';
	      }
	    else if(tecla==' ' && IndexChar==0)
	      {
		//No fa res si posem un espai al inici
	      }
	    else if(tecla<=31 || tecla==127)
	      {
		//No fa res ja que són caràcters no imprimibles
	      }
	    //Aquest if mirara si hem arribat al màxim tamany de l'array
	    else if(IndexChar<99)
	      {
		INomArxiuGeoQuad[IndexChar]=tecla;
		INomArxiuGeoQuad[IndexChar+1]='\0';
	      }
      
	  }
	else if(ControlSubMenu==4)	//Nom de l'arxiu de voxelitzat
	  {
	    while(INomArxiuGeoVox[IndexChar]!='\0' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
	      {
		IndexChar++;
	      }
	    if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
	      {
		INomArxiuGeoVox[IndexChar-1]='\0';
	      }
	    else if(tecla==' ' && IndexChar==0)
	      {
		//No fa res si posem un espai al inici
	      }
	    else if(tecla<=31 || tecla==127)
	      {
		//No fa res ja que són caràcters no imprimibles
	      }
	    //Aquest if mirara si hem arribat al màxim tamany de l'array
	    else if(IndexChar<99)
	      {
		INomArxiuGeoVox[IndexChar]=tecla;
		INomArxiuGeoVox[IndexChar+1]='\0';
	      }
      
	  }
	else if(ControlSubMenu==5)	//Indica que omplim el quadre de nombre de simulacions
	  {
	    while(INumSimulacions[IndexChar]!='V' && IndexChar<2)		//Mira quina posició és la primera buida (Amb una 'V')
	      {
		IndexChar++;
	      }
	    if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
	      {
		INumSimulacions[IndexChar-1]='V';
	      }
	    //Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un número
	    else if( IndexChar<2 && ( tecla=='0' || tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9'))
	      {
		if(IndexChar==0 && tecla=='0')
		  {
		    //No fa res
		  }
		else
		  {
		    INumSimulacions[IndexChar]=tecla;
		  }
	      }
	  }
      }
    else if(ControlMenu==9)
      {
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	//////////////////////////Visor de resultats///////////////////////////////////////////////////////////////////////////   
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////    
 
	if(ControlSubMenu==0)	//Nom de la simulacio
	  {
	    while(INomSimulacio[IndexChar]!='\0' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
	      {
		IndexChar++;
	      }
	    if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
	      {
		INomSimulacio[IndexChar-1]='\0';
	      }
	    else if(tecla==' ' && IndexChar==0)
	      {
		//No fa res si posem un espai al inici
	      }
	    else if(tecla<=31 || tecla==127)
	      {
		//No fa res ja que són caràcters no imprimibles
	      }
	    //Aquest if mirara si hem arribat al màxim tamany de l'array
	    else if(IndexChar<99)
	      {
		INomSimulacio[IndexChar]=tecla;
		INomSimulacio[IndexChar+1]='\0';
	      }
      
	  }
	else if(ControlSubMenu==1)
	  {
	    //////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    //////////////////////////////////Dosi mínima del visor de resultats//////////////////////////////////////////
	    //////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    if(ControlSubSubMenu==1)
	      {
		while(IMinDosisChar[IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    IMinDosisChar[IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<MAX_CARACTERS_INTRODUIR && ( tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0' || tecla=='.'))
		  {
		    if(tecla=='.')		//si es un punt mirarem si ja hi ha un punt al array
		      {
			i=0;
			while(i<IndexChar)	//Mira totes les posicions ocupades en busca d'un '.'
			  {
			    if(IMinDosisChar[i]=='.')	//Si el troba posara LocPunt=true
			      {
				LocPunt=true;
				break;
			      }
			    i++;
			  }
			if(LocPunt==false)			//si no ha trobat punt el posarà a l'array
			  {
			    IMinDosisChar[IndexChar]=tecla;
			  }
		      }else
		      {
			IMinDosisChar[IndexChar]=tecla;
		      }
		  }      
	      }
	    //////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    //////////////////////////////////Dosi màxima del visor de resultats//////////////////////////////////////////
	    //////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    else if(ControlSubSubMenu==2)
	      {
		while(IMaxDosisChar[IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    IMaxDosisChar[IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<MAX_CARACTERS_INTRODUIR && ( tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0' || tecla=='.'))
		  {
		    if(tecla=='.')		//si es un punt mirarem si ja hi ha un punt al array
		      {
			i=0;
			while(i<IndexChar)	//Mira totes les posicions ocupades en busca d'un '.'
			  {
			    if(IMaxDosisChar[i]=='.')	//Si el troba posara LocPunt=true
			      {
				LocPunt=true;
				break;
			      }
			    i++;
			  }
			if(LocPunt==false)			//si no ha trobat punt el posarà a l'array
			  {
			    IMaxDosisChar[IndexChar]=tecla;
			  }
		      }else
		      {
			IMaxDosisChar[IndexChar]=tecla;
		      }
		  }      
	      }    
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    //////////////////////////Plans X del visor de resultats///////////////////////////////////////////////////////////////////////////////////////   
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////    
 
 
	    else if(ControlSubSubMenu==3)	//Indica que omplim el quadre de pla X de tall per a pintar els voxels
	      {
		while(IPlansTallChar[0][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    IPlansTallChar[0][IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<MAX_CARACTERS_INTRODUIR && ( tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0' || tecla=='.'))
		  {
		    if(tecla=='.')		//si es un punt mirarem si ja hi ha un punt al array
		      {
			i=0;
			while(i<IndexChar)	//Mira totes les posicions ocupades en busca d'un '.'
			  {
			    if(IPlansTallChar[0][i]=='.')	//Si el troba posara LocPunt=true
			      {
				LocPunt=true;
				break;
			      }
			    i++;
			  }
			if(LocPunt==false)			//si no ha trobat punt el posarà a l'array
			  {
			    IPlansTallChar[0][IndexChar]=tecla;
			  }
		      }else
		      {
			IPlansTallChar[0][IndexChar]=tecla;
		      }
		  }
	      }    
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    //////////////////////////Plans Y del visor de resultats///////////////////////////////////////////////////////////////////////////////////////   
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////    
    
	    else if(ControlSubSubMenu==4)	//Indica que omplim el quadre de pla Y de tall per a pintar els voxels
	      {
		while(IPlansTallChar[1][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    IPlansTallChar[1][IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<MAX_CARACTERS_INTRODUIR && ( tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0' || tecla=='.'))
		  {
		    if(tecla=='.')		//si es un punt mirarem si ja hi ha un punt al array
		      {
			i=0;
			while(i<IndexChar)	//Mira totes les posicions ocupades en busca d'un '.'
			  {
			    if(IPlansTallChar[1][i]=='.')	//Si el troba posara LocPunt=true
			      {
				LocPunt=true;
				break;
			      }
			    i++;
			  }
			if(LocPunt==false)			//si no ha trobat punt el posarà a l'array
			  {
			    IPlansTallChar[1][IndexChar]=tecla;
			  }
		      }else
		      {
			IPlansTallChar[1][IndexChar]=tecla;
		      }
		  }
	      }
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    //////////////////////////Plans Z del visor de resultats///////////////////////////////////////////////////////////////////////////////////////   
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////    
    
	    else if(ControlSubSubMenu==5)	//Indica que omplim el quadre de pla Y de tall per a pintar els voxels
	      {
		while(IPlansTallChar[2][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    IPlansTallChar[2][IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu=1;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<MAX_CARACTERS_INTRODUIR && ( tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0' || tecla=='.'))
		  {
		    if(tecla=='.')		//si es un punt mirarem si ja hi ha un punt al array
		      {
			i=0;
			while(i<IndexChar)	//Mira totes les posicions ocupades en busca d'un '.'
			  {
			    if(IPlansTallChar[2][i]=='.')	//Si el troba posara LocPunt=true
			      {
				LocPunt=true;
				break;
			      }
			    i++;
			  }
			if(LocPunt==false)			//si no ha trobat punt el posarà a l'array
			  {
			    IPlansTallChar[2][IndexChar]=tecla;
			  }
		      }else
		      {
			IPlansTallChar[2][IndexChar]=tecla;
		      }
		  }
	      }
	  }
      }
    else if(ControlMenu==10)
      {
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	//////////////////////////Introducció de la carpeta amb el DICOM///////////////////////////////////////////////////////   
	/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
	if(ControlSubMenu==0)
	  {
	    while(INomDicom[IndexChar]!='\0' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
	      {
		IndexChar++;
	      }
	    if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
	      {
		INomDicom[IndexChar-1]='\0';
	      }
	    else if(tecla==' ' && IndexChar==0)
	      {
		//No fa res si posem un espai al inici
	      }
	    else if(tecla<=31 || tecla==127)
	      {
		//No fa res ja que són caràcters no imprimibles
	      }
	    //Aquest if mirara si hem arribat al màxim tamany de l'array
	    else if(IndexChar<99)
	      {
		INomDicom[IndexChar]=tecla;
		INomDicom[IndexChar+1]='\0';
	      }
      
	  
	  }
	else if(ControlSubMenu==1)
	  {
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    //////////////////////////Plans de tall dels voxels del DICOM/////////////////////////////////////////////////////////////////////////////////   
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////    
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    //////////////////////////Plans X Superiors///////////////////////////////////////////////////////////////////////////////////////   
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////    
 
 
	    if(ControlSubSubMenu==1)	//Indica que omplim el quadre de pla X de tall per a pintar els voxels
	      {
		while(IPlansTallChar[0][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    IPlansTallChar[0][IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<MAX_CARACTERS_INTRODUIR && ( tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0' || tecla=='.'))
		  {
		    if(tecla=='.')		//si es un punt mirarem si ja hi ha un punt al array
		      {
			i=0;
			while(i<IndexChar)	//Mira totes les posicions ocupades en busca d'un '.'
			  {
			    if(IPlansTallChar[0][i]=='.')	//Si el troba posara LocPunt=true
			      {
				LocPunt=true;
				break;
			      }
			    i++;
			  }
			if(LocPunt==false)			//si no ha trobat punt el posarà a l'array
			  {
			    IPlansTallChar[0][IndexChar]=tecla;
			  }
		      }else
		      {
			IPlansTallChar[0][IndexChar]=tecla;
		      }
		  }
	      }    
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    //////////////////////////Plans Y Superiors///////////////////////////////////////////////////////////////////////////////////////   
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////    
    
	    else if(ControlSubSubMenu==2)	//Indica que omplim el quadre de pla Y de tall per a pintar els voxels
	      {
		while(IPlansTallChar[1][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    IPlansTallChar[1][IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<MAX_CARACTERS_INTRODUIR && ( tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0' || tecla=='.'))
		  {
		    if(tecla=='.')		//si es un punt mirarem si ja hi ha un punt al array
		      {
			i=0;
			while(i<IndexChar)	//Mira totes les posicions ocupades en busca d'un '.'
			  {
			    if(IPlansTallChar[1][i]=='.')	//Si el troba posara LocPunt=true
			      {
				LocPunt=true;
				break;
			      }
			    i++;
			  }
			if(LocPunt==false)			//si no ha trobat punt el posarà a l'array
			  {
			    IPlansTallChar[1][IndexChar]=tecla;
			  }
		      }else
		      {
			IPlansTallChar[1][IndexChar]=tecla;
		      }
		  }
	      }    
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    //////////////////////////Plans Z Superiors///////////////////////////////////////////////////////////////////////////////////////   
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////    
    
	    else if(ControlSubSubMenu==3)	//Indica que omplim el quadre de pla Y de tall per a pintar els voxels
	      {
		while(IPlansTallChar[2][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    IPlansTallChar[2][IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<MAX_CARACTERS_INTRODUIR && ( tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0' || tecla=='.'))
		  {
		    if(tecla=='.')		//si es un punt mirarem si ja hi ha un punt al array
		      {
			i=0;
			while(i<IndexChar)	//Mira totes les posicions ocupades en busca d'un '.'
			  {
			    if(IPlansTallChar[2][i]=='.')	//Si el troba posara LocPunt=true
			      {
				LocPunt=true;
				break;
			      }
			    i++;
			  }
			if(LocPunt==false)			//si no ha trobat punt el posarà a l'array
			  {
			    IPlansTallChar[2][IndexChar]=tecla;
			  }
		      }else
		      {
			IPlansTallChar[2][IndexChar]=tecla;
		      }
		  }
	      }    
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    //////////////////////////Plans X Inferiors///////////////////////////////////////////////////////////////////////////////////////   
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////    
 
 
	    else if(ControlSubSubMenu==4)	//Indica que omplim el quadre de pla X de tall per a pintar els voxels
	      {
		while(IPlansTallCharInf[0][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    IPlansTallCharInf[0][IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<MAX_CARACTERS_INTRODUIR && ( tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0' || tecla=='.'))
		  {
		    if(tecla=='.')		//si es un punt mirarem si ja hi ha un punt al array
		      {
			i=0;
			while(i<IndexChar)	//Mira totes les posicions ocupades en busca d'un '.'
			  {
			    if(IPlansTallCharInf[0][i]=='.')	//Si el troba posara LocPunt=true
			      {
				LocPunt=true;
				break;
			      }
			    i++;
			  }
			if(LocPunt==false)			//si no ha trobat punt el posarà a l'array
			  {
			    IPlansTallCharInf[0][IndexChar]=tecla;
			  }
		      }else
		      {
			IPlansTallCharInf[0][IndexChar]=tecla;
		      }
		  }
	      }    
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    //////////////////////////Plans Y Inferiors///////////////////////////////////////////////////////////////////////////////////////   
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////    
    
	    else if(ControlSubSubMenu==5)	//Indica que omplim el quadre de pla Y de tall per a pintar els voxels
	      {
		while(IPlansTallCharInf[1][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    IPlansTallCharInf[1][IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu++;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<MAX_CARACTERS_INTRODUIR && ( tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0' || tecla=='.'))
		  {
		    if(tecla=='.')		//si es un punt mirarem si ja hi ha un punt al array
		      {
			i=0;
			while(i<IndexChar)	//Mira totes les posicions ocupades en busca d'un '.'
			  {
			    if(IPlansTallCharInf[1][i]=='.')	//Si el troba posara LocPunt=true
			      {
				LocPunt=true;
				break;
			      }
			    i++;
			  }
			if(LocPunt==false)			//si no ha trobat punt el posarà a l'array
			  {
			    IPlansTallCharInf[1][IndexChar]=tecla;
			  }
		      }else
		      {
			IPlansTallCharInf[1][IndexChar]=tecla;
		      }
		  }
	      }    
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    //////////////////////////Plans Z Inferiors///////////////////////////////////////////////////////////////////////////////////////   
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////    
    
	    else if(ControlSubSubMenu==6)	//Indica que omplim el quadre de pla Y de tall per a pintar els voxels
	      {
		while(IPlansTallCharInf[2][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
		  {
		    IndexChar++;
		  }
		if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
		  {
		    IPlansTallCharInf[2][IndexChar-1]='V';
		  }
		else if(tecla==9)						//Si apretem el tabulador
		  {
		    ControlSubSubMenu=1;
		  }
		//Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
		else if( IndexChar<MAX_CARACTERS_INTRODUIR && ( tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0' || tecla=='.'))
		  {
		    if(tecla=='.')		//si es un punt mirarem si ja hi ha un punt al array
		      {
			i=0;
			while(i<IndexChar)	//Mira totes les posicions ocupades en busca d'un '.'
			  {
			    if(IPlansTallCharInf[2][i]=='.')	//Si el troba posara LocPunt=true
			      {
				LocPunt=true;
				break;
			      }
			    i++;
			  }
			if(LocPunt==false)			//si no ha trobat punt el posarà a l'array
			  {
			    IPlansTallCharInf[2][IndexChar]=tecla;
			  }
		      }else
		      {
			IPlansTallCharInf[2][IndexChar]=tecla;
		      }
		  }
	      }     
	  }
      }
    else if(ControlMenu==11)
      {
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	//////////////////////////Introducció dels parametres de les transformacions de grup///////////////////////////////////////////////////////   
	/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
	if(ControlSubSubMenu==1)
	  {
	    while(ISelFigChar[IndexChar]!='V' && IndexChar<3)		//Mira quina posició és la primera buida (Amb una 'V')
	      {
		IndexChar++;
	      }
	    if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
	      {
		ISelFigChar[IndexChar-1]='V';
	      }
	    //Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
	    else if( IndexChar<3 && ( tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0'))
	      {
		ISelFigChar[IndexChar]=tecla;
	      }      
	    
	  }
	else if(ControlSubSubMenu==2)
	  {
	    while(ISelCosChar[IndexChar]!='V' && IndexChar<3)		//Mira quina posició és la primera buida (Amb una 'V')
	      {
		IndexChar++;
	      }
	    if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
	      {
		ISelCosChar[IndexChar-1]='V';
	      }
	    //Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
	    else if( IndexChar<3 && ( tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0'))
	      {
		ISelCosChar[IndexChar]=tecla;
	      }      
	    
	  }
	else if(ControlSubSubMenu==3)
	  {
	    while(ISelMaterialChar[IndexChar]!='V' && IndexChar<3)		//Mira quina posició és la primera buida (Amb una 'V')
	      {
		IndexChar++;
	      }
	    if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
	      {
		ISelMaterialChar[IndexChar-1]='V';
	      }
	    //Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
	    else if( IndexChar<3 && ( tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0'))
	      {
		ISelMaterialChar[IndexChar]=tecla;
	      }      
	    
	  }
	else if(ControlSubSubMenu==4)
	  {
	    while(IParametresTransformacioChar[0][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
	      {
		IndexChar++;
	      }
	    if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
	      {
		IParametresTransformacioChar[0][IndexChar-1]='V';
	      }
	    //Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
	    else if( IndexChar<MAX_CARACTERS_INTRODUIR && ((tecla=='-' && IndexChar==0) || tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0' || tecla=='.'))
	      {
		if(tecla=='.')		//si es un punt mirarem si ja hi ha un punt al array
		  {
		    i=0;
		    while(i<IndexChar)	//Mira totes les posicions ocupades en busca d'un '.'
		      {
			if(IParametresTransformacioChar[0][i]=='.')	//Si el troba posara LocPunt=true
			  {
			    LocPunt=true;
			    break;
			  }
			i++;
		      }
		    if(LocPunt==false)			//si no ha trobat punt el posarà a l'array
		      {
			IParametresTransformacioChar[0][IndexChar]=tecla;
		      }
		  }else
		  {
		    IParametresTransformacioChar[0][IndexChar]=tecla;
		  }
	      }
	    
	  }
	else if(ControlSubSubMenu==5)
	  {
	    while(IParametresTransformacioChar[1][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
	      {
		IndexChar++;
	      }
	    if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
	      {
		IParametresTransformacioChar[1][IndexChar-1]='V';
	      }
	    //Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
	    else if( IndexChar<MAX_CARACTERS_INTRODUIR && ((tecla=='-' && IndexChar==0) || tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0' || tecla=='.'))
	      {
		if(tecla=='.')		//si es un punt mirarem si ja hi ha un punt al array
		  {
		    i=0;
		    while(i<IndexChar)	//Mira totes les posicions ocupades en busca d'un '.'
		      {
			if(IParametresTransformacioChar[1][i]=='.')	//Si el troba posara LocPunt=true
			  {
			    LocPunt=true;
			    break;
			  }
			i++;
		      }
		    if(LocPunt==false)			//si no ha trobat punt el posarà a l'array
		      {
			IParametresTransformacioChar[1][IndexChar]=tecla;
		      }
		  }else
		  {
		    IParametresTransformacioChar[1][IndexChar]=tecla;
		  }
	      }
	    
	  }
	else if(ControlSubSubMenu==6)
	  {
	    while(IParametresTransformacioChar[2][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
	      {
		IndexChar++;
	      }
	    if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
	      {
		IParametresTransformacioChar[2][IndexChar-1]='V';
	      }
	    //Aquest if mirara si hem arribat al màxim tamany de l'array i si estem introduïnt un '-' un '.' o un número
	    else if( IndexChar<MAX_CARACTERS_INTRODUIR && ((tecla=='-' && IndexChar==0) || tecla=='1' || tecla=='2' || tecla=='3' || tecla=='4' || tecla=='5' || tecla=='6' || tecla=='7' || tecla=='8' || tecla=='9' || tecla=='0' || tecla=='.'))
	      {
		if(tecla=='.')		//si es un punt mirarem si ja hi ha un punt al array
		  {
		    i=0;
		    while(i<IndexChar)	//Mira totes les posicions ocupades en busca d'un '.'
		      {
			if(IParametresTransformacioChar[2][i]=='.')	//Si el troba posara LocPunt=true
			  {
			    LocPunt=true;
			    break;
			  }
			i++;
		      }
		    if(LocPunt==false)			//si no ha trobat punt el posarà a l'array
		      {
			IParametresTransformacioChar[2][IndexChar]=tecla;
		      }
		  }else
		  {
		    IParametresTransformacioChar[2][IndexChar]=tecla;
		  }
	      }
	    
	  }

      }

    
  
  switch(tecla)
  {
    case 's':					//mou la imatge
    {
      if(Pantalla==0)
	{
	  //Calculem la distancia a l'origen per a calcular la distancia que ens desplaçarem
	  DistanciaObservadorOrigen=sqrt(pow(DimEspai[0]+DimEspai[1]+DimEspai[2]+X,2)+pow(DimEspai[1]*0.5+Y,2)+pow(DimEspai[2]*0.5+Z,2));
	  IncrementMovimentPantalla=DistanciaObservadorOrigen*FactorMoviment;
	  //Realitzem el desplaçament
	  Z=Z+IncrementMovimentPantalla;
	  //Indiquem que hem de repintar aquesta finestra
	  RendFinestraGran=true;	  
	}
      if(Pantalla==1)
	{
	  DistanciaObservadorOrigen=sqrt(pow(DimEspai[0]+DimEspai[1]+DimEspai[2]+X1,2)+pow(DimEspai[1]*0.5+Y1,2)+pow(DimEspai[2]*0.5+Z1,2));
	  IncrementMovimentPantalla=DistanciaObservadorOrigen*FactorMoviment;	  
	  X1=X1+IncrementMovimentPantalla;
	  RendFinestraInf=true;
	}
      if(Pantalla==2)
	{
	  DistanciaObservadorOrigen=sqrt(pow(DimEspai[0]+DimEspai[1]+DimEspai[2]+X2,2)+pow(DimEspai[1]*0.5+Y2,2)+pow(DimEspai[2]*0.5+Z2,2));
	  IncrementMovimentPantalla=DistanciaObservadorOrigen*FactorMoviment;	  
	  X2=X2-IncrementMovimentPantalla;
	  RendFinestraSup=true;
	}
	break;
    }
    case 'w':					//mou la imatge
    {
      if(Pantalla==0)
	{
	  DistanciaObservadorOrigen=sqrt(pow(DimEspai[0]+DimEspai[1]+DimEspai[2]+X,2)+pow(DimEspai[1]*0.5+Y,2)+pow(DimEspai[2]*0.5+Z,2));
	  IncrementMovimentPantalla=DistanciaObservadorOrigen*FactorMoviment;	  
	  Z=Z-IncrementMovimentPantalla;
	  RendFinestraGran=true;
	}
      if(Pantalla==1)
	{
	  DistanciaObservadorOrigen=sqrt(pow(DimEspai[0]+DimEspai[1]+DimEspai[2]+X1,2)+pow(DimEspai[1]*0.5+Y1,2)+pow(DimEspai[2]*0.5+Z1,2));
	  IncrementMovimentPantalla=DistanciaObservadorOrigen*FactorMoviment;	  
	  X1=X1-IncrementMovimentPantalla;
	  RendFinestraInf=true;
	}
      if(Pantalla==2)
	{
	  DistanciaObservadorOrigen=sqrt(pow(DimEspai[0]+DimEspai[1]+DimEspai[2]+X2,2)+pow(DimEspai[1]*0.5+Y2,2)+pow(DimEspai[2]*0.5+Z2,2));
	  IncrementMovimentPantalla=DistanciaObservadorOrigen*FactorMoviment;	  
	  X2=X2+IncrementMovimentPantalla;
	  RendFinestraSup=true;
	}
	break;
    }
    case 'd':					//mou la imatge
    {
      if(Pantalla==0)
	{
	  DistanciaObservadorOrigen=sqrt(pow(DimEspai[0]+DimEspai[1]+DimEspai[2]+X,2)+pow(DimEspai[1]*0.5+Y,2)+pow(DimEspai[2]*0.5+Z,2));
	  IncrementMovimentPantalla=DistanciaObservadorOrigen*FactorMoviment;	  
	  Y=Y-IncrementMovimentPantalla;
	  RendFinestraGran=true;
	}
      if(Pantalla==1)
	{
	  DistanciaObservadorOrigen=sqrt(pow(DimEspai[0]+DimEspai[1]+DimEspai[2]+X1,2)+pow(DimEspai[1]*0.5+Y1,2)+pow(DimEspai[2]*0.5+Z1,2));
	  IncrementMovimentPantalla=DistanciaObservadorOrigen*FactorMoviment;	  
	  Y1=Y1-IncrementMovimentPantalla;
	  RendFinestraInf=true;
	}
      if(Pantalla==2)
	{
	  DistanciaObservadorOrigen=sqrt(pow(DimEspai[0]+DimEspai[1]+DimEspai[2]+X2,2)+pow(DimEspai[1]*0.5+Y2,2)+pow(DimEspai[2]*0.5+Z2,2));
	  IncrementMovimentPantalla=DistanciaObservadorOrigen*FactorMoviment;	  
	  Y2=Y2-IncrementMovimentPantalla;
	  RendFinestraSup=true;
	}
	break;
    } 
    case 'a':					//mou la imatge
    {
      if(Pantalla==0)
	{
	  DistanciaObservadorOrigen=sqrt(pow(DimEspai[0]+DimEspai[1]+DimEspai[2]+X,2)+pow(DimEspai[1]*0.5+Y,2)+pow(DimEspai[2]*0.5+Z,2));
	  IncrementMovimentPantalla=DistanciaObservadorOrigen*FactorMoviment;	  
	  Y=Y+IncrementMovimentPantalla;
	  RendFinestraGran=true;
	}
      if(Pantalla==1)
	{
	  DistanciaObservadorOrigen=sqrt(pow(DimEspai[0]+DimEspai[1]+DimEspai[2]+X1,2)+pow(DimEspai[1]*0.5+Y1,2)+pow(DimEspai[2]*0.5+Z1,2));
	  IncrementMovimentPantalla=DistanciaObservadorOrigen*FactorMoviment;	  
	  Y1=Y1+IncrementMovimentPantalla;
	  RendFinestraInf=true;
	}
      if(Pantalla==2)
	{
	  DistanciaObservadorOrigen=sqrt(pow(DimEspai[0]+DimEspai[1]+DimEspai[2]+X2,2)+pow(DimEspai[1]*0.5+Y2,2)+pow(DimEspai[2]*0.5+Z2,2));
	  IncrementMovimentPantalla=DistanciaObservadorOrigen*FactorMoviment;	  
	  Y2=Y2+IncrementMovimentPantalla;
	  RendFinestraSup=true;
	}
      
	break;
    }
    case '+':					//mou la imatge
    {
      if(Pantalla==0)
	{
	  DistanciaObservadorOrigen=sqrt(pow(DimEspai[0]+DimEspai[1]+DimEspai[2]+X,2)+pow(DimEspai[1]*0.5+Y,2)+pow(DimEspai[2]*0.5+Z,2));
	  IncrementMovimentPantalla=DistanciaObservadorOrigen*FactorMoviment;
	  X=X+IncrementMovimentPantalla;
	  RendFinestraGran=true;
	}
      if(Pantalla==1)
	{
	  DistanciaObservadorOrigen=sqrt(pow(DimEspai[0]+DimEspai[1]+DimEspai[2]+X1,2)+pow(DimEspai[1]*0.5+Y1,2)+pow(DimEspai[2]*0.5+Z1,2));
	  IncrementMovimentPantalla=DistanciaObservadorOrigen*FactorMoviment;	  
	  Z1=Z1-IncrementMovimentPantalla;
	  RendFinestraInf=true;
	}
      if(Pantalla==2)
	{
	  DistanciaObservadorOrigen=sqrt(pow(DimEspai[0]+DimEspai[1]+DimEspai[2]+X2,2)+pow(DimEspai[1]*0.5+Y2,2)+pow(DimEspai[2]*0.5+Z2,2));
	  IncrementMovimentPantalla=DistanciaObservadorOrigen*FactorMoviment;	  
	  Z2=Z2+IncrementMovimentPantalla;
	  RendFinestraSup=true;
	}
	break;
    }
    case '-':					//mou la imatge
    {
      if(Pantalla==0)
	{
	  DistanciaObservadorOrigen=sqrt(pow(DimEspai[0]+DimEspai[1]+DimEspai[2]+X,2)+pow(DimEspai[1]*0.5+Y,2)+pow(DimEspai[2]*0.5+Z,2));
	  IncrementMovimentPantalla=DistanciaObservadorOrigen*FactorMoviment;
	  X=X-IncrementMovimentPantalla;
	  RendFinestraGran=true;
	}
      if(Pantalla==1)
	{
	  DistanciaObservadorOrigen=sqrt(pow(DimEspai[0]+DimEspai[1]+DimEspai[2]+X1,2)+pow(DimEspai[1]*0.5+Y1,2)+pow(DimEspai[2]*0.5+Z1,2));
	  IncrementMovimentPantalla=DistanciaObservadorOrigen*FactorMoviment;	  
	  Z1=Z1+IncrementMovimentPantalla;
	  RendFinestraInf=true;
	}
      if(Pantalla==2)
	{
	  DistanciaObservadorOrigen=sqrt(pow(DimEspai[0]+DimEspai[1]+DimEspai[2]+X2,2)+pow(DimEspai[1]*0.5+Y2,2)+pow(DimEspai[2]*0.5+Z2,2));
	  IncrementMovimentPantalla=DistanciaObservadorOrigen*FactorMoviment;	  
	  Z2=Z2-IncrementMovimentPantalla;
	  RendFinestraSup=true;
	}
	break;
    }


  }
  glutPostRedisplay();
}

//---------------------------------------Funcio que controla el teclat amb acarcters especials------------------------------------------//

void TeclatEsp(int tecla, int x, int y)
{
  if(ActivarVisor2D==true)
  {
    if(tecla==GLUT_KEY_UP && (PlaVisor2D*DimPlaDicom[2])<DimEspaiDicom[2]-DimPlaDicom[2])
    {
      PlaVisor2D++;
      RendVisor2D=true;
      CrearLlistaVox=true;
    }
    else if(tecla==GLUT_KEY_DOWN && PlaVisor2D>0)
    {
      PlaVisor2D--;
      RendVisor2D=true;
      CrearLlistaVox=true;
    }
  }
  else if(Pantalla==0) //Si estem a la pantalla gran, podrem moure la llegenda
    {
      if(tecla==GLUT_KEY_UP)
	{
	  PosLlegenda++;
	  RendFinestraGran=true;
	}
      else if(tecla==GLUT_KEY_DOWN && PosLlegenda>0)
	{
	  PosLlegenda--;
	  RendFinestraGran=true;
	}
    }
  glutPostRedisplay();
}

//--------------------------------------Funcio que controla el ratoli--------------------------------------------------------//

void ratoli(int boto, int estat, int x, int y)
{  
  float OrigenXPantallaMenu=Origen_Menu[0];                   
  float OrigenYPantallaMenu=ALTURA; //Agafem els origens del menu tenint en compte que en la funció del ratoli esta el (0,0) en el canto superior esquerra
  
  if(boto==GLUT_LEFT_BUTTON && estat==GLUT_UP && ActivarVisor2D==true)
  {
    //Si estem al visor de dicom i despres d'apretar el boto dret el soltem, deseleccionem el canvi grafic de plans de tall
    SelPlaTallSup[0]=false;
    SelPlaTallSup[1]=false;
    SelPlaTallInf[0]=false;
    SelPlaTallInf[1]=false;
    if(SelBarraVisor==true)
    {
      SelBarraVisor=false;
      RendVisor2D=true;
      CrearLlistaVox=true;
      glutPostRedisplay();
    }
  }
  if(boto==GLUT_LEFT_BUTTON && estat==GLUT_DOWN)
  {    
    PosCursorX=x;
    //Primer mirarem si ens trobem a la finestra de guardat/carregat, de manera que si tenim aquesta finestra activada, no podam interactuar en el programa fins que eixim d'esta
    if(ActivarVisor2D==true)
    {
      if(x<Origen_Visor2D[0]+AmpladaVisor2D && x>Origen_Visor2D[0] && y<Origen_Visor2D[1]+AlturaVisor2D && y>Origen_Visor2D[1]) //Si s'acompleix, es troba dins de la pantalla del visor
      {
	PosVisor2D[0]=float(DimPlaDicom[0]/AmpladaVisor2D)*x;
	PosVisor2D[1]=float(DimPlaDicom[1]/AlturaVisor2D)*(AlturaVisor2D-y);	
	
	  //Controlara si hem de modificar algun pla de tall amb el metode grafic
	  if(fabs(PosVisor2D[0]-PlansTall[0])<DimPlaDicom[0]*0.01)
	  {
	    SelPlaTallSup[0]=true;
	    ActualitzarPlansVisor2D=true;
	  }
	  else if(fabs(PosVisor2D[0]-PlansTallInf[0])<DimPlaDicom[0]*0.01)
	  {
	    SelPlaTallInf[0]=true;
	    ActualitzarPlansVisor2D=true;
	  }
	  if(fabs(PosVisor2D[1]-PlansTallInf[1])<DimPlaDicom[1]*0.02)
	  {
	    SelPlaTallInf[1]=true;
	    ActualitzarPlansVisor2D=true;
	  }
	  else if(fabs(PosVisor2D[1]-PlansTall[1])<DimPlaDicom[1]*0.02)
	  {
	    SelPlaTallSup[1]=true;
	    ActualitzarPlansVisor2D=true;
	  }
	
      }
      //Mirem si hem apretat dins de la barreta 
      else if(x>AmpladaVisor2D && x<1205 && y>0 && y<AlturaVisor2D)
      {
	  SelBarraVisor=true;
      }

    }
    if((ControlMenu==4 && (ControlSubMenu==1 || ControlSubMenu==2 || ControlSubMenu==3)) || ControlMenu==5)
    {
      //No fem res, no interaccionem amb el programa perque estem a la finestra de guardat/carregat
    }
    else if(x<Origen_Pantalla_Gran[0]+Dimensions_Pantalla_Gran[0] && y<Origen_Pantalla_Gran[1]+Dimensions_Pantalla_Gran[1])
    {
      Pantalla=0;
    }else if(x>Origen_Pantalla_Inferior[0] && x<Origen_Pantalla_Inferior[0]+Dimensions_Pantalla_Menuda[0] && y<ALTURA-Origen_Pantalla_Inferior[1] && y>ALTURA-(Origen_Pantalla_Inferior[1]+Dimensions_Pantalla_Menuda[1]))
    {
      Pantalla=1;
      
    }else if(x>Origen_Pantalla_Superior[0] && x<Origen_Pantalla_Superior[0]+Dimensions_Pantalla_Menuda[0] && y<ALTURA-Origen_Pantalla_Superior[1] && y>ALTURA-(Origen_Pantalla_Superior[1]+Dimensions_Pantalla_Menuda[1]))
    {
      Pantalla=2;
    }
    else
    {
	Pantalla=3;
	////////////////////////ACI ES CONTROLA EL MENU//////////////////////////////////////
	if(x>OrigenXPantallaMenu+NovaFigura.LimitEsquerra && x<OrigenXPantallaMenu+NovaFigura.LimitDret && y>OrigenYPantallaMenu-NovaFigura.LimitSuperior && y<OrigenYPantallaMenu-NovaFigura.LimitInferior)
	{
	    ControlMenu=1;				//Opcio de crear figura
	    ControlSubMenu=0;
	    ControlSubSubMenu=0;
	    SeleccioFigura=false;
	    VoxelsActualitzats=false;
	    PintVox=false;
	    PintObjectes=true;
	    if(PintarDicom==true)
	    {
	      PintarDicom=false;
	      ActivarVisor2D=false;
	      CrearLlistaVox=true;
	      PlansTall[0]=DimEspai[0];
	      PlansTall[1]=DimEspai[1];
	      PlansTall[2]=DimEspai[2];
	    }
	    //Diguem que hem de tornar a renderitzar les pantalles
	    RendFinestraGran=true;
	    RendFinestraSup=true;
	    RendFinestraInf=true;
	}
	else if(x>OrigenXPantallaMenu+SelFigura.LimitEsquerra && x<OrigenXPantallaMenu+SelFigura.LimitDret && y>OrigenYPantallaMenu-SelFigura.LimitSuperior && y<OrigenYPantallaMenu-SelFigura.LimitInferior)
	{
	    ControlMenu=2;				//Opcio de seleccionar figura
	    ControlSubMenu=1;
	    ControlSubSubMenu=0;
	    SeleccioFigura=true;
	    PintVox=false;
	    PintObjectes=true;
	    if(PintarDicom==true)
	    {
	      PintarDicom=false;
	      ActivarVisor2D=false;
	      CrearLlistaVox=true;
	      PlansTall[0]=DimEspai[0];
	      PlansTall[1]=DimEspai[1];
	      PlansTall[2]=DimEspai[2];
	    }
	    //Diguem que hem de tornar a renderitzar les pantalles
	    RendFinestraGran=true;
	    RendFinestraSup=true;
	    RendFinestraInf=true;
	    
	}
	else if(x>OrigenXPantallaMenu+BColor.LimitEsquerra && x<OrigenXPantallaMenu+BColor.LimitDret && y>OrigenYPantallaMenu-BColor.LimitSuperior && y<OrigenYPantallaMenu-BColor.LimitInferior)
	{
	    ControlMenu=3;				//Opcio de seleccionar com pintar
	    PosLlegenda=0;
	    ControlSubMenu=0;
	    ControlSubSubMenu=0;
	    PintObjectes=true;			//Pintara els objectes
	    PintVox=false;
	    SeleccioFigura=false;
	    if(PintarDicom==true)
	    {
	      PintarDicom=false;
	      ActivarVisor2D=false;
	      CrearLlistaVox=true;
	      PlansTall[0]=DimEspai[0];
	      PlansTall[1]=DimEspai[1];
	      PlansTall[2]=DimEspai[2];
	    }
	    //Diguem que hem de tornar a renderitzar les pantalles
	    RendFinestraGran=true;
	    RendFinestraSup=true;
	    RendFinestraInf=true;
	    
	}    
	else if(x>OrigenXPantallaMenu+BGuardar.LimitEsquerra && x<OrigenXPantallaMenu+BGuardar.LimitDret && y>OrigenYPantallaMenu-BGuardar.LimitSuperior && y<OrigenYPantallaMenu-BGuardar.LimitInferior)
	{
	    ControlMenu=4;				//Desar geometria
	    ControlSubMenu=0;
	    ControlSubSubMenu=0;
	    SeleccioFigura=false;
	    if(PintarDicom==true)
	    {
	      PintarDicom=false;
	      ActivarVisor2D=false;
	      CrearLlistaVox=true;
	      PlansTall[0]=DimEspai[0];
	      PlansTall[1]=DimEspai[1];
	      PlansTall[2]=DimEspai[2];
	    }
	    //Diguem que hem de tornar a renderitzar les pantalles
	    RendFinestraGran=true;
	    RendFinestraSup=true;
	    RendFinestraInf=true;
	    
	}
	
	else if(x>OrigenXPantallaMenu+BCarregar.LimitEsquerra && x<OrigenXPantallaMenu+BCarregar.LimitDret && y>OrigenYPantallaMenu-BCarregar.LimitSuperior && y<OrigenYPantallaMenu-BCarregar.LimitInferior)
	{
	  ControlMenu=5;			//Obrir Geometria
	  ControlSubMenu=0;
	  ControlSubSubMenu=0;
	  VoxelsActualitzats=false;
	  SeleccioFigura=false;	  
	  glutSetWindow(IdeFinestres[1]);
	  PintObMat=0;
	  PintVox=false;
	  PintObjectes=true;	  
	  if(PintarDicom==true)
	    {
	      PintarDicom=false;
	      ActivarVisor2D=false;
	      CrearLlistaVox=true;
	      PlansTall[0]=DimEspai[0];
	      PlansTall[1]=DimEspai[1];
	      PlansTall[2]=DimEspai[2];
	    }
	  //Diguem que hem de tornar a renderitzar les pantalles
	  RendFinestraGran=true;
	  RendFinestraSup=true;
	  RendFinestraInf=true;
	  
	  glutShowWindow();  
	}
	else if(x>OrigenXPantallaMenu+BTransformarGrup.LimitEsquerra && x<OrigenXPantallaMenu+BTransformarGrup.LimitDret && y>OrigenYPantallaMenu-BTransformarGrup.LimitSuperior && y<OrigenYPantallaMenu-BTransformarGrup.LimitInferior)
	{
	    ControlMenu=11;				//Opcio de Transformar grups
	    ControlSubMenu=0;
	    ControlSubSubMenu=0;
	    PintVox=false;
	    PintObjectes=true;
	    if(PintarDicom==true)
	    {
	      PintarDicom=false;
	      ActivarVisor2D=false;
	      CrearLlistaVox=true;
	      PlansTall[0]=DimEspai[0];
	      PlansTall[1]=DimEspai[1];
	      PlansTall[2]=DimEspai[2];
	    }
	    //Diguem que hem de tornar a renderitzar les pantalles
	    RendFinestraGran=true;
	    RendFinestraSup=true;
	    RendFinestraInf=true;
	    
	}
	else if(x>OrigenXPantallaMenu+BEspai.LimitEsquerra && x<OrigenXPantallaMenu+BEspai.LimitDret && y>OrigenYPantallaMenu-BEspai.LimitSuperior && y<OrigenYPantallaMenu-BEspai.LimitInferior)
	{
	  ControlMenu=6;			//Canviar l'espai
	  ControlSubMenu=1;
	  ControlSubSubMenu=0;
	  SeleccioFigura=false;
	  VoxelsActualitzats=false;
	  PintVox=false;
	  PintObjectes=true;
	    if(PintarDicom==true)
	    {
	      PintarDicom=false;
	      ActivarVisor2D=false;
	      CrearLlistaVox=true;
	      PlansTall[0]=DimEspai[0];
	      PlansTall[1]=DimEspai[1];
	      PlansTall[2]=DimEspai[2];
	    }
	  //Diguem que hem de tornar a renderitzar les pantalles
	  RendFinestraGran=true;
	  RendFinestraSup=true;
	  RendFinestraInf=true;

	  //Els valors mostrats inicialment als requadres seran
	  //els valors actuals de l'espai

	  for(unsigned int i = 0; i < 3; i++)
	    {
	      int Num_numeros = sprintf(INumVoxChar[i], "%d", NumVoxels[i]);
	      for(unsigned int j = Num_numeros; j < 4; j++)
		{
		  INumVoxChar[i][j] = 'V';
		}
	      Num_numeros = sprintf(IDimVoxChar[i], "%4.3lf", DimEspai[i]);
	      for(unsigned int j = Num_numeros; j < 100; j++)
		{
		  IDimVoxChar[i][j] = 'V';
		}
	    }
	}
	else if(x>OrigenXPantallaMenu+ColorVoxels.LimitEsquerra && x<OrigenXPantallaMenu+ColorVoxels.LimitDret && y>OrigenYPantallaMenu-ColorVoxels.LimitSuperior && y<OrigenYPantallaMenu-ColorVoxels.LimitInferior)
	{
	  PintObMat=1;			//Pintara els Voxels
	  ControlMenu=3;			//Accedira al submenu dels voxels
	  ControlSubMenu=1;
	  ControlSubSubMenu=0;
	  if(VoxelsActualitzats==false)
	  {
	    CrearPunts=true;
	  }	  
	  PintVox=false;		//activem pintar voxels
	  PintObjectes=true;	//Activem pintar objectes per a que actualitze els punts dels voxels
	  PintVQuad=false;		//desactivem pintar els voxels com a cubs
	  CrearLlistaVox=true;	//hem de tornar a crear la llista de Voxels
	  //Diguem que hem de tornar a renderitzar les pantalles
	  RendFinestraGran=true;
	  RendFinestraSup=true;
	  RendFinestraInf=true;
	  
	}	
	else if(x>OrigenXPantallaMenu+BSimulacio.LimitEsquerra && x<OrigenXPantallaMenu+BSimulacio.LimitDret && y>OrigenYPantallaMenu-BSimulacio.LimitSuperior && y<OrigenYPantallaMenu-BSimulacio.LimitInferior)
	{
	  ControlMenu=7;			//Simulacio
	  ControlSubMenu=1;
	  ControlSubSubMenu=0;
	  SeleccioFigura=false;
	    if(PintarDicom==true)
	    {
	      PintarDicom=false;
	      ActivarVisor2D=false;
	      CrearLlistaVox=true;
	      PlansTall[0]=DimEspai[0];
	      PlansTall[1]=DimEspai[1];
	      PlansTall[2]=DimEspai[2];
	    }
	  //Diguem que hem de tornar a renderitzar les pantalles
	  RendFinestraGran=true;
	  RendFinestraSup=true;
	  RendFinestraInf=true;
	  
	}

	else if(x>OrigenXPantallaMenu+BGuardarVox.LimitEsquerra && x<OrigenXPantallaMenu+BGuardarVox.LimitDret && y>OrigenYPantallaMenu-BGuardarVox.LimitSuperior && y<OrigenYPantallaMenu-BGuardarVox.LimitInferior)
	{
	    ControlMenu=8;				//Desar Voxels
	    ControlSubMenu=0;
	    ControlSubSubMenu=0;
	    if(VoxelsActualitzats==false)
	    {
	      CrearPunts=true;
	    }
	    SeleccioFigura=false;
	    PintVox=false;
	    PintVQuad=false;
	    PintObjectes=true;
	    if(PintarDicom==true)
	    {
	      PintarDicom=false;
	      ActivarVisor2D=false;
	      CrearLlistaVox=true;
	      PlansTall[0]=DimEspai[0];
	      PlansTall[1]=DimEspai[1];
	      PlansTall[2]=DimEspai[2];
	    }
	    //Diguem que hem de tornar a renderitzar les pantalles
	    RendFinestraGran=true;
	    RendFinestraSup=true;
	    RendFinestraInf=true;
	    
	}
	else if(x>OrigenXPantallaMenu+BResultats.LimitEsquerra && x<OrigenXPantallaMenu+BResultats.LimitDret && y>OrigenYPantallaMenu-BResultats.LimitSuperior && y<OrigenYPantallaMenu-BResultats.LimitInferior)
	{
	  ControlMenu=9;			//Visualitzar resultats
	  ControlSubMenu=0;
	  ControlSubSubMenu=0;
	  VoxelsActualitzats=false;
	  SeleccioFigura=false;
	    if(PintarDicom==true)
	    {
	      PintarDicom=false;
	      ActivarVisor2D=false;
	      CrearLlistaVox=true;
	      PlansTall[0]=DimEspai[0];
	      PlansTall[1]=DimEspai[1];
	      PlansTall[2]=DimEspai[2];
	    }
	  //Diguem que hem de tornar a renderitzar les pantalles
	  RendFinestraGran=true;
	  RendFinestraSup=true;
	  RendFinestraInf=true;
	  
	}
	else if(x>OrigenXPantallaMenu+BDicom.LimitEsquerra && x<OrigenXPantallaMenu+BDicom.LimitDret && y>OrigenYPantallaMenu-BDicom.LimitSuperior && y<OrigenYPantallaMenu-BDicom.LimitInferior)
	{
	  ControlMenu=10;			//Obrir un DICOM
	  ControlSubMenu=0;
	  ControlSubSubMenu=0;
	  VoxelsActualitzats=false;
	  SeleccioFigura=false;
	  ActivarVisor2D=false;
	  PintMatDicom=true;
	  PintDensDicom=false;
	  PintVQuad=false;
	  PintVox=false;
	  //Diguem que hem de tornar a renderitzar les pantalles
	  RendFinestraGran=true;
	  RendFinestraSup=true;
	  RendFinestraInf=true;
	  
	}
	///////////////////////////////////////////////////////////////////////////////////////////////////////
	/////////////IDIOMA////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////////////////
	else if(x>OrigenXPantallaMenu+BIdioma[0].LimitEsquerra && x<OrigenXPantallaMenu+BIdioma[0].LimitDret && y>OrigenYPantallaMenu-BIdioma[0].LimitSuperior && y<OrigenYPantallaMenu-BIdioma[0].LimitInferior)
	{
	  			//Angles
	  Idioma=0;
	  menuCreat=false;
	  menuCreat2=false;
	  //Diguem que hem de tornar a renderitzar les pantalles
	  RendFinestraGran=true;
	  RendFinestraSup=true;
	  RendFinestraInf=true;
	  
	}
	else if(x>OrigenXPantallaMenu+BIdioma[1].LimitEsquerra && x<OrigenXPantallaMenu+BIdioma[1].LimitDret && y>OrigenYPantallaMenu-BIdioma[1].LimitSuperior && y<OrigenYPantallaMenu-BIdioma[1].LimitInferior)
	{
	  			//Catala
	  Idioma=1;
	  menuCreat=false;
	  menuCreat2=false;
	  //Diguem que hem de tornar a renderitzar les pantalles
	  RendFinestraGran=true;
	  RendFinestraSup=true;
	  RendFinestraInf=true;
	  
	}
	else if(x>OrigenXPantallaMenu+BIdioma[2].LimitEsquerra && x<OrigenXPantallaMenu+BIdioma[2].LimitDret && y>OrigenYPantallaMenu-BIdioma[2].LimitSuperior && y<OrigenYPantallaMenu-BIdioma[2].LimitInferior)
	{
	  			//Espanyol
	  Idioma=2;
	  menuCreat=false;
	  menuCreat2=false;
	  //Diguem que hem de tornar a renderitzar les pantalles
	  RendFinestraGran=true;
	  RendFinestraSup=true;
	  RendFinestraInf=true;
	  
	}    
	
	else if(ControlMenu==1)
	  {
	    /////////////////////////////////////////////////////////////////////////////////////////////////
	    /////////////SUBMENU CREAR FIGURA////////////////////////////////////////////////////////////////
	    /////////////////////////////////////////////////////////////////////////////////////////////////
	    if(ControlSubMenu==0)
	      {
		if(ControlMenu==1 && x>OrigenXPantallaMenu+NouCub.LimitEsquerra && x<OrigenXPantallaMenu+NouCub.LimitDret && y>OrigenYPantallaMenu-NouCub.LimitSuperior && y<OrigenYPantallaMenu-NouCub.LimitInferior)
		  {
		    //Opcio de crear Cub
		    ControlSubMenu=1;
		    ControlSubSubMenu=1;
		  }  
		else if(ControlMenu==1 && x>OrigenXPantallaMenu+NovaEsfera.LimitEsquerra && x<OrigenXPantallaMenu+NovaEsfera.LimitDret && y>OrigenYPantallaMenu-NovaEsfera.LimitSuperior && y<OrigenYPantallaMenu-NovaEsfera.LimitInferior)
		  {
		    //Opcio de crear Esfera
		    ControlSubMenu=2;
		    ControlSubSubMenu=1;	    
		  }
		else if(ControlMenu==1 && x>OrigenXPantallaMenu+NouCilindre.LimitEsquerra && x<OrigenXPantallaMenu+NouCilindre.LimitDret && y>OrigenYPantallaMenu-NouCilindre.LimitSuperior && y<OrigenYPantallaMenu-NouCilindre.LimitInferior)
		  {
		    //Opcio de crear Cilindre/Con
		    ControlSubMenu=3;
		    ControlSubSubMenu=1;	    
		  }
		else if(ControlMenu==1 && x>OrigenXPantallaMenu+NouPla.LimitEsquerra && x<OrigenXPantallaMenu+NouPla.LimitDret && y>OrigenYPantallaMenu-NouPla.LimitSuperior && y<OrigenYPantallaMenu-NouPla.LimitInferior)
		  {
		    //Opcio de crear Pla Infinit
		    ControlSubMenu=4;
		    ControlSubSubMenu=1;	    
		  }
		else if(ControlMenu==1 && x>OrigenXPantallaMenu+NouSeccioEsf.LimitEsquerra && x<OrigenXPantallaMenu+NouSeccioEsf.LimitDret && y>OrigenYPantallaMenu-NouSeccioEsf.LimitSuperior && y<OrigenYPantallaMenu-NouSeccioEsf.LimitInferior)
		  {
		    //Opcio de crear Seccio d'esfera
		    ControlSubMenu=5;
		    ControlSubSubMenu=1;	    
		  }
	      }
	    else if(ControlSubMenu==1)
	      {
		////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		/////////////SUBSUBMENU DE NOU CUB///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		if(x>OrigenXPantallaMenu+Centre[0].LimitEsquerra && x<OrigenXPantallaMenu+Centre[0].LimitDret && y>OrigenYPantallaMenu-Centre[0].LimitSuperior && y<OrigenYPantallaMenu-Centre[0].LimitInferior)
		  {
		    ControlSubSubMenu=1;  		//CentreX
		  }
		else if(x>OrigenXPantallaMenu+Centre[1].LimitEsquerra && x<OrigenXPantallaMenu+Centre[1].LimitDret && y>OrigenYPantallaMenu-Centre[1].LimitSuperior && y<OrigenYPantallaMenu-Centre[1].LimitInferior)
		  {
		    ControlSubSubMenu=2;			//CentreY
		  }
		else if(x>OrigenXPantallaMenu+Centre[2].LimitEsquerra && x<OrigenXPantallaMenu+Centre[2].LimitDret && y>OrigenYPantallaMenu-Centre[2].LimitSuperior && y<OrigenYPantallaMenu-Centre[2].LimitInferior)
		  {
		    ControlSubSubMenu=3;			//CentreZ
		  }
      
		else if(x>OrigenXPantallaMenu+Dim[0].LimitEsquerra && x<OrigenXPantallaMenu+Dim[0].LimitDret && y>OrigenYPantallaMenu-Dim[0].LimitSuperior && y<OrigenYPantallaMenu-Dim[0].LimitInferior)
		  {
		    ControlSubSubMenu=4;			//DimensioX
		  }
		else if(x>OrigenXPantallaMenu+Dim[1].LimitEsquerra && x<OrigenXPantallaMenu+Dim[1].LimitDret && y>OrigenYPantallaMenu-Dim[1].LimitSuperior && y<OrigenYPantallaMenu-Dim[1].LimitInferior)
		  {
		    ControlSubSubMenu=5;			//DimensioY
		  }
		else if(x>OrigenXPantallaMenu+Dim[2].LimitEsquerra && x<OrigenXPantallaMenu+Dim[2].LimitDret && y>OrigenYPantallaMenu-Dim[2].LimitSuperior && y<OrigenYPantallaMenu-Dim[2].LimitInferior)
		  {
		    ControlSubSubMenu=6;			//DimensioZ
		  } 
		else if(x>OrigenXPantallaMenu+Prioritat.LimitEsquerra && x<OrigenXPantallaMenu+Prioritat.LimitDret && y>OrigenYPantallaMenu-Prioritat.LimitSuperior && y<OrigenYPantallaMenu-Prioritat.LimitInferior)
		  {
		    ControlSubSubMenu=7;			//Prioritat
		  }
		else if(x>OrigenXPantallaMenu+Interns.LimitEsquerra && x<OrigenXPantallaMenu+Interns.LimitDret && y>OrigenYPantallaMenu-Interns.LimitSuperior && y<OrigenYPantallaMenu-Interns.LimitInferior)
		  {
		    ControlSubSubMenu=8;			//Prioritat interior 
		  }
		else if(x>OrigenXPantallaMenu+AfegirInterns[0].LimitEsquerra && x<OrigenXPantallaMenu+AfegirInterns[0].LimitDret && y>OrigenYPantallaMenu-AfegirInterns[0].LimitSuperior && y<OrigenYPantallaMenu-AfegirInterns[0].LimitInferior)
		  {
		    if(IDinsCubChar[0]!='V')			//Guarda aquesta prioritat com a una de les incloses si no es troba ja al vector
		      {
			//Comprovem que el número no es troba ja al vector
			bool dins=false;		//Controla si el número ja es troba al vector o no
			int i=0;
			while(i<100 && DinsCubChar[i][0]!='V')
			  {
			    if(DinsCubChar[i][0]==IDinsCubChar[0] && DinsCubChar[i][1]==IDinsCubChar[1] && DinsCubChar[i][2]==IDinsCubChar[2])
			      {
				dins=true;
				break;
			      }
			    i++;
			  }
			if(dins==false)
			  {
			    DinsCubChar[i][0]=IDinsCubChar[0];
			    DinsCubChar[i][1]=IDinsCubChar[1];
			    DinsCubChar[i][2]=IDinsCubChar[2];
			  }
			IDinsCubChar[0]='V';
			IDinsCubChar[1]='V';
			IDinsCubChar[2]='V';
		      }
		  }
		else if(x>OrigenXPantallaMenu+AfegirInterns[1].LimitEsquerra && x<OrigenXPantallaMenu+AfegirInterns[1].LimitDret && y>OrigenYPantallaMenu-AfegirInterns[1].LimitSuperior && y<OrigenYPantallaMenu-AfegirInterns[1].LimitInferior)
		  {
		    //Borrara la prioritat introduida de la llista
		    int i=0;
		    bool dins=false;		//Controla si el número ja es troba al vector o no
		    while(i<100 && DinsCubChar[i][0]!='V')	//Primer busquem el numero al vector
		      {
			if(DinsCubChar[i][0]==IDinsCubChar[0] && DinsCubChar[i][1]==IDinsCubChar[1] && DinsCubChar[i][2]==IDinsCubChar[2])
			  {
			    dins=true;
			    break;
			  }
			i++;
		      }
		    if(dins==true)
		      {
			while(i<100 && DinsCubChar[i][0]!='V')	//ara el borrem
			  {
			    DinsCubChar[i][0]=DinsCubChar[i+1][0];
			    DinsCubChar[i][1]=DinsCubChar[i+1][1];
			    DinsCubChar[i][2]=DinsCubChar[i+1][2];
			    i++;
			  }
		      }
		    IDinsCubChar[0]='V';
		    IDinsCubChar[1]='V';
		    IDinsCubChar[2]='V';
		  }
		else if(x>OrigenXPantallaMenu+MatDens[0].LimitEsquerra && x<OrigenXPantallaMenu+MatDens[0].LimitDret && y>OrigenYPantallaMenu-MatDens[0].LimitSuperior && y<OrigenYPantallaMenu-MatDens[0].LimitInferior)
		  {
		    ControlSubSubMenu=9;			//Material
		  }
		else if(x>OrigenXPantallaMenu+MatDens[1].LimitEsquerra && x<OrigenXPantallaMenu+MatDens[1].LimitDret && y>OrigenYPantallaMenu-MatDens[1].LimitSuperior && y<OrigenYPantallaMenu-MatDens[1].LimitInferior)
		  {
		    ControlSubSubMenu=10;			//Densitat
		  }
		else if(x>OrigenXPantallaMenu+Angles[0].LimitEsquerra && x<OrigenXPantallaMenu+Angles[0].LimitDret && y>OrigenYPantallaMenu-Angles[0].LimitSuperior && y<OrigenYPantallaMenu-Angles[0].LimitInferior)
		  {
		    ControlSubSubMenu=11;			//Alfa
		  }
		else if(x>OrigenXPantallaMenu+Angles[1].LimitEsquerra && x<OrigenXPantallaMenu+Angles[1].LimitDret && y>OrigenYPantallaMenu-Angles[1].LimitSuperior && y<OrigenYPantallaMenu-Angles[1].LimitInferior)
		  {
		    ControlSubSubMenu=12;			//Beta
		  }
		else if(x>OrigenXPantallaMenu+Angles[2].LimitEsquerra && x<OrigenXPantallaMenu+Angles[2].LimitDret && y>OrigenYPantallaMenu-Angles[2].LimitSuperior && y<OrigenYPantallaMenu-Angles[2].LimitInferior)
		  {
		    ControlSubSubMenu=13;			//Gamma
		  }
		else if(x>OrigenXPantallaMenu+Crear.LimitEsquerra && x<OrigenXPantallaMenu+Crear.LimitDret && y>OrigenYPantallaMenu-Crear.LimitSuperior && y<OrigenYPantallaMenu-Crear.LimitInferior)
		  {
		    //Crea el cub///
		    //Diguem que hem de tornar a renderitzar les pantalles
		    RendFinestraGran=true;
		    RendFinestraSup=true;
		    RendFinestraInf=true;
	  
		    int errors=0;			//Controla el nombre d'errors//
	  
		    char Aux[101];		//Posem dimensio 101 per a que sempre capiga el '\0' inclus si el CubChar te 100 caràcters
		    int IndexChar=0;
		    //Guardem la coordenada X del centre i al mateix temps buidem el char//
		    while(ICentreCubChar[0][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)
		      {
			Aux[IndexChar]=ICentreCubChar[0][IndexChar];
			IndexChar++;
		      }
		    if(IndexChar==0)			//Missatge d'error si no hi ha cap valor guardat
		      {
			errors++;
			if(Idioma==0)
			  {
			    std::cout<<"Missing the X coordinate of center"<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"Falta la coordenada X del centre"<<std::endl;
			  }
			else if(Idioma==2)
			  {
			    std::cout<<"Falta la coordenada X del centro"<<std::endl;
			  }
	    
		      }else
		      {
			Aux[IndexChar]='\0';
			ICentreCub[0]=atof(Aux);
		      }

		    IndexChar=0;
		    //Guardem la coordenada Y del centre//
		    while(ICentreCubChar[1][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)
		      {
			Aux[IndexChar]=ICentreCubChar[1][IndexChar];
			IndexChar++;
		      }
		    if(IndexChar==0)			//Missatge d'error si no hi ha cap valor guardat
		      {
			errors++;
			if(Idioma==0)
			  {
			    std::cout<<"Missing the Y coordinate of center"<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"Falta la coordenada Y del centre"<<std::endl;
			  }
			else if(Idioma==2)
			  {
			    std::cout<<"Falta la coordenada Y del centro"<<std::endl;
			  }
	    
		      }else
		      {      
			Aux[IndexChar]='\0';
			ICentreCub[1]=atof(Aux);
		      }     
	  
		    IndexChar=0;
		    //Guardem la coordenada Z del centre//
		    while(ICentreCubChar[2][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)
		      {
			Aux[IndexChar]=ICentreCubChar[2][IndexChar];
			IndexChar++;
		      }
		    if(IndexChar==0)			//Missatge d'error si no hi ha cap valor guardat
		      {
			errors++;
			if(Idioma==0)
			  {
			    std::cout<<"Missing the Z coordinate of center"<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"Falta la coordenada Z del centre"<<std::endl;
			  }
			else if(Idioma==2)
			  {
			    std::cout<<"Falta la coordenada Z del centro"<<std::endl;
			  }	
		      }else
		      {      
			Aux[IndexChar]='\0';
			ICentreCub[2]=atof(Aux);
		      }
		    IndexChar=0;
	  
	  
		    //Guardem la dimensio X del cub//
		    while(IDimCubChar[0][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)
		      {
			Aux[IndexChar]=IDimCubChar[0][IndexChar];
			IndexChar++;
		      }
		    if(IndexChar==0)			//Missatge d'error si no hi ha cap valor guardat
		      {
			errors++;
			if(Idioma==0)
			  {
			    std::cout<<"Missing X dimension of the cube"<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"Falta la dimensió X del cub"<<std::endl;
			  }
			else if(Idioma==2)
			  {
			    std::cout<<"Falta la dimensión X del cubo"<<std::endl;
			  }
	    
		      }else
		      {      
			Aux[IndexChar]='\0';
			IDimCub[0]=atof(Aux);
		      }

		    IndexChar=0;


		    //Guardem la dimensio Y del cub//
		    while(IDimCubChar[1][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)
		      {
			Aux[IndexChar]=IDimCubChar[1][IndexChar];
			IndexChar++;
		      }
		    if(IndexChar==0)			//Missatge d'error si no hi ha cap valor guardat
		      {
			errors++;
			if(Idioma==0)
			  {
			    std::cout<<"Missing Y dimension of the cube"<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"Falta la dimensió Y del cub"<<std::endl;
			  }
			else if(Idioma==2)
			  {
			    std::cout<<"Falta la dimensión Y del cubo"<<std::endl;
			  }
	    
		      }else
		      {            
			Aux[IndexChar]='\0';
			IDimCub[1]=atof(Aux);
		      }
		    IndexChar=0;
	  
	  
		    //Guardem la dimensio Z del cub//
		    while(IDimCubChar[2][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)
		      {
			Aux[IndexChar]=IDimCubChar[2][IndexChar];
			IndexChar++;
		      }
		    if(IndexChar==0)			//Missatge d'error si no hi ha cap valor guardat
		      {
			errors++;
			if(Idioma==0)
			  {
			    std::cout<<"Missing Z dimension of the cube"<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"Falta la dimensió Z del cub"<<std::endl;
			  }
			else if(Idioma==2)
			  {
			    std::cout<<"Falta la dimensión Z del cubo"<<std::endl;
			  }
	    
		      }else
		      {      
			Aux[IndexChar]='\0';
			IDimCub[2]=atof(Aux);
		      }
		    IndexChar=0;
		    //Guardem la prioritat del cub//
		    while(IPrioritatCubChar[IndexChar]!='V' && IndexChar<3)
		      {
			Aux[IndexChar]=IPrioritatCubChar[IndexChar];
			IndexChar++;
		      }
		    if(IndexChar==0)			//Missatge d'error si no hi ha cap valor guardat
		      {
			errors++;
			if(Idioma==0)
			  {
			    std::cout<<"Missing the priority of the cube"<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"Falta la prioritat del cub"<<std::endl;
			  }
			else if(Idioma==2)
			  {
			    std::cout<<"Falta la prioridad del cubo"<<std::endl;
			  }
	    
		      }else
		      {      
			Aux[IndexChar]='\0';
			IPrioritatCub=atoi(Aux);
		      }      
		    IndexChar=0;
		    //Guardem les prioritats dins del cub//
		    while(DinsCubChar[IndexChar][0]!='V' && IndexChar<100)
		      {
			Aux[0]=DinsCubChar[IndexChar][0];
			if(DinsCubChar[IndexChar][1]!='V')
			  {
			    Aux[1]=DinsCubChar[IndexChar][1];
			    if(DinsCubChar[IndexChar][2]!='V')
			      {
				Aux[2]=DinsCubChar[IndexChar][2];
				Aux[3]='\0';
			      }
			    else{Aux[2]='\0';}
			  }
			else{Aux[1]='\0';}
	    
	    
			IDinsCub[IndexChar]=atoi(Aux);
			//Comprovem que les prioritats dins del cub són majors que la seua propia
			if(IDinsCub[IndexChar]<=IPrioritatCub)
			  {
			    errors++;
			    if(Idioma==0)
			      {
				std::cout<<"The body within the object must be greater than the object body"<<std::endl;
			      }
			    else if(Idioma==1)
			      {
				std::cout<<"El cos dins de l'objecte ha de ser major que la del propi objecte"<<std::endl;

			      }
			    else if(Idioma==2)
			      {
				std::cout<<"El cuerpo dentro del objeto deben ser mayores que la del propio objeto"<<std::endl;
			      }	
			    break;
			  }
			IndexChar++;	
		      }
	  
		    while(IndexChar<100)		//Omplim la resta del vector de zeros
		      {
			IDinsCub[IndexChar]=0;
			IndexChar++;
		      }

		    IndexChar=0;


		    //Guardem el material del cub//
	  
		    if(IMatCubChar[0]!='V')
		      {
			Aux[0]=IMatCubChar[0];
			if(IMatCubChar[1]!='V')
			  {
			    Aux[1]=IMatCubChar[1];
			    Aux[2]='\0';
			  }
			else{Aux[1]='\0';}
			IMatCub=atoi(Aux);
		      }
		    else			//Missatge d'error si no hi ha cap valor guardat
		      {
			errors++;
			if(Idioma==0)
			  {
			    std::cout<<"Missing the cube material"<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"Falta el material del cub"<<std::endl;

			  }
			else if(Idioma==2)
			  {
			    std::cout<<"Falta el material del cubo"<<std::endl;
			  }
	    
		      }    
	  
		    IndexChar=0;

	    
		    //Guardem la densitat del cub//
		    while(IDensCubChar[IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)
		      {
			Aux[IndexChar]=IDensCubChar[IndexChar];
			IndexChar++;
		      }
		    if(IndexChar==0)			//Missatge d'error si no hi ha cap valor guardat
		      {
			errors++;
			if(Idioma==0)
			  {
			    std::cout<<"Missing the cube density"<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"Falta la densitat del cub"<<std::endl;

			  }
			else if(Idioma==2)
			  {
			    std::cout<<"Falta la densidad del cubo"<<std::endl;
			  }
	    
		      }else
		      {      
			Aux[IndexChar]='\0';
			IDensCub=atof(Aux);	
		      }
	  
		    IndexChar=0;
	
	  
		    //Guardem l'angle de rotació Alfa//
		    while(IAnglesCubChar[0][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)
		      {
			Aux[IndexChar]=IAnglesCubChar[0][IndexChar];
			IndexChar++;
		      }
		    if(IndexChar==0)			//Missatge d'error si no hi ha cap valor guardat
		      {
			errors++;
			if(Idioma==0)
			  {
			    std::cout<<"Missing the rotation angle alpha of the cube"<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"Falta l'angle alfa de rotació del cub"<<std::endl;

			  }
			else if(Idioma==2)
			  {
			    std::cout<<"Falta el angulo alfa de rotación del cubo"<<std::endl;
			  }
	    
	    
		      }else
		      {      
			Aux[IndexChar]='\0';
			IAnglesCub[0]=atof(Aux);	
		      }
		    IndexChar=0;
	  
	  
	  
		    //Guardem l'angle de rotació Beta//
		    while(IAnglesCubChar[1][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)
		      {
			Aux[IndexChar]=IAnglesCubChar[1][IndexChar];
			IndexChar++;
		      }
		    if(IndexChar==0)			//Missatge d'error si no hi ha cap valor guardat
		      {
			errors++;
			if(Idioma==0)
			  {
			    std::cout<<"Missing the rotation angle beta of the cube"<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"Falta l'angle beta de rotació del cub"<<std::endl;

			  }
			else if(Idioma==2)
			  {
			    std::cout<<"Falta el angulo beta de rotación del cubo"<<std::endl;
			  }
	    
		      }else
		      {
			Aux[IndexChar]='\0';
			IAnglesCub[1]=atof(Aux);	
		      }
		    IndexChar=0;      
	
	  
	  
		    //Guardem l'angle de rotació Gamma//
		    while(IAnglesCubChar[2][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)
		      {
			Aux[IndexChar]=IAnglesCubChar[2][IndexChar];
			IndexChar++;
		      }
		    if(IndexChar==0)			//Missatge d'error si no hi ha cap valor guardat
		      {
			errors++;
			if(Idioma==0)
			  {
			    std::cout<<"Missing the rotation angle gamma of the cube"<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"Falta l'angle gamma de rotació del cub"<<std::endl;

			  }
			else if(Idioma==2)
			  {
			    std::cout<<"Falta el angulo gamma de rotación del cubo"<<std::endl;
			  }
	    
		      }else
		      {
			Aux[IndexChar]='\0';
			IAnglesCub[2]=atof(Aux);	
		      }
		    IndexChar=0;      
	  	  
		    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		    //Depenent de si estem seleccionat una figura o creant una nova, crearem la figura o modificarem la ja existent////
		    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		    if(errors==0 && NumCubs<=MaxCubs)		//Si no ha trobat errors crearà el cub
		      {
			ColorBotoCrear=1;
			if(SeleccioFigura==false)
			  {
			    //Tornem a posar els valors per defecte//
			    //L'angle per defecte serà zero//
			    IAnglesCubChar[0][0]='0';
			    IAnglesCubChar[1][0]='0';
			    IAnglesCubChar[2][0]='0';
			    //La densitat per defecte serà 1//
			    IDensCubChar[0]='1';
	      
			    ControlMenu=0;
			    ControlSubMenu=0;
			    ControlSubSubMenu=0;
			    if(MaxPrioritat<IPrioritatCub)	//Comprova si la prioritat introduida és major que la màxima fins ara
			      {
				MaxPrioritat=IPrioritatCub;
			      }	  
			    //Busquem la posició, del vector que controla les prioritats, on hi ha un zero per a guardar la prioritat que hem gastat i on hi ha un zero per a guardar les que ara es troben dins d'un objecte
			    int PosBuit0=10001;
			    int m=0;
			    while(m<1000)
			      {
				if(PrioritatsAsignades[0][m]==0 && PosBuit0==10001)
				  {
				    PosBuit0=m;
				    break;
				  }
				m++;
			      }
			    PrioritatsAsignades[0][PosBuit0]=IPrioritatCub;
	      
			    NumCubs++;
			    rectangles[NumCubs].CanviarCentre(ICentreCub[0],ICentreCub[1],ICentreCub[2]);
			    rectangles[NumCubs].CanviarDimensions(IDimCub[0],IDimCub[1],IDimCub[2]);
			    rectangles[NumCubs].CanviarMaterial(IMatCub,IDensCub);
			    rectangles[NumCubs].Girar(IAnglesCub[0],IAnglesCub[1],IAnglesCub[2]);
			    rectangles[NumCubs].Prioritat=IPrioritatCub;
			    int i=0;
			    while(i<100)
			      {
				rectangles[NumCubs].PDins[i]=IDinsCub[i];		
				i++;
			      }  			    
			  }
			else if(SeleccioFigura==true)
			  {
			    if(MaxPrioritat<IPrioritatCub)	//Comprova si la prioritat introduida és major que la màxima fins ara
			      {
				MaxPrioritat=IPrioritatCub;
			      }	  
			    //Busquem la posició, del vector que controla les prioritats, on hi ha un zero per a guardar la prioritat que hem gastat i on hi ha un zero per a guardar les que ara es troben dins d'un objecte
			    int PosBuit0=10001;
			    int m=0;
			    while(m<1000)
			      {
				if(PrioritatsAsignades[0][m]==rectangles[NumFigSel].Prioritat && PosBuit0==10001)
				  {
				    PosBuit0=m;
				    break;
				  }
				m++;
			      }
			    PrioritatsAsignades[0][PosBuit0]=IPrioritatCub;
	      
			    rectangles[NumFigSel].CanviarCentre(ICentreCub[0],ICentreCub[1],ICentreCub[2]);
			    rectangles[NumFigSel].CanviarDimensions(IDimCub[0],IDimCub[1],IDimCub[2]);
			    rectangles[NumFigSel].CanviarMaterial(IMatCub,IDensCub);
			    rectangles[NumFigSel].Girar(IAnglesCub[0],IAnglesCub[1],IAnglesCub[2]);
			    rectangles[NumFigSel].Prioritat=IPrioritatCub;
			    int i=0;
			    while(i<100)
			      {
				rectangles[NumFigSel].PDins[i]=IDinsCub[i];
				i++;
			      }      			    
			  }
			//Buidem les prioritats internes//
			int i=0;
			while(i<100)
			  {
			    IDinsCub[i]=0;
			    i++;
			  }			
		      }else
		      {
			ColorBotoCrear=2;
			if(Idioma==0)
			  {
			    std::cout<<"The cube is not created"<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"No es crearà el cub"<<std::endl;
			  }
			else if(Idioma==2)
			  {
			    std::cout<<"No se creará el cubo"<<std::endl;
			  }
		      }
		    //Buidem les variables//
		    int i=0;
		    while(i<100)
		      {
			IDinsCub[i]=0;
			i++;
		      }      
		    ICentreCub[0]=0;ICentreCub[1]=0;ICentreCub[2]=0;
		    IDimCub[0]=0;IDimCub[1]=0;IDimCub[2]=0;
		    IMatCub=0;IDensCub=1;
		    IAnglesCub[0]=0;IAnglesCub[1]=0;IAnglesCub[2]=0;
		    IPrioritatCub=0;
	
		  }
		
	      }
	    else if(ControlSubMenu==2)
	      {
		//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////    
		/////////////SUBSUBMENU DE NOVA ESFERA//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////    
		////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
		if(x>OrigenXPantallaMenu+Centre[0].LimitEsquerra && x<OrigenXPantallaMenu+Centre[0].LimitDret && y>OrigenYPantallaMenu-Centre[0].LimitSuperior && y<OrigenYPantallaMenu-Centre[0].LimitInferior)
		  {
		    ControlSubSubMenu=1;			//CentreX
		  }
		else if(x>OrigenXPantallaMenu+Centre[1].LimitEsquerra && x<OrigenXPantallaMenu+Centre[1].LimitDret && y>OrigenYPantallaMenu-Centre[1].LimitSuperior && y<OrigenYPantallaMenu-Centre[1].LimitInferior)
		  {
		    ControlSubSubMenu=2;			//CentreY
		  }
		else if(x>OrigenXPantallaMenu+Centre[2].LimitEsquerra && x<OrigenXPantallaMenu+Centre[2].LimitDret && y>OrigenYPantallaMenu-Centre[2].LimitSuperior && y<OrigenYPantallaMenu-Centre[2].LimitInferior)
		  {
		    ControlSubSubMenu=3;			//CentreZ
		  }
      
		else if(x>OrigenXPantallaMenu+Dim[0].LimitEsquerra && x<OrigenXPantallaMenu+Dim[0].LimitDret && y>OrigenYPantallaMenu-Dim[0].LimitSuperior && y<OrigenYPantallaMenu-Dim[0].LimitInferior)
		  {
		    ControlSubSubMenu=4;			//Dimensio
		  }
		else if(x>OrigenXPantallaMenu+Prioritat.LimitEsquerra && x<OrigenXPantallaMenu+Prioritat.LimitDret && y>OrigenYPantallaMenu-Prioritat.LimitSuperior && y<OrigenYPantallaMenu-Prioritat.LimitInferior)
		  {
		    ControlSubSubMenu=5;			//Prioritat
		  }
		else if(x>OrigenXPantallaMenu+Interns.LimitEsquerra && x<OrigenXPantallaMenu+Interns.LimitDret && y>OrigenYPantallaMenu-Interns.LimitSuperior && y<OrigenYPantallaMenu-Interns.LimitInferior)
		  {
		    ControlSubSubMenu=6;			//Prioritat interior 
		  }
		else if(x>OrigenXPantallaMenu+AfegirInterns[0].LimitEsquerra && x<OrigenXPantallaMenu+AfegirInterns[0].LimitDret && y>OrigenYPantallaMenu-AfegirInterns[0].LimitSuperior && y<OrigenYPantallaMenu-AfegirInterns[0].LimitInferior)
		  {
		    if(IDinsEsfChar[0]!='V')			//Guarda aquesta prioritat com a una de les incloses si no es troba ja al vector
		      {
			//Comprovem que el número no es troba ja al vector
			bool dins=false;		//Controla si el número ja es troba al vector o no
			int i=0;
			while(i<100 && DinsEsfChar[i][0]!='V')
			  {
			    if(DinsEsfChar[i][0]==IDinsEsfChar[0] && DinsEsfChar[i][1]==IDinsEsfChar[1] && DinsEsfChar[i][2]==IDinsEsfChar[2])
			      {
				dins=true;
				break;
			      }
			    i++;
			  }
			if(dins==false)
			  {
			    DinsEsfChar[i][0]=IDinsEsfChar[0];
			    DinsEsfChar[i][1]=IDinsEsfChar[1];
			    DinsEsfChar[i][2]=IDinsEsfChar[2];
			  }
			IDinsEsfChar[0]='V';
			IDinsEsfChar[1]='V';
			IDinsEsfChar[2]='V';
		      }
		  }
		else if(x>OrigenXPantallaMenu+AfegirInterns[1].LimitEsquerra && x<OrigenXPantallaMenu+AfegirInterns[1].LimitDret && y>OrigenYPantallaMenu-AfegirInterns[1].LimitSuperior && y<OrigenYPantallaMenu-AfegirInterns[1].LimitInferior)
		  {
		    //Borrara la prioritat introduida de la llista
		    int i=0;
		    bool dins=false;		//Controla si el número ja es troba al vector o no
		    while(i<100 && DinsEsfChar[i][0]!='V')	//Primer busquem el numero al vector
		      {
			if(DinsEsfChar[i][0]==IDinsEsfChar[0] && DinsEsfChar[i][1]==IDinsEsfChar[1] && DinsEsfChar[i][2]==IDinsEsfChar[2])
			  {
			    dins=true;
			    break;
			  }
			i++;
		      }
		    if(dins==true)
		      {
			while(i<100 && DinsEsfChar[i][0]!='V')	//ara el borrem
			  {
			    DinsEsfChar[i][0]=DinsEsfChar[i+1][0];
			    DinsEsfChar[i][1]=DinsEsfChar[i+1][1];
			    DinsEsfChar[i][2]=DinsEsfChar[i+1][2];
			    i++;
			  }
		      }
		    IDinsEsfChar[0]='V';
		    IDinsEsfChar[1]='V';
		    IDinsEsfChar[2]='V';
		  }
		else if(x>OrigenXPantallaMenu+MatDens[0].LimitEsquerra && x<OrigenXPantallaMenu+MatDens[0].LimitDret && y>OrigenYPantallaMenu-MatDens[0].LimitSuperior && y<OrigenYPantallaMenu-MatDens[0].LimitInferior)
		  {
		    ControlSubSubMenu=7;			//Material
		  }
		else if(x>OrigenXPantallaMenu+MatDens[1].LimitEsquerra && x<OrigenXPantallaMenu+MatDens[1].LimitDret && y>OrigenYPantallaMenu-MatDens[1].LimitSuperior && y<OrigenYPantallaMenu-MatDens[1].LimitInferior)
		  {
		    ControlSubSubMenu=8;			//Densitat
		  }
		else if(x>OrigenXPantallaMenu+Crear.LimitEsquerra && x<OrigenXPantallaMenu+Crear.LimitDret && y>OrigenYPantallaMenu-Crear.LimitSuperior && y<OrigenYPantallaMenu-Crear.LimitInferior)
		  {
		    //Crea l'esfera///
		    //Diguem que hem de tornar a renderitzar les pantalles
		    RendFinestraGran=true;
		    RendFinestraSup=true;
		    RendFinestraInf=true;
	  
		    int errors=0;			//Controla el nombre d'errors//
	  
		    char Aux[101];		//Posem dimensio 101 per a que sempre capiga el '\0' inclus si el EsfChar te 100 caràcters
		    int IndexChar=0;
		    //Guardem la coordenada X del centre i al mateix temps buidem el char//
		    while(ICentreEsfChar[0][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)
		      {
			Aux[IndexChar]=ICentreEsfChar[0][IndexChar];
			IndexChar++;
		      }
		    if(IndexChar==0)			//Missatge d'error si no hi ha cap valor guardat
		      {
			errors++;
			if(Idioma==0)
			  {
			    std::cout<<"Missing the X coordinate of center"<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"Falta la coordenada X del centre"<<std::endl;
			  }
			else if(Idioma==2)
			  {
			    std::cout<<"Falta la coordenada X del centro"<<std::endl;
			  }	
	    
		      }else
		      {
			Aux[IndexChar]='\0';
			ICentreEsf[0]=atof(Aux);
		      }

		    IndexChar=0;
		    //Guardem la coordenada Y del centre//
		    while(ICentreEsfChar[1][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)
		      {
			Aux[IndexChar]=ICentreEsfChar[1][IndexChar];
			IndexChar++;
		      }
		    if(IndexChar==0)			//Missatge d'error si no hi ha cap valor guardat
		      {
			errors++;
			if(Idioma==0)
			  {
			    std::cout<<"Missing the Y coordinate of center"<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"Falta la coordenada Y del centre"<<std::endl;
			  }
			else if(Idioma==2)
			  {
			    std::cout<<"Falta la coordenada Y del centro"<<std::endl;
			  }
	    
		      }else
		      {      
			Aux[IndexChar]='\0';
			ICentreEsf[1]=atof(Aux);
		      }     
	  
		    IndexChar=0;
		    //Guardem la coordenada Z del centre//
		    while(ICentreEsfChar[2][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)
		      {
			Aux[IndexChar]=ICentreEsfChar[2][IndexChar];
			IndexChar++;
		      }
		    if(IndexChar==0)			//Missatge d'error si no hi ha cap valor guardat
		      {
			errors++;
			if(Idioma==0)
			  {
			    std::cout<<"Missing the Z coordinate of center"<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"Falta la coordenada Z del centre"<<std::endl;
			  }
			else if(Idioma==2)
			  {
			    std::cout<<"Falta la coordenada Z del centro"<<std::endl;
			  }	
		      }else
		      {      
			Aux[IndexChar]='\0';
			ICentreEsf[2]=atof(Aux);
		      }
		    IndexChar=0;
	  
	  
		    //Guardem el radi de l'esfera//
		    while(IDimEsfChar[IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)
		      {
			Aux[IndexChar]=IDimEsfChar[IndexChar];
			IndexChar++;
		      }
		    if(IndexChar==0)			//Missatge d'error si no hi ha cap valor guardat
		      {
			errors++;
			if(Idioma==0)
			  {
			    std::cout<<"Missing sphere radius"<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"Falta el radi de l'esfera"<<std::endl;
			  }
			else if(Idioma==2)
			  {
			    std::cout<<"Falta el radio de la esfera"<<std::endl;
			  }
	    
		      }else
		      {      
			Aux[IndexChar]='\0';
			IDimEsf=atof(Aux);
		      }
		    if(IDimEsf==0)
		      {
			errors++;
			if(Idioma==0)
			  {
			    std::cout<<"The sphere radius must be bigger than zero"<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"El radi ha de ser major que zero"<<std::endl;
			  }
			else if(Idioma==2)
			  {
			    std::cout<<"El radio de la esfera debe ser mayor que cero"<<std::endl;
			  }
		      }
		    IndexChar=0;


		    //Guardem la prioritat de l'esfera//
		    while(IPrioritatEsfChar[IndexChar]!='V' && IndexChar<3)
		      {
			Aux[IndexChar]=IPrioritatEsfChar[IndexChar];
			IndexChar++;
		      }
		    if(IndexChar==0)			//Missatge d'error si no hi ha cap valor guardat
		      {
			errors++;
			if(Idioma==0)
			  {
			    std::cout<<"Missing the priority of the sphere"<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"Falta la prioritat del esfera"<<std::endl;
			  }
			else if(Idioma==2)
			  {
			    std::cout<<"Falta la prioridad del esfera"<<std::endl;
			  }	
		      }else
		      {      
			Aux[IndexChar]='\0';
			IPrioritatEsf=atoi(Aux);	    
		      }      
		    IndexChar=0;
		    //Guardem les prioritats dins de l'esfera//
		    while(DinsEsfChar[IndexChar][0]!='V' && IndexChar<100)
		      {
			Aux[0]=DinsEsfChar[IndexChar][0];
			if(DinsEsfChar[IndexChar][1]!='V')
			  {
			    Aux[1]=DinsEsfChar[IndexChar][1];
			    if(DinsEsfChar[IndexChar][2]!='V')
			      {
				Aux[2]=DinsEsfChar[IndexChar][2];
				Aux[3]='\0';
			      }
			    else{Aux[2]='\0';}
			  }
			else{Aux[1]='\0';}
	    	    
			IDinsEsf[IndexChar]=atoi(Aux);
	    
			//Comprovem que les prioritats dins de l'esfera són majors que la seua propia
			if(IDinsEsf[IndexChar]<=IPrioritatEsf)
			  {
			    errors++;
			    if(Idioma==0)
			      {
				std::cout<<"The body within the object must be greater than the object body"<<std::endl;
			      }
			    else if(Idioma==1)
			      {
				std::cout<<"El cos dins de l'objecte ha de ser major que la del propi objecte"<<std::endl;

			      }
			    else if(Idioma==2)
			      {
				std::cout<<"El cuerpo dentro del objeto deben ser mayores que la del propio objeto"<<std::endl;
			      }
			    break;
			  } 
			IndexChar++;
		      }
	  
		    while(IndexChar<100)		//Omplim la resta del vector de zeros
		      {
			IDinsEsf[IndexChar]=0;
			IndexChar++;
		      }

		    IndexChar=0;


		    //Guardem el material de l'esfera//
	  
		    if(IMatEsfChar[0]!='V')
		      {
			Aux[0]=IMatEsfChar[0];
			if(IMatEsfChar[1]!='V')
			  {
			    Aux[1]=IMatEsfChar[1];
			    Aux[2]='\0';
			  }
			else{Aux[1]='\0';}
			IMatEsf=atoi(Aux);
		      }
		    else			//Missatge d'error si no hi ha cap valor guardat
		      {
			errors++;
			if(Idioma==0)
			  {
			    std::cout<<"Missing the material of sphere"<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"Falta el material de l'esfera"<<std::endl;
			  }
			else if(Idioma==2)
			  {
			    std::cout<<"Falta el material de la esfera"<<std::endl;
			  }
	    
		      }    
	  
		    IndexChar=0;

	    
		    //Guardem la densitat de l'esfera//
		    while(IDensEsfChar[IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)
		      {
			Aux[IndexChar]=IDensEsfChar[IndexChar];
			IndexChar++;
		      }
		    if(IndexChar==0)			//Missatge d'error si no hi ha cap valor guardat
		      {
			errors++;
			if(Idioma==0)
			  {
			    std::cout<<"Missing the density of sphere"<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"Falta la densitat de l'esfera"<<std::endl;
			  }
			else if(Idioma==2)
			  {
			    std::cout<<"Falta la densidad de la esfera"<<std::endl;
			  }
	    
		      }else
		      {      
			Aux[IndexChar]='\0';
			IDensEsf=atof(Aux);	
		      }
	  
		    IndexChar=0;
	
	  
	
		    //Tornem a posar els valors per defecte//
		    //La densitat per defecte serà 1//
		    IDensEsfChar[0]='1';
	  
	  
		    if(errors==0 && NumEsf<=MaxEsferes)		//Si no ha trobat errors crearà l'esfera
		      {
			ColorBotoCrear=1;
			if(SeleccioFigura==false)
			  {
			    ControlMenu=0;
			    ControlSubMenu=0;
			    ControlSubSubMenu=0;
			    if(MaxPrioritat<IPrioritatEsf)	//Comprova si la prioritat introduida és major que la màxima fins ara
			      {
				MaxPrioritat=IPrioritatEsf;
			      }	  
			    //Busquem la posició, del vector que controla les prioritats, on hi ha un zero per a guardar la prioritat que hem gastat i on hi ha un zero per a guardar les que ara es troben dins d'un objecte
			    int PosBuit0=10001;
			    int m=0;
			    while(m<1000)
			      {
				if(PrioritatsAsignades[0][m]==0 && PosBuit0==10001)
				  {
				    PosBuit0=m;
				    break;
				  }
				m++;
			      }
			    PrioritatsAsignades[0][PosBuit0]=IPrioritatEsf;	      
	      
			    NumEsf++;
			    esferes[NumEsf].CanviarCentre(ICentreEsf[0],ICentreEsf[1],ICentreEsf[2]);
			    esferes[NumEsf].CanviarDimensions(IDimEsf);
			    esferes[NumEsf].CanviarMaterial(IMatEsf,IDensEsf);
			    esferes[NumEsf].Prioritat=IPrioritatEsf;
			    int i=0;
			    while(i<100)
			      {
				esferes[NumEsf].PDins[i]=IDinsEsf[i];
				i++;
			      }
			  }
			else if (SeleccioFigura==true)
			  {
			    if(MaxPrioritat<IPrioritatEsf)	//Comprova si la prioritat introduida és major que la màxima fins ara
			      {
				MaxPrioritat=IPrioritatEsf;
			      }	  
			    //Busquem la posició, del vector que controla les prioritats, on hi ha un zero per a guardar la prioritat que hem gastat i on hi ha un zero per a guardar les que ara es troben dins d'un objecte
			    int PosBuit0=10001;
			    int m=0;
			    while(m<1000)
			      {
				if(PrioritatsAsignades[0][m]==esferes[NumFigSel].Prioritat && PosBuit0==10001)
				  {
				    PosBuit0=m;
				    break;
				  }
				m++;
			      }
			    PrioritatsAsignades[0][PosBuit0]=IPrioritatEsf;
	      
			    esferes[NumFigSel].CanviarCentre(ICentreEsf[0],ICentreEsf[1],ICentreEsf[2]);
			    esferes[NumFigSel].CanviarDimensions(IDimEsf);
			    esferes[NumFigSel].CanviarMaterial(IMatEsf,IDensEsf);
			    esferes[NumFigSel].Prioritat=IPrioritatEsf;
			    int i=0;
			    while(i<100)
			      {
				esferes[NumFigSel].PDins[i]=IDinsEsf[i];		
				i++;
			      }	  
			  }
			//Buidem les prioritats internes//
			int i=0;
			while(i<100)
			  {
			    IDinsEsf[i]=0;
			    i++;
			  }    
		      }else
		      {
			ColorBotoCrear=2;
			if(Idioma==0)
			  {
			    std::cout<<"The sphere is not created"<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"No es crearà l'esfera"<<std::endl;
			  }
			else if(Idioma==2)
			  {
			    std::cout<<"No se creará la esfera"<<std::endl;
			  }
		      }
		    //Buidem les variables//
		    int i=0;
		    while(i<100)
		      {
			IDinsEsf[i]=0;
			i++;
		      }      
		    ICentreEsf[0]=0;ICentreEsf[1]=0;ICentreEsf[2]=0;
		    IDimEsf=0;
		    IMatEsf=0;IDensEsf=1;
		    IPrioritatEsf=0;
	  
		  }
		
	      }
	    else if(ControlSubMenu==3)
	      {
		////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
		/////////////SUBSUBMENU DE NOU CILINDRE//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		if(x>OrigenXPantallaMenu+Centre[0].LimitEsquerra && x<OrigenXPantallaMenu+Centre[0].LimitDret && y>OrigenYPantallaMenu-Centre[0].LimitSuperior && y<OrigenYPantallaMenu-Centre[0].LimitInferior)
		  {
		    ControlSubSubMenu=1;			//CentreX
		  }
		else if(x>OrigenXPantallaMenu+Centre[1].LimitEsquerra && x<OrigenXPantallaMenu+Centre[1].LimitDret && y>OrigenYPantallaMenu-Centre[1].LimitSuperior && y<OrigenYPantallaMenu-Centre[1].LimitInferior)
		  {
		    ControlSubSubMenu=2;			//CentreY
		  }
		else if(x>OrigenXPantallaMenu+Centre[2].LimitEsquerra && x<OrigenXPantallaMenu+Centre[2].LimitDret && y>OrigenYPantallaMenu-Centre[2].LimitSuperior && y<OrigenYPantallaMenu-Centre[2].LimitInferior)
		  {
		    ControlSubSubMenu=3;			//CentreZ
		  }
		else if(x>OrigenXPantallaMenu+Dim[0].LimitEsquerra && x<OrigenXPantallaMenu+Dim[0].LimitDret && y>OrigenYPantallaMenu-Dim[0].LimitSuperior && y<OrigenYPantallaMenu-Dim[0].LimitInferior)
		  {
		    ControlSubSubMenu=4;			//Dimensio altura
		  }
		else if(x>OrigenXPantallaMenu+Dim[1].LimitEsquerra && x<OrigenXPantallaMenu+Dim[1].LimitDret && y>OrigenYPantallaMenu-Dim[1].LimitSuperior && y<OrigenYPantallaMenu-Dim[1].LimitInferior)
		  {
		    ControlSubSubMenu=5;			//Dimensio radi superior
		  }
		else if(x>OrigenXPantallaMenu+Dim[2].LimitEsquerra && x<OrigenXPantallaMenu+Dim[2].LimitDret && y>OrigenYPantallaMenu-Dim[2].LimitSuperior && y<OrigenYPantallaMenu-Dim[2].LimitInferior)
		  {
		    ControlSubSubMenu=6;			//Dimensio radi inferior
		  } 
		else if(x>OrigenXPantallaMenu+Prioritat.LimitEsquerra && x<OrigenXPantallaMenu+Prioritat.LimitDret && y>OrigenYPantallaMenu-Prioritat.LimitSuperior && y<OrigenYPantallaMenu-Prioritat.LimitInferior)
		  {
		    ControlSubSubMenu=7;			//Prioritat
		  }
		else if(x>OrigenXPantallaMenu+Interns.LimitEsquerra && x<OrigenXPantallaMenu+Interns.LimitDret && y>OrigenYPantallaMenu-Interns.LimitSuperior && y<OrigenYPantallaMenu-Interns.LimitInferior)
		  {
		    ControlSubSubMenu=8;			//Prioritat interior 
		  }
		else if(x>OrigenXPantallaMenu+AfegirInterns[0].LimitEsquerra && x<OrigenXPantallaMenu+AfegirInterns[0].LimitDret && y>OrigenYPantallaMenu-AfegirInterns[0].LimitSuperior && y<OrigenYPantallaMenu-AfegirInterns[0].LimitInferior)
		  {
		    if(IDinsCilChar[0]!='V')			//Guarda aquesta prioritat com a una de les incloses si no es troba ja al vector
		      {
			//Comprovem que el número no es troba ja al vector
			bool dins=false;		//Controla si el número ja es troba al vector o no
			int i=0;
			while(i<100 && DinsCilChar[i][0]!='V')
			  {
			    if(DinsCilChar[i][0]==IDinsCilChar[0] && DinsCilChar[i][1]==IDinsCilChar[1] && DinsCilChar[i][2]==IDinsCilChar[2])
			      {
				dins=true;
				break;
			      }
			    i++;
			  }
			if(dins==false)
			  {
			    DinsCilChar[i][0]=IDinsCilChar[0];
			    DinsCilChar[i][1]=IDinsCilChar[1];
			    DinsCilChar[i][2]=IDinsCilChar[2];
			  }
			IDinsCilChar[0]='V';
			IDinsCilChar[1]='V';
			IDinsCilChar[2]='V';
		      }
		  }
		else if(x>OrigenXPantallaMenu+AfegirInterns[1].LimitEsquerra && x<OrigenXPantallaMenu+AfegirInterns[1].LimitDret && y>OrigenYPantallaMenu-AfegirInterns[1].LimitSuperior && y<OrigenYPantallaMenu-AfegirInterns[1].LimitInferior)
		  {
		    //Borrara la prioritat introduida de la llista
		    int i=0;
		    bool dins=false;		//Controla si el número ja es troba al vector o no
		    while(i<100 && DinsCilChar[i][0]!='V')	//Primer busquem el numero al vector
		      {
			if(DinsCilChar[i][0]==IDinsCilChar[0] && DinsCilChar[i][1]==IDinsCilChar[1] && DinsCilChar[i][2]==IDinsCilChar[2])
			  {
			    dins=true;
			    break;
			  }
			i++;
		      }
		    if(dins==true)
		      {
			while(i<100 && DinsCilChar[i][0]!='V')	//ara el borrem
			  {
			    DinsCilChar[i][0]=DinsCilChar[i+1][0];
			    DinsCilChar[i][1]=DinsCilChar[i+1][1];
			    DinsCilChar[i][2]=DinsCilChar[i+1][2];
			    i++;
			  }
		      }
		    IDinsCilChar[0]='V';
		    IDinsCilChar[1]='V';
		    IDinsCilChar[2]='V';
		  }
		else if(x>OrigenXPantallaMenu+MatDens[0].LimitEsquerra && x<OrigenXPantallaMenu+MatDens[0].LimitDret && y>OrigenYPantallaMenu-MatDens[0].LimitSuperior && y<OrigenYPantallaMenu-MatDens[0].LimitInferior)
		  {
		    ControlSubSubMenu=9;			//Material
		  }
		else if(x>OrigenXPantallaMenu+MatDens[1].LimitEsquerra && x<OrigenXPantallaMenu+MatDens[1].LimitDret && y>OrigenYPantallaMenu-MatDens[1].LimitSuperior && y<OrigenYPantallaMenu-MatDens[1].LimitInferior)
		  {
		    ControlSubSubMenu=10;			//Densitat
		  }
		else if(x>OrigenXPantallaMenu+Angles[0].LimitEsquerra && x<OrigenXPantallaMenu+Angles[0].LimitDret && y>OrigenYPantallaMenu-Angles[0].LimitSuperior && y<OrigenYPantallaMenu-Angles[0].LimitInferior)
		  {
		    ControlSubSubMenu=11;			//Alfa
		  }
		else if(x>OrigenXPantallaMenu+Angles[1].LimitEsquerra && x<OrigenXPantallaMenu+Angles[1].LimitDret && y>OrigenYPantallaMenu-Angles[1].LimitSuperior && y<OrigenYPantallaMenu-Angles[1].LimitInferior)
		  {
		    ControlSubSubMenu=12;			//Beta
		  }
		else if(x>OrigenXPantallaMenu+Angles[2].LimitEsquerra && x<OrigenXPantallaMenu+Angles[2].LimitDret && y>OrigenYPantallaMenu-Angles[2].LimitSuperior && y<OrigenYPantallaMenu-Angles[2].LimitInferior)
		  {
		    ControlSubSubMenu=13;			//Gamma
		  }
		else if(x>OrigenXPantallaMenu+BTub.LimitEsquerra && x<OrigenXPantallaMenu+BTub.LimitDret && y>OrigenYPantallaMenu-BTub.LimitSuperior && y<OrigenYPantallaMenu-BTub.LimitInferior)
		  {
		    if(ITubCil==true)
		      {
			ITubCil=false;
		      }
		    else if(ITubCil==false)
		      {
			ITubCil=true;
		      }
		  }
		else if(x>OrigenXPantallaMenu+Crear.LimitEsquerra && x<OrigenXPantallaMenu+Crear.LimitDret && y>OrigenYPantallaMenu-Crear.LimitSuperior && y<OrigenYPantallaMenu-Crear.LimitInferior)
		  {
		    //Crea el cilindre///
		    //Diguem que hem de tornar a renderitzar les pantalles
		    RendFinestraGran=true;
		    RendFinestraSup=true;
		    RendFinestraInf=true;
	  
		    int errors=0;			//Controla el nombre d'errors//
	  
		    char Aux[101];		//Posem dimensio 101 per a que sempre capiga el '\0' inclus si el CilChar te 100 caràcters
		    int IndexChar=0;
		    //Guardem la coordenada X del centre i al mateix temps buidem el char//
		    while(ICentreCilChar[0][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)
		      {
			Aux[IndexChar]=ICentreCilChar[0][IndexChar];
			IndexChar++;
		      }
		    if(IndexChar==0)			//Missatge d'error si no hi ha cap valor guardat
		      {
			errors++;
			if(Idioma==0)
			  {
			    std::cout<<"Missing the X coordinate of center"<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"Falta la coordenada X del centre"<<std::endl;
			  }
			else if(Idioma==2)
			  {
			    std::cout<<"Falta la coordenada X del centro"<<std::endl;
			  }	
		      }else
		      {
			Aux[IndexChar]='\0';
			ICentreCil[0]=atof(Aux);
		      }

		    IndexChar=0;
		    //Guardem la coordenada Y del centre//
		    while(ICentreCilChar[1][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)
		      {
			Aux[IndexChar]=ICentreCilChar[1][IndexChar];
			IndexChar++;
		      }
		    if(IndexChar==0)			//Missatge d'error si no hi ha cap valor guardat
		      {
			errors++;
			if(Idioma==0)
			  {
			    std::cout<<"Missing the Y coordinate of center"<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"Falta la coordenada Y del centre"<<std::endl;
			  }
			else if(Idioma==2)
			  {
			    std::cout<<"Falta la coordenada Y del centro"<<std::endl;
			  }	
		      }else
		      {      
			Aux[IndexChar]='\0';
			ICentreCil[1]=atof(Aux);
		      }     
	  
		    IndexChar=0;
		    //Guardem la coordenada Z del centre//
		    while(ICentreCilChar[2][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)
		      {
			Aux[IndexChar]=ICentreCilChar[2][IndexChar];
			IndexChar++;
		      }
		    if(IndexChar==0)			//Missatge d'error si no hi ha cap valor guardat
		      {
			errors++;
			if(Idioma==0)
			  {
			    std::cout<<"Missing the Z coordinate of center"<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"Falta la coordenada Z del centre"<<std::endl;
			  }
			else if(Idioma==2)
			  {
			    std::cout<<"Falta la coordenada Z del centro"<<std::endl;
			  }	
		      }else
		      {      
			Aux[IndexChar]='\0';
			ICentreCil[2]=atof(Aux);
		      }
		    IndexChar=0;
	  
	  
		    //Guardem la dimensio X del cilindre//
		    while(IDimCilChar[0][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)
		      {
			Aux[IndexChar]=IDimCilChar[0][IndexChar];
			IndexChar++;
		      }
		    if(IndexChar==0)			//Missatge d'error si no hi ha cap valor guardat
		      {
			errors++;
			if(Idioma==0)
			  {
			    std::cout<<"Missing the cylinder height"<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"Falta l'altura del cilindre"<<std::endl;
			  }
			else if(Idioma==2)
			  {
			    std::cout<<"Falta la altura del cilindro"<<std::endl;
			  }
	    
		      }else
		      {      
			Aux[IndexChar]='\0';
			IDimCil[0]=atof(Aux);
		      }

		    IndexChar=0;


		    //Guardem la dimensio Y del cilindre//
		    while(IDimCilChar[1][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)
		      {
			Aux[IndexChar]=IDimCilChar[1][IndexChar];
			IndexChar++;
		      }
		    if(IndexChar==0)			//Missatge d'error si no hi ha cap valor guardat
		      {
			errors++;
			if(Idioma==0)
			  {
			    std::cout<<"Missing the cylinder top radius"<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"Falta el radi superior del cilindre"<<std::endl;
			  }
			else if(Idioma==2)
			  {
			    std::cout<<"Falta el radio superior del cilindro"<<std::endl;
			  }
	    
		      }else
		      {            
			Aux[IndexChar]='\0';
			IDimCil[1]=atof(Aux);
		      }
		    IndexChar=0;
	  
	  
		    //Guardem la dimensio Z del cilindre//
		    while(IDimCilChar[2][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)
		      {
			Aux[IndexChar]=IDimCilChar[2][IndexChar];
			IndexChar++;
		      }
		    if(IndexChar==0)			//Missatge d'error si no hi ha cap valor guardat
		      {
			errors++;
			if(Idioma==0)
			  {
			    std::cout<<"Missing the lower radius of cylinder "<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"Falta el radi inferior del cilindre"<<std::endl;
			  }
			else if(Idioma==2)
			  {
			    std::cout<<"Falta el radio inferior del cilindro"<<std::endl;
			  }
	    
		      }else
		      {      
			Aux[IndexChar]='\0';
			IDimCil[2]=atof(Aux);
		      }
		    IndexChar=0;
		    //Guardem la prioritat del cilindre//
		    while(IPrioritatCilChar[IndexChar]!='V' && IndexChar<3)
		      {
			Aux[IndexChar]=IPrioritatCilChar[IndexChar];
			IndexChar++;
		      }
		    if(IndexChar==0)			//Missatge d'error si no hi ha cap valor guardat
		      {
			errors++;
			if(Idioma==0)
			  {
			    std::cout<<"Missing the priority of the cylinder"<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"Falta la prioritat del cilindre"<<std::endl;
			  }
			else if(Idioma==2)
			  {
			    std::cout<<"Falta la prioridad del cilindro"<<std::endl;
			  }	
		      }else
		      {      
			Aux[IndexChar]='\0';
			IPrioritatCil=atoi(Aux);	    
		      }      
		    IndexChar=0;
		    //Guardem les prioritats dins del cilindre//
		    while(DinsCilChar[IndexChar][0]!='V' && IndexChar<100)
		      {
			Aux[0]=DinsCilChar[IndexChar][0];
			if(DinsCilChar[IndexChar][1]!='V')
			  {
			    Aux[1]=DinsCilChar[IndexChar][1];
			    if(DinsCilChar[IndexChar][2]!='V')
			      {
				Aux[2]=DinsCilChar[IndexChar][2];
				Aux[3]='\0';
			      }
			    else{Aux[2]='\0';}
			  }
			else{Aux[1]='\0';}
	    
			IDinsCil[IndexChar]=atoi(Aux);
			//Comprovem que les prioritats dins del cilindre són majors que la seua propia
			if(IDinsCil[IndexChar]<=IPrioritatCil)
			  {
			    errors++;
			    if(Idioma==0)
			      {
				std::cout<<"The body within the object must be greater than the object body"<<std::endl;
			      }
			    else if(Idioma==1)
			      {
				std::cout<<"El cos dins de l'objecte ha de ser major que la del propi objecte"<<std::endl;

			      }
			    else if(Idioma==2)
			      {
				std::cout<<"El cuerpo dentro del objeto deben ser mayores que la del propio objeto"<<std::endl;
			      }
			    break;
			  }
			IndexChar++;	
		      }
	  
		    while(IndexChar<100)		//Omplim la resta del vector de zeros
		      {
			IDinsCil[IndexChar]=0;
			IndexChar++;
		      }

		    IndexChar=0;


		    //Guardem el material del cilindre//
	  
		    if(IMatCilChar[0]!='V')
		      {
			Aux[0]=IMatCilChar[0];
			if(IMatCilChar[1]!='V')
			  {
			    Aux[1]=IMatCilChar[1];
			    Aux[2]='\0';
			  }
			else{Aux[1]='\0';}
			IMatCil=atoi(Aux);
		      }
		    else			//Missatge d'error si no hi ha cap valor guardat
		      {
			errors++;
			if(Idioma==0)
			  {
			    std::cout<<"Missing the material of cylinder"<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"Falta el material del cilindre"<<std::endl;
			  }
			else if(Idioma==2)
			  {
			    std::cout<<"Falta el material del cilindro"<<std::endl;
			  }	
		      }    
	  
		    IndexChar=0;

	    
		    //Guardem la densitat del cilindre//
		    while(IDensCilChar[IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)
		      {
			Aux[IndexChar]=IDensCilChar[IndexChar];
			IndexChar++;
		      }
		    if(IndexChar==0)			//Missatge d'error si no hi ha cap valor guardat
		      {
			errors++;
			if(Idioma==0)
			  {
			    std::cout<<"Missing the density of the cylinder"<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"Falta la densitat del cilindre"<<std::endl;
			  }
			else if(Idioma==2)
			  {
			    std::cout<<"Falta la densidad del cilindro"<<std::endl;
			  }	
		      }else
		      {      
			Aux[IndexChar]='\0';
			IDensCil=atof(Aux);	
		      }
	  
		    IndexChar=0;
	
	  
		    //Guardem l'angle de rotació Alfa//
		    while(IAnglesCilChar[0][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)
		      {
			Aux[IndexChar]=IAnglesCilChar[0][IndexChar];
			IndexChar++;
		      }
		    if(IndexChar==0)			//Missatge d'error si no hi ha cap valor guardat
		      {
			errors++;
			if(Idioma==0)
			  {
			    std::cout<<"Missing the rotation angle alpha of the cylinder"<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"Falta l'angle alfa de rotació del cilindre"<<std::endl;

			  }
			else if(Idioma==2)
			  {
			    std::cout<<"Falta el angulo alfa de rotación del cilindro"<<std::endl;
			  }	
		      }else
		      {      
			Aux[IndexChar]='\0';
			IAnglesCil[0]=atof(Aux);	
		      }
		    IndexChar=0;
	  
	  
	  
		    //Guardem l'angle de rotació Beta//
		    while(IAnglesCilChar[1][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)
		      {
			Aux[IndexChar]=IAnglesCilChar[1][IndexChar];
			IndexChar++;
		      }
		    if(IndexChar==0)			//Missatge d'error si no hi ha cap valor guardat
		      {
			errors++;
			if(Idioma==0)
			  {
			    std::cout<<"Missing the rotation angle beta of the cylinder"<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"Falta l'angle beta de rotació del cilindre"<<std::endl;

			  }
			else if(Idioma==2)
			  {
			    std::cout<<"Falta el angulo beta de rotación del cilindro"<<std::endl;
			  }	
		      }else
		      {
			Aux[IndexChar]='\0';
			IAnglesCil[1]=atof(Aux);	
		      }
		    IndexChar=0;      
	
	  
	  
		    //Guardem l'angle de rotació Gamma//
		    while(IAnglesCilChar[2][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)
		      {
			Aux[IndexChar]=IAnglesCilChar[2][IndexChar];
			IndexChar++;
		      }
		    if(IndexChar==0)			//Missatge d'error si no hi ha cap valor guardat
		      {
			errors++;
			if(Idioma==0)
			  {
			    std::cout<<"Missing the rotation angle gamma of the cylinder"<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"Falta l'angle gamma de rotació del cilindre"<<std::endl;

			  }
			else if(Idioma==2)
			  {
			    std::cout<<"Falta el angulo gamma de rotación del cilindro"<<std::endl;
			  }	
		      }else
		      {
			Aux[IndexChar]='\0';
			IAnglesCil[2]=atof(Aux);	
		      }
		    IndexChar=0;      
	  	  
	  
		    if(errors==0 && NumCil<=MaxCilindres)		//Si no ha trobat errors crearà el cub
		      {
			ColorBotoCrear=1;
			if(SeleccioFigura==false)
			  {
			    //Tornem a posar els valors per defecte//
			    //L'angle per defecte serà zero//
			    IAnglesCilChar[0][0]='0';
			    IAnglesCilChar[1][0]='0';
			    IAnglesCilChar[2][0]='0';
			    //La densitat per defecte serà 1//
			    IDensCilChar[0]='1';
	      
			    ControlMenu=0;
			    ControlSubMenu=0;
			    ControlSubSubMenu=0;
			    if(MaxPrioritat<IPrioritatCil)	//Comprova si la prioritat introduida és major que la màxima fins ara
			      {
				MaxPrioritat=IPrioritatCil;
			      }
			    //Busquem la posició, del vector que controla les prioritats, on hi ha un zero per a guardar la prioritat que hem gastat i on hi ha un zero per a guardar les que ara es troben dins d'un objecte
			    int PosBuit0=10001;
			    int m=0;
			    while(m<1000)
			      {
				if(PrioritatsAsignades[0][m]==0 && PosBuit0==10001)
				  {
				    PosBuit0=m;
				    break;
				  }
				m++;
			      }
			    PrioritatsAsignades[0][PosBuit0]=IPrioritatCil;
	      
			    NumCil++;
			    cilindres[NumCil].CanviarCentre(ICentreCil[0],ICentreCil[1],ICentreCil[2]);
			    cilindres[NumCil].CanviarDimensions(IDimCil[0],IDimCil[1],IDimCil[2]);
			    cilindres[NumCil].CanviarMaterial(IMatCil,IDensCil);
			    cilindres[NumCil].Girar(IAnglesCil[0],IAnglesCil[1],IAnglesCil[2]);
			    cilindres[NumCil].Prioritat=IPrioritatCil;
			    cilindres[NumCil].ActivarTub(ITubCil);
			    ITubCil=false;
			    int i=0;
			    while(i<100)
			      {
				cilindres[NumCil].PDins[i]=IDinsCil[i];				
				i++;
			      }
			  }
			else if(SeleccioFigura==true)
			  {
			    if(MaxPrioritat<IPrioritatCil)	//Comprova si la prioritat introduida és major que la màxima fins ara
			      {
				MaxPrioritat=IPrioritatCil;
			      }	  
			    //Busquem la posició, del vector que controla les prioritats, on hi ha un zero per a guardar la prioritat que hem gastat i on hi ha un zero per a guardar les que ara es troben dins d'un objecte
			    int PosBuit0=10001;
			    int m=0;
			    while(m<1000)
			      {
				if(PrioritatsAsignades[0][m]==cilindres[NumFigSel].Prioritat && PosBuit0==10001)
				  {
				    PosBuit0=m;
				    break;
				  }
				m++;
			      }
			    PrioritatsAsignades[0][PosBuit0]=IPrioritatCil;
	      
			    cilindres[NumFigSel].CanviarCentre(ICentreCil[0],ICentreCil[1],ICentreCil[2]);
			    cilindres[NumFigSel].CanviarDimensions(IDimCil[0],IDimCil[1],IDimCil[2]);
			    cilindres[NumFigSel].CanviarMaterial(IMatCil,IDensCil);
			    cilindres[NumFigSel].Girar(IAnglesCil[0],IAnglesCil[1],IAnglesCil[2]);
			    cilindres[NumFigSel].Prioritat=IPrioritatCil;
			    cilindres[NumFigSel].ActivarTub(ITubCil);
			    ITubCil=false;			    
			    int i=0;
			    while(i<100)
			      {
				cilindres[NumFigSel].PDins[i]=IDinsCil[i];				
				i++;
			      }	  
			  }
			//Buidem les prioritats internes//
			int i=0;
			while(i<100)
			  {
			    IDinsCil[i]=0;
			    i++;
			  }      			
		      }else
		      {
			ColorBotoCrear=2;
			if(Idioma==0)
			  {
			    std::cout<<"The cylinder is not created"<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"No es crearà el cilindre"<<std::endl;
			  }
			else if(Idioma==2)
			  {
			    std::cout<<"No se creará el cilindro"<<std::endl;
			  }	std::cout<<std::endl;
		      }
		    //Buidem les variables//
		    int i=0;
		    while(i<100)
		      {
			IDinsCil[i]=0;
			i++;
		      }      
		    ICentreCil[0]=0;ICentreCil[1]=0;ICentreCil[2]=0;
		    IDimCil[0]=0;IDimCil[1]=0;IDimCil[2]=0;
		    IMatCil=0;IDensCil=1;
		    IAnglesCil[0]=0;IAnglesCil[1]=0;IAnglesCil[2]=0;
		    IPrioritatCil=0;
		  }
		
	      }
	    else if(ControlSubMenu==4)
	      {
		////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
		/////////////SUBSUBMENU DE NOU PLA INFINIT//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		if(x>OrigenXPantallaMenu+Centre[0].LimitEsquerra && x<OrigenXPantallaMenu+Centre[0].LimitDret && y>OrigenYPantallaMenu-Centre[0].LimitSuperior && y<OrigenYPantallaMenu-Centre[0].LimitInferior)
		  {
		    ControlSubSubMenu=1;			//CentreX
		  }
		else if(x>OrigenXPantallaMenu+Centre[1].LimitEsquerra && x<OrigenXPantallaMenu+Centre[1].LimitDret && y>OrigenYPantallaMenu-Centre[1].LimitSuperior && y<OrigenYPantallaMenu-Centre[1].LimitInferior)
		  {
		    ControlSubSubMenu=2;			//CentreY
		  }
		else if(x>OrigenXPantallaMenu+Centre[2].LimitEsquerra && x<OrigenXPantallaMenu+Centre[2].LimitDret && y>OrigenYPantallaMenu-Centre[2].LimitSuperior && y<OrigenYPantallaMenu-Centre[2].LimitInferior)
		  {
		    ControlSubSubMenu=3;			//CentreZ
		  }
		else if(x>OrigenXPantallaMenu+Prioritat.LimitEsquerra && x<OrigenXPantallaMenu+Prioritat.LimitDret && y>OrigenYPantallaMenu-Prioritat.LimitSuperior && y<OrigenYPantallaMenu-Prioritat.LimitInferior)
		  {
		    ControlSubSubMenu=4;			//Prioritat
		  }
		else if(x>OrigenXPantallaMenu+Interns.LimitEsquerra && x<OrigenXPantallaMenu+Interns.LimitDret && y>OrigenYPantallaMenu-Interns.LimitSuperior && y<OrigenYPantallaMenu-Interns.LimitInferior)
		  {
		    ControlSubSubMenu=5;			//Prioritat interior 
		  }
		else if(x>OrigenXPantallaMenu+AfegirInterns[0].LimitEsquerra && x<OrigenXPantallaMenu+AfegirInterns[0].LimitDret && y>OrigenYPantallaMenu-AfegirInterns[0].LimitSuperior && y<OrigenYPantallaMenu-AfegirInterns[0].LimitInferior)
		  {
		    if(IDinsPlaChar[0]!='V')			//Guarda aquesta prioritat com a una de les incloses si no es troba ja al vector
		      {
			//Comprovem que el número no es troba ja al vector
			bool dins=false;		//Controla si el número ja es troba al vector o no
			int i=0;
			while(i<100 && DinsPlaChar[i][0]!='V')
			  {
			    if(DinsPlaChar[i][0]==IDinsPlaChar[0] && DinsPlaChar[i][1]==IDinsPlaChar[1] && DinsPlaChar[i][2]==IDinsPlaChar[2])
			      {
				dins=true;
				break;
			      }
			    i++;
			  }
			if(dins==false)
			  {
			    DinsPlaChar[i][0]=IDinsPlaChar[0];
			    DinsPlaChar[i][1]=IDinsPlaChar[1];
			    DinsPlaChar[i][2]=IDinsPlaChar[2];
			  }
			IDinsPlaChar[0]='V';
			IDinsPlaChar[1]='V';
			IDinsPlaChar[2]='V';
		      }
		  }
		else if(x>OrigenXPantallaMenu+AfegirInterns[1].LimitEsquerra && x<OrigenXPantallaMenu+AfegirInterns[1].LimitDret && y>OrigenYPantallaMenu-AfegirInterns[1].LimitSuperior && y<OrigenYPantallaMenu-AfegirInterns[1].LimitInferior)
		  {
		    //Borrara la prioritat introduida de la llista
		    int i=0;
		    bool dins=false;		//Controla si el número ja es troba al vector o no
		    while(i<100 && DinsPlaChar[i][0]!='V')	//Primer busquem el numero al vector
		      {
			if(DinsPlaChar[i][0]==IDinsPlaChar[0] && DinsPlaChar[i][1]==IDinsPlaChar[1] && DinsPlaChar[i][2]==IDinsPlaChar[2])
			  {
			    dins=true;
			    break;
			  }
			i++;
		      }
		    if(dins==true)
		      {
			while(i<100 && DinsPlaChar[i][0]!='V')	//ara el borrem
			  {
			    DinsPlaChar[i][0]=DinsPlaChar[i+1][0];
			    DinsPlaChar[i][1]=DinsPlaChar[i+1][1];
			    DinsPlaChar[i][2]=DinsPlaChar[i+1][2];
			    i++;
			  }
		      }
		    IDinsPlaChar[0]='V';
		    IDinsPlaChar[1]='V';
		    IDinsPlaChar[2]='V';
		  }
		else if(x>OrigenXPantallaMenu+MatDens[0].LimitEsquerra && x<OrigenXPantallaMenu+MatDens[0].LimitDret && y>OrigenYPantallaMenu-MatDens[0].LimitSuperior && y<OrigenYPantallaMenu-MatDens[0].LimitInferior)
		  {
		    ControlSubSubMenu=6;			//Material
		  }
		else if(x>OrigenXPantallaMenu+MatDens[1].LimitEsquerra && x<OrigenXPantallaMenu+MatDens[1].LimitDret && y>OrigenYPantallaMenu-MatDens[1].LimitSuperior && y<OrigenYPantallaMenu-MatDens[1].LimitInferior)
		  {
		    ControlSubSubMenu=7;			//Densitat
		  }
		else if(x>OrigenXPantallaMenu+Angles[0].LimitEsquerra && x<OrigenXPantallaMenu+Angles[0].LimitDret && y>OrigenYPantallaMenu-Angles[0].LimitSuperior && y<OrigenYPantallaMenu-Angles[0].LimitInferior)
		  {
		    ControlSubSubMenu=8;			//DireccioX
		  }
		else if(x>OrigenXPantallaMenu+Angles[1].LimitEsquerra && x<OrigenXPantallaMenu+Angles[1].LimitDret && y>OrigenYPantallaMenu-Angles[1].LimitSuperior && y<OrigenYPantallaMenu-Angles[1].LimitInferior)
		  {
		    ControlSubSubMenu=9;			//DireccioY
		  }
		else if(x>OrigenXPantallaMenu+Angles[2].LimitEsquerra && x<OrigenXPantallaMenu+Angles[2].LimitDret && y>OrigenYPantallaMenu-Angles[2].LimitSuperior && y<OrigenYPantallaMenu-Angles[2].LimitInferior)
		  {
		    ControlSubSubMenu=10;			//DireccioZ
		  }
		else if(x>OrigenXPantallaMenu+Crear.LimitEsquerra && x<OrigenXPantallaMenu+Crear.LimitDret && y>OrigenYPantallaMenu-Crear.LimitSuperior && y<OrigenYPantallaMenu-Crear.LimitInferior)
		  {
		    //Crea el Pla Infinit///
		    //Diguem que hem de tornar a renderitzar les pantalles
		    RendFinestraGran=true;
		    RendFinestraSup=true;
		    RendFinestraInf=true;
	  
		    int errors=0;			//Controla el nombre d'errors//
	  
		    char Aux[101];		//Posem dimensio 101 per a que sempre capiga el '\0' inclus si el PlaChar te 100 caràcters
		    int IndexChar=0;
		    //Guardem la coordenada X del centre i al mateix temps buidem el char//
		    while(ICentrePlaChar[0][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)
		      {
			Aux[IndexChar]=ICentrePlaChar[0][IndexChar];
			IndexChar++;
		      }
		    if(IndexChar==0)			//Missatge d'error si no hi ha cap valor guardat
		      {
			errors++;
			if(Idioma==0)
			  {
			    std::cout<<"Missing the X coordinate of center"<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"Falta la coordenada X del centre"<<std::endl;
			  }
			else if(Idioma==2)
			  {
			    std::cout<<"Falta la coordenada X del centro"<<std::endl;
			  }	
		      }else
		      {
			Aux[IndexChar]='\0';
			ICentrePla[0]=atof(Aux);
		      }

		    IndexChar=0;
		    //Guardem la coordenada Y del centre//
		    while(ICentrePlaChar[1][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)
		      {
			Aux[IndexChar]=ICentrePlaChar[1][IndexChar];
			IndexChar++;
		      }
		    if(IndexChar==0)			//Missatge d'error si no hi ha cap valor guardat
		      {
			errors++;
			if(Idioma==0)
			  {
			    std::cout<<"Missing the Y coordinate of center"<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"Falta la coordenada Y del centre"<<std::endl;
			  }
			else if(Idioma==2)
			  {
			    std::cout<<"Falta la coordenada Y del centro"<<std::endl;
			  }	
		      }else
		      {      
			Aux[IndexChar]='\0';
			ICentrePla[1]=atof(Aux);
		      }     
	  
		    IndexChar=0;
		    //Guardem la coordenada Z del centre//
		    while(ICentrePlaChar[2][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)
		      {
			Aux[IndexChar]=ICentrePlaChar[2][IndexChar];
			IndexChar++;
		      }
		    if(IndexChar==0)			//Missatge d'error si no hi ha cap valor guardat
		      {
			errors++;
			if(Idioma==0)
			  {
			    std::cout<<"Missing the Z coordinate of center"<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"Falta la coordenada Z del centre"<<std::endl;
			  }
			else if(Idioma==2)
			  {
			    std::cout<<"Falta la coordenada Z del centro"<<std::endl;
			  }	
		      }else
		      {      
			Aux[IndexChar]='\0';
			ICentrePla[2]=atof(Aux);
		      }
		    IndexChar=0;
		
		    //Guardem la prioritat del pla//
		    while(IPrioritatPlaChar[IndexChar]!='V' && IndexChar<3)
		      {
			Aux[IndexChar]=IPrioritatPlaChar[IndexChar];
			IndexChar++;
		      }
		    if(IndexChar==0)			//Missatge d'error si no hi ha cap valor guardat
		      {
			errors++;
			if(Idioma==0)
			  {
			    std::cout<<"Missing the priority of the plane"<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"Falta la prioritat del pla"<<std::endl;
			  }
			else if(Idioma==2)
			  {
			    std::cout<<"Falta la prioridad del plano"<<std::endl;
			  }	
		      }else
		      {      
			Aux[IndexChar]='\0';
			IPrioritatPla=atoi(Aux);	    
		      }      
		    IndexChar=0;
		    //Guardem les prioritats dins del pla//
		    while(DinsPlaChar[IndexChar][0]!='V' && IndexChar<100)
		      {
			Aux[0]=DinsPlaChar[IndexChar][0];
			if(DinsPlaChar[IndexChar][1]!='V')
			  {
			    Aux[1]=DinsPlaChar[IndexChar][1];
			    if(DinsPlaChar[IndexChar][2]!='V')
			      {
				Aux[2]=DinsPlaChar[IndexChar][2];
				Aux[3]='\0';
			      }
			    else{Aux[2]='\0';}
			  }
			else{Aux[1]='\0';}
	    
			IDinsPla[IndexChar]=atoi(Aux);
	    
			//Comprovem que les prioritats dins del pla són majors que la seua propia
			if(IDinsPla[IndexChar]<=IPrioritatPla)
			  {
			    errors++;
			    if(Idioma==0)
			      {
				std::cout<<"The body within the object must be greater than the object body"<<std::endl;
			      }
			    else if(Idioma==1)
			      {
				std::cout<<"El cos dins de l'objecte ha de ser major que la del propi objecte"<<std::endl;

			      }
			    else if(Idioma==2)
			      {
				std::cout<<"El cuerpo dentro del objeto deben ser mayores que la del propio objeto"<<std::endl;
			      }
			    break;
			  }	    
			IndexChar++;	
		      }
	  
		    while(IndexChar<100)		//Omplim la resta del vector de zeros
		      {
			IDinsPla[IndexChar]=0;
			IndexChar++;
		      }

		    IndexChar=0;


		    //Guardem el material del pla//
	  
		    if(IMatPlaChar[0]!='V')
		      {
			Aux[0]=IMatPlaChar[0];
			if(IMatPlaChar[1]!='V')
			  {
			    Aux[1]=IMatPlaChar[1];
			    Aux[2]='\0';
			  }
			else{Aux[1]='\0';}
			IMatPla=atoi(Aux);
		      }
		    else			//Missatge d'error si no hi ha cap valor guardat
		      {
			errors++;
			if(Idioma==0)
			  {
			    std::cout<<"Missing the material of the plane"<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"Falta el material del pla"<<std::endl;
			  }
			else if(Idioma==2)
			  {
			    std::cout<<"Falta el material del plano"<<std::endl;
			  }	
		      }    
	  
		    IndexChar=0;

	    
		    //Guardem la densitat del cilindre//
		    while(IDensPlaChar[IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)
		      {
			Aux[IndexChar]=IDensPlaChar[IndexChar];
			IndexChar++;
		      }
		    if(IndexChar==0)			//Missatge d'error si no hi ha cap valor guardat
		      {
			errors++;
			if(Idioma==0)
			  {
			    std::cout<<"Missing the density of the plane"<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"Falta la densitat del pla"<<std::endl;
			  }
			else if(Idioma==2)
			  {
			    std::cout<<"Falta la densidad del plano"<<std::endl;
			  }	
		      }else
		      {      
			Aux[IndexChar]='\0';
			IDensPla=atof(Aux);	
		      }
	  
		    IndexChar=0;
	
	  
		    //Guardem la direccio X//
		    while(IAnglesPlaChar[0][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)
		      {
			Aux[IndexChar]=IAnglesPlaChar[0][IndexChar];
			IndexChar++;
		      }
		    if(IndexChar==0)			//Missatge d'error si no hi ha cap valor guardat
		      {
			errors++;
			if(Idioma==0)
			  {
			    std::cout<<"Missing the X direction of the plane"<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"Falta la direcció X del pla"<<std::endl;
			  }
			else if(Idioma==2)
			  {
			    std::cout<<"Falta la dirección X del plano"<<std::endl;
			  }	
	    
		      }else
		      {      
			Aux[IndexChar]='\0';
			IAnglesPla[0]=atof(Aux);	
		      }
		    IndexChar=0;
	  
	  
	  
		    //Guardem la direccio Y//
		    while(IAnglesPlaChar[1][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)
		      {
			Aux[IndexChar]=IAnglesPlaChar[1][IndexChar];
			IndexChar++;
		      }
		    if(IndexChar==0)			//Missatge d'error si no hi ha cap valor guardat
		      {
			errors++;
			if(Idioma==0)
			  {
			    std::cout<<"Missing the Y direction of the plane"<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"Falta la direcció Y del pla"<<std::endl;
			  }
			else if(Idioma==2)
			  {
			    std::cout<<"Falta la dirección Y del plano"<<std::endl;
			  }	
		      }else
		      {
			Aux[IndexChar]='\0';
			IAnglesPla[1]=atof(Aux);	
		      }
		    IndexChar=0;      
	
	  
	  
		    //Guardem la direccio Z//
		    while(IAnglesPlaChar[2][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)
		      {
			Aux[IndexChar]=IAnglesPlaChar[2][IndexChar];
			IndexChar++;
		      }
		    if(IndexChar==0)			//Missatge d'error si no hi ha cap valor guardat
		      {
			errors++;
			if(Idioma==0)
			  {
			    std::cout<<"Missing the Z direction of the plane"<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"Falta la direcció Z del pla"<<std::endl;
			  }
			else if(Idioma==2)
			  {
			    std::cout<<"Falta la dirección Z del plano"<<std::endl;
			  }	
		      }else
		      {
			Aux[IndexChar]='\0';
			IAnglesPla[2]=atof(Aux);	
		      }
		    IndexChar=0;      
	  
	  
	  
		    if(errors==0 && NumPla<=MaxPlans)		//Si no ha trobat errors crearà el pla
		      {
			ColorBotoCrear=1;
			if(SeleccioFigura==false)
			  {
			    //Tornem a posar els valors per defecte//
			    //L'angle per defecte serà zero//
			    IAnglesPlaChar[0][0]='0';
			    IAnglesPlaChar[1][0]='0';
			    IAnglesPlaChar[2][0]='1';
			    //La densitat per defecte serà 1//
			    IDensPlaChar[0]='1';
	      
			    ControlMenu=0;
			    ControlSubMenu=0;
			    ControlSubSubMenu=0;
			    if(MaxPrioritat<IPrioritatPla)	//Comprova si la prioritat introduida és major que la màxima fins ara
			      {
				MaxPrioritat=IPrioritatPla;
			      }
			    float DimMin=DimEspai[0];	//Mirem la dimensió minima per a asignar-li una dimensió al pla

			    if(DimMin>DimEspai[1])
			    {
			      DimMin=DimEspai[1];
			    }
			    if(DimMin>DimEspai[2])
			    {
			      DimMin=DimEspai[2];
	      
			    }
			    //Busquem la posició, del vector que controla les prioritats, on hi ha un zero per a guardar la prioritat que hem gastat i on hi ha un zero per a guardar les que ara es troben dins d'un objecte
			    int PosBuit0=10001;
			    int m=0;
			    while(m<1000)
			      {
				if(PrioritatsAsignades[0][m]==0 && PosBuit0==10001)
				  {
				    PosBuit0=m;
				    break;
				  }
				m++;
			      }
			    PrioritatsAsignades[0][PosBuit0]=IPrioritatPla;
	      
			    NumPla++;
			    plans[NumPla].CanviarDimensions(DimMin/4.0);
			    plans[NumPla].CanviarCentre(ICentrePla[0],ICentrePla[1],ICentrePla[2]);
			    plans[NumPla].CanviarMaterial(IMatPla,IDensPla);
			    plans[NumPla].CanviarDireccio(IAnglesPla[0],IAnglesPla[1],IAnglesPla[2]);
			    plans[NumPla].Prioritat=IPrioritatPla;
			    int i=0;
			    while(i<100)
			      {
				plans[NumPla].PDins[i]=IDinsPla[i];
				i++;
			      }
			  }
			else if(SeleccioFigura==true)
			  {
			    if(MaxPrioritat<IPrioritatPla)	//Comprova si la prioritat introduida és major que la màxima fins ara
			      {
				MaxPrioritat=IPrioritatPla;
			      }	  
			    float DimMin=DimEspai[0];	//Mirem la dimensió minima per a asignar-li una dimensió al pla
			    if(DimMin>DimEspai[1])
			    {
			      DimMin=DimEspai[1];
			    }
			    if(DimMin>DimEspai[2])
			    {
			      DimMin=DimEspai[2];
			    }
			    //Busquem la posició, del vector que controla les prioritats, on hi ha un zero per a guardar la prioritat que hem gastat i on hi ha un zero per a guardar les que ara es troben dins d'un objecte
			    int PosBuit0=10001;
			    int m=0;
			    while(m<1000)
			      {
				if(PrioritatsAsignades[0][m]==plans[NumFigSel].Prioritat && PosBuit0==10001)
				  {
				    PosBuit0=m;
				    break;
				  }
				m++;
			      }
			    PrioritatsAsignades[0][PosBuit0]=IPrioritatPla;
	      
			    plans[NumFigSel].CanviarCentre(ICentrePla[0],ICentrePla[1],ICentrePla[2]);
			    plans[NumFigSel].CanviarMaterial(IMatPla,IDensPla);
			    plans[NumFigSel].CanviarDimensions(DimMin/4.0);
			    plans[NumFigSel].CanviarDireccio(IAnglesPla[0],IAnglesPla[1],IAnglesPla[2]);
			    plans[NumFigSel].Prioritat=IPrioritatPla;
			    int i=0;
			    while(i<100)
			      {
				plans[NumFigSel].PDins[i]=IDinsPla[i];
				i++;
			      }	  
			  }
			//Buidem les prioritats internes//
			int i=0;
			while(i<100)
			  {
			    IDinsPla[i]=0;
			    i++;
			  }      
		      }else
		      {
			ColorBotoCrear=2;
			if(Idioma==0)
			  {
			    std::cout<<"The plane is not created"<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"No es crearà el pla"<<std::endl;
			  }
			else if(Idioma==2)
			  {
			    std::cout<<"No se creará el plano"<<std::endl;
			  }	std::cout<<std::endl;
		      }
	  
		    //Buidem les variables//
		    int i=0;
		    while(i<100)
		      {
			IDinsPla[i]=0;
			i++;
		      }      
		    ICentrePla[0]=0;ICentrePla[1]=0;ICentrePla[2]=0;
		    IMatPla=0;IDensPla=1;
		    IAnglesPla[0]=0;IAnglesPla[1]=0;IAnglesPla[2]=0;
		    IPrioritatPla=0;
		  }
			
	      }
	    else if(ControlSubMenu==5)
	      {
		////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
		/////////////SUBSUBMENU DE NOVA SECCIO D'ESFERA//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		if(x>OrigenXPantallaMenu+Centre[0].LimitEsquerra && x<OrigenXPantallaMenu+Centre[0].LimitDret && y>OrigenYPantallaMenu-Centre[0].LimitSuperior && y<OrigenYPantallaMenu-Centre[0].LimitInferior)
		  {
		    ControlSubSubMenu=1;			//CentreX
		  }
		else if(x>OrigenXPantallaMenu+Centre[1].LimitEsquerra && x<OrigenXPantallaMenu+Centre[1].LimitDret && y>OrigenYPantallaMenu-Centre[1].LimitSuperior && y<OrigenYPantallaMenu-Centre[1].LimitInferior)
		  {
		    ControlSubSubMenu=2;			//CentreY
		  }
		else if(x>OrigenXPantallaMenu+Centre[2].LimitEsquerra && x<OrigenXPantallaMenu+Centre[2].LimitDret && y>OrigenYPantallaMenu-Centre[2].LimitSuperior && y<OrigenYPantallaMenu-Centre[2].LimitInferior)
		  {
		    ControlSubSubMenu=3;			//CentreZ
		  }
      
		else if(x>OrigenXPantallaMenu+Dim[0].LimitEsquerra && x<OrigenXPantallaMenu+Dim[0].LimitDret && y>OrigenYPantallaMenu-Dim[0].LimitSuperior && y<OrigenYPantallaMenu-Dim[0].LimitInferior)
		  {
		    ControlSubSubMenu=4;			//Dimensio radi
		  }
		else if(x>OrigenXPantallaMenu+Dim[1].LimitEsquerra && x<OrigenXPantallaMenu+Dim[1].LimitDret && y>OrigenYPantallaMenu-Dim[1].LimitSuperior && y<OrigenYPantallaMenu-Dim[1].LimitInferior)
		  {
		    ControlSubSubMenu=5;			//Dimensio altura de tall
		  } 
		else if(x>OrigenXPantallaMenu+Prioritat.LimitEsquerra && x<OrigenXPantallaMenu+Prioritat.LimitDret && y>OrigenYPantallaMenu-Prioritat.LimitSuperior && y<OrigenYPantallaMenu-Prioritat.LimitInferior)
		  {
		    ControlSubSubMenu=6;			//Prioritat
		  }
		else if(x>OrigenXPantallaMenu+Interns.LimitEsquerra && x<OrigenXPantallaMenu+Interns.LimitDret && y>OrigenYPantallaMenu-Interns.LimitSuperior && y<OrigenYPantallaMenu-Interns.LimitInferior)
		  {
		    ControlSubSubMenu=7;			//Prioritat interior 
		  }
		else if(x>OrigenXPantallaMenu+AfegirInterns[0].LimitEsquerra && x<OrigenXPantallaMenu+AfegirInterns[0].LimitDret && y>OrigenYPantallaMenu-AfegirInterns[0].LimitSuperior && y<OrigenYPantallaMenu-AfegirInterns[0].LimitInferior)
		  {
		    if(IDinsSecEsfChar[0]!='V')			//Guarda aquesta prioritat com a una de les incloses si no es troba ja al vector
		      {
			//Comprovem que el número no es troba ja al vector
			bool dins=false;		//Controla si el número ja es troba al vector o no
			int i=0;
			while(i<100 && DinsSecEsfChar[i][0]!='V')
			  {
			    if(DinsSecEsfChar[i][0]==IDinsSecEsfChar[0] && DinsSecEsfChar[i][1]==IDinsSecEsfChar[1] && DinsSecEsfChar[i][2]==IDinsSecEsfChar[2])
			      {
				dins=true;
				break;
			      }
			    i++;
			  }
			if(dins==false)
			  {
			    DinsSecEsfChar[i][0]=IDinsSecEsfChar[0];
			    DinsSecEsfChar[i][1]=IDinsSecEsfChar[1];
			    DinsSecEsfChar[i][2]=IDinsSecEsfChar[2];
			  }
			IDinsSecEsfChar[0]='V';
			IDinsSecEsfChar[1]='V';
			IDinsSecEsfChar[2]='V';
		      }
		  }
		else if(x>OrigenXPantallaMenu+AfegirInterns[1].LimitEsquerra && x<OrigenXPantallaMenu+AfegirInterns[1].LimitDret && y>OrigenYPantallaMenu-AfegirInterns[1].LimitSuperior && y<OrigenYPantallaMenu-AfegirInterns[1].LimitInferior)
		  {
		    //Borrara la prioritat introduida de la llista
		    int i=0;
		    bool dins=false;		//Controla si el número ja es troba al vector o no
		    while(i<100 && DinsSecEsfChar[i][0]!='V')	//Primer busquem el numero al vector
		      {
			if(DinsSecEsfChar[i][0]==IDinsSecEsfChar[0] && DinsSecEsfChar[i][1]==IDinsSecEsfChar[1] && DinsSecEsfChar[i][2]==IDinsSecEsfChar[2])
			  {
			    dins=true;
			    break;
			  }
			i++;
		      }
		    if(dins==true)
		      {
			while(i<100 && DinsSecEsfChar[i][0]!='V')	//ara el borrem
			  {
			    DinsSecEsfChar[i][0]=DinsSecEsfChar[i+1][0];
			    DinsSecEsfChar[i][1]=DinsSecEsfChar[i+1][1];
			    DinsSecEsfChar[i][2]=DinsSecEsfChar[i+1][2];
			    i++;
			  }
		      }
		    IDinsSecEsfChar[0]='V';
		    IDinsSecEsfChar[1]='V';
		    IDinsSecEsfChar[2]='V';
		  }
		else if(x>OrigenXPantallaMenu+MatDens[0].LimitEsquerra && x<OrigenXPantallaMenu+MatDens[0].LimitDret && y>OrigenYPantallaMenu-MatDens[0].LimitSuperior && y<OrigenYPantallaMenu-MatDens[0].LimitInferior)
		  {
		    ControlSubSubMenu=8;			//Material
		  }
		else if(x>OrigenXPantallaMenu+MatDens[1].LimitEsquerra && x<OrigenXPantallaMenu+MatDens[1].LimitDret && y>OrigenYPantallaMenu-MatDens[1].LimitSuperior && y<OrigenYPantallaMenu-MatDens[1].LimitInferior)
		  {
		    ControlSubSubMenu=9;			//Densitat
		  }
		else if(x>OrigenXPantallaMenu+Angles[0].LimitEsquerra && x<OrigenXPantallaMenu+Angles[0].LimitDret && y>OrigenYPantallaMenu-Angles[0].LimitSuperior && y<OrigenYPantallaMenu-Angles[0].LimitInferior)
		  {
		    ControlSubSubMenu=10;			//Direccio X
		  }
		else if(x>OrigenXPantallaMenu+Angles[1].LimitEsquerra && x<OrigenXPantallaMenu+Angles[1].LimitDret && y>OrigenYPantallaMenu-Angles[1].LimitSuperior && y<OrigenYPantallaMenu-Angles[1].LimitInferior)
		  {
		    ControlSubSubMenu=11;			//Direccio Y
		  }
		else if(x>OrigenXPantallaMenu+Angles[2].LimitEsquerra && x<OrigenXPantallaMenu+Angles[2].LimitDret && y>OrigenYPantallaMenu-Angles[2].LimitSuperior && y<OrigenYPantallaMenu-Angles[2].LimitInferior)
		  {
		    ControlSubSubMenu=12;			//Direccio Z
		  }
		else if(x>OrigenXPantallaMenu+Crear.LimitEsquerra && x<OrigenXPantallaMenu+Crear.LimitDret && y>OrigenYPantallaMenu-Crear.LimitSuperior && y<OrigenYPantallaMenu-Crear.LimitInferior)
		  {
		    //Aquest control de menu serveix per a mostrar els errors		//Crea la secció d'esfera///
		    //Diguem que hem de tornar a renderitzar les pantalles
		    RendFinestraGran=true;
		    RendFinestraSup=true;
		    RendFinestraInf=true;
	  
		    int errors=0;			//Controla el nombre d'errors//
	  
		    char Aux[101];		//Posem dimensio 101 per a que sempre capiga el '\0' inclus si el SecEsfChar te 100 caràcters
		    int IndexChar=0;
		    //Guardem la coordenada X del centre i al mateix temps buidem el char//
		    while(ICentreSecEsfChar[0][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)
		      {
			Aux[IndexChar]=ICentreSecEsfChar[0][IndexChar];
			IndexChar++;
		      }
		    if(IndexChar==0)			//Missatge d'error si no hi ha cap valor guardat
		      {
			errors++;
			if(Idioma==0)
			  {
			    std::cout<<"Missing the X coordinate of center"<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"Falta la coordenada X del centre"<<std::endl;
			  }
			else if(Idioma==2)
			  {
			    std::cout<<"Falta la coordenada X del centro"<<std::endl;
			  }	
		      }else
		      {
			Aux[IndexChar]='\0';
			ICentreSecEsf[0]=atof(Aux);
		      }

		    IndexChar=0;
		    //Guardem la coordenada Y del centre//
		    while(ICentreSecEsfChar[1][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)
		      {
			Aux[IndexChar]=ICentreSecEsfChar[1][IndexChar];
			IndexChar++;
		      }
		    if(IndexChar==0)			//Missatge d'error si no hi ha cap valor guardat
		      {
			errors++;
			if(Idioma==0)
			  {
			    std::cout<<"Missing the Y coordinate of center"<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"Falta la coordenada Y del centre"<<std::endl;
			  }
			else if(Idioma==2)
			  {
			    std::cout<<"Falta la coordenada Y del centro"<<std::endl;
			  }	
		      }else
		      {      
			Aux[IndexChar]='\0';
			ICentreSecEsf[1]=atof(Aux);
		      }     
	  
		    IndexChar=0;
		    //Guardem la coordenada Z del centre//
		    while(ICentreSecEsfChar[2][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)
		      {
			Aux[IndexChar]=ICentreSecEsfChar[2][IndexChar];
			IndexChar++;
		      }
		    if(IndexChar==0)			//Missatge d'error si no hi ha cap valor guardat
		      {
			errors++;
			if(Idioma==0)
			  {
			    std::cout<<"Missing the Z coordinate of center"<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"Falta la coordenada Z del centre"<<std::endl;
			  }
			else if(Idioma==2)
			  {
			    std::cout<<"Falta la coordenada Z del centro"<<std::endl;
			  }	
		      }else
		      {      
			Aux[IndexChar]='\0';
			ICentreSecEsf[2]=atof(Aux);
		      }
		    IndexChar=0;
	  
	  
		    //Guardem el radi//
		    while(IDimSecEsfChar[0][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)
		      {
			Aux[IndexChar]=IDimSecEsfChar[0][IndexChar];
			IndexChar++;
		      }
		    if(IndexChar==0)			//Missatge d'error si no hi ha cap valor guardat
		      {
			errors++;
			if(Idioma==0)
			  {
			    std::cout<<"Missing sphere radius"<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"Falta el radi de l'esfera"<<std::endl;
			  }
			else if(Idioma==2)
			  {
			    std::cout<<"Falta el radio de la esfera"<<std::endl;
			  }	
		      }else
		      {      
			Aux[IndexChar]='\0';
			IDimSecEsf[0]=atof(Aux);
		      }
		    if(fabs(IDimSecEsf[0])==0)
		      {
			errors++;
			if(Idioma==0)
			  {
			    std::cout<<"The radius of the sphere must be bigger than zero"<<std::endl;	  
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"El radi ha de ser major que zero"<<std::endl;
			  }
			else if(Idioma==2)
			  {
			    std::cout<<"El radio debe ser mayor que cero"<<std::endl;
			  }
		      }
		    IndexChar=0;


		    //Guardem l'altura de tall//
		    while(IDimSecEsfChar[1][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)
		      {
			Aux[IndexChar]=IDimSecEsfChar[1][IndexChar];
			IndexChar++;
		      }
		    if(IndexChar==0)			//Missatge d'error si no hi ha cap valor guardat
		      {
			errors++;
			if(Idioma==0)
			  {
			    std::cout<<"Missing the cut height"<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"Falta l'altura de tall"<<std::endl;
			  }
			else if(Idioma==2)
			  {
			    std::cout<<"Falta la altura de corte"<<std::endl;	  
			  }
	    
		      }else
		      {            
			Aux[IndexChar]='\0';
			IDimSecEsf[1]=atof(Aux);
		      }
		    if(fabs(IDimSecEsf[0])<fabs(IDimSecEsf[1]))
		      {
			errors++;
			if(Idioma==0)
			  {
			    std::cout<<"The cut height module must be higher than radius"<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"L'altura de tall en mòdul ha de ser menor que el radi"<<std::endl;
			  }
			else if(Idioma==2)
			  {
			    std::cout<<"La altura de corte en modulo debe ser menor que el radio"<<std::endl;	  
			  }
		      }
		    IndexChar=0;

		    //Guardem la prioritat de la seccio d'esfera//
		    while(IPrioritatSecEsfChar[IndexChar]!='V' && IndexChar<3)
		      {
			Aux[IndexChar]=IPrioritatSecEsfChar[IndexChar];
			IndexChar++;
		      }
		    if(IndexChar==0)			//Missatge d'error si no hi ha cap valor guardat
		      {
			errors++;
			if(Idioma==0)
			  {
			    std::cout<<"Missing the priority of the sphere section"<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"Falta la prioritat de la secció d'esfera"<<std::endl;
			  }
			else if(Idioma==2)
			  {
			    std::cout<<"Falta la prioridad del sección de esfera"<<std::endl;
			  }
	    
		      }else
		      {      
			Aux[IndexChar]='\0';
			IPrioritatSecEsf=atoi(Aux);	    
		      }      
		    IndexChar=0;
		    //Guardem les prioritats dins de la seccio d'esfera//
		    while(DinsSecEsfChar[IndexChar][0]!='V' && IndexChar<100)
		      {
			Aux[0]=DinsSecEsfChar[IndexChar][0];
			if(DinsSecEsfChar[IndexChar][1]!='V')
			  {
			    Aux[1]=DinsSecEsfChar[IndexChar][1];
			    if(DinsSecEsfChar[IndexChar][2]!='V')
			      {
				Aux[2]=DinsSecEsfChar[IndexChar][2];
				Aux[3]='\0';
			      }
			    else{Aux[2]='\0';}
			  }
			else{Aux[1]='\0';}
	    	    
			IDinsSecEsf[IndexChar]=atoi(Aux);
			//Comprovem que les prioritats dins del cilindre són majors que la seua propia
			if(IDinsSecEsf[IndexChar]<=IPrioritatSecEsf)
			  {
			    errors++;
			    if(Idioma==0)
			      {
				std::cout<<"The body within the object must be greater than the object body"<<std::endl;
			      }
			    else if(Idioma==1)
			      {
				std::cout<<"El cos dins de l'objecte ha de ser major que la del propi objecte"<<std::endl;

			      }
			    else if(Idioma==2)
			      {
				std::cout<<"El cuerpo dentro del objeto deben ser mayores que la del propio objeto"<<std::endl;
			      }	
			    break;
			  }
			IndexChar++;	
		      }
	  
		    while(IndexChar<100)		//Omplim la resta del vector de zeros
		      {
			IDinsSecEsf[IndexChar]=0;
			IndexChar++;
		      }

		    IndexChar=0;


		    //Guardem el material de la seccio d'esfera//
	  
		    if(IMatSecEsfChar[0]!='V')
		      {
			Aux[0]=IMatSecEsfChar[0];
			if(IMatSecEsfChar[1]!='V')
			  {
			    Aux[1]=IMatSecEsfChar[1];
			    Aux[2]='\0';
			  }
			else{Aux[1]='\0';}
			IMatSecEsf=atoi(Aux);
		      }
		    else			//Missatge d'error si no hi ha cap valor guardat
		      {
			errors++;
			if(Idioma==0)
			  {
			    std::cout<<"Missing the material of the sphere section"<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"Falta el material de la secció d'esfera"<<std::endl;
			  }
			else if(Idioma==2)
			  {
			    std::cout<<"Falta el material de la sección de esfera"<<std::endl;
			  }	
		      }    
	  
		    IndexChar=0;

	    
		    //Guardem la densitat de la seccio d'esfera//
		    while(IDensSecEsfChar[IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)
		      {
			Aux[IndexChar]=IDensSecEsfChar[IndexChar];
			IndexChar++;
		      }
		    if(IndexChar==0)			//Missatge d'error si no hi ha cap valor guardat
		      {
			errors++;
			if(Idioma==0)
			  {
			    std::cout<<"Missing the density of the sphere section"<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"Falta la densitat de la secció d'esfera"<<std::endl;
			  }
			else if(Idioma==2)
			  {
			    std::cout<<"Falta la densidad de la sección de esfera"<<std::endl;
			  }	
		      }else
		      {      
			Aux[IndexChar]='\0';
			IDensSecEsf=atof(Aux);	
		      }
	  
		    IndexChar=0;
	
	  
		    //Guardem la direccio X//
		    while(IAnglesSecEsfChar[0][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)
		      {
			Aux[IndexChar]=IAnglesSecEsfChar[0][IndexChar];
			IndexChar++;
		      }
		    if(IndexChar==0)			//Missatge d'error si no hi ha cap valor guardat
		      {
			errors++;
			if(Idioma==0)
			  {
			    std::cout<<"Missing the X direction of the sphere section"<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"Falta la direcció X de la secció d'esfera"<<std::endl;
			  }
			else if(Idioma==2)
			  {
			    std::cout<<"Falta la dirección X de la sección de esfera"<<std::endl;
			  }	
	    
		      }else
		      {      
			Aux[IndexChar]='\0';
			IAnglesSecEsf[0]=atof(Aux);	
		      }
		    IndexChar=0;
	  
	  
	  
		    //Guardem la component Y de la direcció//
		    while(IAnglesSecEsfChar[1][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)
		      {
			Aux[IndexChar]=IAnglesSecEsfChar[1][IndexChar];
			IndexChar++;
		      }
		    if(IndexChar==0)			//Missatge d'error si no hi ha cap valor guardat
		      {
			errors++;
			if(Idioma==0)
			  {
			    std::cout<<"Missing the Y direction of the sphere section"<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"Falta la direcció Y de la secció d'esfera"<<std::endl;
			  }
			else if(Idioma==2)
			  {
			    std::cout<<"Falta la dirección Y de la sección de esfera"<<std::endl;
			  }	
		      }else
		      {
			Aux[IndexChar]='\0';
			IAnglesSecEsf[1]=atof(Aux);	
		      }
		    IndexChar=0;      
	
	  
	  
		    //Guardem la component Z de la direcció//
		    while(IAnglesSecEsfChar[2][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)
		      {
			Aux[IndexChar]=IAnglesSecEsfChar[2][IndexChar];
			IndexChar++;
		      }
		    if(IndexChar==0)			//Missatge d'error si no hi ha cap valor guardat
		      {
			errors++;
			if(Idioma==0)
			  {
			    std::cout<<"Missing the Z direction of the sphere section"<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"Falta la direcció Z de la secció d'esfera"<<std::endl;
			  }
			else if(Idioma==2)
			  {
			    std::cout<<"Falta la dirección Z de la sección de esfera"<<std::endl;
			  }	
		      }else
		      {
			Aux[IndexChar]='\0';
			IAnglesSecEsf[2]=atof(Aux);	
		      }
		    IndexChar=0;      
	  	  
	  
		    if(errors==0 && NumSecEsf<=MaxSecEsf)		//Si no ha trobat errors crearà la secció
		      {
			ColorBotoCrear=1;
			if(SeleccioFigura==false)
			  {
			    //Tornem a posar els valors per defecte//
			    //L'angle per defecte serà zero//
			    IAnglesSecEsfChar[0][0]='0';
			    IAnglesSecEsfChar[1][0]='0';
			    IAnglesSecEsfChar[2][0]='1';
			    //La densitat per defecte serà 1//
			    IDensSecEsfChar[0]='1';
	      
			    ControlMenu=0;
			    ControlSubMenu=0;
			    ControlSubSubMenu=0;
			    if(MaxPrioritat<IPrioritatSecEsf)	//Comprova si la prioritat introduida és major que la màxima fins ara
			      {
				MaxPrioritat=IPrioritatSecEsf;
			      }
			    //Busquem la posició, del vector que controla les prioritats, on hi ha un zero per a guardar la prioritat que hem gastat i on hi ha un zero per a guardar les que ara es troben dins d'un objecte
			    int PosBuit0=10001;
			    int m=0;
			    while(m<1000)
			      {
				if(PrioritatsAsignades[0][m]==0 && PosBuit0==10001)
				  {
				    PosBuit0=m;
				    break;
				  }
				m++;
			      }
			    PrioritatsAsignades[0][PosBuit0]=IPrioritatSecEsf;
	      
			    NumSecEsf++;
			    secEsf[NumSecEsf].CanviarCentre(ICentreSecEsf[0],ICentreSecEsf[1],ICentreSecEsf[2]);
			    secEsf[NumSecEsf].CanviarDimensions(IDimSecEsf[0],IDimSecEsf[1]);
			    secEsf[NumSecEsf].CanviarMaterial(IMatSecEsf,IDensSecEsf);
			    secEsf[NumSecEsf].CanviarDireccio(IAnglesSecEsf[0],IAnglesSecEsf[1],IAnglesSecEsf[2]);
			    secEsf[NumSecEsf].Prioritat=IPrioritatSecEsf;
			    int i=0;
			    while(i<100)
			      {
				secEsf[NumSecEsf].PDins[i]=IDinsSecEsf[i];
				i++;
			      }
			  }
			else if(SeleccioFigura==true)
			  {
			    if(MaxPrioritat<IPrioritatSecEsf)	//Comprova si la prioritat introduida és major que la màxima fins ara
			      {
				MaxPrioritat=IPrioritatSecEsf;
			      }
			    //Busquem la posició, del vector que controla les prioritats, on hi ha un zero per a guardar la prioritat que hem gastat i on hi ha un zero per a guardar les que ara es troben dins d'un objecte
			    int PosBuit0=10001;
			    int m=0;
			    while(m<1000)
			      {
				if(PrioritatsAsignades[0][m]==secEsf[NumFigSel].Prioritat && PosBuit0==10001)
				  {
				    PosBuit0=m;
				    break;
				  }
				m++;
			      }
			    PrioritatsAsignades[0][PosBuit0]=IPrioritatSecEsf;
	      
			    secEsf[NumFigSel].CanviarCentre(ICentreSecEsf[0],ICentreSecEsf[1],ICentreSecEsf[2]);
			    secEsf[NumFigSel].CanviarDimensions(IDimSecEsf[0],IDimSecEsf[1]);
			    secEsf[NumFigSel].CanviarMaterial(IMatSecEsf,IDensSecEsf);
			    secEsf[NumFigSel].CanviarDireccio(IAnglesSecEsf[0],IAnglesSecEsf[1],IAnglesSecEsf[2]);
			    secEsf[NumFigSel].Prioritat=IPrioritatSecEsf;
			    int i=0;
			    while(i<100)
			      {
				secEsf[NumFigSel].PDins[i]=IDinsSecEsf[i];
				i++;
			      }	  
			  }
			//Buidem les prioritats internes//
			int i=0;
			while(i<100)
			  {
			    IDinsSecEsf[i]=0;
			    i++;
			  } 
		      }else
		      {
			ColorBotoCrear=2;
			if(Idioma==0)
			  {
			    std::cout<<"The sphere section is not created"<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"No es crearà la secció d'esfera"<<std::endl;
			  }
			else if(Idioma==2)
			  {
			    std::cout<<"No se creará la sección de esfera"<<std::endl;
			  }	std::cout<<std::endl;
		      }
	  
		    //Buidem les variables//
		    int i=0;
		    while(i<100)
		      {
			IDinsSecEsf[i]=0;
			i++;
		      }      
		    ICentreSecEsf[0]=0;ICentreSecEsf[1]=0;ICentreSecEsf[2]=0;
		    IDimSecEsf[0]=0;IDimSecEsf[1]=0;
		    IMatSecEsf=0;IDensSecEsf=1;
		    IAnglesSecEsf[0]=0;IAnglesSecEsf[1]=0;IAnglesSecEsf[2]=0;
		    IPrioritatSecEsf=0;
		  }
	
		
	      }
	  }
	else if(ControlMenu==2)
	  {
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////
	    /////////////SUBMENU SELECCIONAR FIGURA////////////////////////////////////////////////////////////////
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////
	    if(x>OrigenXPantallaMenu+IFiguraSelec.LimitEsquerra && x<OrigenXPantallaMenu+IFiguraSelec.LimitDret && y>OrigenYPantallaMenu-IFiguraSelec.LimitSuperior && y<OrigenYPantallaMenu-IFiguraSelec.LimitInferior)
	      {
		ControlSubMenu=1;
		ControlSubSubMenu=0;
	      }
	    else if(x>OrigenXPantallaMenu+Crear.LimitEsquerra && x<OrigenXPantallaMenu+Crear.LimitDret && y>OrigenYPantallaMenu-Crear.LimitSuperior && y<OrigenYPantallaMenu-Crear.LimitInferior)
	      {
		//Diguem que hem de tornar a renderitzar les pantalles
		RendFinestraGran=true;
		RendFinestraSup=true;
		RendFinestraInf=true;
	  
		//Busca la figura per a modificar-la//
		int errors=0;
		int IndexChar=0;
		char Aux[3];
		VoxelsActualitzats=false;
		//Guardem el número de figura//
		while(ISelFigChar[IndexChar]!='V' && IndexChar<3)
		  {
		    Aux[IndexChar]=ISelFigChar[IndexChar];
		    ISelFigChar[IndexChar]='V';
		    IndexChar++;
		  }
		if(IndexChar==0)			//Missatge d'error si no hi ha cap valor guardat
		  {
		    errors++;	    
		    if(Idioma==0)
		      {
			std::cout<<"It has not entered any value"<<std::endl;
		      }
		    else if(Idioma==1)
		      {
			std::cout<<"No s'ha introduït cap valor"<<std::endl;
		      }
		    else if(Idioma==2)
		      {
			std::cout<<"No se ha introducido ningun valor"<<std::endl;
		      }
		    std::cout<<std::endl;
	    
		  }else
		  {      
		    Aux[IndexChar]='\0';
		    ISelFig=atoi(Aux);
		  }            
		/////////Si no hi ha cap error, busquem el número de la figura entre totes les creades//
		if(errors==0)
		  {
		    int j=1;
		    TipusFiguraSel=0;
		    NumFigSel=0;
		    while(j<=NumCubs)				//Mira si és un rectangle i quin és
		      {
			if(rectangles[j].NumeroFigura()==ISelFig)
			  {
			    TipusFiguraSel=1;
			    NumFigSel=j;
			    break;
			  }
			j++;
		      }
		    j=1;      
		    while(j<=NumEsf)				//Mira si és una esfera i quina és
		      {
			if(TipusFiguraSel!=0)
			  {
			    break;
			  }
			if(esferes[j].NumeroFigura()==ISelFig)
			  {
			    TipusFiguraSel=2;
			    NumFigSel=j;
			    break;
			  }
			j++;
		      }
		    j=1;
		    while(j<=NumCil)				//Mira si és un cilindre i quin és
		      {
			if(TipusFiguraSel!=0)
			  {
			    break;
			  }
			if(cilindres[j].NumeroFigura()==ISelFig)
			  {
			    TipusFiguraSel=3;
			    NumFigSel=j;
			    break;
			  }
			j++;
		      }
		    j=1;
		    while(j<=NumPla)				//Mira si és un cilindre i quin és
		      {
			if(TipusFiguraSel!=0)
			  {
			    break;
			  }
			if(plans[j].NumeroFigura()==ISelFig)
			  {
			    TipusFiguraSel=4;
			    NumFigSel=j;
			    break;
			  }
			j++;
		      }
		    j=1;
		    while(j<=NumSecEsf)				//Mira si és un cilindre i quin és
		      {
			if(TipusFiguraSel!=0)
			  {
			    break;
			  }
			if(secEsf[j].NumeroFigura()==ISelFig)
			  {
			    TipusFiguraSel=5;
			    NumFigSel=j;
			    break;
			  }
			j++;
		      }
	    
		    //Ara segons el tipus de figura omplim les variables Char per a que es mostren als quadres d'introducció de dades
		    if(TipusFiguraSel==0)
		      {
			if(Idioma==0)
			  {
			    std::cout<<"This object does not exist"<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"Aquesta figura no existeix"<<std::endl;
			  }
			else if(Idioma==2)
			  {
			    std::cout<<"No existe esa figura"<<std::endl;
			  }
			std::cout<<std::endl;
		      }
		    //////////////////////////////////////////////////////////////////////////////////////////////////////////
		    ////////////////////////////////////////////CUBS//////////////////////////////////////////////////////////
		    //////////////////////////////////////////////////////////////////////////////////////////////////////////
		    else if(TipusFiguraSel==1)		//Rectangles
		      {
			//Primer buidarem les variables Char i despres introduirem els valors de la figura
			char aux[100];
			int i=0;
			int NumCaracters=0;			//guarda el nombre de caracters fins al '\0' igualant-lo al sprintf
			///////////////////////////
			//Coordenada X del centre//
			///////////////////////////
			NumCaracters=sprintf(aux,"%f",rectangles[NumFigSel].Centre[0]);
			i=0;
			while(i<MAX_CARACTERS_INTRODUIR)
			  {
			    if(i<NumCaracters)
			      {
				ICentreCubChar[0][i]=aux[i];
			      }
			    else			//Acaba d'omplir la variable amb 'V'
			      {
				ICentreCubChar[0][i]='V';
			      }
			    i++;
			  }
			//Omplim ara els zeros de la dreta despres de l'ultim decimal amb 'V' per a que no es mostren al quadre
			i=99;
			while(i>=0)
			  {
			    if(ICentreCubChar[0][i]=='0' || ICentreCubChar[0][i]=='V')
			      {
				ICentreCubChar[0][i]='V';
			      }
			    else{break;}
			    i--;
			  }
			///////////////////////////
			//Coordenada Y del centre//
			///////////////////////////
			NumCaracters=sprintf(aux,"%f",rectangles[NumFigSel].Centre[1]);
			i=0;
			while(i<MAX_CARACTERS_INTRODUIR)
			  {
			    if(i<NumCaracters)
			      {
				ICentreCubChar[1][i]=aux[i];
			      }
			    else			//Acaba d'omplir la variable amb 'V'
			      {
				ICentreCubChar[1][i]='V';
			      }
			    i++;
			  }
			//Omplim ara els zeros de la dreta despres de l'ultim decimal amb 'V' per a que no es mostren al quadre
			i=99;
			while(i>=0)
			  {
			    if(ICentreCubChar[1][i]=='0' || ICentreCubChar[1][i]=='V')
			      {
				ICentreCubChar[1][i]='V';
			      }
			    else{break;}
			    i--;
			  }	  
			///////////////////////////
			//Coordenada Z del centre//
			///////////////////////////
			NumCaracters=sprintf(aux,"%f",rectangles[NumFigSel].Centre[2]);
			i=0;
			while(i<MAX_CARACTERS_INTRODUIR)
			  {
			    if(i<NumCaracters)
			      {
				ICentreCubChar[2][i]=aux[i];
			      }
			    else			//Acaba d'omplir la variable amb 'V'
			      {
				ICentreCubChar[2][i]='V';
			      }
			    i++;
			  }
			//Omplim ara els zeros de la dreta despres de l'ultim decimal amb 'V' per a que no es mostren al quadre
			i=99;
			while(i>=0)
			  {
			    if(ICentreCubChar[2][i]=='0' || ICentreCubChar[2][i]=='V')
			      {
				ICentreCubChar[2][i]='V';
			      }
			    else{break;}
			    i--;
			  }
			//////////////////////
			//Dimensió X del cub//
			//////////////////////
			NumCaracters=sprintf(aux,"%f",rectangles[NumFigSel].Dimensions[0]);
			i=0;
			while(i<MAX_CARACTERS_INTRODUIR)
			  {
			    if(i<NumCaracters)
			      {
				IDimCubChar[0][i]=aux[i];
			      }
			    else			//Acaba d'omplir la variable amb 'V'
			      {
				IDimCubChar[0][i]='V';
			      }
			    i++;
			  }
			//Omplim ara els zeros de la dreta despres de l'ultim decimal amb 'V' per a que no es mostren al quadre
			i=99;
			while(i>=0)
			  {
			    if(IDimCubChar[0][i]=='0' || IDimCubChar[0][i]=='V')
			      {
				IDimCubChar[0][i]='V';
			      }
			    else{break;}
			    i--;
			  }
			//////////////////////
			//Dimensió Y del cub//
			//////////////////////
			NumCaracters=sprintf(aux,"%f",rectangles[NumFigSel].Dimensions[1]);
			i=0;
			while(i<MAX_CARACTERS_INTRODUIR)
			  {
			    if(i<NumCaracters)
			      {
				IDimCubChar[1][i]=aux[i];
			      }
			    else			//Acaba d'omplir la variable amb 'V'
			      {
				IDimCubChar[1][i]='V';
			      }
			    i++;
			  }
			//Omplim ara els zeros de la dreta despres de l'ultim decimal amb 'V' per a que no es mostren al quadre
			i=99;
			while(i>=0)
			  {
			    if(IDimCubChar[1][i]=='0' || IDimCubChar[1][i]=='V')
			      {
				IDimCubChar[1][i]='V';
			      }
			    else{break;}
			    i--;
			  }
			//////////////////////
			//Dimensió Z del cub//
			//////////////////////
			NumCaracters=sprintf(aux,"%f",rectangles[NumFigSel].Dimensions[2]);
			i=0;
			while(i<MAX_CARACTERS_INTRODUIR)
			  {
			    if(i<NumCaracters)
			      {
				IDimCubChar[2][i]=aux[i];
			      }
			    else			//Acaba d'omplir la variable amb 'V'
			      {
				IDimCubChar[2][i]='V';
			      }
			    i++;
			  }
			//Omplim ara els zeros de la dreta despres de l'ultim decimal amb 'V' per a que no es mostren al quadre
			i=99;
			while(i>=0)
			  {
			    if(IDimCubChar[2][i]=='0' || IDimCubChar[2][i]=='V')
			      {
				IDimCubChar[2][i]='V';
			      }
			    else{break;}
			    i--;
			  }
			/////////////////////
			//Prioritat del cub//
			/////////////////////
			NumCaracters=sprintf(aux,"%d",rectangles[NumFigSel].Prioritat);
			i=0;
			while(i<3)
			  {
			    if(i<NumCaracters)
			      {
				IPrioritatCubChar[i]=aux[i];
			      }
			    else			//Acaba d'omplir la variable amb 'V'
			      {
				IPrioritatCubChar[i]='V';
			      }
			    i++;
			  }
			///////////////////////////
			//Prioritats dins del cub//
			///////////////////////////
			i=0;
			int j=0;
			while(i<100)
			  {
			    NumCaracters=sprintf(aux,"%d",rectangles[NumFigSel].PDins[i]);
		
			    j=0;
			    bool XifraNoZero=false; 			//Mirarem amb aquesta variable si ha trobat una xifra que no siga zero per a que no es menge el zero del 10,20 etc
			    while(j<3)
			      {
				if(j<NumCaracters && (aux[j]!='0' || XifraNoZero==true))		//Tenim compte de que no guarde zeros al vector
				  {
				    DinsCubChar[i][j]=aux[j];
				    XifraNoZero=true;
				  }
				else			//Acaba d'omplir la variable amb 'V'
				  {
				    DinsCubChar[i][j]='V';
				  }
				j++;
			      }
			    i++;
			  }
			////////////////////
			//Material del cub//
			///////////////////
			NumCaracters=sprintf(aux,"%d",rectangles[NumFigSel].Material);
			IMatCubChar[0]=aux[0];
			if(NumCaracters==2)
			  {
			    IMatCubChar[1]=aux[1];
			  }
			else
			  {
			    IMatCubChar[1]='V';
			  }
			////////////////////
			//Densitat del cub//
			////////////////////
			NumCaracters=sprintf(aux,"%f",rectangles[NumFigSel].LlegirDensitat());
			i=0;
			while(i<MAX_CARACTERS_INTRODUIR)
			  {
			    if(i<NumCaracters)
			      {
				IDensCubChar[i]=aux[i];
			      }
			    else			//Acaba d'omplir la variable amb 'V'
			      {
				IDensCubChar[i]='V';
			      }
			    i++;
			  }
			//Omplim ara els zeros de la dreta despres de l'ultim decimal amb 'V' per a que no es mostren al quadre
			i=99;
			while(i>=0)
			  {
			    if(IDensCubChar[i]=='0' || IDensCubChar[i]=='V')
			      {
				IDensCubChar[i]='V';
			      }
			    else{break;}
			    i--;
			  }
			//////////////////////
			//Angle alfa del cub//
			//////////////////////
			NumCaracters=sprintf(aux,"%f",rectangles[NumFigSel].Alfa);
			i=0;
			while(i<MAX_CARACTERS_INTRODUIR)
			  {
			    if(i<NumCaracters)
			      {
				IAnglesCubChar[0][i]=aux[i];
			      }
			    else			//Acaba d'omplir la variable amb 'V'
			      {
				IAnglesCubChar[0][i]='V';
			      }
			    i++;
			  }
			//Omplim ara els zeros de la dreta despres de l'ultim decimal amb 'V' per a que no es mostren al quadre
			i=99;
			while(i>=0)
			  {
			    if(IAnglesCubChar[0][i]=='0' || IAnglesCubChar[0][i]=='V')
			      {
				IAnglesCubChar[0][i]='V';
			      }
			    else{break;}
			    i--;
			  }
			//////////////////////
			//Angle beta del cub//
			//////////////////////
			NumCaracters=sprintf(aux,"%f",rectangles[NumFigSel].Beta);
			i=0;
			while(i<MAX_CARACTERS_INTRODUIR)
			  {
			    if(i<NumCaracters)
			      {
				IAnglesCubChar[1][i]=aux[i];
			      }
			    else			//Acaba d'omplir la variable amb 'V'
			      {
				IAnglesCubChar[1][i]='V';
			      }
			    i++;
			  }
			//Omplim ara els zeros de la dreta despres de l'ultim decimal amb 'V' per a que no es mostren al quadre
			i=99;
			while(i>=0)
			  {
			    if(IAnglesCubChar[1][i]=='0' || IAnglesCubChar[1][i]=='V')
			      {
				IAnglesCubChar[1][i]='V';
			      }
			    else{break;}
			    i--;
			  }
			///////////////////////
			//Angle gamma del cub//
			///////////////////////
			NumCaracters=sprintf(aux,"%f",rectangles[NumFigSel].Gamma);
			i=0;
			while(i<MAX_CARACTERS_INTRODUIR)
			  {
			    if(i<NumCaracters)
			      {
				IAnglesCubChar[2][i]=aux[i];
			      }
			    else			//Acaba d'omplir la variable amb 'V'
			      {
				IAnglesCubChar[2][i]='V';
			      }
			    i++;
			  }
			//Omplim ara els zeros de la dreta despres de l'ultim decimal amb 'V' per a que no es mostren al quadre
			i=99;
			while(i>=0)
			  {
			    if(IAnglesCubChar[2][i]=='0' || IAnglesCubChar[2][i]=='V')
			      {
				IAnglesCubChar[2][i]='V';
			      }
			    else{break;}
			    i--;
			  }	  
	      
			//Mostrem el menu de nou Cub
	      
			ControlMenu=1;
			ControlSubMenu=1;
			ControlSubSubMenu=1;
	      
		      }
		    //////////////////////////////////////////////////////////////////////////////////////////////////////////
		    ////////////////////////////////////////////ESFERES//////////////////////////////////////////////////////////
		    //////////////////////////////////////////////////////////////////////////////////////////////////////////	
		    else if(TipusFiguraSel==2)		//Esferes
		      {
			//Primer buidarem les variables Char i despres introduirem els valors de la figura
			char aux[100];
			int i=0;
			int NumCaracters=0;			//guarda el nombre de caracters fins al '\0' igualant-lo al sprintf
			///////////////////////////
			//Coordenada X del centre//
			///////////////////////////
			NumCaracters=sprintf(aux,"%f",esferes[NumFigSel].Centre[0]);
			i=0;
			while(i<MAX_CARACTERS_INTRODUIR)
			  {
			    if(i<NumCaracters)
			      {
				ICentreEsfChar[0][i]=aux[i];
			      }
			    else			//Acaba d'omplir la variable amb 'V'
			      {
				ICentreEsfChar[0][i]='V';
			      }
			    i++;
			  }
			//Omplim ara els zeros de la dreta despres de l'ultim decimal amb 'V' per a que no es mostren al quadre
			i=99;
			while(i>=0)
			  {
			    if(ICentreEsfChar[0][i]=='0' || ICentreEsfChar[0][i]=='V')
			      {
				ICentreEsfChar[0][i]='V';
			      }
			    else{break;}
			    i--;
			  }
			///////////////////////////
			//Coordenada Y del centre//
			///////////////////////////
			NumCaracters=sprintf(aux,"%f",esferes[NumFigSel].Centre[1]);
			i=0;
			while(i<MAX_CARACTERS_INTRODUIR)
			  {
			    if(i<NumCaracters)
			      {
				ICentreEsfChar[1][i]=aux[i];
			      }
			    else			//Acaba d'omplir la variable amb 'V'
			      {
				ICentreEsfChar[1][i]='V';
			      }
			    i++;
			  }
			//Omplim ara els zeros de la dreta despres de l'ultim decimal amb 'V' per a que no es mostren al quadre
			i=99;
			while(i>=0)
			  {
			    if(ICentreEsfChar[1][i]=='0' || ICentreEsfChar[1][i]=='V')
			      {
				ICentreEsfChar[1][i]='V';
			      }
			    else{break;}
			    i--;
			  }	  
			///////////////////////////
			//Coordenada Z del centre//
			///////////////////////////
			NumCaracters=sprintf(aux,"%f",esferes[NumFigSel].Centre[2]);
			i=0;
			while(i<MAX_CARACTERS_INTRODUIR)
			  {
			    if(i<NumCaracters)
			      {
				ICentreEsfChar[2][i]=aux[i];
			      }
			    else			//Acaba d'omplir la variable amb 'V'
			      {
				ICentreEsfChar[2][i]='V';
			      }
			    i++;
			  }
			//Omplim ara els zeros de la dreta despres de l'ultim decimal amb 'V' per a que no es mostren al quadre
			i=99;
			while(i>=0)
			  {
			    if(ICentreEsfChar[2][i]=='0' || ICentreEsfChar[2][i]=='V')
			      {
				ICentreEsfChar[2][i]='V';
			      }
			    else{break;}
			    i--;
			  }
			//////////////////////
			//Radi de l'esfera  //
			//////////////////////
			NumCaracters=sprintf(aux,"%f",esferes[NumFigSel].Dimensions);
			i=0;
			while(i<MAX_CARACTERS_INTRODUIR)
			  {
			    if(i<NumCaracters)
			      {
				IDimEsfChar[i]=aux[i];
			      }
			    else			//Acaba d'omplir la variable amb 'V'
			      {
				IDimEsfChar[i]='V';
			      }
			    i++;
			  }
			//Omplim ara els zeros de la dreta despres de l'ultim decimal amb 'V' per a que no es mostren al quadre
			i=99;
			while(i>=0)
			  {
			    if(IDimEsfChar[i]=='0' || IDimEsfChar[i]=='V')
			      {
				IDimEsfChar[i]='V';
			      }
			    else{break;}
			    i--;
			  }
			/////////////////////////
			//Prioritat de l'esfera//
			/////////////////////////
			NumCaracters=sprintf(aux,"%d",esferes[NumFigSel].Prioritat);
			i=0;
			while(i<3)
			  {
			    if(i<NumCaracters)
			      {
				IPrioritatEsfChar[i]=aux[i];
			      }
			    else			//Acaba d'omplir la variable amb 'V'
			      {
				IPrioritatEsfChar[i]='V';
			      }
			    i++;
			  }
			///////////////////////////////
			//Prioritats dins de l'esfera//
			///////////////////////////////
			i=0;
			int j=0;
			while(i<100)
			  {
			    NumCaracters=sprintf(aux,"%d",esferes[NumFigSel].PDins[i]);
		
			    j=0;
			    bool XifraNoZero=false;
			    while(j<3)
			      {
				if(j<NumCaracters && (aux[j]!='0' || XifraNoZero==true))		//Tenim compte de que no guarde zeros al vector
				  {
				    DinsEsfChar[i][j]=aux[j];
				    XifraNoZero=true;
				  }
				else			//Acaba d'omplir la variable amb 'V'
				  {
				    DinsEsfChar[i][j]='V';
				  }
				j++;
			      }
			    i++;
			  }
			////////////////////////
			//Material de l'esfera//
			///////////////////////
			NumCaracters=sprintf(aux,"%d",esferes[NumFigSel].Material);
			IMatEsfChar[0]=aux[0];
			if(NumCaracters==2)
			  {
			    IMatEsfChar[1]=aux[1];
			  }
			else
			  {
			    IMatEsfChar[1]='V';
			  }
			////////////////////////
			//Densitat de l'esfera//
			////////////////////////
			NumCaracters=sprintf(aux,"%f",esferes[NumFigSel].LlegirDensitat());
			i=0;
			while(i<MAX_CARACTERS_INTRODUIR)
			  {
			    if(i<NumCaracters)
			      {
				IDensEsfChar[i]=aux[i];
			      }
			    else			//Acaba d'omplir la variable amb 'V'
			      {
				IDensEsfChar[i]='V';
			      }
			    i++;
			  }
			//Omplim ara els zeros de la dreta despres de l'ultim decimal amb 'V' per a que no es mostren al quadre
			i=99;
			while(i>=0)
			  {
			    if(IDensEsfChar[i]=='0' || IDensEsfChar[i]=='V')
			      {
				IDensEsfChar[i]='V';
			      }
			    else{break;}
			    i--;
			  }
	      
			//Mostrem el menu de nova esfera
	      
			ControlMenu=1;
			ControlSubMenu=2;
			ControlSubSubMenu=1;
	      
		      }
	  
		    //////////////////////////////////////////////////////////////////////////////////////////////////////////
		    ////////////////////////////////////////////CILINDRES/CONS//////////////////////////////////////////////////////////
		    //////////////////////////////////////////////////////////////////////////////////////////////////////////
		    else if(TipusFiguraSel==3)		//Cilindres/Cons
		      {
			//Primer buidarem les variables Char i despres introduirem els valors de la figura
			char aux[100];
			int i=0;
			int NumCaracters=0;			//guarda el nombre de caracters fins al '\0' igualant-lo al sprintf
			///////////////////////////
			//Coordenada X del centre//
			///////////////////////////
			NumCaracters=sprintf(aux,"%f",cilindres[NumFigSel].Centre[0]);
			i=0;
			while(i<MAX_CARACTERS_INTRODUIR)
			  {
			    if(i<NumCaracters)
			      {
				ICentreCilChar[0][i]=aux[i];
			      }
			    else			//Acaba d'omplir la variable amb 'V'
			      {
				ICentreCilChar[0][i]='V';
			      }
			    i++;
			  }
			//Omplim ara els zeros de la dreta despres de l'ultim decimal amb 'V' per a que no es mostren al quadre
			i=99;
			while(i>=0)
			  {
			    if(ICentreCilChar[0][i]=='0' || ICentreCilChar[0][i]=='V')
			      {
				ICentreCilChar[0][i]='V';
			      }
			    else{break;}
			    i--;
			  }
			///////////////////////////
			//Coordenada Y del centre//
			///////////////////////////
			NumCaracters=sprintf(aux,"%f",cilindres[NumFigSel].Centre[1]);
			i=0;
			while(i<MAX_CARACTERS_INTRODUIR)
			  {
			    if(i<NumCaracters)
			      {
				ICentreCilChar[1][i]=aux[i];
			      }
			    else			//Acaba d'omplir la variable amb 'V'
			      {
				ICentreCilChar[1][i]='V';
			      }
			    i++;
			  }
			//Omplim ara els zeros de la dreta despres de l'ultim decimal amb 'V' per a que no es mostren al quadre
			i=99;
			while(i>=0)
			  {
			    if(ICentreCilChar[1][i]=='0' || ICentreCilChar[1][i]=='V')
			      {
				ICentreCilChar[1][i]='V';
			      }
			    else{break;}
			    i--;
			  }	  
			///////////////////////////
			//Coordenada Z del centre//
			///////////////////////////
			NumCaracters=sprintf(aux,"%f",cilindres[NumFigSel].Centre[2]);
			i=0;
			while(i<MAX_CARACTERS_INTRODUIR)
			  {
			    if(i<NumCaracters)
			      {
				ICentreCilChar[2][i]=aux[i];
			      }
			    else			//Acaba d'omplir la variable amb 'V'
			      {
				ICentreCilChar[2][i]='V';
			      }
			    i++;
			  }
			//Omplim ara els zeros de la dreta despres de l'ultim decimal amb 'V' per a que no es mostren al quadre
			i=99;
			while(i>=0)
			  {
			    if(ICentreCilChar[2][i]=='0' || ICentreCilChar[2][i]=='V')
			      {
				ICentreCilChar[2][i]='V';
			      }
			    else{break;}
			    i--;
			  }
			///////////////////////////////
			//Dimensió X del cilindre/con//
			///////////////////////////////
			NumCaracters=sprintf(aux,"%f",cilindres[NumFigSel].Dimensions[0]);
			i=0;
			while(i<MAX_CARACTERS_INTRODUIR)
			  {
			    if(i<NumCaracters)
			      {
				IDimCilChar[0][i]=aux[i];
			      }
			    else			//Acaba d'omplir la variable amb 'V'
			      {
				IDimCilChar[0][i]='V';
			      }
			    i++;
			  }
			//Omplim ara els zeros de la dreta despres de l'ultim decimal amb 'V' per a que no es mostren al quadre
			i=99;
			while(i>=0)
			  {
			    if(IDimCilChar[0][i]=='0' || IDimCilChar[0][i]=='V')
			      {
				IDimCilChar[0][i]='V';
			      }
			    else{break;}
			    i--;
			  }
			//////////////////////////////////
			//Radi superior del cilindre/con//
			//////////////////////////////////
			NumCaracters=sprintf(aux,"%f",cilindres[NumFigSel].Dimensions[1]);
			i=0;
			while(i<MAX_CARACTERS_INTRODUIR)
			  {
			    if(i<NumCaracters)
			      {
				IDimCilChar[1][i]=aux[i];
			      }
			    else			//Acaba d'omplir la variable amb 'V'
			      {
				IDimCilChar[1][i]='V';
			      }
			    i++;
			  }
			//Omplim ara els zeros de la dreta despres de l'ultim decimal amb 'V' per a que no es mostren al quadre
			i=99;
			while(i>=0)
			  {
			    if(IDimCilChar[1][i]=='0' || IDimCilChar[1][i]=='V')
			      {
				IDimCilChar[1][i]='V';
			      }
			    else{break;}
			    i--;
			  }
			//////////////////////////////////
			//Radi inferior del cilindre/con//
			//////////////////////////////////
			NumCaracters=sprintf(aux,"%f",cilindres[NumFigSel].Dimensions[2]);
			i=0;
			while(i<MAX_CARACTERS_INTRODUIR)
			  {
			    if(i<NumCaracters)
			      {
				IDimCilChar[2][i]=aux[i];
			      }
			    else			//Acaba d'omplir la variable amb 'V'
			      {
				IDimCilChar[2][i]='V';
			      }
			    i++;
			  }
			//Omplim ara els zeros de la dreta despres de l'ultim decimal amb 'V' per a que no es mostren al quadre
			i=99;
			while(i>=0)
			  {
			    if(IDimCilChar[2][i]=='0' || IDimCilChar[2][i]=='V')
			      {
				IDimCilChar[2][i]='V';
			      }
			    else{break;}
			    i--;
			  }
			//////////////////////////////
			//Prioritat del cilindre/con//
			//////////////////////////////
			NumCaracters=sprintf(aux,"%d",cilindres[NumFigSel].Prioritat);
			i=0;
			while(i<3)
			  {
			    if(i<NumCaracters)
			      {
				IPrioritatCilChar[i]=aux[i];
			      }
			    else			//Acaba d'omplir la variable amb 'V'
			      {
				IPrioritatCilChar[i]='V';
			      }
			    i++;
			  }
			////////////////////////////////////
			//Si el cilindre es un tub        //
			////////////////////////////////////
			ITubCil=cilindres[NumFigSel].Tub;
			////////////////////////////////////
			//Prioritats dins del cilindre/con//
			////////////////////////////////////
			i=0;
			int j=0;
			while(i<100)
			  {
			    NumCaracters=sprintf(aux,"%d",cilindres[NumFigSel].PDins[i]);
		
			    j=0;
			    bool XifraNoZero=false;
			    while(j<3)
			      {
				if(j<NumCaracters && (aux[j]!='0' || XifraNoZero==true))		//Tenim compte de que no guarde zeros al vector
				  {
				    DinsCilChar[i][j]=aux[j];
				    XifraNoZero=true;
				  }
				else			//Acaba d'omplir la variable amb 'V'
				  {
				    DinsCilChar[i][j]='V';
				  }
				j++;
			      }
			    i++;
			  }
			/////////////////////////////
			//Material del cilindre/con//
			/////////////////////////////
			NumCaracters=sprintf(aux,"%d",cilindres[NumFigSel].Material);
			IMatCilChar[0]=aux[0];
			if(NumCaracters==2)
			  {
			    IMatCilChar[1]=aux[1];
			  }
			else
			  {
			    IMatCilChar[1]='V';
			  }
			/////////////////////////////
			//Densitat del cilindre/con//
			/////////////////////////////
			NumCaracters=sprintf(aux,"%f",cilindres[NumFigSel].LlegirDensitat());
			i=0;
			while(i<MAX_CARACTERS_INTRODUIR)
			  {
			    if(i<NumCaracters)
			      {
				IDensCilChar[i]=aux[i];
			      }
			    else			//Acaba d'omplir la variable amb 'V'
			      {
				IDensCilChar[i]='V';
			      }
			    i++;
			  }
			//Omplim ara els zeros de la dreta despres de l'ultim decimal amb 'V' per a que no es mostren al quadre
			i=99;
			while(i>=0)
			  {
			    if(IDensCilChar[i]=='0' || IDensCilChar[i]=='V')
			      {
				IDensCilChar[i]='V';
			      }
			    else{break;}
			    i--;
			  }
			///////////////////////////////
			//Angle alfa del cilindre/con//
			///////////////////////////////
			NumCaracters=sprintf(aux,"%f",cilindres[NumFigSel].Alfa);
			i=0;
			while(i<MAX_CARACTERS_INTRODUIR)
			  {
			    if(i<NumCaracters)
			      {
				IAnglesCilChar[0][i]=aux[i];
			      }
			    else			//Acaba d'omplir la variable amb 'V'
			      {
				IAnglesCilChar[0][i]='V';
			      }
			    i++;
			  }
			//Omplim ara els zeros de la dreta despres de l'ultim decimal amb 'V' per a que no es mostren al quadre
			i=99;
			while(i>=0)
			  {
			    if(IAnglesCilChar[0][i]=='0' || IAnglesCilChar[0][i]=='V')
			      {
				IAnglesCilChar[0][i]='V';
			      }
			    else{break;}
			    i--;
			  }
			///////////////////////////////
			//Angle beta del cilindre/con//
			///////////////////////////////
			NumCaracters=sprintf(aux,"%f",cilindres[NumFigSel].Beta);
			i=0;
			while(i<MAX_CARACTERS_INTRODUIR)
			  {
			    if(i<NumCaracters)
			      {
				IAnglesCilChar[1][i]=aux[i];
			      }
			    else			//Acaba d'omplir la variable amb 'V'
			      {
				IAnglesCilChar[1][i]='V';
			      }
			    i++;
			  }
			//Omplim ara els zeros de la dreta despres de l'ultim decimal amb 'V' per a que no es mostren al quadre
			i=99;
			while(i>=0)
			  {
			    if(IAnglesCilChar[1][i]=='0' || IAnglesCilChar[1][i]=='V')
			      {
				IAnglesCilChar[1][i]='V';
			      }
			    else{break;}
			    i--;
			  }
			////////////////////////////////
			//Angle gamma del cilindre/con//
			////////////////////////////////
			NumCaracters=sprintf(aux,"%f",cilindres[NumFigSel].Gamma);
			i=0;
			while(i<MAX_CARACTERS_INTRODUIR)
			  {
			    if(i<NumCaracters)
			      {
				IAnglesCilChar[2][i]=aux[i];
			      }
			    else			//Acaba d'omplir la variable amb 'V'
			      {
				IAnglesCilChar[2][i]='V';
			      }
			    i++;
			  }
			//Omplim ara els zeros de la dreta despres de l'ultim decimal amb 'V' per a que no es mostren al quadre
			i=99;
			while(i>=0)
			  {
			    if(IAnglesCilChar[2][i]=='0' || IAnglesCilChar[2][i]=='V')
			      {
				IAnglesCilChar[2][i]='V';
			      }
			    else{break;}
			    i--;
			  }	  
	      
			//Mostrem el menu de nou Cilindre/con
	      
			ControlMenu=1;
			ControlSubMenu=3;
			ControlSubSubMenu=1;
	      
		      }
		    
	  
		    //////////////////////////////////////////////////////////////////////////////////////////////////////////
		    ////////////////////////////////////////////PLANS/////////////////////////////////////////////////////////
		    //////////////////////////////////////////////////////////////////////////////////////////////////////////
		    else if(TipusFiguraSel==4)		//Plans
		      {
			//Primer buidarem les variables Char i despres introduirem els valors de la figura
			char aux[100];
			int i=0;
			int NumCaracters=0;			//guarda el nombre de caracters fins al '\0' igualant-lo al sprintf
			///////////////////////////
			//Coordenada X del centre//
			///////////////////////////
			NumCaracters=sprintf(aux,"%f",plans[NumFigSel].Centre[0]);
			i=0;
			while(i<MAX_CARACTERS_INTRODUIR)
			  {
			    if(i<NumCaracters)
			      {
				ICentrePlaChar[0][i]=aux[i];
			      }
			    else			//Acaba d'omplir la variable amb 'V'
			      {
				ICentrePlaChar[0][i]='V';
			      }
			    i++;
			  }
			//Omplim ara els zeros de la dreta despres de l'ultim decimal amb 'V' per a que no es mostren al quadre
			i=99;
			while(i>=0)
			  {
			    if(ICentrePlaChar[0][i]=='0' || ICentrePlaChar[0][i]=='V')
			      {
				ICentrePlaChar[0][i]='V';
			      }
			    else{break;}
			    i--;
			  }
			///////////////////////////
			//Coordenada Y del centre//
			///////////////////////////
			NumCaracters=sprintf(aux,"%f",plans[NumFigSel].Centre[1]);
			i=0;
			while(i<MAX_CARACTERS_INTRODUIR)
			  {
			    if(i<NumCaracters)
			      {
				ICentrePlaChar[1][i]=aux[i];
			      }
			    else			//Acaba d'omplir la variable amb 'V'
			      {
				ICentrePlaChar[1][i]='V';
			      }
			    i++;
			  }
			//Omplim ara els zeros de la dreta despres de l'ultim decimal amb 'V' per a que no es mostren al quadre
			i=99;
			while(i>=0)
			  {
			    if(ICentrePlaChar[1][i]=='0' || ICentrePlaChar[1][i]=='V')
			      {
				ICentrePlaChar[1][i]='V';
			      }
			    else{break;}
			    i--;
			  }	  
			///////////////////////////
			//Coordenada Z del centre//
			///////////////////////////
			NumCaracters=sprintf(aux,"%f",plans[NumFigSel].Centre[2]);
			i=0;
			while(i<MAX_CARACTERS_INTRODUIR)
			  {
			    if(i<NumCaracters)
			      {
				ICentrePlaChar[2][i]=aux[i];
			      }
			    else			//Acaba d'omplir la variable amb 'V'
			      {
				ICentrePlaChar[2][i]='V';
			      }
			    i++;
			  }
			//Omplim ara els zeros de la dreta despres de l'ultim decimal amb 'V' per a que no es mostren al quadre
			i=99;
			while(i>=0)
			  {
			    if(ICentrePlaChar[2][i]=='0' || ICentrePlaChar[2][i]=='V')
			      {
				ICentrePlaChar[2][i]='V';
			      }
			    else{break;}
			    i--;
			  }

			//////////////////////////////
			//Prioritat del pla         //
			//////////////////////////////
			NumCaracters=sprintf(aux,"%d",plans[NumFigSel].Prioritat);
			i=0;
			while(i<3)
			  {
			    if(i<NumCaracters)
			      {
				IPrioritatPlaChar[i]=aux[i];
			      }
			    else			//Acaba d'omplir la variable amb 'V'
			      {
				IPrioritatPlaChar[i]='V';
			      }
			    i++;
			  }
			////////////////////////////////////
			//Prioritats dins del pla         //
			////////////////////////////////////
			i=0;
			int j=0;
			while(i<100)
			  {
			    NumCaracters=sprintf(aux,"%d",plans[NumFigSel].PDins[i]);
		
			    j=0;
			    bool XifraNoZero=false;
			    while(j<3)
			      {
				if(j<NumCaracters && (aux[j]!='0' || XifraNoZero==true))		//Tenim compte de que no guarde zeros al vector
				  {
				    DinsPlaChar[i][j]=aux[j];
				    XifraNoZero=true;
				  }
				else			//Acaba d'omplir la variable amb 'V'
				  {
				    DinsPlaChar[i][j]='V';
				  }
				j++;
			      }
			    i++;
			  }
			/////////////////////////////
			//Material del pla         //
			/////////////////////////////
			NumCaracters=sprintf(aux,"%d",plans[NumFigSel].Material);
			IMatPlaChar[0]=aux[0];
			if(NumCaracters==2)
			  {
			    IMatPlaChar[1]=aux[1];
			  }
			else
			  {
			    IMatPlaChar[1]='V';
			  }
			/////////////////////////////
			//Densitat del pla         //
			/////////////////////////////
			NumCaracters=sprintf(aux,"%f",plans[NumFigSel].LlegirDensitat());
			i=0;
			while(i<MAX_CARACTERS_INTRODUIR)
			  {
			    if(i<NumCaracters)
			      {
				IDensPlaChar[i]=aux[i];
			      }
			    else			//Acaba d'omplir la variable amb 'V'
			      {
				IDensPlaChar[i]='V';
			      }
			    i++;
			  }
			//Omplim ara els zeros de la dreta despres de l'ultim decimal amb 'V' per a que no es mostren al quadre
			i=99;
			while(i>=0)
			  {
			    if(IDensPlaChar[i]=='0' || IDensPlaChar[i]=='V')
			      {
				IDensPlaChar[i]='V';
			      }
			    else{break;}
			    i--;
			  }
			///////////////////////////////
			//Direccio X del pla         //
			///////////////////////////////
			NumCaracters=sprintf(aux,"%f",plans[NumFigSel].Direccio[0]);
			i=0;
			while(i<MAX_CARACTERS_INTRODUIR)
			  {
			    if(i<NumCaracters)
			      {
				IAnglesPlaChar[0][i]=aux[i];
			      }
			    else			//Acaba d'omplir la variable amb 'V'
			      {
				IAnglesPlaChar[0][i]='V';
			      }
			    i++;
			  }
			//Omplim ara els zeros de la dreta despres i sols deixem 5 decimals
			i=99;
			while(i>=5)
			  {
			    IAnglesPlaChar[0][i]='V';
			    i--;
			  }
			///////////////////////////////
			//Direccio Y del pla         //
			///////////////////////////////
			NumCaracters=sprintf(aux,"%f",plans[NumFigSel].Direccio[1]);
			i=0;
			while(i<MAX_CARACTERS_INTRODUIR)
			  {
			    if(i<NumCaracters)
			      {
				IAnglesPlaChar[1][i]=aux[i];
			      }
			    else			//Acaba d'omplir la variable amb 'V'
			      {
				IAnglesPlaChar[1][i]='V';
			      }
			    i++;
			  }
			//Omplim ara els zeros de la dreta despres i sols deixem 5 decimals
			i=99;
			while(i>=5)
			  {
			    IAnglesPlaChar[1][i]='V';
			    i--;
			  }
			////////////////////////////////
			//Direccio Z del pla          //
			////////////////////////////////
			NumCaracters=sprintf(aux,"%f",plans[NumFigSel].Direccio[2]);
			i=0;
			while(i<MAX_CARACTERS_INTRODUIR)
			  {
			    if(i<NumCaracters)
			      {
				IAnglesPlaChar[2][i]=aux[i];
			      }
			    else			//Acaba d'omplir la variable amb 'V'
			      {
				IAnglesPlaChar[2][i]='V';
			      }
			    i++;
			  }
			//Omplim ara els zeros de la dreta despres i sols deixem 5 decimals
			i=99;
			while(i>=5)
			  {
			    IAnglesPlaChar[2][i]='V';
			    i--;
			  }	  
	      
			//Mostrem el menu de nou Pla
	      
			ControlMenu=1;
			ControlSubMenu=4;
			ControlSubSubMenu=1;
	      
		      }
	  
		    //////////////////////////////////////////////////////////////////////////////////////////////////////////
		    ////////////////////////////////////////////SECCIONS D'ESFERA/////////////////////////////////////////////
		    //////////////////////////////////////////////////////////////////////////////////////////////////////////
		    else if(TipusFiguraSel==5)		//Seccions d'esfera
		      {
			//Primer buidarem les variables Char i despres introduirem els valors de la figura
			char aux[100];
			int i=0;
			int NumCaracters=0;			//guarda el nombre de caracters fins al '\0' igualant-lo al sprintf
			///////////////////////////
			//Coordenada X del centre//
			///////////////////////////
			NumCaracters=sprintf(aux,"%f",secEsf[NumFigSel].Centre[0]);
			i=0;
			while(i<MAX_CARACTERS_INTRODUIR)
			  {
			    if(i<NumCaracters)
			      {
				ICentreSecEsfChar[0][i]=aux[i];
			      }
			    else			//Acaba d'omplir la variable amb 'V'
			      {
				ICentreSecEsfChar[0][i]='V';
			      }
			    i++;
			  }
			//Omplim ara els zeros de la dreta despres de l'ultim decimal amb 'V' per a que no es mostren al quadre
			i=99;
			while(i>=0)
			  {
			    if(ICentreSecEsfChar[0][i]=='0' || ICentreSecEsfChar[0][i]=='V')
			      {
				ICentreSecEsfChar[0][i]='V';
			      }
			    else{break;}
			    i--;
			  }
			///////////////////////////
			//Coordenada Y del centre//
			///////////////////////////
			NumCaracters=sprintf(aux,"%f",secEsf[NumFigSel].Centre[1]);
			i=0;
			while(i<MAX_CARACTERS_INTRODUIR)
			  {
			    if(i<NumCaracters)
			      {
				ICentreSecEsfChar[1][i]=aux[i];
			      }
			    else			//Acaba d'omplir la variable amb 'V'
			      {
				ICentreSecEsfChar[1][i]='V';
			      }
			    i++;
			  }
			//Omplim ara els zeros de la dreta despres de l'ultim decimal amb 'V' per a que no es mostren al quadre
			i=99;
			while(i>=0)
			  {
			    if(ICentreSecEsfChar[1][i]=='0' || ICentreSecEsfChar[1][i]=='V')
			      {
				ICentreSecEsfChar[1][i]='V';
			      }
			    else{break;}
			    i--;
			  }	  
			///////////////////////////
			//Coordenada Z del centre//
			///////////////////////////
			NumCaracters=sprintf(aux,"%f",secEsf[NumFigSel].Centre[2]);
			i=0;
			while(i<MAX_CARACTERS_INTRODUIR)
			  {
			    if(i<NumCaracters)
			      {
				ICentreSecEsfChar[2][i]=aux[i];
			      }
			    else			//Acaba d'omplir la variable amb 'V'
			      {
				ICentreSecEsfChar[2][i]='V';
			      }
			    i++;
			  }
			//Omplim ara els zeros de la dreta despres de l'ultim decimal amb 'V' per a que no es mostren al quadre
			i=99;
			while(i>=0)
			  {
			    if(ICentreSecEsfChar[2][i]=='0' || ICentreSecEsfChar[2][i]=='V')
			      {
				ICentreSecEsfChar[2][i]='V';
			      }
			    else{break;}
			    i--;
			  }
			///////////////////////////////////////
			//Dimensió radi de la secció d'esfera//
			///////////////////////////////////////
			NumCaracters=sprintf(aux,"%f",secEsf[NumFigSel].Dimensions[0]);
			i=0;
			while(i<MAX_CARACTERS_INTRODUIR)
			  {
			    if(i<NumCaracters)
			      {
				IDimSecEsfChar[0][i]=aux[i];
			      }
			    else			//Acaba d'omplir la variable amb 'V'
			      {
				IDimSecEsfChar[0][i]='V';
			      }
			    i++;
			  }
			//Omplim ara els zeros de la dreta despres de l'ultim decimal amb 'V' per a que no es mostren al quadre
			i=99;
			while(i>=0)
			  {
			    if(IDimSecEsfChar[0][i]=='0' || IDimSecEsfChar[0][i]=='V')
			      {
				IDimSecEsfChar[0][i]='V';
			      }
			    else{break;}
			    i--;
			  }
			///////////////////////////////////////
			//Altura de tall de la secció d'esfera//
			///////////////////////////////////////
			NumCaracters=sprintf(aux,"%f",secEsf[NumFigSel].Dimensions[1]);
			i=0;
			while(i<MAX_CARACTERS_INTRODUIR)
			  {
			    if(i<NumCaracters)
			      {
				IDimSecEsfChar[1][i]=aux[i];
			      }
			    else			//Acaba d'omplir la variable amb 'V'
			      {
				IDimSecEsfChar[1][i]='V';
			      }
			    i++;
			  }
			//Omplim ara els zeros de la dreta despres de l'ultim decimal amb 'V' per a que no es mostren al quadre
			i=99;
			while(i>=0)
			  {
			    if(IDimSecEsfChar[1][i]=='0' || IDimSecEsfChar[1][i]=='V')
			      {
				IDimSecEsfChar[1][i]='V';
			      }
			    else{break;}
			    i--;
			  }

			///////////////////////////////////
			//Prioritat de la secció d'esfera//
			///////////////////////////////////
			NumCaracters=sprintf(aux,"%d",secEsf[NumFigSel].Prioritat);
			i=0;
			while(i<3)
			  {
			    if(i<NumCaracters)
			      {
				IPrioritatSecEsfChar[i]=aux[i];
			      }
			    else			//Acaba d'omplir la variable amb 'V'
			      {
				IPrioritatSecEsfChar[i]='V';
			      }
			    i++;
			  }
			/////////////////////////////////////////
			//Prioritats dins de la secció d'esfera//
			/////////////////////////////////////////
			i=0;
			int j=0;
			while(i<100)
			  {
			    NumCaracters=sprintf(aux,"%d",secEsf[NumFigSel].PDins[i]);
		
			    j=0;
			    bool XifraNoZero=false;
			    while(j<3)
			      {
				if(j<NumCaracters && (aux[j]!='0' || XifraNoZero==true))		//Tenim compte de que no guarde zeros al vector
				  {
				    DinsSecEsfChar[i][j]=aux[j];
				    XifraNoZero=true;
				  }
				else			//Acaba d'omplir la variable amb 'V'
				  {
				    DinsSecEsfChar[i][j]='V';
				  }
				j++;
			      }
			    i++;
			  }
			//////////////////////////////////
			//Material de la secció d'esfera//
			//////////////////////////////////
			NumCaracters=sprintf(aux,"%d",secEsf[NumFigSel].Material);
			IMatSecEsfChar[0]=aux[0];
			if(NumCaracters==2)
			  {
			    IMatSecEsfChar[1]=aux[1];
			  }
			else
			  {
			    IMatSecEsfChar[1]='V';
			  }
			//////////////////////////////////
			//Densitat de la secció d'esfera//
			//////////////////////////////////
			NumCaracters=sprintf(aux,"%f",secEsf[NumFigSel].LlegirDensitat());
			i=0;
			while(i<MAX_CARACTERS_INTRODUIR)
			  {
			    if(i<NumCaracters)
			      {
				IDensSecEsfChar[i]=aux[i];
			      }
			    else			//Acaba d'omplir la variable amb 'V'
			      {
				IDensSecEsfChar[i]='V';
			      }
			    i++;
			  }
			//Omplim ara els zeros de la dreta despres de l'ultim decimal amb 'V' per a que no es mostren al quadre
			i=99;
			while(i>=0)
			  {
			    if(IDensSecEsfChar[i]=='0' || IDensSecEsfChar[i]=='V')
			      {
				IDensSecEsfChar[i]='V';
			      }
			    else{break;}
			    i--;
			  }
			////////////////////////////////////
			//Direcció X de la secció d'esfera//
			////////////////////////////////////
			NumCaracters=sprintf(aux,"%f",secEsf[NumFigSel].Direccio[0]);
			i=0;
			while(i<MAX_CARACTERS_INTRODUIR)
			  {
			    if(i<NumCaracters)
			      {
				IAnglesSecEsfChar[0][i]=aux[i];
			      }
			    else			//Acaba d'omplir la variable amb 'V'
			      {
				IAnglesSecEsfChar[0][i]='V';
			      }
			    i++;
			  }
			//Omplim ara els zeros de la dreta despres de l'ultim decimal amb 'V' per a que no es mostren al quadre
			i=99;
			while(i>=5)
			  {
			    IAnglesSecEsfChar[0][i]='V';
			    i--;
			  }
			////////////////////////////////////
			//Direcció Y de la secció d'esfera//
			////////////////////////////////////
			NumCaracters=sprintf(aux,"%f",secEsf[NumFigSel].Direccio[1]);
			i=0;
			while(i<MAX_CARACTERS_INTRODUIR)
			  {
			    if(i<NumCaracters)
			      {
				IAnglesSecEsfChar[1][i]=aux[i];
			      }
			    else			//Acaba d'omplir la variable amb 'V'
			      {
				IAnglesSecEsfChar[1][i]='V';
			      }
			    i++;
			  }
			//Omplim ara els zeros de la dreta despres de l'ultim decimal amb 'V' per a que no es mostren al quadre
			i=99;
			while(i>=5)
			  {
			    IAnglesSecEsfChar[1][i]='V';
			    i--;
			  }
			////////////////////////////////////
			//Direcció Z de la secció d'esfera//
			////////////////////////////////////
			NumCaracters=sprintf(aux,"%f",secEsf[NumFigSel].Direccio[2]);
			i=0;
			while(i<MAX_CARACTERS_INTRODUIR)
			  {
			    if(i<NumCaracters)
			      {
				IAnglesSecEsfChar[2][i]=aux[i];
			      }
			    else			//Acaba d'omplir la variable amb 'V'
			      {
				IAnglesSecEsfChar[2][i]='V';
			      }
			    i++;
			  }
			//Omplim ara els zeros de la dreta despres de l'ultim decimal amb 'V' per a que no es mostren al quadre
			i=99;
			while(i>=5)
			  {
			    IAnglesSecEsfChar[2][i]='V';
			    i--;
			  }	  
	      
			//Mostrem el menu de "nou Secció esfera"
	      
			ControlMenu=1;
			ControlSubMenu=5;
			ControlSubSubMenu=1;
	      
		      }	    
		  }
	      }
	    else if(x>OrigenXPantallaMenu+BBorrar.LimitEsquerra && x<OrigenXPantallaMenu+BBorrar.LimitDret && y>OrigenYPantallaMenu-BBorrar.LimitSuperior && y<OrigenYPantallaMenu-BBorrar.LimitInferior)
	      {
		//Busca la figura per a borrar-la//
	  
		//Diguem que hem de tornar a renderitzar les pantalles
		RendFinestraGran=true;
		RendFinestraSup=true;
		RendFinestraInf=true;
	  
		int errors=0;
		int IndexChar=0;
		char Aux[3];
		VoxelsActualitzats=false;
		//Guardem el número de figura//
		while(ISelFigChar[IndexChar]!='V' && IndexChar<3)
		  {
		    Aux[IndexChar]=ISelFigChar[IndexChar];
		    ISelFigChar[IndexChar]='V';
		    IndexChar++;
		  }
		if(IndexChar==0)			//Missatge d'error si no hi ha cap valor guardat
		  {
		    errors++;
		    if(Idioma==0)
		      {
			std::cout<<"It has not entered any value"<<std::endl;
		      }
		    else if(Idioma==1)
		      {
			std::cout<<"No s'ha introduït cap valor"<<std::endl;
		      }
		    else if(Idioma==2)
		      {
			std::cout<<"No se ha introducido ningun valor"<<std::endl;
		      }
		    std::cout<<std::endl;
	    
		  }else
		  {      
		    Aux[IndexChar]='\0';
		    ISelFig=atoi(Aux);
		  }            
		/////////Si no hi ha cap error, busquem el número de la figura entre totes les creades i també borrem les prioritats per a que no estiguen com a gastades//
		if(errors==0)
		  {
		    int j=1;
		    TipusFiguraSel=0;
		    NumFigSel=0;
		    while(j<=NumCubs)				//Mira si és un rectangle i quin és
		      {
			if(rectangles[j].NumeroFigura()==ISelFig)
			  {
			    TipusFiguraSel=1;
			    NumFigSel=j;
			    //Eliminem la seua prioritat del registre i també les prioritats filles//
			    int m=0;
			    while(m<1000)
			      {
				if(rectangles[j].Prioritat==PrioritatsAsignades[0][m])
				  {
				    int n=m;
				    while(n<1000)
				      {
					PrioritatsAsignades[0][n]=PrioritatsAsignades[0][n+1];
					if(PrioritatsAsignades[0][n]==0)
					  {
					    break;
					  }
					n++;
				      }
				    break;
				  }
				m++;
			      }
			    ////////////////////////////Fi de l'eliminacio de les prioritats al registre//////////////
			    break;		  
			  }
			j++;
		      }
		    j=1;      
		    while(j<=NumEsf)				//Mira si és una esfera i quina és
		      {
			if(TipusFiguraSel!=0)
			  {
			    break;
			  }
			if(esferes[j].NumeroFigura()==ISelFig)
			  {
			    TipusFiguraSel=2;
			    NumFigSel=j;
			    //Eliminem la seua prioritat del registre i també les prioritats filles//
			    int m=0;
			    while(m<1000)
			      {
				if(esferes[j].Prioritat==PrioritatsAsignades[0][m])
				  {
				    int n=m;
				    while(n<1000)
				      {
					PrioritatsAsignades[0][n]=PrioritatsAsignades[0][n+1];
					if(PrioritatsAsignades[0][n]==0)
					  {
					    break;
					  }
					n++;
				      }
				    break;
				  }
				m++;
			      }
			    ////////////////////////////Fi de l'eliminacio de les prioritats al registre//////////////		
			    break;
			  }
			j++;
		      }
		    j=1;
		    while(j<=NumCil)				//Mira si és un cilindre i quin és
		      {
			if(TipusFiguraSel!=0)
			  {
			    break;
			  }
			if(cilindres[j].NumeroFigura()==ISelFig)
			  {
			    TipusFiguraSel=3;
			    NumFigSel=j;
			    //Eliminem la seua prioritat del registre i també les prioritats filles//
			    int m=0;
			    while(m<1000)
			      {
				if(cilindres[j].Prioritat==PrioritatsAsignades[0][m])
				  {
				    int n=m;
				    while(n<1000)
				      {
					PrioritatsAsignades[0][n]=PrioritatsAsignades[0][n+1];
					if(PrioritatsAsignades[0][n]==0)
					  {
					    break;
					  }
					n++;
				      }
				    break;
				  }
				m++;
			      }
			    ////////////////////////////Fi de l'eliminacio de les prioritats al registre//////////////		
			    break;
			  }
			j++;
		      }
		    j=1;
		    while(j<=NumPla)				//Mira si és un pla i quin és
		      {
			if(TipusFiguraSel!=0)
			  {
			    break;
			  }
			if(plans[j].NumeroFigura()==ISelFig)
			  {
			    TipusFiguraSel=4;
			    NumFigSel=j;
			    //Eliminem la seua prioritat del registre i també les prioritats filles//
			    int m=0;
			    while(m<1000)
			      {
				if(plans[j].Prioritat==PrioritatsAsignades[0][m])
				  {
				    int n=m;
				    while(n<1000)
				      {
					PrioritatsAsignades[0][n]=PrioritatsAsignades[0][n+1];
					if(PrioritatsAsignades[0][n]==0)
					  {
					    break;
					  }
					n++;
				      }
				    break;
				  }
				m++;
			      }
			    ////////////////////////////Fi de l'eliminacio de les prioritats al registre//////////////		
			    break;
			  }
			j++;
		      }
		    j=1;
		    while(j<=NumSecEsf)				//Mira si és un cilindre i quin és
		      {
			if(TipusFiguraSel!=0)
			  {
			    break;
			  }
			if(secEsf[j].NumeroFigura()==ISelFig)
			  {
			    TipusFiguraSel=5;
			    NumFigSel=j;
			    //Eliminem la seua prioritat del registre i també les prioritats filles//
			    int m=0;
			    while(m<1000)
			      {
				if(secEsf[j].Prioritat==PrioritatsAsignades[0][m])
				  {
				    int n=m;
				    while(n<1000)
				      {
					PrioritatsAsignades[0][n]=PrioritatsAsignades[0][n+1];
					if(PrioritatsAsignades[0][n]==0)
					  {
					    break;
					  }
					n++;
				      }
				    break;
				  }
				m++;
			      }
			    ////////////////////////////Fi de l'eliminacio de les prioritats al registre//////////////		
			    break;
			  }
			j++;
		      }	
		    //Ara segons quina siga borrarem aquesta correrem les posicions del vector de el tipus de figura corresponent
		    if(TipusFiguraSel==0)
		      {
			if(Idioma==0)
			  {
			    std::cout<<"This object does not exist"<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"Aquesta figura no existeix"<<std::endl;
			  }
			else if(Idioma==2)
			  {
			    std::cout<<"Esa figura no existe"<<std::endl;
			  }
			std::cout<<std::endl;
		      }	
		    else if(TipusFiguraSel==1)	//rectangles
		      {
			int i=NumFigSel;
			while(i<MaxCubs)
			  {
			    rectangles[i]=rectangles[i+1];
			    i++;
			  }
			FigBorrades[0]++;
			FigBorrades[FigBorrades[0]]=ISelFig;
			NumCubs--;
			NumFigSel=0;
			ISelFig=0;
		      }
		    else if(TipusFiguraSel==2)	//esferes
		      {
			int i=NumFigSel;
			while(i<MaxEsferes)
			  {
			    esferes[i]=esferes[i+1];
			    i++;
			  }
			FigBorrades[0]++;
			FigBorrades[FigBorrades[0]]=ISelFig;
			NumEsf--;
			NumFigSel=0;
			ISelFig=0;
		      }
		    else if(TipusFiguraSel==3)	//cilindres/cons
		      {
			int i=NumFigSel;
			while(i<MaxCilindres)
			  {
			    cilindres[i]=cilindres[i+1];
			    i++;
			  }
			FigBorrades[0]++;
			FigBorrades[FigBorrades[0]]=ISelFig;
			NumCil--; 
			NumFigSel=0;
			ISelFig=0;
		      }
		    else if(TipusFiguraSel==4)	//plans infinits
		      {
			int i=NumFigSel;
			while(i<MaxPlans)
			  {
			    plans[i]=plans[i+1];
			    i++;
			  }
			FigBorrades[0]++;
			FigBorrades[FigBorrades[0]]=ISelFig;
			NumPla--; 
			NumFigSel=0;
			ISelFig=0;
		      }
		    else if(TipusFiguraSel==5)	//secció d'esfera
		      {
			int i=NumFigSel;
			while(i<MaxSecEsf)
			  {
			    secEsf[i]=secEsf[i+1];
			    i++;
			  }
			FigBorrades[0]++;
			FigBorrades[FigBorrades[0]]=ISelFig;
			NumSecEsf--; 
			NumFigSel=0;
			ISelFig=0;
		      }
	    
		  }
	      }
	  }
	else if(ControlMenu==3)
	  {	  
	    //////////////////////////////////////////////////////////////////////////////////////////////////////
	    /////////////SUBMENU SELECCIONAR COLOR////////////////////////////////////////////////////////////////
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////
	    if(ControlSubMenu==0)
	      {
		if(x>OrigenXPantallaMenu+ColorObjecte.LimitEsquerra && x<OrigenXPantallaMenu+ColorObjecte.LimitDret && y>OrigenYPantallaMenu-ColorObjecte.LimitSuperior && y<OrigenYPantallaMenu-ColorObjecte.LimitInferior)
		  {
		    PintObMat=0;			//Pintara els objectes
		    ControlMenu=3;
		    ControlSubMenu=0;
		    ControlSubSubMenu=0;
		    PintVox=false;
		    PintObjectes=true;
		    //Diguem que hem de tornar a renderitzar les pantalles
		    RendFinestraGran=true;
		    RendFinestraSup=true;
		    RendFinestraInf=true;	  
		  }
		else if(x>OrigenXPantallaMenu+ColorMaterial.LimitEsquerra && x<OrigenXPantallaMenu+ColorMaterial.LimitDret && y>OrigenYPantallaMenu-ColorMaterial.LimitSuperior && y<OrigenYPantallaMenu-ColorMaterial.LimitInferior)
		  {
		    PintObMat=1;			//Pintara els materials
		    ControlMenu=3;
		    ControlSubMenu=0;
		    ControlSubSubMenu=0;
		    PintVox=false;
		    PintObjectes=true;
		    //Diguem que hem de tornar a renderitzar les pantalles
		    RendFinestraGran=true;
		    RendFinestraSup=true;
		    RendFinestraInf=true;
	  
		  }
		else if(x>OrigenXPantallaMenu+ColorPrioritat.LimitEsquerra && x<OrigenXPantallaMenu+ColorPrioritat.LimitDret && y>OrigenYPantallaMenu-ColorPrioritat.LimitSuperior && y<OrigenYPantallaMenu-ColorPrioritat.LimitInferior)
		  {
		    PintObMat=2;			//Pintara les prioritats
		    ControlMenu=3;
		    ControlSubMenu=0;
		    ControlSubSubMenu=0;
		    PintVox=false;
		    PintObjectes=true;
		    //Diguem que hem de tornar a renderitzar les pantalles
		    RendFinestraGran=true;
		    RendFinestraSup=true;
		    RendFinestraInf=true;
	  
		  }    
		else if(x>OrigenXPantallaMenu+ColorOpacitat.LimitEsquerra && x<OrigenXPantallaMenu+ColorOpacitat.LimitDret && y>OrigenYPantallaMenu-ColorOpacitat.LimitSuperior && y<OrigenYPantallaMenu-ColorOpacitat.LimitInferior)
		  {
		    ControlMenu=3;
		    ControlSubMenu=0;
		    ControlSubSubMenu=0;
		    if(OpacitatNormal==1)        //Canvia l'opacitat de les figures
		      {
			OpacitatNormal=0.3;
		      }
		    else
		      {
			OpacitatNormal=1;
		      }
		    //Diguem que hem de tornar a renderitzar les pantalles
		    RendFinestraGran=true;
		    RendFinestraSup=true;
		    RendFinestraInf=true;	  
		  }
	    
	      }
	    else if(ControlSubMenu==1)
	      {
		if(x>OrigenXPantallaMenu+CVoxPunts.LimitEsquerra && x<OrigenXPantallaMenu+CVoxPunts.LimitDret && y>OrigenYPantallaMenu-CVoxPunts.LimitSuperior && y<OrigenYPantallaMenu-CVoxPunts.LimitInferior)
		  {
		    //Pintara punts
		    PintVQuad=false;		//desactivem pintar els voxels com a cubs
		    PintObjectes=false;
		    PintVox=true;
		    CrearLlistaVox=true;	//hem de tornar a crear la llista de Voxels
		    //Diguem que hem de tornar a renderitzar les pantalles
		    RendFinestraGran=true;
		    RendFinestraSup=true;
		    RendFinestraInf=true;
	  
		  }
		else if(x>OrigenXPantallaMenu+CVoxQuad.LimitEsquerra && x<OrigenXPantallaMenu+CVoxQuad.LimitDret && y>OrigenYPantallaMenu-CVoxQuad.LimitSuperior && y<OrigenYPantallaMenu-CVoxQuad.LimitInferior)
		  {
		    PintVQuad=true;		//activem pintar els voxels com a cubs
		    CrearLlistaVox=true;	//hem de tornar a crear la llista de Voxels
		    PintObjectes=false;
		    PintVox=true;
		    //Diguem que hem de tornar a renderitzar les pantalles
		    RendFinestraGran=true;
		    RendFinestraSup=true;
		    RendFinestraInf=true;
	  
		  }
		else if(x>OrigenXPantallaMenu+CVoxPla[0].LimitEsquerra && x<OrigenXPantallaMenu+CVoxPla[0].LimitDret && y>OrigenYPantallaMenu-CVoxPla[0].LimitSuperior && y<OrigenYPantallaMenu-CVoxPla[0].LimitInferior)
		  {
		    ControlSubSubMenu=1;			//Pla X
		  }
		else if(x>OrigenXPantallaMenu+CVoxPla[1].LimitEsquerra && x<OrigenXPantallaMenu+CVoxPla[1].LimitDret && y>OrigenYPantallaMenu-CVoxPla[1].LimitSuperior && y<OrigenYPantallaMenu-CVoxPla[1].LimitInferior)
		  {
		    ControlSubSubMenu=2;			//Pla Y
		  }
		else if(x>OrigenXPantallaMenu+CVoxPla[2].LimitEsquerra && x<OrigenXPantallaMenu+CVoxPla[2].LimitDret && y>OrigenYPantallaMenu-CVoxPla[2].LimitSuperior && y<OrigenYPantallaMenu-CVoxPla[2].LimitInferior)
		  {
		    ControlSubSubMenu=3;			//Pla Z
		  }
		else if(x>OrigenXPantallaMenu+Crear.LimitEsquerra && x<OrigenXPantallaMenu+Crear.LimitDret && y>OrigenYPantallaMenu-Crear.LimitSuperior && y<OrigenYPantallaMenu-Crear.LimitInferior)
		  {
		    //Guardar els plans
		    CrearLlistaVox=true;	//hem de tornar a crear la llista de Voxels
		    CrearLlistaMallat=true;
		    PintVox=true;
		    PintObjectes=false;
		    //Diguem que hem de tornar a renderitzar les pantalles
		    RendFinestraGran=true;
		    RendFinestraSup=true;
		    RendFinestraInf=true;
	  
		    char Aux[101];		//Posem dimensio 101 per a que sempre capiga el '\0' inclus si el CubChar te 100 caràcters
		    int IndexChar=0;
		    //Guardem el Pla X//
		    while(IPlansTallChar[0][IndexChar]!='V' && IndexChar<3)
		      {
			Aux[IndexChar]=IPlansTallChar[0][IndexChar];
			IndexChar++;
		      }
		    if(IndexChar==0)			//Agafara tot l'eix si no hi ha cap valor guardat
		      {
			PlansTall[0]=DimEspai[0];
		      }else
		      {
			Aux[IndexChar]='\0';
			PlansTall[0]=atof(Aux);
			if(PlansTall[0]==0)
			  {
			    PlansTall[0]=DimEspai[0];
			  }      
	    
		      }

		    IndexChar=0;
		    //Guardem el Pla Y//
		    while(IPlansTallChar[1][IndexChar]!='V' && IndexChar<3)
		      {
			Aux[IndexChar]=IPlansTallChar[1][IndexChar];
			IndexChar++;
		      }
		    if(IndexChar==0)			//Agafara tot l'eix si no hi ha cap valor guardat
		      {
			PlansTall[1]=DimEspai[1];
		      }else
		      {      
			Aux[IndexChar]='\0';
			PlansTall[1]=atof(Aux);
			if(PlansTall[1]==0)
			  {
			    PlansTall[1]=DimEspai[1];
			  }      
	    
		      }     
	  
		    IndexChar=0;
		    //Guardem el Pla Z//
		    while(IPlansTallChar[2][IndexChar]!='V' && IndexChar<3)
		      {
			Aux[IndexChar]=IPlansTallChar[2][IndexChar];
			IndexChar++;
		      }
		    if(IndexChar==0)			//Agafara tot l'eix si no hi ha cap valor guardat
		      {
			PlansTall[2]=DimEspai[2];
		      }else
		      {      
			Aux[IndexChar]='\0';
			PlansTall[2]=atof(Aux);
			if(PlansTall[2]==0)
			  {
			    PlansTall[2]=DimEspai[2];
			  }
		      }
		    IndexChar=0;
	  
	  
		  }    
	      }
	  }
	else if(ControlMenu==4)
	  {
	    if(ControlSubMenu==0)
	      {
		if(x>OrigenXPantallaMenu+BGuardarGeo.LimitEsquerra && x<OrigenXPantallaMenu+BGuardarGeo.LimitDret && y>OrigenYPantallaMenu-BGuardarGeo.LimitSuperior && y<OrigenYPantallaMenu-BGuardarGeo.LimitInferior)
		  {
		    ControlSubMenu=1;			//Guardar Geometria
		    ControlSubSubMenu=1;
		    glutSetWindow(IdeFinestres[1]);
		    glutShowWindow();
		  }
		else if(x>OrigenXPantallaMenu+BGuardarPenelope.LimitEsquerra && x<OrigenXPantallaMenu+BGuardarPenelope.LimitDret && y>OrigenYPantallaMenu-BGuardarPenelope.LimitSuperior && y<OrigenYPantallaMenu-BGuardarPenelope.LimitInferior)
		  {
		    ControlSubMenu=2;			//Guardar Geometria penelope
		    ControlSubSubMenu=1;
		    glutSetWindow(IdeFinestres[1]);
		    glutShowWindow();
		  }
		else if(x>OrigenXPantallaMenu+BGuardarGeant4.LimitEsquerra && x<OrigenXPantallaMenu+BGuardarGeant4.LimitDret && y>OrigenYPantallaMenu-BGuardarGeant4.LimitSuperior && y<OrigenYPantallaMenu-BGuardarGeant4.LimitInferior)
		  {
		    ControlSubMenu=4;			//Guardar Geometria penelope
		    ControlSubSubMenu=1;
		    glutSetWindow(IdeFinestres[1]);
		    glutShowWindow();
		  }
		
	      }
	  }
	else if(ControlMenu==8)
	  {
	    if(x>OrigenXPantallaMenu+BGuardarVoxelsPene.LimitEsquerra && x<OrigenXPantallaMenu+BGuardarVoxelsPene.LimitDret && y>OrigenYPantallaMenu-BGuardarVoxelsPene.LimitSuperior && y<OrigenYPantallaMenu-BGuardarVoxelsPene.LimitInferior)
	      {
		ControlMenu=4;
		ControlSubMenu=3;			//Guardar Voxels Penelope
		ControlSubSubMenu=1;
		glutSetWindow(IdeFinestres[1]);
		glutShowWindow();
	      }
	  }
	else if(ControlMenu==6)
	  {	
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////
	    /////////////SUBMENU CANVIAR ESPAI/////////////////////////////////////////////////////////////////////
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////
	    if(x>OrigenXPantallaMenu+BNumVox[0].LimitEsquerra && x<OrigenXPantallaMenu+BNumVox[0].LimitDret && y>OrigenYPantallaMenu-BNumVox[0].LimitSuperior && y<OrigenYPantallaMenu-BNumVox[0].LimitInferior)
	      {
		ControlSubMenu=1;			//Voxels eix X
		ControlSubSubMenu=0;
	      }
	    else if(x>OrigenXPantallaMenu+BNumVox[1].LimitEsquerra && x<OrigenXPantallaMenu+BNumVox[1].LimitDret && y>OrigenYPantallaMenu-BNumVox[1].LimitSuperior && y<OrigenYPantallaMenu-BNumVox[1].LimitInferior)
	      {
		ControlSubMenu=2;			//Voxels eix Y
		ControlSubSubMenu=0;
	      }
	    else if(x>OrigenXPantallaMenu+BNumVox[2].LimitEsquerra && x<OrigenXPantallaMenu+BNumVox[2].LimitDret && y>OrigenYPantallaMenu-BNumVox[2].LimitSuperior && y<OrigenYPantallaMenu-BNumVox[2].LimitInferior)
	      {
		ControlSubMenu=3;			//Voxels eix Z
		ControlSubSubMenu=0;
	      }
      
	    else if(x>OrigenXPantallaMenu+BDimVox[0].LimitEsquerra && x<OrigenXPantallaMenu+BDimVox[0].LimitDret && y>OrigenYPantallaMenu-BDimVox[0].LimitSuperior && y<OrigenYPantallaMenu-BDimVox[0].LimitInferior)
	      {
		ControlSubMenu=4;			//DimensioX
		ControlSubSubMenu=0;
	      }
	    else if(x>OrigenXPantallaMenu+BDimVox[1].LimitEsquerra && x<OrigenXPantallaMenu+BDimVox[1].LimitDret && y>OrigenYPantallaMenu-BDimVox[1].LimitSuperior && y<OrigenYPantallaMenu-BDimVox[1].LimitInferior)
	      {
		ControlSubMenu=5;			//DimensioY
		ControlSubSubMenu=0;
	      }
	    else if(x>OrigenXPantallaMenu+BDimVox[2].LimitEsquerra && x<OrigenXPantallaMenu+BDimVox[2].LimitDret && y>OrigenYPantallaMenu-BDimVox[2].LimitSuperior && y<OrigenYPantallaMenu-BDimVox[2].LimitInferior)
	      {
		ControlSubMenu=6;			//DimensioZ
		ControlSubSubMenu=0;
	      }     
	    else if(x>OrigenXPantallaMenu+Crear.LimitEsquerra && x<OrigenXPantallaMenu+Crear.LimitDret && y>OrigenYPantallaMenu-Crear.LimitSuperior && y<OrigenYPantallaMenu-Crear.LimitInferior)
	      { 
		//Guarda l'espai///
		//Diguem que hem de tornar a renderitzar les pantalles
		RendFinestraGran=true;
		RendFinestraSup=true;
		RendFinestraInf=true;
	  
		int errors=0;			//Controla el nombre d'errors//
		char Aux[101];		//Posem dimensio 101 per a que sempre capiga el '\0' inclus si el CubChar te 100 caràcters
		int IndexChar=0;
		//Guardem el nombre de voxels a l'eix X//
		while(INumVoxChar[0][IndexChar]!='V' && IndexChar<3)
		  {
		    Aux[IndexChar]=INumVoxChar[0][IndexChar];
		    IndexChar++;
		  }
		if(IndexChar==0)			//Missatge d'error si no hi ha cap valor guardat
		  {
		    errors++;
		    if(Idioma==0)
		      {
			std::cout<<"Missing the number of voxels in the X coordinate"<<std::endl;
		      }
		    else if(Idioma==1)
		      {
			std::cout<<"Falta el nombre de voxels a l'eix X"<<std::endl;
		      }
		    else if(Idioma==2)
		      {
			std::cout<<"Falta el numero de voxeles en la coordenada X"<<std::endl;
		      }
		  }else
		  {
		    Aux[IndexChar]='\0';
		    INumVox[0]=atoi(Aux);
		  }

		IndexChar=0;
		//Guardem el nombre de voxels a l'eix Y//
		while(INumVoxChar[1][IndexChar]!='V' && IndexChar<3)
		  {
		    Aux[IndexChar]=INumVoxChar[1][IndexChar];
		    IndexChar++;
		  }
		if(IndexChar==0)			//Missatge d'error si no hi ha cap valor guardat
		  {
		    errors++;
		    if(Idioma==0)
		      {
			std::cout<<"Missing the number of voxels in the Y coordinate"<<std::endl;
		      }
		    else if(Idioma==1)
		      {
			std::cout<<"Falta el nombre de voxels a l'eix Y"<<std::endl;
		      }
		    else if(Idioma==2)
		      {
			std::cout<<"Falta el numero de voxeles en la coordenada Y"<<std::endl;
		      }
	    
		  }else
		  {      
		    Aux[IndexChar]='\0';
		    INumVox[1]=atoi(Aux);
		  }     
	  
		IndexChar=0;
		//Guardem el nombre de voxels a l'eix Z//
		while(INumVoxChar[2][IndexChar]!='V' && IndexChar<3)
		  {
		    Aux[IndexChar]=INumVoxChar[2][IndexChar];
		    IndexChar++;
		  }
		if(IndexChar==0)			//Missatge d'error si no hi ha cap valor guardat
		  {
		    errors++;
		    if(Idioma==0)
		      {
			std::cout<<"Missing the number of voxels in the Z coordinate"<<std::endl;
		      }
		    else if(Idioma==1)
		      {
			std::cout<<"Falta el nombre de voxels a l'eix Z"<<std::endl;
		      }
		    else if(Idioma==2)
		      {
			std::cout<<"Falta el numero de voxeles en la coordenada Z"<<std::endl;
		      }
	    
		  }else
		  {      
		    Aux[IndexChar]='\0';
		    INumVox[2]=atoi(Aux);
		  }
		IndexChar=0;
	  
	  
		//Guardem la dimensio X del voxel//
		while(IDimVoxChar[0][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)
		  {
		    Aux[IndexChar]=IDimVoxChar[0][IndexChar];
		    IndexChar++;
		  }
		if(IndexChar==0)			//Missatge d'error si no hi ha cap valor guardat
		  {
		    errors++;
		    if(Idioma==0)
		      {
			std::cout<<"Missing dimension X"<<std::endl;
		      }
		    else if(Idioma==1)
		      {
			std::cout<<"Falta la dimensió X"<<std::endl;
		      }
		    else if(Idioma==2)
		      {
			std::cout<<"Falta la dimensión X"<<std::endl;
		      }	
	    
		  }else
		  {      
		    Aux[IndexChar]='\0';
		    IDimVox[0]=atof(Aux);
		  }

		IndexChar=0;


		//Guardem la dimensio Y del voxel//
		while(IDimVoxChar[1][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)
		  {
		    Aux[IndexChar]=IDimVoxChar[1][IndexChar];
		    IndexChar++;
		  }
		if(IndexChar==0)			//Missatge d'error si no hi ha cap valor guardat
		  {
		    errors++;	    
		    if(Idioma==0)
		      {
			std::cout<<"Missing dimension Y"<<std::endl;
		      }
		    else if(Idioma==1)
		      {
			std::cout<<"Falta la dimensió Y"<<std::endl;
		      }
		    else if(Idioma==2)
		      {
			std::cout<<"Falta la dimensión Y"<<std::endl;
		      }
	    
		  }else
		  {            
		    Aux[IndexChar]='\0';
		    IDimVox[1]=atof(Aux);
		  }
		IndexChar=0;
	  
	  
		//Guardem la dimensio Z del voxel//
		while(IDimVoxChar[2][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)
		  {
		    Aux[IndexChar]=IDimVoxChar[2][IndexChar];
		    IndexChar++;
		  }
		if(IndexChar==0)			//Missatge d'error si no hi ha cap valor guardat
		  {
		    errors++;
		    if(Idioma==0)
		      {
			std::cout<<"Missing dimension Z"<<std::endl;
		      }
		    else if(Idioma==1)
		      {
			std::cout<<"Falta la dimensió Z"<<std::endl;
		      }
		    else if(Idioma==2)
		      {
			std::cout<<"Falta la dimensión Z"<<std::endl;
		      }
	    
		  }else
		  {      
		    Aux[IndexChar]='\0';
		    IDimVox[2]=atof(Aux);
		  }
		IndexChar=0;      
	  
		if(errors==0)
		  {
		    VoxelsActualitzats=false;
		    ControlMenu=0;
		    ControlSubMenu=0;
		    ControlSubSubMenu=0;
		    NumVoxels[0]=INumVox[0];
		    NumVoxels[1]=INumVox[1];
		    NumVoxels[2]=INumVox[2];
	    
		    //Abans aquesta funcio guardava les dimensions dels voxels, pero per comoditat
		    //ho canviem a que guarde la dimensio total de l'espai i ara calcularem la dimensio dels voxels
		    DimEspai[0]=IDimVox[0];
		    DimEspai[1]=IDimVox[1];
		    DimEspai[2]=IDimVox[2];
	    
		    int t=0;
		    while(t<3)
		      {
			INumVox[t]=0;
			IDimVox[t]=0;
			t++;
		      }
		    //Reajustem la càmera//
		    X=0;
		    Y=0;
		    Z=0;
		    X1=0;
		    Y1=0;
		    Y2=0;
		    X2=0;
		    Y2=0;
		    Z2=0;
      
		    DimVoxels[0]=float(DimEspai[0]/NumVoxels[0]);
		    DimVoxels[1]=float(DimEspai[1]/NumVoxels[1]);
		    DimVoxels[2]=float(DimEspai[2]/NumVoxels[2]);
		    //Ajustem els plans de tall en la representacio de voxels
		    PlansTall[0]=DimEspai[0];
		    PlansTall[1]=DimEspai[1];
		    PlansTall[2]=DimEspai[2];
		    //Reconstruim la matriu de voxels per a que tinga les dimensions del nou espai//
		    ConstruirMatriuVoxels(NumVoxels[0],NumVoxels[1],NumVoxels[2]);
		    
		    glMatrixMode(GL_MODELVIEW);			//S'encarrega de moure i transformar l'espai (Les coordenades de l'espai)
		    glLoadIdentity();
		    gluLookAt(DimEspai[0]+DimEspai[1]+DimEspai[2],DimEspai[1]/2.0,DimEspai[2]/2.0,DimEspai[0]/2.0,DimEspai[1]/2.0,DimEspai[2]/2.0,0.0,0.0,1.0);		//fixem la camera i el punt on mira
	    
	    
		  }else
		  {

		    if(Idioma==0)
		      {
			std::cout<<"Has not changed the space"<<std::endl;
		      }
		    else if(Idioma==1)
		      {
			std::cout<<"No s'ha canviat l'espai"<<std::endl;
		      }
		    else if(Idioma==2)
		      {
			std::cout<<"No se ha cambiado el espacio"<<std::endl;
		      }
	    
		  }
	  
	      }
	  }
	else if(ControlMenu==7)
	  {
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////
	    /////////////SUBMENU SIMULACIO/////////////////////////////////////////////////////////////////////////
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////
	    if(x>OrigenXPantallaMenu+BNomSimulacio.LimitEsquerra && x<OrigenXPantallaMenu+BNomSimulacio.LimitDret && y>OrigenYPantallaMenu-BNomSimulacio.LimitSuperior && y<OrigenYPantallaMenu-BNomSimulacio.LimitInferior)
	      {
		ControlSubMenu=1;			//Nom de la simulacio
		ControlSubSubMenu=0;
	      }
	    else if(x>OrigenXPantallaMenu+BNomArxiuConfig.LimitEsquerra && x<OrigenXPantallaMenu+BNomArxiuConfig.LimitDret && y>OrigenYPantallaMenu-BNomArxiuConfig.LimitSuperior && y<OrigenYPantallaMenu-BNomArxiuConfig.LimitInferior)
	      {
		ControlSubMenu=2;			//no de l'arxiu de configuració
		ControlSubSubMenu=0;
	      }
	    else if(x>OrigenXPantallaMenu+BNomArxiuGeoQuad.LimitEsquerra && x<OrigenXPantallaMenu+BNomArxiuGeoQuad.LimitDret && y>OrigenYPantallaMenu-BNomArxiuGeoQuad.LimitSuperior && y<OrigenYPantallaMenu-BNomArxiuGeoQuad.LimitInferior)
	      {
		ControlSubMenu=3;			//Geometria (Quadrigues)
		ControlSubSubMenu=0;
	      }
	    else if(x>OrigenXPantallaMenu+BNomArxiuGeoVox.LimitEsquerra && x<OrigenXPantallaMenu+BNomArxiuGeoVox.LimitDret && y>OrigenYPantallaMenu-BNomArxiuGeoVox.LimitSuperior && y<OrigenYPantallaMenu-BNomArxiuGeoVox.LimitInferior)
	      {
		ControlSubMenu=4;			//Voxelitzat
		ControlSubSubMenu=0;
	      }
	    else if(x>OrigenXPantallaMenu+BNumSimulacions.LimitEsquerra && x<OrigenXPantallaMenu+BNumSimulacions.LimitDret && y>OrigenYPantallaMenu-BNumSimulacions.LimitSuperior && y<OrigenYPantallaMenu-BNumSimulacions.LimitInferior)
	      {
		ControlSubMenu=5;			//NumSimulacions
		ControlSubSubMenu=0;
	      }    
	    else if(x>OrigenXPantallaMenu+Crear.LimitEsquerra && x<OrigenXPantallaMenu+Crear.LimitDret && y>OrigenYPantallaMenu-Crear.LimitSuperior && y<OrigenYPantallaMenu-Crear.LimitInferior)
	      {
		//Arranca la simulacio
	  
		if(INomSimulacio[0]!='\0')
		  {
		    if(INomArxiuConfig[0]!='\0')
		      {
			if(INomArxiuGeoQuad[0]!='\0' || INomArxiuGeoVox[0]!='\0')
			  {
			    if(INumSimulacions[0]!='V')
			      {
				DIR *DirectoriAux;
				ControlMenu=0;
				ControlSubMenu=0;
				ControlSubSubMenu=0;
				int error=0;				//Controla si hi ha algun error
				int i=0;
				NomSimulacio.clear();			//Netegem la variable amb el nom de la simulacio
				while(INomSimulacio[i]!='\0')
				  {
				    NomSimulacio+=INomSimulacio[i];
				    i++;
				  }
				DirectoriAux=opendir(NomSimulacio.c_str());
				if(DirectoriAux==NULL)	//Comrpovem si ja existeix una simulacio amb aquest nom
				  {
				    //si no està creada tornarà NULL i la creem
				    mkdir(NomSimulacio.c_str(),0744);		//el segon argument són els permisos del directori
				  }
				else	//Si la carpeta esta creada la borrem
				  {
				    std::string AuxString="rm -r ./"+NomSimulacio;
				    system(AuxString.c_str());		//Borrem de forma garrula
				    mkdir(NomSimulacio.c_str(),0744);		//Creem la carpeta, el segon argument són els permisos del directori
				  }
				closedir(DirectoriAux);
		      
				////////////////////////////////////////////////////////////////////////////////////
				//Comrpovem ara si l'arxiu de configuració es troba a la carpeta de configuracions//
				////////////////////////////////////////////////////////////////////////////////////
				//Omplim la variable NomArxiuConfig// 
			
				i=0;
				NomArxiuConfig.clear();			//Netegem la variable amb el nom de la simulacio i l'omplim
				while(INomArxiuConfig[i]!='\0')
				  {
				    NomArxiuConfig+=INomArxiuConfig[i];
				    i++;
				  }
			  
				std::string AuxString;	//String que usarem per a escriure per pantalla
				char AuxChar[200];		//Char on guardarem els noms dels arxius per a pasar-los al string
				dirent *data;		//Variable dela clase "dirent" que emmagatzema informació del directori
				//Obrim el directori 
				DirectoriAux=opendir("ConfiguracionsPenelope");		//Obrim el directori 
				bool Trobat=false;					//Variable que determinara si hem em trobat l'arxiu amb aquest nom
				if(DirectoriAux==NULL)	//Comprovem que s'ha obert correctament
				  {
				    error++;
				    if(Idioma==0)
				      {
					std::cout<<"Can not find the folder with the configuration file, restart the program"<<std::endl;
				      }
				    else if(Idioma==1)
				      {
					std::cout<<"No existeix la carpeta amb les configuracions, reinicia el programa"<<std::endl;
				      }
				    else if(Idioma==2)
				      { 
					std::cout<<"No existe la carpeta con las configuraciones, reinicia el programa"<<std::endl;
				      }
			
				  }
				else
				  {
				    while((data=readdir(DirectoriAux))!=NULL)		//llegim el directori guardant la informació de un dels arxius en cada cicle
				      {
					sprintf(AuxChar,"%s",data->d_name);	//Guardem el nom de l'arxiu (d_name) en AuxChar i el nombre de caracters

					if(AuxChar[0]!='.')				//No mirem els arxiu ocults (.Nom)
					  {
					    AuxString=AuxChar;
					    if(AuxString==NomArxiuConfig)			//Comprovem si es l'arxiu que estem buscant i si ho es parem la busqueda
					      {
						Trobat=true;
						AuxString.clear();
						break;
					      }
					  }
					AuxString.clear();				//netegem el string
				      }
				    if(Trobat==false)
				      {
					error++;
					if(Idioma==0)
					  {
					    std::cout<<"It has not found the configuration file"<<std::endl;
					  }
					else if(Idioma==1)
					  {
					    std::cout<<"No s'ha trobat l'arxiu de configuració"<<std::endl;
					  }
					else if(Idioma==2)
					  {
					    std::cout<<"No se ha encontrado el fichero de configuración"<<std::endl;
					  }
				      }
				    closedir(DirectoriAux);
				  }
				//Si s'ha trobat i per tant no hi ha errors copiem l'arxiu a la carpeta de simulació i continuem
				if(error==0)
				  {
				    AuxString="cp ./ConfiguracionsPenelope/"+NomArxiuConfig+" ./"+NomSimulacio+"/config.in";
				    system(AuxString.c_str());
			
				    /////////////////////////////////////////////////////////////////////////////
				    ////////////////Busquem ara els arxius amb les geometries////////////////////
				    /////////////////////////////////////////////////////////////////////////////
				    if(INomArxiuGeoQuad[0]!='\0')
				      {
					i=0;
					NomArxiuGeoQuad.clear();			//Netegem la variable amb el nom de la geometria i l'omplim
					while(INomArxiuGeoQuad[i]!='\0')
					  {
					    NomArxiuGeoQuad+=INomArxiuGeoQuad[i];
					    i++;
					  }
					//Obrim el directori 
					DirectoriAux=opendir("GeometriesPenelope");		//Obrim el directori
					if(DirectoriAux==NULL)
					  {
					    error++;
					    if(Idioma==0)
					      {
						std::cout<<"There is no folder with the geometries, restart the program"<<std::endl;
					      }
					    else if(Idioma==1)
					      {
						std::cout<<"No existeix la carpeta amb les geometries, reinicia el programa"<<std::endl;
					      }
					    else if(Idioma==2)
					      {
						std::cout<<"No existe la carpeta con las geometrias, reinicia el programa"<<std::endl;
					      }
			      
					  }
					else
					  {
					    AuxString.clear();
					    Trobat=false;					//Variable que determinara si hem em trobat l'arxiu amb aquest nom
					    while((data=readdir(DirectoriAux))!=NULL)		//llegim el directori guardant la informació de un dels arxius en cada cicle
					      {
						sprintf(AuxChar,"%s",data->d_name);	//Guardem el nom de l'arxiu (d_name) en AuxChar i el nombre de caracters

						if(AuxChar[0]!='.')				//No mirem els arxiu ocults (.Nom)
						  {
						    AuxString=AuxChar;
						    if(AuxString==NomArxiuGeoQuad)			//Comprovem si es l'arxiu que estem buscant i si ho es parem la busqueda
						      {
							Trobat=true;
							AuxString.clear();
							break;
						      }
						  }
						AuxString.clear();				//netegem el string
					      }
					    if(Trobat==false)
					      {
						error++;
						if(Idioma==0)
						  {
						    std::cout<<"Could not find the file with geometry"<<std::endl;
						  }
						else if(Idioma==1)
						  {
						    std::cout<<"No s'ha trobat el fitxer amb la geometria"<<std::endl;
						  }
						else if(Idioma==2)
						  {
						    std::cout<<"No se ha encontrado el fichero con la geometria"<<std::endl;
						  }
					      }
					    closedir(DirectoriAux);
					  }
					//si no hi ha erros copiem la geometria i continuem
					if(error==0)
					  {
					    AuxString="cp ./GeometriesPenelope/"+NomArxiuGeoQuad+" ./"+NomSimulacio+"/";
					    system(AuxString.c_str());
					  } 
				      }
				    /////////////////////////////////////////////////////////////////////////////
				    ////////////////Busquem ara els arxius amb el voxelitzat/////////////////////
				    /////////////////////////////////////////////////////////////////////////////
				    if(INomArxiuGeoVox[0]!='\0')
				      {
					i=0;
					NomArxiuGeoVox.clear();			//Netegem la variable amb el nom del voxelitzat i l'omplim
					while(INomArxiuGeoVox[i]!='\0')
					  {
					    NomArxiuGeoVox+=INomArxiuGeoVox[i];
					    i++;
					  }
					//Obrim el directori 
					DirectoriAux=opendir("VoxelsPenelope");		//Obrim el directori
					if(DirectoriAux==NULL)
					  {
					    error++;
					    if(Idioma==0)
					      {
						std::cout<<"There is no folder with voxelized, restart the program"<<std::endl;
					      }
					    else if(Idioma==1)
					      {
						std::cout<<"No existeix la carpeta amb els voxelitzats, reinicia el programa"<<std::endl;
					      }
					    else if(Idioma==2)
					      {
						std::cout<<"No existe la carpeta con los voxelizados, reinicia el programa"<<std::endl;
					      }
			      
					  }
					else
					  {
					    AuxString.clear();
					    Trobat=false;					//Variable que determinara si hem em trobat l'arxiu amb aquest nom
					    while((data=readdir(DirectoriAux))!=NULL)		//llegim el directori guardant la informació de un dels arxius en cada cicle
					      {
						sprintf(AuxChar,"%s",data->d_name);	//Guardem el nom de l'arxiu (d_name) en AuxChar i el nombre de caracters

						if(AuxChar[0]!='.')				//No mirem els arxiu ocults (.Nom)
						  {
						    AuxString=AuxChar;
						    if(AuxString==NomArxiuGeoVox)			//Comprovem si es l'arxiu que estem buscant i si ho es parem la busqueda
						      {
							Trobat=true;
							AuxString.clear();
							break;
						      }
						  }
						AuxString.clear();				//netegem el string
					      }
					    if(Trobat==false)
					      {
						error++;
						if(Idioma==0)
						  {
						    std::cout<<"Could not find the file with the voxelized"<<std::endl;
						  }
						else if(Idioma==1)
						  {
						    std::cout<<"No s'ha trobat l'arxiu amb el voxelitzat"<<std::endl;
						  }
						else if(Idioma==2)
						  {
						    std::cout<<"No se ha encontrado el fichero con el voxelizado"<<std::endl;
						  }
					      }
					    closedir(DirectoriAux);
					  }
					//si no hi ha erros copiem la geometria i continuem
					if(error==0)
					  {
					    AuxString="cp ./VoxelsPenelope/"+NomArxiuGeoVox+" ./"+NomSimulacio+"/";
					    system(AuxString.c_str());
					  } 
				      }
				    /////////////////////////////////////////////////////////////////////////////////
				    //Si no trobem errors copiem els arxius de materials a la carpeta de simulacio///
				    /////////////////////////////////////////////////////////////////////////////////
				    if(error==0)
				      {
					//Obrim el directori 
					DirectoriAux=opendir("MaterialsPenelope");		//Obrim el directori
					if(DirectoriAux==NULL)
					  {
					    error++;
					    if(Idioma==0)
					      {
						std::cout<<"There is no folder with materials, restart the program"<<std::endl;
					      }
					    else if(Idioma==1)
					      {
						std::cout<<"No existeix la carpeta amb els materials, reinicia el programa"<<std::endl;
					      }
					    else if(Idioma==2)
					      {
						std::cout<<"No existe la carpeta con los materiales, reinicia el programa"<<std::endl;
					      }
					  }
					else
					  {
					    AuxString.clear();
					    Trobat=false;					//Variable que determinara si hem em trobat l'arxiu amb aquest nom
					    while((data=readdir(DirectoriAux))!=NULL)		//llegim el directori guardant la informació de un dels arxius en cada cicle
					      {
						sprintf(AuxChar,"%s",data->d_name);	//Guardem el nom de l'arxiu (d_name) en AuxChar i el nombre de caracters

						if(AuxChar[0]!='.')				//No mirem els arxiu ocults (.Nom)
						  {
						    AuxString=AuxChar;

						    AuxString="cp ./MaterialsPenelope/"+AuxString+" ./"+NomSimulacio+"/";
						    system(AuxString.c_str());
							      
						  }
						AuxString.clear();				//netegem el string
					      }

					    closedir(DirectoriAux);
					  }
					/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
					//Copiem ara el penelope compilat a la carpeta de la simulacio. Aquest es troba a una carpeta anomenada Penelope i ha de dir-se penelope//
					/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
					if(error==0)
					  {
					    //Obrim el directori 
					    DirectoriAux=opendir("Penelope");		//Obrim el directori
					    if(DirectoriAux==NULL)
					      {
						error++;
						if(Idioma==0)
						  {
						    std::cout<<"There is no Penelope folder, restart the program and copy penelope compiled to this folder. It should be called ''penelope''"<<std::endl;
						  }
						else if(Idioma==1)
						  {
						    std::cout<<"No existeix la carpeta Penelope, reinicia el programa i copia el penelope compilat a aquesta carpeta. Ha de tindre el nom ''penelope''"<<std::endl;
						  }
						else if(Idioma==2)
						  {
						    std::cout<<"No existe la carpeta Penelope, reinicia el programa y copia el penelope compilado a esta carpeta. Debe llamarse ''penelope''"<<std::endl;
						  }
					      }
					    else
					      {
						AuxString.clear();
						Trobat=false;					//Variable que determinara si hem em trobat l'arxiu amb aquest nom
						bool Trobat2=false;
						while((data=readdir(DirectoriAux))!=NULL)		//llegim el directori guardant la informació de un dels arxius en cada cicle
						  {
						    sprintf(AuxChar,"%s",data->d_name);	//Guardem el nom de l'arxiu (d_name) en AuxChar i el nombre de caracters

						    if(AuxChar[0]!='.')				//No mirem els arxiu ocults (.Nom)
						      {
							AuxString=AuxChar;
							
							if(AuxString=="penelope")
							  {
							    AuxString="cp ./Penelope/"+AuxString+" ./"+NomSimulacio+"/";
							    system(AuxString.c_str());
							    AuxString.clear();
							    Trobat=true;
							  }
							if(AuxString=="arranc.sh")
							  {
							    AuxString="cp ./Penelope/"+AuxString+" ./"+NomSimulacio+"/";
							    system(AuxString.c_str());
							    AuxString.clear();
							    Trobat2=true;
							  }
							if(AuxString=="unir")
							  {
							    AuxString="cp ./Penelope/"+AuxString+" ./"+NomSimulacio+"/";
							    system(AuxString.c_str());
							    AuxString.clear();
							  }				      
								  
						      }
						    AuxString.clear();				//netegem el string
						  }
						closedir(DirectoriAux);
						if(Trobat==false || Trobat2==false)
						  {
						    error++;
						    if(Idioma==0)
						      {
							std::cout<<"Could not find the executable penelope or arranque.sh, be sure that these are in the Penelope folder and is called 'penelope' and 'arranc.sh' "<<std::endl;
						      }
						    else if(Idioma==1)
						      {
							std::cout<<"No s'ha trobat l'executable del penelope o arranc.sh, asegurat que estan a la carpeta Penelope i que es diu 'penelope' i 'arranc.sh'"<<std::endl;
						      }
						    else if(Idioma==2)
						      {
							std::cout<<"No se ha encontrado el ejecutable del penelope o arranc.sh, asegurate que están en la carpeta Penelope y que es llaman 'penelope' y 'arranc.sh'"<<std::endl;
						      }
						  }
						/////////////////////////////////////////////////////////////////////////////////
						//Si no tenim errors pasem a crear les carpetes amb les simulacions simultanies//
						/////////////////////////////////////////////////////////////////////////////////

						if(error==0)
						  {
						    char aux[2];
						    if(INumSimulacions[1]!='V')
						      {
							aux[0]=INumSimulacions[0];
							aux[1]=INumSimulacions[1];
						      }
						    else
						      {
							aux[0]=INumSimulacions[0];
							aux[1]='\0';
						      }
						    NumSimulacions=atoi(aux);
						    int k=1;		//Crearem tantes carpetes com simulacions volem
						    bool EsCarpeta=false;	//Aquesta variable mira si el nom correspon a una de les carpetes de la simulacio
						    while(k<NumSimulacions)
						      {
							//Obrim el directori 
							DirectoriAux=opendir(NomSimulacio.c_str());		//Obrim el directori
							if(DirectoriAux==NULL)
							  {
							    error++;
							    if(Idioma==0)
							      {
								std::cout<<"Could not open the file of the simulation"<<std::endl;
							      }
							    else if(Idioma==1)
							      {
								std::cout<<"No s'ha pogut obrir l'arxiu de la simulació"<<std::endl;
							      }
							    else if(Idioma==2)
							      {
								std::cout<<"No se ha podido abrir el archivo de la simulación"<<std::endl;
							      }
							    break;
							  }
							else
							  {
							    int AuxXifres=0;
							    //Creem una carpeta per a la simulacio paral·lela
							    AuxXifres=sprintf(aux,"%i",k);
							    std::string AuxNumSim;
							    if(AuxXifres==1)
							      {
								AuxNumSim="./"+NomSimulacio+"/sim"+aux[0];
							      }
							    else if(AuxXifres==2)
							      {
								AuxNumSim="./"+NomSimulacio+"/sim"+aux[0]+aux[1];
							      }
							    mkdir(AuxNumSim.c_str(),0744);
							    AuxString.clear();
							    while((data=readdir(DirectoriAux))!=NULL)		//llegim el directori guardant la informació de un dels arxius en cada cicle
							      {
								sprintf(AuxChar,"%s",data->d_name);	//Guardem el nom de l'arxiu (d_name) en AuxChar i el nombre de caracters

								if(AuxChar[0]!='.')				//No mirem els arxiu ocults (.Nom)
								  {
								    AuxString=AuxChar;

								    //Comprovem ara que no anem a copiar una de les carpetes de la simulació
								    int j=1;
								    while(j<NumSimulacions)
								      {
							
									AuxXifres=sprintf(aux,"%i",j);
									std::string AuxNumSim2="sim";
							
									if(AuxXifres==1)
									  {
									    AuxNumSim2+=aux[0];
									  }
									else if(AuxXifres==2)
									  {
									    AuxNumSim2+=aux[0];
									    AuxNumSim2+=aux[1];
									  }
									if(AuxString==AuxNumSim2)
									  {
									    EsCarpeta=true;
									    AuxNumSim2.clear();
									    break;
									  }
									j++;
								      }
								    if(EsCarpeta==false)
								      {
									AuxString="cp ./"+NomSimulacio+"/"+AuxString+" "+AuxNumSim+"/";
									system(AuxString.c_str());
								      }
								    EsCarpeta=false;
								  }
								AuxString.clear();				//netegem el string
							      }

							    closedir(DirectoriAux);
						
							    ///////////////////////////Entrem a cada carpeta de cada simulacio paralela i canviem la llavor de la simulacio per a que no siguen totes la mateixa///////////
							    chdir(AuxNumSim.c_str());
							    //Farem una copia de l'arxiu de configuració amb les llavors canviades
							    std::ifstream ArxiuConf("config.in");
							    if(ArxiuConf.is_open())
							      {
								//Primer buscarem la linea on posa [END OF CONFIG SECTION], ja que les llavors es troben 5 linies per dalt
								AuxString.clear();
								int NumLinea=0;	//Contara la línea on s'ha trobat
								while(AuxString!="[END OF CONFIG SECTION]")
								  {
								    AuxString.clear();
								    getline(ArxiuConf,AuxString);
								    NumLinea++;
								  }
								ArxiuConf.close();
								if(AuxString!="[END OF CONFIG SECTION]")
								  {
								    error++;
								    if(Idioma==0)
								      {
									std::cout<<"Could not change the seed of the simulations"<<std::endl;
								      }
								    else if(Idioma==1)
								      {
									std::cout<<"No s'ha pogut canviar la llavor de les simulacions"<<std::endl;
								      }
								    else if(Idioma==2)
								      {
									std::cout<<"No se ha podido cambiar la semilla de las simulaciones"<<std::endl;
								      }
								  }
								else
								  {
								    int j=1;
								    ArxiuConf.open("config.in");
								    std::ofstream ArxiuConfCanviat("temp.in");
								    //ens situem on estan les llavors
								    while(j<NumLinea-5)
								      {
									AuxString.clear();
									getline(ArxiuConf,AuxString);
									ArxiuConfCanviat<<AuxString<<std::endl;
									j++;
								      }
								    //Una vegada situats, les canviem sumant-li el numero de simulacio
								    int llavor;
								    ArxiuConf>>llavor;
								    ArxiuConfCanviat<<" "<<llavor+k;
								    ArxiuConf>>llavor;
								    ArxiuConfCanviat<<"  "<<llavor+k;
						      
								    //Agafem la resta de la linea
								    AuxString.clear();
								    getline(ArxiuConf,AuxString);
								    ArxiuConfCanviat<<AuxString<<std::endl;
								    //Copiem la resta de l'arxiu de configuracio
								    AuxString.clear();
								    while(getline(ArxiuConf,AuxString))
								      {
									ArxiuConfCanviat<<AuxString<<std::endl;
									AuxString.clear();
								      }
								    //Finalment tanquem els arxius, eliminem el vell arxiu de configuracio i reanomenem el nou
								    ArxiuConf.close();
								    ArxiuConfCanviat.close();
								    remove("config.in");
								    rename("temp.in","config.in");
								    //Tornem al directori inicial (on es troba el programa)
								    chdir(Actualdir);
								  }
							      }
							    else
							      {
								error++;
								if(Idioma==0)
								  {
								    std::cout<<"Could not find the configuration file "<<std::endl;
								  }
								else if(Idioma==1)
								  {
								    std::cout<<"No s'ha trobat el fitxer de configuració"<<std::endl;
								  }
								else if(Idioma==2)
								  {
								    std::cout<<"No se ha encontrado el fichero de configuración"<<std::endl;
								  }
							      }
							    if(error==0)
							      {
								/////////////////////////////////////Arranquem la simulacio/////////////////////
								AuxXifres=0;
								//Creem una variable amb l'arranc del programa en bash
								AuxXifres=sprintf(aux,"%i",k);
								std::string ArrancBash;
								ArrancBash.clear();
								if(AuxXifres==1)
								  {
								    ArrancBash="./arranc.sh ";
								    ArrancBash+=aux[0];
								    ArrancBash+=" &";
								  }
								else if(AuxXifres==2)
								  {
								    ArrancBash="./arranc.sh ";
								    ArrancBash+=aux[0];
								    ArrancBash+=aux[1];
								    ArrancBash+=" &";
								  }
								chdir(AuxNumSim.c_str());
								system(ArrancBash.c_str());
								chdir(Actualdir);
								AuxString.clear();
								ArrancBash.clear();
							      }
							    k++;
							  }
					    
						      }
						    /////////////////////////Finalment arranquem la simulacio de la carpeta global i "unir", que ens dira quan acaba el programa///////////
						    AuxString.clear();
						    AuxString="./"+NomSimulacio;
						    chdir(AuxString.c_str());
						    system("./arranc.sh 0 &");
						    system("./unir &");
						    chdir(Actualdir);
						    AuxString.clear();
						  }
					      }
					  }
				      }
				  }
			      }
			    else
			      {
				if(Idioma==0)
				  {
				    std::cout<<"Missing the number of simulations"<<std::endl;
				  }
				else if(Idioma==1)
				  {
				    std::cout<<"Falta el nombre de simulacions"<<std::endl;
				  }
				else if(Idioma==2)
				  {
				    std::cout<<"Falta el numero de simulaciones"<<std::endl;
				  }
			      }
			  }	  
			else
			  {
			    if(Idioma==0)
			      {
				std::cout<<"Missing file name with geometry"<<std::endl;
			      }
			    else if(Idioma==1)
			      {
				std::cout<<"Falta el nom del fitxer amb la geometria (Quadrigues o Voxels)"<<std::endl;
			      }
			    else if(Idioma==2)
			      {
				std::cout<<"Falta el nombre del fichero con la geometria (De un tipo como mínimo)"<<std::endl;
			      }
			  }
		      }else
		      {
			if(Idioma==0)
			  {
			    std::cout<<"Missing the name of the configuration file"<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"Falta el nom del fitxer de configuració"<<std::endl;
			  }
			else if(Idioma==2)
			  {
			    std::cout<<"Falta el nombre del fichero de configuración"<<std::endl;
			  }
		      }
		  }else
		  {
		    if(Idioma==0)
		      {
			std::cout<<"Missing simulation name"<<std::endl;
		      }
		    else if(Idioma==1)
		      {
			std::cout<<"Falta el nom de la simulació"<<std::endl;
		      }
		    else if(Idioma==2)
		      {
			std::cout<<"Falta el nombre de la simulación"<<std::endl;
		      }
		  }
	      }        
	  }
	else if(ControlMenu==9)
	  {
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////
	    /////////////SUBMENU VISOR RESULTATS///////////////////////////////////////////////////////////////////
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////
	    if(ControlSubMenu==0)
	      {
		if(x>OrigenXPantallaMenu+BNomSimulacio.LimitEsquerra && x<OrigenXPantallaMenu+BNomSimulacio.LimitDret && y>OrigenYPantallaMenu-BNomSimulacio.LimitSuperior && y<OrigenYPantallaMenu-BNomSimulacio.LimitInferior)
		  {
		  }
		else if(x>OrigenXPantallaMenu+Crear.LimitEsquerra && x<OrigenXPantallaMenu+Crear.LimitDret && y>OrigenYPantallaMenu-Crear.LimitSuperior && y<OrigenYPantallaMenu-Crear.LimitInferior)
		  {
		    //Diguem que hem de tornar a renderitzar les pantalles
		    RendFinestraGran=true;
		    RendFinestraSup=true;
		    RendFinestraInf=true;
		    //Carreguem els voxels
		    if(INomSimulacio[0]!='\0')	//Mirem si hem introduit alguna cosa al nom de la simulació
		      {
			DIR *DirectoriAux;
			ControlSubMenu=1;
			ControlSubSubMenu=1;
			int error=0;				//Controla si hi ha algun error
			int i=0;
			NomSimulacio.clear();			//Netegem la variable amb el nom de la simulacio
			while(INomSimulacio[i]!='\0')
			  {
			    NomSimulacio+=INomSimulacio[i];
			    i++;
			  }
			DirectoriAux=opendir(NomSimulacio.c_str());
			if(DirectoriAux==NULL)	//Comrpovem si la simulació amb aquest nom existeix
			  {
			    //si no està creada tornarà NULL
			    error++;
			    if(Idioma==0)
			      {
				std::cout<<"Simulation folder not found"<<std::endl;
			      }
			    else if(Idioma==1)
			      {
				std::cout<<"No s'ha trobat la carpeta amb la simulació"<<std::endl;
			      }
			    else if(Idioma==2)
			      {
				std::cout<<"No se ha encontrado la carpeta con la simulación"<<std::endl;
			      }
			    ControlMenu=9;
			    ControlSubMenu=0;
			    ControlSubSubMenu=0;
			  }
			else	//Si la carpeta esta creada busquem una carpeta anomenada resultats
			  {
			    bool ResultatsTrobats=false;		//Controla si hem trobat algun arxiu de resultats
			    closedir(DirectoriAux);
			    std::string NomDirSimAux;
			    NomDirSimAux.clear();
			    NomDirSimAux=std::string(Actualdir)+std::string("/")+NomSimulacio;
			    chdir(NomDirSimAux.c_str());		  
			    DirectoriAux=opendir("Resultats");
			    if(DirectoriAux==NULL)
			      {
				//Si la carpeta no existeix busquem en la carpeta de la simulacio l'arxiu de resultats
				std::string AuxString;
				AuxString.clear();
				AuxString=std::string(Actualdir)+std::string("/")+NomSimulacio;
				chdir(AuxString.c_str());
			      }
			    else
			      {
				closedir(DirectoriAux);
				//Si si que existeix buscarem asi el fitxer de resultats
				std::string AuxString;
				AuxString.clear();
				AuxString=std::string(Actualdir)+std::string("/")+NomSimulacio+std::string("/")+std::string("Resultats");
				chdir(AuxString.c_str());		    
			      }
			    //Primer mirem si existeix un arxiu amb la dosi de voxels
			    std::ifstream ArxiuResultats("tallyVoxelDoseDistrib.dat");
			    if(ArxiuResultats.is_open())
			      {
				std::cout<<"Carregant voxels..."<<std::endl;
				//Si troba aquest pasem a llegir-lo
				ResultatsTrobats=true;
				std::string LineaAux;
				char aux;

				//Agafem el nombre de voxels i el seu tamany
		      
				getline(ArxiuResultats,LineaAux);
				getline(ArxiuResultats,LineaAux);
				getline(ArxiuResultats,LineaAux);
				getline(ArxiuResultats,LineaAux);
				getline(ArxiuResultats,LineaAux);
				getline(ArxiuResultats,LineaAux);
				getline(ArxiuResultats,LineaAux);
		      
				ArxiuResultats>>aux;
		      
				ArxiuResultats>>NumVoxels[0];
				ArxiuResultats>>NumVoxels[1];
				ArxiuResultats>>NumVoxels[2];
					    
				getline(ArxiuResultats,LineaAux);
				getline(ArxiuResultats,LineaAux);
		      
				ArxiuResultats>>aux;
					  
				ArxiuResultats>>DimVoxels[0];
				ArxiuResultats>>DimVoxels[1];
				ArxiuResultats>>DimVoxels[2];

				getline(ArxiuResultats,LineaAux);
				getline(ArxiuResultats,LineaAux);
				getline(ArxiuResultats,LineaAux);
				getline(ArxiuResultats,LineaAux);
				getline(ArxiuResultats,LineaAux);
				getline(ArxiuResultats,LineaAux);
				getline(ArxiuResultats,LineaAux);
				getline(ArxiuResultats,LineaAux);		  

				//Reconstruim la matriu de voxels amb les dimensions que toca//
				ConstruirMatriuVoxels(NumVoxels[0],NumVoxels[1],NumVoxels[2]);
				//calculem la dimensio de l'espai
				DimEspai[0]=NumVoxels[0]*DimVoxels[0];
				DimEspai[1]=NumVoxels[1]*DimVoxels[1];
				DimEspai[2]=NumVoxels[2]*DimVoxels[2];
				//Reajustem els plans de tall//
				PlansTall[0]=DimEspai[0];
				PlansTall[1]=DimEspai[1];
				PlansTall[2]=DimEspai[2];
				//Pasem ara a carregar la dosi dels voxels en memòria

				int IndexX=1;
				int IndexY=1;
				int IndexZ=1;

				//Buidem els voxels primer
				IndexX=0;
				IndexY=0;
				IndexZ=0;
				while(IndexX<NumVoxels[0])
				  {
				    IndexY=0;
				    while(IndexY<NumVoxels[1])
				      {
					IndexZ=0;
					while(IndexZ<NumVoxels[2])
					  {
					    Voxels[IndexX][IndexY][IndexZ][0]=0;
					    Voxels[IndexX][IndexY][IndexZ][1]=0;
					    IndexZ++;
					  }
					IndexY++;
				      }
				    IndexX++;
				  }
				//Ara els agafem de l'arxiu
				//Iniciem la màxima dosis a zero, que servira per a crear els intervals on s'asignen els colors
				MaxDosis=0;
				IndexZ=0;
				while(IndexZ<NumVoxels[2])
				  {
				    IndexY=0;
				    while(IndexY<NumVoxels[1])
				      {
					IndexX=0;
					while(IndexX<NumVoxels[0])
					  {
					    float DosiVox=0;
					    float EDosiVox=0;
					    ArxiuResultats>>DosiVox;
					    ArxiuResultats>>DosiVox;
					    ArxiuResultats>>DosiVox;
					    ArxiuResultats>>DosiVox;
					    ArxiuResultats>>DosiVox;
					    ArxiuResultats>>DosiVox;
					    ArxiuResultats>>DosiVox;
			    
					    ArxiuResultats>>EDosiVox;
			    
					    Voxels[IndexX][IndexY][IndexZ][0]=DosiVox;
			    
					    if(DosiVox>MaxDosis)	//Mirem si aquesta dosis és la màxima registrada fins ara
					      {
						MaxDosis=DosiVox;
					      }
					    Voxels[IndexX][IndexY][IndexZ][1]=EDosiVox;
			    
					    getline(ArxiuResultats,LineaAux);
			    
					    IndexX++;
					  }
					IndexY++;
					getline(ArxiuResultats,LineaAux);
					getline(ArxiuResultats,LineaAux);
			  
				      }
				    IndexZ++;
				    getline(ArxiuResultats,LineaAux);
				    getline(ArxiuResultats,LineaAux);
				  }
				//Una vegada guardats els voxels i les seues dosis calculem els intervals dels colors
				MinDosis=0;
				DosisMaximaResultats=MaxDosis;
				IntervalColorResultats=MaxDosis*1.0/NumColorsResultats;
		      
		      
				std::cout<<"Voxels carregats"<<std::endl;
				ArxiuResultats.close();
				chdir(Actualdir);
		      		      		      
				PintVox=true;		//activem pintar voxels
				PintObjectes=false;	//desactivem pintar objectes
				PintVQuad=false;		//desactivem pintar els voxels com a cubs
				CrearLlistaVox=true;	//hem de tornar a crear la llista de Voxels
			      } 
			    //else if()
		    
			    if(ResultatsTrobats==false)
			      {
				std::cout<<"No s'ha trobat cap fitxer de dades valid"<<std::endl;
			      }
			  }
			//Centrem la càmera
			glMatrixMode(GL_MODELVIEW);			//S'encarrega de moure i transformar l'espai (Les coordenades de l'espai)
			glLoadIdentity();
			gluLookAt(DimEspai[0]+DimEspai[1]+DimEspai[2],DimEspai[1]/2.0,DimEspai[2]/2.0,DimEspai[0]/2.0,DimEspai[1]/2.0,DimEspai[2]/2.0,0.0,0.0,1.0);		//fixem la camera i el punt on mira
		  
		      }
		    else
		      {
			if(Idioma==0)
			  {
			    std::cout<<"Missing simulation name"<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"Falta el nom de la simulació"<<std::endl;
			  }
			else if(Idioma==2)
			  {
			    std::cout<<"Falta el nombre de la simulación"<<std::endl;
			  }
	     
		      }	   
		  }
	      }
	    else if(ControlSubMenu==1)
	      {
		if(x>OrigenXPantallaMenu+BDosiMin.LimitEsquerra && x<OrigenXPantallaMenu+BDosiMin.LimitDret && y>OrigenYPantallaMenu-BDosiMin.LimitSuperior && y<OrigenYPantallaMenu-BDosiMin.LimitInferior)
		  {
		    ControlSubSubMenu=1;			//Dosis mínima
		  }
		else if(x>OrigenXPantallaMenu+BDosiMax.LimitEsquerra && x<OrigenXPantallaMenu+BDosiMax.LimitDret && y>OrigenYPantallaMenu-BDosiMax.LimitSuperior && y<OrigenYPantallaMenu-BDosiMax.LimitInferior)
		  {
		    ControlSubSubMenu=2;			//Dosis màxima
		  } 
		else if(x>OrigenXPantallaMenu+BEscalaLog.LimitEsquerra && x<OrigenXPantallaMenu+BEscalaLog.LimitDret && y>OrigenYPantallaMenu-BEscalaLog.LimitSuperior && y<OrigenYPantallaMenu-BEscalaLog.LimitInferior)
		  {
		    //Diguem que hem de tornar a renderitzar les pantalles
		    RendFinestraGran=true;
		    RendFinestraSup=true;
		    RendFinestraInf=true;
	  
		    if(EscalaLog==false)
		      {
			EscalaLog=true;		//Activem/desactivem l'escala logaritmica
		      }
		    else if(EscalaLog==true)
		      {
			EscalaLog=false;
		      }
		    CrearLlistaVox=true;	//hem de tornar a crear la llista de Voxels
		  }	
		else if(x>OrigenXPantallaMenu+CVoxPunts.LimitEsquerra && x<OrigenXPantallaMenu+CVoxPunts.LimitDret && y>OrigenYPantallaMenu-CVoxPunts.LimitSuperior && y<OrigenYPantallaMenu-CVoxPunts.LimitInferior)
		  {
		    PintVQuad=false;		//desactivem pintar els voxels com a cubs
		    CrearLlistaVox=true;	//hem de tornar a crear la llista de Voxels
		    //Diguem que hem de tornar a renderitzar les pantalles
		    RendFinestraGran=true;
		    RendFinestraSup=true;
		    RendFinestraInf=true;
	  
		  }
		else if(x>OrigenXPantallaMenu+CVoxQuad.LimitEsquerra && x<OrigenXPantallaMenu+CVoxQuad.LimitDret && y>OrigenYPantallaMenu-CVoxQuad.LimitSuperior && y<OrigenYPantallaMenu-CVoxQuad.LimitInferior)
		  {
		    PintVQuad=true;		//activem pintar els voxels com a cubs
		    CrearLlistaVox=true;	//hem de tornar a crear la llista de Voxels
		    //Diguem que hem de tornar a renderitzar les pantalles
		    RendFinestraGran=true;
		    RendFinestraSup=true;
		    RendFinestraInf=true;
	  
		  }
		else if(x>OrigenXPantallaMenu+CVoxPla[0].LimitEsquerra && x<OrigenXPantallaMenu+CVoxPla[0].LimitDret && y>OrigenYPantallaMenu-CVoxPla[0].LimitSuperior && y<OrigenYPantallaMenu-CVoxPla[0].LimitInferior)
		  {
		    ControlSubSubMenu=3;			//Pla X
		  }
		else if(x>OrigenXPantallaMenu+CVoxPla[1].LimitEsquerra && x<OrigenXPantallaMenu+CVoxPla[1].LimitDret && y>OrigenYPantallaMenu-CVoxPla[1].LimitSuperior && y<OrigenYPantallaMenu-CVoxPla[1].LimitInferior)
		  {
		    ControlSubSubMenu=4;			//Pla Y
		  }
		else if(x>OrigenXPantallaMenu+CVoxPla[2].LimitEsquerra && x<OrigenXPantallaMenu+CVoxPla[2].LimitDret && y>OrigenYPantallaMenu-CVoxPla[2].LimitSuperior && y<OrigenYPantallaMenu-CVoxPla[2].LimitInferior)
		  {
		    ControlSubSubMenu=5;			//Pla Z
		  }
		else if(x>OrigenXPantallaMenu+Crear.LimitEsquerra && x<OrigenXPantallaMenu+Crear.LimitDret && y>OrigenYPantallaMenu-Crear.LimitSuperior && y<OrigenYPantallaMenu-Crear.LimitInferior)
		  {
		    //Guardar els plans
		    CrearLlistaVox=true;	//hem de tornar a crear la llista de Voxels
		    //Diguem que hem de tornar a renderitzar les pantalles
		    RendFinestraGran=true;
		    RendFinestraSup=true;
		    RendFinestraInf=true;
	    
	    
	    
		    char Aux[101];		//Posem dimensio 101 per a que sempre capiga el '\0' inclus si el CubChar te 100 caràcters
		    int IndexChar=0;
		    //Guardem el Pla X//
		    while(IPlansTallChar[0][IndexChar]!='V' && IndexChar<5)
		      {
			Aux[IndexChar]=IPlansTallChar[0][IndexChar];
			IndexChar++;
		      }
		    if(IndexChar==0)			//Agafara tot l'eix si no hi ha cap valor guardat
		      {
			PlansTall[0]=DimEspai[0];
		      }else
		      {
			Aux[IndexChar]='\0';
			PlansTall[0]=atof(Aux);
			if(PlansTall[0]==0)
			  {
			    PlansTall[0]=DimEspai[0];
			  }      
	      
		      }

		    IndexChar=0;
		    //Guardem el Pla Y//
		    while(IPlansTallChar[1][IndexChar]!='V' && IndexChar<5)
		      {
			Aux[IndexChar]=IPlansTallChar[1][IndexChar];
			IndexChar++;
		      }
		    if(IndexChar==0)			//Agafara tot l'eix si no hi ha cap valor guardat
		      {
			PlansTall[1]=DimEspai[1];
		      }else
		      {      
			Aux[IndexChar]='\0';
			PlansTall[1]=atof(Aux);
			if(PlansTall[1]==0)
			  {
			    PlansTall[1]=DimEspai[1];
			  }      
	      
		      }     
	    
		    IndexChar=0;
		    //Guardem el Pla Z//
		    while(IPlansTallChar[2][IndexChar]!='V' && IndexChar<5)
		      {
			Aux[IndexChar]=IPlansTallChar[2][IndexChar];
			IndexChar++;
		      }
		    if(IndexChar==0)			//Agafara tot l'eix si no hi ha cap valor guardat
		      {
			PlansTall[2]=DimEspai[2];
		      }else
		      {      
			Aux[IndexChar]='\0';
			PlansTall[2]=atof(Aux);
			if(PlansTall[2]==0)
			  {
			    PlansTall[2]=DimEspai[2];
			  }
		      }
		    IndexChar=0;

		    //Guardem la dosis mínima//
		    while(IMinDosisChar[IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)
		      {
			Aux[IndexChar]=IMinDosisChar[IndexChar];
			IndexChar++;
		      }
		    if(IndexChar==0)			//No canviem el límit si no hem introduit res
		      {
			//No res
		      }else
		      {      
			Aux[IndexChar]='\0';
			MinDosis=atof(Aux);
		      }
		    IndexChar=0;
		    //Guardem la dosis màxima//
		    while(IMaxDosisChar[IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)
		      {
			Aux[IndexChar]=IMaxDosisChar[IndexChar];
			IndexChar++;
		      }
		    if(IndexChar==0)			//No canviem el límit si no hem introduit res
		      {
			//No res
		      }else
		      {      
			Aux[IndexChar]='\0';
			MaxDosis=atof(Aux);
		      }
		    IndexChar=0;
		    //Recalculem els intervals
	    
		    //Mirem si el valor de la dosi minima és major que la màxima. Si pasa el MinDosis pasarà a ser zero
	    
		    if(MinDosis>=MaxDosis)
		      {
			MinDosis=0.0;
		      }
		    if(MaxDosis==0)
		      {
			MaxDosis=DosisMaximaResultats;
		      }
		    if(MaxDosis>DosisMaximaResultats)
		      {
			MaxDosis=DosisMaximaResultats;
		      }
		    IntervalColorResultats=(MaxDosis-MinDosis)*1.0/NumColorsResultats;
	  
		  }
	      }
	  }
	else if(ControlMenu==10)
	  {
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////
	    /////////////SUBMENU VISOR DICOM///////////////////////////////////////////////////////////////////////
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////

	    if(ControlSubMenu==0)
	      {
		if(x>OrigenXPantallaMenu+Crear.LimitEsquerra && x<OrigenXPantallaMenu+Crear.LimitDret && y>OrigenYPantallaMenu-Crear.LimitSuperior && y<OrigenYPantallaMenu-Crear.LimitInferior)
		  {
		    //Carreguem la imatge DICOM
		    //Hem de tornar a crear la llista amb els vòxels
		    PintVox=true;		//activem pintar voxels
		    PintObjectes=false;	//desactivem pintar objectes
		    PintVQuad=false;		//desactivem pintar els voxels com a cubs
		    CrearLlistaVox=true;	//hem de tornar a crear la llista de Voxels
		    GuardarVoxDicomRep=true;
		    GuardarVoxDicomRepVisible=true;
		    //Diguem que hem de tornar a renderitzar les pantalles
		    RendFinestraGran=true;
		    RendFinestraSup=true;
		    RendFinestraInf=true;
	  
		    if(INomDicom[0]!='\0')	//Mirem si hem introduit el nom de la carpeta
		      {
			DIR *DirectoriAux;
			//Mirem primer si la carpeta existeix
			int error=0;				//Controla si hi ha algun error
			int i=0;
			NomDicom.clear();			//Netegem la variable amb el nom de la simulacio
			while(INomDicom[i]!='\0')
			  {
			    NomDicom+=INomDicom[i];
			    i++;
			  }
			DirectoriAux=opendir(NomDicom.c_str());
			if(DirectoriAux==NULL)	//Comrpovem si la carpeta amb aquest nom existeix
			  {
			    //si no està creada tornarà NULL
			    error++;
			    if(Idioma==0)
			      {
				std::cout<<"folder not found"<<std::endl;
			      }
			    else if(Idioma==1)
			      {
				std::cout<<"No s'ha trobat la carpeta"<<std::endl;
			      }
			    else if(Idioma==2)
			      {
				std::cout<<"No se ha encontrado la carpeta"<<std::endl;
			      }
			  }
			else	//Si la carpeta esta creada, entrem i busquem i carreguem els .dcm
			  {
			    std::string AuxString;
			    AuxString.clear();
			    AuxString=std::string(Actualdir)+std::string("/")+NomDicom;
			    chdir(AuxString.c_str());		    		
		 
			    //Una vegada hem entrat a la carpeta mirem si existeix algun arxiu amb extensió .dcm
			    //Primer declarem una variable del tipus "dirent" per a llegir el nom dels fitxers al seu interior
			    dirent *data;
			    int NumCaracters=0;					//Guardarà el nombre de caracters del nom de cada fitxer
			    char AuxChar[500];                                  //Guarda el nom del dicom que estem carregant
			    char Dicomrtss[500];                                //Guarda el nom del dicom amb les contorns
			    char Dicomrtplan[500];                              //Guarda el nom del dicom amb les llavors
			    int DimensioVector_PlansZDicoms=400;
			    double* PlansZDicoms = new double[DimensioVector_PlansZDicoms];             //Guarda els pla Z on es situa cada dicom
			    int NumDicoms=0;					//Contarà el nombre d'arxius tipus .dcm que hi ha a la carpeta
			    while((data=readdir(DirectoriAux))!=NULL)		//llegim el directori guardant la informació d'un dels fitxers en cada cicle
			      {
				NumCaracters=sprintf(AuxChar,"%s",data->d_name);	//Guardem el nom de l'arxiu (d_name) en AuxChar i el nombre de caracters en NumCaracters
				if(AuxChar[0]!='.')				//No mirem els arxiu ocults (.Nom)
				  {
				    //comprovarem que l'extensió és .dcm comparant els 4 últims caracters i que abans tenen un numero per a saber que formen un dels plans del dicom. Per aquests motius, l'arxiu ha de tenir com a minim 5 caracters de nom
				    if( NumCaracters>=5 && AuxChar[NumCaracters-1]=='m' && AuxChar[NumCaracters-2]=='c' && AuxChar[NumCaracters-3]=='d' && AuxChar[NumCaracters-4]=='.')
				      {
					dicom::dicomfile* dfaux;
					dfaux = dicom::open_dicomfile(AuxChar); //Obrim el dicom
					if(dfaux!=NULL)
					  {
					    //Llegim la modalitat del dicom per a saber de que es tracta
					    dicom::dataelement* de;
					    de = dfaux->get_dataelement(0x00080060);
					    if(de -> is_valid()) //Mirem que puga llegir la modalitat
					      {
						std::string AuxModalitat = de -> to_string();
						if(AuxModalitat == "US" || AuxModalitat == "CT")
						  {
						    //Si te algunes de les modalitats d'imatge permeses, formara part de la imatge
						    //Intentem agafar la posicio Z del pla
						    de = dfaux->get_dataelement(0x00200032);
						    if(de -> is_valid()) //Mirem si existeix l'element amb la posició del pla
						      {
							double* AuxPos;
							int AuxNumComp;
							//Agafem la posicio de la imatge
							de -> to_double_values_a(&AuxPos, &AuxNumComp);
							//Guardem la posicio Z
							PlansZDicoms[NumDicoms] = AuxPos[2];
							free(AuxPos);
							//Aquest dicom conte plans de la imatge i per tant augmentem el nombre de dicoms
							NumDicoms++;

							//Comprovem que el vector no es quede menut
							if(NumDicoms==DimensioVector_PlansZDicoms)
							  {
							    //Hem d'augmentar el vector, el copiem en un auxiliar
							    double* v2Aux = new double[NumDicoms];
							    copiarVector(PlansZDicoms, v2Aux, NumDicoms);
							    delete [] PlansZDicoms;

							    DimensioVector_PlansZDicoms+=200;
							    PlansZDicoms = new double[DimensioVector_PlansZDicoms];
							    copiarVector(v2Aux, PlansZDicoms, NumDicoms);
							    delete [] v2Aux;
							  }
						
						      }						    
						  }
						else if(AuxModalitat == "RTSTRUCT")
						  {
						    //Comprovem si conte contorns agafant el primer element de la sequencia "ROI Contour Sequence"
						    dicom::dataset* ds = dfaux -> get_dataelement(0x30060039)->dataset_at(0);
						    if(ds!=NULL) //Si es valid, significa que es un dicom amb els contorns, guardem el seu nom
						      {
							sprintf(Dicomrtss,"%s",AuxChar);
						      }
						  }
						else if(AuxModalitat == "RTPLAN")
						  {
						    //Comprovem si conte les llavors agafant el primer element de la sequencia "Application Setup Sequence"
						    dicom::dataset* ds = dfaux -> get_dataelement(0x300a0230)->dataset_at(0);
						    if(ds!=NULL)
						      {
							//Si es valid, aquest dicom conte el pla de les llavors, guardem el nom
							sprintf(Dicomrtplan,"%s",AuxChar);
						      }						    
						  }
					      }
					  }
					delete dfaux;
				      }
				  }
			      }
			    //Comprovem que s'ha trobat algun Dicom
			    if(NumDicoms==0)
			      {
				error++;
				if(Idioma==0)
				  {
				    std::cout<<"No files with '.dcm' extension"<<std::endl;
				  }
				else if(Idioma==1)
				  {
				    std::cout<<"No hi ha fitxers amb extensió '.dcm'"<<std::endl;
				  }
				else if(Idioma==2)
				  {
				    std::cout<<"No hay ficheros con extensión '.dcm'"<<std::endl;
				  }
		   
			      }
			    else
			      {
				//Una vegada llegits tots, ajustem les dimensions del vector PlansZDicoms al nombre de dicoms i ordenem les Z de menor a major, que sera l'ordre en que carreguem els dicom
				double* v2Aux = new double[NumDicoms];
				copiarVector(PlansZDicoms, v2Aux, NumDicoms);
				delete [] PlansZDicoms;
				
				PlansZDicoms = new double[NumDicoms];
				copiarVector(v2Aux, PlansZDicoms, NumDicoms);
				delete [] v2Aux;

				ordenar(PlansZDicoms, NumDicoms);
				/////////////////////////////////////////////////////
				//Si hem trobat dicoms, comprovem ara si tenim l'arxiu de calibracio.
				std::ifstream ArxiuCal("calibration.txt");
				if(ArxiuCal.is_open())	//Comprovem que s'ha obert l'arxiu de calibració
				  {
				    float CoeficientsCal[100];		//Com a màxim podrem introduïr 100 coeficients
				    float LimitsMaterials[100][2];
				    int contCal=0;
				    while(contCal<100)	//Els inicialitzem a zero
				      {
					CoeficientsCal[contCal]=0.0;
					LimitsMaterials[contCal][0]=0.0;
					LimitsMaterials[contCal][1]=0.0;
					contCal++;
				      }

				    //Pasem a llegir les dades del calibratge. Aquest és un desenvolupament en sèrie de potències de grau a indicar per l'usuari al fitxer	     
				    int GrauPolCal=0;
				    NumMatsCal=0; //Esta declarat fora perque cal per a construir la llegenda		      
				    MaxDensDCM=0.0;	//Inicializem la densitat màxima
				    MinDensDCM=0.0;     //Inicializem la densitat mínima
				    //Anirem avançant en el fitxer de calibratge fins a arribar on posa "---calibration data---"
				    std::string AuxLinia;
				    ////////////////////////////////////
				    ///////Calibracio///////////////////
				    ////////////////////////////////////
				    bool DadesCalTrobat=false;
				    while(getline(ArxiuCal,AuxLinia))
				      {
					if(AuxLinia=="---calibration data---")
					  {
					    DadesCalTrobat=true;
					    break;
					  }
					AuxLinia.clear();
				      }
		      
				    //Mirem si hem trobat les dades del calibratge
				    if(DadesCalTrobat==true)
				      {
					//El programa agafarà el número després del simbol "=", tot el que hi ha abans serà ignorat
					//La primera dada que ha d'estar és el nombre de graus del polinomi
					//Primer pasem de tots els caracters fins a trobar un  '='
					char auxCharCal='a';
					while(auxCharCal!='=')
					  {
					    ArxiuCal>>auxCharCal;
					  }
					//Una vegada trobat el '=' agafem el grau del polinomi
					ArxiuCal>>GrauPolCal;
					auxCharCal='a';
					//Si és major de 100 el reajustem a zero
					if(GrauPolCal>100)
					  {
					    GrauPolCal=100;
					  }
					//Ara anirem buscant els '=' suposant que els coeficients s'han introduït en ordre ascendent (a0,a1,a2,a3...)
					//Els inicialitzem a zero
					int CoeficientsCalGuardats=0;
					while(CoeficientsCalGuardats<GrauPolCal)
					  {
					    int contFi=0;			//Contará les vegades que trobem un '-' seguides. Si són 3 vegades acaba la introducció de dades de la calibració
					    while(auxCharCal!='=')
					      {
						ArxiuCal>>auxCharCal;
						if(ArxiuCal.eof())
						  {
						    break;
						  }
						if(auxCharCal=='-')
						  {
						    contFi++;
						    if(contFi==3)
						      {
							break;
						      }
						  }
						else if(auxCharCal!='-')
						  {
						    contFi=0;
						  }
					      }
					    if(ArxiuCal.eof())
					      {
						break;
					      }
					    else if(contFi==3)
					      {
						contFi=0;
						break;
					      }
					    if(auxCharCal=='=')	//Si hem trobat un '=' agafem el numero que hi ha a continuació
					      {
						bool EspaisInicials=true;		//Controla si hem acabat d'aafar els espais entre el '=' i els números
						bool PuntDecimals=false;		//Controla si hem trobat un punt decimal
						bool Exponent=false;		//Controla si hem trobat un exponent
						bool PrincipiExponent=false;	//Controla si estem en el primer caracter de l'exponent
						std::string AuxFloat;
						while(1)
						  {
						    ArxiuCal>>auxCharCal;
						    if(auxCharCal==' ' && EspaisInicials==true)
						      {
							continue;
						      }
						    else if(auxCharCal=='-' && (EspaisInicials==true || PrincipiExponent==true) )
						      {
							AuxFloat+=auxCharCal;
							PrincipiExponent=false;
						      }				
						    else if(auxCharCal=='.' && PuntDecimals==false)
						      {
							PuntDecimals=true;
							EspaisInicials=false;
							AuxFloat+=auxCharCal;
						      }
						    else if((auxCharCal=='e' || auxCharCal=='E') && Exponent==false)
						      {
							Exponent=true;
							AuxFloat+=auxCharCal;
							PrincipiExponent=true;
						      }
						    else if(auxCharCal=='0' || auxCharCal=='1' || auxCharCal=='2' || auxCharCal=='3' || auxCharCal=='4' || auxCharCal=='5' || auxCharCal=='6' || auxCharCal=='7' || auxCharCal=='8' || auxCharCal=='9')
						      {
							EspaisInicials=false;
							AuxFloat+=auxCharCal;
							PrincipiExponent=false;
						      }
						    else
						      {
							PrincipiExponent=false;
							break;
						      }
						  }
						CoeficientsCal[CoeficientsCalGuardats]=atof(AuxFloat.c_str());
						AuxFloat.clear();
						CoeficientsCalGuardats++;
					      }
					  }
					std::cout<<"Calibration coeficients loaded = "<<CoeficientsCalGuardats<<"/"<<GrauPolCal<<std::endl;
					contCal=0;
					while(contCal<GrauPolCal)
					  {
					    std::cout<<"a"<<contCal<<" = "<<float(CoeficientsCal[contCal])<<std::endl;
					    contCal++;
					  }
				      }
				    else
				      {
					if(Idioma==0)
					  {
					    std::cout<<"Missing calibration data"<<std::endl;
					  }
					else if(Idioma==1)
					  {
					    std::cout<<"No s'ha trobat polinomi de calibració"<<std::endl;
					  }
					else if(Idioma==2)
					  {
					    std::cout<<"No se ha encontrado polinomio de calibración"<<std::endl;
					  }
					GrauPolCal=1;
					CoeficientsCal[0]=1;
			
				      }
				    ArxiuCal.close();
				    ////////////////////////////////////
				    ///////Materials////////////////////
				    ////////////////////////////////////		      
				    ArxiuCal.open("calibration.txt");
				    //Carreguem ara els materials si existeix la secció "---materials data---". Si no existeix es carregaran per defecte
				    //Anirem avançant en el fitxer de calibratge fins a arribar on posa "---materials data---"
				    AuxLinia.clear();
				    bool DadesMatCalTrobat=false;
				    while(getline(ArxiuCal,AuxLinia))
				      {
					if(AuxLinia=="---materials data---")
					  {
					    DadesMatCalTrobat=true;
					    break;
					  }
					AuxLinia.clear();
				      }
				    //Si trobem la secció carreguem les dades dels materials
				    if(DadesMatCalTrobat==true)
				      {
					//El programa agafarà el número després del simbol "=", tot el que hi ha abans serà ignorat
					//La primera dada que ha d'estar és el nombre de materials
					//Primer pasem de tots els caracters fins a trobar un  '='
					char auxCharCal='a';
					while(auxCharCal!='=')
					  {
					    ArxiuCal>>auxCharCal;
					  }
					//Una vegada trobat el '=' agafem el nombre de materials
					ArxiuCal>>NumMatsCal;
					auxCharCal='a';
					//Si és major de 100 el reajustem a zero
					if(NumMatsCal>100)
					  {
					    NumMatsCal=100;
					  }
					//Ara anirem buscant els '=' suposant que els materials s'han introduït en ordre ascendent (m1,m2,m3,m4...)
					//Els inicialitzem a zero
					int MaterialsCalGuardats=0;
					int InfOSup=0;
					while(MaterialsCalGuardats<NumMatsCal)
					  {
					    int contFi=0;			//Contará les vegades que trobem un '-' seguides. Si són 3 vegades acaba la introducció de dades de la calibració
					    while(auxCharCal!='=')
					      {
						ArxiuCal>>auxCharCal;
						if(ArxiuCal.eof())
						  {
						    break;
						  }
						if(auxCharCal=='-')
						  {
						    contFi++;
						    if(contFi==3)
						      {
							break;
						      }
						  }
						else if(auxCharCal!='-')
						  {
						    contFi=0;
						  }
					      }
					    if(ArxiuCal.eof())
					      {
						break;
					      }
					    else if(contFi==3)
					      {
						contFi=0;
						break;
					      }
					    if(auxCharCal=='=')	//Si hem trobat un '=' agafem el numero que hi ha a continuació
					      {
						bool EspaisInicials=true;		//Controla si hem acabat d'aafar els espais entre el '=' i els números
						bool PuntDecimals=false;		//Controla si hem trobat un punt decimal
						bool Exponent=false;		//Controla si hem trobat un exponent
						bool PrincipiExponent=false;	//Controla si estem en el primer caracter de l'exponent
						std::string AuxFloat;
						while(1)
						  {
						    ArxiuCal>>auxCharCal;
						    if(auxCharCal==' ' && EspaisInicials==true)
						      {
							continue;
						      }
						    else if(auxCharCal=='-' && (EspaisInicials==true || PrincipiExponent==true) )
						      {
							AuxFloat+=auxCharCal;
							PrincipiExponent=false;
						      }				
						    else if(auxCharCal=='.' && PuntDecimals==false)
						      {
							PuntDecimals=true;
							EspaisInicials=false;
							AuxFloat+=auxCharCal;
						      }
						    else if((auxCharCal=='e' || auxCharCal=='E') && Exponent==false)
						      {
							Exponent=true;
							AuxFloat+=auxCharCal;
							PrincipiExponent=true;
						      }
						    else if(auxCharCal=='0' || auxCharCal=='1' || auxCharCal=='2' || auxCharCal=='3' || auxCharCal=='4' || auxCharCal=='5' || auxCharCal=='6' || auxCharCal=='7' || auxCharCal=='8' || auxCharCal=='9')
						      {
							EspaisInicials=false;
							AuxFloat+=auxCharCal;
							PrincipiExponent=false;
						      }
						    else
						      {
							PrincipiExponent=false;
							break;
						      }
						  }
						LimitsMaterials[MaterialsCalGuardats][InfOSup]=atof(AuxFloat.c_str());
						AuxFloat.clear();
						if(InfOSup==0)	//Una vegada guardat el limit inferior (0) o superior (1) canviem el que anem a guardar
						  {
						    InfOSup=1;
						  }else if(InfOSup==1)	//Quan guardem el límit superior pasem al següent material
						  {
						    InfOSup=0;
						    if(LimitsMaterials[MaterialsCalGuardats][1]>MaxDensDCM)
						      {
							MaxDensDCM=LimitsMaterials[MaterialsCalGuardats][1];
						      }
						    MaterialsCalGuardats++;
						  }
					      }
					  }
					std::cout<<"material limits loaded = "<<MaterialsCalGuardats<<"/"<<NumMatsCal<<std::endl;
					contCal=0;
					while(contCal<NumMatsCal)
					  {
					    std::cout<<"material "<<contCal+1<<": inf= "<<float(LimitsMaterials[contCal][0])<<" , sup= "<<float(LimitsMaterials[contCal][1])<<std::endl;
					    contCal++;
					  }			    
				      }
				    else
				      {
					NumMatsCal=12;
					//Aire
					LimitsMaterials[0][0]=0;
					LimitsMaterials[0][1]=0.2;
					//Pulmo unflat
					LimitsMaterials[1][0]=0.2;
					LimitsMaterials[1][1]=0.45;
					//Adipos
					LimitsMaterials[2][0]=0.45;
					LimitsMaterials[2][1]=1.1;
					//Gland
					LimitsMaterials[3][0]=1.1;
					LimitsMaterials[3][1]=1.25;
					//Soft tissue
					LimitsMaterials[4][0]=1.25;
					LimitsMaterials[4][1]=1.35;
					//Prostate
					LimitsMaterials[5][0]=1.35;
					LimitsMaterials[5][1]=1.45;			  
					//Heart
					LimitsMaterials[6][0]=1.45;
					LimitsMaterials[6][1]=1.55;			  
					//Liver
					LimitsMaterials[7][0]=1.55;
					LimitsMaterials[7][1]=1.65;			  
					//Eye lens
					LimitsMaterials[8][0]=1.65;
					LimitsMaterials[8][1]=1.80;			  
					//Cortical Bone
					LimitsMaterials[9][0]=1.80;
					LimitsMaterials[9][1]=2.5;
					MaxDensDCM=2.5;
				      }
				    ArxiuCal.close();
				    ////////////////////////////////////
				    ///////Contorns/////////////////////
				    ////////////////////////////////////		      
				    ArxiuCal.open("calibration.txt");
				    //Carreguem ara els materials si existeix la secció "---materials data---". Si no existeix es carregaran per defecte
				    //Anirem avançant en el fitxer de calibratge fins a arribar on posa "---materials data---"
				    AuxLinia.clear();
				    float PrioritatsContorns[MAX_NOMBRE_CONTORNS]; //Guarda les prioritats dels contorns
				    double DensitatsContorns[MAX_NOMBRE_CONTORNS]; //Guarda les densitats dels materials dels contorns
				    //Inicialitzem els vectors
				    int k=0;
				    while(k<MAX_NOMBRE_CONTORNS)
				      {
					PrioritatsContorns[k]=k+1;
					DensitatsContorns[k]=1; //Per defecte posem una densitat d' 1g/cm^3
					k++;
				      }

				    bool DadesContornTrobat=false;
				    while(getline(ArxiuCal,AuxLinia))
				      {
					if(AuxLinia=="---contour data---")
					  {
					    DadesContornTrobat=true;
					    break;
					  }
					AuxLinia.clear();
				      }
				    //Si trobem la secció carreguem les dades dels contorns
				    if(DadesContornTrobat==true)
				      {
					//El programa agafarà el número després del simbol "=", tot el que hi ha abans serà ignorat
					//La primera dada que ha d'estar és el nombre de materials
					//Primer pasem de tots els caracters fins a trobar un  '='
					char auxCharCal='a';
					while(auxCharCal!='=')
					  {
					    ArxiuCal>>auxCharCal;
					  }
					//Una vegada trobat el '=' agafem el nombre de contorns
					int NumContornsCal=0;
					ArxiuCal>>NumContornsCal;
					auxCharCal='a';
					//Si és major que el maxim, el reajustem
					if(NumContornsCal>MAX_NOMBRE_CONTORNS)
					  {
					    NumContornsCal=MAX_NOMBRE_CONTORNS;
					  }
					//Ara anirem buscant els '=' suposant que els contorns s'han introduït en ordre ascendent (c1,c2,c3,c4...)
					bool PrioritatODens=false;      //Si esta en "false" estem guardant la densitat, si esta en "true" la densitat
					//Els inicialitzem a zero
					int ContornsCalGuardats=0;
					while(ContornsCalGuardats<NumContornsCal)
					  {
					    int contFi=0;			//Contará les vegades que trobem un '-' seguides. Si són 3 vegades acaba la introducció de dades de la calibració
					    while(auxCharCal!='=')
					      {
						ArxiuCal>>auxCharCal;
						if(ArxiuCal.eof())
						  {
						    break;
						  }
						if(auxCharCal=='-')
						  {
						    contFi++;
						    if(contFi==3)
						      {
							break;
						      }
						  }
						else if(auxCharCal!='-')
						  {
						    contFi=0;
						  }
					      }
					    if(ArxiuCal.eof())
					      {
						break;
					      }
					    else if(contFi==3)
					      {
						contFi=0;
						break;
					      }
					    if(auxCharCal=='=')	//Si hem trobat un '=' agafem el numero que hi ha a continuació
					      {
						bool EspaisInicials=true;		//Controla si hem acabat d'agafar els espais entre el '=' i els números
						bool PuntDecimals=false;		//Controla si hem trobat un punt decimal
						bool Exponent=false;		//Controla si hem trobat un exponent
						bool PrincipiExponent=false;	//Controla si estem en el primer caracter de l'exponent
						std::string AuxFloat;
						while(1)
						  {
						    ArxiuCal>>auxCharCal;
						    if(auxCharCal==' ' && EspaisInicials==true)
						      {
							continue;
						      }
						    else if(auxCharCal=='-' && (EspaisInicials==true || PrincipiExponent==true) )
						      {
							AuxFloat+=auxCharCal;
							PrincipiExponent=false;
						      }				
						    else if(auxCharCal=='.' && PuntDecimals==false)
						      {
							PuntDecimals=true;
							EspaisInicials=false;
							AuxFloat+=auxCharCal;
						      }
						    else if((auxCharCal=='e' || auxCharCal=='E') && Exponent==false)
						      {
							Exponent=true;
							AuxFloat+=auxCharCal;
							PrincipiExponent=true;
						      }
						    else if(auxCharCal=='0' || auxCharCal=='1' || auxCharCal=='2' || auxCharCal=='3' || auxCharCal=='4' || auxCharCal=='5' || auxCharCal=='6' || auxCharCal=='7' || auxCharCal=='8' || auxCharCal=='9')
						      {
							EspaisInicials=false;
							AuxFloat+=auxCharCal;
							PrincipiExponent=false;
						      }
						    else
						      {
							PrincipiExponent=false;
							break;
						      }
						  }
						if(PrioritatODens==false)
						  {
						    PrioritatsContorns[ContornsCalGuardats]=atof(AuxFloat.c_str());
						    AuxFloat.clear();
						    PrioritatODens=true;
						  }
						else if(PrioritatODens==true)
						  {
						    DensitatsContorns[ContornsCalGuardats]=atof(AuxFloat.c_str());
						    AuxFloat.clear();
						    PrioritatODens=false;
						    if(MaxDensDCM<DensitatsContorns[ContornsCalGuardats])
						      {
							MaxDensDCM=DensitatsContorns[ContornsCalGuardats];
						      }
						    ContornsCalGuardats++;
						  }
					      }
					  }
					std::cout<<"Contour prioritys loaded = "<<ContornsCalGuardats<<"/"<<NumContornsCal<<std::endl;
					contCal=0;
					while(contCal<NumContornsCal)
					  {
					    std::cout<<"Contour "<<contCal+1<<": Priority = "<<PrioritatsContorns[contCal]<<" Density = "<<DensitatsContorns[contCal]<<" g/cm^3"<<std::endl;
					    contCal++;
					  }			    
				      }
				    else
				      {
					if(Idioma==0)
					  {
					    std::cout<<"Missing contour data"<<std::endl;
					  }
					else if(Idioma==1)
					  {
					    std::cout<<"No s'han asignat prioritats i densitats als contorns"<<std::endl;
					  }
					else if(Idioma==2)
					  {
					    std::cout<<"No se han asignado prioridades i densidades a los contornos"<<std::endl;
					  }
					int k=0;
					while(k<MAX_NOMBRE_CONTORNS)
					  {
					    PrioritatsContorns[k]=k+1;
					    DensitatsContorns[k]=1; //Per defecte posem una densitat d' 1g/cm^3
					    k++;
					  }
				      }		      
				    ArxiuCal.close();
				    
				    //Calculem l'interval de colors
				    IntervalColorDicom=(MaxDensDCM-MinDensDCM)*1.0/NumColorsResultats;
		     
				    //Si hem trobat dicoms, tindrém quants hi ha. Els carregarem un a un per ordre segons el número que tinguen just abans del .dcm.
				    //agafarem tots els números abans del '.dcm' fins trobar un caracter que no siga un número.
		      
				    int NumDicomsCarregats=0;
				    int NumDicomACarregar=0;		//Controla quin número de dicom hem de carregar, comença pel mes alt.
				    int NumDicom=0;			//Asi guardarem el numero de dicom del fitxer que estem mirant
				    int NovaDimensio[3];			//Redimensionarem l'espai segons la dimensió del dicom
				    NovaDimensio[0]=0;			//les inicialitzem a zero
				    NovaDimensio[1]=0;
				    NovaDimensio[2]=0;
				    int NumeroPlaZ=0;			//Controlarà quin pla hem d'omplir cada vegada

				    if(Idioma==0)
				      {
					std::cout<<"Loading "<<NumDicoms<<" DICOMs"<<std::endl;
				      }
				    else if(Idioma==1)
				      {
					std::cout<<"Carregant "<<NumDicoms<<" DICOMs"<<std::endl;
				      }
				    else if(Idioma==2)
				      {
					std::cout<<"Cargando "<<NumDicoms<<" DICOMs"<<std::endl;
				      }
				    //Obrim un arxiu on guardarem els valors dels pixels del DICOM
				    FILE * OutDicom;
				    OutDicom=fopen("TempDicom.dat", "wb" );
				    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
				    //Abans de carregar els Dicom, comprovem si existeix un dicom amb contorneig de zones. Aquest tindra el nom de "rtss.dcm"//
				    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
				    dicom::dicomfile* dfrtss;
				    dfrtss = dicom::open_dicomfile(Dicomrtss);
				    //Netegem les variables de contorneig
				    k=0;
				    while(k<Nombre_Contorns)
				      {
					int n=0;
					while(n<Nombre_Plans_Contorn[k])
					  {
					    delete [] Punts_Contorn[k][n];
					    n++;
					  }
					delete [] Punts_Contorn[k];
					delete [] Nombre_Punts_Contorn[k];
					Nombre_Plans_Contorn[k]=0;
					Color_Contorn[k][0]=0;
					Color_Contorn[k][1]=0;
					Color_Contorn[k][2]=0;
					Nom_Contorn[k].clear();
					Nombre_Voxels_Contorn[k]=0;
					k++;
				      }
				    Nombre_Contorns=0;
				    //comprovem si s'ha obert
				    if(dfrtss)
				      {
					if(Idioma==0)
					  {
					    std::cout<<"Loading DICOMs contours"<<std::endl;
					  }
					else if(Idioma==1)
					  {
					    std::cout<<"Carregant els contorns dels DICOMs"<<std::endl;
					  }
					else if(Idioma==2)
					  {
					    std::cout<<"Cargando los contornos de los DICOMs"<<std::endl;
					  }
			  
					Nombre_Contorns=0; //Conta el nombre de contorns
					bool Queden_Contorns=true; //Controla quan no queden contorns
					while(Queden_Contorns)
					  {
					    //Agafem el membre numero "Nombre_Contorns" del "Structure Set Roi Sequence"
					    dicom::dataset* ds=dfrtss->get_dataelement(0x30060020)->dataset_at(Nombre_Contorns); 

					    //Vegem si existeix el contorn numero "Nombre_Contorns"
					    if(ds!=NULL)
					      {
						//Agafem el nom del contorn
						Nom_Contorn[Nombre_Contorns] = ds->get_dataelement(0x30060026)->to_string();
						//Prenem ara el contorn i el seu color
						//Agafem el membre numero "Nombre_Contorns" del "Roi Contour Sequence"
						ds=dfrtss->get_dataelement(0x30060039)->dataset_at(Nombre_Contorns);
						if(ds!=NULL) //Asegurem que existeix el contorn numero "Nombre_Contorns"
						  {
						    int NumColors;
						    int* AuxColor;
						    ds->get_dataelement(0x3006002a)->to_int_values_a(&AuxColor,&NumColors); //Guardem el color

						    Color_Contorn[Nombre_Contorns][0]=AuxColor[0];
						    Color_Contorn[Nombre_Contorns][1]=AuxColor[1];
						    Color_Contorn[Nombre_Contorns][2]=AuxColor[2];
						    free(AuxColor);
						    //Agafem ara els diferents elements de la seqüencia de "Contour Sequence", la qual conte els punts del contorn ordenats per plans.
						    //Primer contem quants plans tenim
						    
						    while(1)
						      {
							dicom::dataset* ds2 = ds->get_dataelement(0x30060040)->dataset_at(Nombre_Plans_Contorn[Nombre_Contorns]);
							if(ds2!=NULL)
							  {
							    //Existeix un pla mes, per tant augmentem el nombre de punts
							    Nombre_Plans_Contorn[Nombre_Contorns]++;
							  }
							else
							  {
							    //No hi ha mes plans
							    break;
							  }
						      }
						    //Creem un vector amb el nombre de plans que hem trobat
						    if(Nombre_Plans_Contorn[Nombre_Contorns]>0)
						      {
							Punts_Contorn[Nombre_Contorns] = new double*[Nombre_Plans_Contorn[Nombre_Contorns]];
							Nombre_Punts_Contorn[Nombre_Contorns] = new int[Nombre_Plans_Contorn[Nombre_Contorns]];
						      }
						    int ContadorPlans=0;
						    while(ContadorPlans<Nombre_Plans_Contorn[Nombre_Contorns])
						      {
							double* AuxPunts;
							int AuxNumPunts=0;
							//Agafem l'element numero "ContadorContorn" de "Contour Sequence"
							dicom::dataset* ds2 = ds->get_dataelement(0x30060040)->dataset_at(ContadorPlans);
							if(ds2!=NULL) //Mirem si aquest element existeix
							  {
							    //Agafem els punts del contorn d'aquest pla i els pasem a cm
							    ds2->get_dataelement(0x30060050)->to_double_values_a(&AuxPunts, &AuxNumPunts);					     
							    int ContadorPasarcm=0;
							    while(ContadorPasarcm<AuxNumPunts)
							      {
								AuxPunts[ContadorPasarcm]=AuxPunts[ContadorPasarcm]*0.1;
								ContadorPasarcm++;
							      }
							    //creem el vector i guardem els punts
							    Nombre_Punts_Contorn[Nombre_Contorns][ContadorPlans]=AuxNumPunts;
							    Punts_Contorn[Nombre_Contorns][ContadorPlans] = new double[AuxNumPunts];
							    //Guardem els punts
							    int contadorCopiarPunts=0;
							    while(contadorCopiarPunts<AuxNumPunts)
							      {
								Punts_Contorn[Nombre_Contorns][ContadorPlans][contadorCopiarPunts]=AuxPunts[contadorCopiarPunts];
								contadorCopiarPunts++;
							      }
							      
							    ContadorPlans++;		      
					      
							  }
							else
							  {
							    //Si no existeix, eixim del bucle
							    break;
							  }
						      }
						    if(Idioma==0)
						      {
							std::cout<<"Contour "<<Nom_Contorn[Nombre_Contorns]<<" loaded with color "<<"("<<Color_Contorn[Nombre_Contorns][0]<<","<<Color_Contorn[Nombre_Contorns][1]<<","<<Color_Contorn[Nombre_Contorns][2]<<")"<<std::endl;
						      }
						    else if(Idioma==1)
						      {
							std::cout<<"Contorn "<<Nom_Contorn[Nombre_Contorns]<<" carregat amb el color "<<"("<<Color_Contorn[Nombre_Contorns][0]<<","<<Color_Contorn[Nombre_Contorns][1]<<","<<Color_Contorn[Nombre_Contorns][2]<<")"<<std::endl;
						      }
						    else if(Idioma==2)
						      {
							std::cout<<"Contorno "<<Nom_Contorn[Nombre_Contorns]<<" cargado con el color"<<"("<<Color_Contorn[Nombre_Contorns][0]<<","<<Color_Contorn[Nombre_Contorns][1]<<","<<Color_Contorn[Nombre_Contorns][2]<<")"<<std::endl;
						      }				      
						    Nombre_Contorns++;  //Augmentem el nombre de contorns
						  }
				  
					      }
					    else
					      {
						Queden_Contorns=false;
					      }
					  }
					//Igualem el nombre de materials al nombre de contorns +1
					NumMatsCal=Nombre_Contorns+1;
			  
				      }
				    else
				      {
					if(Idioma==0)
					  {
					    std::cout<<"Missing contours DICOM file (rtss.dcm)"<<std::endl;
					  }
					else if(Idioma==1)
					  {
					    std::cout<<"No s'ha trobat el DICOM amb els contorns (rtss.dcm)"<<std::endl;
					  }
					else if(Idioma==2)
					  {
					    std::cout<<"No se ha encontrado el DICOM con los contornos (rtss.dcm)"<<std::endl;
					  }					
				      }
				    delete dfrtss;
				    //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
				    //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
				    //Abans de carregar els Dicom, comprovem si existeix un dicom amb les posicions de les llavors. Aquest tindra el nom de "rtplan.dcm"//
				    //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
				    //Netegem les variables de llavors
				    k=0;
				    while(k<Nombre_Tipus_Llavors)
				      {
					delete [] Posicio_Llavor[k];
					Nombre_Llavors[k]=0;
					k++;
				      }
				    Nombre_Tipus_Llavors=0;
				    
				    dicom::dicomfile* dfrtplan;
				    dfrtplan = dicom::open_dicomfile(Dicomrtplan);
				    if(dfrtplan)   //Mirem si s'ha obert el dicom amb la planificacio de les llavors
				      {
					if(Idioma==0)
					  {
					    std::cout<<"Loading seeds planning"<<std::endl;
					  }
					else if(Idioma==1)
					  {
					    std::cout<<"Carregant la planificació de les llavors"<<std::endl;
					  }
					else if(Idioma==2)
					  {
					    std::cout<<"Cargando la planificación de las semillas"<<std::endl;
					  }
					Nombre_Tipus_Llavors=0;
					bool Queden_Tipus_Llavor=true; //Controla quan no queden contorns
					while(Queden_Tipus_Llavor)
					  {
					    //Agafem el membre numero "Nombre_Tipus_Llavors" del "Application Setup Sequence"
					    dicom::dataset* ds=dfrtss->get_dataelement(0x300a0230)->dataset_at(Nombre_Tipus_Llavors); 

					    //Vegem si existeix el tipus de llavor numero "Nombre_Tipus_Llavors"
					    if(ds!=NULL)
					      {
						int Nombre_Canals=0;
						Nombre_Llavors[Nombre_Tipus_Llavors]=0;
						//Prenem ara el nombre de canals (cateters) del "Channel Sequence"
						bool Queden_Canals=true;
						while(Queden_Canals)
						  {
						    //Agafem el membre numero "Nombre_Canals" del "Channel Sequence"
						    dicom::dataset* ds2 = ds->get_dataelement(0x300a0280)->dataset_at(Nombre_Canals);
						    if(ds2!=NULL) //Asegurem que existeix el canal "Nombre_Canals"
						      {							
							Nombre_Canals++;
							double Temps_Anterior=-1; //Guarda el "Cumulative Time Weight" que es el temps en el que la llavor ha pasat un punt de control. En els punts de controls amb el mateix "Cumulative Time Weight" que el punt de control anterior, significarà que la llavor ha pasat de llarg i no es queda a aquest punt.
							//Calculem ara el nombre de llavors a aquest canal
							bool Queden_Punts_Control=true;
							int contador_punts_control=0;
							while(Queden_Punts_Control)
							  {
							    //std::cout<<"caca "<<Nombre_Canals<<" Punt contol: "<<contador_punts_control<<std::endl;
							    //Agafem el membre numero "contador_punts_control" del "Brachy Control Point Sequence"
							    dicom::dataset* ds3 = ds2->get_dataelement(0x300a02d0)->dataset_at(contador_punts_control);
							    if(ds3!=NULL) //Vegem si existeix el punt de control "contador_punts_control"
							      {
								if(Temps_Anterior==-1) //Si te el valor -1 vol dir que estem en el primer punt de control
								  {
								    Temps_Anterior = ds3 -> get_dataelement(0x300a02d6)->to_double(); //Agafem aquest com a temps anterior
								  }
								else
								  {
								    double Temps_Actual = ds3 -> get_dataelement(0x300a02d6)->to_double();
								    if(Temps_Anterior!=Temps_Actual)
								      {
									//Si els temps són diferents, una llavor roman en aquesta posició i per tant tenim un punt més on es coloca una llavor.
									Nombre_Llavors[Nombre_Tipus_Llavors]++;
									Temps_Anterior=Temps_Actual;
								      }
								  }
								contador_punts_control++;
							      }
							    else
							      {
								Queden_Punts_Control=false;
							      }
							  }
						      }
						    else
						      {
							Queden_Canals=false;
						      }
						  }
						////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
						//Una vegada coneixem el nombre de posicions on va una llavor, pasem a llegir aquestes posicions                      //
						////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
						//Creem els vectors pertinents
						Posicio_Llavor[Nombre_Tipus_Llavors] = new double[Nombre_Llavors[Nombre_Tipus_Llavors]*3]; //3 components per posicio de llavor (x,y,z)

						int contador_llavors=0;  //Recorre el vector Posicio_Llavor
						int contador_canals_llavors=0;
						while(contador_canals_llavors<Nombre_Canals)
						  {
						    
						    //Agafem el membre numero "contador_canals_llavors" del "Channel Sequence"
						    dicom::dataset* ds2 = ds->get_dataelement(0x300a0280)->dataset_at(contador_canals_llavors);
						    if(ds2!=NULL) //Asegurem que existeix el canal "contador_canals_llavors"
						      {
							double Temps_Anterior=-1; //Guarda el "Cumulative Time Weight" que es el temps en el que la llavor ha pasat un punt de control. En els punts de controls amb el mateix "Cumulative Time Weight" que el punt de control anterior, significarà que la llavor ha pasat de llarg i no es queda a aquest punt.
							//Calculem ara el nombre de llavors a aquest canal
							bool Queden_Punts_Control=true;
							int contador_punts_control=0;
							while(Queden_Punts_Control)
							  {
							    //Agafem el membre numero "contador_punts_control" del "Brachy Control Point Sequence"
							    dicom::dataset* ds3 = ds2->get_dataelement(0x300a02d0)->dataset_at(contador_punts_control);
							    if(ds3!=NULL) //Vegem si existeix el punt de control "contador_punts_control"
							      {
								if(Temps_Anterior==-1) //Si te el valor -1 vol dir que estem en el primer punt de control
								  {
								    Temps_Anterior = ds3 -> get_dataelement(0x300a02d6)->to_double(); //Agafem aquest com a temps anterior
								  }
								else
								  {
								    double Temps_Actual = ds3 -> get_dataelement(0x300a02d6)->to_double();
								    if(Temps_Anterior!=Temps_Actual)
								      {
									//Si els temps són diferents, una llavor roman en aquesta posició i per tant tenim un punt més on es coloca una llavor.

									double* AuxPosicio;
									int AuxNumComponents;
									ds3 -> get_dataelement(0x300a02d4)->to_double_values_a(&AuxPosicio, &AuxNumComponents);
									
									Posicio_Llavor[Nombre_Tipus_Llavors][contador_llavors]=AuxPosicio[0]*0.1; //Pasem a cm
									contador_llavors++;
									Posicio_Llavor[Nombre_Tipus_Llavors][contador_llavors]=AuxPosicio[1]*0.1; //Pasem a cm
									contador_llavors++;
									Posicio_Llavor[Nombre_Tipus_Llavors][contador_llavors]=AuxPosicio[2]*0.1; //Pasem a cm
									contador_llavors++;

									//printf("Posicio llavor = (%.5f,%.5f,%.5f)\n",AuxPosicio[0],AuxPosicio[1],AuxPosicio[2]);
									//printf("Posicio llavor = (%.5f,%.5f,%.5f)\n",Posicio_Llavor[Nombre_Tipus_Llavors][contador_llavors-3],Posicio_Llavor[Nombre_Tipus_Llavors][contador_llavors-2],Posicio_Llavor[Nombre_Tipus_Llavors][contador_llavors-1]);
									free(AuxPosicio);
									Temps_Anterior=Temps_Actual;
								      }
								  }
								contador_punts_control++;
							      }
							    else
							      {
								Queden_Punts_Control=false;
							      }
							  }
						      }
						    contador_canals_llavors++;
						  }

						if(Idioma==0)
						  {
						    std::cout<<Nombre_Llavors[Nombre_Tipus_Llavors]<<" seeds loaded of type "<<Nombre_Tipus_Llavors+1<<std::endl;
						  }
						else if(Idioma==1)
						  {
						    std::cout<<"S'han carregat "<<Nombre_Llavors[Nombre_Tipus_Llavors]<<" llavors del tipus "<<Nombre_Tipus_Llavors+1<<std::endl;
						  }
						else if(Idioma==2)
						  {
						    std::cout<<"Se han cargado "<<Nombre_Llavors[Nombre_Tipus_Llavors]<<" semillas del tipo "<<Nombre_Tipus_Llavors+1<<std::endl;
						  }
						
						Nombre_Tipus_Llavors++;						
					      }
					    else
					      {
						Queden_Tipus_Llavor=false;
					      }					    				       
					    
					  }
				      }
				    else
				      {
					if(Idioma==0)
					  {
					    std::cout<<"Missing seeds planing DICOM file (rtplan.dcm)"<<std::endl;
					  }
					else if(Idioma==1)
					  {
					    std::cout<<"No s'ha trobat el DICOM amb la planificació de les llavors (rtplan.dcm)"<<std::endl;
					  }
					else if(Idioma==2)
					  {
					    std::cout<<"No se ha encontrado el DICOM con la planificación de las semillas (rtplan.dcm)"<<std::endl;
					  }					
				      }				    
				    delete dfrtplan;
				    //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
				    float DimVoxelDicom[3]={0};             //Guarda les dimensions dels voxels
				    while(NumDicomsCarregats<NumDicoms)			//El bucle es repetira fins carregar tots els .dcm
				      {
					bool NumeroTrobat=false;		//amb açò comprovarem que s'han trobat tots desde 0 fins a NumDicoms
					//Amb el mateix sistema que abans, anem llegit el nom de tots els fitxers i pararem en aquells que tinguen extensió .dcm
					//Primer hem de tancar el directori i tornar-lo a obrir perque sino ja haura recorregut els noms de tots els arxius i tornara null
					closedir(DirectoriAux);
					AuxString.clear();
					AuxString=std::string(Actualdir)+std::string("/")+NomDicom;
					DirectoriAux=opendir(AuxString.c_str());
					while((data=readdir(DirectoriAux))!=NULL)		//llegim el directori guardant la informació d'un dels fitxers en cada cicle
					  {
					    NumCaracters=sprintf(AuxChar,"%s",data->d_name);	//Guardem el nom de l'arxiu (d_name) en AuxChar i el nombre de caracters en NumCaracters
					    int j=0;
					    if(AuxChar[0]!='.')				//No mirem els arxiu ocults (.Nom)
					      {
						//comprovarem que l'extensió és .dcm comparant els 4 últims caracters
						if(AuxChar[NumCaracters-1]=='m' && AuxChar[NumCaracters-2]=='c' && AuxChar[NumCaracters-3]=='d' && AuxChar[NumCaracters-4]=='.')
						  {
						    //Si te extensio .dcm mirem si es un dicom amb plans de la imatge
						    dicom::dicomfile* dfNum;
						    dicom::dataelement* deNum;
						    dfNum = dicom::open_dicomfile(AuxChar);
						    if(dfNum!=NULL)
						      {
							//Mirem primer la modalitat del dicom, per a veure si es una de les permeses
							deNum = dfNum->get_dataelement(0x00080060);
							if(deNum -> is_valid()) //Mirem que puga llegir la modalitat
							  {
							    std::string AuxModalitat = deNum -> to_string();
							    if(AuxModalitat == "US" || AuxModalitat == "CT")
							      {
								//Si s'acompleix, aquesta modalitat esta permesa
								//Comprovem si conte l'element amb la posicio de la imatge
								deNum = dfNum -> get_dataelement(0x00200032);
								if(deNum -> is_valid())
								  {
								    //Agafem la coordenada Z del pla
								    double* AuxPos;
								    int AuxNumComp;
								    deNum -> to_double_values_a(&AuxPos, &AuxNumComp);

								    //Anem pasant plans fins trobar el d'aquest dicom
								    int contador_buscar_pla=0;
								    bool PlaTrobat=false;
								    while(contador_buscar_pla<NumDicoms)
								      {
									if(AuxPos[2] == PlansZDicoms[contador_buscar_pla])
									  {
									    PlaTrobat=true;
									    NumDicom=contador_buscar_pla;
									    break;
									  }
									contador_buscar_pla++;
								      }
								    free(AuxPos);
								    if(PlaTrobat==false){NumDicom=-1;}
								  }
								else
								  {
								    //Aquest dicom no conte plans de la imatge
								    NumDicom=-1;
								  }

							      }
							    else
							      {
								NumDicom=-1;
							      }
							  }
							else
							  {
							    NumDicom=-1;
							  }
						      }
						    else
						      {
							NumDicom=-1;
						      }
						    delete dfNum;
						    
						    
						    //Ara comprovem si aquest és l'arxiu que toca carregar, sino ho és pasarem al següent
						    if(NumDicom==NumDicomACarregar)
						      {
							std::cout.precision(2);
							std::cout<<"\r"<<NumDicomsCarregats+1<<"/"<<NumDicoms<<" ("<<(NumDicomsCarregats+1)*100.0/NumDicoms<<")%            ";
							fflush( stdout );
							std::cout.precision(6);
							//si hem trobat el que toca, pasem ara a guardar-lo a la matriu de voxelitzat
							NumeroTrobat=true;
				    
							//declarem una variable dicomfile
							dicom::dicomfile *df;
							//obrim el dicom
							df=dicom::open_dicomfile(AuxChar);
							//Comprovem que s'ha obert be
							if(df)
							  {
							    //Si s'ha obert correctament, agafem l'amplada, altura en nombre de pixels, el nombre de frames i el nombre de bytesper pixel
							    int width, height;  //Agafem el nombre de columnes i files en pixels
							    int precision, signedness, ncomponents, bytes_per_pixel;
							    int nframes;  //Ens diu el nombre de plans que conte la imatge
							    df->get_image_info(&width, &height,
									       &precision, &signedness, &ncomponents, &bytes_per_pixel,
									       &nframes);
							    //Agafem altra informació necessària per al tractat de les dades

							    //Agafem si utilitza RGB, MONOCHROME2, MONOCHROME1 etc
							    std::string PhotometricInterpretation =
							      df->get_dataelement("PhotometricInterpretation")->to_string();
							    std::string PixelSpacing =
							      df->get_dataelement("PixelSpacing")->to_string();
							    //Mirem si els pixels son amb signe (1) o unsigned (0)
							    int PixelRep =
							      df->get_dataelement("PixelRepresentation")->to_int();
							    //Mirem com hem de reescalar els pixels (No l'agafa be)
							    //std::string ModalityLUTSequence =
							    //              df->get_dataelement(0x00283000)->to_string("N/A");
							    //std::cout<<ModalityLUTSequence<<std::endl;
							    //Les seguents 2 variables, RescaleIntercept i RescaleSlope, ens calen per a transformar el valor que prenen els pixels de la forma RescaleSlope*Valor_Pixel+RescaleIntercept, i obtindre així el valor final del pixel.
							    int RescaleIntercept =
							      df->get_dataelement("RescaleIntercept")->to_int();		
							    int RescaleSlope =
							      df->get_dataelement("RescaleSlope")->to_int();
							    if(RescaleSlope==0){RescaleSlope=1;}
							    //printf("%d \n",RescaleSlope);						  
							    //////////////////////////////////////////////////////////////////////////
							    //Mirem en quin tipus d'escaner s'ha pres la imatge
							    std::string Modality =
							      df->get_dataelement(0x00080060)->to_string("N/A");
							    //Comprovem que la modalitat es una de les que el programa suporta
							    if(Modality!="CT" && Modality!="US")
							      {
								std::cout<<"Warning: Modality of the dicom ("<<Modality<<") is not supported"<<std::endl;
								delete df;
								break;
							      }
							    else
							      {
								ModalitatDicom=Modality;
							      }
							    //////////////////////////////////////////////////////////////////////////
							    int SamplesPerPixel =
							      df->get_dataelement("SamplesPerPixel")->to_int();
							    //Agafem els bits reservats en el buffer per a cada "sample" de cada pixel
							    //int AllocatedBits =
							    //  df->get_dataelement("BitsAllocated")->to_int();
							    //Agafem quants d'aquests bits reservats s'utilitzen realment
							    int StoredBits =
							      df->get_dataelement("BitsStored")->to_int();
							    //HighBit ens dira on esta l'ultim Bit i per tant si llig de dreta a esquerra o viceversa
							    int HighBit =
							      df->get_dataelement("HighBit")->to_int();
							    //Agafem el gruix de cada pla
							    std::string SliceThickness =
							      df->get_dataelement("SliceThickness")->to_string();
							    std::string studydesc =
							      df->get_dataelement("StudyDescription")->to_string();				      
				      
							    //Comprovem abans de carregar els pixels, que aquest .dcm gasta escala de grisos. Açò es complirà si el "SamplesPerPixel" és 1
				      
							    if(SamplesPerPixel!=1)
							      {
								error++;
								if(Idioma==0)
								  {
								    std::cout<<"Error: The image format is not grayscale"<<std::endl;
								  }
								else if(Idioma==1)
								  {
								    std::cout<<"Error: El format de la imatge no es escala de grisos"<<std::endl;
								  }
								else if(Idioma==2)
								  {
								    std::cout<<"Error: El formato de la imagen no es escala de grises"<<std::endl;
								  }
								delete df;
								break;
							      }
				      
							    //creem ara un buffer amb les dimensions necessàries per a guardar tots els pixels
							    char* pixeldata= new char[width*height*bytes_per_pixel];
							    int pixeldata_length;		//guarda el nombre de pixels
							    //Carreguem els pixels
							    df->get_pixeldata_a(&pixeldata, &pixeldata_length);
							    //Comprovem si s'han carregat i comencem a transformar el valor dels pixels a densitats i material i guardar-ho a la matriu de vòxels
							    //Prenem el conveni que l'origen es troba al canto dalt esquerra. Tambe agafem la posició de la imatge del primer pla, per a saber el desplaçament respecte del (0,0,0)
							    if (pixeldata) 
							      {
								//Si encara no s'han agafat noves dimensions, les agafem ara i fem les transformacions sobre els contorns i llavors per a pasar al nostre sistema de coordenades//
								if(NovaDimensio[0]==0 && NovaDimensio[1]==0)
								  {
								    NovaDimensio[0]=width;
								    NovaDimensio[1]=height;
								    /////////////////////////////////////////////////
								    //Agafem l'origen del pla inferior de la imatge//
								    double* AuxOrigenDicom;
								    int auxInt;
								    df->get_dataelement(0x00200032)->to_double_values_a(&AuxOrigenDicom, &auxInt);
								    Origen_Dicom[0]=AuxOrigenDicom[0]*0.1; //Pasem a cm
								    Origen_Dicom[1]=AuxOrigenDicom[1]*0.1; //Pasem a cm
								    Origen_Dicom[2]=AuxOrigenDicom[2]*0.1; //Pasem a cm

								    free(AuxOrigenDicom);

								    /////////////////////////////////////////////////
								    //agafem el tamany dels pixels de la imatge
								    std::string DimYPixelAux;
								    std::string DimXPixelAux;
								    j=0;
								    int contadorDimYPixel=0;
								    while(PixelSpacing[j]!=92 && PixelSpacing[j]!='/')	//Agafarem caracters fins a trobar una barra
								      {
									DimYPixelAux[contadorDimYPixel]=PixelSpacing[j];
									j++;
									contadorDimYPixel++;
								      }
								    //Ara j es troba sobre el caracter amb la barra, augmentem 1 i agafem la resta de caracters
								    j++;
								    int contadorDimXPixel=0;
								    while(PixelSpacing[j]!='\0')	//Agafarem caracters fins a trobar una barra
								      {
									DimXPixelAux[contadorDimXPixel]=PixelSpacing[j];
									j++;
									contadorDimXPixel++;
								      }
								    //els pasem ara a un float
								    float DimYPixel=atof(DimYPixelAux.c_str());
								    float DimXPixel=atof(DimXPixelAux.c_str());
					  
								    DimVoxelDicom[0]=DimXPixel/10.0;
								    DimVoxelDicom[1]=DimYPixel/10.0;
								    DimVoxelDicom[2]=atof(SliceThickness.c_str())/10.0;
								    int DimensionsDicom[2]={width,height};
								    //Guardem les dimensions a l'arxiu de text//
								    fwrite(DimensionsDicom,sizeof(int),2,OutDicom);
								    fwrite(DimVoxelDicom,sizeof(float),3,OutDicom);
								    //OutDicom<<width<<","<<height<<","<<DimXPixel/10.0<<","<<DimYPixel/10.0<<","<<atof(SliceThickness.c_str())/10.0<<",";
								    ////////////////////////////////////////////
								    //Guardem les dimensions de l'espai del dicom. La dimensió z la completarem al coneixer el nombre total de plans (al finalitzar la càrrega dels dicom)
								    DimEspaiDicom[0]=width*DimXPixel/10.0;
								    DimEspaiDicom[1]=height*DimYPixel/10.0;
								    DimEspaiDicom[2]=atof(SliceThickness.c_str())/10.0;

								    ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
								    //Apliquem una translacio sobre els punts dels contorns (si en tenim) per a que l'origen d'aquests siga el (0,0,0)//
								    j=0;
								    while(j<Nombre_Contorns)
								      {
									int i=0;
									while(i<Nombre_Plans_Contorn[j])
									  {
									    int k=0;
									    while(k<Nombre_Punts_Contorn[j][i])
									      {
										Punts_Contorn[j][i][k]-=Origen_Dicom[0];
										k++;
										Punts_Contorn[j][i][k]-=Origen_Dicom[1];
										Punts_Contorn[j][i][k]=-Punts_Contorn[j][i][k]+DimEspaiDicom[1]; //Apliquem una reflexio en la coordenada Y dels contorns, ja que el dicom te l'origen en el canto esquerra superior i no inferior.
										k++;
										Punts_Contorn[j][i][k]-=Origen_Dicom[2];
										k++;
									      }
									    i++;
									  }
									j++;
								      }
								    ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
								    //////////////////////////////////////////////////////////////
								    //Apliquem una translació sobre les posicions de les llavors//
								    j=0;
								    while(j<Nombre_Tipus_Llavors)
								      {
									int i=0;
									while(i<Nombre_Llavors[j]*3) //multipliquem per 3 el nombre de llavors, ja que tenim 3 components 
									  {
										Posicio_Llavor[j][i]-=Origen_Dicom[0];
										i++;
										Posicio_Llavor[j][i]-=Origen_Dicom[1];										
										Posicio_Llavor[j][i]=-Posicio_Llavor[j][i]+DimEspaiDicom[1]; //Apliquem una reflexio en la coordenada Y dels contorns, ja que el dicom te l'origen en el canto esquerra superior i no en l'inferior.
										i++;
										Posicio_Llavor[j][i]-=Origen_Dicom[2];
										i++;
										//printf("Posicio llavor = (%.5f,%.5f,%.5f)\n",Posicio_Llavor[j][i-3],Posicio_Llavor[j][i-2],Posicio_Llavor[j][i-1]);
									  }
									j++;
								      }
								    //////////////////////////////////////////////////////////////
								  }
								else	//Comprovem que les dimensions de tots els dicom coincideixen
								  {
								    if(NovaDimensio[0]!=width || NovaDimensio[1]!=height)
								      {
						    
									if(Idioma==0)
									  {
									    std::cout<<"Error: DICOM size mismatched"<<std::endl;
									  }
									else if(Idioma==1)
									  {
									    std::cout<<"Error: Les dimensions dels DICOM no coincideixen"<<std::endl;
									  }
									else if(Idioma==2)
									  {
									    std::cout<<"Error: Las dimensiones de los DICOM no coinciden"<<std::endl;
									  }
									delete df;		
									delete pixeldata;
									break;	//deixem de carregar aquest .dcm				
								      }
								  }
								int i=0;		//recorre l'eix x (amplada)
								j=0;		        //recorre l'eix y (altura)
								int k=0;		//recorre els fames (eix z)
								int Nbyte=0;	//recorre les posicions del pixeldata
								while(k<nframes)
								  {
								    //Primer calculem la posicio del centre del voxel
								    double PosVoxel[3];
								    PosVoxel[2]=NumeroPlaZ*DimVoxelDicom[2]+DimVoxelDicom[2]*0.5; //Calculem la posicio Z
								    double PosVoxelZAnterior=(NumeroPlaZ-1)*DimVoxelDicom[2]+DimVoxelDicom[2]*0.5;
								    int* PlaZ_Conte_Voxel = new int[Nombre_Contorns+1]; //Guarda el pla de cada contorn que conte el voxel (Guarda el numero, primer, segon etc). +1 per a evitar els crear un vector de 0 components
								    //std::cout<<"Dim voxel = "<<DimVoxelDicom[2]<<std::endl;
								    /////////////////////////////////////////////////////////////
								    //Busquem el pla de cada contorn que conte el voxel
								    j=0;
								    while(j<Nombre_Contorns)
								      {
									PlaZ_Conte_Voxel[j]=-1; //Si es queda en -1, significa que no tenim pla que continga aquest voxel
									i=0;
									while(i<Nombre_Plans_Contorn[j])
									  {									    
									    if(Punts_Contorn[j][i][2]>PosVoxelZAnterior && Punts_Contorn[j][i][2]<=PosVoxel[2]) //Mirem si la component z dels punts d'aquest pla del contorn esta entre el centre del voxel actual i l'anterior
									      {
										PlaZ_Conte_Voxel[j]=i;
										break;
									      }
									    i++;
									  }
									j++;
								      }
								    j=0;
								    while(j<height)
								      {
									PosVoxel[1]=j*DimVoxelDicom[1]+DimVoxelDicom[1]*0.5; //Calculem la posicio Y
									i=0;
									while(i<width)
									  {
									    PosVoxel[0]=i*DimVoxelDicom[0]+DimVoxelDicom[0]*0.5; //Calculem la posicio X
									    std::string Aux;
									    Aux.clear();
									    int cont=0;
									    while(cont<bytes_per_pixel)
									      {
										Aux[cont]=pixeldata[Nbyte];
										cont++;
										Nbyte++;
									      }
									    //Declarem una variable per a guardar la densitat del vòxel i una per al material
									    float densitatPixel=0.0;
									    int materialPixel=0;					      
									    //una vegada tenim els bytes del pixel, ho pasem a un integer
									    //hem de tindre en compte si els pixels son unsigned o signed
									    if(PixelRep==0) 	//unsigned
									      {
										unsigned int auxint1=0;
										if(HighBit==StoredBits-1)	//si s'acompleix aço, llegim d'esquerra a dreta
										  {
										    cont=bytes_per_pixel-1;
										    while(cont>=0)	//anem guardat els bytes 
										      {
											auxint1 = (auxint1 << 8) +Aux[cont];
											cont--;
										      }						  
										  }
										else if(HighBit==0)	//ara en canvi llegim de dreta a esquerra
										  {
										    cont=0;
										    while(cont<bytes_per_pixel)	//anem guardat els bytes 
										      {
											auxint1 = (auxint1 << 8) +Aux[cont];
											cont++;
										      }
										  }
										//Assignem la densitat del pixel segons la "modalitat"
										if(Modality=="CT")
										  {
										    //ara amb la recta de calibració calculem el valor
										    int auxint2=RescaleSlope*auxint1+RescaleIntercept;
										    //ho pasem a densitat i material per a finalment guardar-ho al vòxel corresponent
										    //Calculem ara la densitat electronica relativa a l'aigua del vòxel utilitzant el polinomi de la calibració de l'aparell
										    float DensElec=0;
										    cont=0;
										    while(cont<GrauPolCal)	//Primer amb el polinomi de calibratge calculem la densitat electrònica
										      {
											DensElec+=CoeficientsCal[cont]*pow(auxint2,cont);
											cont++;
										      }
										    //Ara dividim per la densitat electronica de l'aigua per a obtindre la relativa
										    DensElec=DensElec*1.0/DElecW;
										    //utilitzem ara l'ajust del TG_186 per a calcular la densitat
										    densitatPixel=-0.1746+1.176*DensElec;
										  }
										else if(Modality=="US")
										  {
										    //En aquest cas la densitat del pixel s'asigna segons el material del contorn. Primer li posem per defecte la de l'aigua
										    densitatPixel=1.0000000000;		       
										  }
										if(densitatPixel<0)
										  {
										    //No permetem densitats negatives
										    densitatPixel=0;
										  }
									      }
									    else if(PixelRep==1)	//signed
									      {
										int auxint1=0;
										if(HighBit==StoredBits-1)	//si s'acompleix aço, llegim d'esquerra a dreta
										  {
										    cont=bytes_per_pixel-1;
										    while(cont>=0)	//anem guardat els bytes 
										      {
											auxint1 = (auxint1 << 8) +Aux[cont];
											cont--;
										      }
										  }
										else if(HighBit==0)	//ara en canvi llegim de dreta a esquerra
										  {
										    cont=0;
										    while(cont<bytes_per_pixel)	//anem guardat els bytes 
										      {
											auxint1 = (auxint1 << 8) +Aux[cont];
											cont++;
										      }
										  }
										//Assignem la densitat del pixel segons la "modalitat"
										if(Modality=="CT")
										  {
										    //ara amb la recta de calibració calculem el valor
										    int auxint2=RescaleSlope*auxint1+RescaleIntercept;
										    //ho pasem a densitat i material per a finalment guardar-ho al vòxel corresponent
										    //Calculem ara la densitat electronica relativa a l'aigua del vòxel utilitzant el polinomi de la calibració de l'aparell
										    float DensElec=0;
										    cont=0;
										    while(cont<GrauPolCal)	//Primer amb el polinomi de calibratge calculem la densitat electrònica
										      {
											DensElec+=CoeficientsCal[cont]*pow(auxint2,cont);
											cont++;
										      }
										    //Ara dividim per la densitat electronica de l'aigua per a obtindre la relativa
										    DensElec=DensElec*1.0/DElecW;
										    //utilitzem ara l'ajust del TG_186 per a calcular la densitat
										    densitatPixel=-0.1746+1.176*DensElec;
										  }
										else if(Modality=="US")
										  {
										    //En aquest cas la densitat del pixel s'asigna segons el material del contorn. Primer li posem per defecte la de l'aigua
										    densitatPixel=1.0000000000;
										  }
										if(densitatPixel<0)
										  {
										    //No permetem densitats negatives
										    densitatPixel=0;
										  }
									      }
									    ///////////////////////////////
									    //Asignacio de material////////
									    ///////////////////////////////
									    //Una vegada tenim la densitat del vòxel asignarem el número de material a partir de les especificacions de l'arxiu o dels parametres per defecte
									    if(Modality=="CT")
									      {
										cont=0;
										bool MaterialAsignat=false;
										while(cont<NumMatsCal)
										  {
										    if(densitatPixel>=LimitsMaterials[cont][0] && densitatPixel<LimitsMaterials[cont][1])
										      {
											materialPixel=cont+1;
											MaterialAsignat=true;
											break;
										      }
										    cont++;
										  }
										//A tots els vòxels fora dels rangs li asignarem el mateix material
										if(MaterialAsignat==false)
										  {
										    materialPixel=NumMatsCal+1;
										  }
									      }
									    else if(Modality=="US")
									      {
										//Mirem si aquest punt es troba dins dels contorns
										bool DinsContorn[MAX_NOMBRE_CONTORNS]={0}; //Guarda si el punt es troba dins del contorn

										//Per a comprovar si el voxel es troba dins del contorn, tracem una recta amb la component x fixa i igual a la component x del voxel amb origen amb y=-1, per a asegurar que es troba fora del contorn, i que travese tot l'espai. Vegent quan intercecta amb els segments que delimiten el pla amb z constant del contorn, sabrem quan ens trobem dins i fora del contorn i aixi si el voxel es troba dins o fora.
										//Creem l'origen de la recta
										double Origen_Recta[2]={PosVoxel[0],-1.0}; //coordenades {x,y}						  
										int z=0;
										while(z<Nombre_Contorns)
										  {
										    DinsContorn[z]=false;
										    //Mirem si hi ha un pla que continga el voxel en aquest contorn
										    if(PlaZ_Conte_Voxel[z]==-1)
										      {
											z++;
											continue;
										      }
										    //Mirem els diferents segments dels plans inferior i superior
										    double* Y_Tall = new double[Nombre_Punts_Contorn[z][PlaZ_Conte_Voxel[z]]]; //Guarda les coordenades Y on la recta talla algun segment del pla del contorn
										    int Nombre_Talls=0; //Vegades que talla el pla del contorn
										    /////////////////////////////////////////
										    //Busquem els talls del pla//////////////
										    /////////////////////////////////////////
										    int n=0;
										    while(n<Nombre_Punts_Contorn[z][PlaZ_Conte_Voxel[z]])
										      {
											//Agafem punts de 2 en 2 per a formar segments i mirem si la recta pasa entre ells
											int Coordenada_x_Punt_Seguent;
											if(n==Nombre_Punts_Contorn[z][PlaZ_Conte_Voxel[z]]-3)
											  {
											    //Estem a l'ultim punt, per tant agafem el primer punt per a fer el segment
											    Coordenada_x_Punt_Seguent = 0;
											  }
											else{Coordenada_x_Punt_Seguent = n+3;}
							  
											if(((Punts_Contorn[z][PlaZ_Conte_Voxel[z]][n]>=Origen_Recta[0] && Punts_Contorn[z][PlaZ_Conte_Voxel[z]][Coordenada_x_Punt_Seguent]<=Origen_Recta[0]) || (Punts_Contorn[z][PlaZ_Conte_Voxel[z]][n]<=Origen_Recta[0] && Punts_Contorn[z][PlaZ_Conte_Voxel[z]][Coordenada_x_Punt_Seguent]>=Origen_Recta[0])) && (Punts_Contorn[z][PlaZ_Conte_Voxel[z]][n]!=Punts_Contorn[z][PlaZ_Conte_Voxel[z]][Coordenada_x_Punt_Seguent]))
											  {
											    //Per a saber si talla el segment entre els 2 punts, mirem dues coses:
											    //1-> Que la component x d'un punt estiga a la part dreta de la recta o sobre esta i que la component x de l'altre estiga a la part esquerra o sobre esta.
											    //2-> Que els dos  punts no tinguen la mateixa component X, ja que si acompleix la primer pero no la segona, la recta pasara pels 2 punts i per tant paralela al segment que formen i no estara entrat o eixint de la superficie del contorn.
											    //Mirem ara on talla la recta al segment
											    double pendent = (Punts_Contorn[z][PlaZ_Conte_Voxel[z]][Coordenada_x_Punt_Seguent+1]-Punts_Contorn[z][PlaZ_Conte_Voxel[z]][n+1])/(Punts_Contorn[z][PlaZ_Conte_Voxel[z]][Coordenada_x_Punt_Seguent]-Punts_Contorn[z][PlaZ_Conte_Voxel[z]][n]);  //Pendent del segment entre els punts
											    Y_Tall[Nombre_Talls] = Origen_Recta[0]*pendent+Punts_Contorn[z][PlaZ_Conte_Voxel[z]][n+1]-pendent*Punts_Contorn[z][PlaZ_Conte_Voxel[z]][n];
											    Nombre_Talls++;
											  }
											n=n+3;
										      }
										    //Una vegada tenim tots els punts on talla, els ordenem de menor a major
										    ordenar(Y_Tall, Nombre_Talls);
										    //Una vegada ordentas, pasem a veure si el voxel esta dins
										    n=0;
										    bool Dins=false;   //Controla si ens trobem dins o fora del contorn. Comença per false ja que inicialment estem fora el contorn
										    while(n<Nombre_Talls)
										      {
											if(PosVoxel[1]<Y_Tall[n])
											  {
											    //Si trobem el punt abans que el proxim tall, parem el bucle i ens quedarem en la posicio actual (dins o fora)
											    break;
											  }
											if(Dins==false){Dins=true;}else{Dins=false;}
											n++;
										      }
										    DinsContorn[z]=Dins;
										    //Eliminem el vector
										    delete [] Y_Tall;
										    z++;
										  }
										//Una vegada tenim dins de quins contorns esta, hem de decidir el material que li asignem
										int Prioritat_Material=0; //Guarda la prioritat del contorn que te asignat actualment
										z=0;
										while(z<Nombre_Contorns)
										  {
										    if(DinsContorn[z]==true) //Mirem si esta dins d'aquest contorn
										      {
											if(PrioritatsContorns[z]>Prioritat_Material) //Mirem si la prioritat d'aquest contorn es major que l'actual
											  {
											    materialPixel=z+2; //+2 perque comença de 0 i el material 1 li asignem aigua
											    Prioritat_Material=PrioritatsContorns[z];
											    densitatPixel=DensitatsContorns[z];
											  }
										      }
										    z++;
										  }
										if(Prioritat_Material==0) //Si no esta dins de cap contorn, li asignem aigua
										  {
										    materialPixel=1;
										  }
										//Mirem si forma part d'algun dels contorns i el sumem al nombre total de voxels d'aquest contorn
										z=0;
										while(z<Nombre_Contorns)
										  {
										    if(materialPixel==z+2) //+2 perque els materials comensen per 1 i el primer es el dels voxels no contornejats
										      {
											Nombre_Voxels_Contorn[z]++;
											break;
										      }
										    z++;
										  }
						  
									      }
									    /////////////////////////////////
									    //Finalment ho guardem al fitxer de text 
									    fwrite(&materialPixel,sizeof(int),1,OutDicom);
									    fwrite(&densitatPixel,sizeof(float),1,OutDicom);
									    i++;
									  }
									j++;
								      }
								    //Com que canviem de Z, eliminem el vector amb el plans dels contorns  que conte el voxel per a recalcularlos
								    delete [] PlaZ_Conte_Voxel;								    
								    NumeroPlaZ++;	//augmentem el nombre de plans que hem omplit
								    k++;
								  }

							      }
							    else{std::cout<<"Error"<<std::endl;}
							    delete pixeldata;		//eliminem el pixeldata				  				  
							  }
							else
							  {
							    if(Idioma==0)
							      {
								std::cout<<"Error opening dicom"<<std::endl;
							      }
							    else if(Idioma==1)
							      {
								std::cout<<"Error obrint el dicom"<<std::endl;
							      }
							    else if(Idioma==2)
							      {
								std::cout<<"Error abriendo el dicom"<<std::endl;
							      }
							  }
							delete df;			//eliminem la variable amb l'arxiu dicom				
							break;
						      }
						  }
					      }
					  }
					if(NumeroTrobat==false)
					  {
					    
					    if(Idioma==0)
					      {
						std::cout<<"Warning: DICOM number "<<NumDicomACarregar<<" not loaded           "<<std::endl;
					      }
					    else if(Idioma==1)
					      {
						std::cout<<"Warning: No s'ha carregat el DICOM numero "<<NumDicomACarregar<<"         "<<std::endl;
					      }
					    else if(Idioma==2)
					      {
						std::cout<<"Warning: No se ha cargado el DICOM numero "<<NumDicomACarregar<<"         "<<std::endl;
					      }
					    NumDicomsCarregats++;
					    NumDicomACarregar++;
					  }
					else if(NumeroTrobat==true)
					  {
					    NumDicomsCarregats++;
					    NumDicomACarregar++;
					  }
				      }
				    std::cout<<std::endl;
				    //std::cout<<"Carregats "<<ContCaca1<<" voxels"<<std::endl;
				    //Completem la dimensió z del DICOM
				    DimEspaiDicom[2]=DimEspaiDicom[2]*NumeroPlaZ;
				    //Reiniciem els plans de tall//
				    PlansTall[0]=DimEspaiDicom[0];
				    PlansTall[1]=DimEspaiDicom[1];
				    PlansTall[2]=DimEspaiDicom[2];
				    PlansTallInf[0]=0;
				    PlansTallInf[1]=0;
				    PlansTallInf[2]=0;
				      
				    //Una vegada carregats tots, tanquem l'arxiu de text
				    fclose(OutDicom);
				    //Reajustem la càmera//
				    X=0;
				    Y=0;
				    Z=0;
				    X1=0;
				    Y1=0;
				    Y2=0;
				    X2=0;
				    Y2=0;
				    Z2=0;
			      
				    glMatrixMode(GL_MODELVIEW);			//S'encarrega de moure i transformar l'espai (Les coordenades de l'espai)
				    glLoadIdentity();
				    gluLookAt(DimEspaiDicom[0]+DimEspaiDicom[1]+DimEspaiDicom[2],DimEspaiDicom[1]/2.0,DimEspaiDicom[2]/2.0,DimEspaiDicom[0]/2.0,DimEspaiDicom[1]/2.0,DimEspaiDicom[2]/2.0,0.0,0.0,1.0);		//fixem la camera i el punt on mira
		      
				    //Ara indiquem que hem de representar un Dicom
				    PintarDicom=true;
				    //Tornem al directori on es troba el programa
				    chdir(Actualdir);
				    //Movem el fitxer a la carpeta on es troba el programa
				    AuxString.clear();
				    AuxString=std::string("mv ")+NomDicom+std::string("/TempDicom.dat ./");
				    system(AuxString.c_str());
				    ControlSubMenu=1; 
		      
				  }
				else		//Si no trobem l'arxiu de calibració no carreguem els DICOMs
				  {
				    //Tornem al directori on es troba el programa
				    chdir(Actualdir);
				    AuxString.clear();
		    
				    if(Idioma==0)
				      {
					std::cout<<"Missing the calibration file"<<std::endl;
				      }
				    else if(Idioma==1)
				      {
					std::cout<<"Falta el fitxer el calibratge"<<std::endl;
				      }
				    else if(Idioma==2)
				      {
					std::cout<<"Falta el fichero con la calibración"<<std::endl;
				      }
		    
				  }
			      }
			  }

		      }
		    else
		      {
			if(Idioma==0)
			  {
			    std::cout<<"Missing the folder name"<<std::endl;
			  }
			else if(Idioma==1)
			  {
			    std::cout<<"Falta el nom de la carpeta"<<std::endl;
			  }
			else if(Idioma==2)
			  {
			    std::cout<<"Falta el nombre de la carpeta"<<std::endl;
			  }
	     
		      }
	  
		  }
	      }
	    else if(ControlSubMenu==1)
	      {
		if(x>OrigenXPantallaMenu+CVoxPunts.LimitEsquerra && x<OrigenXPantallaMenu+CVoxPunts.LimitDret && y>OrigenYPantallaMenu-CVoxPunts.LimitSuperior && y<OrigenYPantallaMenu-CVoxPunts.LimitInferior)
		  {
		    if(PintVQuad==true)			//Activem l'opcio de pintar punts, pero primer mirem si ja estava activada
		      {
			PintVQuad=false;
			CrearLlistaVox=true;
			//Diguem que hem de tornar a renderitzar les pantalles
			RendFinestraGran=true;
			RendFinestraSup=true;
			RendFinestraInf=true;
		      }
		  }
		else if(x>OrigenXPantallaMenu+CVoxQuad.LimitEsquerra && x<OrigenXPantallaMenu+CVoxQuad.LimitDret && y>OrigenYPantallaMenu-CVoxQuad.LimitSuperior && y<OrigenYPantallaMenu-CVoxQuad.LimitInferior)
		  {
		    if(PintVQuad==false)			//Activem l'opcio de pintar cubs, pero primer mirem si ja estava activada
		      {
			PintVQuad=true;
			CrearLlistaVox=true;
			//Diguem que hem de tornar a renderitzar les pantalles
			RendFinestraGran=true;
			RendFinestraSup=true;
			RendFinestraInf=true;
		      }
		  }
		else if(x>OrigenXPantallaMenu+BPintMatDCM.LimitEsquerra && x<OrigenXPantallaMenu+BPintMatDCM.LimitDret && y>OrigenYPantallaMenu-BPintMatDCM.LimitSuperior && y<OrigenYPantallaMenu-BPintMatDCM.LimitInferior)
		  {
		    if(PintMatDicom==false)			//Activem l'opcio de pintar segons material, pero primer mirem si ja estava activada
		      {
			RendVisor2D=true;
			PintDensDicom=false;
			PintMatDicom=true;
			CrearLlistaVox=true;
			//Diguem que hem de tornar a renderitzar les pantalles
			RendFinestraGran=true;
			RendFinestraSup=true;
			RendFinestraInf=true;
		      }
		  }
		else if(x>OrigenXPantallaMenu+BPintDensDCM.LimitEsquerra && x<OrigenXPantallaMenu+BPintDensDCM.LimitDret && y>OrigenYPantallaMenu-BPintDensDCM.LimitSuperior && y<OrigenYPantallaMenu-BPintDensDCM.LimitInferior)
		  {
		    if(PintDensDicom==false)			//Activem l'opcio de pintar segons densitat, pero primer mirem si ja estava activada
		      {
			RendVisor2D=true;
			PintDensDicom=true;
			PintMatDicom=false;
			CrearLlistaVox=true;
			//Diguem que hem de tornar a renderitzar les pantalles
			RendFinestraGran=true;
			RendFinestraSup=true;
			RendFinestraInf=true;
		      }
		  }	
		else if(x>OrigenXPantallaMenu+BContornsDICOM.LimitEsquerra && x<OrigenXPantallaMenu+BContornsDICOM.LimitDret && y>OrigenYPantallaMenu-BContornsDICOM.LimitSuperior && y<OrigenYPantallaMenu-BContornsDICOM.LimitInferior)
		  {
		    //Activa o desactiva dibuixar els contorns
		    if(DibuixarContorns==false)
		      {
			DibuixarContorns=true;
		      }
		    else if(DibuixarContorns==true)
		      {
			DibuixarContorns=false;
		      }
		    RendVisor2D=true;
		    CrearLlistaVox=true;
		    //Diguem que hem de tornar a renderitzar les pantalles
		    RendFinestraGran=true;
		    RendFinestraSup=true;
		    RendFinestraInf=true;		    
		  }
		else if(x>OrigenXPantallaMenu+CVoxPla[0].LimitEsquerra && x<OrigenXPantallaMenu+CVoxPla[0].LimitDret && y>OrigenYPantallaMenu-CVoxPla[0].LimitSuperior && y<OrigenYPantallaMenu-CVoxPla[0].LimitInferior)
		  {
		    ControlSubSubMenu=1;			//Pla X superior
		  }
		else if(x>OrigenXPantallaMenu+CVoxPla[1].LimitEsquerra && x<OrigenXPantallaMenu+CVoxPla[1].LimitDret && y>OrigenYPantallaMenu-CVoxPla[1].LimitSuperior && y<OrigenYPantallaMenu-CVoxPla[1].LimitInferior)
		  {
		    ControlSubSubMenu=2;			//Pla Y superior
		  }
		else if(x>OrigenXPantallaMenu+CVoxPla[2].LimitEsquerra && x<OrigenXPantallaMenu+CVoxPla[2].LimitDret && y>OrigenYPantallaMenu-CVoxPla[2].LimitSuperior && y<OrigenYPantallaMenu-CVoxPla[2].LimitInferior)
		  {
		    ControlSubSubMenu=3;			//Pla Z superior
		  }
		else if(x>OrigenXPantallaMenu+CVoxPlaInf[0].LimitEsquerra && x<OrigenXPantallaMenu+CVoxPlaInf[0].LimitDret && y>OrigenYPantallaMenu-CVoxPlaInf[0].LimitSuperior && y<OrigenYPantallaMenu-CVoxPlaInf[0].LimitInferior)
		  {
		    ControlSubSubMenu=4;			//Pla X inferior
		  }
		else if(x>OrigenXPantallaMenu+CVoxPlaInf[1].LimitEsquerra && x<OrigenXPantallaMenu+CVoxPlaInf[1].LimitDret && y>OrigenYPantallaMenu-CVoxPlaInf[1].LimitSuperior && y<OrigenYPantallaMenu-CVoxPlaInf[1].LimitInferior)
		  {
		    ControlSubSubMenu=5;			//Pla Y inferior
		  }
		else if(x>OrigenXPantallaMenu+CVoxPlaInf[2].LimitEsquerra && x<OrigenXPantallaMenu+CVoxPlaInf[2].LimitDret && y>OrigenYPantallaMenu-CVoxPlaInf[2].LimitSuperior && y<OrigenYPantallaMenu-CVoxPlaInf[2].LimitInferior)
		  {
		    ControlSubSubMenu=6;			//Pla Z inferior
		  }	
		else if(x>OrigenXPantallaMenu+Crear.LimitEsquerra && x<OrigenXPantallaMenu+Crear.LimitDret && y>OrigenYPantallaMenu-Crear.LimitSuperior && y<OrigenYPantallaMenu-Crear.LimitInferior)
		  {
		    //Guardar els plans
		    CrearLlistaVox=true;	//hem de tornar a crear la llista de Voxels
		    //Diguem que hem de tornar a renderitzar les pantalles
		    RendFinestraGran=true;
		    RendFinestraSup=true;
		    RendFinestraInf=true;
		    //Hem de tornar a guardar els dicom que es representen visibles, ja que han canviat
		    GuardarVoxDicomRepVisible=true;
	    
		    char Aux[101];		//Posem dimensio 101 per a que sempre capiga el '\0' inclus si el CubChar te 100 caràcters
		    int IndexChar=0;
		    //Guardem el Pla X superior//
		    while(IPlansTallChar[0][IndexChar]!='V' && IndexChar<5)
		      {
			Aux[IndexChar]=IPlansTallChar[0][IndexChar];
			IndexChar++;
		      }
		    if(IndexChar==0)			//Agafara tot l'eix si no hi ha cap valor guardat
		      {
			PlansTall[0]=DimEspaiDicom[0];
		      }else
		      {
			Aux[IndexChar]='\0';
			PlansTall[0]=atof(Aux);
			if(PlansTall[0]==0)
			  {
			    PlansTall[0]=DimEspaiDicom[0];
			  }
			else if(PlansTall[0]>DimEspaiDicom[0])
			  {
			    PlansTall[0]=DimEspaiDicom[0];
			  }
		      }

		    IndexChar=0;
		    //Guardem el Pla Y superior//
		    while(IPlansTallChar[1][IndexChar]!='V' && IndexChar<5)
		      {
			Aux[IndexChar]=IPlansTallChar[1][IndexChar];
			IndexChar++;
		      }
		    if(IndexChar==0)			//Agafara tot l'eix si no hi ha cap valor guardat
		      {
			PlansTall[1]=DimEspaiDicom[1];
		      }else
		      {      
			Aux[IndexChar]='\0';
			PlansTall[1]=atof(Aux);
			if(PlansTall[1]==0)
			  {
			    PlansTall[1]=DimEspaiDicom[1];
			  }      
			else if(PlansTall[1]>DimEspaiDicom[1])
			  {
			    PlansTall[1]=DimEspaiDicom[1];
			  }
	    
	      
		      }     
	    
		    IndexChar=0;
		    //Guardem el Pla Z superior//
		    while(IPlansTallChar[2][IndexChar]!='V' && IndexChar<5)
		      {
			Aux[IndexChar]=IPlansTallChar[2][IndexChar];
			IndexChar++;
		      }
		    if(IndexChar==0)			//Agafara tot l'eix si no hi ha cap valor guardat
		      {
			PlansTall[2]=DimEspaiDicom[2];
		      }else
		      {      
			Aux[IndexChar]='\0';
			PlansTall[2]=atof(Aux);
			if(PlansTall[2]==0)
			  {
			    PlansTall[2]=DimEspaiDicom[2];
			  }
			else if(PlansTall[2]>DimEspaiDicom[2])
			  {
			    PlansTall[2]=DimEspaiDicom[2];
			  }
	      
		      }
		    IndexChar=0;


		    //Guardem el Pla X inferior//
		    while(IPlansTallCharInf[0][IndexChar]!='V' && IndexChar<5)
		      {
			Aux[IndexChar]=IPlansTallCharInf[0][IndexChar];
			IndexChar++;
		      }
		    if(IndexChar==0)			//Agafara tot l'eix si no hi ha cap valor guardat
		      {
			PlansTallInf[0]=0;
		      }else
		      {
			Aux[IndexChar]='\0';
			PlansTallInf[0]=atof(Aux);
			if(PlansTallInf[0]>=PlansTall[0])
			  {
			    PlansTallInf[0]=0;
			  }
		      }

		    IndexChar=0;
		    //Guardem el Pla Y inferior//
		    while(IPlansTallCharInf[1][IndexChar]!='V' && IndexChar<5)
		      {
			Aux[IndexChar]=IPlansTallCharInf[1][IndexChar];
			IndexChar++;
		      }
		    if(IndexChar==0)			//Agafara tot l'eix si no hi ha cap valor guardat
		      {
			PlansTallInf[1]=0;
		      }else
		      {      
			Aux[IndexChar]='\0';
			PlansTallInf[1]=atof(Aux);
			if(PlansTallInf[1]>=PlansTall[1])
			  {
			    PlansTallInf[1]=0;
			  }      
	      
		      }     
	    
		    IndexChar=0;
		    //Guardem el Pla Z inferior//
		    while(IPlansTallCharInf[2][IndexChar]!='V' && IndexChar<5)
		      {
			Aux[IndexChar]=IPlansTallCharInf[2][IndexChar];
			IndexChar++;
		      }
		    if(IndexChar==0)			//Agafara tot l'eix si no hi ha cap valor guardat
		      {
			PlansTallInf[2]=0;
		      }else
		      {      
			Aux[IndexChar]='\0';
			PlansTallInf[2]=atof(Aux);
			if(PlansTallInf[2]>=PlansTall[2])
			  {
			    PlansTallInf[2]=0;
			  }
		      }
		    IndexChar=0;
		    //Li diguem que ha de tornar a crear la llita de voxels
		    CrearLlistaVox=true;
		    PintarDicom=true;
	    
		  }

		else if(x>OrigenXPantallaMenu+Tallar.LimitEsquerra && x<OrigenXPantallaMenu+Tallar.LimitDret && y>OrigenYPantallaMenu-Tallar.LimitSuperior && y<OrigenYPantallaMenu-Tallar.LimitInferior)
		  {
		    //Tallarà el DICOM
		    //Desactivem el visor 2D
		    ActivarVisor2D=false;
		    //Diguem que hem de tornar a renderitzar les pantalles
		    RendFinestraGran=true;
		    RendFinestraSup=true;
		    RendFinestraInf=true;
		    int ContadorZ=0;
		    //Primer mirem a partir de quin pla hem de llegir i fins a quin
		    int PlaInicial;
		    int PlaFinal;
		    //Obrim el pla z=0 per a llegir el tamany en l'eix Z dels voxels
		    FILE* DicomAux;
		    DicomAux=fopen("TempPD/DicomRepZ0.dat","rb");
	  
		    int AuxInt[2];
		    float AuxFloat[3];
	  
		    fread(AuxInt,sizeof(int),2,DicomAux);
		    fread(AuxFloat,sizeof(float),3,DicomAux);
	  
		    float TamPlaZ=AuxFloat[2];

		    fclose(DicomAux);
		    //Una vegada tenim el tamany Z dels vòxels, calculem els plans inferior i superior
		    PlaInicial=int(PlansTallInf[2]/TamPlaZ);
		    PlaFinal=int(PlansTall[2]/TamPlaZ);
		    if(Idioma==0)
		      {
			std::cout<<"Cutting DICOM..."<<std::endl; 
		      }
		    else if(Idioma==1)
		      {
			std::cout<<"Tallant el DICOM..."<<std::endl; 
		      }
		    else if(Idioma==2)
		      {
			std::cout<<"Cortando el DICOM..."<<std::endl; 
		      }	  
	  
		    //#pragma omp for	/////////////////////////////////////Comença un cicle for paral·lelitzat//////////////////////	  
		    for(ContadorZ=PlaInicial;ContadorZ<PlaFinal;ContadorZ++)
		      {
			float PercentatgeCompletat=(ContadorZ-PlaInicial)*100.0/(PlaFinal-PlaInicial);
			std::cout.precision(2);
			std::cout<<"\r"<<PercentatgeCompletat<<"%                "; //\r tornarà al inici de la línia
			fflush( stdout );
			std::cout.precision(6);

			//Obrim el fitxer depenent del contadorZ
			std::string NomFitxer;
			char NumContZChar[5];
			sprintf(NumContZChar,"%i",ContadorZ);
	      
			NomFitxer.clear();
			NomFitxer=std::string("TempPD/DicomRepZ")+std::string(NumContZChar)+std::string(".dat");
			//std::ifstream InDicom(NomFitxer.c_str());
			FILE* InDicom;
			InDicom=fopen(NomFitxer.c_str(),"rb");
			//Creem un nou fitxer de text amb les dades del nou arxiu DICOM
			std::string NomFitxer2;
			NomFitxer2.clear();
			NomFitxer2=std::string("TempPD/DicomTallZ")+std::string(NumContZChar)+std::string(".dat");	    
			//std::ofstream TallDicom(NomFitxer2.c_str());	//Aquest sera temporal per a poder calcular el nou nombre de pixels i guardar sols els que estan dins del tall
			FILE* TallDicom;
			TallDicom=fopen(NomFitxer2.c_str(),"wb");
			if (InDicom==NULL)	//Mirem si s'ha obert correctament
			  {
			    if(Idioma==0)
			      {
				std::cout<<NomFitxer<<" file not found"<<std::endl; 
			      }
			    else if(Idioma==1)
			      {
				std::cout<<"No s'ha trobat el fitxer "<<NomFitxer<<std::endl; 
			      }
			    else if(Idioma==2)
			      {
				std::cout<<"No se ha encontrado el fichero" <<NomFitxer<<std::endl; 
			      }	 
			  }	      
			else//Mirem si s'ha obert correctament
			  {
			    //Ara llegim els primers valors que corresponen a: Num pixels eix X, Num pixels eix Y, tamany pixels eix x,y,z
			    int NPixelsX=0;
			    int NPixelsY=0;
			    float TamPixels[3];

			    int NumPixels[2];
		
			    fread(NumPixels,sizeof(int),2,InDicom);
			    fread(TamPixels,sizeof(float),3,InDicom);
		
			    NPixelsX=NumPixels[0];
			    NPixelsY=NumPixels[1];
				
			    //Una vegada tenim aquests valors, pasem a llegir l'arxiu
			    int ContadorX=0;
			    int ContadorY=0;
			    int ContadorXTall=0;	//Contarà el nou nombre de pixels a l'eix X
			    int ContadorYTall=0;	//Contarà el nou nombre de pixels a l'eix Y

			    float CentreVox[3];
			    int PlaInicialTallY=0;		//Mira quin és el primer pla Y on comensem a guardar els vòxels
			    int PlaInicialTallX=0;		//Mira quin és el primer pla X on comensem a guardar els vòxels
			    int PlaFinalTallY=0;
			    int PlaFinalTallX=0;
			    CentreVox[2]=ContadorZ*TamPixels[2]+TamPixels[2]*0.5;
		
			    bool PlaInicialTallAgafat=false;
			    while(!feof(InDicom))
			      {
				int Mat[1];
				float Dens[1];
		  
				fread(Mat,sizeof(int),1,InDicom);
				fread(Dens,sizeof(float),1,InDicom);
		  
				CentreVox[0]=ContadorX*TamPixels[0]+TamPixels[0]*0.5;
				CentreVox[1]=ContadorY*TamPixels[1]+TamPixels[1]*0.5;
		  
				if(CentreVox[0]<=PlansTallInf[0] || CentreVox[0]>=PlansTall[0] || CentreVox[1]<=PlansTallInf[1] || CentreVox[1]>=PlansTall[1])
				  {
				    //Augmentem els contadors
				    ContadorX++;
				    if(ContadorX==NPixelsX)
				      {
					ContadorX=0;
					ContadorY++;
					if(ContadorY==NPixelsY)
					  {
					    break;
					  }
				      }
				    continue;
				  }
				else
				  {
				    if(PlaInicialTallAgafat==false)
				      {
					PlaInicialTallY=ContadorY;
					PlaInicialTallX=ContadorX;
					PlaInicialTallAgafat=true;
				      }
				    if(PlaFinalTallX<ContadorX)
				      {
					PlaFinalTallX=ContadorX;
				      }
				    if(PlaFinalTallY<ContadorY)
				      {
					PlaFinalTallY=ContadorY;
				      }

				    fwrite(Mat,sizeof(int),1,TallDicom);
				    fwrite(Dens,sizeof(float),1,TallDicom);
		    
				    ContadorX++;
				    if(ContadorX==NPixelsX)
				      {
					ContadorX=0;
					ContadorY++;
					if(ContadorY==NPixelsY)
					  {
					    break;
					  }
				      }
				  }
		  
			      }		
			    ContadorXTall=PlaFinalTallX-PlaInicialTallX+1;
			    ContadorYTall=PlaFinalTallY-PlaInicialTallY+1;
			    //hem de tindre en compte si els limits superiors són iguals a la dimensió de l'espai DICOM. Si és així, al arribar el contador X a l'ultim vòxel de la seva fila/columna, incremetarà el següent contador i ell s'inicialitzarà
			    //a zero, perdent-se així un vòxel que desplaçarà la resta al fer el tall.
			    fclose(InDicom);
			    fclose(TallDicom);
			    //Reobrim els arxius per a guardar el fitxer final, (Notar en el nom dels fitxers que ara, el que abans era de input és otput i viceversa)
			    InDicom=fopen(NomFitxer2.c_str(),"rb");
			    TallDicom=fopen(NomFitxer.c_str(),"wb");
		
			    //Guardem aquestes dades al nou arxiu DICOM
		
			    int AuxInt[2];
			    AuxInt[0]=ContadorXTall;
			    AuxInt[1]=ContadorYTall;

			    fwrite(AuxInt,sizeof(int),2,TallDicom);
			    fwrite(TamPixels,sizeof(float),3,TallDicom);		
		
			    //Guardem ara els pixels dins del tall
			    while(!feof(InDicom))
			      {
				int Mat[1];
				float Dens[1];

				fread(Mat,sizeof(int),1,InDicom);
				fread(Dens,sizeof(float),1,InDicom);
		  
				fwrite(Mat,sizeof(int),1,TallDicom);
				fwrite(Dens,sizeof(float),1,TallDicom);
		  
		  
			      }
			    //Tanquem els arxius//
			    fclose(InDicom);
			    fclose(TallDicom);
			    //Recalculem les dimensions del nou Dicom//
			    DimEspaiDicom[0]=ContadorXTall*TamPixels[0];
			    DimEspaiDicom[1]=ContadorYTall*TamPixels[1];
			    DimEspaiDicom[2]=(PlaFinal-PlaInicial)*TamPixels[2];
			    NomFitxer2=std::string("rm ")+NomFitxer2;
			    system(NomFitxer2.c_str());
			  }

		      }	  
		    //Renombrem els fitxers amb els plans de forma que el pla inicial siga el zero i borrem els que han quedat exclosos
		    for(ContadorZ=PlaInicial;ContadorZ<PlaFinal;ContadorZ++)
		      {

			if(PlaInicial==0)
			  {
			    break;
			  }
			//Obrim el fitxer depenent del contadorZ
			std::string NomFitxer;
			char NumContZChar[5];
			sprintf(NumContZChar,"%i",ContadorZ);
			char NumContZChar2[5];
			sprintf(NumContZChar2,"%i",ContadorZ-PlaInicial);
			NomFitxer.clear();
			NomFitxer=std::string("mv TempPD/DicomRepZ")+std::string(NumContZChar)+std::string(".dat TempPD/DicomRepZ")+std::string(NumContZChar2)+std::string(".dat");
			system(NomFitxer.c_str());
		      }
		    ///////////////////////////////////////////////
		    //Movem els contorns, ja que canviem l'origen//
		    
		    if(Nombre_Contorns>0)
		      {
			int i=0;
			while(i<Nombre_Contorns)
			  {
			    int j=0;
			    while(j<Nombre_Plans_Contorn[i])
			      {
				int k=0;
				while(k<Nombre_Punts_Contorn[i][j])
				  {
				    Punts_Contorn[i][j][k]=Punts_Contorn[i][j][k]-PlansTallInf[0];  //Component X
				    k++;
				    Punts_Contorn[i][j][k]=Punts_Contorn[i][j][k]-PlansTallInf[1];  //Component Y
				    k++;
				    Punts_Contorn[i][j][k]=Punts_Contorn[i][j][k]-PlansTallInf[2];  //Component Z
				    k++;
				  }
				j++;
			      }
			    i++;
			  }
		      }
		    ///////////////////////////////////////////////
		    ///////////////////////////////////////////////
		    //Movem les llavors, ja que canviem l'origen//
		    
		    if(Nombre_Tipus_Llavors>0)
		      {
			int i=0;
			while(i<Nombre_Tipus_Llavors) //Recorrem tots els tipus de llavors
			  {
			    int j=0;
			    while(j<Nombre_Llavors[i]*3) //Recorrem el nombre de llavors per 3, ja que cada llavor te una posicio de 3 components (x,y,z) 
			      {
				Posicio_Llavor[i][j]=Posicio_Llavor[i][j]-PlansTallInf[0];  //Component X
				j++;
				Posicio_Llavor[i][j]=Posicio_Llavor[i][j]-PlansTallInf[1];  //Component Y
				j++;
				Posicio_Llavor[i][j]=Posicio_Llavor[i][j]-PlansTallInf[2];  //Component Z
				j++;
			      }
			    i++;
			  }
		      }
		    ///////////////////////////////////////////////		    
		    
		    //Reiniciem els plans de tall//
		    PlansTall[0]=DimEspaiDicom[0];
		    PlansTall[1]=DimEspaiDicom[1];
		    PlansTall[2]=DimEspaiDicom[2];
		
		    PlansTallInf[0]=0;
		    PlansTallInf[1]=0;
		    PlansTallInf[2]=0;
				
		    //Reajustem la càmera//
		    X=0;
		    Y=0;
		    Z=0;
		    X1=0;
		    Y1=0;
		    Y2=0;
		    X2=0;
		    Y2=0;
		    Z2=0;
			      
		    glMatrixMode(GL_MODELVIEW);			//S'encarrega de moure i transformar l'espai (Les coordenades de l'espai)
		    glLoadIdentity();
		    gluLookAt(DimEspaiDicom[0]+DimEspaiDicom[1]+DimEspaiDicom[2],DimEspaiDicom[1]/2.0,DimEspaiDicom[2]/2.0,DimEspaiDicom[0]/2.0,DimEspaiDicom[1]/2.0,DimEspaiDicom[2]/2.0,0.0,0.0,1.0);		//fixem la camera i el punt on mira

		    std::cout<<"\r"<<100<<"%                "; //\r tornarà al inici de la línia
		    fflush( stdout );
		    std::cout<<std::endl;
		    //Diguem que ha acabat
		    if(Idioma==0)
		      {
			std::cout<<"DICOM cutted"<<std::endl; 
		      }
		    else if(Idioma==1)
		      {
			std::cout<<"DICOM tallat"<<std::endl; 
		      }
		    else if(Idioma==2)
		      {
			std::cout<<"DICOM cortado"<<std::endl; 
		      }	 
		    
		    //Li diguem que torne a pintar//
		    CrearLlistaVox=true;
		    PintVQuad=false;
		    GuardarVoxDicomRep=false;	//Ja estan guardats els vòxels que es representen
		    GuardarVoxDicomRepVisible=true;	//Pero no els visibles
		    glutPostRedisplay();
		  }

		else if(x>OrigenXPantallaMenu+BGuardarVoxelsPene.LimitEsquerra && x<OrigenXPantallaMenu+BGuardarVoxelsPene.LimitDret && y>OrigenYPantallaMenu-BGuardarVoxelsPene.LimitSuperior && y<OrigenYPantallaMenu-BGuardarVoxelsPene.LimitInferior)
		  {
		    //Guardem els vòxels en un arxiu del PENELOPE
		    if(Idioma==0)
		      {
			std::cout<<"Saving voxels..."<<std::endl; 
		      }
		    else if(Idioma==1)
		      {
			std::cout<<"Desant vòxels..."<<std::endl; 
		      }
		    else if(Idioma==2)
		      {
			std::cout<<"Salvando vóxeles..."<<std::endl; 
		      }	  
	      
		    int ContadorZ=0;
		    //Primer mirem a partir de quin pla hem de llegir i fins a quin
		    //Obrim el pla z=0 per a llegir el tamany en l'eix Z dels voxels
		    //std::ifstream DicomAux("TempPD/DicomRepZ0.dat");
		    FILE* DicomAux;
		    DicomAux=fopen("TempPD/DicomRepZ0.dat","rb");
	  
		    int AuxInt[2];
		    float AuxFloat[3];
	  
		    fread(AuxInt,sizeof(int),2,DicomAux);
		    fread(AuxFloat,sizeof(float),3,DicomAux);
	  
		    fclose(DicomAux);
	  
		    //Calculem el nombre de plans en l'eix Z
		    float NumVoxZ=0;
		    NumVoxZ=int(DimEspaiDicom[2]/AuxFloat[2]);
		    //Creem un arxiu de text aci que contindrà el voxelitzat i te el nom de la carpeta
		    std::string AuxString;

		    //Hem de buscar l'ultima "/" en el nom de l'arxiu per a extraure unicament el nom del dicom i no les carpetes superiors
		    int Posicio_Barra=0;
		    int i=0;
		    while(NomDicom[i]!='\0')
		      {
			if(NomDicom[i]=='/'){Posicio_Barra=i;}
			i++;
		      }
		    AuxString.clear();
      
		    if(Posicio_Barra==0){i=0;}
		    else{i=Posicio_Barra+1;}
      
		    while(NomDicom[i]!='\0')
		      {
			AuxString+=NomDicom[i];
			i++;
		      }
		    //Creem una carpeta on guardarem la informacio del dicom
		    std::string AuxString2;
		    std::string AuxString3;
		    AuxString3="rm -r VoxelsPenelope/"+AuxString;
		    AuxString2="mkdir VoxelsPenelope/"+AuxString;
		    system(AuxString3.c_str());
		    system(AuxString2.c_str());
		    FILE* OutContorns;
		    std::string AuxString4;
		    AuxString4="VoxelsPenelope/"+AuxString+"/contours.dat";
		    OutContorns = fopen(AuxString4.c_str(),"w");
		    
		    fprintf(OutContorns,"# VOXELMAGES CONTOUR DATA\n");
		    fprintf(OutContorns,"#\n");
		    fprintf(OutContorns,"# Number of contours:\n");
		    fprintf(OutContorns,"#    %i\n",Nombre_Contorns);
		    fprintf(OutContorns,"#\n");
		    fprintf(OutContorns,"# Name, number of voxels and volume of each contour (cm^3)\n");
		    fprintf(OutContorns,"#\n");
		    i=0;
		    while(i<Nombre_Contorns)
		      {
			fprintf(OutContorns,"#    Contour %i: %s %u %.5E\n",i+1, Nom_Contorn[i].c_str(), Nombre_Voxels_Contorn[i], Nombre_Voxels_Contorn[i]*AuxFloat[0]*AuxFloat[1]*AuxFloat[2]);
			i++;
		      }
		    fprintf(OutContorns,"#\n");
		    fprintf(OutContorns,"# countor points data\n");
		    fprintf(OutContorns,"# contour number | Z Position | X Position | Y Position |\n");
		    i=0;
		    while(i<Nombre_Contorns)
		      {
			int j=0;
			while(j<Nombre_Plans_Contorn[i])
			  {
			    int k=0;
			    while(k<Nombre_Punts_Contorn[i][j])
			      {
				fprintf(OutContorns,"      %i           %.5E  %.5E  %.5E\n",i+1,Punts_Contorn[i][j][k+2],Punts_Contorn[i][j][k],Punts_Contorn[i][j][k+1]);
				k=k+3;
			      }
			    j++;
			  }
			i++;
		      }
		    fprintf(OutContorns,"#\n");
		    fprintf(OutContorns,"# End of contour data\n");
		    fclose(OutContorns);
		    //Obrim l'output de voxelitzat
		    AuxString="VoxelsPenelope/"+AuxString+"/"+AuxString+".vox";
		    std::ofstream OutVox(AuxString.c_str());
		    //Guardem ara la capsalera de l'arxiu de voxelitzat
		    /////////////////////////Escrivim l'arxiu.vox///////////////////////////////////////////////////////////////////
		    OutVox<<"# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"<<'\n';
		    OutVox<<"# >>>>>>>>>>>DICOM PROCESSED BY VOXELMAGES>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"<<'\n';
		    OutVox<<"# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"<<'\n';
		    //Posem en la capsalera els materials existents
		    OutVox<<"# Materials:"<<'\n';
		    OutVox<<"# "<<'\n';
		    i=0;
		    while(i<NumMatsCal)
		      {
			if(Nombre_Contorns>0 && ModalitatDicom=="US")
			  {
			    if(i==0){OutVox<<"# Material "<<i+1<<" -> "<<"water"<<'\n';}
			    else{OutVox<<"# Material "<<i+1<<" -> "<<Nom_Contorn[i-1]<<'\n';}
			  }
			else{OutVox<<"# Material "<<i+1<<" -> "<<'\n';}
			i++;
		      }
		    OutVox<<"# "<<'\n';
		    OutVox<<"# Seeds positions (x,y,z):"<<'\n';
		    OutVox<<"# "<<'\n';
		    i=0;
		    while(i<Nombre_Tipus_Llavors)
		      {
			OutVox<<"#   Type 1:"<<'\n';
			OutVox<<"#"<<'\n';
			int contador_llavor=1;
			int j=0;
			while(j<Nombre_Llavors[i]*3) // per 3 perque tenim 3 components per llavor (x,y,z)
			  {
			    OutVox<<"#     Seed "<<contador_llavor<<" position = ("<<Posicio_Llavor[i][j]<<","<<Posicio_Llavor[i][j+1]<<","<<Posicio_Llavor[i][j+2]<<")"<<'\n';
			    j=j+3;
			    contador_llavor++;
			  }
			OutVox<<"#"<<'\n';
			i++;
		      }		    
		    OutVox<<"# "<<'\n';
		    OutVox<<"[SECTION VOXELS HEADER v.2008-04-13]"<<'\n';
		    OutVox<<" "<<AuxInt[0]<<" "<<AuxInt[1]<<" "<<NumVoxZ<<"              No. OF VOXELS IN X,Y,Z"<<'\n';
		    OutVox<<" "<<AuxFloat[0]<<" "<<AuxFloat[1]<<" "<<AuxFloat[2]<<"        VOXEL SIZE (cm) ALONG X,Y,Z"<<'\n';
		    OutVox<<" 1                    COLUMN NUMBER WHERE MATERIAL ID IS LOCATED"<<'\n';
		    OutVox<<" 2                    COLUMN NUMBER WHERE THE MASS DENSITY IS LOCATED"<<'\n';
		    OutVox<<" 0                    BLANK LINES AT END OF X,Y-CYCLES (1=YES,0=NO)"<<'\n';
		    OutVox<<"[END OF VXH SECTION]"<<'\n';
		    OutVox<<"# >>>> DATA BEGINS >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"<<'\n';
		    OutVox<<"# MatID : dens(g/cm^3)"<<'\n';
	  
		    for(ContadorZ=0;ContadorZ<NumVoxZ;ContadorZ++)
		      {
			float PercentatgeCompletat=ContadorZ*100.0/NumVoxZ;
			std::cout.precision(2);
			std::cout<<"\r"<<PercentatgeCompletat<<"%                "; //\r tornarà al inici de la línia
			fflush( stdout );
			std::cout.precision(6);

			//Obrim el fitxer depenent del contadorZ
			std::string NomFitxer;
			char NumContZChar[5];
			sprintf(NumContZChar,"%i",ContadorZ);
	      
			NomFitxer.clear();
			NomFitxer=std::string("TempPD/DicomRepZ")+std::string(NumContZChar)+std::string(".dat");
			//std::ifstream InDicom(NomFitxer.c_str());
			FILE* InDicom;
			InDicom=fopen(NomFitxer.c_str(),"rb");
			if (InDicom==NULL)	//Mirem si s'ha obert correctament
			  {
			    if(Idioma==0)
			      {
				std::cout<<"Error :"<<NomFitxer<<" file not found"<<std::endl; 
			      }
			    else if(Idioma==1)
			      {
				std::cout<<"Error: No s'ha trobat el fitxer "<<NomFitxer<<std::endl; 
			      }
			    else if(Idioma==2)
			      {
				std::cout<<"Error No se ha encontrado el fichero" <<NomFitxer<<std::endl; 
			      }	 
		  
			    break;
			  }	      
			else//Mirem si s'ha obert correctament
			  {
			    //Ara llegim els primers valors que corresponen a: Num pixels eix X, Num pixels eix Y, tamany pixels eix x,y,z
			    float TamPixels[3];
			    int NumPixels[2];
		
			    fread(NumPixels,sizeof(int),2,InDicom);
			    fread(TamPixels,sizeof(float),3,InDicom);
		
			    //Pasem a guardar els vòxels
			    int ContadorFi=0;
			    int NumPixelsTotals=NumPixels[0]*NumPixels[1];
			    while(!feof(InDicom))
			      {
				int Mat[1]={0};
				float Dens[1]={0.0};
		  
				fread(Mat,sizeof(int),1,InDicom);
				fread(Dens,sizeof(float),1,InDicom);

				std::cout.precision(6);
				OutVox<<" "<<Mat[0]<<" "<<Dens[0]<<std::endl;
				ContadorFi++;
				if(ContadorFi==NumPixelsTotals)
				  {
				    break;
				  }
			      }
			    fclose(InDicom);
			  }
		      }
		    std::cout<<std::endl;
	      
		    OutVox.close();

		    if(Idioma==0)
		      {
			std::cout<<"Voxels saved"<<std::endl; 
		      }
		    else if(Idioma==1)
		      {
			std::cout<<"Vòxels guardats"<<std::endl; 
		      }
		    else if(Idioma==2)
		      {
			std::cout<<"Vóxeles guardados"<<std::endl; 
		      }	  
		    //Tornem a la direcció on es troba el programa
		  }
		else if(x>OrigenXPantallaMenu+BDicom2D.LimitEsquerra && x<OrigenXPantallaMenu+BDicom2D.LimitDret && y>OrigenYPantallaMenu-BDicom2D.LimitSuperior && y<OrigenYPantallaMenu-BDicom2D.LimitInferior)
		  {
		    //Canviem a la visio en 2D
		    CrearLlistaVox=true;	//hem de tornar a crear la llista de Voxels	  
		    if(ActivarVisor2D==false)
		      {
			ActivarVisor2D=true;
			RendVisor2D=true;
			PlaVisor2D=0;
		      }
		    else
		      {
			ActivarVisor2D=false;
			RendVisor2D=true;
			RendFinestraGran=true;
			RendFinestraInf=true;
			RendFinestraSup=true;	    
		      }
		  }
	      }
	  }
	else if(ControlMenu==11)
	  {
	    if(x>OrigenXPantallaMenu+BNetejarSeleccio.LimitEsquerra && x<OrigenXPantallaMenu+BNetejarSeleccio.LimitDret && y>OrigenYPantallaMenu-BNetejarSeleccio.LimitSuperior && y<OrigenYPantallaMenu-BNetejarSeleccio.LimitInferior)
	      {
		NumFiguresSeleccionades=0;
	      }
	    else if(x>OrigenXPantallaMenu+IFiguraSelec.LimitEsquerra && x<OrigenXPantallaMenu+IFiguraSelec.LimitDret && y>OrigenYPantallaMenu-IFiguraSelec.LimitSuperior && y<OrigenYPantallaMenu-IFiguraSelec.LimitInferior)
	      {
		ControlSubSubMenu=1;
	      }
	    else if(x>OrigenXPantallaMenu+ICosSelec.LimitEsquerra && x<OrigenXPantallaMenu+ICosSelec.LimitDret && y>OrigenYPantallaMenu-ICosSelec.LimitSuperior && y<OrigenYPantallaMenu-ICosSelec.LimitInferior)
	      {
		ControlSubSubMenu=2;
	      }
	    else if(x>OrigenXPantallaMenu+IMaterialSelec.LimitEsquerra && x<OrigenXPantallaMenu+IMaterialSelec.LimitDret && y>OrigenYPantallaMenu-IMaterialSelec.LimitSuperior && y<OrigenYPantallaMenu-IMaterialSelec.LimitInferior)
	      {
		ControlSubSubMenu=3;
	      }		
	    else if(x>OrigenXPantallaMenu+AfegirFiguraSelec[0].LimitEsquerra && x<OrigenXPantallaMenu+AfegirFiguraSelec[0].LimitDret && y>OrigenYPantallaMenu-AfegirFiguraSelec[0].LimitSuperior && y<OrigenYPantallaMenu-AfegirFiguraSelec[0].LimitInferior)
	      {
		//Comprovem si el numero de figura existeix i el guardem
		//Guardem el número de figura//
		int IndexChar=0;
		char Aux[4];
		while(ISelFigChar[IndexChar]!='V' && IndexChar<3)
		  {
		    Aux[IndexChar]=ISelFigChar[IndexChar];
		    ISelFigChar[IndexChar]='V';
		    IndexChar++;
		  }
		if(IndexChar!=0)
		  {
		    Aux[IndexChar]='\0';
		    ISelFig=atoi(Aux);
		  }
		//Comprovem que existeix la figura
		if(ISelFig<=NumTotalFig)
		  {
		    int i=1;
		    bool Existeix=true;
		    while(i<=FigBorrades[0])
		      {
			if(ISelFig==FigBorrades[i])
			  {
			    Existeix=false;
			    break;
			  }
			i++;
		      }
		    if(Existeix==true)
		      {
			//si la figura existeix, comprovem que no es troba ja a la llista i l'afegim a la llista de seleccionats
			bool JaAfegit=false;
			i=0;
			while(i<NumFiguresSeleccionades)
			  {
			    if(ISelFig==FiguresSeleccionades[i])
			      {
				JaAfegit=true;
				break;
			      }
			    i++;
			  }
			if(JaAfegit==false)
			  {
			    FiguresSeleccionades[NumFiguresSeleccionades]=ISelFig;
			    NumFiguresSeleccionades++;
			  }
		      }
		  }
		
	      }
	    else if(x>OrigenXPantallaMenu+AfegirFiguraSelec[1].LimitEsquerra && x<OrigenXPantallaMenu+AfegirFiguraSelec[1].LimitDret && y>OrigenYPantallaMenu-AfegirFiguraSelec[1].LimitSuperior && y<OrigenYPantallaMenu-AfegirFiguraSelec[1].LimitInferior)
	      {
		//Busquem el numero a la llista de seleccionats i el borrem
		int IndexChar=0;
		char Aux[4];
		while(ISelFigChar[IndexChar]!='V' && IndexChar<3)
		  {
		    Aux[IndexChar]=ISelFigChar[IndexChar];
		    ISelFigChar[IndexChar]='V';
		    IndexChar++;
		  }
		if(IndexChar!=0)
		  {
		    Aux[IndexChar]='\0';
		    ISelFig=atoi(Aux);
		  }
		int i=0;
		while(i<NumFiguresSeleccionades)
		  {
		    if(ISelFig==FiguresSeleccionades[i])
		      {
			int j=i;
			while(j<NumFiguresSeleccionades-1)
			  {
			    FiguresSeleccionades[i]=FiguresSeleccionades[i+1];
			    j++;
			  }
			NumFiguresSeleccionades--;
			break;
		      }
		    i++;
		  }
	      }
	    else if(x>OrigenXPantallaMenu+AfegirCosSelec[0].LimitEsquerra && x<OrigenXPantallaMenu+AfegirCosSelec[0].LimitDret && y>OrigenYPantallaMenu-AfegirCosSelec[0].LimitSuperior && y<OrigenYPantallaMenu-AfegirCosSelec[0].LimitInferior)
	      {
		//Comprovem si el numero de figura existeix i el guardem
		//Guardem el número de figura//
		int IndexChar=0;
		char Aux[4];
		while(ISelCosChar[IndexChar]!='V' && IndexChar<3)
		  {
		    Aux[IndexChar]=ISelCosChar[IndexChar];
		    ISelCosChar[IndexChar]='V';
		    IndexChar++;
		  }
		if(IndexChar!=0)
		  {
		    Aux[IndexChar]='\0';
		    ISelCos=atoi(Aux);
		  }
		//Comprovem que existeix aquest numero de cos
		if(ISelCos<=MaxPrioritat)
		  {
		    //Ara pasem a buscar les figures amb aquest numero de cos
		    int AuxInt[1000];     //Guardara les numeros de figura que hem de guardar
		    int NumFigAfegir=0;   //Conta el nombre de figures que es guarden
		    int i=1;
		    while(i<=NumCubs)
		      {
			if(ISelCos==rectangles[i].Prioritat)
			  {
			    AuxInt[NumFigAfegir]=rectangles[i].NumeroFigura();
			    NumFigAfegir++;
			  }
			i++;
		      }
		    i=1;
		    while(i<=NumCil)
		      {
			if(ISelCos==cilindres[i].Prioritat)
			  {
			    AuxInt[NumFigAfegir]=cilindres[i].NumeroFigura();
			    NumFigAfegir++;
			  }
			i++;
		      }
		    i=1;
		    while(i<=NumEsf)
		      {
			if(ISelCos==esferes[i].Prioritat)
			  {
			    AuxInt[NumFigAfegir]=esferes[i].NumeroFigura();
			    NumFigAfegir++;
			  }
			i++;
		      }
		    i=1;
		    while(i<=NumPla)
		      {
			if(ISelCos==plans[i].Prioritat)
			  {
			    AuxInt[NumFigAfegir]=plans[i].NumeroFigura();
			    NumFigAfegir++;
			  }
			i++;
		      }
		    i=1;
		    while(i<=NumSecEsf)
		      {
			if(ISelCos==secEsf[i].Prioritat)
			  {
			    AuxInt[NumFigAfegir]=secEsf[i].NumeroFigura();
			    NumFigAfegir++;
			  }
			i++;
		      }
		    //Pasem ara a guardar els numeros
		    i=0;
		    while(i<NumFigAfegir)
		      {
			bool JaAfegit=false;
			int j=0;
			while(j<NumFiguresSeleccionades)
			  {
			    if(AuxInt[i]==FiguresSeleccionades[j])
			      {
				JaAfegit=true;
				break;
			      }
			    j++;
			  }
			if(JaAfegit==false)
			  {
			    FiguresSeleccionades[NumFiguresSeleccionades]=AuxInt[i];
			    NumFiguresSeleccionades++;
			  }
			i++;
		      }
		  }
		
	      }
	    else if(x>OrigenXPantallaMenu+AfegirCosSelec[1].LimitEsquerra && x<OrigenXPantallaMenu+AfegirCosSelec[1].LimitDret && y>OrigenYPantallaMenu-AfegirCosSelec[1].LimitSuperior && y<OrigenYPantallaMenu-AfegirCosSelec[1].LimitInferior)
	      {
		//Comprovem si el numero de figura existeix
		//Guardem el número de figura//
		int IndexChar=0;
		char Aux[4];
		while(ISelCosChar[IndexChar]!='V' && IndexChar<3)
		  {
		    Aux[IndexChar]=ISelCosChar[IndexChar];
		    ISelCosChar[IndexChar]='V';
		    IndexChar++;
		  }
		if(IndexChar!=0)
		  {
		    Aux[IndexChar]='\0';
		    ISelCos=atoi(Aux);
		  }
		//Comprovem que existeix aquest numero de cos
		if(ISelCos<=MaxPrioritat)
		  {
		    //Ara pasem a buscar les figures amb aquest numero de cos
		    int AuxInt[1000];     //Guardara les numeros de figura que hem de guardar
		    int NumFigAfegir=0;   //Conta el nombre de figures que es guarden
		    int i=1;
		    while(i<=NumCubs)
		      {
			if(ISelCos==rectangles[i].Prioritat)
			  {
			    AuxInt[NumFigAfegir]=rectangles[i].NumeroFigura();
			    NumFigAfegir++;
			  }
			i++;
		      }
		    i=1;
		    while(i<=NumCil)
		      {
			if(ISelCos==cilindres[i].Prioritat)
			  {
			    AuxInt[NumFigAfegir]=cilindres[i].NumeroFigura();
			    NumFigAfegir++;
			  }
			i++;
		      }
		    i=1;
		    while(i<=NumEsf)
		      {
			if(ISelCos==esferes[i].Prioritat)
			  {
			    AuxInt[NumFigAfegir]=esferes[i].NumeroFigura();
			    NumFigAfegir++;
			  }
			i++;
		      }
		    i=1;
		    while(i<=NumPla)
		      {
			if(ISelCos==plans[i].Prioritat)
			  {
			    AuxInt[NumFigAfegir]=plans[i].NumeroFigura();
			    NumFigAfegir++;
			  }
			i++;
		      }
		    i=1;
		    while(i<=NumSecEsf)
		      {
			if(ISelCos==secEsf[i].Prioritat)
			  {
			    AuxInt[NumFigAfegir]=secEsf[i].NumeroFigura();
			    NumFigAfegir++;
			  }
			i++;
		      }
		    //Pasem ara a buscar els numeros a la llista
		    i=0;
		    while(i<NumFigAfegir)
		      {
			int j=0;
			while(j<NumFiguresSeleccionades)
			  {
			    if(AuxInt[i]==FiguresSeleccionades[j])
			      {
				//Si es troba a la llista l'eliminem
				int k=j;
				while(k<NumFiguresSeleccionades-1)
				  {
				    FiguresSeleccionades[k]=FiguresSeleccionades[k+1];
				    k++;
				  }
				NumFiguresSeleccionades--;
				break;
			      }
			    j++;
			  }
			i++;
		      }
		  }
		
	      }
	    else if(x>OrigenXPantallaMenu+AfegirMaterialSelec[0].LimitEsquerra && x<OrigenXPantallaMenu+AfegirMaterialSelec[0].LimitDret && y>OrigenYPantallaMenu-AfegirMaterialSelec[0].LimitSuperior && y<OrigenYPantallaMenu-AfegirMaterialSelec[0].LimitInferior)
	      {
		//Comprovem si el numero de figura existeix i el guardem
		//Guardem el número de figura//
		int IndexChar=0;
		char Aux[4];
		while(ISelMaterialChar[IndexChar]!='V' && IndexChar<3)
		  {
		    Aux[IndexChar]=ISelMaterialChar[IndexChar];
		    ISelMaterialChar[IndexChar]='V';
		    IndexChar++;
		  }
		if(IndexChar!=0)
		  {
		    Aux[IndexChar]='\0';
		    ISelMaterial=atoi(Aux);
		  }
		//Comprovem que existeix aquest numero de cos
		if(ISelMaterial<=MaxMaterial)
		  {
		    //Ara pasem a buscar les figures amb aquest numero de material
		    int AuxInt[1000];     //Guardara les numeros de figura que hem de guardar
		    int NumFigAfegir=0;   //Conta el nombre de figures que es guarden
		    int i=1;
		    while(i<=NumCubs)
		      {
			if(ISelMaterial==rectangles[i].Material)
			  {
			    AuxInt[NumFigAfegir]=rectangles[i].NumeroFigura();
			    NumFigAfegir++;
			  }
			i++;
		      }
		    i=1;
		    while(i<=NumCil)
		      {
			if(ISelMaterial==cilindres[i].Material)
			  {
			    AuxInt[NumFigAfegir]=cilindres[i].NumeroFigura();
			    NumFigAfegir++;
			  }
			i++;
		      }
		    i=1;
		    while(i<=NumEsf)
		      {
			if(ISelMaterial==esferes[i].Material)
			  {
			    AuxInt[NumFigAfegir]=esferes[i].NumeroFigura();
			    NumFigAfegir++;
			  }
			i++;
		      }
		    i=1;
		    while(i<=NumPla)
		      {
			if(ISelMaterial==plans[i].Material)
			  {
			    AuxInt[NumFigAfegir]=plans[i].NumeroFigura();
			    NumFigAfegir++;
			  }
			i++;
		      }
		    i=1;
		    while(i<=NumSecEsf)
		      {
			if(ISelMaterial==secEsf[i].Material)
			  {
			    AuxInt[NumFigAfegir]=secEsf[i].NumeroFigura();
			    NumFigAfegir++;
			  }
			i++;
		      }
		    //Pasem ara a guardar els numeros
		    i=0;
		    while(i<NumFigAfegir)
		      {
			bool JaAfegit=false;
			int j=0;
			while(j<NumFiguresSeleccionades)
			  {
			    if(AuxInt[i]==FiguresSeleccionades[j])
			      {
				JaAfegit=true;
				break;
			      }
			    j++;
			  }
			if(JaAfegit==false)
			  {
			    FiguresSeleccionades[NumFiguresSeleccionades]=AuxInt[i];
			    NumFiguresSeleccionades++;
			  }
			i++;
		      }
		  }
		
	      }
	    else if(x>OrigenXPantallaMenu+AfegirMaterialSelec[1].LimitEsquerra && x<OrigenXPantallaMenu+AfegirMaterialSelec[1].LimitDret && y>OrigenYPantallaMenu-AfegirMaterialSelec[1].LimitSuperior && y<OrigenYPantallaMenu-AfegirMaterialSelec[1].LimitInferior)
	      {
		//Comprovem si el numero de figura existeix
		//Guardem el número de figura//
		int IndexChar=0;
		char Aux[4];
		while(ISelMaterialChar[IndexChar]!='V' && IndexChar<3)
		  {
		    Aux[IndexChar]=ISelMaterialChar[IndexChar];
		    ISelMaterialChar[IndexChar]='V';
		    IndexChar++;
		  }
		if(IndexChar!=0)
		  {
		    Aux[IndexChar]='\0';
		    ISelMaterial=atoi(Aux);
		  }
		//Comprovem que existeix aquest numero de cos
		if(ISelMaterial<=MaxMaterial)
		  {
		    //Ara pasem a buscar les figures amb aquest numero de cos
		    int AuxInt[1000];     //Guardara les numeros de figura que hem de guardar
		    int NumFigAfegir=0;   //Conta el nombre de figures que es guarden
		    int i=1;
		    while(i<=NumCubs)
		      {
			if(ISelMaterial==rectangles[i].Material)
			  {
			    AuxInt[NumFigAfegir]=rectangles[i].NumeroFigura();
			    NumFigAfegir++;
			  }
			i++;
		      }
		    i=1;
		    while(i<=NumCil)
		      {
			if(ISelMaterial==cilindres[i].Material)
			  {
			    AuxInt[NumFigAfegir]=cilindres[i].NumeroFigura();
			    NumFigAfegir++;
			  }
			i++;
		      }
		    i=1;
		    while(i<=NumEsf)
		      {
			if(ISelMaterial==esferes[i].Material)
			  {
			    AuxInt[NumFigAfegir]=esferes[i].NumeroFigura();
			    NumFigAfegir++;
			  }
			i++;
		      }
		    i=1;
		    while(i<=NumPla)
		      {
			if(ISelMaterial==plans[i].Material)
			  {
			    AuxInt[NumFigAfegir]=plans[i].NumeroFigura();
			    NumFigAfegir++;
			  }
			i++;
		      }
		    i=1;
		    while(i<=NumSecEsf)
		      {
			if(ISelMaterial==secEsf[i].Material)
			  {
			    AuxInt[NumFigAfegir]=secEsf[i].NumeroFigura();
			    NumFigAfegir++;
			  }
			i++;
		      }
		    //Pasem ara a buscar els numeros a la llista
		    i=0;
		    while(i<NumFigAfegir)
		      {
			int j=0;
			while(j<NumFiguresSeleccionades)
			  {
			    if(AuxInt[i]==FiguresSeleccionades[j])
			      {
				//Si es troba a la llista l'eliminem
				int k=j;
				while(k<NumFiguresSeleccionades-1)
				  {
				    FiguresSeleccionades[k]=FiguresSeleccionades[k+1];
				    k++;
				  }
				NumFiguresSeleccionades--;
				break;
			      }
			    j++;
			  }
			i++;
		      }
		  }
		
	      }
	    else if(ControlSubMenu==0 || ControlSubMenu==1 || ControlSubMenu==2 || ControlSubMenu==3 || ControlSubMenu==4)
	      {
		if(x>OrigenXPantallaMenu+BTranslacio.LimitEsquerra && x<OrigenXPantallaMenu+BTranslacio.LimitDret && y>OrigenYPantallaMenu-BTranslacio.LimitSuperior && y<OrigenYPantallaMenu-BTranslacio.LimitInferior)
		  {
		    ControlSubMenu=1;
		  }
		else if(ControlSubMenu==1)
		  {
		    if(x>OrigenXPantallaMenu+BParametresTransformacio[0].LimitEsquerra && x<OrigenXPantallaMenu+BParametresTransformacio[0].LimitDret && y>OrigenYPantallaMenu-BParametresTransformacio[0].LimitSuperior && y<OrigenYPantallaMenu-BParametresTransformacio[0].LimitInferior)
		      {
			ControlSubSubMenu=4;
		      }
		    else if(x>OrigenXPantallaMenu+BParametresTransformacio[1].LimitEsquerra && x<OrigenXPantallaMenu+BParametresTransformacio[1].LimitDret && y>OrigenYPantallaMenu-BParametresTransformacio[1].LimitSuperior && y<OrigenYPantallaMenu-BParametresTransformacio[1].LimitInferior)
		      {
			ControlSubSubMenu=5;
		      }
		    else if(x>OrigenXPantallaMenu+BParametresTransformacio[2].LimitEsquerra && x<OrigenXPantallaMenu+BParametresTransformacio[2].LimitDret && y>OrigenYPantallaMenu-BParametresTransformacio[2].LimitSuperior && y<OrigenYPantallaMenu-BParametresTransformacio[2].LimitInferior)
		      {
			ControlSubSubMenu=6;
		      }
		    else if(x>OrigenXPantallaMenu+Crear.LimitEsquerra && x<OrigenXPantallaMenu+Crear.LimitDret && y>OrigenYPantallaMenu-Crear.LimitSuperior && y<OrigenYPantallaMenu-Crear.LimitInferior)
		      {
			//Pasem a translladar totes les figures seleccionades
			if(NumFiguresSeleccionades==0)
			  {
			    //No fem res ja que no hi ha figures a la llista
			  }
			else
			  {
			    //Agafem els valors introduits
			    int i=0;
			    while(i<3)
			      {
				int IndexChar=0;
				char Aux[101];
				while(IParametresTransformacioChar[i][IndexChar]!='V' && IndexChar<MAX_CARACTERS_INTRODUIR)
				  {
				    Aux[IndexChar]=IParametresTransformacioChar[i][IndexChar];
				    IParametresTransformacioChar[i][IndexChar]='V';
				    IndexChar++;
				  }
				if(IndexChar!=0)
				  {
				    Aux[IndexChar]='\0';
				    IParametresTransformacio[i]=atoi(Aux);
				  }
				else
				  {
				    IParametresTransformacio[i]=0.0;
				  }
				i++;
			      }
			    //Movem totes les figures de la llista
			    i=0;
			    while(i<NumFiguresSeleccionades)
			      {
				int j=1;
				while(j<=NumCubs)
				  {
				    if(FiguresSeleccionades[i]==rectangles[j].NumeroFigura())
				      {
					
					//Si es troba a la llista movem el seu centre
					float NouCentre[3];
					NouCentre[0]=rectangles[j].Centre[0]+IParametresTransformacio[0];
					NouCentre[1]=rectangles[j].Centre[1]+IParametresTransformacio[1];
					NouCentre[2]=rectangles[j].Centre[2]+IParametresTransformacio[2];
					rectangles[j].CanviarCentre(NouCentre[0],NouCentre[1],NouCentre[2]);
				      }
				    j++;
				  }
				j=1;
				while(j<=NumEsf)
				  {
				    if(FiguresSeleccionades[i]==esferes[j].NumeroFigura())
				      {
					//Si es troba a la llista movem el seu centre
					float NouCentre[3];
					NouCentre[0]=esferes[j].Centre[0]+IParametresTransformacio[0];
					NouCentre[1]=esferes[j].Centre[1]+IParametresTransformacio[1];
					NouCentre[2]=esferes[j].Centre[2]+IParametresTransformacio[2];
					esferes[j].CanviarCentre(NouCentre[0],NouCentre[1],NouCentre[2]);
				      }
				    j++;
				  }
				j=1;
				while(j<=NumCil)
				  {
				    if(FiguresSeleccionades[i]==cilindres[j].NumeroFigura())
				      {
					//Si es troba a la llista movem el seu centre
					float NouCentre[3];
					NouCentre[0]=cilindres[j].Centre[0]+IParametresTransformacio[0];
					NouCentre[1]=cilindres[j].Centre[1]+IParametresTransformacio[1];
					NouCentre[2]=cilindres[j].Centre[2]+IParametresTransformacio[2];
					cilindres[j].CanviarCentre(NouCentre[0],NouCentre[1],NouCentre[2]);
				      }
				    j++;
				  }
				j=1;
				while(j<=NumPla)
				  {
				    if(FiguresSeleccionades[i]==plans[j].NumeroFigura())
				      {
					//Si es troba a la llista movem el seu centre
					float NouCentre[3];
					NouCentre[0]=plans[j].Centre[0]+IParametresTransformacio[0];
					NouCentre[1]=plans[j].Centre[1]+IParametresTransformacio[1];
					NouCentre[2]=plans[j].Centre[2]+IParametresTransformacio[2];
					plans[j].CanviarCentre(NouCentre[0],NouCentre[1],NouCentre[2]);
				      }
				    j++;
				  }
				j=1;
				while(j<=NumSecEsf)
				  {
				    if(FiguresSeleccionades[i]==secEsf[j].NumeroFigura())
				      {
					//Si es troba a la llista movem el seu centre
					float NouCentre[3];
					NouCentre[0]=secEsf[j].Centre[0]+IParametresTransformacio[0];
					NouCentre[1]=secEsf[j].Centre[1]+IParametresTransformacio[1];
					NouCentre[2]=secEsf[j].Centre[2]+IParametresTransformacio[2];
					secEsf[j].CanviarCentre(NouCentre[0],NouCentre[1],NouCentre[2]);
				      }
				    j++;
				  }				
				i++;
			      }
			    //Diguem que hem de tornar a renderitzar les pantalles
			    RendFinestraGran=true;
			    RendFinestraSup=true;
			    RendFinestraInf=true;
			  }
		      }
		    
		  }
	      }
	  }
	                  
    }
 
  glutPostRedisplay(); 
  }
 
}

//--------------------------------------Funcio que controla el moviment del ratoli--------------------------------------------------//

void MovimentRatoli(int x, int y)
{
  if(ActivarVisor2D==true)
  {
    if(SelBarraVisor==true)
    {
	float NumPlans=float(DimEspaiDicom[2]/DimPlaDicom[2]);
	
	PlaVisor2D=int(((AlturaVisor2D-y)-AlturaBarraMobil*0.5)/AlturaBarraMobil);
	//Comprovem que no sobrepasa els limits
	if(PlaVisor2D>=NumPlans)
	{
	  PlaVisor2D=NumPlans-1;
	}
	else if(PlaVisor2D<0)
	{
	  PlaVisor2D=0;
	}
	glutPostRedisplay();
    }    
    else if(x<AmpladaVisor2D && x>0 && y<AlturaVisor2D && y>0) //Si s'acompleix, es troba dins de la pantalla del visor
    {
      PosVisor2D[0]=float(DimPlaDicom[0]/AmpladaVisor2D)*x;
      PosVisor2D[1]=float(DimPlaDicom[1]/AlturaVisor2D)*(AlturaVisor2D-y);
      

	if(SelPlaTallSup[0]==true)	//Canviem el pla de tall superior de l'eix X
	{
	  ActualitzarPlansVisor2D=true;
	  if(PosVisor2D[0]>PlansTallInf[0])	//Si la posicio del ratoli es major que el pla inferior s'asigna el valor
	  {
	    PlansTall[0]=PosVisor2D[0];
	  }
	  else	//si no és així canviem la selecció al pla de tall inferior
	  {
	    SelPlaTallSup[0]=false;
	    SelPlaTallInf[0]=true;
	    PlansTallInf[0]=PosVisor2D[0];
	  }
	}
	else if(SelPlaTallInf[0]==true)	//Canviem el pla de tall superior de l'eix X
	{
	  ActualitzarPlansVisor2D=true;
	  if(PosVisor2D[0]<PlansTall[0])	//Si la posicio del ratoli es menor que el pla superior s'asigna el valor
	  {
	    PlansTallInf[0]=PosVisor2D[0];
	  }
	  else	//si no és així canviem la selecció al pla de tall superior
	  {
	    SelPlaTallSup[0]=true;
	    SelPlaTallInf[0]=false;
	    PlansTall[0]=PosVisor2D[0];
	  }
	}

	if(SelPlaTallSup[1]==true)	//Canviem el pla de tall superior de l'eix X
	{
	  ActualitzarPlansVisor2D=true;
	  if(PosVisor2D[1]>PlansTallInf[1])	//Si la posicio del ratoli es major que el pla inferior s'asigna el valor
	  {
	    PlansTall[1]=PosVisor2D[1];
	  }
	  else	//si no és així canviem la selecció al pla de tall inferior
	  {
	    SelPlaTallSup[1]=false;
	    SelPlaTallInf[1]=true;
	    PlansTallInf[1]=PosVisor2D[1];
	  }
	}
	else if(SelPlaTallInf[1]==true)	//Canviem el pla de tall superior de l'eix X
	{
	  ActualitzarPlansVisor2D=true;
	  if(PosVisor2D[1]<PlansTall[1])	//Si la posicio del ratoli es menor que el pla superior s'asigna el valor
	  {
	    PlansTallInf[1]=PosVisor2D[1];
	  }
	  else	//si no és així canviem la selecció al pla de tall superior
	  {
	    SelPlaTallSup[1]=true;
	    SelPlaTallInf[1]=false;
	    PlansTall[1]=PosVisor2D[1];
	  }
	}      

      glutPostRedisplay();
    }
  }
  else
  {
    if(Pantalla==0)
    {
      angle=angle+(x-PosCursorX)*0.25;
      PosCursorX=x;
      //Diguem que hem de tornar a renderitzar la pantalla gran
      RendFinestraGran=true;    
      glutPostRedisplay();
    }else if(Pantalla==2)
    {
      angle2=angle2+(x-PosCursorX)*0.25;
      PosCursorX=x;
      //Diguem que hem de tornar a renderitzar la pantalla superior
      RendFinestraSup=true;
      
      glutPostRedisplay();
    }else if(Pantalla==1)
    {
      angle1=angle1+(x-PosCursorX)*0.25;
      PosCursorX=x;      
      //Diguem que hem de tornar a renderitzar la pantalla inferior
      RendFinestraInf=true;    
      glutPostRedisplay();
    }
  }
}

//---------------------------------------Funcio que controla el teclat de la finestra guardar/carregar------------------------------------------//


void Fteclat(unsigned char tecla, int x, int y)
{
    if(ControlMenu==4 || ControlMenu==5 )	//Indica que omplim el quadre on s'introdueix el nom dels arxius a guardar/carregar
    {
      int IndexChar=0;
      while(INomArxiuChar[IndexChar]!='\0' && IndexChar<MAX_CARACTERS_INTRODUIR)		//Mira quina posició és la primera buida (Amb una 'V')
      {
	IndexChar++;
      }
      if(tecla==8 && IndexChar!=0)				//Si apretem la tecla retroses borra l'ultim numero
      {
	INomArxiuChar[IndexChar-1]='\0';
      }
      else if(tecla==' ' && IndexChar==0)
      {
	//No fa res si posem un espai al inici
      }
      else if(tecla<=31 || tecla==127)
      {
	//No fa res ja que són caràcters no imprimibles
      }
      //Aquest if mirara si hem arribat al màxim tamany de l'array
      else if(IndexChar<99)
      {
	 INomArxiuChar[IndexChar]=tolower(tecla);
	 INomArxiuChar[IndexChar+1]='\0';
      }
    }
    
   glutPostRedisplay();
}

//---------------------------------------Funcio que controla el teclat amb acarcters especials de la finestra guardar/carregar-----------------------------------------//

void FTeclatEsp(int tecla, int x, int y)
{
  if(tecla==GLUT_KEY_UP && YGC>0)
  {
    YGC-=5;
  }
  else if(tecla==GLUT_KEY_DOWN)
  {
    YGC+=5;
  }
  glutPostRedisplay();
}

//--------------------------------------Funcio que controla el ratoli de la finestra guardar/carregar--------------------------------------------------------//

void Fratoli(int boto, int estat, int x, int y)
{
  //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  ////////////////////////////////////////////////////GUARDAR GEOMETRIA/////////////////////////////////////////////////////////////////////////
  //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  if(boto==GLUT_LEFT_BUTTON && estat==GLUT_DOWN && (ControlMenu==4 && ControlSubMenu==1) && y<ALTURA2-TamanyBotons[1]*2+TamanyBotons[1]/2.0 && y>ALTURA2-TamanyBotons[1]*2-TamanyBotons[1]/2.0 && x<AMPLADA2-TamanyBotons[0]/2.0+TamanyBotons[0]/4.0 && x>AMPLADA2-TamanyBotons[0]/2.0-TamanyBotons[0]/4.0)
  {
      //Guardar//
    if(INomArxiuChar[0]!='\0')
    {
      YGC=0;
      ControlMenu=0;
      ControlSubMenu=0;
      ControlSubSubMenu=0;
      chdir(Geometriadir.c_str());
      std::string AuxStringDirectori;
      
      int i=0;
      while(INomArxiuChar[i]!='\0')
      {
	AuxStringDirectori+=INomArxiuChar[i];
	i++;
      }
      AuxStringDirectori=AuxStringDirectori+".txt";

      //Obrim l'arxiu//
      std::ofstream Arxiu;
      Arxiu.open(AuxStringDirectori.c_str(), std::ios::out );
      
      Arxiu<<std::endl;
      Arxiu<<NumVoxels[0]<<" "<<NumVoxels[1]<<" "<<NumVoxels[2]<<std::endl;
      Arxiu<<DimVoxels[0]<<" "<<DimVoxels[1]<<" "<<DimVoxels[2]<<std::endl;
      Arxiu<<NumCubs<<" "<<NumEsf<<" "<<NumCil<<" "<<NumPla<<" "<<NumSecEsf<<std::endl;
      //Guardem el registre de les prioritats. Primer les utilitzades i després les internes//
      i=0;
      while(i<1000)
      {
	Arxiu<<PrioritatsAsignades[0][i]<<" ";
	i++;
      }
      Arxiu<<std::endl;
      i=1;
      int j=0;
      /////////////////////Guardem els cubs///////////////////////////////////
      while(i<=NumCubs)
      {
	Arxiu<<rectangles[i].radiMax<<std::endl;
	Arxiu<<rectangles[i].Densitat<<std::endl;
	Arxiu<<rectangles[i].llistaCreada<<std::endl;				
	Arxiu<<rectangles[i].NFigura<<std::endl;
	j=0;
	while(j<100)
	{
	  Arxiu<<rectangles[i].PDins[j]<<" ";
	  j++;
	}
	Arxiu<<std::endl;
	Arxiu<<rectangles[i].Alfa<<" "<<rectangles[i].Beta<<" "<<rectangles[i].Gamma<<std::endl;
	Arxiu<<rectangles[i].Centre[0]<<" "<<rectangles[i].Centre[1]<<" "<<rectangles[i].Centre[2]<<std::endl;
	Arxiu<<rectangles[i].Material<<std::endl;
	Arxiu<<rectangles[i].Prioritat<<std::endl;
	
	Arxiu<<rectangles[i].Dimensions[0]<<" "<<rectangles[i].Dimensions[1]<<" "<<rectangles[i].Dimensions[2]<<std::endl;
	i++;
      }
      i=1;
      ///////////////////////Guardem les esferes////////////////////////////////
      while(i<=NumEsf)
      {
	Arxiu<<esferes[i].radiMax<<std::endl;
	Arxiu<<esferes[i].Densitat<<std::endl;
	Arxiu<<esferes[i].llistaCreada<<std::endl;				//Li diguem que la llista no està creada
	Arxiu<<esferes[i].NFigura<<std::endl;
	j=0;
	while(j<100)
	{
	  Arxiu<<esferes[i].PDins[j]<<" ";
	  j++;
	}
	Arxiu<<std::endl;
	Arxiu<<esferes[i].Centre[0]<<" "<<esferes[i].Centre[1]<<" "<<esferes[i].Centre[2]<<std::endl;
	Arxiu<<esferes[i].Material<<std::endl;
	Arxiu<<esferes[i].Prioritat<<std::endl;
	
	Arxiu<<esferes[i].Dimensions<<std::endl;
	i++;
      } 
      i=1;
      ////////////////////////Guardem els cilindres////////////////////////////////
      while(i<=NumCil)
      {
	Arxiu<<cilindres[i].radiMax<<std::endl;
	Arxiu<<cilindres[i].Densitat<<std::endl;
	Arxiu<<cilindres[i].llistaCreada<<std::endl;				//Li diguem que la llista no està creada
	Arxiu<<cilindres[i].NFigura<<std::endl;
	j=0;
	while(j<100)
	{
	  Arxiu<<cilindres[i].PDins[j]<<" ";
	  j++;
	}
	Arxiu<<std::endl;
	Arxiu<<cilindres[i].Alfa<<" "<<cilindres[i].Beta<<" "<<cilindres[i].Gamma<<std::endl;
	Arxiu<<cilindres[i].Centre[0]<<" "<<cilindres[i].Centre[1]<<" "<<cilindres[i].Centre[2]<<std::endl;
	Arxiu<<cilindres[i].Material<<std::endl;
	Arxiu<<cilindres[i].Prioritat<<std::endl;
	Arxiu<<cilindres[i].Tub<<std::endl;
	
	Arxiu<<cilindres[i].Dimensions[0]<<" "<<cilindres[i].Dimensions[1]<<" "<<cilindres[i].Dimensions[2]<<std::endl;
	i++;
      }
      i=1;
      ////////////////////////Guardem els plans////////////////////////////////
      while(i<=NumPla)
      {
	Arxiu<<plans[i].radiMax<<std::endl;
	Arxiu<<plans[i].Densitat<<std::endl;
	Arxiu<<plans[i].llistaCreada<<std::endl;				//Li diguem que la llista no està creada
	Arxiu<<plans[i].NFigura<<std::endl;
	j=0;
	while(j<100)
	{
	  Arxiu<<plans[i].PDins[j]<<" ";
	  j++;
	}
	Arxiu<<std::endl;
	Arxiu<<plans[i].Alfa<<" "<<plans[i].Beta<<" "<<plans[i].Gamma<<std::endl;
	Arxiu<<plans[i].Centre[0]<<" "<<plans[i].Centre[1]<<" "<<plans[i].Centre[2]<<std::endl;
	Arxiu<<plans[i].Material<<std::endl;
	Arxiu<<plans[i].Prioritat<<std::endl;
	
	Arxiu<<plans[i].Direccio[0]<<" "<<plans[i].Direccio[1]<<" "<<plans[i].Direccio[2]<<std::endl;
	i++;
      }
      i=1;
      ////////////////////////Guardem les seccions d'esfera////////////////////////////////
      while(i<=NumSecEsf)
      {
	Arxiu<<secEsf[i].radiMax<<std::endl;
	Arxiu<<secEsf[i].Densitat<<std::endl;
	Arxiu<<secEsf[i].llistaCreada<<std::endl;				//Li diguem que la llista no està creada
	Arxiu<<secEsf[i].NFigura<<std::endl;
	j=0;
	while(j<100)
	{
	  Arxiu<<secEsf[i].PDins[j]<<" ";
	  j++;
	}
	Arxiu<<std::endl;
	Arxiu<<secEsf[i].Alfa<<" "<<secEsf[i].Beta<<" "<<secEsf[i].Gamma<<std::endl;
	Arxiu<<secEsf[i].Centre[0]<<" "<<secEsf[i].Centre[1]<<" "<<secEsf[i].Centre[2]<<std::endl;
	Arxiu<<secEsf[i].Material<<std::endl;
	Arxiu<<secEsf[i].Prioritat<<std::endl;
	
	Arxiu<<secEsf[i].Dimensions[0]<<" "<<secEsf[i].Dimensions[1]<<std::endl;
	Arxiu<<secEsf[i].Direccio[0]<<" "<<secEsf[i].Direccio[1]<<" "<<secEsf[i].Direccio[2]<<std::endl;
	i++;
      }
      
      Arxiu<<NumTotalFig<<std::endl;
      Arxiu<<MaxMaterial<<std::endl;
      Arxiu<<MaxPrioritat<<std::endl;
      Arxiu.close();
      chdir(Actualdir);
      glutHideWindow();				//Amaguem la finestra fins que necesitem guardar o carregar un arxiu
  
      glutSetWindow(IdeFinestres[0]);		//seleccionem la finestra principal      
    
      INomArxiuChar[0]='\0';
    }
    
  }
  //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  ////////////////////////////////////////////////////GUARDAR GEOMETRIA PENE////////////////////////////////////////////////////////////////////
  //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  else if(boto==GLUT_LEFT_BUTTON && estat==GLUT_DOWN && (ControlMenu==4 && ControlSubMenu==2) && y<ALTURA2-TamanyBotons[1]*2+TamanyBotons[1]/2.0 && y>ALTURA2-TamanyBotons[1]*2-TamanyBotons[1]/2.0 && x<AMPLADA2-TamanyBotons[0]/2.0+TamanyBotons[0]/4.0 && x>AMPLADA2-TamanyBotons[0]/2.0-TamanyBotons[0]/4.0)
  {
    if(INomArxiuChar[0]!='\0')
    {
      YGC=0;
      ControlMenu=0;
      ControlSubMenu=0;
      ControlSubSubMenu=0;
      chdir("GeometriesPenelope");
      std::string AuxStringDirectori;
      
      int i=0;
      while(INomArxiuChar[i]!='\0')
      {
	AuxStringDirectori+=INomArxiuChar[i];
	i++;
      }
      AuxStringDirectori=AuxStringDirectori+".geo";

      //Obrim l'arxiu//
      //////////////////////////////////////////Escrivim l'arxiu .geo/////////////////////////////////////////////////////////////
      FILE* arxiu;
      arxiu=fopen(AuxStringDirectori.c_str(),"w");
      fprintf(arxiu,">>> GEOMETRY FILE FOR THE PENELOPE SYSTEM >>>>>>>>>>>>>>>>>>>>>>\n");
      fprintf(arxiu,"****************************************************************\n");
      fprintf(arxiu,"************GEOMETRY CONSTRUCTED WITH VOXEL MAGES***************\n");
      fprintf(arxiu,"****************************************************************\n");
      fprintf(arxiu,">>> END OF HEADER >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>\n");
      fprintf(arxiu,"  Materials:\n\n");
      i=0;
      while(i<MaxMaterial)
	{
	  fprintf(arxiu,"     mat %i -> \n",i);
	  i++;
	}
      fprintf(arxiu,"\n");
      int NumSuperficie=1;
      int NumCosos=1;
    //////////////////////////Comença des de l'ultima prioritat (les figures que es pinten sobre les altres) i va baixant fins a prioritat 1, que són les figures més externes//////////
    i=1000;	//és el nombre màxim de prioritats		
    int j=1;
    //Creem dos vectors. En el primer guardem les figures que formaran un unic cos (Totes les que tinguen la mateixa prioritat) i  el seu material (posicions 0 i 1 respectivament). El segon guarda els "BODY"s que te dins el cos//
    int NumFigures=NumCubs+NumEsf+NumCil+NumPla+NumSecEsf;
    int FiguresDelCos[MaxFigures][2];
    int CosDins[MaxFigures][MaxFigures];  //Guardara els cosos que conte cada cos
    int NumFigCos=0;                        //Nombre d'objectes que formen un mateix cos
    int NumCosDins[MaxFigures];           //Guarda el nombre de cosos que conte cada cos
    int NumSuperficieInicial=0;
    j=0;
    while(j<NumFigures+1)
    {
        FiguresDelCos[j][0]=0;
        FiguresDelCos[j][1]=0;
	int z=0;
	while(z<NumFigures+1)
	  {
	    CosDins[j][z]=0;
	    z++;
	  }
	NumCosDins[j]=0;
	j++;
    }    
    while(i>0)
    {
      //Guardem el numero de superficie on comença el nou objecte///
      NumSuperficieInicial=NumSuperficie;
      //////////////////////////////////////////////////////////////
      int CososPrioritat[MaxCubs+MaxEsferes+MaxCilindres+MaxPlans+MaxSecEsf];	//Guarda la prioritat de cada cos per a poder determinar els cossos a l'interior de cada cos, comparant amb el vector de prioritats dins de cada objecte
      //Buidem les figures que formen el cos//
      j=0;
      while(j<NumFigures+1)
      {
        FiguresDelCos[j][0]=0;
        FiguresDelCos[j][1]=0;	
	j++;
      }
      NumFigCos=0;
      //Hem de tindre en compte si la figura esta rotada, el que afectarà al desplaçament de les superfícies que la formen. Per aquest motiu definim les variables,//
      double xRotat=0;
      double yRotat=0;
      double zRotat=0;
      double omega=0;
      double theta=0;
      double phi=0;
      j=1;
      while(j<=NumCubs)				//Mira en tots els cubs si algun te la prioritat que es demana
      {
	if(rectangles[j].Prioritat==i)		//Si un rectangle te la prioritat que demana el guarda
	{
	  //Primer guardem que aquesta figura formara part del cos, el tipus de figura, el material i les prioritats que tindra dins.
	  FiguresDelCos[NumFigCos][0]=1;
	  FiguresDelCos[NumFigCos][1]=rectangles[j].Material;
	  NumFigCos++;
	  int k=0;
	  while(k<100)
	  {
	    bool Trobat=false;			//Controlarà si ja esta la prioritat a la llista
	    if(rectangles[j].PDins[k]==0)
	    {
	      break;
	    }
	    //Comprovem que aquesta prioritat no estiga ja incluida//
	    int m=0;
	    while(m<NumCosDins[NumCosos])
	    {
	      if(CosDins[NumCosos][m]==rectangles[j].PDins[k])
	      {
		Trobat=true;
		break;
	      }
	      m++;
	    }
	    if(Trobat==false)
	    {
	      CosDins[NumCosos][NumCosDins[NumCosos]]=rectangles[j].PDins[k];
	      NumCosDins[NumCosos]++;
	    }
	    Trobat=false;
	    k++;
	   }
	   ////////////////////////////////////////////////////////////////////////////////////////////////////
	   //Guarda la prioritat d'aquest cos per a poder buscar-la despres i asignar-li el cos pare//
	  CososPrioritat[NumCosos]=rectangles[j].Prioritat;
	  //He agafat com a referència el model de Box a la carpeta del penelope//
	  omega=rectangles[j].Alfa*PI/180.0;
	  theta=rectangles[j].Beta*PI/180.0;
	  phi=rectangles[j].Gamma*PI/180.0;
	  //Rotarem el vector que va del 0,0,0 al centre de la superfície que forma part de la figura i després farem la translació al punt elegit com centre de la figura
	  //Superficie 1//
	  if(rectangles[j].Alfa==0 && rectangles[j].Beta==0 && rectangles[j].Gamma==0)
	  {
	    xRotat=rectangles[j].Centre[0];
	    yRotat=rectangles[j].Centre[1];
	    zRotat=-rectangles[j].Dimensions[2]/2.0+rectangles[j].Centre[2];
	  }else
	  {
	    xRotat=-rectangles[j].Dimensions[2]/2.0*cos(phi)*sin(theta)+rectangles[j].Centre[0];
	    yRotat=-rectangles[j].Dimensions[2]/2.0*sin(theta)*sin(phi)+rectangles[j].Centre[1];
	    zRotat=-rectangles[j].Dimensions[2]/2.0*cos(theta)+rectangles[j].Centre[2];
	  }
	  fprintf(arxiu,"0000000000000000000000000000000000000000000000000000000000000000\n");	  
	  fprintf(arxiu,"SURFACE (%s%i) Pla superior (-Z)\n",NumSuperficie>=10 ? (NumSuperficie>=100 ? " ":"  "):"   ",NumSuperficie);		//Pla superior	(-Z)
	  NumSuperficie++;
	  fprintf(arxiu,"INDICES=( 0, 0, 0, 1, 0)\n");
	  fprintf(arxiu,"X-SHIFT=(%s%.15E,   0)\n",xRotat>=0 ? "+":"",xRotat);
	  fprintf(arxiu,"Y-SHIFT=(%s%.15E,   0)\n",yRotat>=0 ? "+":"",yRotat);
	  fprintf(arxiu,"Z-SHIFT=(%s%.15E,   0)\n",zRotat>=0 ? "+":"",zRotat);
	  fprintf(arxiu,"  OMEGA=(%s%.15E,   0) RAD\n",omega>=0 ? "+":"",omega);
	  fprintf(arxiu,"  THETA=(%s%.15E,   0) RAD\n",theta>=0 ? "+":"",theta);
	  fprintf(arxiu,"    PHI=(%s%.15E,   0) RAD\n",phi>=0 ? "+":"",phi);
	  //Superficie 2//
	  if(rectangles[j].Alfa==0 && rectangles[j].Beta==0 && rectangles[j].Gamma==0)
	  {
	    xRotat=rectangles[j].Centre[0];
	    yRotat=rectangles[j].Centre[1];
	    zRotat=rectangles[j].Dimensions[2]/2.0+rectangles[j].Centre[2];
	  }else
	  {
	    xRotat=rectangles[j].Dimensions[2]/2.0*cos(phi)*sin(theta)+rectangles[j].Centre[0];
	    yRotat=rectangles[j].Dimensions[2]/2.0*sin(theta)*sin(phi)+rectangles[j].Centre[1];
	    zRotat=rectangles[j].Dimensions[2]/2.0*cos(theta)+rectangles[j].Centre[2];
	  }
	  fprintf(arxiu,"0000000000000000000000000000000000000000000000000000000000000000\n");
	  fprintf(arxiu,"SURFACE (%s%i) Pla inferior (+Z)\n" ,NumSuperficie>=10 ? (NumSuperficie>=100 ? " ":"  "):"   ",NumSuperficie);		//Pla inferior	(+Z)
	  NumSuperficie++;	
	  fprintf(arxiu,"INDICES=( 0, 0, 0, 1, 0)\n");
	  fprintf(arxiu,"X-SHIFT=(%s%.15E,   0)\n",xRotat>=0 ? "+":"",xRotat);
	  fprintf(arxiu,"Y-SHIFT=(%s%.15E,   0)\n",yRotat>=0 ? "+":"",yRotat);
	  fprintf(arxiu,"Z-SHIFT=(%s%.15E,   0)\n",zRotat>=0 ? "+":"",zRotat);
	  fprintf(arxiu,"  OMEGA=(%s%.15E,   0) RAD\n",omega>=0 ? "+":"",omega);
	  fprintf(arxiu,"  THETA=(%s%.15E,   0) RAD\n",theta>=0 ? "+":"",theta);
	  fprintf(arxiu,"    PHI=(%s%.15E,   0) RAD\n",phi>=0 ? "+":"",phi);
	  //Superficie 3//
	  if(rectangles[j].Alfa==0 && rectangles[j].Beta==0 && rectangles[j].Gamma==0)
	  {
	    xRotat=rectangles[j].Centre[0]-rectangles[j].Dimensions[0]/2.0;
	    yRotat=rectangles[j].Centre[1];
	    zRotat=rectangles[j].Centre[2];
	  }else
	  {
	    xRotat=-rectangles[j].Dimensions[0]/2.0*(cos(theta)*cos(phi)*cos(omega)-sin(phi)*sin(omega))+rectangles[j].Centre[0];
	    yRotat=-rectangles[j].Dimensions[0]/2.0*(cos(theta)*cos(omega)*sin(phi)+cos(phi)*sin(omega))+rectangles[j].Centre[1];
	    zRotat=+rectangles[j].Dimensions[0]/2.0*cos(omega)*sin(theta)+rectangles[j].Centre[2];
	  }
	  fprintf(arxiu,"0000000000000000000000000000000000000000000000000000000000000000\n");
	  fprintf(arxiu,"SURFACE (%s%i) Pla en -X\n",NumSuperficie>=10 ? (NumSuperficie>=100 ? " ":"  "):"   ",NumSuperficie);		//Pla en -X
	  NumSuperficie++;
	  fprintf(arxiu,"INDICES=( 0, 0, 0, 0, 0)\n");
	  fprintf(arxiu,"     AX=(+1.000000000000000E+00,   0)\n");
	  fprintf(arxiu,"1111111111111111111111111111111111111111111111111111111111111111\n");
	  fprintf(arxiu,"X-SHIFT=(%s%.15E,   0)\n",xRotat>=0 ? "+":"",xRotat);
	  fprintf(arxiu,"Y-SHIFT=(%s%.15E,   0)\n",yRotat>=0 ? "+":"",yRotat);
	  fprintf(arxiu,"Z-SHIFT=(%s%.15E,   0)\n",zRotat>=0 ? "+":"",zRotat);
	  fprintf(arxiu,"  OMEGA=(%s%.15E,   0) RAD\n",omega>=0 ? "+":"",omega);
	  fprintf(arxiu,"  THETA=(%s%.15E,   0) RAD\n",theta>=0 ? "+":"",theta);
	  fprintf(arxiu,"    PHI=(%s%.15E,   0) RAD\n",phi>=0 ? "+":"",phi);
	  //Superficie 4//
	  if(rectangles[j].Alfa==0 && rectangles[j].Beta==0 && rectangles[j].Gamma==0)
	  {
	    xRotat=rectangles[j].Centre[0]+rectangles[j].Dimensions[0]/2.0;
	    yRotat=rectangles[j].Centre[1];
	    zRotat=rectangles[j].Centre[2];
	  }else
	  {
	    xRotat=rectangles[j].Dimensions[0]/2.0*(cos(theta)*cos(phi)*cos(omega)-sin(phi)*sin(omega))+rectangles[j].Centre[0];
	    yRotat=rectangles[j].Dimensions[0]/2.0*(cos(theta)*cos(omega)*sin(phi)+cos(phi)*sin(omega))+rectangles[j].Centre[1];
	    zRotat=-rectangles[j].Dimensions[0]/2.0*cos(omega)*sin(theta)+rectangles[j].Centre[2];
	  }
	  fprintf(arxiu,"0000000000000000000000000000000000000000000000000000000000000000\n");
	  fprintf(arxiu,"SURFACE (%s%i) Pla en +X\n",NumSuperficie>=10 ? (NumSuperficie>=100 ? " ":"  "):"   ",NumSuperficie);		//Pla en +X
	  NumSuperficie++;
	  fprintf(arxiu,"INDICES=( 0, 0, 0, 0, 0)\n");
	  fprintf(arxiu,"     AX=(+1.000000000000000E+00,   0)\n");
	  fprintf(arxiu,"1111111111111111111111111111111111111111111111111111111111111111\n");
	  fprintf(arxiu,"X-SHIFT=(%s%.15E,   0)\n",xRotat>=0 ? "+":"",xRotat);
	  fprintf(arxiu,"Y-SHIFT=(%s%.15E,   0)\n",yRotat>=0 ? "+":"",yRotat);
	  fprintf(arxiu,"Z-SHIFT=(%s%.15E,   0)\n",zRotat>=0 ? "+":"",zRotat);
	  fprintf(arxiu,"  OMEGA=(%s%.15E,   0) RAD\n",omega>=0 ? "+":"",omega);
	  fprintf(arxiu,"  THETA=(%s%.15E,   0) RAD\n",theta>=0 ? "+":"",theta);
	  fprintf(arxiu,"    PHI=(%s%.15E,   0) RAD\n",phi>=0 ? "+":"",phi);
	  //Superficie 5//
	  if(rectangles[j].Alfa==0 && rectangles[j].Beta==0 && rectangles[j].Gamma==0)
	  {
	    xRotat=rectangles[j].Centre[0];
	    yRotat=rectangles[j].Centre[1]-rectangles[j].Dimensions[1]/2.0;
	    zRotat=rectangles[j].Centre[2];
	  }else
	  {
	    xRotat=-rectangles[j].Dimensions[1]/2.0*(-cos(omega)*sin(phi)-cos(theta)*cos(phi)*sin(omega))+rectangles[j].Centre[0];
	    yRotat=-rectangles[j].Dimensions[1]/2.0*(cos(phi)*cos(omega)-cos(theta)*sin(phi)*sin(omega))+rectangles[j].Centre[1];
	    zRotat=-rectangles[j].Dimensions[1]/2.0*sin(theta)*sin(omega)+rectangles[j].Centre[2];
	  }
	  fprintf(arxiu,"0000000000000000000000000000000000000000000000000000000000000000\n");
	  fprintf(arxiu,"SURFACE (%s%i) Pla en -Y\n",NumSuperficie>=10 ? (NumSuperficie>=100 ? " ":"  "):"   ",NumSuperficie);		//Pla en -Y
	  NumSuperficie++;
	  fprintf(arxiu,"INDICES=( 0, 0, 0, 0, 0)\n");
	  fprintf(arxiu,"     AY=(+1.000000000000000E+00,   0)\n");
	  fprintf(arxiu,"1111111111111111111111111111111111111111111111111111111111111111\n");
	  fprintf(arxiu,"X-SHIFT=(%s%.15E,   0)\n",xRotat>=0 ? "+":"",xRotat);
	  fprintf(arxiu,"Y-SHIFT=(%s%.15E,   0)\n",yRotat>=0 ? "+":"",yRotat);
	  fprintf(arxiu,"Z-SHIFT=(%s%.15E,   0)\n",zRotat>=0 ? "+":"",zRotat);
	  fprintf(arxiu,"  OMEGA=(%s%.15E,   0) RAD\n",omega>=0 ? "+":"",omega);
	  fprintf(arxiu,"  THETA=(%s%.15E,   0) RAD\n",theta>=0 ? "+":"",theta);
	  fprintf(arxiu,"    PHI=(%s%.15E,   0) RAD\n",phi>=0 ? "+":"",phi);
	  //Superficie 6//
	  if(rectangles[j].Alfa==0 && rectangles[j].Beta==0 && rectangles[j].Gamma==0)
	  {
	    xRotat=rectangles[j].Centre[0];
	    yRotat=rectangles[j].Centre[1]+rectangles[j].Dimensions[1]/2.0;
	    zRotat=rectangles[j].Centre[2];
	  }else
	  {
	    xRotat=rectangles[j].Dimensions[1]/2.0*(-cos(omega)*sin(phi)-cos(theta)*cos(phi)*sin(omega))+rectangles[j].Centre[0];
	    yRotat=rectangles[j].Dimensions[1]/2.0*(cos(phi)*cos(omega)-cos(theta)*sin(phi)*sin(omega))+rectangles[j].Centre[1];
	    zRotat=rectangles[j].Dimensions[1]/2.0*sin(theta)*sin(omega)+rectangles[j].Centre[2];
	  }	  
	  fprintf(arxiu,"0000000000000000000000000000000000000000000000000000000000000000\n");
	  fprintf(arxiu,"SURFACE (%s%i) Pla en +Y\n",NumSuperficie>=10 ? (NumSuperficie>=100 ? " ":"  "):"   ",NumSuperficie);		//Pla en +Y
	  NumSuperficie++;
	  fprintf(arxiu,"INDICES=( 0, 0, 0, 0, 0)\n");
	  fprintf(arxiu,"     AY=(+1.000000000000000E+00,   0)\n");
	  fprintf(arxiu,"1111111111111111111111111111111111111111111111111111111111111111\n");
	  fprintf(arxiu,"X-SHIFT=(%s%.15E,   0)\n",xRotat>=0 ? "+":"",xRotat);
	  fprintf(arxiu,"Y-SHIFT=(%s%.15E,   0)\n",yRotat>=0 ? "+":"",yRotat);
	  fprintf(arxiu,"Z-SHIFT=(%s%.15E,   0)\n",zRotat>=0 ? "+":"",zRotat);
	  fprintf(arxiu,"  OMEGA=(%s%.15E,   0) RAD\n",omega>=0 ? "+":"",omega);
	  fprintf(arxiu,"  THETA=(%s%.15E,   0) RAD\n",theta>=0 ? "+":"",theta);
	  fprintf(arxiu,"    PHI=(%s%.15E,   0) RAD\n",phi>=0 ? "+":"",phi);	  

      }
	j++;
     }
      j=1;
      while(j<=NumEsf)
      {
	if(esferes[j].Prioritat==i)
	{
	  //Primer guardem que aquesta figura formara part del cos, el tipus de figura, el material i les prioritats que tindra dins.
	  FiguresDelCos[NumFigCos][0]=2;
	  FiguresDelCos[NumFigCos][1]=esferes[j].Material;
	  NumFigCos++;
	  int k=0;
	  while(k<100)
	  {
	    bool Trobat=false;			//Controlarà si ja esta la prioritat a la llista
	    if(esferes[j].PDins[k]==0)
	    {
	      break;
	    }
	    //Comprovem que aquesta prioritat no estiga ja incluida//
	    int m=0;
	    while(m<NumCosDins[NumCosos])
	    {
	      if(CosDins[NumCosos][m]==esferes[j].PDins[k])
	      {
		Trobat=true;
		break;
	      }
	      m++;
	    }
	    if(Trobat==false)
	    {
	      CosDins[NumCosos][NumCosDins[NumCosos]]=esferes[j].PDins[k];
	      NumCosDins[NumCosos]++;
	    }
	    Trobat=false;
	    k++;
	   }
	   ////////////////////////////////////////////////////////////////////////////////////////////////////
	  CososPrioritat[NumCosos]=esferes[j].Prioritat;
	  ////////////////////////Pintem la superfície de l'esfera/////////////////////////////////////
	  fprintf(arxiu,"0000000000000000000000000000000000000000000000000000000000000000\n");
	  fprintf(arxiu,"SURFACE (%s%i) Superficie de l'esfera\n",NumSuperficie>=10 ? (NumSuperficie>=100 ? " ":"  "):"   ",NumSuperficie);		
	  NumSuperficie++;
	  fprintf(arxiu,"INDICES=( 1, 1, 1, 0,-1)\n");
	  fprintf(arxiu,"X-SCALE=(%s%.15E,   0)\n",esferes[j].Dimensions>=0 ? "+":"",esferes[j].Dimensions);
	  fprintf(arxiu,"Y-SCALE=(%s%.15E,   0)\n",esferes[j].Dimensions>=0 ? "+":"",esferes[j].Dimensions);
	  fprintf(arxiu,"Z-SCALE=(%s%.15E,   0)\n",esferes[j].Dimensions>=0 ? "+":"",esferes[j].Dimensions);	
	  fprintf(arxiu,"X-SHIFT=(%s%.15E,   0)\n",esferes[j].Centre[0]>=0 ? "+":"",esferes[j].Centre[0]);
	  fprintf(arxiu,"Y-SHIFT=(%s%.15E,   0)\n",esferes[j].Centre[1]>=0 ? "+":"",esferes[j].Centre[1]);
	  fprintf(arxiu,"Z-SHIFT=(%s%.15E,   0)\n",esferes[j].Centre[2]>=0 ? "+":"",esferes[j].Centre[2]);

	}
	j++;
      }
      j=1;
      while(j<=NumCil)
      {
	if(cilindres[j].Prioritat==i)
	{
	  //Primer guardem que aquesta figura formara part del cos, el tipus de figura, el material i les prioritats que tindra dins.	  
	  FiguresDelCos[NumFigCos][1]=cilindres[j].Material;
	  int k=0;
	  while(k<100)
	  {
	    bool Trobat=false;			//Controlarà si ja esta la prioritat a la llista
	    if(cilindres[j].PDins[k]==0)
	    {
	      break;
	    }
	    //Comprovem que aquesta prioritat no estiga ja incluida//
	    int m=0;
	    while(m<NumCosDins[NumCosos])
	    {
	      if(CosDins[NumCosos][m]==cilindres[j].PDins[k])
	      {
		Trobat=true;
		break;
	      }
	      m++;
	    }
	    if(Trobat==false)
	    {
	      CosDins[NumCosos][NumCosDins[NumCosos]]=cilindres[j].PDins[k];
	      NumCosDins[NumCosos]++;
	    }
	    Trobat=false;
	    k++;
	   }
	   ////////////////////////////////////////////////////////////////////////////////////////////////////
	  CososPrioritat[NumCosos]=cilindres[j].Prioritat;
	  omega=cilindres[j].Alfa*PI/180.0;
	  theta=cilindres[j].Beta*PI/180.0;
	  phi=cilindres[j].Gamma*PI/180.0;
	  //Mirem si es un tub o no
	  if(cilindres[j].Tub==true)
	    {
		  //El tub sera el tipus de figura 8//
		  FiguresDelCos[NumFigCos][0]=8;
		  NumFigCos++;	    
		  ////////////////////////////////////////////////Pintem el tub cilindric////////////////////////////////////////////////////////////////
		  //Pintem primer el cilindre extern del tub//
		  //Superficie 1//
		  if(cilindres[j].Alfa==0 && cilindres[j].Beta==0 && cilindres[j].Gamma==0)
		    {
		      xRotat=cilindres[j].Centre[0];
		      yRotat=cilindres[j].Centre[1];
		      zRotat=cilindres[j].Centre[2];
		    }else
		    {
		      xRotat=cilindres[j].Centre[0];
		      yRotat=cilindres[j].Centre[1];
		      zRotat=cilindres[j].Centre[2];
		    }
		  fprintf(arxiu,"0000000000000000000000000000000000000000000000000000000000000000\n");
		  fprintf(arxiu,"SURFACE (%s%i) Superficie del cilindre extern\n",NumSuperficie>=10 ? (NumSuperficie>=100 ? " ":"  "):"   ",NumSuperficie);		
		  NumSuperficie++;
		  fprintf(arxiu,"INDICES=( 1, 1, 0, 0,-1)\n");
		  fprintf(arxiu,"X-SCALE=(%s%.15E,   0)\n",fabs(cilindres[j].Dimensions[1])>=0 ? "+":"",cilindres[j].Dimensions[1]);
		  fprintf(arxiu,"Y-SCALE=(%s%.15E,   0)\n",fabs(cilindres[j].Dimensions[1])>=0 ? "+":"",cilindres[j].Dimensions[1]);	
		  fprintf(arxiu,"X-SHIFT=(%s%.15E,   0)\n",xRotat>=0 ? "+":"",xRotat);
		  fprintf(arxiu,"Y-SHIFT=(%s%.15E,   0)\n",yRotat>=0 ? "+":"",yRotat);
		  fprintf(arxiu,"Z-SHIFT=(%s%.15E,   0)\n",zRotat>=0 ? "+":"",zRotat);
		  fprintf(arxiu,"  OMEGA=(%s%.15E,   0) RAD\n",omega>=0 ? "+":"",omega);
		  fprintf(arxiu,"  THETA=(%s%.15E,   0) RAD\n",theta>=0 ? "+":"",theta);
		  fprintf(arxiu,"    PHI=(%s%.15E,   0) RAD\n",phi>=0 ? "+":"",phi);
		  //Pintem ara el cilindre interior//
		  //Superficie 2//
		  if(cilindres[j].Alfa==0 && cilindres[j].Beta==0 && cilindres[j].Gamma==0)
		    {
		      xRotat=cilindres[j].Centre[0];
		      yRotat=cilindres[j].Centre[1];
		      zRotat=cilindres[j].Centre[2];
		    }else
		    {
		      xRotat=cilindres[j].Centre[0];
		      yRotat=cilindres[j].Centre[1];
		      zRotat=cilindres[j].Centre[2];
		    }
		  fprintf(arxiu,"0000000000000000000000000000000000000000000000000000000000000000\n");
		  fprintf(arxiu,"SURFACE (%s%i) Superficie del cilindre intern\n",NumSuperficie>=10 ? (NumSuperficie>=100 ? " ":"  "):"   ",NumSuperficie);		
		  NumSuperficie++;
		  fprintf(arxiu,"INDICES=( 1, 1, 0, 0,-1)\n");
		  fprintf(arxiu,"X-SCALE=(%s%.15E,   0)\n",fabs(cilindres[j].Dimensions[2])>=0 ? "+":"",cilindres[j].Dimensions[2]);
		  fprintf(arxiu,"Y-SCALE=(%s%.15E,   0)\n",fabs(cilindres[j].Dimensions[2])>=0 ? "+":"",cilindres[j].Dimensions[2]);	
		  fprintf(arxiu,"X-SHIFT=(%s%.15E,   0)\n",xRotat>=0 ? "+":"",xRotat);
		  fprintf(arxiu,"Y-SHIFT=(%s%.15E,   0)\n",yRotat>=0 ? "+":"",yRotat);
		  fprintf(arxiu,"Z-SHIFT=(%s%.15E,   0)\n",zRotat>=0 ? "+":"",zRotat);
		  fprintf(arxiu,"  OMEGA=(%s%.15E,   0) RAD\n",omega>=0 ? "+":"",omega);
		  fprintf(arxiu,"  THETA=(%s%.15E,   0) RAD\n",theta>=0 ? "+":"",theta);
		  fprintf(arxiu,"    PHI=(%s%.15E,   0) RAD\n",phi>=0 ? "+":"",phi);
		  
		  ////////////////////////////Pintem ara els plans que delimiten el cilindre/////////////////////////////////////////
		  //Superficie 3//
		  if(cilindres[j].Alfa==0 && cilindres[j].Beta==0 && cilindres[j].Gamma==0)
		    {
		      xRotat=cilindres[j].Centre[0];
		      yRotat=cilindres[j].Centre[1];
		      zRotat=cilindres[j].Centre[2]-cilindres[j].Dimensions[0]/2.0;
		    }else
		    {
		      xRotat=-cilindres[j].Dimensions[0]/2.0*cos(phi)*sin(theta)+cilindres[j].Centre[0];
		      yRotat=-cilindres[j].Dimensions[0]/2.0*sin(theta)*sin(phi)+cilindres[j].Centre[1];
		      zRotat=-cilindres[j].Dimensions[0]/2.0*cos(theta)+cilindres[j].Centre[2];
		    }
		  fprintf(arxiu,"0000000000000000000000000000000000000000000000000000000000000000\n");
		  fprintf(arxiu,"SURFACE (%s%i) Pla inferior del tub\n",NumSuperficie>=10 ? (NumSuperficie>=100 ? " ":"  "):"   ",NumSuperficie);		//Pla inferior	(-Z)
		  NumSuperficie++;
		  fprintf(arxiu,"INDICES=( 0, 0, 0, 1, 0)\n");
		  fprintf(arxiu,"X-SHIFT=(%s%.15E,   0)\n",xRotat>=0 ? "+":"",xRotat);
		  fprintf(arxiu,"Y-SHIFT=(%s%.15E,   0)\n",yRotat>=0 ? "+":"",yRotat);
		  fprintf(arxiu,"Z-SHIFT=(%s%.15E,   0)\n",zRotat>=0 ? "+":"",zRotat);
		  fprintf(arxiu,"  OMEGA=(%s%.15E,   0) RAD\n",omega>=0 ? "+":"",omega);
		  fprintf(arxiu,"  THETA=(%s%.15E,   0) RAD\n",theta>=0 ? "+":"",theta);
		  fprintf(arxiu,"    PHI=(%s%.15E,   0) RAD\n",phi>=0 ? "+":"",phi);
		  //Superficie 4//
		  if(cilindres[j].Alfa==0 && cilindres[j].Beta==0 && cilindres[j].Gamma==0)
		    {
		      xRotat=cilindres[j].Centre[0];
		      yRotat=cilindres[j].Centre[1];
		      zRotat=cilindres[j].Centre[2]+cilindres[j].Dimensions[0]/2.0;
		    }else
		    {
		      xRotat=cilindres[j].Dimensions[0]/2.0*cos(phi)*sin(theta)+cilindres[j].Centre[0];
		      yRotat=cilindres[j].Dimensions[0]/2.0*sin(theta)*sin(phi)+cilindres[j].Centre[1];
		      zRotat=cilindres[j].Dimensions[0]/2.0*cos(theta)+cilindres[j].Centre[2];
		    }
		  fprintf(arxiu,"0000000000000000000000000000000000000000000000000000000000000000\n");
		  fprintf(arxiu,"SURFACE (%s%i) Pla superior del tub\n",NumSuperficie>=10 ? (NumSuperficie>=100 ? " ":"  "):"   ",NumSuperficie);		//Pla superior	(+Z)
		  NumSuperficie++;	
		  fprintf(arxiu,"INDICES=( 0, 0, 0, 1, 0)\n");
		  fprintf(arxiu,"X-SHIFT=(%s%.15E,   0)\n",xRotat>=0 ? "+":"",xRotat);
		  fprintf(arxiu,"Y-SHIFT=(%s%.15E,   0)\n",yRotat>=0 ? "+":"",yRotat);
		  fprintf(arxiu,"Z-SHIFT=(%s%.15E,   0)\n",zRotat>=0 ? "+":"",zRotat);
		  fprintf(arxiu,"  OMEGA=(%s%.15E,   0) RAD\n",omega>=0 ? "+":"",omega);
		  fprintf(arxiu,"  THETA=(%s%.15E,   0) RAD\n",theta>=0 ? "+":"",theta);
		  fprintf(arxiu,"    PHI=(%s%.15E,   0) RAD\n",phi>=0 ? "+":"",phi);	      
	    }
	  else
	    {
	      //Si no es un tub, mirem si es un con o un cilindre i si el con es invertit o no
	      if(cilindres[j].Dimensions[1]==cilindres[j].Dimensions[2])
		{
		  //El tipus de figura al cas del cilindre pot ser de 3 formes distintes//
		  FiguresDelCos[NumFigCos][0]=3;
		  NumFigCos++;	    
		  ////////////////////////////////////////////////Pintem el cilindre////////////////////////////////////////////////////////////////
		  //Superficie 1//
		  if(cilindres[j].Alfa==0 && cilindres[j].Beta==0 && cilindres[j].Gamma==0)
		    {
		      xRotat=cilindres[j].Centre[0];
		      yRotat=cilindres[j].Centre[1];
		      zRotat=cilindres[j].Centre[2];
		    }else
		    {
		      xRotat=cilindres[j].Centre[0];
		      yRotat=cilindres[j].Centre[1];
		      zRotat=cilindres[j].Centre[2];
		    }
		  fprintf(arxiu,"0000000000000000000000000000000000000000000000000000000000000000\n");
		  fprintf(arxiu,"SURFACE (%s%i) Superficie del cilindre\n",NumSuperficie>=10 ? (NumSuperficie>=100 ? " ":"  "):"   ",NumSuperficie);		
		  NumSuperficie++;
		  fprintf(arxiu,"INDICES=( 1, 1, 0, 0,-1)\n");
		  fprintf(arxiu,"X-SCALE=(%s%.15E,   0)\n",fabs(cilindres[j].Dimensions[1])>=0 ? "+":"",cilindres[j].Dimensions[1]);
		  fprintf(arxiu,"Y-SCALE=(%s%.15E,   0)\n",fabs(cilindres[j].Dimensions[2])>=0 ? "+":"",cilindres[j].Dimensions[2]);	
		  fprintf(arxiu,"X-SHIFT=(%s%.15E,   0)\n",xRotat>=0 ? "+":"",xRotat);
		  fprintf(arxiu,"Y-SHIFT=(%s%.15E,   0)\n",yRotat>=0 ? "+":"",yRotat);
		  fprintf(arxiu,"Z-SHIFT=(%s%.15E,   0)\n",zRotat>=0 ? "+":"",zRotat);
		  fprintf(arxiu,"  OMEGA=(%s%.15E,   0) RAD\n",omega>=0 ? "+":"",omega);
		  fprintf(arxiu,"  THETA=(%s%.15E,   0) RAD\n",theta>=0 ? "+":"",theta);
		  fprintf(arxiu,"    PHI=(%s%.15E,   0) RAD\n",phi>=0 ? "+":"",phi);
		  ////////////////////////////Pintem ara els plans que delimiten el cilindre/////////////////////////////////////////
		  //Superficie 2//
		  if(cilindres[j].Alfa==0 && cilindres[j].Beta==0 && cilindres[j].Gamma==0)
		    {
		      xRotat=cilindres[j].Centre[0];
		      yRotat=cilindres[j].Centre[1];
		      zRotat=cilindres[j].Centre[2]-cilindres[j].Dimensions[0]/2.0;
		    }else
		    {
		      xRotat=-cilindres[j].Dimensions[0]/2.0*cos(phi)*sin(theta)+cilindres[j].Centre[0];
		      yRotat=-cilindres[j].Dimensions[0]/2.0*sin(theta)*sin(phi)+cilindres[j].Centre[1];
		      zRotat=-cilindres[j].Dimensions[0]/2.0*cos(theta)+cilindres[j].Centre[2];
		    }
		  fprintf(arxiu,"0000000000000000000000000000000000000000000000000000000000000000\n");
		  fprintf(arxiu,"SURFACE (%s%i) Pla inferior del cilindre\n",NumSuperficie>=10 ? (NumSuperficie>=100 ? " ":"  "):"   ",NumSuperficie);		//Pla inferior	(-Z)
		  NumSuperficie++;
		  fprintf(arxiu,"INDICES=( 0, 0, 0, 1, 0)\n");
		  fprintf(arxiu,"X-SHIFT=(%s%.15E,   0)\n",xRotat>=0 ? "+":"",xRotat);
		  fprintf(arxiu,"Y-SHIFT=(%s%.15E,   0)\n",yRotat>=0 ? "+":"",yRotat);
		  fprintf(arxiu,"Z-SHIFT=(%s%.15E,   0)\n",zRotat>=0 ? "+":"",zRotat);
		  fprintf(arxiu,"  OMEGA=(%s%.15E,   0) RAD\n",omega>=0 ? "+":"",omega);
		  fprintf(arxiu,"  THETA=(%s%.15E,   0) RAD\n",theta>=0 ? "+":"",theta);
		  fprintf(arxiu,"    PHI=(%s%.15E,   0) RAD\n",phi>=0 ? "+":"",phi);
		  //Superficie 3//
		  if(cilindres[j].Alfa==0 && cilindres[j].Beta==0 && cilindres[j].Gamma==0)
		    {
		      xRotat=cilindres[j].Centre[0];
		      yRotat=cilindres[j].Centre[1];
		      zRotat=cilindres[j].Centre[2]+cilindres[j].Dimensions[0]/2.0;
		    }else
		    {
		      xRotat=cilindres[j].Dimensions[0]/2.0*cos(phi)*sin(theta)+cilindres[j].Centre[0];
		      yRotat=cilindres[j].Dimensions[0]/2.0*sin(theta)*sin(phi)+cilindres[j].Centre[1];
		      zRotat=cilindres[j].Dimensions[0]/2.0*cos(theta)+cilindres[j].Centre[2];
		    }
		  fprintf(arxiu,"0000000000000000000000000000000000000000000000000000000000000000\n");
		  fprintf(arxiu,"SURFACE (%s%i) Pla superior de cilindre\n",NumSuperficie>=10 ? (NumSuperficie>=100 ? " ":"  "):"   ",NumSuperficie);		//Pla superior	(+Z)
		  NumSuperficie++;	
		  fprintf(arxiu,"INDICES=( 0, 0, 0, 1, 0)\n");
		  fprintf(arxiu,"X-SHIFT=(%s%.15E,   0)\n",xRotat>=0 ? "+":"",xRotat);
		  fprintf(arxiu,"Y-SHIFT=(%s%.15E,   0)\n",yRotat>=0 ? "+":"",yRotat);
		  fprintf(arxiu,"Z-SHIFT=(%s%.15E,   0)\n",zRotat>=0 ? "+":"",zRotat);
		  fprintf(arxiu,"  OMEGA=(%s%.15E,   0) RAD\n",omega>=0 ? "+":"",omega);
		  fprintf(arxiu,"  THETA=(%s%.15E,   0) RAD\n",theta>=0 ? "+":"",theta);
		  fprintf(arxiu,"    PHI=(%s%.15E,   0) RAD\n",phi>=0 ? "+":"",phi);
	    	    
		}
	      else if(cilindres[j].Dimensions[1]>cilindres[j].Dimensions[2])
		{
		  ////////////////////////////////////////////////////////////////////////////////
		  ///////////////////////////////CON//////////////////////////////////////////////
		  ////////////////////////////////////////////////////////////////////////////////
		  //El tipus de figura al cas del cilindre pot ser de 3 formes distintes//
		  FiguresDelCos[NumFigCos][0]=4;
		  NumFigCos++;	    
		  ////////////////////////////////////////////////////////////////////////
		  double z=cilindres[j].Dimensions[2]*cilindres[j].Dimensions[0]/(cilindres[j].Dimensions[1]-cilindres[j].Dimensions[2]);	//Calcula la distància entre l'origen del con i el pla mes proper a aquest

		  //Superficie 1//
		  if(cilindres[j].Alfa==0 && cilindres[j].Beta==0 && cilindres[j].Gamma==0)
		    {
		      xRotat=cilindres[j].Centre[0];
		      yRotat=cilindres[j].Centre[1];
		      zRotat=cilindres[j].Centre[2]-cilindres[j].Dimensions[0]*0.5-z;
		    }else
		    {
		      xRotat=(-cilindres[j].Dimensions[0]/2.0-z)*cos(phi)*sin(theta)+cilindres[j].Centre[0];
		      yRotat=(-cilindres[j].Dimensions[0]/2.0-z)*sin(theta)*sin(phi)+cilindres[j].Centre[1];
		      zRotat=(-cilindres[j].Dimensions[0]/2.0-z)*cos(theta)+cilindres[j].Centre[2];
		    }	    
		  fprintf(arxiu,"0000000000000000000000000000000000000000000000000000000000000000\n");
		  fprintf(arxiu,"SURFACE (%s%i) Superficie del con\n",NumSuperficie>=10 ? (NumSuperficie>=100 ? " ":"  "):"   ",NumSuperficie);		//Con
		  NumSuperficie++;
		  fprintf(arxiu,"INDICES=( 1, 1,-1, 0, 0)\n");
		  fprintf(arxiu,"X-SCALE=(%s%.15E,   0)\n",fabs(cilindres[j].Dimensions[1])>=0 ? "+":"",cilindres[j].Dimensions[1]);
		  fprintf(arxiu,"Y-SCALE=(%s%.15E,   0)\n",fabs(cilindres[j].Dimensions[1])>=0 ? "+":"",cilindres[j].Dimensions[1]);	
		  fprintf(arxiu,"Z-SCALE=(%s%.15E,   0)\n",fabs(cilindres[j].Dimensions[0]+z)>=0 ? "+":"",cilindres[j].Dimensions[0]+z);
		  fprintf(arxiu,"X-SHIFT=(%s%.15E,   0)\n",xRotat>=0 ? "+":"",xRotat);
		  fprintf(arxiu,"Y-SHIFT=(%s%.15E,   0)\n",yRotat>=0 ? "+":"",yRotat);
		  fprintf(arxiu,"Z-SHIFT=(%s%.15E,   0)\n",zRotat>=0 ? "+":"",zRotat);
		  fprintf(arxiu,"  OMEGA=(%s%.15E,   0) RAD\n",omega>=0 ? "+":"",omega);
		  fprintf(arxiu,"  THETA=(%s%.15E,   0) RAD\n",theta>=0 ? "+":"",theta);
		  fprintf(arxiu,"    PHI=(%s%.15E,   0) RAD\n",phi>=0 ? "+":"",phi);
		  ////////////////////////////Pintem ara els plans que delimiten el con/////////////////////////////////////////
		  //Superficie 2//
		  if(cilindres[j].Alfa==0 && cilindres[j].Beta==0 && cilindres[j].Gamma==0)
		    {
		      xRotat=cilindres[j].Centre[0];
		      yRotat=cilindres[j].Centre[1];
		      zRotat=cilindres[j].Centre[2]-cilindres[j].Dimensions[0]/2.0;
		    }else
		    {
		      xRotat=-cilindres[j].Dimensions[0]/2.0*cos(phi)*sin(theta)+cilindres[j].Centre[0];
		      yRotat=-cilindres[j].Dimensions[0]/2.0*sin(theta)*sin(phi)+cilindres[j].Centre[1];
		      zRotat=-cilindres[j].Dimensions[0]/2.0*cos(theta)+cilindres[j].Centre[2];
		    }
		  fprintf(arxiu,"0000000000000000000000000000000000000000000000000000000000000000\n");
		  fprintf(arxiu,"SURFACE (%s%i) Pla inferior del con\n",NumSuperficie>=10 ? (NumSuperficie>=100 ? " ":"  "):"   ",NumSuperficie);		//Pla inferior del con
		  NumSuperficie++;
		  fprintf(arxiu,"INDICES=( 0, 0, 0, 1, 0)\n");
		  fprintf(arxiu,"X-SHIFT=(%s%.15E,   0)\n",xRotat>=0 ? "+":"",xRotat);
		  fprintf(arxiu,"Y-SHIFT=(%s%.15E,   0)\n",yRotat>=0 ? "+":"",yRotat);
		  fprintf(arxiu,"Z-SHIFT=(%s%.15E,   0)\n",zRotat>=0 ? "+":"",zRotat);
		  fprintf(arxiu,"  OMEGA=(%s%.15E,   0) RAD\n",omega>=0 ? "+":"",omega);
		  fprintf(arxiu,"  THETA=(%s%.15E,   0) RAD\n",theta>=0 ? "+":"",theta);
		  fprintf(arxiu,"    PHI=(%s%.15E,   0) RAD\n",phi>=0 ? "+":"",phi);
		  //Superficie 3//
		  if(cilindres[j].Alfa==0 && cilindres[j].Beta==0 && cilindres[j].Gamma==0)
		    {
		      xRotat=cilindres[j].Centre[0];
		      yRotat=cilindres[j].Centre[1];
		      zRotat=cilindres[j].Centre[2]+cilindres[j].Dimensions[0]/2.0;
		    }else
		    {
		      xRotat=cilindres[j].Dimensions[0]/2.0*cos(phi)*sin(theta)+cilindres[j].Centre[0];
		      yRotat=cilindres[j].Dimensions[0]/2.0*sin(theta)*sin(phi)+cilindres[j].Centre[1];
		      zRotat=cilindres[j].Dimensions[0]/2.0*cos(theta)+cilindres[j].Centre[2];
		    }
		  fprintf(arxiu,"0000000000000000000000000000000000000000000000000000000000000000\n");
		  fprintf(arxiu,"SURFACE (%s%i) Pla superior del con\n",NumSuperficie>=10 ? (NumSuperficie>=100 ? " ":"  "):"   ",NumSuperficie);		//Pla que limita el con per dalt
		  NumSuperficie++;	
		  fprintf(arxiu,"INDICES=( 0, 0, 0, 1, 0)\n");
		  fprintf(arxiu,"X-SHIFT=(%s%.15E,   0)\n",xRotat>=0 ? "+":"",xRotat);
		  fprintf(arxiu,"Y-SHIFT=(%s%.15E,   0)\n",yRotat>=0 ? "+":"",yRotat);
		  fprintf(arxiu,"Z-SHIFT=(%s%.15E,   0)\n",zRotat>=0 ? "+":"",zRotat);
		  fprintf(arxiu,"  OMEGA=(%s%.15E,   0) RAD\n",omega>=0 ? "+":"",omega);
		  fprintf(arxiu,"  THETA=(%s%.15E,   0) RAD\n",theta>=0 ? "+":"",theta);
		  fprintf(arxiu,"    PHI=(%s%.15E,   0) RAD\n",phi>=0 ? "+":"",phi);	    
	    
		}
	      else if(cilindres[j].Dimensions[1]<cilindres[j].Dimensions[2])
		{
		  /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		  ///////////////////////////////////////////////////CON 2/////////////////////////////////////////////////////////////////////////
		  /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

		  //El tipus de figura al cas del cilindre pot ser de 3 formes distintes//
		  FiguresDelCos[NumFigCos][0]=5;
		  NumFigCos++;	    
		  ////////////////////////////////////////////////////////////////////////

		  double z=cilindres[j].Dimensions[1]*cilindres[j].Dimensions[0]/(cilindres[j].Dimensions[2]-cilindres[j].Dimensions[1]);	//Calcula la distància entre l'origen del con i el pla mes proper a aquest

		  //Superficie 1//
		  if(cilindres[j].Alfa==0 && cilindres[j].Beta==0 && cilindres[j].Gamma==0)
		    {
		      xRotat=cilindres[j].Centre[0];
		      yRotat=cilindres[j].Centre[1];
		      zRotat=cilindres[j].Centre[2]+cilindres[j].Dimensions[0]*0.5+z;
		    }else
		    {
		      xRotat=(cilindres[j].Dimensions[0]/2.0+z)*cos(phi)*sin(theta)+cilindres[j].Centre[0];
		      yRotat=(cilindres[j].Dimensions[0]/2.0+z)*sin(theta)*sin(phi)+cilindres[j].Centre[1];
		      zRotat=(cilindres[j].Dimensions[0]/2.0+z)*cos(theta)+cilindres[j].Centre[2];
		    }	    	    
		  fprintf(arxiu,"0000000000000000000000000000000000000000000000000000000000000000\n");
		  fprintf(arxiu,"SURFACE (%s%i) Superficie del con\n",NumSuperficie>=10 ? (NumSuperficie>=100 ? " ":"  "):"   ",NumSuperficie);		//Con
		  NumSuperficie++;
		  fprintf(arxiu,"INDICES=( 1, 1,-1, 0, 0)\n");
		  fprintf(arxiu,"X-SCALE=(%s%.15E,   0)\n",fabs(cilindres[j].Dimensions[2])>=0 ? "+":"",cilindres[j].Dimensions[2]);
		  fprintf(arxiu,"Y-SCALE=(%s%.15E,   0)\n",fabs(cilindres[j].Dimensions[2])>=0 ? "+":"",cilindres[j].Dimensions[2]);	
		  fprintf(arxiu,"Z-SCALE=(%s%.15E,   0)\n",fabs(cilindres[j].Dimensions[0]+z)>=0 ? "+":"",cilindres[j].Dimensions[0]+z);
		  fprintf(arxiu,"X-SHIFT=(%s%.15E,   0)\n",xRotat>=0 ? "+":"",xRotat);
		  fprintf(arxiu,"Y-SHIFT=(%s%.15E,   0)\n",yRotat>=0 ? "+":"",yRotat);
		  fprintf(arxiu,"Z-SHIFT=(%s%.15E,   0)\n",zRotat>=0 ? "+":"",zRotat);
		  fprintf(arxiu,"  OMEGA=(%s%.15E,   0) RAD\n",omega>=0 ? "+":"",omega);
		  fprintf(arxiu,"  THETA=(%s%.15E,   0) RAD\n",theta>=0 ? "+":"",theta);
		  fprintf(arxiu,"    PHI=(%s%.15E,   0) RAD\n",phi>=0 ? "+":"",phi);
		  ////////////////////////////Pintem ara els plans que delimiten el con/////////////////////////////////////////
		  //Superficie 2//
		  if(cilindres[j].Alfa==0 && cilindres[j].Beta==0 && cilindres[j].Gamma==0)
		    {
		      xRotat=cilindres[j].Centre[0];
		      yRotat=cilindres[j].Centre[1];
		      zRotat=cilindres[j].Centre[2]+cilindres[j].Dimensions[0]/2.0;
		    }else
		    {
		      xRotat=cilindres[j].Dimensions[0]/2.0*cos(phi)*sin(theta)+cilindres[j].Centre[0];
		      yRotat=cilindres[j].Dimensions[0]/2.0*sin(theta)*sin(phi)+cilindres[j].Centre[1];
		      zRotat=cilindres[j].Dimensions[0]/2.0*cos(theta)+cilindres[j].Centre[2];
		    }
		  fprintf(arxiu,"0000000000000000000000000000000000000000000000000000000000000000\n");
		  fprintf(arxiu,"SURFACE (%s%i) Pla superior del con\n",NumSuperficie>=10 ? (NumSuperficie>=100 ? " ":"  "):"   ",NumSuperficie);		//Pla que limita el con per dalt
		  NumSuperficie++;
		  fprintf(arxiu,"INDICES=( 0, 0, 0, 1, 0)\n");
		  fprintf(arxiu,"X-SHIFT=(%s%.15E,   0)\n",xRotat>=0 ? "+":"",xRotat);
		  fprintf(arxiu,"Y-SHIFT=(%s%.15E,   0)\n",yRotat>=0 ? "+":"",yRotat);
		  fprintf(arxiu,"Z-SHIFT=(%s%.15E,   0)\n",zRotat>=0 ? "+":"",zRotat);
		  fprintf(arxiu,"  OMEGA=(%s%.15E,   0) RAD\n",omega>=0 ? "+":"",omega);
		  fprintf(arxiu,"  THETA=(%s%.15E,   0) RAD\n",theta>=0 ? "+":"",theta);
		  fprintf(arxiu,"    PHI=(%s%.15E,   0) RAD\n",phi>=0 ? "+":"",phi);
		  //Superficie 3//
		  if(cilindres[j].Alfa==0 && cilindres[j].Beta==0 && cilindres[j].Gamma==0)
		    {
		      xRotat=cilindres[j].Centre[0];
		      yRotat=cilindres[j].Centre[1];
		      zRotat=cilindres[j].Centre[2]-cilindres[j].Dimensions[0]/2.0;
		    }else
		    {
		      xRotat=-cilindres[j].Dimensions[0]/2.0*cos(phi)*sin(theta)+cilindres[j].Centre[0];
		      yRotat=-cilindres[j].Dimensions[0]/2.0*sin(theta)*sin(phi)+cilindres[j].Centre[1];
		      zRotat=-cilindres[j].Dimensions[0]/2.0*cos(theta)+cilindres[j].Centre[2];
		    }
		  fprintf(arxiu,"0000000000000000000000000000000000000000000000000000000000000000\n");
		  fprintf(arxiu,"SURFACE (%s%i) Pla inferior del con\n",NumSuperficie>=10 ? (NumSuperficie>=100 ? " ":"  "):"   ",NumSuperficie);		//Pla inferior	que limita el con per baix
		  NumSuperficie++;	
		  fprintf(arxiu,"INDICES=( 0, 0, 0, 1, 0)\n");
		  fprintf(arxiu,"X-SHIFT=(%s%.15E,   0)\n",xRotat>=0 ? "+":"",xRotat);
		  fprintf(arxiu,"Y-SHIFT=(%s%.15E,   0)\n",yRotat>=0 ? "+":"",yRotat);
		  fprintf(arxiu,"Z-SHIFT=(%s%.15E,   0)\n",zRotat>=0 ? "+":"",zRotat);
		  fprintf(arxiu,"  OMEGA=(%s%.15E,   0) RAD\n",omega>=0 ? "+":"",omega);
		  fprintf(arxiu,"  THETA=(%s%.15E,   0) RAD\n",theta>=0 ? "+":"",theta);
		  fprintf(arxiu,"    PHI=(%s%.15E,   0) RAD\n",phi>=0 ? "+":"",phi);
	
		}
	    }
	}
	j++;
      }
      j=1;
      while(j<=NumPla)
      {
	if(plans[j].Prioritat==i)
	{
	  //Primer guardem que aquesta figura formara part del cos, el tipus de figura, el material i les prioritats que tindra dins.
	  FiguresDelCos[NumFigCos][0]=6;
	  FiguresDelCos[NumFigCos][1]=plans[j].Material;
	  NumFigCos++;
	  int k=0;
	  while(k<100)
	  {
	    bool Trobat=false;			//Controlarà si ja esta la prioritat a la llista
	    if(plans[j].PDins[k]==0)
	    {
	      break;
	    }
	    //Comprovem que aquesta prioritat no estiga ja incluida//
	    int m=0;
	    while(m<NumCosDins[NumCosos])
	    {
	      if(CosDins[NumCosos][m]==plans[j].PDins[k])
	      {
		Trobat=true;
		break;
	      }
	      m++;
	    }
	    if(Trobat==false)
	    {
	      CosDins[NumCosos][NumCosDins[NumCosos]]=plans[j].PDins[k];
	      NumCosDins[NumCosos]++;
	    }
	    Trobat=false;
	    k++;
	   }
	   ////////////////////////////////////////////////////////////////////////////////////////////////////	  
	  CososPrioritat[NumCosos]=plans[j].Prioritat;
	  ////////////////////////////Pintem el pla/////////////////////////////////////////
	  fprintf(arxiu,"0000000000000000000000000000000000000000000000000000000000000000\n");
	  fprintf(arxiu,"SURFACE (%s%i) Pla infinit\n",NumSuperficie>=10 ? (NumSuperficie>=100 ? " ":"  "):"   ",NumSuperficie);	
	  NumSuperficie++;
	  fprintf(arxiu,"INDICES=( 0, 0, 0, 1, 0)\n");	
	  fprintf(arxiu,"X-SHIFT=(%s%.15E,   0)\n",(plans[j].Centre[0])>=0 ? "+":"",plans[j].Centre[0]);
	  fprintf(arxiu,"Y-SHIFT=(%s%.15E,   0)\n",(plans[j].Centre[1])>=0 ? "+":"",plans[j].Centre[1]);	  
	  fprintf(arxiu,"Z-SHIFT=(%s%.15E,   0)\n",(plans[j].Centre[2])>=0 ? "+":"",plans[j].Centre[2]);
	  fprintf(arxiu,"  OMEGA=(%s%.15E,   0) DEG\n",(plans[j].Alfa)>=0 ? "+":"",plans[j].Alfa);
	  fprintf(arxiu,"  THETA=(%s%.15E,   0) DEG\n",(plans[j].Beta)>=0 ? "+":"",plans[j].Beta);
	  fprintf(arxiu,"    PHI=(%s%.15E,   0) DEG\n",(plans[j].Gamma)>=0 ? "+":"",plans[j].Gamma);

	  
	}
	j++;
      }
      j=1;
      while(j<=NumSecEsf)
      {
	if(secEsf[j].Prioritat==i)
	{
	  //Primer guardem que aquesta figura formara part del cos, el tipus de figura, el material i les prioritats que tindra dins.
	  FiguresDelCos[NumFigCos][0]=7;
	  FiguresDelCos[NumFigCos][1]=secEsf[j].Material;
	  NumFigCos++;
	  int k=0;
	  while(k<100)
	  {
	    bool Trobat=false;			//Controlarà si ja esta la prioritat a la llista
	    if(secEsf[j].PDins[k]==0)
	    {
	      break;
	    }
	    //Comprovem que aquesta prioritat no estiga ja incluida//
	    int m=0;
	    while(m<NumCosDins[NumCosos])
	    {
	      if(CosDins[NumCosos][m]==secEsf[j].PDins[k])
	      {
		Trobat=true;
		break;
	      }
	      m++;
	    }
	    if(Trobat==false)
	    {
	      CosDins[NumCosos][NumCosDins[NumCosos]]=secEsf[j].PDins[k];
	      NumCosDins[NumCosos]++;
	    }
	    Trobat=false;
	    k++;
	   }
	   ////////////////////////////////////////////////////////////////////////////////////////////////////	  
	  CososPrioritat[NumCosos]=secEsf[j].Prioritat;
  	  omega=secEsf[j].Alfa*PI/180.0;
	  theta=secEsf[j].Beta*PI/180.0;
	  phi=secEsf[j].Gamma*PI/180.0;
	  ////////////////////////Pintem la superfície de l'esfera/////////////////////////////////////
	  fprintf(arxiu,"0000000000000000000000000000000000000000000000000000000000000000\n");
	  fprintf(arxiu,"SURFACE (%s%i) Superficie de l'esfera\n",NumSuperficie>=10 ? (NumSuperficie>=100 ? " ":"  "):"   ",NumSuperficie);		
	  NumSuperficie++;
	  fprintf(arxiu,"INDICES=( 1, 1, 1, 0,-1)\n");
	  fprintf(arxiu,"X-SCALE=(%s%.15E,   0)\n",secEsf[j].Dimensions[0]>=0 ? "+":"",secEsf[j].Dimensions[0]);
	  fprintf(arxiu,"Y-SCALE=(%s%.15E,   0)\n",secEsf[j].Dimensions[0]>=0 ? "+":"",secEsf[j].Dimensions[0]);
	  fprintf(arxiu,"Z-SCALE=(%s%.15E,   0)\n",secEsf[j].Dimensions[0]>=0 ? "+":"",secEsf[j].Dimensions[0]);	
	  fprintf(arxiu,"X-SHIFT=(%s%.15E,   0)\n",secEsf[j].Centre[0]>=0 ? "+":"",secEsf[j].Centre[0]);
	  fprintf(arxiu,"Y-SHIFT=(%s%.15E,   0)\n",secEsf[j].Centre[1]>=0 ? "+":"",secEsf[j].Centre[1]);
	  fprintf(arxiu,"Z-SHIFT=(%s%.15E,   0)\n",secEsf[j].Centre[2]>=0 ? "+":"",secEsf[j].Centre[2]);
	  ////////////////////////////Pintem ara els plans que delimiten la secció d'esfera/////////////////////////////////////////
	  //Superficie 2//
	    if(secEsf[j].Alfa==0 && secEsf[j].Beta==0 && secEsf[j].Gamma==0)
	    {
	      xRotat=secEsf[j].Centre[0];
	      yRotat=secEsf[j].Centre[1];
	      zRotat=secEsf[j].Centre[2]+secEsf[j].Dimensions[1];
	    }else
	    {
	      xRotat=secEsf[j].Dimensions[1]*cos(phi)*sin(theta)+secEsf[j].Centre[0];
	      yRotat=secEsf[j].Dimensions[1]*sin(theta)*sin(phi)+secEsf[j].Centre[1];
	      zRotat=secEsf[j].Dimensions[1]*cos(theta)+secEsf[j].Centre[2];
	    }
	  fprintf(arxiu,"0000000000000000000000000000000000000000000000000000000000000000\n");
	  fprintf(arxiu,"SURFACE (%s%i) Pla de tall\n",NumSuperficie>=10 ? (NumSuperficie>=100 ? " ":"  "):"   ",NumSuperficie);		//Pla que talla l'esfera
	  NumSuperficie++;
	  fprintf(arxiu,"INDICES=( 0, 0, 0, 1, 0)\n");
	  fprintf(arxiu,"X-SHIFT=(%s%.15E,   0)\n",xRotat>=0 ? "+":"",xRotat);
	  fprintf(arxiu,"Y-SHIFT=(%s%.15E,   0)\n",yRotat>=0 ? "+":"",yRotat);
	  fprintf(arxiu,"Z-SHIFT=(%s%.15E,   0)\n",zRotat>=0 ? "+":"",zRotat);
	  fprintf(arxiu,"  OMEGA=(%s%.15E,   0) RAD\n",omega>=0 ? "+":"",omega);
	  fprintf(arxiu,"  THETA=(%s%.15E,   0) RAD\n",theta>=0 ? "+":"",theta);
	  fprintf(arxiu,"    PHI=(%s%.15E,   0) RAD\n",phi>=0 ? "+":"",phi);

	}
	j++;
      }      
      //Si no hi ha cap figura amb aquesta prioritat passarem a la següent//
      if(NumFigCos==0)
      {
	i--;
	continue;
      }
	  
	//Ara anem posant les superficies. Per a açò mirarem el tipus de figura que s'ha utilitzat/////////////

	j=0;
	int MaterialAux=0;
	int signe=1;		//Controlara si les superficies apunten en la direccio usual per a formar l'objecte o les invertim
	
	//Agafem el material de la primera figura del cos
	MaterialAux=FiguresDelCos[0][1];

	  fprintf(arxiu,"0000000000000000000000000000000000000000000000000000000000000000\n");
	  fprintf(arxiu,"BODY    (%s%i)\n",NumCosos>=10 ? "  ":"   ",NumCosos);		//Cos
	  fprintf(arxiu,"MATERIAL(%s%i)\n",MaterialAux>=10 ? "  ":"   ",MaterialAux);		//Material

	j=0;
	while(j<NumFigCos)
	{
	  //Segons el tipus de figura crearem un objecte o un altre 
	  if(FiguresDelCos[j][0]==1)
	  {
	    /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    ///////////////////////////////////////////////////Una vegada creades les superficies, creem el cub/////////////////////////////////////////////////////////////////////////
	    /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    fprintf(arxiu,"SURFACE (%s%i), SIDE POINTER=(%s%i)\n",(NumSuperficieInicial)>=10 ? (NumSuperficieInicial>=100 ? " ":"  "):"   ",(NumSuperficieInicial),(1*signe)>0 ? " ":"",1*signe);	
	    fprintf(arxiu,"SURFACE (%s%i), SIDE POINTER=(%s%i)\n",(NumSuperficieInicial+1)>=10 ? (NumSuperficieInicial+1>=100 ? " ":"  "):"   ",(NumSuperficieInicial+1),(-1*signe)>0 ? " ":"",-1*signe);
	    fprintf(arxiu,"SURFACE (%s%i), SIDE POINTER=(%s%i)\n",(NumSuperficieInicial+2)>=10 ? (NumSuperficieInicial+2>=100 ? " ":"  "):"   ",(NumSuperficieInicial+2),(1*signe)>0 ? " ":"",1*signe);
	    fprintf(arxiu,"SURFACE (%s%i), SIDE POINTER=(%s%i)\n",(NumSuperficieInicial+3)>=10 ? (NumSuperficieInicial+3>=100 ? " ":"  "):"   ",(NumSuperficieInicial+3),(-1*signe)>0 ? " ":"",-1*signe);
	    fprintf(arxiu,"SURFACE (%s%i), SIDE POINTER=(%s%i)\n",(NumSuperficieInicial+4)>=10 ? (NumSuperficieInicial+4>=100 ? " ":"  "):"   ",(NumSuperficieInicial+4),(1*signe)>0 ? " ":"",1*signe);
	    fprintf(arxiu,"SURFACE (%s%i), SIDE POINTER=(%s%i)\n",(NumSuperficieInicial+5)>=10 ? (NumSuperficieInicial+5>=100 ? " ":"  "):"   ",(NumSuperficieInicial+5),(-1*signe)>0 ? " ":"",-1*signe);
	    NumSuperficieInicial=NumSuperficieInicial+6;
	  }
	  else if(FiguresDelCos[j][0]==2)
	  {
	    //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////	
	    ////////////////////////////////////Creem el cos de la esfera /////////////////////////////////////////////////////////////////////
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    fprintf(arxiu,"SURFACE (%s%i), SIDE POINTER=(%s%i)\n",(NumSuperficieInicial)>=10 ? (NumSuperficieInicial>=100 ? " ":"  "):"   ",(NumSuperficieInicial),(-1*signe)>0 ? " ":"",-1*signe);
	    NumSuperficieInicial++;
	  }
	  else if(FiguresDelCos[j][0]==3)
	  {
	    /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    ///////////////////////////////////////////////////Una vegada creades les superficies, creem el cilindre/////////////////////////////////////////////////////////////////////////
	    /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    fprintf(arxiu,"SURFACE (%s%i), SIDE POINTER=(%s%i)\n",(NumSuperficieInicial)>=10 ? (NumSuperficieInicial>=100 ? " ":"  "):"   ",(NumSuperficieInicial),(-1*signe)>0 ? " ":"",-1*signe);
	    fprintf(arxiu,"SURFACE (%s%i), SIDE POINTER=(%s%i)\n",(NumSuperficieInicial+1)>=10 ? (NumSuperficieInicial+1>=100 ? " ":"  "):"   ",(NumSuperficieInicial+1),(1*signe)>0 ? " ":"",1*signe);
	    fprintf(arxiu,"SURFACE (%s%i), SIDE POINTER=(%s%i)\n",(NumSuperficieInicial+2)>=10 ? (NumSuperficieInicial+2>=100 ? " ":"  "):"   ",(NumSuperficieInicial+2),(-1*signe)>0 ? " ":"",-1*signe);
	    NumSuperficieInicial=NumSuperficieInicial+3;
	  }
	  else if(FiguresDelCos[j][0]==4)
	  {
	    /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    ///////////////////////////////////////////////////Una vegada creades les superficies, creem el con/////////////////////////////////////////////////////////////////////////
	    /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    fprintf(arxiu,"SURFACE (%s%i), SIDE POINTER=(%s%i)\n",(NumSuperficieInicial)>=10 ? (NumSuperficieInicial>=100 ? " ":"  "):"   ",(NumSuperficieInicial),(-1*signe)>0 ? " ":"",-1*signe);
	    fprintf(arxiu,"SURFACE (%s%i), SIDE POINTER=(%s%i)\n",(NumSuperficieInicial+1)>=10 ? (NumSuperficieInicial+1>=100 ? " ":"  "):"   ",(NumSuperficieInicial+1),(1*signe)>0 ? " ":"",1*signe);
	    fprintf(arxiu,"SURFACE (%s%i), SIDE POINTER=(%s%i)\n",(NumSuperficieInicial+2)>=10 ? (NumSuperficieInicial+2>=100 ? " ":"  "):"   ",(NumSuperficieInicial+2),(-1*signe)>0 ? " ":"",-1*signe);
	    NumSuperficieInicial=NumSuperficieInicial+3;	    
	  }
	  else if(FiguresDelCos[j][0]==5)
	  {
	    /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    ///////////////////////////////////////////////////Una vegada creades les superficies, creem el con/////////////////////////////////////////////////////////////////////////
	    /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    fprintf(arxiu,"SURFACE (%s%i), SIDE POINTER=(%s%i)\n",(NumSuperficieInicial)>=10 ? (NumSuperficieInicial>=100 ? " ":"  "):"   ",(NumSuperficieInicial),(-1*signe)>0 ? " ":"",-1*signe);
	    fprintf(arxiu,"SURFACE (%s%i), SIDE POINTER=(%s%i)\n",(NumSuperficieInicial+1)>=10 ? (NumSuperficieInicial+1>=100 ? " ":"  "):"   ",(NumSuperficieInicial+1),(-1*signe)>0 ? " ":"",-1*signe);
	    fprintf(arxiu,"SURFACE (%s%i), SIDE POINTER=(%s%i)\n",(NumSuperficieInicial+2)>=10 ? (NumSuperficieInicial+2>=100 ? " ":"  "):"   ",(NumSuperficieInicial+2),(1*signe)>0 ? " ":"",1*signe);
	    NumSuperficieInicial=NumSuperficieInicial+3;	    	    
	  }
	  else if(FiguresDelCos[j][0]==6)
	  {
	    //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////	
	    ////////////////////////////////////Creem el cos del pla /////////////////////////////////////////////////////////////////////
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    fprintf(arxiu,"SURFACE (%s%i), SIDE POINTER=(%s%i)\n",(NumSuperficieInicial)>=10 ? (NumSuperficieInicial>=100 ? " ":"  "):"   ",(NumSuperficieInicial),(1*signe)>0 ? " ":"",1*signe);
	    NumSuperficieInicial++;	    	    	    
	  }
	  else if(FiguresDelCos[j][0]==7)
	  {
	    //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////	
	    ////////////////////////////////////Creem el cos de la secció d'esfera /////////////////////////////////////////////////////////////////////
	    ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    fprintf(arxiu,"SURFACE (%s%i), SIDE POINTER=(%s%i)\n",(NumSuperficieInicial)>=10 ? (NumSuperficieInicial>=100 ? " ":"  "):"   ",(NumSuperficieInicial),(-1*signe)>0 ? " ":"",-1*signe);	
	    fprintf(arxiu,"SURFACE (%s%i), SIDE POINTER=(%s%i)\n",(NumSuperficieInicial+1)>=10 ? (NumSuperficieInicial+1>=100 ? " ":"  "):"   ",(NumSuperficieInicial+1),(-1*signe)>0 ? " ":"",-1*signe);	  
	    NumSuperficieInicial=NumSuperficieInicial+2;	    	    	    	    
	  }
	  else if(FiguresDelCos[j][0]==8)
	  {
	    /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    ///////////////////////////////////////////////////Una vegada creades les superficies, creem el tub cilindric/////////////////////////////////////////////////////////////////////////
	    /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	    fprintf(arxiu,"SURFACE (%s%i), SIDE POINTER=(%s%i)\n",(NumSuperficieInicial)>=10 ? (NumSuperficieInicial>=100 ? " ":"  "):"   ",(NumSuperficieInicial),(-1*signe)>0 ? " ":"",-1*signe);
	    fprintf(arxiu,"SURFACE (%s%i), SIDE POINTER=(%s%i)\n",(NumSuperficieInicial+1)>=10 ? (NumSuperficieInicial+1>=100 ? " ":"  "):"   ",(NumSuperficieInicial+1),(1*signe)>0 ? " ":"",1*signe);	    
	    fprintf(arxiu,"SURFACE (%s%i), SIDE POINTER=(%s%i)\n",(NumSuperficieInicial+2)>=10 ? (NumSuperficieInicial+2>=100 ? " ":"  "):"   ",(NumSuperficieInicial+2),(1*signe)>0 ? " ":"",1*signe);
	    fprintf(arxiu,"SURFACE (%s%i), SIDE POINTER=(%s%i)\n",(NumSuperficieInicial+3)>=10 ? (NumSuperficieInicial+3>=100 ? " ":"  "):"   ",(NumSuperficieInicial+3),(-1*signe)>0 ? " ":"",-1*signe);
	    NumSuperficieInicial=NumSuperficieInicial+3;
	  }
	  
	  j++;
	}
	
	///////////////////Augmentem el nombre de "BODY"s i escrivim els que estan dins de l'objecte que acabem de crear
	//Creem un vector per a guardar les prioritats interns que ja s'han guardat
	int PrioritatsAfegides[MAX_PRIORITAT]; //Prioritats internes ja afegides al cos
	int NumPrioritatsAfegides=0;  //Numero de prioritats internes que ja s'han afegit al  cos
	int k=0;
	while(k<NumCosos)  //inicialitzem a zero
	  {
	    PrioritatsAfegides[k]=0;
	    k++;
	  }
	k=0;      //Aquesta variable repasa primer les prioritats internes ja afegides i despres les prioritats internes del cos que estem creant
	NumCosos++;
	int t=1;  //Aquesta variable s'encarrega de recorrer tots els cosos ja existents
	//Mirem quins cosos te a l'interior
	while(t<NumCosos)     //Repasem tots els cosos ja existents
	  {
	    //Comprovem primer que aquesta prioritat no es troba ja afegida
	    k=0;
	    bool JaAfegida=false;
	    while(k<NumPrioritatsAfegides)
	      {
		if(CososPrioritat[t]==PrioritatsAfegides[k]){JaAfegida=true;break;}
		k++;
	      }
	    if(JaAfegida==true){t++;continue;}
	    //Si no es troba ja afegida, pasem a buscar-la en les prioritats internes del cos
	    k=0;
	    while(k<NumCosDins[NumCosos-1])  //Mirem si la prioritat del cos "t" es una de les prioritats que te el cos que estem creant com a internes
	      {
		
		if(CososPrioritat[t]==CosDins[NumCosos-1][k]) //Comprovem si la prioritat del cos "t" esta en el vector que guarda les prioritats dels cosos interns al que estem creant
		  {
		    fprintf(arxiu,"BODY    (%s%i)\n",t>=10 ? "  ":"   ",t); //Si es troba al vector de cosos interns, diguem al penelope que esta dins i afegim esta prioritat com prioritat ja afegida
		    PrioritatsAfegides[NumPrioritatsAfegides]=CososPrioritat[t];
		    NumPrioritatsAfegides++;
		    //A part diguem que els cosos interns a aquest, tambe estaran dins del que estem creant i fem que torne a buscar desde t=1, ja que les prioritats que afegir correspondran a "t" més baixes que l'actual
		    int z=0; //Recorre les prioritats internes al cos "t"
		    while(z<NumCosDins[t])
		      {
			//Primer comprovem que no estiga ja al vector de "CosDins" del cos que estem creant
			int CososDinsActualment=NumCosDins[NumCosos-1];
			bool EstaJa=false;
			int m=0; //Recorre les prioritats internes del cos que estem creant
			while(m<CososDinsActualment)
			  {
			    if(CosDins[t][z]==CosDins[NumCosos-1][m]){EstaJa=true;break;}
			    m++;
			  }
			if(EstaJa==false)
			  {
			    CosDins[NumCosos-1][CososDinsActualment]=CosDins[t][z];
			    NumCosDins[NumCosos-1]++;
			  }
			z++;
		      }
		    t=0;
		    break;
		  }
	      k++;
	      }
	    t++;
	  }
	i--;
    }	  
    
    fprintf(arxiu,"0000000000000000000000000000000000000000000000000000000000000000\n");
    fprintf(arxiu,"END      0000000000000000000000000000000000000000000000000000000\n");
    fclose(arxiu);
    if(Idioma==0)
      {
	  std::cout<<"Quadrics saved"<<std::endl;
	}
	else if(Idioma==1)
	{
	  std::cout<<"Quadriques guardades"<<std::endl;
	}
	else if(Idioma==2)
	{
	  std::cout<<"Quadricas guardadas"<<std::endl;
	}
	chdir(Actualdir);
	glutHideWindow();				//Amaguem la finestra fins que necesitem guardar o carregar un arxiu
    
	glutSetWindow(IdeFinestres[0]);		//seleccionem la finestra principal      
      
	INomArxiuChar[0]='\0';
    }
	
  }

  //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  ////////////////////////////////////////////////////GUARDAR GEOMETRIA GEANT4////////////////////////////////////////////////////////////////////
  //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    else if(boto==GLUT_LEFT_BUTTON && estat==GLUT_DOWN && (ControlMenu==4 && ControlSubMenu==4) && y<ALTURA2-TamanyBotons[1]*2+TamanyBotons[1]/2.0 && y>ALTURA2-TamanyBotons[1]*2-TamanyBotons[1]/2.0 && x<AMPLADA2-TamanyBotons[0]/2.0+TamanyBotons[0]/4.0 && x>AMPLADA2-TamanyBotons[0]/2.0-TamanyBotons[0]/4.0)
      {
	if(INomArxiuChar[0]!='\0')
	  {
	    YGC=0;
	    ControlMenu=0;
	    ControlSubMenu=0;
	    ControlSubSubMenu=0;
	    chdir("GeometriesGeant4");
	    std::string AuxStringDirectori;
	    std::string AuxStringDirectoriH; //Guarda el nom del .h
	    std::string AuxStringDirectoriCPP; //Guarda el nom del .cpp
	    
      
	    int i=0;
	    while(INomArxiuChar[i]!='\0')
	      {
		AuxStringDirectori+=INomArxiuChar[i];
		i++;
	      }
	    AuxStringDirectoriH=AuxStringDirectori+".h";
	    AuxStringDirectoriCPP=AuxStringDirectori+".cpp";
	    //Obrim l'arxiu//
	    //////////////////////////////////////////Escrivim l'arxiu .cpp/////////////////////////////////////////////////////////////
	    FILE* arxiu;
	    arxiu=fopen(AuxStringDirectoriCPP.c_str(),"w");
	    fprintf(arxiu,"//>>>>> GEOMETRY FILE FOR THE GEANT4 SYSTEM >>>>>>>>>>>>>>>>>>>>>>//\n");
	    fprintf(arxiu,"// ************************************************************** //\n");
	    fprintf(arxiu,"// ***********GEOMETRY CONSTRUCTED WITH VOXEL MAGES************** //\n");
	    fprintf(arxiu,"// ************************************************************** //\n");
	    fprintf(arxiu,"//>>> END OF HEADER >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>//\n\n");
	    fprintf(arxiu,"///Materials///\n\n");
	    i=0;
	    while(i<MaxMaterial)
	      {
		fprintf(arxiu,"//     mat_%i -> \n",i);
		i++;
	      }
	    //Escrivim el include
	    fprintf(arxiu,"\n\n#include\"%s\"\n",AuxStringDirectori.c_str());
	    fprintf(arxiu,"//-------------------------Geometry constructor-------------------------//\n");
	    fprintf(arxiu,"%s::%s() : G4VUserDetectorConstruction(), fScoringVolume(0)\n",AuxStringDirectori.c_str(),AuxStringDirectori.c_str());
	    fprintf(arxiu,"{}\n");
	    fprintf(arxiu,"//-------------------------Geometry destructor--------------------------//\n");
	    fprintf(arxiu,"%s::~%s()\n",AuxStringDirectori.c_str(),AuxStringDirectori.c_str());
	    fprintf(arxiu,"{}\n");
	    fprintf(arxiu,"//----------------------Geometry Construct function---------------------//\n");
	    fprintf(arxiu,"G4VPhysicalVolume* %s::Construct()\n",AuxStringDirectori.c_str());
	    fprintf(arxiu,"{\n");
	    fprintf(arxiu,"  ////////////////////////////\n");
	    fprintf(arxiu,"  ///Materials construction///\n");
	    fprintf(arxiu,"  ////////////////////////////\n");
	    fprintf(arxiu,"\n  //To load nist materials\n");
	    fprintf(arxiu,"  G4NistManager* nist = G4NistManager::Instance();\n\n");
	    i=0;
	    while(i<MaxMaterial)
	      {
		fprintf(arxiu,"  G4Material* mat_%i = ;\n",i);
		i++;
	      }
	    fprintf(arxiu,"  ////////////////////////////\n");
	    fprintf(arxiu,"  ////////Materials End///////\n");
	    fprintf(arxiu,"  ////////////////////////////\n\n");
	  
	    fprintf(arxiu,"  ////////////////////////////\n");
	    fprintf(arxiu,"  ////Geometry construction///\n");
	    fprintf(arxiu,"  ////////////////////////////\n\n");

	    fprintf(arxiu,"  bool CheckOverlaps = true;     // Active/Desactive overlaps check \n\n");
	    //Construim primer tots els solids i logics, despres farem els fisics
	    bool MonCreat=false; //Controla si ja hem creat el mon
	    int PrioritatMon=-1;  //Guarda la prioritat del mon
	    //Variables que controlen les figures que hem creat//
	    int NumCubsCreats=0;
	    int NumCilindresCreats=0;
	    int NumTubsCreats=0;
	    int NumConsCreats=0;
	    int NumEsferesCreades=0;
	    int NumSeccioEsferaCreades=0;
	    int NumPlansCreats=0;
	    /////////////////////////////////////////////////////
	    int NumFigures=NumCubs+NumEsf+NumCil+NumSecEsf+NumPla;
	    int MaterialObjecte[MaxFigures]={0};
	    double AnglesRotacioObjecte[MaxFigures][3]; //Guarda els angles de rotacio dels objectes
	    double CentreObjectes[MaxFigures][3]; // Guarda els centres dels objectes 
	    char NomsObjectes[MaxFigures][200];  //Guarda els noms dels objectes creats
	    int PrioritatsDinsObjecte[MaxFigures][100]; //Guarda les prioritats dins de cada objecte
	    //Inicialitzem els vectors
	    i=0;
	    while(i<NumFigures)
	      {
		AnglesRotacioObjecte[i][0]=0;
		AnglesRotacioObjecte[i][1]=0;
		AnglesRotacioObjecte[i][2]=0;
		CentreObjectes[i][0]=0;
		CentreObjectes[i][1]=0;
		CentreObjectes[i][2]=0;
		NomsObjectes[i][0]='\0';
		int m=0;
		while(m<100)
		  {
		    PrioritatsDinsObjecte[i][m]=0;
		    m++;
		  }
		i++;
	      }
     
	    int NumObjectesCreats=0;
	    //Busquem la prioritat mes menuda en numero, la qual asignarem com a "world"
	    /////////////////////////////////////////////////////
	    i=1; 
	    while(i<1000) //D'aquesta forma no creara al final el mon
	      {
		int NumeroInicialObjectes=NumObjectesCreats; //Guarda el nombre d'objectes que teniem creats abans d'arribar a aquesta prioritat
		//Primer creem els solids necesaris per a aquesta prioritat//
		int j=0;
		while(j<=NumCubs) //Repasem tots els "rectangles"
		  {
		    if(rectangles[j].Prioritat==i)//Comprovem si aquest "rectangle" te la prioritat que busquem
		      {
			//Creem una caixa solida
			//Primer mirem si el mon s'ha creat o no per a posarli de nom "world"
			if(MonCreat==false){sprintf(NomsObjectes[NumObjectesCreats],"World");MonCreat=true;PrioritatMon=i;}
			else{sprintf(NomsObjectes[NumObjectesCreats],"Box_%i",NumCubsCreats);}

			fprintf(arxiu,"  //%s//\n",NomsObjectes[NumObjectesCreats]);
			fprintf(arxiu,"  G4double %s_Size_x = %.10e*cm;\n",NomsObjectes[NumObjectesCreats],rectangles[j].Dimensions[0]);   
			fprintf(arxiu,"  G4double %s_Size_y = %.10e*cm;\n",NomsObjectes[NumObjectesCreats],rectangles[j].Dimensions[1]);
			fprintf(arxiu,"  G4double %s_Size_z = %.10e*cm;\n\n",NomsObjectes[NumObjectesCreats],rectangles[j].Dimensions[2]);
		      
			fprintf(arxiu,"  G4Box* Solid_%s = \n    new G4Box(\"%s\",        //its name\n        0.5*%s_Size_x, 0.5*%s_Size_y, 0.5*%s_Size_z);  //its size\n\n",NomsObjectes[NumObjectesCreats],NomsObjectes[NumObjectesCreats],NomsObjectes[NumObjectesCreats],NomsObjectes[NumObjectesCreats],NomsObjectes[NumObjectesCreats]);

			MaterialObjecte[NumObjectesCreats]=rectangles[j].Material;
			AnglesRotacioObjecte[NumObjectesCreats][0]=rectangles[j].Alfa;
			AnglesRotacioObjecte[NumObjectesCreats][1]=rectangles[j].Beta;
			AnglesRotacioObjecte[NumObjectesCreats][2]=rectangles[j].Gamma;
			CentreObjectes[NumObjectesCreats][0]=rectangles[j].Centre[0];
			CentreObjectes[NumObjectesCreats][1]=rectangles[j].Centre[1];
			CentreObjectes[NumObjectesCreats][2]=rectangles[j].Centre[2];

			//Guardem les prioritats dins d'aquesta prioritat
			int m=0;
			while(m<100)
			  {
			    if(rectangles[j].PDins[m]==0){break;} //No hi ha mes que guardar
			    //Comprovem que aquesta prioritat no esta ja inclosa (aço podria pasar si tenim 2 o me objectes creant un cos per interseccio)
			    bool Trobat=false;
			    int n=0;
			    while(n<100)
			      {
				if(PrioritatsDinsObjecte[NumeroInicialObjectes][n]==0){break;}
				if(PrioritatsDinsObjecte[NumeroInicialObjectes][n]==rectangles[j].PDins[m]){Trobat=true;break;}
				n++;
			      }
			    if(Trobat==false)
			      {
				//Si no el troba es perque no esta afegit. Per tant l'afegirem
				PrioritatsDinsObjecte[NumeroInicialObjectes][n]=rectangles[j].PDins[m];
			      }
			    m++;
			  }
			NumObjectesCreats++;
			NumCubsCreats++;
		      
		      }
		    j++;
		  }
		j=0;
		while(j<=NumEsf)
		  {
		    if(esferes[j].Prioritat==i)
		      {
			//Creem una esfera solida
			//Primer mirem si el mon s'ha creat o no per a posarli de nom "world"
			if(MonCreat==false){sprintf(NomsObjectes[NumObjectesCreats],"World");MonCreat=true;PrioritatMon=i;}
			else{sprintf(NomsObjectes[NumObjectesCreats],"Sphere_%i",NumEsferesCreades);}

			fprintf(arxiu,"  //%s//\n",NomsObjectes[NumObjectesCreats]);
			fprintf(arxiu,"  G4double %s_RMin = 0.0*cm;\n",NomsObjectes[NumObjectesCreats]);	      
			fprintf(arxiu,"  G4double %s_RMax = %.10e*cm;\n",NomsObjectes[NumObjectesCreats],esferes[j].Dimensions);	      
			fprintf(arxiu,"  G4double %s_Start_Phi = 0.0*deg;\n",NomsObjectes[NumObjectesCreats]);	      
			fprintf(arxiu,"  G4double %s_End_Phi = 360.0*deg;\n",NomsObjectes[NumObjectesCreats]);	      
			fprintf(arxiu,"  G4double %s_Start_Theta = 0.0*deg;\n",NomsObjectes[NumObjectesCreats]);	      
			fprintf(arxiu,"  G4double %s_End_Theta = 180.0*deg;\n",NomsObjectes[NumObjectesCreats]);	      

			fprintf(arxiu,"  G4Sphere* Solid_%s = \n    new G4Sphere(\"%s\",        //its name\n        %s_RMin, %s_RMax, %s_Start_Phi, %s_End_Phi, %s_Start_Theta, %s_End_Theta);       //its parameters\n\n",NomsObjectes[NumObjectesCreats],NomsObjectes[NumObjectesCreats],NomsObjectes[NumObjectesCreats],NomsObjectes[NumObjectesCreats],NomsObjectes[NumObjectesCreats],NomsObjectes[NumObjectesCreats],NomsObjectes[NumObjectesCreats],NomsObjectes[NumObjectesCreats]);
		      
			MaterialObjecte[NumObjectesCreats]=esferes[j].Material;
			AnglesRotacioObjecte[NumObjectesCreats][0]=esferes[j].Alfa;
			AnglesRotacioObjecte[NumObjectesCreats][1]=esferes[j].Beta;
			AnglesRotacioObjecte[NumObjectesCreats][2]=esferes[j].Gamma;
			CentreObjectes[NumObjectesCreats][0]=esferes[j].Centre[0];
			CentreObjectes[NumObjectesCreats][1]=esferes[j].Centre[1];
			CentreObjectes[NumObjectesCreats][2]=esferes[j].Centre[2];

			//Guardem les prioritats dins d'aquesta prioritat
			int m=0;
			while(m<100)
			  {
			    if(esferes[j].PDins[m]==0){break;} //No hi ha mes que guardar 
			    //Comprovem que aquesta prioritat no esta ja inclosa (aço podria pasar si tenim 2 o me objectes creant un cos per interseccio)
			    bool Trobat=false;
			    int n=0;
			    while(n<100)
			      {
				if(PrioritatsDinsObjecte[NumeroInicialObjectes][n]==0){break;}
				if(PrioritatsDinsObjecte[NumeroInicialObjectes][n]==esferes[j].PDins[m]){Trobat=true;break;}
				n++;
			      }
			    if(Trobat==false)
			      {
				//Si no el troba es perque no esta afegit. Per tant l'afegirem
				PrioritatsDinsObjecte[NumeroInicialObjectes][n]=esferes[j].PDins[m];
			      }
			    m++;
			  }
			
			NumObjectesCreats++;			
			NumEsferesCreades++;
		      }
		    j++;
		  }
		j=0;
		while(j<=NumCil)
		  {
		    if(cilindres[j].Prioritat==i)
		      {
			//Vegem ara si estem creant un tub o no
			if(cilindres[j].Tub==true)
			  {
			    //Creem un tub cilindric
			    //Primer mirem si el mon s'ha creat o no per a posarli de nom "world"
			    if(MonCreat==false){sprintf(NomsObjectes[NumObjectesCreats],"World");MonCreat=true;PrioritatMon=i;}
			    else{sprintf(NomsObjectes[NumObjectesCreats],"Tube_%i",NumTubsCreats);}			  

			    fprintf(arxiu,"  //%s//\n",NomsObjectes[NumObjectesCreats]);
			    fprintf(arxiu,"  G4double %s_Height = %.10e*cm;\n",NomsObjectes[NumObjectesCreats],cilindres[j].Dimensions[0]);
			    fprintf(arxiu,"  G4double %s_Rmin = %.10e*cm;\n",NomsObjectes[NumObjectesCreats],cilindres[j].Dimensions[2]);
			    fprintf(arxiu,"  G4double %s_Rmax = %.10e*cm;\n",NomsObjectes[NumObjectesCreats],cilindres[j].Dimensions[1]);
			    fprintf(arxiu,"  G4double %s_Start_Phi = 0*deg;\n",NomsObjectes[NumObjectesCreats]);
			    fprintf(arxiu,"  G4double %s_End_Phi = 360*deg;\n\n",NomsObjectes[NumObjectesCreats]);

			    fprintf(arxiu,"  G4Tubs* Solid_%s = \n    new G4Tubs(\n%s\n,        //its name\n        %s_Rmin, %s_Rmax, 0.5*%s_Height, %s_Start_Phi, %s_End_Phi);       //its parameters\n\n",NomsObjectes[NumObjectesCreats],NomsObjectes[NumObjectesCreats],NomsObjectes[NumObjectesCreats],NomsObjectes[NumObjectesCreats],NomsObjectes[NumObjectesCreats],NomsObjectes[NumObjectesCreats],NomsObjectes[NumObjectesCreats]);
			  
			    NumTubsCreats++;
			  }
			else
			  {
			    //Si no es un tub, mirem si es un con o un cilindre i si el con es invertit o no
			    if(cilindres[j].Dimensions[1]==cilindres[j].Dimensions[2])
			      {
				//Creem un cilindre
				//Primer mirem si el mon s'ha creat o no per a posarli de nom "world"
				if(MonCreat==false){sprintf(NomsObjectes[NumObjectesCreats],"World");MonCreat=true;PrioritatMon=i;}
				else{sprintf(NomsObjectes[NumObjectesCreats],"Cylinder_%i",NumCilindresCreats);}			  

				fprintf(arxiu,"  //%s//\n",NomsObjectes[NumObjectesCreats]);
				fprintf(arxiu,"  G4double %s_Height = %.10e*cm;\n",NomsObjectes[NumObjectesCreats],cilindres[j].Dimensions[0]);
				fprintf(arxiu,"  G4double %s_Rmin = 0.0*cm;\n",NomsObjectes[NumObjectesCreats]);
				fprintf(arxiu,"  G4double %s_Rmax = %.10e*cm;\n",NomsObjectes[NumObjectesCreats],cilindres[j].Dimensions[1]);
				fprintf(arxiu,"  G4double %s_Start_Phi = 0*deg;\n",NomsObjectes[NumObjectesCreats]);
				fprintf(arxiu,"  G4double %s_End_Phi = 360*deg;\n\n",NomsObjectes[NumObjectesCreats]);

				fprintf(arxiu,"  G4Tubs* Solid_%s = \n    new G4Tubs(\n%s\n,        //its name\n        %s_Rmin, %s_Rmax, 0.5*%s_Height, %s_Start_Phi, %s_End_Phi);       //its parameters\n\n",NomsObjectes[NumObjectesCreats],NomsObjectes[NumObjectesCreats],NomsObjectes[NumObjectesCreats],NomsObjectes[NumObjectesCreats],NomsObjectes[NumObjectesCreats],NomsObjectes[NumObjectesCreats],NomsObjectes[NumObjectesCreats]);

				NumCilindresCreats++;
			      }
			    else
			      {
				//Creem un con
				//Primer mirem si el mon s'ha creat o no per a posarli de nom "world"
				if(MonCreat==false){sprintf(NomsObjectes[NumObjectesCreats],"World");MonCreat=true;PrioritatMon=i;}
				else{sprintf(NomsObjectes[NumObjectesCreats],"Cone_%i",NumConsCreats);}

				fprintf(arxiu,"  //%s//\n",NomsObjectes[NumObjectesCreats]);
				fprintf(arxiu,"  G4double %s_Height = %.10e*cm;\n",NomsObjectes[NumObjectesCreats],cilindres[j].Dimensions[0]);
				fprintf(arxiu,"  G4double %s_Rmin_Inf = 0.0*cm;\n",NomsObjectes[NumObjectesCreats]);
				fprintf(arxiu,"  G4double %s_Rmax_Inf = %.10e*cm;\n",NomsObjectes[NumObjectesCreats],cilindres[j].Dimensions[2]);
				fprintf(arxiu,"  G4double %s_Rmin_Sup = 0.0*cm;\n",NomsObjectes[NumObjectesCreats]);
				fprintf(arxiu,"  G4double %s_Rmax_Sup = %.10e*cm;\n",NomsObjectes[NumObjectesCreats],cilindres[j].Dimensions[1]);
				fprintf(arxiu,"  G4double %s_Start_Phi = 0*deg;\n",NomsObjectes[NumObjectesCreats]);
				fprintf(arxiu,"  G4double %s_End_Phi = 360*deg;\n\n",NomsObjectes[NumObjectesCreats]);

				fprintf(arxiu,"  G4Cons* Solid_%s = \n    new G4Cons(\"%s\",        //its name\n        %s_Rmin_Inf, %s_Rmax_inf, %s_Rmin_Sup, %s_Rmax_Sup, 0.5*%s_Height, %s_Start_Phi, %s_End_Phi);       //its parameters\n\n",NomsObjectes[NumObjectesCreats],NomsObjectes[NumObjectesCreats],NomsObjectes[NumObjectesCreats],NomsObjectes[NumObjectesCreats],NomsObjectes[NumObjectesCreats],NomsObjectes[NumObjectesCreats],NomsObjectes[NumObjectesCreats],NomsObjectes[NumObjectesCreats],NomsObjectes[NumObjectesCreats]);

				NumConsCreats++;
			      
			      }
		      
			  }
			MaterialObjecte[NumObjectesCreats]=cilindres[j].Material;
			AnglesRotacioObjecte[NumObjectesCreats][0]=cilindres[j].Alfa;
			AnglesRotacioObjecte[NumObjectesCreats][1]=cilindres[j].Beta;
			AnglesRotacioObjecte[NumObjectesCreats][2]=cilindres[j].Gamma;
			CentreObjectes[NumObjectesCreats][0]=cilindres[j].Centre[0];
			CentreObjectes[NumObjectesCreats][1]=cilindres[j].Centre[1];
			CentreObjectes[NumObjectesCreats][2]=cilindres[j].Centre[2];

			//Guardem les prioritats dins d'aquesta prioritat
			int m=0;
			while(m<100)
			  {
			    if(cilindres[j].PDins[m]==0){break;} //No hi ha mes que guardar
			    //Comprovem que aquesta prioritat no esta ja inclosa (aço podria pasar si tenim 2 o me objectes creant un cos per interseccio)
			    bool Trobat=false;
			    int n=0;
			    while(n<100)
			      {
				if(PrioritatsDinsObjecte[NumeroInicialObjectes][n]==0){break;}
				if(PrioritatsDinsObjecte[NumeroInicialObjectes][n]==cilindres[j].PDins[m]){Trobat=true;break;}
				n++;
			      }
			    if(Trobat==false)
			      {
				//Si no el troba es perque no esta afegit. Per tant l'afegirem
				PrioritatsDinsObjecte[NumeroInicialObjectes][n]=cilindres[j].PDins[m];
			      }
			    m++;
			  }
			
			NumObjectesCreats++;
			
		      }
		    j++;
		  }
		j=0;
		while(j<=NumPla)
		  {
		    if(plans[j].Prioritat)
		      {
			//Creem una caixa molt gran
			//Primer mirem si el mon s'ha creat o no per a posarli de nom "world"
			if(MonCreat==false){sprintf(NomsObjectes[NumObjectesCreats],"World");MonCreat=true;PrioritatMon=i;}
			else{sprintf(NomsObjectes[NumObjectesCreats],"Infinite_Plane_%i",NumCubsCreats);}

			fprintf(arxiu,"  //%s//\n",NomsObjectes[NumObjectesCreats]);
			fprintf(arxiu,"  G4double %s_Size_x = 1e6*cm;\n",NomsObjectes[NumObjectesCreats]);   
			fprintf(arxiu,"  G4double %s_Size_y = 1e6*cm;\n",NomsObjectes[NumObjectesCreats]);
			fprintf(arxiu,"  G4double %s_Size_z = 1e6*cm;\n\n",NomsObjectes[NumObjectesCreats]);
		      
			fprintf(arxiu,"  G4Box* Solid_%s = \n    new G4Box(\"%s\",        //its name\n        0.5*%s_Size_x, 0.5*%s_Size_y, 0.5*%s_Size_z);  //its size\n\n",NomsObjectes[NumObjectesCreats],NomsObjectes[NumObjectesCreats],NomsObjectes[NumObjectesCreats],NomsObjectes[NumObjectesCreats],NomsObjectes[NumObjectesCreats]);

			MaterialObjecte[NumObjectesCreats]=plans[j].Material;
			AnglesRotacioObjecte[NumObjectesCreats][0]=plans[j].Alfa;
			AnglesRotacioObjecte[NumObjectesCreats][1]=plans[j].Beta;
			AnglesRotacioObjecte[NumObjectesCreats][2]=plans[j].Gamma;
			CentreObjectes[NumObjectesCreats][0]=plans[j].Centre[0];
			CentreObjectes[NumObjectesCreats][1]=plans[j].Centre[1];
			CentreObjectes[NumObjectesCreats][2]=plans[j].Centre[2];

			//Guardem les prioritats dins d'aquesta prioritat
			int m=0;
			while(m<100)
			  {
			    if(plans[j].PDins[m]==0){break;} //No hi ha mes que guardar
			    //Comprovem que aquesta prioritat no esta ja inclosa (aço podria pasar si tenim 2 o me objectes creant un cos per interseccio)
			    bool Trobat=false;
			    int n=0;
			    while(n<100)
			      {
				if(PrioritatsDinsObjecte[NumeroInicialObjectes][n]==0){break;}
				if(PrioritatsDinsObjecte[NumeroInicialObjectes][n]==plans[j].PDins[m]){Trobat=true;break;}
				n++;
			      }
			    if(Trobat==false)
			      {
				//Si no el troba es perque no esta afegit. Per tant l'afegirem
				PrioritatsDinsObjecte[NumeroInicialObjectes][n]=plans[j].PDins[m];
			      }
			    m++;
			  }			
			NumObjectesCreats++;
			NumPlansCreats++;
		      
		      }
		    j++;
		  }
		j=0;
		while(j<=NumSecEsf)
		  {
		    if(secEsf[j].Prioritat==i)
		      {
			//Creem una seccio d'esfera
			//Primer mirem si el mon s'ha creat o no per a posarli de nom "world"
			if(MonCreat==false){sprintf(NomsObjectes[NumObjectesCreats],"World");MonCreat=true;PrioritatMon=i;}
			else{sprintf(NomsObjectes[NumObjectesCreats],"Sphere_Section_%i",NumSeccioEsferaCreades);}

			//Calculem l'angle inicial "theta" on comença l'esfera
			double Theta=0.0;
			if(secEsf[j].Dimensions[1]>0){Theta=acos(secEsf[j].Dimensions[1]/secEsf[j].Dimensions[0]);}
			else if(secEsf[j].Dimensions[1]==0){Theta=90;}
			else if(secEsf[j].Dimensions[1]<0){Theta=90+asin(-secEsf[j].Dimensions[1]/secEsf[j].Dimensions[0]);}
		      
			fprintf(arxiu,"  //%s//\n",NomsObjectes[NumObjectesCreats]);
			fprintf(arxiu,"  G4double %s_RMin = 0.0*cm;\n",NomsObjectes[NumObjectesCreats]);	      
			fprintf(arxiu,"  G4double %s_RMax = %e*cm;\n",NomsObjectes[NumObjectesCreats],secEsf[j].Dimensions[0]);	      
			fprintf(arxiu,"  G4double %s_Start_Phi = 0.0*deg;\n",NomsObjectes[NumObjectesCreats]);	      
			fprintf(arxiu,"  G4double %s_End_Phi = 360.0*deg;\n",NomsObjectes[NumObjectesCreats]);	      
			fprintf(arxiu,"  G4double %s_Start_Theta = %e*deg;\n",NomsObjectes[NumObjectesCreats],Theta);	      
			fprintf(arxiu,"  G4double %s_End_Theta = 180.0*deg;\n",NomsObjectes[NumObjectesCreats]);	      

			fprintf(arxiu,"  G4Sphere* Solid_%s = \n    new G4Sphere(\"%s\",        //its name\n        %s_RMin, %s_RMax, %s_Start_Phi, %s_End_Phi, %s_Start_Theta, %s_End_Theta);       //its parameters\n\n",NomsObjectes[NumObjectesCreats],NomsObjectes[NumObjectesCreats],NomsObjectes[NumObjectesCreats],NomsObjectes[NumObjectesCreats],NomsObjectes[NumObjectesCreats],NomsObjectes[NumObjectesCreats],NomsObjectes[NumObjectesCreats],NomsObjectes[NumObjectesCreats]);

			MaterialObjecte[NumObjectesCreats]=secEsf[j].Material;
			AnglesRotacioObjecte[NumObjectesCreats][0]=secEsf[j].Alfa;
			AnglesRotacioObjecte[NumObjectesCreats][1]=secEsf[j].Beta;
			AnglesRotacioObjecte[NumObjectesCreats][2]=secEsf[j].Gamma;
			CentreObjectes[NumObjectesCreats][0]=secEsf[j].Centre[0];
			CentreObjectes[NumObjectesCreats][1]=secEsf[j].Centre[1];
			CentreObjectes[NumObjectesCreats][2]=secEsf[j].Centre[2];

			//Guardem les prioritats dins d'aquesta prioritat
			int m=0;
			while(m<100)
			  {
			    if(secEsf[j].PDins[m]==0){break;} //No hi ha mes que guardar
			    //Comprovem que aquesta prioritat no esta ja inclosa (aço podria pasar si tenim 2 o me objectes creant un cos per interseccio)
			    bool Trobat=false;
			    int n=0;
			    while(n<100)
			      {
				if(PrioritatsDinsObjecte[NumeroInicialObjectes][n]==0){break;}
				if(PrioritatsDinsObjecte[NumeroInicialObjectes][n]==secEsf[j].PDins[m]){Trobat=true;break;}
				n++;
			      }
			    if(Trobat==false)
			      {
				//Si no el troba es perque no esta afegit. Per tant l'afegirem
				PrioritatsDinsObjecte[NumeroInicialObjectes][n]=secEsf[j].PDins[m];
			      }
			    m++;
			  }			
			NumObjectesCreats++;
			NumSeccioEsferaCreades++;
		      }
		    j++;
		  }
		//Vegem si hi ha més d'un objecte amb aquesta prioritat. Si es així, el solid final sera la intersecció de tots ells.
		int ObjectesNous=NumObjectesCreats-NumeroInicialObjectes;
		if(ObjectesNous==0){i++;continue;}  //No hi ha cap objecte amb aquesta prioritat
		else if(ObjectesNous>1) //Si tenim més d'un objecte amb aquesta prioritat, generarem un solid que serà la intersecció de tots els que compartisquen dita prioritat
		  {
		    fprintf(arxiu,"  //Calculate %i intersection solids//\n\n",ObjectesNous);
		    
		    char NomSolidFusionat[200]; //Guarda els noms dels objectes la interseccio dels quals formen aquest solid.
		    NomSolidFusionat[0]='\0';
		    int contadorNomFusionat=0; //Marca la primera posició buida del vector nomSolidFusionat
		    int k=0; //Repasa els objectes que hi ha en aquesta prioritat
		    while(k<ObjectesNous)
		      {
			char NomSolidFusionatAnterior[200]; // Guarda el nom del solid fusionat abans d'afegir un altre
			sprintf(NomSolidFusionatAnterior,"%s",NomSolidFusionat);
			int m=0;
			while(m<200 && NomsObjectes[NumeroInicialObjectes+k][m]!='\0') //Afegim el nom dels objectes creats al nom del solid fusionat
			  {
			    NomSolidFusionat[contadorNomFusionat]=NomsObjectes[NumeroInicialObjectes+k][m];
			    contadorNomFusionat++;
			    m++;
			  }

			//Mirem si no es el primer objecte, ja que, no tindriem 2 solids amb que calcular la intersecció
			if(k==0)
			  {
			    fprintf(arxiu,"  //Calculate the inverse rotation of the first intersection solid//\n\n");
			    //Si es zero, sera el primer objecte. Calculem la rotacio i translacio que el deixa a l'origen i sense rotar
			    fprintf(arxiu,"  G4RotationMatrix* Inverse_Rotation_%s = new G4RotationMatrix();\n",NomsObjectes[NumeroInicialObjectes]);
			    fprintf(arxiu,"  Inverse_Rotation_%s->G4RotateZ3D(%f*deg);\n",NomsObjectes[NumeroInicialObjectes],AnglesRotacioObjecte[NumeroInicialObjectes][0]);
			    fprintf(arxiu,"  Inverse_Rotation_%s->G4RotateY3D(%f*deg);\n",NomsObjectes[NumeroInicialObjectes],AnglesRotacioObjecte[NumeroInicialObjectes][1]);
			    fprintf(arxiu,"  Inverse_Rotation_%s->G4RotateZ3D(%f*deg);\n",NomsObjectes[NumeroInicialObjectes],AnglesRotacioObjecte[NumeroInicialObjectes][2]);
			    fprintf(arxiu,"  Inverse_Rotation_%s.inverse();\n\n",NomsObjectes[NumeroInicialObjectes]);			    	    
			    
			  }
			else if(k>0)
			  {
			    //Una vegada tenim el nom de l'objecte afegit, calculem la seva posició relativa al primer
			    //Primer calculem les transformacions inverses del primer cos
			    fprintf(arxiu,"  //Calculate the relative translation of the intersection solids//\n\n");
			    
			    fprintf(arxiu,"  G4ThreeVector Relative_Translation_%s = G4ThreeVector(%.10e,%e.10,%e.10);\n", NomSolidFusionat,CentreObjectes[NumeroInicialObjectes][0]-CentreObjectes[NumeroInicialObjectes+k][0],CentreObjectes[NumeroInicialObjectes][1]-CentreObjectes[NumeroInicialObjectes+k][1],CentreObjectes[NumeroInicialObjectes][2]-CentreObjectes[NumeroInicialObjectes+k][2]);

			    fprintf(arxiu,"  //Calculate the relative rotation of the intersection solids//\n\n");
			    fprintf(arxiu,"  G4RotationMatrix* Rotation_%s = new G4RotationMatrix();\n",NomsObjectes[NumeroInicialObjectes+k]);
			    fprintf(arxiu,"  Rotation_%s->G4RotateZ3D(%f*deg);\n",NomsObjectes[NumeroInicialObjectes+k],AnglesRotacioObjecte[NumeroInicialObjectes+k][0]);
			    fprintf(arxiu,"  Rotation_%s->G4RotateY3D(%f*deg);\n",NomsObjectes[NumeroInicialObjectes+k],AnglesRotacioObjecte[NumeroInicialObjectes+k][1]);
			    fprintf(arxiu,"  Rotation_%s->G4RotateZ3D(%f*deg);\n\n",NomsObjectes[NumeroInicialObjectes+k],AnglesRotacioObjecte[NumeroInicialObjectes+k][2]);

			    fprintf(arxiu,"  G4RotationMatrix* Relative_Rotation_%s = new G4RotationMatrix();\n",NomSolidFusionat);
			    fprintf(arxiu,"  Relative_Rotation_%s = Inverse_Rotation_%s*Rotation_%s;\n\n",NomSolidFusionat,NomsObjectes[NumeroInicialObjectes],NomsObjectes[NumeroInicialObjectes+1]);

			    fprintf(arxiu,"  //Calculate the intersection solid//\n\n");

			    fprintf(arxiu," G4VSolid* Solid_%s = new G4IntersectionSolid(\"%s\", Solid_%s, Solid_%s, Relative_Rotation_%s, Relative_Translation_%s);",NomSolidFusionat,NomSolidFusionat,NomSolidFusionatAnterior,NomsObjectes[NumeroInicialObjectes+k],NomSolidFusionat,NomSolidFusionat);
			    
			  }
			k++;
			//Al final del nom de cada objecte posem una "_" per a espaiar els noms
			if(k<ObjectesNous) //Mirem si queda algun objecte per escriure
			  {
			    NomSolidFusionat[contadorNomFusionat]='_';
			    contadorNomFusionat++;
			  }
		      }
		    //Una vegada tenim el solid final (el resultant de les interseccions), eliminem els solids que el formen de la llista, ja que no caldran mes
		    //Guardem el nom en la posició del solid inicial
		    sprintf(NomsObjectes[NumeroInicialObjectes],"%s",NomSolidFusionat);
		    //Borrem la resta. La rotacio i translacio a aplicar sera la del solid inicial, ja que hem fet les interseccions respecte el sistema de referencia on el primer solid esta en l'origen i sense rotar.
		    k=1;
		    while(k<ObjectesNous)
		      {
			//Centre
			CentreObjectes[NumeroInicialObjectes+k][0]=0;CentreObjectes[NumeroInicialObjectes+k][1]=0;CentreObjectes[NumeroInicialObjectes+k][2]=0;
			//Angles
			AnglesRotacioObjecte[NumeroInicialObjectes+k][0]=0;AnglesRotacioObjecte[NumeroInicialObjectes+k][1]=0;AnglesRotacioObjecte[NumeroInicialObjectes+k][2]=0;

			MaterialObjecte[NumeroInicialObjectes+k]=0;
			NomsObjectes[NumeroInicialObjectes+k][0]='\0';
			NumObjectesCreats--;
			
			k++;
		      }
		  }
		//Creem el volum logic
		fprintf(arxiu,"  //Logical volume of: %s //\n\n",NomsObjectes[NumObjectesCreats-1]);
		fprintf(arxiu,"\n  G4LogicalVolume* Logic_%s =\n    new G4LogicalVolume(Solid_%s,       //its solid\n                        mat_%i,        //its material\n                       \"%s\");       //its name\n\n",NomsObjectes[NumObjectesCreats-1], NomsObjectes[NumObjectesCreats-1], MaterialObjecte[NumObjectesCreats-1],NomsObjectes[NumObjectesCreats-1]);
		//Creem el volum fisic
		fprintf(arxiu,"  //Physical volume of: %s //\n\n",NomsObjectes[NumObjectesCreats-1]);

		if(i==PrioritatMon)
		  {
		    //Si el volum "world" esta desplaçat o rotat, avisem que no esta permes fer aixo
		    if(CentreObjectes[NumObjectesCreats-1][0]!=0 || CentreObjectes[NumObjectesCreats-1][1]!=0 || CentreObjectes[NumObjectesCreats-1][2]!=0 || AnglesRotacioObjecte[NumObjectesCreats-1][0]!=0 || AnglesRotacioObjecte[NumObjectesCreats-1][1]!=0 || AnglesRotacioObjecte[NumObjectesCreats-1][2]!=0)
		      {
			std::cout<<"Warning: World volume must be unrotated and it must be placed at the origin of the global coordinate system"<<std::endl;
		      }
		    //Si es el mon no el podem rotar
		    fprintf(arxiu,"  G4PhysicalVolume* Physic_%s \n    = new G4PVPlacement(\n                 0,       //no rotation\n                 G4ThreeVector(),  //at (0,0,0)\n                 Logic_%s,     //its logical volume\n                 %s,   //its name\n                 0,       //its mother volume\n                 false,   //no boolean operation\n                 0,       //copy number\n                 CheckOverlaps);   //CheckOverlaps\n\n",NomsObjectes[NumObjectesCreats-1], NomsObjectes[NumObjectesCreats-1], NomsObjectes[NumObjectesCreats-1]);
		  }
		else
		  {
		    //Busque el volum mare
		    int PosicioVolumMare=0;
		    int k=0;
		    while(k<NumObjectesCreats) //De tots els objectes que continguen aquesta prioritat, ens quedarem en l'ultim creat (el mes inter) per a que siga el volum mare
		      {
			int m=0;
			while(m<100)
			  {
			    if(PrioritatsDinsObjecte[k][m]==i)
			      {
				PosicioVolumMare=k;
				break;
			      }
			    m++;
			  }
			k++;
		      }
		    fprintf(arxiu,"  //%s Rotation//\n\n",NomsObjectes[NumObjectesCreats-1]);
		    //Si es zero, sera el primer objecte. Calculem la rotacio i translacio que el deixa a l'origen i sense rotar
		    fprintf(arxiu,"  G4RotationMatrix* Rotation_%s = new G4RotationMatrix();\n",NomsObjectes[NumObjectesCreats-1]);
		    fprintf(arxiu,"  Inverse_Rotation_%s->G4RotateZ3D(%f*deg);\n",NomsObjectes[NumObjectesCreats-1],AnglesRotacioObjecte[NumObjectesCreats-1][0]);
		    fprintf(arxiu,"  Inverse_Rotation_%s->G4RotateY3D(%f*deg);\n",NomsObjectes[NumObjectesCreats-1],AnglesRotacioObjecte[NumObjectesCreats-1][1]);
		    fprintf(arxiu,"  Inverse_Rotation_%s->G4RotateZ3D(%f*deg);\n",NomsObjectes[NumObjectesCreats-1],AnglesRotacioObjecte[NumObjectesCreats-1][2]);

		    //Si el volum mare no es el"world", aleshores desfem les rotacions i translacions del mare
		    if(PosicioVolumMare!=0)
		      {
			//Com que el sistema de referencia es el del volum mare, primer farem la rotació inversa a la del volum mare i despres la rotacio del objecte que estem creant
			fprintf(arxiu,"  G4RotationMatrix* Inverse_Mother_Rotation_%s = new G4RotationMatrix();  //Inverse rotation of the mother volume\n",NomsObjectes[NumObjectesCreats-1]);
			fprintf(arxiu,"  Inverse_Mother_Rotation_%s = Rotation_%s.inverse();\n",NomsObjectes[NumObjectesCreats-1],NomsObjectes[PosicioVolumMare]);

			fprintf(arxiu,"  Rotation_%s = Rotation_%s*Inverse_Mother_Rotation_%s;\n\n",NomsObjectes[NumObjectesCreats-1],NomsObjectes[NumObjectesCreats-1],NomsObjectes[NumObjectesCreats-1]);
		    
			//Calculem ara la translació relativa al centre de la mare
			fprintf(arxiu,"  //%s Translation//\n\n",NomsObjectes[NumObjectesCreats-1]);
		    
			fprintf(arxiu,"  G4ThreeVector Translation_%s = G4ThreeVector(%.10e,%.10e,%.10e);\n\n",NomsObjectes[NumObjectesCreats-1],CentreObjectes[NumObjectesCreats-1][0]-CentreObjectes[PosicioVolumMare][0],CentreObjectes[NumObjectesCreats-1][1]-CentreObjectes[PosicioVolumMare][1],CentreObjectes[NumObjectesCreats-1][2]-CentreObjectes[PosicioVolumMare][2]);

		      }
		    else //Si el volum mare es el "world", aquest no pot estar rotat ni translladat
		      {
			fprintf(arxiu,"  //%s Translation//\n\n",NomsObjectes[NumObjectesCreats-1]);
		    
			fprintf(arxiu,"  G4ThreeVector Translation_%s = G4ThreeVector(%.10e,%.10e,%.10e);\n\n",NomsObjectes[NumObjectesCreats-1],CentreObjectes[NumObjectesCreats-1][0],CentreObjectes[NumObjectesCreats-1][1],CentreObjectes[NumObjectesCreats-1][2]);
		      }
		    //Creem el volum fisic
		    fprintf(arxiu,"  //%s Physical Volume//\n\n",NomsObjectes[NumObjectesCreats-1]);
		    
		    fprintf(arxiu,"  G4PhysicalVolume* Physic_%s \n    = new G4PVPlacement(\n                 Rotation_%s,       //rotation\n                 Translation_%s,  //translation\n                 Logic_%s,     //its logical volume\n                 %s,   //its name\n                 Physic_%s,       //its mother volume\n                 false,   //no boolean operation\n                 0,       //copy number\n                 CheckOverlaps);   //CheckOverlaps\n\n",NomsObjectes[NumObjectesCreats-1], NomsObjectes[NumObjectesCreats-1], NomsObjectes[NumObjectesCreats-1], NomsObjectes[NumObjectesCreats-1], NomsObjectes[NumObjectesCreats-1],  NomsObjectes[PosicioVolumMare]);
		      
		  }
		i++;
	      }
	    fprintf(arxiu,"  ////////////////////////////\n");
	    fprintf(arxiu,"  ////////Geometry End////////\n");
	    fprintf(arxiu,"  ////////////////////////////\n\n");

	    //Per a finalitzar fem que el return torne el mon "fisic"
	    fprintf(arxiu,"  return Physic_%s;\n",NomsObjectes[0]);
	    
	    fprintf(arxiu,"}\n");

	    //Tanquem l'arxiu .cpp
	    fclose(arxiu);
	    //Creem l'arxiu .h
	    arxiu=fopen(AuxStringDirectoriH.c_str(),"w");
	    fprintf(arxiu,"#ifndef %s_h\n",AuxStringDirectori.c_str());
	    fprintf(arxiu,"#define %s_h 1\n\n",AuxStringDirectori.c_str());

	    fprintf(arxiu,"#include \"G4VUserDetectorConstruction.hh\"\n");
	    fprintf(arxiu,"#include \"globals.hh\"\n");
	    fprintf(arxiu,"#include \"G4RunManager.hh\"\n");
	    fprintf(arxiu,"#include \"G4NistManager.hh\"\n");
	    fprintf(arxiu,"#include \"G4Box.hh\"\n");
	    fprintf(arxiu,"#include \"G4Cons.hh\"\n");
	    fprintf(arxiu,"#include \"G4Orb.hh\"\n");
	    fprintf(arxiu,"#include \"G4Sphere.hh\"\n");
	    fprintf(arxiu,"#include \"G4Trd.hh\"\n");
	    fprintf(arxiu,"#include \"G4LogicalVolume.hh\"\n");
	    fprintf(arxiu,"#include \"G4PVPlacement.hh\"\n");
	    fprintf(arxiu,"#include \"G4SystemOfUnits.hh\"\n\n");

	    fprintf(arxiu,"class G4PhysicalVolume;\n");
	    fprintf(arxiu,"class G4LogicalVolume;\n\n");

	    fprintf(arxiu,"class %s : public G4VUserDetectorConstruction\n",AuxStringDirectori.c_str());
	    fprintf(arxiu,"{\n");
	    fprintf(arxiu," public:\n");
	    fprintf(arxiu,"  %s();\n",AuxStringDirectori.c_str());
	    fprintf(arxiu,"  virtual ~%s();\n",AuxStringDirectori.c_str());
	    fprintf(arxiu,"  virtual G4VPhysicalVolume* %s();\n",AuxStringDirectori.c_str());
	    fprintf(arxiu,"  G4VLogicalVolume* GetScoringVolume() const { return fScoringVolume; }\n\n");

	    fprintf(arxiu," protected:\n");
	    fprintf(arxiu,"  G4LogicalVolume* fScoringVolume;\n");
	    fprintf(arxiu,"};\n\n");
	    fprintf(arxiu,"#endif");

	    fclose(arxiu);
	    if(Idioma==0)
	      {
		std::cout<<"Geometry saved"<<std::endl;
	      }
	    else if(Idioma==1)
	      {
		std::cout<<"Geometria guardada"<<std::endl;
	      }
	    else if(Idioma==2)
	      {
		std::cout<<"Geometria guardada"<<std::endl;
	      }
	    chdir(Actualdir);
	    glutHideWindow();				//Amaguem la finestra fins que necesitem guardar o carregar un arxiu
    
	    glutSetWindow(IdeFinestres[0]);		//seleccionem la finestra principal      
      
	    INomArxiuChar[0]='\0';
	    
	  }
      }
  //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  ////////////////////////////////////////////////////GUARDAR VOXELS PENE///////////////////////////////////////////////////////////////////////
  //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  else if(boto==GLUT_LEFT_BUTTON && estat==GLUT_DOWN && (ControlMenu==4 && ControlSubMenu==3) && y<ALTURA2-TamanyBotons[1]*2+TamanyBotons[1]/2.0 && y>ALTURA2-TamanyBotons[1]*2-TamanyBotons[1]/2.0 && x<AMPLADA2-TamanyBotons[0]/2.0+TamanyBotons[0]/4.0 && x>AMPLADA2-TamanyBotons[0]/2.0-TamanyBotons[0]/4.0)
  {
    if(INomArxiuChar[0]!='\0')
    {   
      YGC=0;
      ControlMenu=0;
      ControlSubMenu=0;
      ControlSubSubMenu=0;
      chdir("VoxelsPenelope");
      std::string AuxStringDirectori;

      int i=0;
      while(INomArxiuChar[i]!='\0')
      {
	AuxStringDirectori+=INomArxiuChar[i];
	i++;
      }
      AuxStringDirectori=AuxStringDirectori+".vox";
      std::cout<<AuxStringDirectori<<std::endl;
      std::ofstream arxiuvox(AuxStringDirectori.c_str());

      arxiuvox<<"#>>> GEOMETRY FILE FOR THE PENELOPE SYSTEM >>>>>>>>>>>>>>>>>>>>>>\n";
      arxiuvox<<"#****************************************************************\n";
      arxiuvox<<"#*************VOXELS CONSTRUCTED WITH VOXEL MAGES****************\n";
      arxiuvox<<"#****************************************************************\n";
      arxiuvox<<"#>>> END OF HEADER >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>\n";
      arxiuvox<<"#  Materials:\n";
      arxiuvox<<"#\n";
      i=0;
      while(i<MaxMaterial)
	{
	  arxiuvox<<"#     mat "<<i+1<<" -> \n";
	  i++;
	}
      arxiuvox<<"#\n";
      /////////////////////////Escrivim l'arxiu.vox///////////////////////////////////////////////////////////////////
      arxiuvox<<"[SECTION VOXELS HEADER v.2008-04-13]"<<'\n';
      arxiuvox<<" "<<NumVoxels[0]<<" "<<NumVoxels[1]<<" "<<NumVoxels[2]<<"              No. OF VOXELS IN X,Y,Z"<<'\n';
      arxiuvox<<" "<<DimVoxels[0]<<" "<<DimVoxels[1]<<" "<<DimVoxels[2]<<"        VOXEL SIZE (cm) ALONG X,Y,Z"<<'\n';
      arxiuvox<<" 1                    COLUMN NUMBER WHERE MATERIAL ID IS LOCATED"<<'\n';
      arxiuvox<<" 2                    COLUMN NUMBER WHERE THE MASS DENSITY IS LOCATED"<<'\n';
      arxiuvox<<" 1                    BLANK LINES AT END OF X,Y-CYCLES (1=YES,0=NO)"<<'\n';
      arxiuvox<<"[END OF VXH SECTION]"<<'\n';
      arxiuvox<<"# >>>> DATA BEGINS >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"<<'\n';
      arxiuvox<<"# MatID : dens(g/cm^3)"<<'\n';
      //Introduim ara les dades de la geometria
      
      i=0;		//Index X
      int j=0;		//Index Y
      int k=0;		//Index Z
      
     //Comensem a omplir des de el voxel 0, el centre del qual està a DimVoxels/2.
      while(k<NumVoxels[2])
      {
	arxiuvox<<"#Comença l'index z= "<<k+1<<std::endl;
	j=0;
	while(j<NumVoxels[1])
	{
	  arxiuvox<<"#Comença l'index y= "<<j+1<<std::endl;
	  i=0;
	  while(i<NumVoxels[0])
	  {
	    arxiuvox<<" "<<Voxels[i][j][k][0]<<" "<<Voxels[i][j][k][1]<<std::endl;
	    i++;
	  }
	  arxiuvox<<std::endl;	  
	  j++;
	}
	arxiuvox<<std::endl;
	
	std::cout.precision(2);
	std::cout<<"\r"<<std::fixed<<k*100.0/NumVoxels[2]<<"%                "; //\r tornarà al inici de la línia
	fflush( stdout );
	std::cout.unsetf(std::ios::floatfield);
	std::cout.precision(6);
	k++;
      }
      std::cout<<"\r100%                "<<std::endl; //\r tornarà al inici de la línia
      fflush( stdout );     
      arxiuvox.close();
      std::cout<<"Voxels guardats"<<std::endl;   
      chdir(Actualdir);
      glutHideWindow();				//Amaguem la finestra fins que necesitem guardar o carregar un arxiu
  
      glutSetWindow(IdeFinestres[0]);		//seleccionem la finestra principal      
    
      INomArxiuChar[0]='\0';      
    }
  }
  //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  ////////////////////////////////////////////////////CANCELAR//////////////////////////////////////////////////////////////////////////////////
  //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  else if(boto==GLUT_LEFT_BUTTON && estat==GLUT_DOWN && (ControlMenu==4 || ControlMenu==5) && y<ALTURA2-TamanyBotons[1]*2+TamanyBotons[1]/2.0 && y>ALTURA2-TamanyBotons[1]*2-TamanyBotons[1]/2.0 && x<AMPLADA2-TamanyBotons[0]*2/2.0-10+TamanyBotons[0]/4.0 && x>AMPLADA2-TamanyBotons[0]*2/2.0-10-TamanyBotons[0]/4.0)
  {
    ControlMenu=0;
    ControlSubMenu=0;
    ControlSubSubMenu=0;
    glutHideWindow();				//Amaguem la finestra fins que necesitem guardar o carregar un arxiu
    glutSetWindow(IdeFinestres[0]);		//seleccionem la finestra principal          
  
    //Repintem les finestres
    RendFinestraGran=true;
    RendFinestraInf=true;
    RendFinestraSup=true;
    
    INomArxiuChar[0]='\0';
    YGC=0;
  }
  //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  ////////////////////////////////////////////////////BORRAR////////////////////////////////////////////////////////////////////////////////////
  //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

  else  if(boto==GLUT_LEFT_BUTTON && estat==GLUT_DOWN && (ControlMenu==4 || ControlMenu==5) && y<ALTURA2-TamanyBotons[1]*2+TamanyBotons[1]/2.0 && y>ALTURA2-TamanyBotons[1]*2-TamanyBotons[1]/2.0 && x<AMPLADA2-TamanyBotons[0]*3/2.0-20+TamanyBotons[0]/4.0 && x>AMPLADA2-TamanyBotons[0]*3/2.0-20-TamanyBotons[0]/4.0)
  {
    if(INomArxiuChar[0]!='\0')
    {

      std::string AuxStringDirectori;
      
      int i=0;
      while(INomArxiuChar[i]!='\0')
      {
	AuxStringDirectori+=INomArxiuChar[i];
	i++;
      }
      if((ControlMenu==4 && ControlSubMenu==1) || ControlMenu==5 )
      {
	chdir(Geometriadir.c_str());
	AuxStringDirectori=AuxStringDirectori+".txt";
      }else if(ControlMenu==4 && ControlSubMenu==2)
      {
	chdir("GeometriesPenelope");
	AuxStringDirectori=AuxStringDirectori+".geo";
      }else if(ControlMenu==4 && ControlSubMenu==3)
      {
	chdir("VoxelsPenelope");
	AuxStringDirectori=AuxStringDirectori+".vox";
      }
      remove(AuxStringDirectori.c_str());
      
      chdir(Actualdir);
      
      INomArxiuChar[0]='\0';
      
    }
  }
  

  //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  ////////////////////////////////////////////////////CARREGAR GEOMETRIA////////////////////////////////////////////////////////////////////////
  //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  else if(boto==GLUT_LEFT_BUTTON && estat==GLUT_DOWN && ControlMenu==5 && y<ALTURA2-TamanyBotons[1]*2+TamanyBotons[1]/2.0 && y>ALTURA2-TamanyBotons[1]*2-TamanyBotons[1]/2.0 && x<AMPLADA2-TamanyBotons[0]/2.0+TamanyBotons[0]/4.0 && x>AMPLADA2-TamanyBotons[0]/2.0-TamanyBotons[0]/4.0)
  {
    if(INomArxiuChar[0]!='\0')
    {
      YGC=0;
      chdir(Geometriadir.c_str());
      std::string AuxStringDirectori;
      std::string linea;
      int i=0;
      while(INomArxiuChar[i]!='\0')
      {
	AuxStringDirectori+=INomArxiuChar[i];
	i++;
      }
      //Comprovem si l'usuari ha escrit l'extensio .txt
      //Si no l'ha escrit, l'afegim nosaltres
      if(strstr(AuxStringDirectori.c_str(),".txt") == 0)
	{
	  AuxStringDirectori=AuxStringDirectori+".txt";
	}
      //Obrim l'arxiu//
      std::ifstream Arxiu;
      Arxiu.open(AuxStringDirectori.c_str());
      if (Arxiu.is_open())				//Comprovem que s'ha obert correctament
      {
	//Buidem els voxels
	i=0;
	int j=0;
	int k=0;
	
	while(i<NumVoxels[0])
	{
	  j=0;
	  while(j<NumVoxels[1])
	  {
	    k=0;
	    while(k<NumVoxels[2])
	    {
	      Voxels[i][j][k][0]=1;
	      Voxels[i][j][k][1]=1;
	      k++;
	    }
	    j++;
	  }
	  i++;
	}
	//Diguem que cal tornar a renderitzar les finestres
	RendFinestraGran=true;
	RendFinestraInf=true;
	RendFinestraSup=true;
	
	//Pasarem a l'opcio de pintar els objectes
	PintObMat=0;			//Pintara els objectes
	PintVox=false;
	PintObjectes=true;
	  
	//Buidem variables
	NumVoxels[0]=0;NumVoxels[1]=0;NumVoxels[2]=0;
	DimVoxels[0]=0;DimVoxels[1]=0;DimVoxels[2]=0;
	
	
	ControlMenu=0;
	ControlSubMenu=0;
	ControlSubSubMenu=0;
	getline(Arxiu,linea);
	Arxiu>>NumVoxels[0]; Arxiu>>NumVoxels[1]; Arxiu>>NumVoxels[2];
	getline(Arxiu,linea);
	Arxiu>>DimVoxels[0]; Arxiu>>DimVoxels[1]; Arxiu>>DimVoxels[2];
	getline(Arxiu,linea);
	Arxiu>>NumCubs; Arxiu>>NumEsf; Arxiu>>NumCil; Arxiu>>NumPla; Arxiu>>NumSecEsf;
	getline(Arxiu,linea);
	//Carreguem el registre de prioritats//
	i=0;
	while(i<1000)
	{
	  Arxiu>>PrioritatsAsignades[0][i];
	  i++;
	}
	i=1;
	j=0;
	/////////////////////Carreguem els cubs///////////////////////////////////
	while(i<=NumCubs)
	{
	  Arxiu>>rectangles[i].radiMax;
	  getline(Arxiu,linea);
	  Arxiu>>rectangles[i].Densitat;
	  getline(Arxiu,linea);
	  Arxiu>>rectangles[i].llistaCreada;
	  getline(Arxiu,linea);
	  Arxiu>>rectangles[i].NFigura;
	  getline(Arxiu,linea);
	  j=0;
	  while(j<100)
	  {
	    Arxiu>>rectangles[i].PDins[j];
	    j++;
	  }
	  getline(Arxiu,linea);
	  Arxiu>>rectangles[i].Alfa; Arxiu>>rectangles[i].Beta; Arxiu>>rectangles[i].Gamma;
	  getline(Arxiu,linea);
	  Arxiu>>rectangles[i].Centre[0]; Arxiu>>rectangles[i].Centre[1]; Arxiu>>rectangles[i].Centre[2];
	  getline(Arxiu,linea);
	  Arxiu>>rectangles[i].Material;
	  getline(Arxiu,linea);
	  Arxiu>>rectangles[i].Prioritat;
	  getline(Arxiu,linea);
	  
	  Arxiu>>rectangles[i].Dimensions[0]; Arxiu>>rectangles[i].Dimensions[1]; Arxiu>>rectangles[i].Dimensions[2];
	  getline(Arxiu,linea);
	  i++;
	}
	i=1;
	///////////////////////Carreguem les esferes////////////////////////////////
	while(i<=NumEsf)
	{
	  Arxiu>>esferes[i].radiMax;
	  getline(Arxiu,linea);
	  Arxiu>>esferes[i].Densitat;
	  getline(Arxiu,linea);
	  Arxiu>>esferes[i].llistaCreada;
	  getline(Arxiu,linea);
	  Arxiu>>esferes[i].NFigura;
	  getline(Arxiu,linea);
	  j=0;
	  while(j<100)
	  {
	    Arxiu>>esferes[i].PDins[j];
	    j++;
	  }
	  getline(Arxiu,linea);
	  Arxiu>>esferes[i].Centre[0]; Arxiu>>esferes[i].Centre[1]; Arxiu>>esferes[i].Centre[2];
	  getline(Arxiu,linea);
	  Arxiu>>esferes[i].Material;
	  getline(Arxiu,linea);
	  Arxiu>>esferes[i].Prioritat;
	  getline(Arxiu,linea);
	  
	  Arxiu>>esferes[i].Dimensions;
	  getline(Arxiu,linea);
	  i++;
	} 
	i=1;
	////////////////////////Carreguem els cilindres////////////////////////////////
	while(i<=NumCil)
	{
	  Arxiu>>cilindres[i].radiMax;
	  getline(Arxiu,linea);
	  Arxiu>>cilindres[i].Densitat;
	  getline(Arxiu,linea);
	  Arxiu>>cilindres[i].llistaCreada;
	  getline(Arxiu,linea);
	  Arxiu>>cilindres[i].NFigura;
	  getline(Arxiu,linea);
	  j=0;
	  while(j<100)
	  {
	    Arxiu>>cilindres[i].PDins[j];
	    j++;
	  }
	  getline(Arxiu,linea);
	  Arxiu>>cilindres[i].Alfa; Arxiu>>cilindres[i].Beta; Arxiu>>cilindres[i].Gamma;
	  getline(Arxiu,linea);
	  Arxiu>>cilindres[i].Centre[0]; Arxiu>>cilindres[i].Centre[1]; Arxiu>>cilindres[i].Centre[2];
	  getline(Arxiu,linea);
	  Arxiu>>cilindres[i].Material;
	  getline(Arxiu,linea);
	  Arxiu>>cilindres[i].Prioritat;
	  getline(Arxiu,linea);
	  Arxiu>>cilindres[i].Tub;
	  getline(Arxiu,linea);
	  
	  Arxiu>>cilindres[i].Dimensions[0]; Arxiu>>cilindres[i].Dimensions[1]; Arxiu>>cilindres[i].Dimensions[2];
	  getline(Arxiu,linea);
	  i++;
	}
	i=1;
	////////////////////////Carreguem els plans////////////////////////////////
	while(i<=NumPla)
	{
	  Arxiu>>plans[i].radiMax;
	  getline(Arxiu,linea);
	  Arxiu>>plans[i].Densitat;
	  getline(Arxiu,linea);
	  Arxiu>>plans[i].llistaCreada;
	  getline(Arxiu,linea);
	  Arxiu>>plans[i].NFigura;
	  getline(Arxiu,linea);
	  j=0;
	  while(j<100)
	  {
	    Arxiu>>plans[i].PDins[j];
	    j++;
	  }
	  getline(Arxiu,linea);
	  Arxiu>>plans[i].Alfa; Arxiu>>plans[i].Beta; Arxiu>>plans[i].Gamma;
	  getline(Arxiu,linea);
	  Arxiu>>plans[i].Centre[0]; Arxiu>>plans[i].Centre[1]; Arxiu>>plans[i].Centre[2];
	  getline(Arxiu,linea);
	  Arxiu>>plans[i].Material;
	  getline(Arxiu,linea);
	  Arxiu>>plans[i].Prioritat;
	  getline(Arxiu,linea);
	  
	  Arxiu>>plans[i].Direccio[0]; Arxiu>>plans[i].Direccio[1]; Arxiu>>plans[i].Direccio[2];
	  getline(Arxiu,linea);
	  i++;
	}
	i=1;
	////////////////////////Carreguem les seccions d'esfera////////////////////////////////
	while(i<=NumSecEsf)
	{
	  Arxiu>>secEsf[i].radiMax;
	  getline(Arxiu,linea);
	  Arxiu>>secEsf[i].Densitat;
	  getline(Arxiu,linea);
	  Arxiu>>secEsf[i].llistaCreada;
	  getline(Arxiu,linea);
	  Arxiu>>secEsf[i].NFigura;
	  getline(Arxiu,linea);
	  j=0;
	  while(j<100)
	  {
	    Arxiu>>secEsf[i].PDins[j];
	    j++;
	  }
	  getline(Arxiu,linea);
	  Arxiu>>secEsf[i].Alfa; Arxiu>>secEsf[i].Beta; Arxiu>>secEsf[i].Gamma;
	  getline(Arxiu,linea);
	  Arxiu>>secEsf[i].Centre[0]; Arxiu>>secEsf[i].Centre[1]; Arxiu>>secEsf[i].Centre[2];
	  getline(Arxiu,linea);
	  Arxiu>>secEsf[i].Material;
	  getline(Arxiu,linea);
	  Arxiu>>secEsf[i].Prioritat;
	  getline(Arxiu,linea);
	  
	  Arxiu>>secEsf[i].Dimensions[0]; Arxiu>>secEsf[i].Dimensions[1];
	  getline(Arxiu,linea);
	  Arxiu>>secEsf[i].Direccio[0]; Arxiu>>secEsf[i].Direccio[1]; Arxiu>>secEsf[i].Direccio[2];
	  getline(Arxiu,linea);
	  i++;
	}	
	Arxiu>>NumTotalFig;
	getline(Arxiu,linea);
	Arxiu>>MaxMaterial;
	getline(Arxiu,linea);
	Arxiu>>MaxPrioritat;	
	Arxiu.close();
	chdir(Actualdir);
	glutHideWindow();				//Amaguem la finestra fins que necesitem guardar o carregar un arxiu
    
	glutSetWindow(IdeFinestres[0]);		//seleccionem la finestra principal      
      
	INomArxiuChar[0]='\0';  
	
		      //Reajustem la càmera//
	X=0;
	Y=0;
	Z=0;
	X1=0;
	Y1=0;
	Y2=0;
	X2=0;
	Y2=0;
	Z2=0;
  
	DimEspai[0]=NumVoxels[0]*DimVoxels[0];
	DimEspai[1]=NumVoxels[1]*DimVoxels[1];
	DimEspai[2]=NumVoxels[2]*DimVoxels[2];
		
	//Ajustem els plans de tall en la representacio de voxels
	PlansTall[0]=DimEspai[0];
	PlansTall[1]=DimEspai[1];
	PlansTall[2]=DimEspai[2];
	//Reconstruim la matriu de voxels per a que tinga les dimensions del nou espai//
	ConstruirMatriuVoxels(NumVoxels[0],NumVoxels[1],NumVoxels[2]);
	
	
	glMatrixMode(GL_MODELVIEW);			//S'encarrega de moure i transformar l'espai (Les coordenades de l'espai)
	glLoadIdentity();
	gluLookAt(DimEspai[0]+DimEspai[1]+DimEspai[2],DimEspai[1]/2.0,DimEspai[2]/2.0,DimEspai[0]/2.0,DimEspai[1]/2.0,DimEspai[2]/2.0,0.0,0.0,1.0);		//fixem la camera i el punt on mira
  		
	//Posem les figures borrades a zero
	j=0;
	while(j<100)
	{
	  FigBorrades[j]=0;
	  j++;
	}
      }
      else{std::cout<<"Error: Can't open "<<AuxStringDirectori<<std::endl;}
    }
  }
  
  glutPostRedisplay();
}

//--------------------------------------Funcio reescalar-----------------------------------------------------------------------//
void reshape (int w, int h)
{
  bool Redimensionar=false;
   if(w!=AMPLADA)
    {
      Redimensionar=true;
    //Forcem que es mantinga la proporcio amplada/altura

      Proporcio_Lletra=(float)w/AMPLADA_INICIAL;
      AMPLADA=w;
      ALTURA=AMPLADA*(1.0/PROPORCIO_PANTALLA);
      glutReshapeWindow(AMPLADA,ALTURA);		//Reajustarà les dimensions a les inicials
    }
  else if(h!=ALTURA)
    {
      Redimensionar=true;
      Proporcio_Lletra=(float)h/ALTURA_INICIAL;
      ALTURA=h;
      AMPLADA=ALTURA*PROPORCIO_PANTALLA;
      glutReshapeWindow(AMPLADA,ALTURA);
    }
  if(Redimensionar==true)
    {
      menuCreat=false;
      menuCreat2=false;

      //Redimensionem les coses
      AMPLADA2=AMPLADA*AMPLADA_PANTALLA_GUARDAR_CARREGAR;
      ALTURA2=ALTURA*ALTURA_PANTALLA_GUARDAR_CARREGAR;

      //Redimensionem la finestra de guardar/carregar
      glutSetWindow(IdeFinestres[1]);
      glutReshapeWindow(AMPLADA2,ALTURA2);
      glutPositionWindow(AMPLADA/4.0,ALTURA/6.0);
      glutSetWindow(IdeFinestres[0]);
      //L'origen es el canto esquerra inferior

      Dimensions_Pantalla_Gran[0]=AMPLADA*AMPLADA_PANTALLA_GRAN;
      Dimensions_Pantalla_Gran[1]=ALTURA*ALTURA_PANTALLA_GRAN;
 
      Origen_Pantalla_Gran[0]=AMPLADA*ORIGEN_PANTALLA_GRAN_X;
      Origen_Pantalla_Gran[1]=ALTURA*ORIGEN_PANTALLA_GRAN_Y;

      Dimensions_Pantalla_Menuda[0]=AMPLADA*AMPLADA_PANTALLA_MENUDA;
      Dimensions_Pantalla_Menuda[1]=ALTURA*ALTURA_PANTALLA_MENUDA;

      Origen_Pantalla_Inferior[0]=AMPLADA*ORIGEN_PANTALLA_INFERIOR_X;
      Origen_Pantalla_Inferior[1]=ALTURA*ORIGEN_PANTALLA_INFERIOR_Y;

      Origen_Pantalla_Superior[0]=AMPLADA*ORIGEN_PANTALLA_SUPERIOR_X;
      Origen_Pantalla_Superior[1]=ALTURA*ORIGEN_PANTALLA_SUPERIOR_Y;

      Dimensions_Menu[0]=AMPLADA*AMPLADA_MENU;
      Dimensions_Menu[1]=ALTURA*ALTURA_MENU;
   
      Origen_Menu[0]=AMPLADA*ORIGEN_MENU_X;
      Origen_Menu[1]=ALTURA*ORIGEN_MENU_Y;

      Dimensions_Visor2D[0]=AMPLADA*AMPLADA_VISOR_2D;
      Dimensions_Visor2D[1]=ALTURA*ALTURA_VISOR_2D;
 
      Origen_Visor2D[0]=AMPLADA*ORIGEN_VISOR_2D_X;
      Origen_Visor2D[1]=ALTURA*ORIGEN_VISOR_2D_Y;

      AmpladaVisor2D=Dimensions_Visor2D[0]*(1-0.01); //L'amplada del visor no inclou l'amplada de la barra
      AlturaVisor2D=Dimensions_Visor2D[1];

      RendFinestraGran=true;
      RendFinestraInf=true;
      RendFinestraSup=true;
      RendVisor2D=true;
      
      }
  glutPostRedisplay();
}
//--------------------------------------Codi Principal-----------------------------------------------------------------------//
int main(int argc, char **argv)
{
  //Llicencia
  std::cout<<"////////////////////////////////////////////////////////////////\nVoxel Mages  Copyright (C) 2015  Vicent Giménez Alventosa\nThis program comes with ABSOLUTELY NO WARRANTY.\nThis is free software, and you are welcome to redistribute it \nunder certain conditions.\n////////////////////////////////////////////////////////////////"<<std::endl;
  std::cout<<std::endl;
//////////////////////FITXERS//////////////////////////////////////////
////Comprovem que podem obtindre el directori actual i el home/////////
  
  if ((Homedir = getenv("HOME")) == NULL)
  {
    std::cout<<"Error al trobar el /home"<<std::endl;
    Eixir=true;
  }
    if ((Actualdir = getenv("PWD")) == NULL)
  {
    std::cout<<"Error al trobar el directori actual"<<std::endl;
    Eixir=true;
  }

  
  
  DIR *DirectoriAux;
  
  Programadir=std::string(Homedir)+std::string("/.peneView");
  
  Geometriadir=std::string(Programadir)+std::string("/Geometries");
  
  
  DirectoriAux=opendir(Programadir.c_str());
  if(DirectoriAux==NULL)	//Comrpovem si esta creada la carpeta del programa .pView
  {
    //si no està creada tornarà NULL i la creem
    mkdir(Programadir.c_str(),0744);		//el segon argument són els permisos del directori
    mkdir(Geometriadir.c_str(),0744);
    std::cout<<"Creating "<<Programadir<<std::endl;
    std::cout<<"Creating "<<Geometriadir<<std::endl;
    
  }
  else
  {
    closedir(DirectoriAux);
    DirectoriAux=opendir(Geometriadir.c_str());
    if(DirectoriAux==NULL)
    {
      mkdir(Geometriadir.c_str(),0744);
    }
    closedir(DirectoriAux);
  }
  //Comprovem si hi ha una carpeta Geometries Penelope creada i sino la creem
  DirectoriAux=opendir("GeometriesPenelope");
  if(DirectoriAux==NULL)
  {
    mkdir("GeometriesPenelope",0744);
    system("cp Penelope/gview2d.exe GeometriesPenelope/");
    system("cp Penelope/gview3d.exe GeometriesPenelope/");
    std::cout<<"Creating GeometriesPenelope"<<std::endl;
  }
    else
  {
    closedir(DirectoriAux);
  }
  //Comprovem si hi ha una carpeta Geometries Geant4 creada i sino la creem
  DirectoriAux=opendir("GeometriesGeant4");
  if(DirectoriAux==NULL)
  {
    mkdir("GeometriesGeant4",0744);
    std::cout<<"Creating GeometriesGeant4"<<std::endl;
  }
    else
  {
    closedir(DirectoriAux);
  }
  
  //Comprovem si hi ha una carpeta VoxelsPenelope creada i sino la creem
  DirectoriAux=opendir("VoxelsPenelope");
  if(DirectoriAux==NULL)
  {
    mkdir("VoxelsPenelope",0744);
    system("cp Penelope/voxelView VoxelsPenelope");
    std::cout<<"Creating VoxelsPenelope"<<std::endl;
  }
  else
  {
    closedir(DirectoriAux);
  }
//Comprovem si hi ha una carpeta Configuracions Penelope creada i sino la creem
  DirectoriAux=opendir("ConfiguracionsPenelope");
  if(DirectoriAux==NULL)
  {
    mkdir("ConfiguracionsPenelope",0744);
    std::cout<<"Creating ConfiguracionsPenelope"<<std::endl;
  }
  else
  {
    closedir(DirectoriAux);
  }  
//Comprovem si hi ha una carpeta Materials Penelope creada i sino la creem
  DirectoriAux=opendir("MaterialsPenelope");
  if(DirectoriAux==NULL)
  {
    mkdir("MaterialsPenelope",0744);
    std::cout<<"Creant carpeta MaterialsPenelope"<<std::endl;
  }
  else
  {
    closedir(DirectoriAux);
  }  
//Comprovem si hi ha una carpeta Penelope creada i sino la creem. Asi ha d'estar el penelope compilat unicament
  DirectoriAux=opendir("Penelope");
  if(DirectoriAux==NULL)
  {
    mkdir("Penelope",0744);
    std::cout<<"Creant carpeta Penelope"<<std::endl;
  }
  else
  {
    closedir(DirectoriAux);
  }  
    
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////FI FITXERS///////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

  //Inicialment tindrem un espai de 100x100x100 vòxels
  ConstruirMatriuVoxels(100,100,100);	//Construim la matriu de vòxels

  glutInit(&argc,argv);
  glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGBA | GLUT_DEPTH);
  glutInitWindowSize(AMPLADA,ALTURA);
  glutInitWindowPosition(ORIGENX,ORIGENY);
  IdeFinestres[0]=glutCreateWindow("Vox MAGES");

   geo();	//Cridem a la funció on s'inicialitzen els parametres de la geometria
 
  glutMouseFunc(ratoli);
  glutKeyboardFunc(teclat);
  glutSpecialFunc(TeclatEsp);
  glutDisplayFunc(dibuixar);
  glutMotionFunc(MovimentRatoli);
  glutReshapeFunc(reshape);
  
  //Finestra de guardar/carregar//
//  glutInitWindowSize(AMPLADA2,ALTURA2);
//  glutInitWindowPosition(AMPLADA/4.0,ALTURA/4.0);
//  IdeFinestres[1]=glutCreateWindow("No tancar");
  IdeFinestres[1]=glutCreateSubWindow(IdeFinestres[0],AMPLADA/4.0,ALTURA/6.0,AMPLADA2,ALTURA2);
  iniciarF2();
  glutHideWindow();				//Amaguem la finestra fins que necesitem guardar o carregar un arxiu

  glutMouseFunc(Fratoli);  
  glutDisplayFunc(FGuardarCarregar);
  glutSpecialFunc(FTeclatEsp);
  glutKeyboardFunc(Fteclat);  
  
  glutSetWindow(IdeFinestres[0]);		//Seleccionem la finestra principal
  
  glutMainLoop();
  
  return 0;
}
